package kal.base.com.query;

import kal.base.jdf.com.Logger;
import kal.base.com.util.*;

 /**
   * BASE2  SQL 
   * @author Copyright (c) 2005/01/06 HIST  
   */     
public class ComQ01Query {
	private static ComQ01Query instance = new ComQ01Query();
	
	public static ComQ01Query getInstance() {
		return instance;
	}
	
	/** 
	  *  DB ð ȸ SQLԼ.
	  * @param format String Return Date Format  ex) YYYYMMDD
	  * @param setTime String  ð ex) GMT : 540/1440   KST : 0
	  * @return String Query 
	  * @author Copyright (c) 2005/01/06 HIST 
	  */
	public String selDbTime(String format,String setTime) {

		StringBuffer sql = new StringBuffer();
		sql.append(" SELECT TO_CHAR(SYSDATE-("+setTime+"),'"+format+"') DB_TIME FROM DUAL");
		return sql.toString();
	}	
	
	/** 
	  * DB Table ȸ Լ.
	  *  Table SELECT ,TABLE,ȸ,ORDERBY  ȸѴ
	  * @param tblName String DB Table
	  * @param selName String ȸ ʵ
	  * @param paramName String ȸ ʵ
	  * @param orderName String OrderBy
	  * @return String Query 
	  * @author Copyright (c) 2005/01/06 HIST 
	  */
	public String selDbTable(String selName,String tblName,String paramName,String orderName) {

		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT "+selName);
		sql.append(" FROM "+tblName);
		sql.append(" WHERE "+paramName);
		sql.append(" ORDER BY "+orderName);
		return sql.toString();
	}	
	
	/** 
	  * Dom/Int/Cgo Query ȸԼ.
	  *  ǿ ´ Query Ѵ
	  * @param domIntX String 
	  * @return String Query 
	  * @author Copyright (c) 2005/01/26 HIST 
	  */
	public String selDomIntQ(String domIntX) {

		StringBuffer sql = new StringBuffer();
		if (domIntX != null && domIntX.length() != 0)
			domIntX = domIntX.toUpperCase();
		else 
			domIntX = StringUtil.checkString(domIntX);
		
		if (domIntX.equals("DOM")) {
			//2008.02.22  
			//sql.append(" 	(Substr(Flt_Num,1,1) = '1' Or");
			//sql.append(" 		(Substr(Flt_Num,1,2) = '01' And");
			//sql.append(" 	(Substr(Flt_Num,5,1) >= 'A' And Substr(Flt_Num,5,1) <= 'Z') And");
			//sql.append(" 		Not Kactyp In('M1F','7FQ','7FR','74Y','7FG','79S'))) And");
			sql.append(" 	SUBSTR(FLT_NUM,1,1) = '1' AND ");
			
		} else if (domIntX.equals("INT")) {
			//2008.02.22  
			//sql.append(" 	Not (Substr(Flt_Num,1,1) = '1'  Or");
			//sql.append(" 		(Substr(Flt_Num,1,2) = '01' And (Substr(Flt_Num,5,1) >= 'A' And");
			//sql.append(" 	Substr(Flt_Num,5,1) <= 'Z')) or");
			//sql.append(" 	Kactyp In('M1F','7FQ','7FR','74Y','7FG','79S')) And");
			sql.append(" 	NOT (SUBSTR(FLT_NUM,1,1) = '1' OR ");
			sql.append(" 	KACTYP IN('ABF','M1F','7FQ','7FR','74Y','7FG','79S','7GG','ABH','74F','74N','77X')) AND "); //2009.05.21 ߰ : ABH, 2010.03.26 ߰ : 74F, 2010.03.26 ߰ : 74N, 77X
			
		} else if (domIntX.equals("CGO")) {
			//2008.02.22 
			//sql.append(" 	Substr(Flt_Num,1,1) <> '1'   And");
			//sql.append(" 	Kactyp In('M1F','7FQ','7FR','74Y','7FG','79S') And");
			sql.append(" 	KACTYP IN('ABF','M1F','7FQ','7FR','74Y','7FG','79S','7GG','ABH','74F','74N','77X') AND "); //2009.05.21 ߰ : ABH, 2010.03.26 ߰ : 74F, 2010.03.26 ߰ : 74N, 77X
			
		} else {
			sql.setLength(0);
		}

		return sql.toString();
	}	
	
	/** 
	  * ACTYP ȸ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2005/01/27 HIST 
	  */
	public String selActyp() {
		StringBuffer sql = new StringBuffer();
		sql.append(" Select Distinct Code_c");
		sql.append(" From CODE_T");
		sql.append(" Where Step_x  = '1' And");
		sql.append(" Use_y   = 'Y' And");
		sql.append(" Desc_e  <> 'ATLAS' And");
		sql.append(" Code_x  = 'KAL ACTYPE'");
				
		return sql.toString();
	}		

	/** 
	  * Desk Description ȸ SQLԼ.
	  * @param String descE Desk_Code
	  * @return String Query  
	  * @author Copyright (c) 2005/01/27 HIST 
	  */
	public String selDesk(String descX) {
		StringBuffer sql = new StringBuffer();
		sql.append(" Select Code_x From Code_t");
		sql.append(" Where Step_x = '0'");
		sql.append(" And Use_y = 'N'");
		sql.append(" And Desc_e = '"+descX+"'");
		
		//Logger.debug.println("===== sql : "+sql.toString());
				
		return sql.toString();
	}	
	
	/** 
	  * FTS  ȸ SQLԼ.
	  * @param String empNo User ID
	  * @return String Query  
	  * @author Copyright (c) 2005/01/27 HIST 
	  */
	public String selFtsAuth(String empNo) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" Select B.Project_c, B.Auth_Pmsn");
		sql.append(" From Password_t A, Password_Auth_t B");
		sql.append(" Where A.Emp_No = B.Emp_No And");
		sql.append(" 			A.Emp_No = '"+empNo+"' And");
		sql.append(" 			B.Project_c = 'FTS'");
		
		Logger.debug.println("[selFtsAuth] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * FTS Menu ȸ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2005/04/27 HIST  
	  */
	public String selFtsMenu() {
		StringBuffer sql = new StringBuffer();
				
		sql.append(" Select Rpt_No, Rpt_Loc");
		sql.append(" From fc_report_t@copera");//@2014-03-03 sql.append(" From fc_report_t"); ٸ, fc_report_t  OLAP Ǵ ̺   ʴ ̺()
		
		Logger.debug.println("[FTS:FtsQ010Query:selFtsMenu] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * Region Flight ȸ SQLԼ.
	  * @param fltNum String Flight Number
	  * @return String Query  
	  * @author Copyright (c) 2005/05/04 HIST  
	  */
	public String getRegionFlt(String fltNum) {
		StringBuffer sql = new StringBuffer();
				
		sql.append(" Select Region_Flt");
		sql.append(" From Cm_Region_Flt_t");
		sql.append(" Where Flt_Num1 <= '"+fltNum+"' And");
		sql.append("       		Flt_Num2 >= '"+fltNum+"'");
		
		Logger.debug.println("[BASE2:ComQ01Query:getRegionFlt] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * Region X ȸ SQLԼ.
	  * @param stnFr String  Station From
	  * @param stnTo String  Station To
	  * @return String Query  
	  * @author Copyright (c) 2005/05/04 HIST  
	  */
	public String getRegionX(String stnFr, String stnTo) {
		StringBuffer sql = new StringBuffer();
				
		sql.append(" Select Max(Region_x) Region_x");
		sql.append(" From Cm_Port_t");
		sql.append(" Where Iata_Port In ('"+stnFr+"','"+stnTo+"')");
		
		Logger.debug.println("[BASE2:ComQ01Query:getRegionX] sql : "+sql.toString());
		return sql.toString();
	}		
	
	/** 
	  * Region X ȸ SQLԼ.
	  * @param ipC1 String  IP Code 1
	  * @param ipC2 String  IP Code 2
	  * @param ipC3 String  IP Code 3
	  * @param ipC4 String  IP Code 4
	  * @return String Query  
	  * @author Copyright (c) 2005/05/04 HIST  
	  */
	public String selIpCheck(String ipC1, String ipC2, String ipC3, String ipC4) {
		StringBuffer sql = new StringBuffer();
		
		//Logger.debug.println("ipC1 : "+ipC1+", ipC2 : "+ipC2+", ipC3 : "+ipC3+", ipC4 : "+ipC4);
		
		sql.append(" Select count(*) Cnt From Cm_Ip_Svc_t");
		sql.append(" Where Project_c = 'BASE2' And");
		sql.append("       		Ip_C1 = '"+ipC1+"' And");
		sql.append("       		(Ip_C2 = '"+ipC2+"' Or Ip_C2 = '*') And");
		sql.append("       		(Ip_C3 = '"+ipC3+"' Or Ip_C3 = '*') And");
		sql.append("       		(Ip_C4 = '"+ipC4+"' Or Ip_C4 = '*')");		
		
		//Logger.debug.println("[BASE2:ComQ01Query:selIpCheck] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * IROPS ߻ ȸ SQLԼ.
	  * DB Time  1   ȸ
	  * @return String Query  
	  * @author Copyright (c) 2005/05/04 HIST  
	  */
	public String selIrops() {
		StringBuffer sql = new StringBuffer();

		sql.append(" Select To_Char(First_Leg_Flt_Dt,'yyyymmdd') First_Leg_Flt_Dt,Flt_Num,Stnfr,Stnto,");
		sql.append("        	To_Char(First_Leg_Flt_Dt,'DDMON') First_Mon,Seq_Num,Option_Num,Title_X");
		sql.append(" From Irops_Sch_T");
		sql.append(" Where Complete_Y = 'N'");
		sql.append(" And Processed = 'X'");
		sql.append(" And Decision_C = 'X'");
		sql.append(" And Decision_E = ' '");
		sql.append(" And Timestamp >= Sysdate-(1/1440)");
		//sql.append(" And Timestamp >= Sysdate-(1/24)");
		
		//Logger.debug.println("[BASE2:ComQ01Query:selIrops] sql : "+sql.toString());
		return sql.toString();
	}		
	
	/** 
	  * Area Code ȸ SQLԼ.
	  * @return String Query 
	  * @author Copyright (c) 2005/07/13 
	  */
	public String selAreaList(String mode){
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT AREA_CD FROM BS_AREA_T");
		if (!mode.equals("A"))
			sql.append(" WHERE AREA_TYP='S'"); 
		sql.append(" ORDER BY AREA_CD");
		
		return sql.toString();
	}	
	
	/** 
	  * EMS Status Check SQLԼ.
	  * @return String Query 
	  * @author Copyright (c) 2006/03/17 
	  */
	public String selEmsStatus(){
		
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT STATUS_Y ");
		sql.append(" FROM CM_SYS_STATUS_T ");
		sql.append(" WHERE TARGET_SYS_C = 'EMS' ");

		return sql.toString();
	}
	
	/** 
	  * SMTP Status Check SQLԼ.
	  * @return String Query 
	  * @author Copyright (c) 2006/03/23 
	  */
	public String selSmtpStatus(){
		
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT STATUS_Y ");
		sql.append(" FROM CM_SYS_STATUS_T ");
		sql.append(" WHERE TARGET_SYS_C = 'SMTP' ");

		return sql.toString();
	}
	
	/** 
	  * FFS  CODE_T ȸ SQLԼ.
	  * @return String Query 
	  * @author Copyright (c) 2008/12/01 
	  */
	public String getNaiRange() {
		
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT OTHRS_E ");
		sql.append(" FROM CODE_T ");
		sql.append(" WHERE STEP_X = '2' ");
		sql.append(" 		AND CODE_X = 'UKFOS' ");
		sql.append(" 		AND CODE_C = 'NAI RANGE' ");
		sql.append(" 		AND USE_Y = 'N' ");
		
		return sql.toString();
	}
	
	/** 
	  * Irops Image Title ȸ SQLԼ.
	  * @return String Query 
	  * @author Copyright (c) 2012/01/15 
	  */
	public String selIropsImgTitles() {
		
		StringBuffer sql = new StringBuffer();
		
		sql.append(" Select Code_c, Desc_e ");
        sql.append(" From Code_T ");
        sql.append(" Where Step_x = '2'  And ");
        sql.append(" Code_x = 'IROPS_IMAGE' And ");
        sql.append(" Use_y  = 'Y' ");
        sql.append(" Order BY Code_c ");
		
		return sql.toString();
	}
	
}// end class