package kal.base.com.util;

import java.net.URI;
import java.util.ArrayList;
import java.util.Map;
import java.util.HashMap;
import java.util.Vector;
import java.net.URLEncoder;
import java.net.URLDecoder;
import com.ke.xwqs.crypto.KECryptoHelper;

import kal.base.jdf.serv.Box;


@SuppressWarnings({"unchecked","rawtypes"})
public class SecurityUtil{   
           /*-------------------------------------------------------------------         Field
           ----------------------------------------------------------------------        */
           private static KECryptoHelper crypto         =         new KECryptoHelper();
           private static HashMap emptyMap            =         new HashMap();  //" "ڸ ȣȭ ؼ , ȣȭ   ϱ      
           private String charSet                                        =         "EUC-KR";                     //crypto ϰų URLEncode,URLDecode Ҷ 
           /*-------------------------------------------------------------------         Constructor           SecurityUtil
           ----------------------------------------------------------------------        */
           public static SecurityUtil self = SecurityUtil.getInstance();
           private static SecurityUtil getInstance(){return new SecurityUtil();}       
           private SecurityUtil(){// ּ 1ȸ 
                      resetField();
           }
           /*-------------------------------------------------------------------         resetField
           ----------------------------------------------------------------------        */
           private void resetField(String serviceURL,String keyPath,String charSet){
                      try{
                                  this.charSet        =         charSet;
                                  crypto.setUrl(serviceURL);
                                  crypto.setTrustStorePath(keyPath);                        
                                  crypto.setCharSet(charSet);                                 
                                  
                                  //emptyMap.put("INT_HMAC", encrypt(" ","INT_HMAC"));//ȣȭ ϴϱ ǹ̾
                                  emptyMap.put("INT_TEL", encrypt(" ","INT_TEL"));
                                 emptyMap.put("INT_EML", encrypt(" ","INT_EML"));
                                  emptyMap.put("INT_ADR", encrypt(" ","INT_ADR"));
                      }catch(Exception e){
                                  System.out.println("SecurityUtil.resetField(String serviceURL,String keyPath,String charSet) : "+e.toString());
                      }
           }
           /*-------------------------------------------------------------------         encodeFilter
           ----------------------------------------------------------------------        */
           public String encodeFilter(String data,String cryptoType){
                      String result       =         data;
                      try{
                                  if(result!=null){
                                             if("INT_ADR".equals(cryptoType)==false){//INT_ADR ڵ ڵ ֱ⶧ 
                                                        result    =         result.replaceAll("[<>&]","");//
                                             }
                                  }
                      }catch(Exception e){
                                  System.out.println("SecurityUtil.encodeFilter : "+e.toString());
                      }
                      return result;
           }
           /*-------------------------------------------------------------------         String[] parameter           
           String[] encryptsResult     =         SecurityUtil.self.encrypts(new String[]{"a",null,"b"},"INT_XXX");
           String[] decryptsResult     =         SecurityUtil.self.decrypts(new String[]{"30ec4632667092...","c758c63691c69e66d8...",...},"INT_XXX");
           ----------------------------------------------------------------------        */
           public String[] encrypts(String[] data,String cryptoType){
                      String[] result     =         data==null?null:new String[data.length];
                      try{
                                  if(result==null||result.length==0||(result.length!=1 && "INT_HMAC".equals(cryptoType))){//н ѰŸ 
                                             return result;
                                  }
                                  
                                  for(int i=0; data!=null && i<data.length; i++){
                                             if(data[i]==null||data[i].length()==0){//ȣȭ Ҷ null  ȣȭ   " " Ѱ ڷ ־
                                                        result[i]=" ";
                                             }else if("INT_ADR".equals(cryptoType)){//ѱ۶ ڵ ؼ 
                                                        result[i]=           URLEncoder.encode(data[i],charSet);
                                             }else{
                                                        result[i]  =         encodeFilter(data[i],cryptoType);
                                             }
                                  }                                 
                                  result= crypto.encryptStrings(result,cryptoType);//ȣȭ
                                  
                                  //ȣȭ ϱ ӽ÷ ־صŸ̸  
                                  for(int i=0; result!=null && result.length==data.length && i<result.length; i++){
                                             result[i]=(data[i]==null||data[i].length()==0)?data[i]:result[i];
                                  }
                      }catch(Exception e){
                                  System.out.println("SecurityUtil.encrypts(String[] data,String cryptoType) : "+e.toString());
                      }
                      return result;
           }          
           public String[] decrypts(String[] data,String cryptoType){
                      String[] result     =         data==null?null:new String[data.length];
                      try{
                                  if(result==null||result.length==0||"INT_HMAC".equals(cryptoType)){//н ȣȭ  
                                             return result;
                                  }
                                  //ȣȭ Ҷ null  ȣȭ   ⺻ڷ ־
                                  for(int i=0; data!=null && i<data.length; i++){
                                             result[i]=(data[i]==null||data[i].length()==0)?(String)emptyMap.get(cryptoType):data[i];
                                  }                                 
                                  
                                  result= crypto.decryptStrings(result,cryptoType);//ȣȭ
                                                                   
                                  for(int i=0; result!=null && result.length==data.length && i<result.length; i++){
                                             if(data[i]==null||data[i].length()==0){//ȣȭ ϱ ӽ÷ ־صŸ̸  
                                                        result[i]  =         data[i];
                                             }else if("INT_ADR".equals(cryptoType)){//ѱ۶ ڵ ؼ ڵ
                                                        result[i]=          URLDecoder.decode(result[i],charSet);
                                             }else{
                                                        result[i]  =         result[i];
                                             }
                                  }
                      }catch(Exception e){
                                  System.out.println("SecurityUtil.decrypts(String[] data,String cryptoType) : "+e.toString());
                      }
                      return result;
           }
           /*-------------------------------------------------------------------         String parameter
             ȯ
           String encryptResult        =         SecurityUtil.self.encrypt("abc","INT_XXX");
           String decryptResult        =           SecurityUtil.self.decrypt("30ec4632667092...","INT_XXX");
           ----------------------------------------------------------------------        */
           public String encrypt(String data,String cryptoType){
                      String result       =         null;
                      try{
                                  String[] convertData        =         data==null||data.length()==0?null:encrypts(new String[]{data},cryptoType);                                  
                                  result    =         (convertData!=null && convertData.length==1)?convertData[0]:null;
                      }catch(Exception e){
                                  System.out.println("SecurityUtil.encrypt(String data,String cryptoType) : "+e.toString());
                      }
                      return result==null?"":result;
           }
           public String decrypt(String data,String cryptoType){
                      String result       =         null;
                      try{
                                  String[] convertData        =         data==null||data.length()==0?null:decrypts(new String[]{data},cryptoType);                                  
                                  result    =         (convertData!=null && convertData.length==1)?convertData[0]:null;
                      }catch(Exception e){
                                  System.out.println("SecurityUtil.decrypt(String data,String cryptoType) : "+e.toString());
                      }
                      return result==null?"":result;
           }
           /*-------------------------------------------------------------------         multi
           webservice ּȣ  Row Ÿ ϰ 
            ̵ 9 ٲٰ Ǹ 9  ȣ
           ׷ Լ   100̰ Խù  鼭  ȯϰ Ǹ 100*9  Ǳ⶧ 900 񽺸 ȣϰ 
           
           multiCrypts(kind,boxs,cryptoType_key);
           
           SecurityUtil.self.multiCrypts('E',boxs,new String[][]{
                                                                                         {"INT_HMAC","p_enc_pswd_c"}
                                                                              ,          {"INT_EML","p_enc_email_c"}
                                                                              ,           {"INT_TEL","p_enc_home_tel"}
                                                                              ,           {"INT_TEL","p_enc_office_tel"}
                                                                              ,           {"INT_TEL","p_enc_cell_tel"}
                                                                              ,           {"INT_ADR","p_enc_zip1_c"}
                                                                              ,           {"INT_ADR","p_enc_zip2_c"}
                                                                              ,           {"INT_ADR","p_enc_addr1_c"}
                                                                              ,           {"INT_ADR","p_enc_addr2_c"}
                                                                              });         //Ķͷ  ȣȭ
                                                                              
           SecurityUtil.self.multiCrypts('D',boxs,new String[][]{
                                                                                         {"INT_EML","ENC_EMAIL_C"}
                                                                              ,           {"INT_TEL","ENC_HOME_TEL"}
                                                                              ,           {"INT_TEL","ENC_OFFICE_TEL"}
                                                                              ,           {"INT_TEL","ENC_CELL_TEL"}
                                                                              ,           {"INT_ADR","ENC_ADDR1_C"}
                                                                              ,           {"INT_ADR","ENC_ADDR2_C"}
                                                                              ,           {"INT_HMAC","ENC_PSWD_C"}
                                                                              });         //Ķͷ  ȣȭ
           
           SecurityUtil.self.multiEncrypts(boxs);//Ķͷ  ȣȭ
           
           SecurityUtil.self.multiDecrypts(boxs);//ȣȭ Ȱ ȣȭ
           ----------------------------------------------------------------------        */
           public void multiCrypts(char kind,ArrayList<Map> boxs,String[][] cryptoType_key){//÷̸  ˾Ƽ ٲ            
                      try{
                                  if(boxs==null || boxs.size()==0||cryptoType_key==null||cryptoType_key.length==0){
                                             return;
                                  }
                                  Map      box;
                                  String cryptoType;
                                  String key;
                                  String[] value;
                                  //---------------------------------     ÷ Ͽ  String[]  
                                  for(int k=0; k<cryptoType_key.length; k++){
                                                        
                                             cryptoType        =         cryptoType_key[k][0];
                                             key                             =         cryptoType_key[k][1];
                                             
                                             value     =         new String[boxs.size()];//ʱȭ
                                             for(int i=0; i<boxs.size(); i++){//
                                                        box                  =         boxs.get(i);                                                      
                                                        value[i]  =         (String)box.get(key);
                                                        
                                                        box.put((kind=='E'?"enc_":"dec_")+key,null);//Ÿ 
                                                        boxs.set(i,box);
                                             }
                                             value     =         kind=='E'?encrypts(value,cryptoType):decrypts(value,cryptoType);//ȯ

                                             for(int i=0; value!=null && i<value.length; i++){
                                                        box       =         boxs.get(i);
                                                        box.put((kind=='E'?"enc_":"dec_")+key,value[i]);//ٲ۵Ÿ տ ± ٿ ߰ ־
                                                        boxs.set(i,box);
                                             }
                                  }
                      }catch(Exception e){
                                  System.out.println("SecurityUtil.multiCrypts(char kind,ArrayList<Map> boxs,String[][] cryptoType_key) : "+e.toString());
                      }
           }
           public void multiEncrypts(ArrayList<Map> boxs){//ڽ Ʈ ֻϴ Ÿ ڵ ȣȭ Ҷ 
                      try{
                                  Map      box     =         new HashMap();
                                  for(int i=0; i<boxs.size(); i++){// Ű ֱ 
                                             box.putAll( boxs.get(i));
                                  }                                 
                                  //Map    box                            =         (boxs==null || boxs.size()==0)?null:boxs.get(0);
                                  
                                  Vector<String[]> v          =         new Vector<String[]>();
                                  if(box!=null && box.size()!=0){
                                             if(box.containsKey("p_enc_pswd_c")){          v.add(new String[]{"INT_HMAC","p_enc_pswd_c"});}//p_enc_pswd_c   ĶͰ  н ȣȭ
                                             if(box.containsKey("p_enc_email_c")){          v.add(new String[]{"INT_EML","p_enc_email_c"});}
                                             if(box.containsKey("p_enc_home_tel")){       v.add(new String[]{"INT_TEL","p_enc_home_tel"});}
                                             if(box.containsKey("p_enc_office_tel")){        v.add(new String[]{"INT_TEL","p_enc_office_tel"});}
                                             if(box.containsKey("p_enc_cell_tel")){          v.add(new String[]{"INT_TEL","p_enc_cell_tel"});}
                                             if(box.containsKey("p_enc_zip1_c")){           v.add(new String[]{"INT_ADR","p_enc_zip1_c"});}
                                             if(box.containsKey("p_enc_zip2_c")){           v.add(new String[]{"INT_ADR","p_enc_zip2_c"});}
                                             if(box.containsKey("p_enc_addr1_c")){         v.add(new String[]{"INT_ADR","p_enc_addr1_c"});}
                                             if(box.containsKey("p_enc_addr2_c")){         v.add(new String[]{"INT_ADR","p_enc_addr2_c"});}
                                  }
                                  String[][] cryptoType_key  =         new String[v.size()][2];
                                  for(int i=0; i<v.size(); i++){
                                             cryptoType_key[i]=v.get(i);
                                  }
                                  multiCrypts('E',boxs,cryptoType_key);
                      }catch(Exception e){
                                  System.out.println("SecurityUtil.multiEncrypts(ArrayList<Map> boxs) : "+e.toString());
                      }
           }
           public void multiDecrypts(ArrayList<Map> boxs){//ڽ Ʈ ֻϴ Ÿ ڵ ȣȭ Ҷ 
                      try{
                                  Map      box     =         new HashMap();
                                  for(int i=0; i<boxs.size(); i++){
                                             box.putAll( boxs.get(i));
                                  }
                                  Vector<String[]> v          =         new Vector<String[]>();
                                  if(box!=null){                                        
                                             if(box.containsKey("ENC_PSWD_C")){          v.add(new String[]{"INT_HMAC","ENC_PSWD_C"});} //н  ȣȭ 
                                             if(box.containsKey("ENC_EMAIL_C")){          v.add(new String[]{"INT_EML","ENC_EMAIL_C"});}//ENC_EMAIL_C   Ͱ  ̸  ȣȭ
                                             if(box.containsKey("ENC_SEMAIL")){           v.add(new String[]{"INT_EML","ENC_SEMAIL"});}
                                             if(box.containsKey("ENC_EMAIL")){ v.add(new String[]{"INT_EML","ENC_EMAIL"});}
                                             
                                             if(box.containsKey("ENC_HOME_TEL")){       v.add(new String[]{"INT_TEL","ENC_HOME_TEL"});}
                                             if(box.containsKey("ENC_OFFICE_TEL")){      v.add(new String[]{"INT_TEL","ENC_OFFICE_TEL"});}
                                             if(box.containsKey("ENC_CELL_TEL")){         v.add(new String[]{"INT_TEL","ENC_CELL_TEL"});}
                                             if(box.containsKey("ENC_ZIP1_C")){ v.add(new String[]{"INT_ADR","ENC_ZIP1_C"});}
                                             if(box.containsKey("ENC_ZIP2_C")){ v.add(new String[]{"INT_ADR","ENC_ZIP2_C"});}
                                             if(box.containsKey("ENC_ADDR1_C")){         v.add(new String[]{"INT_ADR","ENC_ADDR1_C"});}
                                             if(box.containsKey("ENC_ADDR2_C")){         v.add(new String[]{"INT_ADR","ENC_ADDR2_C"});}
                                  }
                                  String[][] cryptoType_key  =         new String[v.size()][2];
                                  for(int i=0; i<v.size(); i++){
                                             cryptoType_key[i]=v.get(i);
                                  }
                                  multiCrypts('D',boxs,cryptoType_key);
                      }catch(Exception e){
                                  System.out.println("SecurityUtil.multiDecrypts(ArrayList<Map> boxs) : "+e.toString());
                      }
           }
           /*-------------------------------------------------------------------         ƿ
           ----------------------------------------------------------------------        */
           private void debugURI(URI uri){
                      try{
                                  if(uri==null){
                                             System.out.println("uri is null");
                                  }else{
                                             StringBuffer sb    =         new StringBuffer();
                                             sb.append("\n   toString : "+uri.toString());
                                             sb.append("\n   getPath : "+uri.getPath());
                                             sb.append("\n   toURL : "+uri.toURL());
                                             if(uri.isAbsolute()){
                                                        sb.append("\n   toURL.getPath : "+(uri.toURL()==null?null:uri.toURL().getPath()));
                                             }
                                             //keyURI.toString().replaceAll("wsjar:","").replaceAll("file:","").replaceAll("!","");
                                             System.out.println(sb);
                                  }
                      }catch(Exception e){
                                  System.out.println("SecurityUtil.debugURI(URI uri) : "+e.toString());
                      }
           }
           /*-------------------------------------------------------------------         getPassword
           String enc_pswdNo         =         SecurityUtil.self.getPassword(pswdNo.toUpperCase());
           ----------------------------------------------------------------------        */                    
           public String getPassword(String originStr){
                      return encrypt(originStr,"INT_HMAC");
           }
           /*-------------------------------------------------------------------         passwordEqual
           if(rs!=null && rs.next()){
                      userChk =           SecurityUtil.self.passwordEqual(rs.getString("ENC_PSWD_NO"),pswdNo.toUpperCase());
           }
           ----------------------------------------------------------------------        */                    
           public boolean passwordEqual(String encPwd,String originStr){//ȣȭ ȰͰ Ķ 
                      return encPwd!=null && encPwd.length()!=0 && encPwd.equals(getPassword(originStr));
           }
           /*-------------------------------------------------------------------         
           Ŀ : Ʈ °  κ
           ----------------------------------------------------------------------        */                    
           private void resetField(){
                      try{
                                  //--------------------------------     serviceURL : ȣȭ  
                                  String    serviceURL         =           "https://cipherprd.koreanair.com/SafeNetServiceAxis2/DataProtectionService";// 
                                  
                                  //--------------------------------     keyPath : Ű  
                                  //URI     keyURI  =	this.getClass().getResource("/WEB-INF/lib/truststore.v2.jks").toURI();
                                  URI       keyURI	=   this.getClass().getResource("truststore.v2.jks").toURI();//EJBϰ
                                  String    keyPath =   (keyURI==null)?null:keyURI.getPath();
                                  
                                  System.out.println("keyPath:"+keyPath);
                                  
                                  if(keyPath==null){//     ϸ鼭 EJB ó  ϰ νĸ.  
                                             keyPath = "/was/apps/EK/BASEEAR.ear/BASEWeb.war/WEB-INF/lib/truststore.v2.jks";
                                  }
                                  //--------------------------------     
                                  debugURI(keyURI);
                                  resetField(serviceURL,keyPath,"EUC-KR");
                      }catch(Exception e){
                                  System.out.println("SecurityUtil.resetField() : "+e.toString());
                      }                      
           } 
          
           
           public ArrayList<Box> encrypts(ArrayList<Box> listBoxs,String[][] cryptoType_key){
        	   
        	   ArrayList<Box> boxs       =         null;//ArrayList<HashMap> 
               
        	   try{
                   if(listBoxs==null || listBoxs.size()==0 || cryptoType_key==null || cryptoType_key.length==0){
                	   return boxs;
                   }

                  boxs     =         new ArrayList<Box>(listBoxs);
                  
                  Box  box;//HashMap 
                  String cryptoType;
                  String key;
                  String[] value;
                  
                  for(int k=0; k<cryptoType_key.length; k++){
                             cryptoType        =         cryptoType_key[k][0];
                             key                             =         cryptoType_key[k][1];
                             //System.out.println("cryptoType:"+cryptoType+"/key:"+key);
                             
                             value     =         new String[boxs.size()];                                      
                             for(int i=0; i<boxs.size(); i++){
                                        box                  =         boxs.get(i);
                                        value[i]=           (String)box.get(key);
                                        //System.out.println("value:"+i+":"+ value[i]);
                             }
                             value     =         encrypts(value,cryptoType);// ȣǴ κ. ѹ ٲٰ
                             
                             
                             
                             for(int i=0;value != null && i<value.length; i++){//ٲ۵Ÿ ϵŸ ־ְ
                                        box       =         boxs.get(i);
                                        box.put(key,value[i]);
                                        boxs.set(i,box);
                             }
                  }
              }catch(Exception e){
            	  System.out.println("SecurityUtil.encrypts(ArrayList<Box> listBoxs,String[][] cryptoType_key) : "+e.toString());
              }
              return boxs;
           }
           
           
           public ArrayList<Box> decrypts(ArrayList<Box> listBoxs,String[][] cryptoType_key){	   
        	   ArrayList<Box> boxs       =         null;//ArrayList<HashMap> 
               
        	   System.out.println("      listBoxs:"+listBoxs);
        	   System.out.println("cryptoType_key:"+cryptoType_key);
        	   
        	   try{
        		   
                   if(listBoxs==null || listBoxs.size()==0 || cryptoType_key==null || cryptoType_key.length==0){
                	   return boxs;
                   }

                  boxs     =         new ArrayList<Box>(listBoxs);
                  
                  Box  box;//HashMap 
                  String cryptoType;
                  String key;
                  String[] value;
                  
                  System.out.println("cryptoType_key.length:"+cryptoType_key.length);
                  
                  for(int k=0; k<cryptoType_key.length; k++){
                      cryptoType        =         cryptoType_key[k][0];
                      key                             =         cryptoType_key[k][1];
                      //System.out.println("cryptoType:"+cryptoType+"/key:"+key);
                      
                      value     =         new String[boxs.size()];                                      
                      for(int i=0; i<boxs.size(); i++){
                                 box                  =         boxs.get(i);
                                 value[i]=           (String)box.get(key);
                                 //System.out.println("value:"+i+":"+ value[i]);
                      }
                      value     =         decrypts(value,cryptoType);// ȣǴ κ. ѹ ٲٰ
                      
                      
                      
                      for(int i=0;value != null && i<value.length; i++){//ٲ۵Ÿ ϵŸ ־ְ
                                 box       =         boxs.get(i);
                                 box.put(key,value[i]);
                                 boxs.set(i,box);
                      }
                  }
                  
                  
                  
              }catch(Exception e){
            	  System.out.println("SecurityUtil.decrypts(ArrayList<Box> listBoxs,String[][] cryptoType_key) : "+e.toString());
              }
              return boxs;
           }
     
}
