package kal.base.ffs.query;

import kal.base.ffs.dbbean.FfsA080BG;

public class FfsA080Query {
    private static FfsA080Query instance = new FfsA080Query();
    
    public static FfsA080Query getInstance(){
    	return instance;
    }
    
    public String selFfsRouteTab(FfsA080BG params){
    	StringBuffer sql = new StringBuffer();
    	
    	sql.append(" SELECT B.REGION_CD, TO_CHAR(A.FIRST_LEG_FLT_DT,'YYYYMMDD') FIRST_LEG_FLT_DT, A.FLT_NUM, A.LEG_NUM, A.REGNO, A.SACTYP, A.STNFR, A.STNTO, TO_CHAR(A.EST_DEP_DT,'HH24:MI') EST_DEP_DT, A.EST_DEP_DT ORDERBY,");
    	sql.append("        TO_CHAR(A.EST_ARV_DT,'HH24:MI') EST_ARV_DT, C.ABHR, C.PLN_TRIP_FUEL, C.FUEL_COST, C.OVERFLT_COST, C.CREW_COST, C.MAINT_COST, C.COST_AMOUNT, ");
    	sql.append("        C.COMPARED_TO_KAM, C.ROUTE ");
    	sql.append(" FROM DAILY_SCH_T A, CM_CITYPAIR_DEF_T B, KFOS.ERS_MASTER_T C ");
    	//sql.append(" WHERE A.EST_DEP_DT >= SYSDATE - 9/24 ");
    	//sql.append(" AND A.EST_DEP_DT <= SYSDATE + 5/24 ");
    	//sql.append(" WHERE A.EST_DEP_DT >=SYSDATE - 21/24 ");// 2013/01/30 
    	//sql.append(" AND A.EST_DEP_DT <= SYSDATE + 3/24 ");// 2013/01/30     	
    	sql.append("	WHERE A.EST_DEP_DT >= SYSDATE - 12/24");//@2013-12-04 ּ :2013.3.20  κ
    	sql.append("	AND	A.EST_DEP_DT <= SYSDATE + 12/24");//@2013-12-04  ּ :2013.3.20  κ
    	
    	sql.append(" AND B.REGION_CD IN ("+params.getRegionCd()+")");
    	sql.append(" AND A.EST_DEP_DT >= TO_DATE('"+params.getFromDt()+"','YYMMDDHH24MI') ");
    	sql.append(" AND A.EST_DEP_DT <= TO_DATE('"+params.getToDt()+"','YYMMDDHH24MI' ) ");
    	sql.append(" AND A.DEP_STS <> 'INI' ");
    	//sql.append(" AND A.FLT_PLANNED = 'N' ");//2012.11.13  : Ͱ  FLT_PLANNED = Y ٲ𶧱 ð  ªƼ Ͱ ݹ 
    	sql.append(" AND A.ACTNID <> 'CNL' ");//2012.11.13  
    	sql.append(" AND A.STNFR = B.DEP_PORT ");
    	sql.append(" AND A.STNTO = B.ARV_PORT ");
    	sql.append(" AND A.FIRST_LEG_FLT_DT = C.FIRST_LEG_FLT_DT(+) ");
    	sql.append(" AND A.FLT_NUM = C.FLT_NUM(+) ");
    	sql.append(" AND A.LEG_NUM = C.LEG_NUM(+) ");
    	sql.append(" AND A.STNFR = C.STNFR(+) ");
    	sql.append(" AND A.STNTO = C.STNTO(+) ");
    	sql.append(" AND A.FLT_NUM NOT LIKE '1%' ");
    	sql.append(" AND SUBSTR(A.FLT_NUM, 1, 1) <> '4' "); 
    	sql.append(" AND C.CONFIRM_Y(+)='Y' ");
    	//sql.append(" ORDER BY ORDERBY ASC ");
    	sql.append(" ORDER BY A.EST_DEP_DT ASC ");//2013/01/30 
    	
    	//System.out.println(sql);
    	
    	return sql.toString();
    }
    
    public String selEnabledRouteList_back(FfsA080BG params){//2013-02-14 Ʒ 
    	StringBuffer sql = new StringBuffer();
    	
    	sql.append("SELECT DISTINCT AL.FIRST_LEG_FLT_DT, AL.FLT_NUM, AL.LEG_NUM, AL.STNFR, AL.STNTO, AL.ACTYP, AL.REGNO, NVL(AL.RT_GROUPING,'****') RT_GROUPING, MAST.REASON_1, MAST.REASON_2, \n");// 2012.11.26 DISTINCT ߰ //@@@@@AL.RT_GROUPING 񱳸  MAST.ROUTE ߰, 
    	sql.append("       MAST.ROUTE MAST_RT_GROUPING, MAST.PLN_TRIP_FUEL MAST_PLN_TRIP_FUEL, \n");// AL.RT_GROUPING 񱳸  MAST.ROUTE ߰
    	sql.append("       AL.ABHR, AL.PLN_TRIP_FUEL, AL.CHARGE, AL.FUEL_COST, AL.CREW_COST, AL.MAINTENANCE_COST, DECODE(MAST.CONFIRM_Y,'Y','Y','N') CONF \n");
    	sql.append("FROM (SELECT FP.FIRST_LEG_FLT_DT, FP.FLT_NUM, FP.LEG_NUM, FP.STNFR, FP.STNTO, FP.ACTYP, FP.REGNO, RT.RT_GROUPING, FP.ABHR, FP.PLN_TRIP_FUEL, \n");
    	sql.append("             FP.CHARGE, FP.FUEL_COST,  \n"); //2012.11.26 Ʒ ڵ ü : /*ROUND((CREW.CREW_COST/RFP.AVG_ABHR)*(FP.ABHR/60),3) CREW_COST, ROUND((MAINT.MAINTENANCE_COST/RFP.AVG_ABHR)*(FP.ABHR/60),3) MAINTENANCE_COST*/
    	// ROUND((CREW.CREW_COST/RFP.AVG_ABHR)*(FP.ABHR/60),3) CREW_COST, 
    	// ROUND((MAINT.MAINTENANCE_COST/RFP.AVG_ABHR)*(FP.ABHR/60),3) MAINTENANCE_COST
    	sql.append("             DECODE(RFP.AVG_ABHR, NULL, NULL, ROUND((CREW.CREW_COST/RFP.AVG_ABHR)*(FP.ABHR/60),3)) CREW_COST,  \n");
    	sql.append("             DECODE(RFP.AVG_ABHR, NULL, NULL, ROUND((MAINT.MAINTENANCE_COST/RFP.AVG_ABHR)*(FP.ABHR/60),3)) MAINTENANCE_COST \n");
    	sql.append("      FROM (SELECT AAA.FLIGHT_NUMBER, AAA.DEPARTURE_IATA_CTY_APO_CD, AAA.ARRIVAL_IATA_CTY_APO_CD, AAA.AIRCRAFT_VERSION_CODE, ROUND(AAA.CREW_COST/BBB.CONVERSION_RATE,2) CREW_COST \n");//@1.SUBSTR(AAA.AIRCRAFT_VERSION_CODE,0,3) AIRCRAFT_VERSION_CODE,
    	//2012.12.13 : AA.MONTHLY_AMT-> NVL(AA.MONTHLY_AMT,0)  ..AA->BB...
    	//sql.append("            FROM (SELECT SUBSTR(AA.FLIGHT_NUMBER,3,4) FLIGHT_NUMBER, AA.DEPARTURE_IATA_CTY_APO_CD, AA.ARRIVAL_IATA_CTY_APO_CD, \n");
    	//sql.append("                         AA.AIRCRAFT_VERSION_CODE, (AA.MONTHLY_AMT+BB.STANDARD_KRW_COST) CREW_COST \n");
    	sql.append("            FROM (SELECT SUBSTR(BB.FLIGHT_NUMBER,3,4) FLIGHT_NUMBER, BB.DEPARTURE_IATA_CTY_APO_CD, BB.ARRIVAL_IATA_CTY_APO_CD, \n");
    	sql.append("                         BB.AIRCRAFT_VERSION_CODE, (NVL(AA.MONTHLY_AMT,0)+BB.STANDARD_KRW_COST) CREW_COST \n");
    	sql.append("                  FROM (SELECT A.PERIOD_NAME, A.FLIGHT_NUMBER, A.DEPARTURE_IATA_CTY_APO_CD, A.ARRIVAL_IATA_CTY_APO_CD, \n");
    	sql.append("                               A.AIRCRAFT_VERSION_CODE, ROUND(SUM(A.MONTHLY_AMT/A.FRQ),3) MONTHLY_AMT\n");//@@@@@@@A.PERIOD_NAME, A.FLIGHT_NUMBER, A.DEPARTURE_IATA_CTY_APO_CD, A.ARRIVAL_IATA_CTY_APO_CD, A.AIRCRAFT_VERSION_CODE .. ¹  ٹð
    	sql.append("                        FROM KFOS.ERS_CABIN_CREW_COST_T A, (SELECT MAX(PERIOD_NAME) PERIOD_NAME \n");
    	sql.append("                                                       FROM KFOS.ERS_CABIN_CREW_COST_T \n");
    	sql.append("                                                       WHERE FLIGHT_NUMBER = 'KE'||'"+params.getPFltNum()+"' -- SELECTED FLT_NUM \n");
    	sql.append("                                                       AND DEPARTURE_IATA_CTY_APO_CD = '"+params.getPStnFr()+"' -- SELECTED STNFR \n");
    	sql.append("                                                       AND ARRIVAL_IATA_CTY_APO_CD = '"+params.getPStnTo()+"' -- SELECTED STNTO \n");
    	sql.append("                                                       AND SUBSTR(AIRCRAFT_VERSION_CODE,0,3) = '"+params.getPSacTyp()+"') B -- SELECTED SACTYP \n");
    	sql.append("                        WHERE A.PERIOD_NAME = B.PERIOD_NAME \n");
    	sql.append("                        AND A.FLIGHT_NUMBER = 'KE'||'"+params.getPFltNum()+"' -- SELECTED FLT_NUM \n");
    	sql.append("                        AND A.DEPARTURE_IATA_CTY_APO_CD = '"+params.getPStnFr()+"' -- SELECTED STNFR \n");
    	sql.append("                        AND A.ARRIVAL_IATA_CTY_APO_CD = '"+params.getPStnTo()+"' -- SELECTED STNTO \n");
    	sql.append("                        AND SUBSTR(A.AIRCRAFT_VERSION_CODE,0,3) = '"+params.getPSacTyp()+"' -- SELECTED SACTYP \n");
    	sql.append("                        GROUP BY A.PERIOD_NAME, A.FLIGHT_NUMBER, A.DEPARTURE_IATA_CTY_APO_CD, A.ARRIVAL_IATA_CTY_APO_CD, A.AIRCRAFT_VERSION_CODE) AA, \n");
    	sql.append("                        (SELECT C.PERIOD_NAME, C.FLIGHT_NUMBER, C.DEPARTURE_IATA_CTY_APO_CD, C.ARRIVAL_IATA_CTY_APO_CD, C.AIRCRAFT_VERSION_CODE, C.STANDARD_KRW_COST \n");
    	sql.append("                         FROM KFOS.ERS_COCKPIT_CREW_COST_T C, (SELECT MAX(PERIOD_NAME) PERIOD_NAME \n");
    	sql.append("                                                          FROM KFOS.ERS_COCKPIT_CREW_COST_T \n");
    	sql.append("                                                          WHERE FLIGHT_NUMBER = 'KE'||'"+params.getPFltNum()+"' -- SELECTED FLT_NUM \n");
    	sql.append("                                                          AND DEPARTURE_IATA_CTY_APO_CD = '"+params.getPStnFr()+"' -- SELECTED STNFR \n");
    	sql.append("                                                          AND ARRIVAL_IATA_CTY_APO_CD = '"+params.getPStnTo()+"' -- SELECTED STNTO \n");
    	sql.append("                                                          AND SUBSTR(AIRCRAFT_VERSION_CODE,0,3) = '"+params.getPSacTyp()+"') D -- SELECTED SACTYP \n");
    	sql.append("                         WHERE C.PERIOD_NAME = D.PERIOD_NAME \n");
    	sql.append("                         AND C.FLIGHT_NUMBER = 'KE'||'"+params.getPFltNum()+"' -- SELECTED FLT_NUM \n");
    	sql.append("                         AND C.DEPARTURE_IATA_CTY_APO_CD = '"+params.getPStnFr()+"' -- SELECTED STNFR \n");
    	sql.append("                         AND C.ARRIVAL_IATA_CTY_APO_CD = '"+params.getPStnTo()+"' -- SELECTED STNTO \n");
    	sql.append("                         AND SUBSTR(C.AIRCRAFT_VERSION_CODE,0,3) = '"+params.getPSacTyp()+"') BB -- SELECTED SACTYP \n");
    	sql.append("                  WHERE AA.FLIGHT_NUMBER(+) = BB.FLIGHT_NUMBER \n");//2012.12.13 AA.FLIGHT_NUMBER = BB.FLIGHT_NUMBER (+) ߰
    	sql.append("                  AND AA.DEPARTURE_IATA_CTY_APO_CD(+) = BB.DEPARTURE_IATA_CTY_APO_CD \n");
    	sql.append("                  AND AA.ARRIVAL_IATA_CTY_APO_CD(+) = BB.ARRIVAL_IATA_CTY_APO_CD \n");
    	sql.append("                  AND AA.AIRCRAFT_VERSION_CODE(+) = BB.AIRCRAFT_VERSION_CODE) AAA, (SELECT FROM_CURRENCY, TO_CURRENCY, CONVERSION_RATE \n");
    	sql.append("                                                                                 FROM (SELECT * FROM KFOS.TDAILY_RATES_II \n");
    	sql.append("                                                                                       WHERE FROM_CURRENCY = 'USD' \n");
    	sql.append("                                                                                       AND TO_CURRENCY = 'KRW' \n");
    	sql.append("                                                                                       AND USER_CONVERSION_TYPE = 'KE_CURRENCY_IATA_FD' \n");
    	sql.append("                                                                                       ORDER BY CONVERSION_DATE DESC) \n");
    	sql.append("                                                                                 WHERE ROWNUM = 1) BBB) CREW, \n");
    	sql.append("            (SELECT SUBSTR(AA.FLIGHT_NUMBER,3,4) FLIGHT_NUMBER, AA.DEPARTURE_IATA_CTY_APO_CD, AA.ARRIVAL_IATA_CTY_APO_CD, AA.AIRCRAFT_VERSION_CODE, ROUND(AA.MAINTENANCE_COST/BB.CONVERSION_RATE,2) MAINTENANCE_COST \n");//@2.SUBSTR(AA.AIRCRAFT_VERSION_CODE,0,3) AIRCRAFT_VERSION_CODE, 
    	sql.append("            FROM (SELECT A.PERIOD_NAME, A.FLIGHT_NUMBER, A.DEPARTURE_IATA_CTY_APO_CD, A.ARRIVAL_IATA_CTY_APO_CD, A.AIRCRAFT_VERSION_CODE, \n");
    	sql.append("                         ROUND(SUM(A.INVOICE_KRW_AMOUNT)/A.REVENUE_FLIGHT_OPERATION_COUNT,3) MAINTENANCE_COST \n");
    	sql.append("                  FROM KFOS.ERS_MAINTENANCE_COST_T A, (SELECT MAX(PERIOD_NAME) PERIOD_NAME \n");
    	sql.append("                                                  FROM KFOS.ERS_MAINTENANCE_COST_T \n");
    	sql.append("                                                  WHERE FLIGHT_NUMBER = 'KE'||'"+params.getPFltNum()+"' -- SELECTED FLT_NUM \n");
    	sql.append("                                                  AND DEPARTURE_IATA_CTY_APO_CD = '"+params.getPStnFr()+"' -- SELECTED STNFR \n");
    	sql.append("                                                  AND ARRIVAL_IATA_CTY_APO_CD = '"+params.getPStnTo()+"' -- SELECTED STNTO \n");
    	sql.append("                                                  AND SUBSTR(AIRCRAFT_VERSION_CODE,0,3) = '"+params.getPSacTyp()+"') B -- SELECTED SACTYP \n");
    	sql.append("                  WHERE A.PERIOD_NAME = B.PERIOD_NAME \n");
    	sql.append("                  AND A.FLIGHT_NUMBER = 'KE'||'"+params.getPFltNum()+"' -- SELECTED FLT_NUM \n");
    	sql.append("                  AND A.DEPARTURE_IATA_CTY_APO_CD = '"+params.getPStnFr()+"' -- SELECTED STNFR \n");
    	sql.append("                  AND A.ARRIVAL_IATA_CTY_APO_CD = '"+params.getPStnTo()+"' -- SELECTED STNTO \n");
    	sql.append("                  AND SUBSTR(A.AIRCRAFT_VERSION_CODE,0,3) = '"+params.getPSacTyp()+"' -- SELECTED SACTYP \n");
    	sql.append("                  GROUP BY A.PERIOD_NAME, A.FLIGHT_NUMBER, A.DEPARTURE_IATA_CTY_APO_CD, A.ARRIVAL_IATA_CTY_APO_CD, A.AIRCRAFT_VERSION_CODE, A.REVENUE_FLIGHT_OPERATION_COUNT) AA, \n");
    	sql.append("                  (SELECT FROM_CURRENCY, TO_CURRENCY, CONVERSION_RATE \n");
    	sql.append("                   FROM (SELECT * FROM KFOS.TDAILY_RATES_II \n");
    	sql.append("                         WHERE FROM_CURRENCY = 'USD' \n");
    	sql.append("                         AND TO_CURRENCY = 'KRW' \n");
    	sql.append("                         AND USER_CONVERSION_TYPE = 'KE_CURRENCY_IATA_FD' \n");
    	sql.append("                         ORDER BY CONVERSION_DATE DESC) \n");
    	sql.append("                   WHERE ROWNUM = 1) BB) MAINT, \n");
    	sql.append("            (SELECT A.FIRST_LEG_FLT_DT, A.FLT_NUM, A.LEG_NUM, A.STNFR, A.STNTO, A.ACTYP, A.REGION_CD, A.REGNO, A.ROUTE, A.ABHR, A.PLN_TRIP_FUEL, \n");
    	sql.append("                    A.CHARGE, ROUND(PLN_TRIP_FUEL*100*DECODE(B.INT_FUEL_UPRC_USD,NULL,3,B.INT_FUEL_UPRC_USD)/6.7,3) FUEL_COST \n");
    	sql.append("            FROM KFOS.FLIGHT_PLAN_T_PLAN A, (SELECT * \n");
    	sql.append("                                        FROM (SELECT IATA_PORT, INT_FUEL_UPRC_USD FROM KFOS.ERP_PORT_FUEL_UPRC_II \n");
    	sql.append("                                              WHERE IATA_PORT = '"+params.getPStnFr()+"' -- SELECTED STNFR\n");
    	sql.append("                                              ORDER BY TIMESTMP DESC) \n");
    	sql.append("                                        WHERE ROWNUM = 1) B \n");
    	sql.append("            WHERE A.FIRST_LEG_FLT_DT = TO_DATE('"+params.getPFirstLegFltDt()+"','YYYYMMDD') -- SELECTED FIRST_LEG_FLT_DT \n");
    	sql.append("            AND A.FLT_NUM = '"+params.getPFltNum()+"' -- SELECTED FLT_NUM \n");
    	sql.append("            AND A.STNFR = '"+params.getPStnFr()+"' -- SELECTED STNFR \n");
    	sql.append("            AND A.STNTO = '"+params.getPStnTo()+"' -- SELECTED STNTO \n");
    	sql.append("            AND A.ACTYP = '"+params.getPSacTyp()+"' -- SELECTED SACTYP \n");
    	sql.append("            AND A.CHARGE IS NOT NULL \n");
    	sql.append("            AND A.STNFR = B.IATA_PORT(+)) FP, (SELECT ROUND(AVG(ABHR)/60,3) AVG_ABHR FROM FLIGHT_PLAN_T \n");
    	sql.append("                                               WHERE FIRST_LEG_FLT_DT BETWEEN TRUNC(ADD_MONTHS(SYSDATE, -1) +1) - TO_CHAR(SYSDATE,'DD') AND TRUNC(LAST_DAY(ADD_MONTHS(SYSDATE,-1)))+0.99999421 \n");
    	sql.append("                                               AND ACTIVE = 'Y' \n");
    	sql.append("                                               AND FLT_NUM = '"+params.getPFltNum()+"' -- SELECTED FLT_NUM \n");
    	sql.append("                                               AND STNFR = '"+params.getPStnFr()+"' -- SELECTED STNFR \n");
    	sql.append("                                               AND ACTYP = '"+params.getPSacTyp()+"') RFP, KFOS.ERS_ROUTE_T RT, DAILY_SCH_T DS -- SELECTED SACTYP \n");//@3.DAILY_SCH_T DS
    	sql.append(" WHERE DS.FLT_NUM = CREW.FLIGHT_NUMBER(+) \n");
    	sql.append(" AND DS.FLT_NUM = MAINT.FLIGHT_NUMBER(+) \n");
    	sql.append(" AND DS.STNFR = CREW.DEPARTURE_IATA_CTY_APO_CD(+) \n");
    	sql.append(" AND DS.STNFR = MAINT.DEPARTURE_IATA_CTY_APO_CD(+) \n");
    	sql.append(" AND DS.STNTO = CREW.ARRIVAL_IATA_CTY_APO_CD(+) \n");
    	sql.append(" AND DS.STNTO = MAINT.ARRIVAL_IATA_CTY_APO_CD(+) \n");
    	sql.append(" AND DS.ACVER = CREW.AIRCRAFT_VERSION_CODE(+) \n");
    	sql.append(" AND DS.ACVER = MAINT.AIRCRAFT_VERSION_CODE(+) \n");
    	
    	sql.append(" AND FP.FIRST_LEG_FLT_DT = DS.FIRST_LEG_FLT_DT \n");
    	sql.append(" AND FP.FLT_NUM = DS.FLT_NUM \n");
    	sql.append(" AND FP.STNFR = DS.STNFR \n");
    	sql.append(" AND FP.STNTO = DS.STNTO \n");
    	sql.append(" AND DS.ACTNID<>'CNL' \n");
    	
    	sql.append(" AND RT.REGION(+) = FP.REGION_CD \n");
    	sql.append(" AND RT.ROUTE_ID(+) = SUBSTR(FP.ROUTE,0,3) \n");
    	/* 2012.11.26  ڵ ü
    	sql.append("      WHERE FP.FLT_NUM = CREW.FLIGHT_NUMBER(+) \n");
    	sql.append("      AND FP.FLT_NUM = MAINT.FLIGHT_NUMBER(+) \n");
    	sql.append("      AND FP.STNFR = CREW.DEPARTURE_IATA_CTY_APO_CD(+) \n");
    	sql.append("      AND FP.STNFR = MAINT.DEPARTURE_IATA_CTY_APO_CD(+) \n");
    	sql.append("      AND FP.STNTO = CREW.ARRIVAL_IATA_CTY_APO_CD(+) \n");
    	sql.append("      AND FP.STNTO = MAINT.ARRIVAL_IATA_CTY_APO_CD(+) \n");
    	//sql.append("      AND FP.ACTYP = CREW.AIRCRAFT_VERSION_CODE(+) \n");@4. ּó
    	//sql.append("      AND FP.ACTYP = MAINT.AIRCRAFT_VERSION_CODE(+) \n");@5. ּó
    	sql.append("      AND RT.REGION(+) = FP.REGION_CD \n");
    	sql.append("      AND FP.FIRST_LEG_FLT_DT = DS.FIRST_LEG_FLT_DT ");//@5.
    	sql.append("      AND FP.FLT_NUM = DS.FLT_NUM \n");
    	sql.append("      AND FP.STNFR = DS.STNFR \n");
    	sql.append("      AND FP.STNTO = DS.STNTO \n");
    	sql.append("      AND DS.ACTNID <> 'CNL' \n");
    	sql.append("      AND DS.ACVER = CREW.AIRCRAFT_VERSION_CODE \n");
    	sql.append("      AND DS.ACVER = MAINT.AIRCRAFT_VERSION_CODE \n");//߰ 
    	sql.append("      AND RT.ROUTE_ID(+) = SUBSTR(FP.ROUTE,0,3) -- 2012/11/13 ߰ \n");
    	*/
    	sql.append("      ORDER BY FP.ROUTE ASC) AL, KFOS.ERS_MASTER_T MAST \n");
    	sql.append("WHERE AL.FIRST_LEG_FLT_DT = MAST.FIRST_LEG_FLT_DT(+) \n");
    	sql.append("AND AL.FLT_NUM = MAST.FLT_NUM(+) \n");
    	sql.append("AND AL.LEG_NUM = MAST.LEG_NUM(+) \n");
    	sql.append("AND AL.STNFR = MAST.STNFR(+) \n");
    	sql.append("AND AL.STNTO = MAST.STNTO(+)\n");
    	sql.append("AND AL.RT_GROUPING = MAST.ROUTE(+) \n");
    	
    	//System.out.println(sql.toString());
    	    	
    	return sql.toString();
    }
    
    public String selEnabledRouteListORG(FfsA080BG params){//2013-02-14
    	StringBuffer sql = new StringBuffer();    	

    	sql.append("\n	SELECT DISTINCT ");
    	sql.append("\n		AL.FIRST_LEG_FLT_DT");
    	sql.append("\n	,	AL.FLT_NUM");
    	sql.append("\n	,	AL.LEG_NUM");
    	sql.append("\n	,	AL.STNFR");
    	sql.append("\n	,	AL.STNTO");
    	sql.append("\n	,	AL.ACTYP");
    	sql.append("\n	,	AL.REGNO");
    	sql.append("\n	,	AL.ROUTE");//@2013-12-04  (ּ:2013.03.20 ߰ κ)
    	sql.append("\n	,	NVL(AL.RT_GROUPING,'****') RT_GROUPING");
    	sql.append("\n	,	NVL(MAST.REASON_1,	'') REASON_1");
    	sql.append("\n	,	NVL(MAST.REASON_2,	'') REASON_2");
    	sql.append("\n	,	MAST.ROUTE MAST_RT_GROUPING");
    	sql.append("\n	,	MAST.PLN_TRIP_FUEL MAST_PLN_TRIP_FUEL");
    	sql.append("\n	,	AL.ABHR");
    	sql.append("\n	,	AL.PLN_TRIP_FUEL");
    	sql.append("\n	,	AL.CHARGE");
    	sql.append("\n	,	AL.FUEL_COST");
    	//sql.append("\n	,	AL.CREW_COST");
    	//sql.append("\n	,	AL.MAINTENANCE_COST");
    	sql.append("\n	,	NVL(AL.CREW_COST,MAST.CREW_COST) CREW_COST");
    	sql.append("\n	,	NVL(AL.MAINTENANCE_COST,MAST.MAINT_COST) MAINTENANCE_COST");    	
    	sql.append("\n	,	DECODE(NVL(MAST.CONFIRM_Y,	''),	'Y',	'Y',	'N') CONF");
    	sql.append("\n	,	DECODE(MAST.CHK,'Y','Y','N') CHK");
    	sql.append("\n	FROM ");
    	sql.append("\n		(");
    	sql.append("\n			SELECT FP.FIRST_LEG_FLT_DT");
    	sql.append("\n			,	FP.FLT_NUM");
    	sql.append("\n			,	FP.LEG_NUM");
    	sql.append("\n			,	FP.STNFR");
    	sql.append("\n			,	FP.STNTO");
    	sql.append("\n			,	FP.ACTYP");
    	sql.append("\n			,	FP.REGNO");
    	sql.append("\n			,	FP.ROUTE");
    	sql.append("\n			,	RT.RT_GROUPING");
    	sql.append("\n			,	FP.ABHR");
    	//sql.append("\n			,	FP.PLN_TRIP_FUEL*100 PLN_TRIP_FUEL");
    	sql.append("\n			,	FP.PLN_TRIP_FUEL");
    	sql.append("\n			,	FP.CHARGE");
    	sql.append("\n			,	FP.FUEL_COST");
    	sql.append("\n			,	DECODE(RFP.AVG_ABHR,	NULL,	NULL,	ROUND((CREW.CREW_COST/RFP.AVG_ABHR)*(FP.ABHR/60),	3)) CREW_COST");
    	sql.append("\n			,	DECODE(RFP.AVG_ABHR,	NULL,	NULL,	ROUND((MAINT.MAINTENANCE_COST/RFP.AVG_ABHR)*(FP.ABHR/60),	3)) MAINTENANCE_COST");
    	sql.append("\n			FROM");
    	sql.append("\n				(");
    	sql.append("\n					SELECT ");
    	sql.append("\n						AAA.DEPARTURE_IATA_CTY_APO_CD");
    	sql.append("\n					,	AAA.ARRIVAL_IATA_CTY_APO_CD");
    	sql.append("\n					,	AAA.AIRCRAFT_VERSION_CODE");
    	sql.append("\n					,	ROUND(AAA.CREW_COST/BBB.CONVERSION_RATE,	2) CREW_COST");
    	sql.append("\n					FROM");
    	sql.append("\n						(");
    	sql.append("\n							SELECT ");
    	sql.append("\n								BB.DEPARTURE_IATA_CTY_APO_CD");
    	sql.append("\n							,	BB.ARRIVAL_IATA_CTY_APO_CD");
    	sql.append("\n							,	BB.AIRCRAFT_VERSION_CODE");
    	sql.append("\n							,	AVG((NVL(AA.MONTHLY_AMT,	0)+BB.STANDARD_KRW_COST)) CREW_COST");
    	sql.append("\n							FROM");
    	sql.append("\n								(");
    	sql.append("\n									SELECT ");
    	sql.append("\n										A.PERIOD_NAME");
    	sql.append("\n									,	A.DEPARTURE_IATA_CTY_APO_CD");
    	sql.append("\n									,	A.ARRIVAL_IATA_CTY_APO_CD");
    	sql.append("\n									,	A.AIRCRAFT_VERSION_CODE");
    	sql.append("\n									,	ROUND(SUM(A.MONTHLY_AMT/A.FRQ),	3) MONTHLY_AMT");
    	sql.append("\n									 FROM ");
    	sql.append("\n										KFOS.ERS_CABIN_CREW_COST_T A");
    	sql.append("\n									,	(");
    	sql.append("\n											SELECT ");
    	sql.append("\n												MAX(PERIOD_NAME) PERIOD_NAME");
    	sql.append("\n											FROM ");
    	sql.append("\n												KFOS.ERS_CABIN_CREW_COST_T ");
    	sql.append("\n											WHERE ");
    	sql.append("\n												DEPARTURE_IATA_CTY_APO_CD = '"+params.getPStnFr()+"' -- SELECTED STNFR");
    	sql.append("\n											AND ARRIVAL_IATA_CTY_APO_CD = '"+params.getPStnTo()+"' -- SELECTED STNTO");
    	sql.append("\n											AND SUBSTR(AIRCRAFT_VERSION_CODE,	0,	3) = '"+params.getPSacTyp()+"'");
    	sql.append("\n										) B -- SELECTED SACTYP");
    	sql.append("\n									WHERE ");
    	sql.append("\n										A.PERIOD_NAME = B.PERIOD_NAME");
    	sql.append("\n									AND A.DEPARTURE_IATA_CTY_APO_CD = '"+params.getPStnFr()+"' -- SELECTED STNFR");
    	sql.append("\n									AND A.ARRIVAL_IATA_CTY_APO_CD = '"+params.getPStnTo()+"' -- SELECTED STNTO");
    	sql.append("\n									AND SUBSTR(A.AIRCRAFT_VERSION_CODE,	0,	3) = '"+params.getPSacTyp()+"' -- SELECTED SACTYP");
    	sql.append("\n									GROUP BY ");
    	sql.append("\n										A.PERIOD_NAME");
    	sql.append("\n									,	A.DEPARTURE_IATA_CTY_APO_CD");
    	sql.append("\n									,	A.ARRIVAL_IATA_CTY_APO_CD");
    	sql.append("\n									,	A.AIRCRAFT_VERSION_CODE");
    	sql.append("\n								) AA");
    	sql.append("\n							,	(");
    	sql.append("\n									SELECT C.PERIOD_NAME");
    	sql.append("\n									,	C.DEPARTURE_IATA_CTY_APO_CD");
    	sql.append("\n									,	C.ARRIVAL_IATA_CTY_APO_CD");
    	sql.append("\n									,	C.AIRCRAFT_VERSION_CODE");
    	sql.append("\n									,	C.STANDARD_KRW_COST");
    	sql.append("\n									FROM ");
    	sql.append("\n										KFOS.ERS_COCKPIT_CREW_COST_T C");
    	sql.append("\n									,	(");
    	sql.append("\n											SELECT ");
    	sql.append("\n												MAX(PERIOD_NAME) PERIOD_NAME");
    	sql.append("\n											FROM KFOS.ERS_COCKPIT_CREW_COST_T");
    	sql.append("\n											WHERE ");
    	sql.append("\n												DEPARTURE_IATA_CTY_APO_CD = '"+params.getPStnFr()+"' -- SELECTED STNFR");
    	sql.append("\n											AND ARRIVAL_IATA_CTY_APO_CD = '"+params.getPStnTo()+"' -- SELECTED STNTO");
    	sql.append("\n											AND SUBSTR(AIRCRAFT_VERSION_CODE,	0,	3) = '"+params.getPSacTyp()+"'");
    	sql.append("\n										) D -- SELECTED SACTYP");
    	sql.append("\n									WHERE C.PERIOD_NAME = D.PERIOD_NAME");
    	sql.append("\n									AND C.DEPARTURE_IATA_CTY_APO_CD = '"+params.getPStnFr()+"' -- SELECTED STNFR");
    	sql.append("\n									AND C.ARRIVAL_IATA_CTY_APO_CD = '"+params.getPStnTo()+"' -- SELECTED STNTO");
    	sql.append("\n									AND SUBSTR(C.AIRCRAFT_VERSION_CODE,	0,	3) = '"+params.getPSacTyp()+"'");
    	sql.append("\n								) BB -- SELECTED SACTYP");
    	sql.append("\n							WHERE ");
    	sql.append("\n								AA.DEPARTURE_IATA_CTY_APO_CD(+) = BB.DEPARTURE_IATA_CTY_APO_CD");
    	sql.append("\n							AND AA.ARRIVAL_IATA_CTY_APO_CD(+) = BB.ARRIVAL_IATA_CTY_APO_CD");
    	sql.append("\n							AND AA.AIRCRAFT_VERSION_CODE(+) = BB.AIRCRAFT_VERSION_CODE");
    	sql.append("\n							GROUP BY ");
    	sql.append("\n								BB.DEPARTURE_IATA_CTY_APO_CD");
    	sql.append("\n							,	BB.ARRIVAL_IATA_CTY_APO_CD");
    	sql.append("\n							,	BB.AIRCRAFT_VERSION_CODE");
    	sql.append("\n						) AAA");
    	sql.append("\n					,	(");
    	sql.append("\n							SELECT FROM_CURRENCY");
    	sql.append("\n							,	TO_CURRENCY");
    	sql.append("\n							,	CONVERSION_RATE");
    	sql.append("\n							FROM ");
    	sql.append("\n							(");
    	sql.append("\n								SELECT * FROM KFOS.TDAILY_RATES_II");
    	sql.append("\n								WHERE");
    	sql.append("\n									FROM_CURRENCY = 'USD'");
    	sql.append("\n								AND TO_CURRENCY = 'KRW'");
    	sql.append("\n								AND USER_CONVERSION_TYPE = 'KE_CURRENCY_IATA_FD'");
    	sql.append("\n								ORDER BY CONVERSION_DATE DESC");
    	sql.append("\n							)");
    	sql.append("\n							WHERE ROWNUM = 1");
    	sql.append("\n						) BBB");
    	sql.append("\n					WHERE ROWNUM = 1");//@2013-12-04  (ּ:2013.11.28 ߰ κ)
    	sql.append("\n				) CREW");
    	sql.append("\n			,	(");
    	sql.append("\n					SELECT * FROM (");//@2013-12-04  (ּ:2013.11.28 ߰ κ)
    	sql.append("\n						SELECT AA.DEPARTURE_IATA_CTY_APO_CD");
    	sql.append("\n						,	AA.ARRIVAL_IATA_CTY_APO_CD");
    	sql.append("\n						,	AA.AIRCRAFT_VERSION_CODE");
    	sql.append("\n						,	ROUND(AA.MAINTENANCE_COST/BB.CONVERSION_RATE");
    	sql.append("\n						,	2) MAINTENANCE_COST");
    	sql.append("\n						FROM");
    	sql.append("\n							(");
    	sql.append("\n								SELECT PERIOD_NAME");
    	sql.append("\n								,	DEPARTURE_IATA_CTY_APO_CD");
    	sql.append("\n								,	ARRIVAL_IATA_CTY_APO_CD");
    	sql.append("\n								,	AIRCRAFT_VERSION_CODE");
    	sql.append("\n								,	ROUND(AVG(MAINTENANCE_COST),	3) MAINTENANCE_COST");
    	sql.append("\n								FROM ");
    	sql.append("\n									(");
    	sql.append("\n										SELECT A.PERIOD_NAME");
    	sql.append("\n										,	A.DEPARTURE_IATA_CTY_APO_CD");
    	sql.append("\n										,	A.ARRIVAL_IATA_CTY_APO_CD");
    	sql.append("\n										,	A.AIRCRAFT_VERSION_CODE");
    	sql.append("\n										,	ROUND(SUM(A.INVOICE_KRW_AMOUNT)/A.REVENUE_FLIGHT_OPERATION_COUNT,	3) MAINTENANCE_COST");
    	sql.append("\n										 FROM KFOS.ERS_MAINTENANCE_COST_T A");
    	sql.append("\n										,	(");
    	sql.append("\n										SELECT MAX(PERIOD_NAME) PERIOD_NAME");
    	sql.append("\n										FROM");
    	sql.append("\n											KFOS.ERS_MAINTENANCE_COST_T");
    	sql.append("\n										WHERE ");
    	sql.append("\n											DEPARTURE_IATA_CTY_APO_CD = '"+params.getPStnFr()+"' -- SELECTED STNFR");
    	sql.append("\n										AND ARRIVAL_IATA_CTY_APO_CD = '"+params.getPStnTo()+"' -- SELECTED STNTO");
    	sql.append("\n										AND SUBSTR(AIRCRAFT_VERSION_CODE,	0,	3) = '"+params.getPSacTyp()+"'");
    	sql.append("\n									) B -- SELECTED SACTYP");
    	sql.append("\n								WHERE ");
    	sql.append("\n									A.PERIOD_NAME = B.PERIOD_NAME");
    	sql.append("\n								AND A.DEPARTURE_IATA_CTY_APO_CD = '"+params.getPStnFr()+"' -- SELECTED STNFR");
    	sql.append("\n								AND A.ARRIVAL_IATA_CTY_APO_CD = '"+params.getPStnTo()+"' -- SELECTED STNTO");
    	sql.append("\n								AND SUBSTR(A.AIRCRAFT_VERSION_CODE,	0,	3) = '"+params.getPSacTyp()+"' -- SELECTED SACTYP");
    	sql.append("\n								GROUP BY ");
    	sql.append("\n									A.PERIOD_NAME");
    	sql.append("\n								,	A.DEPARTURE_IATA_CTY_APO_CD");
    	sql.append("\n								,	A.ARRIVAL_IATA_CTY_APO_CD");
    	sql.append("\n								,	A.AIRCRAFT_VERSION_CODE");
    	sql.append("\n								,	A.REVENUE_FLIGHT_OPERATION_COUNT");
    	sql.append("\n							)");
    	sql.append("\n						GROUP BY ");
    	sql.append("\n							PERIOD_NAME");
    	sql.append("\n						,	DEPARTURE_IATA_CTY_APO_CD");
    	sql.append("\n						,	ARRIVAL_IATA_CTY_APO_CD");
    	sql.append("\n						,	AIRCRAFT_VERSION_CODE)AA");
    	sql.append("\n						,	(");
    	sql.append("\n								SELECT ");
    	sql.append("\n									FROM_CURRENCY");
    	sql.append("\n								,	TO_CURRENCY");
    	sql.append("\n								,	CONVERSION_RATE");
    	sql.append("\n								FROM ");
    	sql.append("\n									(");
    	sql.append("\n										SELECT * FROM KFOS.TDAILY_RATES_II");
    	sql.append("\n										WHERE FROM_CURRENCY = 'USD'");
    	sql.append("\n										AND TO_CURRENCY = 'KRW'");
    	sql.append("\n										AND USER_CONVERSION_TYPE = 'KE_CURRENCY_IATA_FD'");
    	sql.append("\n										ORDER BY CONVERSION_DATE DESC");
    	sql.append("\n									)");
    	sql.append("\n								WHERE ROWNUM = 1");
    	sql.append("\n							) BB");
    	sql.append("\n					) WHERE ROWNUM = 1");//@2013-12-04  (ּ:2013.11.28 ߰ κ)
    	sql.append("\n				) MAINT");
    	sql.append("\n			,	(");
    	sql.append("\n					SELECT A.FIRST_LEG_FLT_DT");
    	sql.append("\n					,	A.FLT_NUM");
    	sql.append("\n					,	A.LEG_NUM");
    	sql.append("\n					,	A.STNFR");
    	sql.append("\n					,	A.STNTO");
    	sql.append("\n					,	A.ACTYP");
    	sql.append("\n					,	A.REGION_CD");
    	sql.append("\n					,	A.REGNO");
    	sql.append("\n					,	A.ROUTE");
    	sql.append("\n					,	A.ABHR");
    	sql.append("\n					,	A.PLN_TRIP_FUEL");
    	sql.append("\n					,	A.CHARGE");
    	sql.append("\n					,	ROUND(PLN_TRIP_FUEL*100*DECODE(B.INT_FUEL_UPRC_USD,	NULL,	3,	B.INT_FUEL_UPRC_USD)/6.7,	3) FUEL_COST");
    	//sql.append("\n					,	ROUND(PLN_TRIP_FUEL*DECODE(B.INT_FUEL_UPRC_USD,	NULL,	3,	B.INT_FUEL_UPRC_USD)/6.7,	3) FUEL_COST");
    	sql.append("\n					FROM");
    	sql.append("\n						KFOS.FLIGHT_PLAN_T_PLAN A");
    	sql.append("\n					,	(");
    	sql.append("\n							SELECT *");
    	sql.append("\n							FROM");
    	sql.append("\n								(");
    	sql.append("\n									SELECT");
    	sql.append("\n										IATA_PORT");
    	sql.append("\n									,	INT_FUEL_UPRC_USD ");
    	sql.append("\n									FROM ");
    	sql.append("\n										KFOS.ERP_PORT_FUEL_UPRC_II");
    	sql.append("\n									WHERE ");
    	sql.append("\n										IATA_PORT = '"+params.getPStnFr()+"' -- SELECTED STNFR");
    	sql.append("\n									ORDER BY TIMESTMP DESC");
    	sql.append("\n								)");
    	sql.append("\n							WHERE ROWNUM = 1");
    	sql.append("\n						) B");
    	sql.append("\n					WHERE ");
    	sql.append("\n						A.FIRST_LEG_FLT_DT = TO_DATE('"+params.getPFirstLegFltDt()+"',	'YYYYMMDD') -- SELECTED FIRST_LEG_FLT_DT");
    	sql.append("\n					AND A.FLT_NUM = '"+params.getPFltNum()+"' -- SELECTED FLT_NUM");
    	sql.append("\n					AND A.STNFR = '"+params.getPStnFr()+"' -- SELECTED STNFR");
    	sql.append("\n					AND A.STNTO = '"+params.getPStnTo()+"' -- SELECTED STNTO");
    	sql.append("\n					AND A.ACTYP = '"+params.getPSacTyp()+"' -- SELECTED SACTYP");
    	sql.append("\n					AND A.CHARGE IS NOT NULL");
    	sql.append("\n					AND A.STNFR = B.IATA_PORT(+)");
    	sql.append("\n				) FP");
    	sql.append("\n			,	(");
    	sql.append("\n					SELECT ROUND(AVG(ABHR)/60,	3) AVG_ABHR ");
    	sql.append("\n					FROM FLIGHT_PLAN_T");
    	sql.append("\n					WHERE");
    	sql.append("\n						FIRST_LEG_FLT_DT BETWEEN TRUNC(ADD_MONTHS(SYSDATE,	-3) +1) - TO_CHAR(SYSDATE,	'DD') ");
    	sql.append("\n					AND TRUNC(LAST_DAY(ADD_MONTHS(SYSDATE,	-1)))+0.99999421");
    	sql.append("\n					AND ACTIVE = 'Y'");
    	sql.append("\n					AND STNFR = '"+params.getPStnFr()+"' -- SELECTED STNFR");
    	sql.append("\n					AND STNTO = '"+params.getPStnTo()+"' -- SELECTED STNTO");
    	sql.append("\n					AND ACTYP = '"+params.getPSacTyp()+"'");
    	sql.append("\n				) RFP");
    	sql.append("\n			,	KFOS.ERS_ROUTE_T RT");
    	sql.append("\n			,	DAILY_SCH_T DS -- SELECTED SACTYP");
    	sql.append("\n			WHERE");
    	sql.append("\n				DS.STNFR = CREW.DEPARTURE_IATA_CTY_APO_CD(+)");
    	sql.append("\n			AND DS.STNFR = MAINT.DEPARTURE_IATA_CTY_APO_CD(+)");
    	sql.append("\n			AND DS.STNTO = CREW.ARRIVAL_IATA_CTY_APO_CD(+)");
    	sql.append("\n			AND DS.STNTO = MAINT.ARRIVAL_IATA_CTY_APO_CD(+)");
    	//sql.append("\n			AND DS.ACVER = CREW.AIRCRAFT_VERSION_CODE(+)");//@2013-12-04
    	//sql.append("\n			AND DS.ACVER = MAINT.AIRCRAFT_VERSION_CODE(+)");//@2013-12-04
    	sql.append("\n			AND DS.SACTYP = SUBSTR(CREW.AIRCRAFT_VERSION_CODE(+),0,3)");//@2013-12-04  (ּ:2013.03.20  κ)
    	sql.append("\n			AND DS.SACTYP = SUBSTR(MAINT.AIRCRAFT_VERSION_CODE(+),0,3)");//@2013-12-04  (ּ:2013.03.20  κ)
    	sql.append("\n			AND FP.FIRST_LEG_FLT_DT = DS.FIRST_LEG_FLT_DT");
    	sql.append("\n			AND FP.FLT_NUM = DS.FLT_NUM");
    	sql.append("\n			AND FP.STNFR = DS.STNFR");
    	sql.append("\n			AND FP.STNTO = DS.STNTO");
    	sql.append("\n			AND DS.ACTNID <> 'CNL'");
    	sql.append("\n			AND RT.REGION(+) = FP.REGION_CD");
    	sql.append("\n			AND RT.ROUTE_ID(+) = SUBSTR(FP.ROUTE,	0,	3)");
    	sql.append("\n			ORDER BY FP.ROUTE ASC");
    	sql.append("\n		) AL");
    	sql.append("\n	,	KFOS.ERS_MASTER_T MAST");
    	sql.append("\n	WHERE ");
    	sql.append("\n		AL.FIRST_LEG_FLT_DT = MAST.FIRST_LEG_FLT_DT(+)");
    	sql.append("\n	AND AL.FLT_NUM = MAST.FLT_NUM(+)");
    	sql.append("\n	AND AL.LEG_NUM = MAST.LEG_NUM(+)");
    	sql.append("\n	AND AL.STNFR = MAST.STNFR(+)");
    	sql.append("\n	AND AL.STNTO = MAST.STNTO(+)");
    	sql.append("\n	AND AL.RT_GROUPING = MAST.ROUTE(+)");
    	sql.append("\n	AND AL.ABHR = MAST.ABHR(+)");
    	//sql.append("\n	AND AL.PLN_TRIP_FUEL = MAST.PLN_TRIP_FUEL(+)*100");
    	sql.append("\n	AND AL.PLN_TRIP_FUEL = MAST.PLN_TRIP_FUEL(+)");
    	sql.append("\n	ORDER BY ");
    	sql.append("\n		NVL(AL.RT_GROUPING,'****')");
    	sql.append("\n	,	AL.ROUTE");//@2013-12-04(ּ: 2013.03.20 ߰ κ)
    	sql.append("\n	");

    	
    	//System.out.println(sql.toString());
    	
    	return sql.toString();
    }
    //20150608 
    public String selEnabledRouteList_back2(FfsA080BG params){
    	StringBuffer sql = new StringBuffer();    	
    	
    	/*
    	sql.append("\n		SELECT DISTINCT ");
    	sql.append("\n		AL.FIRST_LEG_FLT_DT ");
    	sql.append("\n	,	AL.FLT_NUM ");
    	sql.append("\n	,	AL.LEG_NUM ");
    	sql.append("\n	,	AL.STNFR ");
    	sql.append("\n	,	AL.STNTO ");
    	sql.append("\n	,	AL.ACTYP ");
    	sql.append("\n	,	AL.REGNO ");
    	sql.append("\n	,	AL.ROUTE ");	//@2013-12-04  (ּ:2013.03.20 ߰ κ)
    	sql.append("\n	,	NVL(AL.RT_GROUPING,'****') RT_GROUPING ");
    	sql.append("\n	,	NVL(MAST.REASON_1,	'') REASON_1 ");
    	sql.append("\n	,	NVL(MAST.REASON_2,	'') REASON_2 ");
    	sql.append("\n	,	MAST.ROUTE MAST_RT_GROUPING ");
    	sql.append("\n	,	MAST.PLN_TRIP_FUEL MAST_PLN_TRIP_FUEL ");
    	sql.append("\n	,	AL.ABHR ");
    	sql.append("\n	,	AL.PLN_TRIP_FUEL ");
    	sql.append("\n	,	AL.CHARGE ");
    	sql.append("\n	,	AL.FUEL_COST ");
//    	sql.append("\n	,	AL.CREW_COST ");
//    	sql.append("\n	,	AL.MAINTENANCE_COST ");
    	sql.append("\n	,	NVL(AL.CREW_COST,MAST.CREW_COST) CREW_COST ");
    	sql.append("\n	,	NVL(AL.MAINTENANCE_COST,MAST.MAINT_COST) MAINTENANCE_COST    	 ");
    	sql.append("\n	,	DECODE(NVL(MAST.CONFIRM_Y,	''),	'Y',	'Y',	'N') CONF ");
    	sql.append("\n	,	DECODE(MAST.CHK,'Y','Y','N') CHK ");
    	sql.append("\n	FROM ");
    	sql.append("\n		( ");
    	sql.append("\n			SELECT FP.FIRST_LEG_FLT_DT ");
    	sql.append("\n			,	FP.FLT_NUM ");
    	sql.append("\n			,	FP.LEG_NUM ");
    	sql.append("\n			,	FP.STNFR ");
    	sql.append("\n			,	FP.STNTO ");
    	sql.append("\n			,	FP.ACTYP ");
    	sql.append("\n			,	FP.REGNO ");
    	sql.append("\n			,	FP.ROUTE ");
    	sql.append("\n			,	RT.RT_GROUPING ");
    	sql.append("\n			,	FP.ABHR ");
//    	sql.append("\n			,	FP.PLN_TRIP_FUEL*100 PLN_TRIP_FUEL ");
    	sql.append("\n			,	FP.PLN_TRIP_FUEL ");
    	sql.append("\n			,	FP.CHARGE ");
    	sql.append("\n			,	FP.FUEL_COST ");
    	sql.append("\n			,	DECODE(RFP.AVG_ABHR,	NULL,	NULL,	ROUND((CREW.CREW_COST/RFP.AVG_ABHR)*(FP.ABHR/60),	3)) CREW_COST ");
    	sql.append("\n			,	DECODE(RFP.AVG_ABHR,	NULL,	NULL,	ROUND((MAINT.MAINTENANCE_COST/RFP.AVG_ABHR)*(FP.ABHR/60),	3)) MAINTENANCE_COST ");
    	sql.append("\n			FROM ");
    	sql.append("\n				( ");
    	sql.append("\n					SELECT ");
    	sql.append("\n						AAA.DEPARTURE_IATA_CTY_APO_CD ");
    	sql.append("\n					,	AAA.ARRIVAL_IATA_CTY_APO_CD ");
    	sql.append("\n					,	AAA.AIRCRAFT_VERSION_CODE ");
    	sql.append("\n					,	ROUND(AAA.CREW_COST/BBB.CONVERSION_RATE,	2) CREW_COST ");
    	sql.append("\n					FROM ");
    	sql.append("\n						( ");
    	sql.append("\n							SELECT ");
    	sql.append("\n								BB.DEPARTURE_IATA_CTY_APO_CD ");
    	sql.append("\n							,	BB.ARRIVAL_IATA_CTY_APO_CD ");
    	sql.append("\n							,	BB.AIRCRAFT_VERSION_CODE ");
    	sql.append("\n							,	AVG((NVL(AA.MONTHLY_AMT,	0)+BB.STANDARD_KRW_COST)) CREW_COST ");
    	sql.append("\n							FROM ");
    	sql.append("\n								( ");
    	sql.append("\n									SELECT ");
    	sql.append("\n										A.PERIOD_NAME ");
    	sql.append("\n									,	A.DEPARTURE_IATA_CTY_APO_CD ");
    	sql.append("\n									,	A.ARRIVAL_IATA_CTY_APO_CD ");
//    	sql.append("\n									,	A.AIRCRAFT_VERSION_CODE ");
    	sql.append("\n									,	A.FLIGHT_NUMBER  ");
    	sql.append("\n									,	SUBSTR(A.AIRCRAFT_VERSION_CODE,	0,	3) AIRCRAFT_VERSION_CODE  ");
    	sql.append("\n									,	ROUND(SUM(A.MONTHLY_AMT/A.FRQ),	3) MONTHLY_AMT ");
    	sql.append("\n									 FROM ");
    	sql.append("\n										KFOS.ERS_CABIN_CREW_COST_T A ");
    	sql.append("\n									,	( ");
    	sql.append("\n											SELECT ");
    	sql.append("\n												MAX(PERIOD_NAME) PERIOD_NAME ");
    	sql.append("\n											FROM ");
    	sql.append("\n												KFOS.ERS_CABIN_CREW_COST_T ");
    	sql.append("\n											WHERE ");
    	sql.append("\n												DEPARTURE_IATA_CTY_APO_CD = '"+params.getPStnFr()+"' -- SELECTED STNFR ");
    	sql.append("\n											AND ARRIVAL_IATA_CTY_APO_CD = '"+params.getPStnTo()+"' -- SELECTED STNTO ");
    	sql.append("\n											AND SUBSTR(AIRCRAFT_VERSION_CODE,	0,	3) = '"+params.getPSacTyp()+"' ");
    	sql.append("\n										) B -- SELECTED SACTYP ");
    	sql.append("\n									WHERE ");
    	sql.append("\n										A.PERIOD_NAME = B.PERIOD_NAME ");
    	sql.append("\n									AND A.DEPARTURE_IATA_CTY_APO_CD = '"+params.getPStnFr()+"' -- SELECTED STNFR ");
    	sql.append("\n									AND A.ARRIVAL_IATA_CTY_APO_CD = '"+params.getPStnTo()+"' -- SELECTED STNTO ");
    	sql.append("\n									AND SUBSTR(A.AIRCRAFT_VERSION_CODE,	0,	3) = '"+params.getPSacTyp()+"' -- SELECTED SACTYP ");
    	sql.append("\n									GROUP BY ");
    	sql.append("\n										A.PERIOD_NAME ");
    	sql.append("\n									,	A.DEPARTURE_IATA_CTY_APO_CD ");
    	sql.append("\n									,	A.ARRIVAL_IATA_CTY_APO_CD ");
//    	sql.append("\n									,	A.AIRCRAFT_VERSION_CODE ");
    	sql.append("\n									,	A.FLIGHT_NUMBER  ");
    	sql.append("\n									,	SUBSTR(A.AIRCRAFT_VERSION_CODE,	0,	3)  ");
    	sql.append("\n								) AA ");
    	sql.append("\n							,	( ");
    	sql.append("\n									SELECT C.PERIOD_NAME ");
    	sql.append("\n									,	C.DEPARTURE_IATA_CTY_APO_CD ");
    	sql.append("\n									,	C.ARRIVAL_IATA_CTY_APO_CD ");
//    	sql.append("\n									,	C.AIRCRAFT_VERSION_CODE ");
//    	sql.append("\n									,	C.STANDARD_KRW_COST ");
    	sql.append("\n									,	SUBSTR(C.AIRCRAFT_VERSION_CODE,	0,	3) AIRCRAFT_VERSION_CODE  ");
    	sql.append("\n									,	AVG(C.STANDARD_KRW_COST) STANDARD_KRW_COST  ");
    	sql.append("\n									FROM ");
    	sql.append("\n										KFOS.ERS_COCKPIT_CREW_COST_T C ");
    	sql.append("\n									,	( ");
    	sql.append("\n											SELECT ");
    	sql.append("\n												MAX(PERIOD_NAME) PERIOD_NAME ");
    	sql.append("\n											FROM KFOS.ERS_COCKPIT_CREW_COST_T ");
    	sql.append("\n											WHERE ");
    	sql.append("\n												DEPARTURE_IATA_CTY_APO_CD = '"+params.getPStnFr()+"' -- SELECTED STNFR ");
    	sql.append("\n											AND ARRIVAL_IATA_CTY_APO_CD = '"+params.getPStnTo()+"' -- SELECTED STNTO ");
    	sql.append("\n											AND SUBSTR(AIRCRAFT_VERSION_CODE,	0,	3) = '"+params.getPSacTyp()+"' ");
    	sql.append("\n										) D -- SELECTED SACTYP ");
    	sql.append("\n									WHERE C.PERIOD_NAME = D.PERIOD_NAME ");
    	sql.append("\n									AND C.DEPARTURE_IATA_CTY_APO_CD = '"+params.getPStnFr()+"' -- SELECTED STNFR ");
    	sql.append("\n									AND C.ARRIVAL_IATA_CTY_APO_CD = '"+params.getPStnTo()+"' -- SELECTED STNTO ");
    	sql.append("\n									AND SUBSTR(C.AIRCRAFT_VERSION_CODE,	0,	3) = '"+params.getPSacTyp()+"' ");
    	sql.append("\n					                GROUP BY   ");
    	sql.append("\n										C.PERIOD_NAME  ");
    	sql.append("\n									,	C.DEPARTURE_IATA_CTY_APO_CD  ");
    	sql.append("\n									,	C.ARRIVAL_IATA_CTY_APO_CD  ");
    	sql.append("\n									,	SUBSTR(C.AIRCRAFT_VERSION_CODE,	0,	3)  ");
    	sql.append("\n								) BB -- SELECTED SACTYP ");
    	sql.append("\n							WHERE ");
    	sql.append("\n								AA.DEPARTURE_IATA_CTY_APO_CD(+) = BB.DEPARTURE_IATA_CTY_APO_CD ");
    	sql.append("\n							AND AA.ARRIVAL_IATA_CTY_APO_CD(+) = BB.ARRIVAL_IATA_CTY_APO_CD ");
    	sql.append("\n							AND AA.AIRCRAFT_VERSION_CODE(+) = BB.AIRCRAFT_VERSION_CODE ");
    	sql.append("\n							GROUP BY ");
    	sql.append("\n								BB.DEPARTURE_IATA_CTY_APO_CD ");
    	sql.append("\n							,	BB.ARRIVAL_IATA_CTY_APO_CD ");
    	sql.append("\n							,	BB.AIRCRAFT_VERSION_CODE ");
    	sql.append("\n						) AAA ");
    	sql.append("\n					,	( ");
    	sql.append("\n							SELECT FROM_CURRENCY ");
    	sql.append("\n							,	TO_CURRENCY ");
    	sql.append("\n							,	CONVERSION_RATE ");
    	sql.append("\n							FROM ");
    	sql.append("\n							( ");
    	sql.append("\n								SELECT * FROM KFOS.TDAILY_RATES_II ");
    	sql.append("\n								WHERE ");
    	sql.append("\n									FROM_CURRENCY = 'USD' ");
    	sql.append("\n								AND TO_CURRENCY = 'KRW' ");
    	sql.append("\n								AND USER_CONVERSION_TYPE = 'KE_CURRENCY_IATA_FD' ");
    	sql.append("\n								ORDER BY CONVERSION_DATE DESC ");
    	sql.append("\n							) ");
    	sql.append("\n							WHERE ROWNUM = 1 ");
    	sql.append("\n						) BBB ");
    	sql.append("\n					WHERE ROWNUM = 1 ");	//@2013-12-04  (ּ:2013.11.28 ߰ κ)
    	sql.append("\n				) CREW ");
    	sql.append("\n			,	( ");
    	sql.append("\n					SELECT * FROM ( ");	//@2013-12-04  (ּ:2013.11.28 ߰ κ)
    	sql.append("\n						SELECT AA.DEPARTURE_IATA_CTY_APO_CD ");
    	sql.append("\n						,	AA.ARRIVAL_IATA_CTY_APO_CD ");
    	sql.append("\n						,	AA.AIRCRAFT_VERSION_CODE ");
    	sql.append("\n						,	ROUND(AA.MAINTENANCE_COST/BB.CONVERSION_RATE ");
    	sql.append("\n						,	2) MAINTENANCE_COST ");
    	sql.append("\n						FROM ");
    	sql.append("\n							( ");
    	sql.append("\n								SELECT PERIOD_NAME ");
    	sql.append("\n								,	DEPARTURE_IATA_CTY_APO_CD ");
    	sql.append("\n								,	ARRIVAL_IATA_CTY_APO_CD ");
//    	sql.append("\n								,	AIRCRAFT_VERSION_CODE ");
//    	sql.append("\n								,	ROUND(AVG(MAINTENANCE_COST),	3) MAINTENANCE_COST ");
    	sql.append("\n								,	SUBSTR(AIRCRAFT_VERSION_CODE,0,3) AIRCRAFT_VERSION_CODE  ");
    	sql.append("\n								,	ROUND(SUM(INVOICE_KRW_AMOUNT)/SUM(REVENUE_FLIGHT_OPERATION_COUNT),	3) MAINTENANCE_COST  ");
    	sql.append("\n								FROM ");
    	sql.append("\n									( ");
    	sql.append("\n										SELECT A.PERIOD_NAME ");
    	sql.append("\n										,	A.FLIGHT_NUMBER  ");
    	sql.append("\n										,	A.DEPARTURE_IATA_CTY_APO_CD ");
    	sql.append("\n										,	A.ARRIVAL_IATA_CTY_APO_CD ");
    	sql.append("\n										,	A.AIRCRAFT_VERSION_CODE ");
    	sql.append("\n										,	ROUND(SUM(A.INVOICE_KRW_AMOUNT)/A.REVENUE_FLIGHT_OPERATION_COUNT,	3) MAINTENANCE_COST ");
    	sql.append("\n										,	A.REVENUE_FLIGHT_OPERATION_COUNT  ");
    	sql.append("\n										,	SUM(A.INVOICE_KRW_AMOUNT)  INVOICE_KRW_AMOUNT  ");
    	sql.append("\n	 ");
    	sql.append("\n										 FROM KFOS.ERS_MAINTENANCE_COST_T A ");
    	sql.append("\n										,	( ");
    	sql.append("\n										SELECT MAX(PERIOD_NAME) PERIOD_NAME ");
    	sql.append("\n										FROM ");
    	sql.append("\n											KFOS.ERS_MAINTENANCE_COST_T ");
    	sql.append("\n										WHERE ");
    	sql.append("\n											DEPARTURE_IATA_CTY_APO_CD = '"+params.getPStnFr()+"' -- SELECTED STNFR ");
    	sql.append("\n										AND ARRIVAL_IATA_CTY_APO_CD = '"+params.getPStnTo()+"' -- SELECTED STNTO ");
    	sql.append("\n										AND SUBSTR(AIRCRAFT_VERSION_CODE,	0,	3) = '"+params.getPSacTyp()+"' ");
    	sql.append("\n									) B -- SELECTED SACTYP ");
    	sql.append("\n								WHERE ");
    	sql.append("\n									A.PERIOD_NAME = B.PERIOD_NAME ");
    	sql.append("\n								AND A.DEPARTURE_IATA_CTY_APO_CD = '"+params.getPStnFr()+"' -- SELECTED STNFR ");
    	sql.append("\n								AND A.ARRIVAL_IATA_CTY_APO_CD = '"+params.getPStnTo()+"' -- SELECTED STNTO ");
    	sql.append("\n								AND SUBSTR(A.AIRCRAFT_VERSION_CODE,	0,	3) = '"+params.getPSacTyp()+"' -- SELECTED SACTYP ");
    	sql.append("\n								GROUP BY ");
    	sql.append("\n									A.PERIOD_NAME ");
    	sql.append("\n								,	A.FLIGHT_NUMBER  ");
    	sql.append("\n								,	A.DEPARTURE_IATA_CTY_APO_CD ");
    	sql.append("\n								,	A.ARRIVAL_IATA_CTY_APO_CD ");
    	sql.append("\n								,	A.AIRCRAFT_VERSION_CODE ");
    	sql.append("\n								,	A.REVENUE_FLIGHT_OPERATION_COUNT ");
    	sql.append("\n							) ");
    	sql.append("\n						GROUP BY ");
    	sql.append("\n							PERIOD_NAME ");
    	sql.append("\n						,	DEPARTURE_IATA_CTY_APO_CD ");
    	sql.append("\n						,	ARRIVAL_IATA_CTY_APO_CD ");
//    	sql.append("\n						,	AIRCRAFT_VERSION_CODE)AA ");
    	sql.append("\n						,	SUBSTR(AIRCRAFT_VERSION_CODE,	0,	3))AA  ");
    	sql.append("\n						,	( ");
    	sql.append("\n								SELECT ");
    	sql.append("\n									FROM_CURRENCY ");
    	sql.append("\n								,	TO_CURRENCY ");
    	sql.append("\n								,	CONVERSION_RATE ");
    	sql.append("\n								FROM ");
    	sql.append("\n									( ");
    	sql.append("\n										SELECT * FROM KFOS.TDAILY_RATES_II ");
    	sql.append("\n										WHERE FROM_CURRENCY = 'USD' ");
    	sql.append("\n										AND TO_CURRENCY = 'KRW' ");
    	sql.append("\n										AND USER_CONVERSION_TYPE = 'KE_CURRENCY_IATA_FD' ");
    	sql.append("\n										ORDER BY CONVERSION_DATE DESC ");
    	sql.append("\n									) ");
    	sql.append("\n								WHERE ROWNUM = 1 ");
    	sql.append("\n							) BB ");
    	sql.append("\n					) WHERE ROWNUM = 1 ");	//@2013-12-04  (ּ:2013.11.28 ߰ κ)
    	sql.append("\n				) MAINT ");
    	sql.append("\n			,	( ");
    	sql.append("\n					SELECT A.FIRST_LEG_FLT_DT ");
    	sql.append("\n					,	A.FLT_NUM ");
    	sql.append("\n					,	A.LEG_NUM ");
    	sql.append("\n					,	A.STNFR ");
    	sql.append("\n					,	A.STNTO ");
    	sql.append("\n					,	A.ACTYP ");
    	sql.append("\n					,	A.REGION_CD ");
    	sql.append("\n					,	A.REGNO ");
    	sql.append("\n					,	A.ROUTE ");
    	sql.append("\n					,	A.ABHR ");
    	sql.append("\n					,	A.PLN_TRIP_FUEL ");
    	sql.append("\n					,	A.CHARGE ");
    	sql.append("\n					,	ROUND(PLN_TRIP_FUEL*100*DECODE(B.INT_FUEL_UPRC_USD,	NULL,	3,	B.INT_FUEL_UPRC_USD)/6.7,	3) FUEL_COST ");
//    	sql.append("\n					,	ROUND(PLN_TRIP_FUEL*DECODE(B.INT_FUEL_UPRC_USD,	NULL,	3,	B.INT_FUEL_UPRC_USD)/6.7,	3) FUEL_COST ");
    	sql.append("\n					FROM ");
    	sql.append("\n						KFOS.FLIGHT_PLAN_T_PLAN A ");
    	sql.append("\n					,	( ");
    	sql.append("\n							SELECT * ");
    	sql.append("\n							FROM ");
    	sql.append("\n								( ");
    	sql.append("\n									SELECT ");
    	sql.append("\n										IATA_PORT ");
    	sql.append("\n									,	INT_FUEL_UPRC_USD ");
    	sql.append("\n									FROM ");
    	sql.append("\n										KFOS.ERP_PORT_FUEL_UPRC_II ");
    	sql.append("\n									WHERE ");
    	sql.append("\n										IATA_PORT = '"+params.getPStnFr()+"' -- SELECTED STNFR ");
    	//20151229 
    	//sql.append("\n									ORDER BY TIMESTMP DESC ");
    	sql.append("\n									ORDER BY FUEL_UPRC_DT DESC, TIMESTMP DESC ");
    	sql.append("\n								) ");
    	sql.append("\n							WHERE ROWNUM = 1 ");
    	sql.append("\n						) B ");
    	sql.append("\n					WHERE ");
    	sql.append("\n						A.FIRST_LEG_FLT_DT = TO_DATE('"+params.getPFirstLegFltDt()+"',	'YYYYMMDD') -- SELECTED FIRST_LEG_FLT_DT ");
    	sql.append("\n					AND A.FLT_NUM = '"+params.getPFltNum()+"' -- SELECTED FLT_NUM ");
    	sql.append("\n					AND A.STNFR = '"+params.getPStnFr()+"' -- SELECTED STNFR ");
    	sql.append("\n					AND A.STNTO = '"+params.getPStnTo()+"' -- SELECTED STNTO ");
    	sql.append("\n					AND A.ACTYP = '"+params.getPSacTyp()+"' -- SELECTED SACTYP ");
    	sql.append("\n					AND A.CHARGE IS NOT NULL ");
    	sql.append("\n					AND A.STNFR = B.IATA_PORT(+) ");
    	sql.append("\n				) FP ");
    	sql.append("\n			,	( ");
    	sql.append("\n					SELECT ROUND(AVG(ABHR)/60,	3) AVG_ABHR ");
    	sql.append("\n					FROM FLIGHT_PLAN_T ");
    	sql.append("\n					WHERE ");
    	sql.append("\n						FIRST_LEG_FLT_DT BETWEEN TRUNC(ADD_MONTHS(SYSDATE,	-3) +1) - TO_CHAR(SYSDATE,	'DD') ");
    	sql.append("\n					AND TRUNC(LAST_DAY(ADD_MONTHS(SYSDATE,	-1)))+0.99999421 ");
    	sql.append("\n					AND ACTIVE = 'Y' ");
    	sql.append("\n					AND STNFR = '"+params.getPStnFr()+"' -- SELECTED STNFR ");
    	sql.append("\n					AND STNTO = '"+params.getPStnTo()+"' -- SELECTED STNTO ");
    	sql.append("\n					AND ACTYP = '"+params.getPSacTyp()+"' ");
    	sql.append("\n				) RFP ");
    	sql.append("\n			,	KFOS.ERS_ROUTE_T RT ");
    	sql.append("\n			,	DAILY_SCH_T DS -- SELECTED SACTYP ");
    	sql.append("\n			WHERE ");
    	sql.append("\n				DS.STNFR = CREW.DEPARTURE_IATA_CTY_APO_CD(+) ");
    	sql.append("\n			AND DS.STNFR = MAINT.DEPARTURE_IATA_CTY_APO_CD(+) ");
    	sql.append("\n			AND DS.STNTO = CREW.ARRIVAL_IATA_CTY_APO_CD(+) ");
    	sql.append("\n			AND DS.STNTO = MAINT.ARRIVAL_IATA_CTY_APO_CD(+) ");
//    	sql.append("\n			AND DS.ACVER = CREW.AIRCRAFT_VERSION_CODE(+) ");	//@2013-12-04
//    	sql.append("\n			AND DS.ACVER = MAINT.AIRCRAFT_VERSION_CODE(+) ");	//@2013-12-04
    	sql.append("\n			AND DS.SACTYP = SUBSTR(CREW.AIRCRAFT_VERSION_CODE(+),0,3) ");	//@2013-12-04  (ּ:2013.03.20  κ)
    	sql.append("\n			AND DS.SACTYP = SUBSTR(MAINT.AIRCRAFT_VERSION_CODE(+),0,3) ");	//@2013-12-04  (ּ:2013.03.20  κ)
    	sql.append("\n			AND FP.FIRST_LEG_FLT_DT = DS.FIRST_LEG_FLT_DT ");
    	sql.append("\n			AND FP.FLT_NUM = DS.FLT_NUM ");
    	sql.append("\n			AND FP.STNFR = DS.STNFR ");
    	sql.append("\n			AND FP.STNTO = DS.STNTO ");
    	sql.append("\n			AND DS.ACTNID <> 'CNL' ");
    	sql.append("\n			AND RT.REGION(+) = FP.REGION_CD ");
    	sql.append("\n			AND RT.ROUTE_ID(+) = SUBSTR(FP.ROUTE,	0,	3) ");
    	sql.append("\n			ORDER BY FP.ROUTE ASC ");
    	sql.append("\n		) AL ");
    	sql.append("\n	,	KFOS.ERS_MASTER_T MAST ");
    	sql.append("\n	WHERE ");
    	sql.append("\n		AL.FIRST_LEG_FLT_DT = MAST.FIRST_LEG_FLT_DT(+) ");
    	sql.append("\n	AND AL.FLT_NUM = MAST.FLT_NUM(+) ");
    	sql.append("\n	AND AL.LEG_NUM = MAST.LEG_NUM(+) ");
    	sql.append("\n	AND AL.STNFR = MAST.STNFR(+) ");
    	sql.append("\n	AND AL.STNTO = MAST.STNTO(+) ");
    	sql.append("\n	AND AL.RT_GROUPING = MAST.ROUTE(+) ");
    	sql.append("\n	AND AL.ABHR = MAST.ABHR(+) ");
//    	sql.append("\n	AND AL.PLN_TRIP_FUEL = MAST.PLN_TRIP_FUEL(+)*100 ");
    	sql.append("\n	AND AL.PLN_TRIP_FUEL = MAST.PLN_TRIP_FUEL(+) ");
    	sql.append("\n	ORDER BY ");
    	sql.append("\n		NVL(AL.RT_GROUPING,'****') ");
    	sql.append("\n	,	AL.ROUTE ");	//@2013-12-04(ּ: 2013.03.20 ߰ κ)
		*/
    	
    	
    	sql.append("\n	SELECT DISTINCT                                                                                                                   ");
    	sql.append("\n		AL.FIRST_LEG_FLT_DT                                                                                                           ");
    	sql.append("\n	,	AL.FLT_NUM                                                                                                                    ");
    	sql.append("\n	,	AL.LEG_NUM                                                                                                                    ");
    	sql.append("\n	,	AL.STNFR                                                                                                                      ");
    	sql.append("\n	,	AL.STNTO                                                                                                                      ");
    	sql.append("\n	,	AL.ACTYP                                                                                                                      ");
    	sql.append("\n	,	AL.REGNO                                                                                                                      ");
    	sql.append("\n	,	AL.ROUTE                                                                                                                      ");
    	sql.append("\n	,	NVL(AL.RT_GROUPING,'****') RT_GROUPING                                                                                        ");
    	sql.append("\n	,	NVL(MAST.REASON_1,	'') REASON_1                                                                                              ");
    	sql.append("\n	,	NVL(MAST.REASON_2,	'') REASON_2                                                                                              ");
    	sql.append("\n	,	MAST.ROUTE MAST_RT_GROUPING                                                                                                   ");
    	sql.append("\n	,	MAST.PLN_TRIP_FUEL MAST_PLN_TRIP_FUEL                                                                                         ");
    	sql.append("\n	,	AL.ABHR                                                                                                                       ");
    	sql.append("\n	,	AL.PLN_TRIP_FUEL                                                                                                              ");
    	sql.append("\n	,	AL.CHARGE                                                                                                                     ");
    	sql.append("\n	,	AL.FUEL_COST                                                                                                                  ");
    	sql.append("\n	,	NVL(AL.CREW_COST,MAST.CREW_COST) CREW_COST                                                                                    ");
    	sql.append("\n	,	NVL(AL.MAINTENANCE_COST,MAST.MAINT_COST) MAINTENANCE_COST    	                                                              ");
    	sql.append("\n	,	DECODE(NVL(MAST.CONFIRM_Y,	''),	'Y',	'Y',	'N') CONF                                                                 ");
    	sql.append("\n	,	DECODE(MAST.CHK,'Y','Y','N') CHK                                                                                              ");
    	sql.append("\n	FROM                                                                                                                              ");
    	sql.append("\n		(                                                                                                                             ");
    	sql.append("\n	    SELECT FIRST_LEG_FLT_DT                                                                                                       ");
    	sql.append("\n			,	FLT_NUM                                                                                                               ");
    	sql.append("\n			,	LEG_NUM                                                                                                               ");
    	sql.append("\n			,	STNFR                                                                                                                 ");
    	sql.append("\n			,	STNTO                                                                                                                 ");
    	sql.append("\n			,	ACTYP                                                                                                                 ");
    	sql.append("\n			,	REGNO                                                                                                                 ");
    	sql.append("\n			,	ROUTE                                                                                                                 ");
    	sql.append("\n			,	RT_GROUPING                                                                                                           ");
    	sql.append("\n			,	ABHR                                                                                                                  ");
    	sql.append("\n			,	PLN_TRIP_FUEL                                                                                                         ");
    	sql.append("\n			,	CHARGE                                                                                                                ");
    	sql.append("\n			,	FUEL_COST                                                                                                             ");
    	sql.append("\n			,	CREW_COST                                                                                                             ");
    	sql.append("\n			,	MAINTENANCE_COST                                                                                                      ");
    	sql.append("\n	    FROM (                                                                                                                        ");
    	sql.append("\n	      SELECT FP.FIRST_LEG_FLT_DT                                                                                                  ");
    	sql.append("\n	      ,	FP.FLT_NUM                                                                                                                ");
    	sql.append("\n	      ,	FP.LEG_NUM                                                                                                                ");
    	sql.append("\n	      ,	FP.STNFR                                                                                                                  ");
    	sql.append("\n	      ,	FP.STNTO                                                                                                                  ");
    	sql.append("\n	      ,	FP.ACTYP                                                                                                                  ");
    	sql.append("\n	      ,	FP.REGNO                                                                                                                  ");
    	sql.append("\n	      ,	FP.ROUTE                                                                                                                  ");
    	//sql.append("\n	      ,	RT.RT_GROUPING");//@2017-07-21
    	sql.append("\n	      ,	NVL(RT.RT_GROUPING,'****') AS RT_GROUPING");    	
    	sql.append("\n	      ,	FP.ABHR                                                                                                                   ");
    	sql.append("\n	      ,	FP.PLN_TRIP_FUEL                                                                                                          ");
    	sql.append("\n	      ,	FP.CHARGE                                                                                                                 ");
    	sql.append("\n	      ,	FP.FUEL_COST                                                                                                              ");
    	sql.append("\n	      ,	DECODE(RFP.AVG_ABHR,	NULL,	NULL,	ROUND((CREW.CREW_COST/RFP.AVG_ABHR)*(FP.ABHR/60),	3)) CREW_COST                 ");
    	sql.append("\n	      ,	DECODE(RFP.AVG_ABHR,	NULL,	NULL,	ROUND((MAINT.MAINTENANCE_COST/RFP.AVG_ABHR)*(FP.ABHR/60),	3)) MAINTENANCE_COST  ");
    	sql.append("\n	      FROM                                                                                                                        ");
    	sql.append("\n	        (                                                                                                                         ");
    	sql.append("\n	          SELECT                                                                                                                  ");
    	sql.append("\n	            AAA.DEPARTURE_IATA_CTY_APO_CD                                                                                         ");
    	sql.append("\n	          ,	AAA.ARRIVAL_IATA_CTY_APO_CD                                                                                           ");
    	sql.append("\n	          ,	AAA.AIRCRAFT_VERSION_CODE                                                                                             ");
    	sql.append("\n	          ,	ROUND(AAA.CREW_COST/BBB.CONVERSION_RATE,	2) CREW_COST                                                              ");
    	sql.append("\n	          FROM                                                                                                                    ");
    	sql.append("\n	            (                                                                                                                     ");
    	sql.append("\n	              SELECT                                                                                                              ");
    	sql.append("\n	                BB.DEPARTURE_IATA_CTY_APO_CD                                                                                      ");
    	sql.append("\n	              ,	BB.ARRIVAL_IATA_CTY_APO_CD                                                                                        ");
    	sql.append("\n	              ,	BB.AIRCRAFT_VERSION_CODE                                                                                          ");
    	sql.append("\n	              ,	AVG((NVL(AA.MONTHLY_AMT,	0)+BB.STANDARD_KRW_COST)) CREW_COST                                                   ");
    	sql.append("\n	              FROM                                                                                                                ");
    	sql.append("\n	                (                                                                                                                 ");
    	sql.append("\n	                  SELECT                                                                                                          ");
    	sql.append("\n	                    A.PERIOD_NAME                                                                                                 ");
    	sql.append("\n	                  ,	A.DEPARTURE_IATA_CTY_APO_CD                                                                                   ");
    	sql.append("\n	                  ,	A.ARRIVAL_IATA_CTY_APO_CD                                                                                     ");
    	sql.append("\n	                  ,	A.FLIGHT_NUMBER                                                                                               ");
    	sql.append("\n	                  ,	SUBSTR(A.AIRCRAFT_VERSION_CODE,	0,	3) AIRCRAFT_VERSION_CODE                                                  ");
    	sql.append("\n	                  ,	ROUND(SUM(A.MONTHLY_AMT/A.FRQ),	3) MONTHLY_AMT                                                                ");
    	sql.append("\n	                   FROM                                                                                                           ");
    	sql.append("\n	                    KFOS.ERS_CABIN_CREW_COST_T A                                                                                  ");
    	sql.append("\n	                  ,	(                                                                                                             ");
    	sql.append("\n	                      SELECT                                                                                                      ");
    	sql.append("\n	                        MAX(PERIOD_NAME) PERIOD_NAME                                                                              ");
    	sql.append("\n	                      FROM                                                                                                        ");
    	sql.append("\n	                        KFOS.ERS_CABIN_CREW_COST_T                                                                                ");
    	sql.append("\n	                      WHERE                                                                                                       ");
    	sql.append("\n	                        DEPARTURE_IATA_CTY_APO_CD = '"+params.getPStnFr()+"' -- SELECTED STNFR                                    ");
    	sql.append("\n	                      AND ARRIVAL_IATA_CTY_APO_CD = '"+params.getPStnTo()+"' -- SELECTED STNTO                                    ");
    	sql.append("\n	                      AND SUBSTR(AIRCRAFT_VERSION_CODE,	0,	3) = '"+params.getPSacTyp()+"'                                        ");
    	sql.append("\n	                    ) B -- SELECTED SACTYP                                                                                        ");
    	sql.append("\n	                  WHERE                                                                                                           ");
    	sql.append("\n	                    A.PERIOD_NAME = B.PERIOD_NAME                                                                                 ");
    	sql.append("\n	                  AND A.DEPARTURE_IATA_CTY_APO_CD = '"+params.getPStnFr()+"' -- SELECTED STNFR                                    ");
    	sql.append("\n	                  AND A.ARRIVAL_IATA_CTY_APO_CD = '"+params.getPStnTo()+"' -- SELECTED STNTO                                      ");
    	sql.append("\n	                  AND SUBSTR(A.AIRCRAFT_VERSION_CODE,	0,	3) = '"+params.getPSacTyp()+"' -- SELECTED SACTYP                     ");
    	sql.append("\n	                  GROUP BY                                                                                                        ");
    	sql.append("\n	                    A.PERIOD_NAME                                                                                                 ");
    	sql.append("\n	                  ,	A.DEPARTURE_IATA_CTY_APO_CD                                                                                   ");
    	sql.append("\n	                  ,	A.ARRIVAL_IATA_CTY_APO_CD                                                                                     ");
    	sql.append("\n	                  ,	A.FLIGHT_NUMBER                                                                                               ");
    	sql.append("\n	                  ,	SUBSTR(A.AIRCRAFT_VERSION_CODE,	0,	3)                                                                        ");
    	sql.append("\n	                ) AA                                                                                                              ");
    	sql.append("\n	              ,	(                                                                                                                 ");
    	sql.append("\n	                  SELECT C.PERIOD_NAME                                                                                            ");
    	sql.append("\n	                  ,	C.DEPARTURE_IATA_CTY_APO_CD                                                                                   ");
    	sql.append("\n	                  ,	C.ARRIVAL_IATA_CTY_APO_CD                                                                                     ");
    	sql.append("\n	                  ,	SUBSTR(C.AIRCRAFT_VERSION_CODE,	0,	3) AIRCRAFT_VERSION_CODE                                                  ");
    	sql.append("\n	                  ,	AVG(C.STANDARD_KRW_COST) STANDARD_KRW_COST                                                                    ");
    	sql.append("\n	                  FROM                                                                                                            ");
    	sql.append("\n	                    KFOS.ERS_COCKPIT_CREW_COST_T C                                                                                ");
    	sql.append("\n	                  ,	(                                                                                                             ");
    	sql.append("\n	                      SELECT                                                                                                      ");
    	sql.append("\n	                        MAX(PERIOD_NAME) PERIOD_NAME                                                                              ");
    	sql.append("\n	                      FROM KFOS.ERS_COCKPIT_CREW_COST_T                                                                           ");
    	sql.append("\n	                      WHERE                                                                                                       ");
    	sql.append("\n	                        DEPARTURE_IATA_CTY_APO_CD = '"+params.getPStnFr()+"' -- SELECTED STNFR                                    ");
    	sql.append("\n	                      AND ARRIVAL_IATA_CTY_APO_CD = '"+params.getPStnTo()+"' -- SELECTED STNTO                                    ");
    	sql.append("\n	                      AND SUBSTR(AIRCRAFT_VERSION_CODE,	0,	3) = '"+params.getPSacTyp()+"'                                        ");
    	sql.append("\n	                    ) D -- SELECTED SACTYP                                                                                        ");
    	sql.append("\n	                  WHERE C.PERIOD_NAME = D.PERIOD_NAME                                                                             ");
    	sql.append("\n	                  AND C.DEPARTURE_IATA_CTY_APO_CD = '"+params.getPStnFr()+"' -- SELECTED STNFR                                    ");
    	sql.append("\n	                  AND C.ARRIVAL_IATA_CTY_APO_CD = '"+params.getPStnTo()+"' -- SELECTED STNTO                                      ");
    	sql.append("\n	                  AND SUBSTR(C.AIRCRAFT_VERSION_CODE,	0,	3) = '"+params.getPSacTyp()+"'                                        ");
    	sql.append("\n	                          GROUP BY                                                                                                ");
    	sql.append("\n	                    C.PERIOD_NAME                                                                                                 ");
    	sql.append("\n	                  ,	C.DEPARTURE_IATA_CTY_APO_CD                                                                                   ");
    	sql.append("\n	                  ,	C.ARRIVAL_IATA_CTY_APO_CD                                                                                     ");
    	sql.append("\n	                  ,	SUBSTR(C.AIRCRAFT_VERSION_CODE,	0,	3)                                                                        ");
    	sql.append("\n	                ) BB -- SELECTED SACTYP                                                                                           ");
    	sql.append("\n	              WHERE                                                                                                               ");
    	sql.append("\n	                AA.DEPARTURE_IATA_CTY_APO_CD(+) = BB.DEPARTURE_IATA_CTY_APO_CD                                                    ");
    	sql.append("\n	              AND AA.ARRIVAL_IATA_CTY_APO_CD(+) = BB.ARRIVAL_IATA_CTY_APO_CD                                                      ");
    	sql.append("\n	              AND AA.AIRCRAFT_VERSION_CODE(+) = BB.AIRCRAFT_VERSION_CODE                                                          ");
    	sql.append("\n	              GROUP BY                                                                                                            ");
    	sql.append("\n	                BB.DEPARTURE_IATA_CTY_APO_CD                                                                                      ");
    	sql.append("\n	              ,	BB.ARRIVAL_IATA_CTY_APO_CD                                                                                        ");
    	sql.append("\n	              ,	BB.AIRCRAFT_VERSION_CODE                                                                                          ");
    	sql.append("\n	            ) AAA                                                                                                                 ");
    	sql.append("\n	          ,	(                                                                                                                     ");
    	sql.append("\n	              SELECT FROM_CURRENCY                                                                                                ");
    	sql.append("\n	              ,	TO_CURRENCY                                                                                                       ");
    	sql.append("\n	              ,	CONVERSION_RATE                                                                                                   ");
    	sql.append("\n	              FROM                                                                                                                ");
    	sql.append("\n	              (                                                                                                                   ");
    	sql.append("\n	                SELECT * FROM KFOS.TDAILY_RATES_II                                                                                ");
    	sql.append("\n	                WHERE                                                                                                             ");
    	sql.append("\n	                  FROM_CURRENCY = 'USD'                                                                                           ");
    	sql.append("\n	                AND TO_CURRENCY = 'KRW'                                                                                           ");
    	sql.append("\n	                AND USER_CONVERSION_TYPE = 'KE_CURRENCY_IATA_FD'                                                                  ");
    	sql.append("\n	                ORDER BY CONVERSION_DATE DESC                                                                                     ");
    	sql.append("\n	              )                                                                                                                   ");
    	sql.append("\n	              WHERE ROWNUM = 1                                                                                                    ");
    	sql.append("\n	            ) BBB                                                                                                                 ");
    	sql.append("\n	          WHERE ROWNUM = 1                                                                                                        ");
    	sql.append("\n	        ) CREW                                                                                                                    ");
    	sql.append("\n	      ,	(                                                                                                                         ");
    	sql.append("\n	          SELECT * FROM (                                                                                                         ");
    	sql.append("\n	            SELECT AA.DEPARTURE_IATA_CTY_APO_CD                                                                                   ");
    	sql.append("\n	            ,	AA.ARRIVAL_IATA_CTY_APO_CD                                                                                        ");
    	sql.append("\n	            ,	AA.AIRCRAFT_VERSION_CODE                                                                                          ");
    	sql.append("\n	            ,	ROUND(AA.MAINTENANCE_COST/BB.CONVERSION_RATE                                                                      ");
    	sql.append("\n	            ,	2) MAINTENANCE_COST                                                                                               ");
    	sql.append("\n	            FROM                                                                                                                  ");
    	sql.append("\n	              (                                                                                                                   ");
    	sql.append("\n	                SELECT PERIOD_NAME                                                                                                ");
    	sql.append("\n	                ,	DEPARTURE_IATA_CTY_APO_CD                                                                                     ");
    	sql.append("\n	                ,	ARRIVAL_IATA_CTY_APO_CD                                                                                       ");
    	sql.append("\n	                ,	SUBSTR(AIRCRAFT_VERSION_CODE,0,3) AIRCRAFT_VERSION_CODE                                                       ");
    	sql.append("\n	                ,	ROUND(SUM(INVOICE_KRW_AMOUNT)/SUM(REVENUE_FLIGHT_OPERATION_COUNT),	3) MAINTENANCE_COST                       ");
    	sql.append("\n	                FROM                                                                                                              ");
    	sql.append("\n	                  (                                                                                                               ");
    	sql.append("\n	                    SELECT A.PERIOD_NAME                                                                                          ");
    	sql.append("\n	                    ,	A.FLIGHT_NUMBER                                                                                           ");
    	sql.append("\n	                    ,	A.DEPARTURE_IATA_CTY_APO_CD                                                                               ");
    	sql.append("\n	                    ,	A.ARRIVAL_IATA_CTY_APO_CD                                                                                 ");
    	sql.append("\n	                    ,	A.AIRCRAFT_VERSION_CODE                                                                                   ");
    	sql.append("\n	                    ,	ROUND(SUM(A.INVOICE_KRW_AMOUNT)/A.REVENUE_FLIGHT_OPERATION_COUNT,	3) MAINTENANCE_COST                   ");
    	sql.append("\n	                    ,	A.REVENUE_FLIGHT_OPERATION_COUNT                                                                          ");
    	sql.append("\n	                    ,	SUM(A.INVOICE_KRW_AMOUNT)  INVOICE_KRW_AMOUNT                                                             ");
    	sql.append("\n	                     FROM KFOS.ERS_MAINTENANCE_COST_T A                                                                           ");
    	sql.append("\n	                    ,	(                                                                                                         ");
    	sql.append("\n	                    SELECT MAX(PERIOD_NAME) PERIOD_NAME                                                                           ");
    	sql.append("\n	                    FROM                                                                                                          ");
    	sql.append("\n	                      KFOS.ERS_MAINTENANCE_COST_T                                                                                 ");
    	sql.append("\n	                    WHERE                                                                                                         ");
    	sql.append("\n	                      DEPARTURE_IATA_CTY_APO_CD = '"+params.getPStnFr()+"' -- SELECTED STNFR                                      ");
    	sql.append("\n	                    AND ARRIVAL_IATA_CTY_APO_CD = '"+params.getPStnTo()+"' -- SELECTED STNTO                                      ");
    	sql.append("\n	                    AND SUBSTR(AIRCRAFT_VERSION_CODE,	0,	3) = '"+params.getPSacTyp()+"'                                        ");
    	sql.append("\n	                  ) B -- SELECTED SACTYP                                                                                          ");
    	sql.append("\n	                WHERE                                                                                                             ");
    	sql.append("\n	                  A.PERIOD_NAME = B.PERIOD_NAME                                                                                   ");
    	sql.append("\n	                AND A.DEPARTURE_IATA_CTY_APO_CD = '"+params.getPStnFr()+"' -- SELECTED STNFR                                      ");
    	sql.append("\n	                AND A.ARRIVAL_IATA_CTY_APO_CD = '"+params.getPStnTo()+"' -- SELECTED STNTO                                        ");
    	sql.append("\n	                AND SUBSTR(A.AIRCRAFT_VERSION_CODE,	0,	3) = '"+params.getPSacTyp()+"' -- SELECTED SACTYP                         ");
    	sql.append("\n	                GROUP BY                                                                                                          ");
    	sql.append("\n	                  A.PERIOD_NAME                                                                                                   ");
    	sql.append("\n	                ,	A.FLIGHT_NUMBER                                                                                               ");
    	sql.append("\n	                ,	A.DEPARTURE_IATA_CTY_APO_CD                                                                                   ");
    	sql.append("\n	                ,	A.ARRIVAL_IATA_CTY_APO_CD                                                                                     ");
    	sql.append("\n	                ,	A.AIRCRAFT_VERSION_CODE                                                                                       ");
    	sql.append("\n	                ,	A.REVENUE_FLIGHT_OPERATION_COUNT                                                                              ");
    	sql.append("\n	              )                                                                                                                   ");
    	sql.append("\n	            GROUP BY                                                                                                              ");
    	sql.append("\n	              PERIOD_NAME                                                                                                         ");
    	sql.append("\n	            ,	DEPARTURE_IATA_CTY_APO_CD                                                                                         ");
    	sql.append("\n	            ,	ARRIVAL_IATA_CTY_APO_CD                                                                                           ");
    	sql.append("\n	            ,	SUBSTR(AIRCRAFT_VERSION_CODE,	0,	3))AA                                                                         ");
    	sql.append("\n	            ,	(                                                                                                                 ");
    	sql.append("\n	                SELECT                                                                                                            ");
    	sql.append("\n	                  FROM_CURRENCY                                                                                                   ");
    	sql.append("\n	                ,	TO_CURRENCY                                                                                                   ");
    	sql.append("\n	                ,	CONVERSION_RATE                                                                                               ");
    	sql.append("\n	                FROM                                                                                                              ");
    	sql.append("\n	                  (                                                                                                               ");
    	sql.append("\n	                    SELECT * FROM KFOS.TDAILY_RATES_II                                                                            ");
    	sql.append("\n	                    WHERE FROM_CURRENCY = 'USD'                                                                                   ");
    	sql.append("\n	                    AND TO_CURRENCY = 'KRW'                                                                                       ");
    	sql.append("\n	                    AND USER_CONVERSION_TYPE = 'KE_CURRENCY_IATA_FD'                                                              ");
    	sql.append("\n	                    ORDER BY CONVERSION_DATE DESC                                                                                 ");
    	sql.append("\n	                  )                                                                                                               ");
    	sql.append("\n	                WHERE ROWNUM = 1                                                                                                  ");
    	sql.append("\n	              ) BB                                                                                                                ");
    	sql.append("\n	          ) WHERE ROWNUM = 1                                                                                                      ");
    	sql.append("\n	        ) MAINT                                                                                                                   ");
    	sql.append("\n	      ,	(                                                                                                                         ");
    	sql.append("\n	          SELECT A.FIRST_LEG_FLT_DT                                                                                               ");
    	sql.append("\n	          ,	A.FLT_NUM                                                                                                             ");
    	sql.append("\n	          ,	A.LEG_NUM                                                                                                             ");
    	sql.append("\n	          ,	A.STNFR                                                                                                               ");
    	sql.append("\n	          ,	A.STNTO                                                                                                               ");
    	sql.append("\n	          ,	A.ACTYP                                                                                                               ");
    	sql.append("\n	          ,	A.REGION_CD                                                                                                           ");
    	sql.append("\n	          ,	A.REGNO                                                                                                               ");
    	sql.append("\n	          ,	A.ROUTE                                                                                                               ");
    	sql.append("\n	          ,	A.ABHR                                                                                                                ");
    	sql.append("\n	          ,	A.PLN_TRIP_FUEL                                                                                                       ");
    	sql.append("\n	          ,	A.CHARGE                                                                                                              ");
    	sql.append("\n	          ,	ROUND(PLN_TRIP_FUEL*100*DECODE(B.INT_FUEL_UPRC_USD,	NULL,	3,	B.INT_FUEL_UPRC_USD)/6.7,	3) FUEL_COST              ");
    	sql.append("\n	          FROM                                                                                                                    ");
    	sql.append("\n	            KFOS.FLIGHT_PLAN_T_PLAN A                                                                                             ");
    	sql.append("\n	          ,	(                                                                                                                     ");
    	sql.append("\n	              SELECT *                                                                                                            ");
    	sql.append("\n	              FROM                                                                                                                ");
    	sql.append("\n	                (                                                                                                                 ");
    	sql.append("\n	                  SELECT                                                                                                          ");
    	sql.append("\n	                    IATA_PORT                                                                                                     ");
    	sql.append("\n	                  ,	INT_FUEL_UPRC_USD                                                                                             ");
    	sql.append("\n	                  FROM                                                                                                            ");
    	sql.append("\n	                    KFOS.ERP_PORT_FUEL_UPRC_II                                                                                    ");
    	sql.append("\n	                  WHERE                                                                                                           ");
    	sql.append("\n	                    IATA_PORT = '"+params.getPStnFr()+"' -- SELECTED STNFR                                                        ");
    	sql.append("\n	                  ORDER BY TIMESTMP DESC                                                                                          ");
    	sql.append("\n	                )                                                                                                                 ");
    	sql.append("\n	              WHERE ROWNUM = 1                                                                                                    ");
    	sql.append("\n	            ) B                                                                                                                   ");
    	sql.append("\n	          WHERE                                                                                                                   ");
    	sql.append("\n	            A.FIRST_LEG_FLT_DT = TO_DATE('"+params.getPFirstLegFltDt()+"',	'YYYYMMDD') -- SELECTED FIRST_LEG_FLT_DT              ");
    	sql.append("\n	          AND A.FLT_NUM = '"+params.getPFltNum()+"' -- SELECTED FLT_NUM                                                           ");
    	sql.append("\n	          AND A.STNFR = '"+params.getPStnFr()+"' -- SELECTED STNFR                                                                ");
    	sql.append("\n	          AND A.STNTO = '"+params.getPStnTo()+"' -- SELECTED STNTO                                                                ");
    	sql.append("\n	          AND A.ACTYP = '"+params.getPSacTyp()+"' -- SELECTED SACTYP                                                              ");
    	sql.append("\n	          AND A.CHARGE IS NOT NULL                                                                                                ");
    	sql.append("\n	          AND A.STNFR = B.IATA_PORT(+)                                                                                            ");
    	sql.append("\n	        ) FP                                                                                                                      ");
    	sql.append("\n	      ,	(                                                                                                                         ");
    	sql.append("\n	          SELECT ROUND(AVG(ABHR)/60,	3) AVG_ABHR                                                                               ");
    	sql.append("\n	          FROM KFOS.FLIGHT_PLAN_T                                                                                                      ");
    	sql.append("\n	          WHERE                                                                                                                   ");
    	sql.append("\n	            FIRST_LEG_FLT_DT BETWEEN TRUNC(ADD_MONTHS(SYSDATE,	-3) +1) - TO_CHAR(SYSDATE,	'DD')                                 ");
    	sql.append("\n	          AND TRUNC(LAST_DAY(ADD_MONTHS(SYSDATE,	-1)))+0.99999421                                                              ");
    	sql.append("\n	          AND ACTIVE = 'Y'                                                                                                        ");
    	sql.append("\n	          AND STNFR = '"+params.getPStnFr()+"' -- SELECTED STNFR                                                                  ");
    	sql.append("\n	          AND STNTO = '"+params.getPStnTo()+"' -- SELECTED STNTO                                                                  ");
    	sql.append("\n	          AND ACTYP = '"+params.getPSacTyp()+"'                                                                                   ");
    	sql.append("\n	        ) RFP                                                                                                                     ");
    	sql.append("\n	      ,	KFOS.ERS_ROUTE_T RT                                                                                                       ");
    	sql.append("\n	      ,	DAILY_SCH_T DS -- SELECTED SACTYP                                                                                         ");
    	sql.append("\n	      WHERE                                                                                                                       ");
    	sql.append("\n	        DS.STNFR = CREW.DEPARTURE_IATA_CTY_APO_CD(+)                                                                              ");
    	sql.append("\n	      AND DS.STNFR = MAINT.DEPARTURE_IATA_CTY_APO_CD(+)                                                                           ");
    	sql.append("\n	      AND DS.STNTO = CREW.ARRIVAL_IATA_CTY_APO_CD(+)                                                                              ");
    	sql.append("\n	      AND DS.STNTO = MAINT.ARRIVAL_IATA_CTY_APO_CD(+)                                                                             ");
    	sql.append("\n	      AND DS.SACTYP = SUBSTR(CREW.AIRCRAFT_VERSION_CODE(+),0,3)                                                                   ");
    	sql.append("\n	      AND DS.SACTYP = SUBSTR(MAINT.AIRCRAFT_VERSION_CODE(+),0,3)                                                                  ");
    	sql.append("\n	      AND FP.FIRST_LEG_FLT_DT = DS.FIRST_LEG_FLT_DT                                                                               ");
    	sql.append("\n	      AND FP.FLT_NUM = DS.FLT_NUM                                                                                                 ");
    	sql.append("\n	      AND FP.STNFR = DS.STNFR                                                                                                     ");
    	sql.append("\n	      AND FP.STNTO = DS.STNTO                                                                                                     ");
    	sql.append("\n	      AND DS.ACTNID <> 'CNL'                                                                                                      ");
    	sql.append("\n	      AND RT.REGION(+) = FP.REGION_CD                                                                                             ");
    	
    	//@2017-07-13	sql.append("\n	      AND RT.ROUTE_ID(+) = SUBSTR(FP.ROUTE,	0,	3)");
    	sql.append("\n	      AND RT.ROUTE_ID(+) = FP.ROUTE");
    	
    	sql.append("\n	      ORDER BY FP.ROUTE ASC                                                                                                       ");
    	sql.append("\n	    )                                                                                                                             ");
    	sql.append("\n	    UNION                                                                                                                         ");
    	sql.append("\n	    SELECT FIRST_LEG_FLT_DT                                                                                                       ");
    	sql.append("\n			,	FLT_NUM                                                                                                               ");
    	sql.append("\n			,	LEG_NUM                                                                                                               ");
    	sql.append("\n			,	STNFR                                                                                                                 ");
    	sql.append("\n			,	STNTO                                                                                                                 ");
    	sql.append("\n			,	ACTYP                                                                                                                 ");
    	sql.append("\n			,	REGNO                                                                                                                 ");
    	sql.append("\n			,	ROUTE                                                                                                                 ");
    	sql.append("\n			,	RT_GROUPING                                                                                                           ");
    	sql.append("\n			,	ABHR                                                                                                                  ");
    	sql.append("\n			,	PLN_TRIP_FUEL                                                                                                         ");
    	sql.append("\n			,	TO_CHAR(CHARGE) AS CHARGE                                                                                             ");
    	sql.append("\n			,	FUEL_COST                                                                                                             ");
    	sql.append("\n			,	TO_CHAR(CREW_COST) AS CREW_COST                                                                                       ");
    	sql.append("\n			,	TO_CHAR(MAINTENANCE_COST) AS MAINTENANCE_COST                                                                         ");
    	sql.append("\n			FROM KFOS.ERS_EXCEPTION_ROUTE_T                                                                                           ");
    	sql.append("\n	    WHERE                                                                                                                         ");
    	sql.append("\n						FIRST_LEG_FLT_DT = TO_DATE('"+params.getPFirstLegFltDt()+"',	'YYYYMMDD') -- SELECTED FIRST_LEG_FLT_DT      ");
    	sql.append("\n	    AND FLT_NUM = '"+params.getPFltNum()+"' -- SELECTED FLT_NUM                                                                   ");
    	sql.append("\n	    AND STNFR = '"+params.getPStnFr()+"' -- SELECTED STNFR                                                                        ");
    	sql.append("\n	    AND STNTO = '"+params.getPStnTo()+"' -- SELECTED STNTO                                                                        ");
    	sql.append("\n	    AND ACTYP = '"+params.getPSacTyp()+"' -- SELECTED SACTYP                                                                      ");
    	sql.append("\n		) AL                                                                                                                          ");
    	sql.append("\n	,	KFOS.ERS_MASTER_T MAST                                                                                                        ");
    	sql.append("\n	WHERE                                                                                                                             ");
    	sql.append("\n		AL.FIRST_LEG_FLT_DT = MAST.FIRST_LEG_FLT_DT(+)                                                                                ");
    	sql.append("\n	AND AL.FLT_NUM = MAST.FLT_NUM(+)                                                                                                  ");
    	sql.append("\n	AND AL.LEG_NUM = MAST.LEG_NUM(+)                                                                                                  ");
    	sql.append("\n	AND AL.STNFR = MAST.STNFR(+)                                                                                                      ");
    	sql.append("\n	AND AL.STNTO = MAST.STNTO(+)                                                                                                      ");
    	sql.append("\n	AND AL.RT_GROUPING = MAST.ROUTE(+)                                                                                                ");
    	sql.append("\n	AND AL.ABHR = MAST.ABHR(+)                                                                                                        ");
    	sql.append("\n	AND AL.PLN_TRIP_FUEL = MAST.PLN_TRIP_FUEL(+)                                                                                      ");
    	sql.append("\n	ORDER BY                                                                                                                          ");
    	sql.append("\n		NVL(AL.RT_GROUPING,'****')                                                                                                    ");
    	sql.append("\n	,	AL.ROUTE                                                                                                                      ");
    	
    	System.out.println("selEnabledRouteList_back2 : " + sql.toString());
    	
    	return sql.toString();
    }
    
  //@2019-07-01
  	public String selEnabledRouteList(FfsA080BG params){
      		StringBuffer sql = new StringBuffer();    	

  		sql.append("\n	SELECT DISTINCT"); 		
  		sql.append("\n		AL.FIRST_LEG_FLT_DT");
  		sql.append("\n	,	AL.FLT_NUM");
  		sql.append("\n	,	AL.LEG_NUM");
  		sql.append("\n	,	AL.STNFR");
  		sql.append("\n	,	AL.STNTO");
  		sql.append("\n	,	AL.ACTYP");
  		sql.append("\n	,	AL.REGNO");
  		sql.append("\n	,	AL.ROUTE");
  		sql.append("\n	,	NVL(AL.RT_GROUPING,'****') RT_GROUPING");
  		sql.append("\n	,	NVL(MAST.REASON_1,	'') REASON_1");
  		sql.append("\n	,	NVL(MAST.REASON_2,	'') REASON_2");
  		sql.append("\n	,	MAST.ROUTE MAST_RT_GROUPING");
  		sql.append("\n	,	MAST.PLN_TRIP_FUEL MAST_PLN_TRIP_FUEL");
  		sql.append("\n	,	AL.ABHR");
  		sql.append("\n	,	AL.PLN_TRIP_FUEL");
  		sql.append("\n	,	AL.CHARGE");
  		sql.append("\n	,	AL.FUEL_COST");
  		sql.append("\n	,	NVL(AL.CREW_COST,MAST.CREW_COST) CREW_COST");
  		sql.append("\n	,	NVL(AL.MAINTENANCE_COST,MAST.MAINT_COST) MAINTENANCE_COST");
  		sql.append("\n	,	DECODE(NVL(MAST.CONFIRM_Y,	''),	'Y',	'Y',	'N') CONF");
  		sql.append("\n	,	DECODE(MAST.CHK,'Y','Y','N') CHK");
  		sql.append("\n	FROM");
  		sql.append("\n		(");
  		sql.append("\n			SELECT FIRST_LEG_FLT_DT");
  		sql.append("\n			,	FLT_NUM");
  		sql.append("\n			,	LEG_NUM");
  		sql.append("\n			,	STNFR");
  		sql.append("\n			,	STNTO");
  		sql.append("\n			,	ACTYP");
  		sql.append("\n			,	REGNO");
  		sql.append("\n			,	ROUTE");
  		sql.append("\n			,	RT_GROUPING");
  		sql.append("\n			,	ABHR");
  		sql.append("\n			,	PLN_TRIP_FUEL");
  		sql.append("\n			,	CHARGE");
  		sql.append("\n			,	FUEL_COST");
  		sql.append("\n			,	CREW_COST");
  		sql.append("\n			,	MAINTENANCE_COST");
  		sql.append("\n	    FROM (");
  		sql.append("\n	      SELECT FP.FIRST_LEG_FLT_DT");
  		sql.append("\n	      ,	FP.FLT_NUM");
  		sql.append("\n	      ,	FP.LEG_NUM");
  		sql.append("\n	      ,	FP.STNFR");
  		sql.append("\n	      ,	FP.STNTO");
  		sql.append("\n	      ,	FP.ACTYP");
  		sql.append("\n	      ,	FP.REGNO");
  		sql.append("\n	      ,	FP.ROUTE");
  		sql.append("\n	      ,	NVL(RT.RT_GROUPING,'****') AS RT_GROUPING");    	
  		sql.append("\n	      ,	FP.ABHR");
  		sql.append("\n	      ,	FP.PLN_TRIP_FUEL");
  		sql.append("\n	      ,	FP.CHARGE");
  		sql.append("\n	      ,	FP.FUEL_COST");
  		sql.append("\n	      ,	DECODE(RFP.AVG_ABHR,	NULL,	NULL,	ROUND((CREW.CREW_COST/RFP.AVG_ABHR)*(FP.ABHR/60),	3)) CREW_COST");
  		sql.append("\n	      ,	DECODE(RFP.AVG_ABHR,	NULL,	NULL,	ROUND((MAINT.MAINTENANCE_COST/RFP.AVG_ABHR)*(FP.ABHR/60),	3)) MAINTENANCE_COST");
  		sql.append("\n	      FROM");
  		sql.append("\n	        (");
  		sql.append("\n	          SELECT");
  		sql.append("\n	            AAA.DEPARTURE_IATA_CTY_APO_CD");
  		sql.append("\n	          ,	AAA.ARRIVAL_IATA_CTY_APO_CD");
  		sql.append("\n	          ,	AAA.AIRCRAFT_VERSION_CODE");
  		sql.append("\n	          ,	ROUND(AAA.CREW_COST/BBB.CONVERSION_RATE,	2) CREW_COST");
  		sql.append("\n	          FROM");
  		sql.append("\n	            (");
  		sql.append("\n	              SELECT");
  		sql.append("\n	                BB.DEPARTURE_IATA_CTY_APO_CD");
  		sql.append("\n	              ,	BB.ARRIVAL_IATA_CTY_APO_CD");
  		sql.append("\n	              ,	BB.AIRCRAFT_VERSION_CODE");
  		sql.append("\n	              ,	AVG((NVL(AA.MONTHLY_AMT,	0)+BB.STANDARD_KRW_COST)) CREW_COST");
  		sql.append("\n	              FROM");
  		sql.append("\n	                (");
  		sql.append("\n	                  SELECT");
  		sql.append("\n	                    A.PERIOD_NAME");
  		sql.append("\n	                  ,	A.DEPARTURE_IATA_CTY_APO_CD");
  		sql.append("\n	                  ,	A.ARRIVAL_IATA_CTY_APO_CD");
  		sql.append("\n	                  ,	A.FLIGHT_NUMBER");
  		sql.append("\n	                  ,	SUBSTR(A.AIRCRAFT_VERSION_CODE,	0,	3) AIRCRAFT_VERSION_CODE");
  		sql.append("\n	                  ,	ROUND(SUM(A.MONTHLY_AMT/A.FRQ),	3) MONTHLY_AMT");
  		sql.append("\n	                   FROM");
  		sql.append("\n	                    KFOS.ERS_CABIN_CREW_COST_T A");
  		sql.append("\n	                  ,	(");
  		sql.append("\n	                      SELECT");
  		sql.append("\n	                        MAX(PERIOD_NAME) PERIOD_NAME");
  		sql.append("\n	                      FROM");
  		sql.append("\n	                        KFOS.ERS_CABIN_CREW_COST_T");
  		sql.append("\n	                      WHERE");
  		sql.append("\n	                        DEPARTURE_IATA_CTY_APO_CD = '"+params.getPStnFr()+"' -- SELECTED STNFR");
  		sql.append("\n	                      AND ARRIVAL_IATA_CTY_APO_CD = '"+params.getPStnTo()+"' -- SELECTED STNTO");
  		sql.append("\n	                      AND SUBSTR(AIRCRAFT_VERSION_CODE,	0,	3) = '"+params.getPSacTyp()+"'");
  		sql.append("\n	                    ) B -- SELECTED SACTYP");
  		sql.append("\n	                  WHERE");
  		sql.append("\n	                    A.PERIOD_NAME = B.PERIOD_NAME");
  		sql.append("\n	                  AND A.DEPARTURE_IATA_CTY_APO_CD = '"+params.getPStnFr()+"' -- SELECTED STNFR");
  		sql.append("\n	                  AND A.ARRIVAL_IATA_CTY_APO_CD = '"+params.getPStnTo()+"' -- SELECTED STNTO");
  		sql.append("\n	                  AND SUBSTR(A.AIRCRAFT_VERSION_CODE,	0,	3) = '"+params.getPSacTyp()+"' -- SELECTED SACTYP");
  		sql.append("\n	                  GROUP BY");
  		sql.append("\n	                    A.PERIOD_NAME");
  		sql.append("\n	                  ,	A.DEPARTURE_IATA_CTY_APO_CD");
  		sql.append("\n	                  ,	A.ARRIVAL_IATA_CTY_APO_CD");
  		sql.append("\n	                  ,	A.FLIGHT_NUMBER");
  		sql.append("\n	                  ,	SUBSTR(A.AIRCRAFT_VERSION_CODE,	0,	3)");
  		sql.append("\n	                ) AA");
  		sql.append("\n	              ,	(");
  		sql.append("\n	                  SELECT C.PERIOD_NAME");
  		sql.append("\n	                  ,	C.DEPARTURE_IATA_CTY_APO_CD");
  		sql.append("\n	                  ,	C.ARRIVAL_IATA_CTY_APO_CD");
  		sql.append("\n	                  ,	SUBSTR(C.AIRCRAFT_VERSION_CODE,	0,	3) AIRCRAFT_VERSION_CODE");
  		sql.append("\n	                  ,	AVG(C.STANDARD_KRW_COST) STANDARD_KRW_COST");
  		sql.append("\n	                  FROM");
  		sql.append("\n	                    KFOS.ERS_COCKPIT_CREW_COST_T C");
  		sql.append("\n	                  ,	(");
  		sql.append("\n	                      SELECT");
  		sql.append("\n	                        MAX(PERIOD_NAME) PERIOD_NAME");
  		sql.append("\n	                      FROM KFOS.ERS_COCKPIT_CREW_COST_T");
  		sql.append("\n	                      WHERE");
  		sql.append("\n	                        DEPARTURE_IATA_CTY_APO_CD = '"+params.getPStnFr()+"' -- SELECTED STNFR");
  		sql.append("\n	                      AND ARRIVAL_IATA_CTY_APO_CD = '"+params.getPStnTo()+"' -- SELECTED STNTO");
  		sql.append("\n	                      AND SUBSTR(AIRCRAFT_VERSION_CODE,	0,	3) = '"+params.getPSacTyp()+"'");
  		sql.append("\n	                    ) D -- SELECTED SACTYP");
  		sql.append("\n	                  WHERE C.PERIOD_NAME = D.PERIOD_NAME");
  		sql.append("\n	                  AND C.DEPARTURE_IATA_CTY_APO_CD = '"+params.getPStnFr()+"' -- SELECTED STNFR");
  		sql.append("\n	                  AND C.ARRIVAL_IATA_CTY_APO_CD = '"+params.getPStnTo()+"' -- SELECTED STNTO");
  		sql.append("\n	                  AND SUBSTR(C.AIRCRAFT_VERSION_CODE,	0,	3) = '"+params.getPSacTyp()+"'");
  		sql.append("\n	                          GROUP BY");
  		sql.append("\n	                    C.PERIOD_NAME");
  		sql.append("\n	                  ,	C.DEPARTURE_IATA_CTY_APO_CD");
  		sql.append("\n	                  ,	C.ARRIVAL_IATA_CTY_APO_CD");
  		sql.append("\n	                  ,	SUBSTR(C.AIRCRAFT_VERSION_CODE,	0,	3)");
  		sql.append("\n	                ) BB -- SELECTED SACTYP");
  		sql.append("\n	              WHERE");
  		sql.append("\n	                AA.DEPARTURE_IATA_CTY_APO_CD(+) = BB.DEPARTURE_IATA_CTY_APO_CD");
  		sql.append("\n	              AND AA.ARRIVAL_IATA_CTY_APO_CD(+) = BB.ARRIVAL_IATA_CTY_APO_CD");
  		sql.append("\n	              AND AA.AIRCRAFT_VERSION_CODE(+) = BB.AIRCRAFT_VERSION_CODE");
  		sql.append("\n	              GROUP BY");
  		sql.append("\n	                BB.DEPARTURE_IATA_CTY_APO_CD");
  		sql.append("\n	              ,	BB.ARRIVAL_IATA_CTY_APO_CD");
  		sql.append("\n	              ,	BB.AIRCRAFT_VERSION_CODE");
  		sql.append("\n	            ) AAA");
  		sql.append("\n	          ,	(");
  		sql.append("\n	              SELECT FROM_CURRENCY");
  		sql.append("\n	              ,	TO_CURRENCY");
  		sql.append("\n	              ,	CONVERSION_RATE");
  		sql.append("\n	              FROM");
  		sql.append("\n	              (");
  		sql.append("\n	                SELECT * FROM KFOS.TDAILY_RATES_II");
  		sql.append("\n	                WHERE");
  		sql.append("\n	                  FROM_CURRENCY = 'USD'");
  		sql.append("\n	                AND TO_CURRENCY = 'KRW'");
  		sql.append("\n	                AND USER_CONVERSION_TYPE = 'KE_CURRENCY_IATA_FD'");
  		sql.append("\n	                ORDER BY CONVERSION_DATE DESC");
  		sql.append("\n	              )");
  		sql.append("\n	              WHERE ROWNUM = 1");
  		sql.append("\n	            ) BBB");
  		sql.append("\n	          WHERE ROWNUM = 1");
  		sql.append("\n	        ) CREW");


    	sql.append("\n	      ,	(                                                                                                                         ");
    	sql.append("\n          SELECT                                                                                                                    ");
    	sql.append("\n	            AA.DEPARTURE_IATA_CTY_APO_CD                                                                                          ");
    	sql.append("\n	            ,	AA.ARRIVAL_IATA_CTY_APO_CD                                                                                        ");
    	sql.append("\n	            ,	AA.AIRCRAFT_VERSION_CODE                                                                                          ");
    	sql.append("\n	            , ROUND(AA.MAINTENANCE_COST/BB.CONVERSION_RATE,2) AS MAINTENANCE_COST                                                 ");
    	sql.append("\n          FROM                                                                                                                      ");
    	sql.append("\n              (                                                                                                                     ");
    	sql.append("\n              SELECT                                                                                                                ");
    	sql.append("\n                  DEPARTURE_IATA_CTY_APO_CD                                                                                         ");
    	sql.append("\n                  ,	ARRIVAL_IATA_CTY_APO_CD                                                                                       ");
    	sql.append("\n                  ,	SUBSTR(AIRCRAFT_VERSION_CODE,0,3) AS AIRCRAFT_VERSION_CODE                                                    ");
    	sql.append("\n                  ,	ROUND(SUM(INVOICE_KRW_AMOUNT)/SUM(REVENUE_FLIGHT_OPERATION_COUNT), 3) AS MAINTENANCE_COST                          ");
    	sql.append("\n              FROM                                                                                                                  ");
    	sql.append("\n                  (                                                                                                                 ");
    	sql.append("\n                  SELECT                                                                                                            ");
    	sql.append("\n                      PERIOD_NAME                                                                                                   ");
    	sql.append("\n                      ,	FLIGHT_NUMBER                                                                                             ");
    	sql.append("\n                      ,	DEPARTURE_IATA_CTY_APO_CD                                                                                 ");
    	sql.append("\n                      ,	ARRIVAL_IATA_CTY_APO_CD                                                                                   ");
    	sql.append("\n                      ,	AIRCRAFT_VERSION_CODE                                                                                     ");
    	sql.append("\n                      ,	REVENUE_FLIGHT_OPERATION_COUNT                                                                            ");
    	sql.append("\n                      ,	SUM(INVOICE_KRW_AMOUNT)	AS INVOICE_KRW_AMOUNT                                                             ");
    	sql.append("\n                  FROM KFOS.ERS_MAINTENANCE_COST_T                                                                                  ");
    	sql.append("\n                  WHERE DEPARTURE_IATA_CTY_APO_CD =	'"+params.getPStnFr()+"' -- SELECTED STNFR                                    ");
    	sql.append("\n                  AND ARRIVAL_IATA_CTY_APO_CD = '"+params.getPStnTo()+"' -- SELECTED STNTO                                          ");
    	sql.append("\n                  AND SUBSTR(AIRCRAFT_VERSION_CODE,	0,	3) = '"+params.getPSacTyp()+"' -- SELECTED SACTYP                         ");
    	sql.append("\n                  AND PERIOD_NAME BETWEEN TO_CHAR(ADD_MONTHS(SYSDATE,-13),'YYYYMM') AND TO_CHAR(SYSDATE,'YYYYMM')                   ");
    	sql.append("\n                  GROUP BY                                                                                                          ");
    	sql.append("\n                      PERIOD_NAME                                                                                                   ");
    	sql.append("\n                      ,	FLIGHT_NUMBER                                                                                             ");
    	sql.append("\n                      ,	DEPARTURE_IATA_CTY_APO_CD                                                                                 ");
    	sql.append("\n                      ,	ARRIVAL_IATA_CTY_APO_CD                                                                                   ");
    	sql.append("\n                      ,	AIRCRAFT_VERSION_CODE                                                                                     ");
    	sql.append("\n                      ,	REVENUE_FLIGHT_OPERATION_COUNT                                                                            ");
    	sql.append("\n                  )                                                                                                                 ");
    	sql.append("\n              GROUP BY                                                                                                              ");
    	sql.append("\n                  DEPARTURE_IATA_CTY_APO_CD                                                                                         ");
    	sql.append("\n	                ,	ARRIVAL_IATA_CTY_APO_CD                                                                                       ");
    	sql.append("\n	                ,	SUBSTR(AIRCRAFT_VERSION_CODE,0,3)                                                                             ");
    	sql.append("\n              ) AA                                                                                                                  ");
    	sql.append("\n              , (                                                                                                                   ");
    	sql.append("\n              SELECT                                                                                                                ");
    	sql.append("\n                  CONVERSION_RATE                                                                                                   ");
    	sql.append("\n	            FROM                                                                                                                  ");
    	sql.append("\n                  (                                                                                                                 ");
    	sql.append("\n                  SELECT * FROM KFOS.TDAILY_RATES_II                                                                                ");
    	sql.append("\n                  WHERE FROM_CURRENCY = 'USD'                                                                                       ");
    	sql.append("\n                  AND TO_CURRENCY = 'KRW'                                                                                           ");
    	sql.append("\n                  AND USER_CONVERSION_TYPE = 'KE_CURRENCY_IATA_FD'                                                                  ");
    	sql.append("\n                  ORDER BY CONVERSION_DATE DESC                                                                                     ");
    	sql.append("\n                  )                                                                                                                 ");
    	sql.append("\n              WHERE ROWNUM = 1                                                                                                      ");
    	sql.append("\n              ) BB                                                                                                                  ");
    	sql.append("\n	        ) MAINT                                                                                                                   ");
  		
  		sql.append("\n	      ,	(");
  		sql.append("\n	          SELECT A.FIRST_LEG_FLT_DT");
  		sql.append("\n	          ,	A.FLT_NUM");
  		sql.append("\n	          ,	A.LEG_NUM");
  		sql.append("\n	          ,	A.STNFR");
  		sql.append("\n	          ,	A.STNTO");
  		sql.append("\n	          ,	A.ACTYP");
  		sql.append("\n	          ,	A.REGION_CD");
  		sql.append("\n	          ,	A.REGNO");
  		sql.append("\n	          ,	A.ROUTE");
  		sql.append("\n	          ,	A.ABHR");
  		sql.append("\n	          ,	A.PLN_TRIP_FUEL");
  		sql.append("\n	          ,	A.CHARGE");
  		sql.append("\n	          ,	ROUND(PLN_TRIP_FUEL*100*DECODE(B.INT_FUEL_UPRC_USD,	NULL,	3,	B.INT_FUEL_UPRC_USD)/6.7,	3) FUEL_COST");
  		sql.append("\n	          FROM");
  		sql.append("\n	            KFOS.FLIGHT_PLAN_T_PLAN A");
  		sql.append("\n	          ,	(");
  		sql.append("\n	              SELECT *");
  		sql.append("\n	              FROM");
  		sql.append("\n	                (");
  		sql.append("\n	                  SELECT");
  		sql.append("\n	                    IATA_PORT");
  		sql.append("\n	                  ,	INT_FUEL_UPRC_USD");
  		sql.append("\n	                  FROM");
  		sql.append("\n	                    KFOS.ERP_PORT_FUEL_UPRC_II");
  		sql.append("\n	                  WHERE");
  		sql.append("\n	                    IATA_PORT = '"+params.getPStnFr()+"' -- SELECTED STNFR");
  		sql.append("\n	                  ORDER BY TIMESTMP DESC");
  		sql.append("\n	                )");
  		sql.append("\n	              WHERE ROWNUM = 1");
  		sql.append("\n	            ) B");
  		sql.append("\n	          WHERE");
  		sql.append("\n	            A.FIRST_LEG_FLT_DT = TO_DATE('"+params.getPFirstLegFltDt()+"',	'YYYYMMDD') -- SELECTED FIRST_LEG_FLT_DT");
  		sql.append("\n	          AND A.FLT_NUM = '"+params.getPFltNum()+"' -- SELECTED FLT_NUM");
  		sql.append("\n	          AND A.STNFR = '"+params.getPStnFr()+"' -- SELECTED STNFR");
  		sql.append("\n	          AND A.STNTO = '"+params.getPStnTo()+"' -- SELECTED STNTO");
  		sql.append("\n	          AND A.ACTYP = '"+params.getPSacTyp()+"' -- SELECTED SACTYP");
  		sql.append("\n	          AND A.CHARGE IS NOT NULL");
  		sql.append("\n	          AND A.STNFR = B.IATA_PORT(+)");
  		sql.append("\n	        ) FP");
  		sql.append("\n	      ,	(");
  		sql.append("\n	          SELECT ROUND(AVG(ABHR)/60,	3) AVG_ABHR");
  		sql.append("\n	          FROM KFOS.FLIGHT_PLAN_T");
  		sql.append("\n	          WHERE");
  		sql.append("\n	            FIRST_LEG_FLT_DT BETWEEN TRUNC(ADD_MONTHS(SYSDATE,	-3) +1) - TO_CHAR(SYSDATE,	'DD')");
  		sql.append("\n	          AND TRUNC(LAST_DAY(ADD_MONTHS(SYSDATE,	-1)))+0.99999421");
  		sql.append("\n	          AND ACTIVE = 'Y'");
  		sql.append("\n	          AND STNFR = '"+params.getPStnFr()+"' -- SELECTED STNFR");
  		sql.append("\n	          AND STNTO = '"+params.getPStnTo()+"' -- SELECTED STNTO");
  		sql.append("\n	          AND ACTYP = '"+params.getPSacTyp()+"'");
  		sql.append("\n	        ) RFP");
  		sql.append("\n	      ,	KFOS.ERS_ROUTE_T RT");
  		sql.append("\n	      ,	DAILY_SCH_T DS -- SELECTED SACTYP");
  		sql.append("\n	      WHERE");
  		sql.append("\n	        DS.STNFR = CREW.DEPARTURE_IATA_CTY_APO_CD(+)");
  		sql.append("\n	      AND DS.STNFR = MAINT.DEPARTURE_IATA_CTY_APO_CD(+)");
  		sql.append("\n	      AND DS.STNTO = CREW.ARRIVAL_IATA_CTY_APO_CD(+)");
  		sql.append("\n	      AND DS.STNTO = MAINT.ARRIVAL_IATA_CTY_APO_CD(+)");
  		sql.append("\n	      AND DS.SACTYP = SUBSTR(CREW.AIRCRAFT_VERSION_CODE(+),0,3)");
  		sql.append("\n	      AND DS.SACTYP = SUBSTR(MAINT.AIRCRAFT_VERSION_CODE(+),0,3)");
  		sql.append("\n	      AND FP.FIRST_LEG_FLT_DT = DS.FIRST_LEG_FLT_DT");
  		sql.append("\n	      AND FP.FLT_NUM = DS.FLT_NUM");
  		sql.append("\n	      AND FP.STNFR = DS.STNFR");
  		sql.append("\n	      AND FP.STNTO = DS.STNTO");
  		sql.append("\n	      AND DS.ACTNID <> 'CNL'");
  		sql.append("\n	      AND RT.REGION(+) = FP.REGION_CD");
  		sql.append("\n	      AND RT.ROUTE_ID(+) = FP.ROUTE");
  		sql.append("\n	      ORDER BY FP.ROUTE ASC");
  		sql.append("\n	    )");
  		sql.append("\n	    UNION");
  		sql.append("\n	    SELECT FIRST_LEG_FLT_DT");
  		sql.append("\n			,	FLT_NUM");
  		sql.append("\n			,	LEG_NUM");
  		sql.append("\n			,	STNFR");
  		sql.append("\n			,	STNTO");
  		sql.append("\n			,	ACTYP");
  		sql.append("\n			,	REGNO");
  		sql.append("\n			,	ROUTE");
  		sql.append("\n			,	RT_GROUPING");
  		sql.append("\n			,	ABHR");
  		sql.append("\n			,	PLN_TRIP_FUEL");
  		sql.append("\n			,	TO_CHAR(CHARGE) AS CHARGE");
  		sql.append("\n			,	FUEL_COST");
  		sql.append("\n			,	TO_CHAR(CREW_COST) AS CREW_COST");
  		sql.append("\n			,	TO_CHAR(MAINTENANCE_COST) AS MAINTENANCE_COST");
  		sql.append("\n			FROM KFOS.ERS_EXCEPTION_ROUTE_T");
  		sql.append("\n	    WHERE");
  		sql.append("\n						FIRST_LEG_FLT_DT = TO_DATE('"+params.getPFirstLegFltDt()+"',	'YYYYMMDD') -- SELECTED FIRST_LEG_FLT_DT");
  		sql.append("\n	    AND FLT_NUM = '"+params.getPFltNum()+"' -- SELECTED FLT_NUM");
  		sql.append("\n	    AND STNFR = '"+params.getPStnFr()+"' -- SELECTED STNFR");
  		sql.append("\n	    AND STNTO = '"+params.getPStnTo()+"' -- SELECTED STNTO");
  		sql.append("\n	    AND ACTYP = '"+params.getPSacTyp()+"' -- SELECTED SACTYP");
  		sql.append("\n		) AL");
  		sql.append("\n	,	KFOS.ERS_MASTER_T MAST");
  		sql.append("\n	WHERE");
  		sql.append("\n		AL.FIRST_LEG_FLT_DT = MAST.FIRST_LEG_FLT_DT(+)");
  		sql.append("\n	AND AL.FLT_NUM = MAST.FLT_NUM(+)");
  		sql.append("\n	AND AL.LEG_NUM = MAST.LEG_NUM(+)");
  		sql.append("\n	AND AL.STNFR = MAST.STNFR(+)");
  		sql.append("\n	AND AL.STNTO = MAST.STNTO(+)");
  		sql.append("\n	AND AL.RT_GROUPING = MAST.ROUTE(+)");
  		sql.append("\n	AND AL.ABHR = MAST.ABHR(+)");
  		sql.append("\n	AND AL.PLN_TRIP_FUEL = MAST.PLN_TRIP_FUEL(+)");
  		sql.append("\n	ORDER BY");
  		sql.append("\n		NVL(AL.RT_GROUPING,'****')");
  		sql.append("\n	,	AL.ROUTE");

  		System.out.println("selEnabledRouteList : " + sql.toString());
      	
  		return sql.toString();
  	}
    	
    public String selErsMasterT(FfsA080BG params){
    	StringBuffer sql = new StringBuffer();
    	
    	sql.append(" SELECT COUNT(*) CNT FROM KFOS.ERS_MASTER_T ");
    	sql.append(" WHERE FIRST_LEG_FLT_DT = TO_DATE('"+params.getPFirstLegFltDt()+"','YYYYMMDD') ");
    	sql.append(" AND FLT_NUM = '"+params.getPFltNum()+"'");
    	sql.append(" AND LEG_NUM = '"+params.getPLegNum()+"'");
    	sql.append(" AND STNFR = '"+params.getPStnFr()+"'");
    	sql.append(" AND STNTO = '"+params.getPStnTo()+"'");
    	
    	//System.out.println(sql.toString());
    	
    	return sql.toString();
    }
    
    /*public String insErsMasterT(FfsA080BG params){
    	StringBuffer sql = new StringBuffer();
    	
    	sql.append(" INSERT INTO KFOS.ERS_MASTER_T ( ");
    	sql.append("     FIRST_LEG_FLT_DT, FLT_NUM, LEG_NUM, STNFR, STNTO, REGNO, SACTYP, ABHR, ");
    	sql.append("     PLN_TRIP_FUEL, FUEL_COST, OVERFLT_COST, CREW_COST, MAINT_COST, COST_AMOUNT, COMPARED_TO_KAM, ");
    	sql.append("     ROUTE, REASON_1, REASON_2, USERID, TIMESTMP, CONFIRM_Y ");
    	sql.append(" ) VALUES ( ");
    	sql.append(" TO_DATE('"+params.getPFirstLegFltDt()+"','YYYYMMDD') , '"+params.getPFltNum()+"', '"+params.getPLegNum()+"','"+params.getPStnFr()+"','"+params.getPStnTo()+"','"+params.getPRegNo()+"','"+params.getPSacTyp()+"','"+params.getAbhr()+"',");
    	sql.append(" '"+params.getPlnTripFuel()+"','"+params.getFuelCost()+"','"+params.getOverfltCost()+"','"+params.getCrewCost()+"','"+params.getMaintenceCost()+"','"+params.getCostAmount()+"','"+params.getCompareTo()+"',");
    	sql.append(" '"+params.getRtGrouping()+"','"+params.getReason1()+"','"+params.getReason2()+"','system',SYSDATE, '"+params.getConf()+"' )");
    	
    	System.out.println(sql.toString());    	
    	return sql.toString();
    }*/
    public String insErsMasterT(FfsA080BG params){//2013-02-14
    	StringBuffer sql = new StringBuffer();
    	
    	sql.append(" INSERT INTO KFOS.ERS_MASTER_T ( ");
    	sql.append("     FIRST_LEG_FLT_DT, FLT_NUM, LEG_NUM, STNFR, STNTO, REGNO, SACTYP, ABHR, ");
    	sql.append("     PLN_TRIP_FUEL, FUEL_COST, OVERFLT_COST, CREW_COST, MAINT_COST, COST_AMOUNT, COMPARED_TO_KAM, ");
    	sql.append("     ROUTE, REASON_1, REASON_2, USERID, TIMESTMP, CONFIRM_Y,CHK,PLAN_RT ");
    	sql.append(" ) VALUES ( ");
    	sql.append(" TO_DATE('"+params.getPFirstLegFltDt()+"','YYYYMMDD') , '"+params.getPFltNum()+"', '"+params.getPLegNum()+"','"+params.getPStnFr()+"','"+params.getPStnTo()+"','"+params.getPRegNo()+"','"+params.getPSacTyp()+"','"+params.getAbhr()+"',");
    	sql.append(" '"+params.getPlnTripFuel()+"','"+params.getFuelCost()+"','"+params.getOverfltCost()+"','"+params.getCrewCost()+"','"+params.getMaintenceCost()+"','"+params.getCostAmount()+"','"+params.getCompareTo()+"',");
    	sql.append(" '"+params.getRtGrouping()+"','"+params.getReason1()+"','"+params.getReason2()+"','system',SYSDATE, '"+params.getConf()+"','"+params.getChk()+"','"+params.getRoute()+"' )");
    	
    	//System.out.println(sql.toString());    	
    	return sql.toString();
    }
    
    public String updErsMasterT(FfsA080BG params){
    	StringBuffer sql = new StringBuffer();
    	
    	sql.append("UPDATE KFOS.ERS_MASTER_T ");
    	sql.append("SET ABHR = '"+params.getAbhr()+"', PLN_TRIP_FUEL = '"+params.getPlnTripFuel()+"',");
    	sql.append("FUEL_COST = '"+params.getFuelCost()+"',OVERFLT_COST='"+params.getOverfltCost()+"',CREW_COST='"+params.getCrewCost()+"',MAINT_COST='"+params.getMaintCost()+"',");
    	sql.append("COST_AMOUNT = '"+params.getCostAmount()+"',COMPARED_TO_KAM='"+params.getCompareTo()+"',ROUTE='"+params.getRtGrouping()+"', ");
    	sql.append("REASON_1='"+params.getReason1()+"',REASON_2='"+params.getReason2()+"',USERID='system',TIMESTMP=SYSDATE ");
    	sql.append("WHERE FIRST_LEG_FLT_DT = TO_DATE('"+params.getPFirstLegFltDt()+"','YYYYMMDD') ");
    	sql.append("AND FLT_NUM = '"+params.getPFltNum()+"' ");
    	sql.append("AND LEG_NUM = '"+params.getPLegNum()+"' ");
    	sql.append("AND STNFR = '"+params.getPStnFr()+"' ");
    	sql.append("AND STNTO = '"+params.getPStnTo()+"' ");
    	
    	//System.out.println(sql.toString());
    	
    	return sql.toString();
    }

	public String delErsMasterT(FfsA080BG params){
		StringBuffer sql = new StringBuffer();

		sql.append("DELETE FROM KFOS.ERS_MASTER_T ");
		sql.append("WHERE FIRST_LEG_FLT_DT = TO_DATE('"+params.getPFirstLegFltDt()+"','YYYYMMDD') ");
    	sql.append("AND FLT_NUM = '"+params.getPFltNum()+"' ");
    	sql.append("AND LEG_NUM = '"+params.getPLegNum()+"' ");
    	sql.append("AND STNFR = '"+params.getPStnFr()+"' ");
    	sql.append("AND STNTO = '"+params.getPStnTo()+"' ");
    	
    	//System.out.println(sql.toString());
		return sql.toString();
	}
}
