package kal.base.ffs.query;

import kal.base.jdf.com.Logger;
import kal.base.ffs.dbbean.*;
import kal.base.com.query.*;
import kal.base.com.util.*;

 /**
  * Position Report Է SQL 
  * @author Copyright (c) 2007/07/12  
  */   
public class FfsA240Query {
	private static FfsA240Query instance = new FfsA240Query();
	
	public static FfsA240Query getInstance() {
		return instance;
	}
	
	/** 
	  *  ð ȸ
	  * @return String Query  
	  * @author Copyright (c) 2007/07/12  
	  */
	public String selTime(FfsA240BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT TO_CHAR(SYSDATE - 9/24,'HH24MI') HH24MI, ");
		sql.append(" 	TO_CHAR(SYSDATE - 9/24,'YYYYMMDD') YYYYMMDD_9, ");
		sql.append(" 	TO_CHAR(SYSDATE - 33/24,'YYYYMMDD') YYYYMMDD_33 ");
		sql.append(" FROM DUAL ");

		Logger.debug.println("[BASE:FfsA240Query:selTime] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * Position Report Է(Waypoint Name̳ /浵   ) SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2007/07/12  
	  */
	public String updWpt(FfsA240BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" UPDATE WAYPOINT_T ");
		sql.append(" SET ");
		sql.append(" 	ATA = TO_DATE('"+params.getYmdAta()+"','YYYYMMDD HH24MI'), ");
		sql.append(" 	ACT_FOB_FUEL = '"+params.getActFobFuel()+"', ");
		sql.append(" 	ACT_LEVEL = '"+params.getActLevel()+"' ");
		sql.append(" WHERE SYSKEY = '"+params.getSyskey()+"' ");
		sql.append(" 	AND SEQ = '"+params.getSeq()+"' ");

		Logger.debug.println("[BASE:FfsA240Query:updWpt] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * POS_TMPST ȸ
	  * @return String Query  
	  * @author Copyright (c) 2007/07/12  
	  */
	public String selPosTmpst(FfsA240BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT TO_CHAR(POS_TMPST - 9/24,'YYYYMMDD HH24MI') POS_TMPST ");
		sql.append(" FROM FLIGHT_PLAN_T ");
		sql.append(" WHERE FIRST_LEG_FLT_DT = TO_DATE('"+params.getFirstLegFltDt()+"','YYYYMMDD') ");
		sql.append(" 	AND FLT_NUM = '"+params.getFltNum()+"' ");
		sql.append(" 	AND STNFR = '"+params.getStnfr()+"' ");
		sql.append(" 	AND STNTO = '"+params.getStnto()+"' ");
		sql.append(" 	AND ACTIVE = 'Y' ");

		Logger.debug.println("[BASE:FfsA240Query:selPosTmpst] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * POS_TMPST 
	  * @return String Query  
	  * @author Copyright (c) 2007/07/12  
	  */
	public String updPosTmpst(FfsA240BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" UPDATE FLIGHT_PLAN_T ");
		sql.append(" SET POS_TMPST = TO_DATE('"+params.getPosTmpst()+"00','YYYYMMDD HH24MISS') + 9/24 "); //POS_TMPST KST
		sql.append(" WHERE FIRST_LEG_FLT_DT = TO_DATE('"+params.getFirstLegFltDt()+"','YYYYMMDD') ");
		sql.append(" 	AND FLT_NUM = '"+params.getFltNum()+"' ");
		sql.append(" 	AND STNFR = '"+params.getStnfr()+"' ");
		sql.append(" 	AND STNTO = '"+params.getStnto()+"' ");
		sql.append(" 	AND ACTIVE = 'Y' ");

		Logger.debug.println("[BASE:FfsA240Query:updPosTmpst] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  *  ð ȸ2
	  * @return String Query  
	  * @author Copyright (c) 2007/07/12  
	  */
	public String selDDHH24MI() {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT TO_CHAR(SYSDATE - 9/24,'DDHH24MI') DDHH24MI ");
		sql.append(" FROM DUAL ");

		Logger.debug.println("[BASE:FfsA240Query:selDDHHMM] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * MS_TELEX_MSG_T MQ Է
	  * @return String Query 
	  * @author Copyright (c) 2008/03/27 
	  */
	public String insMsTelexMsgORG(String seq, String msg, String dbTime){
		StringBuffer sql = new StringBuffer();
		
		sql.append(" INSERT INTO MS_TELEX_MSG_T (MSG_CAT, MSG_TMPST, UNI_SEQ, MSG_MAX, MSG_POS, ORIGIN_ADDR, MESSAGE,PRIORITY, SYS_MQID, PROJECT_NO, PROCESSED, ERROR_REPLY) ");
		sql.append(" VALUES ('FFSMQ',SYSDATE-(9/24),"+seq+", 1, 1, 'SELXWKE','"+msg+"', 1, "+dbTime+"||TRIM(TO_CHAR("+seq+",'00000')), 'FFSMQ', 'N', ' ') ");
		
		Logger.debug.println("[BASE:FfsA240Query:insMsTelexMsg] sql : "+sql.toString());
		return sql.toString();	
	}
	//20150428 MHS
	public String insMsTelexMsg(String seq, String msg, String dbTime){
		
		msg = msg != null ? msg.replace("\"", "") : msg;
		
		StringBuffer sql = new StringBuffer();
		
		sql.append(" INSERT INTO KFOS.MS_TELEX_MHS_T (MSG_CAT, MSG_TMPST, UNI_SEQ, MSG_MAX, MSG_POS, ORIGIN_ADDR, MESSAGE,PRIORITY, SYS_MQID, PROJECT_NO, PROCESSED, ERROR_REPLY) ");
		sql.append(" VALUES ('FFSMQ',SYSDATE-(9/24),"+seq+", 1, 1, 'SELXWKE','"+msg+"', 1, "+dbTime+"||TRIM(TO_CHAR("+seq+",'00000')), 'FFSMQ', 'N', ' ') ");
		
		Logger.debug.println("[BASE:FfsA240Query:insMsTelexMsg] sql : "+sql.toString());
		return sql.toString();	
	}
	
}
