package kal.base.ffs.query;

import kal.base.jdf.com.Logger;
import kal.base.ffs.dbbean.*;
import kal.base.com.query.*;
import kal.base.com.util.*;

 /**
  * Release Message ȸ,  SQL 
  * @author Copyright (c) 2009/01/02  
  */   
public class FfsA260Query {
	private static FfsA260Query instance = new FfsA260Query();
	
	public static FfsA260Query getInstance() {
		return instance;
	}
	
	/** 
	  * ISSUED NBR ȸ
	  * @return String Query  
	  * @author Copyright (c) 2009/01/02  
	  */
	public String selIssuedNbr(FfsA260BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT MSG_SEQ ");
		sql.append(" FROM BS_FUELMSG_T ");
		sql.append(" WHERE  FIRST_LEG_FLT_DT = TO_DATE('"+params.getPFirstLegFltDt()+"','YYYYMMDD') ");
		sql.append(" 	AND FLT_NUM = '"+params.getPFltNum()+"' ");
		sql.append(" 	AND STNFR = '"+params.getPStnfr()+"' ");
		sql.append(" 	AND STNTO = '"+params.getPStnto()+"' ");
		sql.append(" ORDER BY MSG_SEQ ");
		
		//System.out.println("[BASE:FfsA260Query:selIssuedNbr] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * MAX(MSG_SEQ) ȸ
	  * @return String Query  
	  * @author Copyright (c) 2009/01/16  
	  */
	public String selMaxSeq(FfsA260BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT MSG_SEQ, ADD_FUEL_Q ");
		sql.append(" FROM BS_FUELMSG_T ");
		sql.append(" WHERE  FIRST_LEG_FLT_DT = TO_DATE('"+params.getPFirstLegFltDt()+"','YYYYMMDD') ");
		sql.append(" 	AND FLT_NUM = '"+params.getPFltNum()+"' ");
		sql.append(" 	AND STNFR = '"+params.getPStnfr()+"' ");
		sql.append(" 	AND STNTO = '"+params.getPStnto()+"' ");
		sql.append(" 	AND MSG_SEQ = ");
		sql.append(" ( SELECT MAX(MSG_SEQ) ");
		sql.append(" FROM BS_FUELMSG_T ");
		sql.append(" WHERE  FIRST_LEG_FLT_DT = TO_DATE('"+params.getPFirstLegFltDt()+"','YYYYMMDD') ");
		sql.append(" 	AND FLT_NUM = '"+params.getPFltNum()+"' ");
		sql.append(" 	AND STNFR = '"+params.getPStnfr()+"' ");
		sql.append(" 	AND STNTO = '"+params.getPStnto()+"' ) ");

		//System.out.println("[BASE:FfsA260Query:selMaxSeq] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * ش Release Message ȸ
	  * @return String Query  
	  * @author Copyright (c) 2009/01/02  
	  */
	public String selRlsMsg_back(FfsA260BG params) {
		StringBuffer sql = new StringBuffer();
		
		/*
		 * DOC_NO   FLIGHT_ALERT_T  ϵ  
		sql.append(" SELECT MSG_SEQ, PLAN_NO, SUBSTR(REGNO,3,4) REGNO, EST_DEP_T, EST_DEP_D, ");
		sql.append(" 	ADD_FUEL_Q, ADD_RSN_CD, ");
		sql.append(" 	RAMP_FUEL_Q, TAXI_FUEL_Q, TOF_Q, TIF_Q, PLD_Q, TOW_Q, ");
		sql.append(" 	DISP_NAME, CC_FUEL95_Q, CC_FUEL75_Q, CC_FUEL50_Q, ADD_INFO, SI_INFO, RCV_ADDR, ORGN_ADDR "); //2009.01.16 ߰ : ORGN_ADDR, 2010.07.21 ߰ : CC_FUEL50_Q
		sql.append(" 	FROM BS_FUELMSG_T ");
		sql.append(" WHERE  FIRST_LEG_FLT_DT = TO_DATE('"+params.getPFirstLegFltDt()+"','YYYYMMDD') ");
		sql.append(" 	AND FLT_NUM = '"+params.getPFltNum()+"' ");
		sql.append(" 	AND STNFR = '"+params.getPStnfr()+"' ");
		sql.append(" 	AND STNTO = '"+params.getPStnto()+"' ");
		sql.append(" 	AND MSG_SEQ = '"+params.getPMsgSeq()+"' ");
		*/
		
		sql.append(" SELECT A.MSG_SEQ, A.PLAN_NO, SUBSTR(A.REGNO,3,4) REGNO, A.EST_DEP_T, A.EST_DEP_D, ");
		sql.append(" 	A.ADD_FUEL_Q, A.ADD_RSN_CD, ");
		sql.append(" 	A.RAMP_FUEL_Q, A.TAXI_FUEL_Q, A.TOF_Q, A.TIF_Q, A.PLD_Q, A.TOW_Q, ");
		sql.append(" 	A.DISP_NAME, A.CC_FUEL95_Q, A.CC_FUEL75_Q, A.CC_FUEL50_Q, A.ADD_INFO, A.SI_INFO, A.RCV_ADDR, A.ORGN_ADDR "); //2009.01.16 ߰ : ORGN_ADDR, 2010.07.21 ߰ : CC_FUEL50_Q
		sql.append(" 	, F.SYSKEY AS DOC_NO ");
		
		//2016.07.27 ߰
		sql.append(" 	, CASE WHEN C.CCF_50_ROW < 0 THEN TO_CHAR(C.CCF_50_ROW * 100) WHEN C.CCF_50_ROW > 0 THEN CONCAT('+', C.CCF_50_ROW * 100) ELSE '' END AS CCF_50_ROW ");
		sql.append(" 	, CASE WHEN C.CCF_90_ROW < 0 THEN TO_CHAR(C.CCF_90_ROW * 100) WHEN C.CCF_90_ROW > 0 THEN CONCAT('+', C.CCF_90_ROW * 100) ELSE '' END AS CCF_90_ROW ");
		sql.append(" 	, CASE WHEN C.CCF_99_ROW < 0 THEN TO_CHAR(C.CCF_99_ROW * 100) WHEN C.CCF_99_ROW > 0 THEN CONCAT('+', C.CCF_99_ROW * 100) ELSE '' END AS CCF_99_ROW ");

		sql.append(" 	FROM BS_FUELMSG_T A ");
		sql.append(" 		 , KFOS.FFS_ALERT_T F ");
		sql.append(" 		 , CM_CITYPAIR_AC_T C ");
		sql.append(" WHERE  A.FIRST_LEG_FLT_DT = TO_DATE('"+params.getPFirstLegFltDt()+"','YYYYMMDD') ");
		sql.append(" 	AND A.FLT_NUM = '"+params.getPFltNum()+"' ");
		sql.append(" 	AND A.STNFR = '"+params.getPStnfr()+"' ");
		sql.append(" 	AND A.STNTO = '"+params.getPStnto()+"' ");
		sql.append(" 	AND A.MSG_SEQ = '"+params.getPMsgSeq()+"' ");
		sql.append(" 	AND A.FIRST_LEG_FLT_DT = F.FIRST_LEG_FLT_DT(+) ");
		sql.append(" 	AND A.FLT_NUM = F.FLT_NUM(+) ");
		sql.append(" 	AND A.STNFR = F.STNFR(+) ");
		sql.append(" 	AND A.STNTO = F.STNTO(+) ");
		sql.append(" 	AND C.DEP_PORT = F.STNFR ");
		sql.append(" 	AND C.ARV_PORT = F.STNTO ");
		sql.append(" 	AND C.SACTYP = F.SACTYP ");
		
		
		
		//System.out.println("[BASE:FfsA260Query:selRlsMsg] sql : "+sql.toString());
		return sql.toString();
	}
	public String selRlsMsg(FfsA260BG params) {//@2018-08
		StringBuffer sql = new StringBuffer();
		
		sql.append("	SELECT");
		sql.append("		A.MSG_SEQ");
		sql.append("	,	A.PLAN_NO");
		sql.append("	,	SUBSTR(A.REGNO ,	3 ,	4) REGNO");
		sql.append("	,	A.EST_DEP_T");
		sql.append("	,	A.EST_DEP_D");
		sql.append("	,	A.ADD_FUEL_Q");
		sql.append("	,	A.ADD_RSN_CD");
		sql.append("	,	A.RAMP_FUEL_Q");
		sql.append("	,	A.TAXI_FUEL_Q");
		sql.append("	,	A.TOF_Q");
		sql.append("	,	A.TIF_Q");
		sql.append("	,	A.PLD_Q");
		sql.append("	,	A.TOW_Q");
		sql.append("	,	A.DISP_NAME");
		sql.append("	,	A.CC_FUEL95_Q");
		sql.append("	,	A.CC_FUEL75_Q");
		sql.append("	,	A.CC_FUEL50_Q");
		sql.append("	,	A.ADD_INFO");
		sql.append("	,	A.SI_INFO");
		sql.append("	,	A.RCV_ADDR");
		sql.append("	,	A.ORGN_ADDR");
		sql.append("	,	F.SYSKEY AS DOC_NO");
		sql.append("	,	CASE WHEN C.CCF_50_ROW < 0 THEN TO_CHAR(C.CCF_50_ROW * 100) WHEN C.CCF_50_ROW > 0 THEN CONCAT('+' ,	C.CCF_50_ROW * 100) ELSE '' END AS CCF_50_ROW");
		sql.append("	,	CASE WHEN C.CCF_90_ROW < 0 THEN TO_CHAR(C.CCF_90_ROW * 100) WHEN C.CCF_90_ROW > 0 THEN CONCAT('+' ,	C.CCF_90_ROW * 100) ELSE '' END AS CCF_90_ROW");
		sql.append("	,	CASE WHEN C.CCF_99_ROW < 0 THEN TO_CHAR(C.CCF_99_ROW * 100) WHEN C.CCF_99_ROW > 0 THEN CONCAT('+' ,	C.CCF_99_ROW * 100) ELSE '' END AS CCF_99_ROW");
		sql.append("	,	W.PLN_EXTR_FUEL1");
		sql.append("	,	W.PLN_EXTR_RSN1");
		sql.append("	,	W.PLN_EXTR_FUEL2");
		sql.append("	,	W.PLN_EXTR_RSN2");
		sql.append("	,	W.PLN_RTOW");
		sql.append("	FROM");
		sql.append("		BS_FUELMSG_T A");
		sql.append("	,	KFOS.FFS_ALERT_T F");
		sql.append("	,	CM_CITYPAIR_AC_T C");
		sql.append("	,	FLT_FUEL_WT_T W");
		sql.append("	WHERE");
		sql.append("				A.FIRST_LEG_FLT_DT = TO_DATE('"+params.getPFirstLegFltDt()+"'	,	'YYYYMMDD')");
		sql.append("	AND	A.FLT_NUM = '"+params.getPFltNum()+"'");
		sql.append("	AND	A.STNFR = '"+params.getPStnfr()+"'");
		sql.append("	AND	A.STNTO = '"+params.getPStnto()+"'");
		sql.append("	AND	A.MSG_SEQ = '"+params.getPMsgSeq()+"'");
		sql.append("	AND	A.FIRST_LEG_FLT_DT = F.FIRST_LEG_FLT_DT(+)");
		sql.append("	AND	A.FLT_NUM = F.FLT_NUM(+)");
		sql.append("	AND	A.STNFR = F.STNFR(+)");
		sql.append("	AND	A.STNTO = F.STNTO(+)");
		sql.append("	AND	C.DEP_PORT = F.STNFR");
		sql.append("	AND	C.ARV_PORT = F.STNTO");
		sql.append("	AND	C.SACTYP = F.SACTYP");
		sql.append("	AND	A.FIRST_LEG_FLT_DT = W.FIRST_LEG_FLT_DT");
		sql.append("	AND	A.FLT_NUM = W.FLT_NUM");
		sql.append("	AND	A.STNFR = W.STNFR");
		sql.append("	AND	A.STNTO = W.STNTO");
		
		System.out.println("[BASE:FfsA260Query:selRlsMsg] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * VC RAMP FUEL  ȸ
	  * @return String Query  
	  * @author Copyright (c) 2009/01/02  
	  */
	public String selVcRampFuel(FfsA260BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT MSG_SEQ, RAMP_FUEL_Q ");
		sql.append(" FROM BS_FUELMSG_T ");
		sql.append(" WHERE  FIRST_LEG_FLT_DT = TO_DATE('"+params.getPFirstLegFltDt()+"','YYYYMMDD') ");
		sql.append(" 	AND FLT_NUM = '"+params.getPFltNum()+"' ");
		sql.append(" 	AND STNFR = '"+params.getPStnfr()+"' ");
		sql.append(" 	AND STNTO = '"+params.getPStnto()+"' ");
		sql.append(" 	AND MSG_SEQ = ");
		sql.append(" ( SELECT MAX(MSG_SEQ) ");
		sql.append(" FROM BS_FUELMSG_T ");
		sql.append(" WHERE  FIRST_LEG_FLT_DT = TO_DATE('"+params.getPFirstLegFltDt()+"','YYYYMMDD') ");
		sql.append(" 	AND FLT_NUM = '"+params.getPFltNum()+"' ");
		sql.append(" 	AND STNFR = '"+params.getPStnfr()+"' ");
		sql.append(" 	AND STNTO = '"+params.getPStnto()+"' ");
		sql.append(" 	AND MSG_SEQ < '"+params.getPMsgSeq()+"' ) ");

		//System.out.println("[BASE:FfsA260Query:selVcRampFuel] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  *   MSG Է
	  * @return String Query  
	  * @author Copyright (c) 2009/01/08  
	  */
	public String insNewRlsMsg(FfsA260BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" INSERT INTO BS_FUELMSG_T ( ");
		sql.append("   FIRST_LEG_FLT_DT, FLT_NUM, STNFR, STNTO, MSG_SEQ, ");
		sql.append("   PLAN_NO, REGNO, EST_DEP_T, EST_DEP_D, RAMP_FUEL_Q, ");
		sql.append("   TAXI_FUEL_Q, ADD_FUEL_Q, ADD_RSN_CD, TOF_Q, TIF_Q, ");
		sql.append("   PLD_Q, TOW_Q, DISP_NAME, CC_FUEL95_Q, CC_FUEL75_Q, CC_FUEL50_Q, "); //2010.07.21 ߰ : CC_FUEL50_Q
		sql.append("   ADD_INFO, SI_INFO, RCV_ADDR, TIMESTMP, USERID, ");
		sql.append("   ORGN_ADDR "); //2009.01.16 ߰ : ORGN_ADDR
		sql.append(" ) VALUES ( ");
		sql.append(" TO_DATE('"+params.getPFirstLegFltDt()+"','YYYYMMDD'), '"+params.getPFltNum()+"', '"+params.getPStnfr()+"', '"+params.getPStnto()+"', '"+params.getPMsgSeq()+"', ");
		sql.append(" '"+params.getPlanNo()+"', 'HL"+params.getRegno()+"', '"+params.getEstDepT()+"', '"+params.getEstDepD()+"', "+params.getRampFuelQ()+", ");
		sql.append(" "+params.getTaxiFuelQ()+", "+params.getAddFuelQ()+", '"+params.getAddRsnCd()+"', "+params.getTofQ()+", "+params.getTifQ()+", ");
		sql.append(" "+params.getPldQ()+", "+params.getTowQ()+", '"+params.getDispName()+"', "+params.getCcFuel95Q()+", "+params.getCcFuel75Q()+", "+params.getCcFuel50Q()+", ");
		sql.append(" '"+params.getAddInfo()+"', '"+params.getSiInfo()+"', '"+params.getRcvAddr()+"', SYSDATE, '"+params.getEmpNo()+"', ");
		sql.append(" '"+params.getOrgnAddr()+"' ) ");

		//System.out.println("[BASE:FfsA260Query:insNewRlsMsg] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * DAILY_SCH_T κ EST_DEP_DT_LOC ȸ
	  * @return String Query  
	  * @author Copyright (c) 2009/01/12  
	  */
	public String getEstDepDtLoc(FfsA260BG params) {
		StringBuffer sql = new StringBuffer();
		
		//2009.03.06  : DDMON -> DDMONYY, 2010.07.08 ߰ : EST_DEP_DT (LOC->UTC )
		// : 2011.05.13 by ihkim ( : sql.append(" SELECT TO_CHAR(EST_DEP_DT_LOC, 'DDMONYY') EST_DEP_DT_LOC, TO_CHAR(EST_DEP_DT, 'DDMONYY') EST_DEP_DT ");)
		sql.append(" SELECT TO_CHAR(EST_DEP_DT_LOC, 'DDMONYY','nls_date_language=american') EST_DEP_DT_LOC, TO_CHAR(EST_DEP_DT, 'DDMONYY','nls_date_language=american') EST_DEP_DT ");
		sql.append(" FROM DAILY_SCH_T ");
		sql.append(" WHERE FIRST_LEG_FLT_DT = TO_DATE('"+params.getPFirstLegFltDt()+"','YYYYMMDD') ");
		sql.append("  AND FLT_NUM = '"+params.getPFltNum()+"' ");
		sql.append("  AND STNFR = '"+params.getPStnfr()+"' ");
		sql.append("  AND STNTO = '"+params.getPStnto()+"' ");
		
		//System.out.println("[BASE:FfsA260Query:getEstDepDtLoc] sql : "+sql.toString());
		return sql.toString();
	}
	/** 
	  * DAILY_SCH_T κ SCH_DEP_DT_LOC ȸ
	  * @return String Query  
	  * @2014-02-17
	  */
	public String getSchDepDtLoc(FfsA260BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT TO_CHAR(SCH_DEP_DT_LOC, 'DDMONYY','nls_date_language=american') SCH_DEP_DT_LOC, TO_CHAR(SCH_DEP_DT, 'DDMONYY','nls_date_language=american') SCH_DEP_DT ");
		sql.append(" FROM DAILY_SCH_T ");
		sql.append(" WHERE FIRST_LEG_FLT_DT = TO_DATE('"+params.getPFirstLegFltDt()+"','YYYYMMDD') ");
		sql.append("  AND FLT_NUM = '"+params.getPFltNum()+"' ");
		sql.append("  AND STNFR = '"+params.getPStnfr()+"' ");
		sql.append("  AND STNTO = '"+params.getPStnto()+"' ");
		
		//System.out.println("[BASE:FfsA260Query:getSchDepDtLoc sql : "+sql.toString());
		return sql.toString();
	}
	
	
	/** 
	  *  ð DDHH24MI ȸ
	  * @return String Query  
	  * @author Copyright (c) 2009/01/12  
	  */
	public String getDDHH24MI() {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT TO_CHAR(SYSDATE-9/24, 'DDHH24MI') DDHH24MI FROM DUAL ");
		
		//System.out.println("[BASE:FfsA260Query:getDDHH24MI] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * UNI_SEQ ȸ
	  * @return String Query  
	  * @author Copyright (c) 2009/01/12  
	  */
	public String getUniSeq() {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT TO_CHAR(UNI_SEQ.NEXTVAL) UNI_SEQ FROM DUAL ");
		
		//System.out.println("[BASE:FfsA260Query:getUniSeq] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * INSERT MS_TELEX_MSG_T
	  * @return String Query  
	  * @author Copyright (c) 2009/01/12  
	  */
	public String insMsTelexMsgTORG(String msgCat, String uniSeq, String orginAddr, String msg, String processed) {
		StringBuffer sql = new StringBuffer();
	
		sql.append(" INSERT INTO MS_TELEX_MSG_T ");
		sql.append(" (MSG_CAT, MSG_TMPST, UNI_SEQ, MSG_MAX, MSG_POS, ");
		sql.append(" ORIGIN_ADDR, MESSAGE, PRIORITY, SYS_MQID, ");
		sql.append(" PROJECT_NO, PROCESSED, ERROR_REPLY) ");
		sql.append(" VALUES ");
		sql.append(" ('"+msgCat+"', SYSDATE, "+uniSeq+", 1, 1, ");
		sql.append(" '"+orginAddr+"', '"+StringUtil.DBInsStr(msg)+"', 1, TO_CHAR(SYSDATE,'YYYYMMDDHH24MISS')||TRIM(TO_CHAR('"+uniSeq+"','00000')), ");
		sql.append(" TO_CHAR(SYSDATE,'YYYYMMDDHH24MISS')||TRIM(TO_CHAR('"+uniSeq+"','00000')), '"+processed+"', ' ') ");
		
		//System.out.println("[BASE:FfsA260Query:insMsTelexMsgT] sql : "+sql.toString());
		return sql.toString();
	}
	//20150428 MHS
	//20150603 
	public String insMsTelexMsgT(String msgCat, String uniSeq, String orginAddr, String msg, String processed) {
		
		msg = msg != null ? msg.replace("\"", "") : msg;
		
		StringBuffer sql = new StringBuffer();
	
		//sql.append(" INSERT INTO KFOS.MS_TELEX_MHS_T_TEST ");
		sql.append(" INSERT INTO KFOS.MS_TELEX_MHS_T ");
		sql.append(" (MSG_CAT, MSG_TMPST, UNI_SEQ, MSG_MAX, MSG_POS, ");
		sql.append(" ORIGIN_ADDR, MESSAGE, PRIORITY, SYS_MQID, ");
		sql.append(" PROJECT_NO, PROCESSED, ERROR_REPLY) ");
		sql.append(" VALUES ");
		sql.append(" ('"+msgCat+"', SYSDATE, "+uniSeq+", 1, 1, ");
		sql.append(" '"+orginAddr+"', '"+StringUtil.DBInsStr(msg)+"', 1, TO_CHAR(SYSDATE,'YYYYMMDDHH24MISS')||TRIM(TO_CHAR('"+uniSeq+"','00000')), ");
		sql.append(" TO_CHAR(SYSDATE,'YYYYMMDDHH24MISS')||TRIM(TO_CHAR('"+uniSeq+"','00000')), '"+processed+"', ' ') ");
		
		//System.out.println("[BASE:FfsA260Query:insMsTelexMsgT] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * ֱ  DSP_CD ȸ
	  * @return String Query  
	  * @author Copyright (c) 2009/06/23  
	  */
	public String getLastDspCd(String regno) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT DSP_CD ");
		sql.append(" FROM PE_ACREG_INFO_T ");
		sql.append(" WHERE REGNO='"+regno+"' ");
		
		//System.out.println("[BASE:FfsA260Query:getLastDspCd] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * DSP_CD Ʈ ȸ
	  * @return String Query  
	  * @author Copyright (c) 2009/07/03  
	  */
	public String getDspCdList() {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT DISTINCT(SITA_ADR) SITA_ADR ");
		sql.append(" FROM PE_DSP_T ");
		sql.append(" ORDER BY SITA_ADR ");
		
		//System.out.println("[BASE:FfsA260Query:getDspCdList] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * FLT_FUEL_WT_T ִ ȸ
	  * @param params FfsA260BG
	  * @return String Query 
	  * ۼ ¥ : 2010-08-24
	  */
	public String selFltFuelWtT(FfsA260BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT PLN_EXTR_FUEL1, PLN_EXTR_RSN1, PLN_EXTR_FUEL2, PLN_EXTR_RSN2, PLN_TANK_FUEL ");
		sql.append(" FROM FLT_FUEL_WT_T ");
		sql.append(" WHERE FIRST_LEG_FLT_DT = TO_DATE('"+params.getPFirstLegFltDt()+"','YYYYMMDD') ");
		sql.append(" AND ARLN_CD = 'KE' ");
		sql.append(" AND FLT_NUM = '"+params.getPFltNum()+"' ");
		sql.append(" AND STNFR = '"+params.getPStnfr()+"' ");
		sql.append(" AND STNTO = '"+params.getPStnto()+"' ");
		
		//System.out.println("[BASE:FfsA260Query:selFltFuelWtT] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * FLT_FUEL_WT_T 
	  * @param params FfsA260BG
	  * @return String Query 
	  * ۼ ¥ : 2010-08-24
	  */
	public String updFltFuelWtT(FfsA260BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" UPDATE FLT_FUEL_WT_T ");
		sql.append(" SET ");
		sql.append(" 		PLN_PLD = '"+params.getPlnPld()+"', ");
		sql.append(" 		PLN_ZFW = '"+params.getPlnZfw()+"', ");
		sql.append(" 		PLN_TOW = '"+params.getPlnTow()+"', ");
		sql.append(" 		PLN_RAMP_FUEL = '"+params.getPlnRampFuel()+"', ");
		sql.append(" 		PLN_TKOF_FUEL = '"+params.getPlnTkofFuel()+"', ");
		sql.append(" 		PLN_TRIP_FUEL = '"+params.getPlnTripFuel()+"', ");
		sql.append(" 		PLN_FOD_FUEL = '"+params.getPlnFodFuel()+"', ");
		sql.append(" 		PLN_EXTR_FUEL1 = '"+params.getPlnExtrFuel1()+"', ");
		sql.append(" 		PLN_EXTR_RSN1 = '"+params.getPlnExtrRsn1()+"', ");
		sql.append(" 		PLN_EXTR_FUEL2 = '"+params.getPlnExtrFuel2()+"', ");
		sql.append(" 		PLN_EXTR_RSN2 = '"+params.getPlnExtrRsn2()+"', ");
		sql.append(" 		PLN_TANK_FUEL = '"+params.getPlnTankFuel()+"', ");
		sql.append(" 		TIMESTMP = SYSDATE, ");
		sql.append(" 		USERID = '"+params.getEmpNo()+"' ");
		sql.append(" WHERE FIRST_LEG_FLT_DT = TO_DATE('"+params.getPFirstLegFltDt()+"','YYYYMMDD') ");
		sql.append(" AND ARLN_CD = 'KE' ");
		sql.append(" AND FLT_NUM = '"+params.getPFltNum()+"' ");
		sql.append(" AND STNFR = '"+params.getPStnfr()+"' ");
		sql.append(" AND STNTO = '"+params.getPStnto()+"' ");
		
		//System.out.println("[BASE:FfsA260Query:updFltFuelWtT] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * FLT_FUEL_WT_T Է
	  * @param params FfsA260BG
	  * @return String Query 
	  * ۼ ¥ : 2010-08-24
	  */
	public String insFltFuelWtT(FfsA260BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" INSERT INTO FLT_FUEL_WT_T ");
		sql.append(" (FIRST_LEG_FLT_DT, ARLN_CD, FLT_NUM, STNFR, STNTO, ");
		sql.append(" PLN_PLD, PLN_ZFW, PLN_TOW, PLN_RAMP_FUEL, PLN_TKOF_FUEL, PLN_TRIP_FUEL, PLN_FOD_FUEL, ");
		sql.append(" PLN_EXTR_FUEL1, PLN_EXTR_RSN1, PLN_EXTR_FUEL2, PLN_EXTR_RSN2, PLN_TANK_FUEL, TIMESTMP, USERID) ");
		sql.append(" VALUES ");
		sql.append(" ('"+params.getPFirstLegFltDt()+"', 'KE', '"+params.getPFltNum()+"', '"+params.getPStnfr()+"', '"+params.getPStnto()+"',  ");
		sql.append(" '"+params.getPlnPld()+"', '"+params.getPlnZfw()+"', '"+params.getPlnTow()+"', '"+params.getPlnRampFuel()+"', '"+params.getPlnTkofFuel()+"', '"+params.getPlnTripFuel()+"', '"+params.getPlnFodFuel()+"', ");
		sql.append(" '"+params.getPlnExtrFuel1()+"', '"+params.getPlnExtrRsn1()+"', '"+params.getPlnExtrFuel2()+"', '"+params.getPlnExtrRsn2()+"', '"+params.getPlnTankFuel()+"', SYSDATE, '"+params.getEmpNo()+"') ");
		
		//System.out.println("[BASE:FfsA260Query:insFltFuelWtT] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * ó ȸ ߰
	  * 20140903  
	  * sunpark 
	  */
	public String selRlsMsgAddress(FfsA260BG params, String grpStr) {
		StringBuffer sql = new StringBuffer();
		
		//20141030 ߰
		String arlnCdStr = " AND ARLN_CD = 'KE' ";
		String pstnfrStr = params.getPStnfr();
		if("4".equals(params.getPFltNum().substring(0, 1))){
			arlnCdStr = " AND ARLN_CD = 'LJ' ";
			//20150107  ׺ ϴ° 
			//pstnfrStr = "JNA";
		}
		//arlnCdStr += "4".equals(params.getPFltNum().substring(0, 1)) ? "'LJ'" : "'KE'";
		
		sql.append(" SELECT NTK, ADDR_LIST, ENC_ADDR_LIST ");
		sql.append(" FROM KFOS.FLIGHT_ADDR_T ");
		sql.append(" WHERE IATA_PORT = '" + pstnfrStr + "' ");
		sql.append(" AND NTK = 'Email' ");
		sql.append(" AND (OPTN LIKE '%R%' OR OPTN LIKE '%P%') ");
		sql.append(" AND (GRP_NAME = 'FD'||'" + pstnfrStr + "'||'ALL' OR GRP_NAME = 'FD'||'" + pstnfrStr + "'||'" + grpStr + "') ");
		//20141030 ߰
		sql.append(arlnCdStr);
		sql.append(" AND ROWNUM = 1 ");
		sql.append(" UNION ");
		sql.append(" SELECT NTK, ADDR_LIST, ENC_ADDR_LIST ");
		sql.append(" FROM KFOS.FLIGHT_ADDR_T ");
		sql.append(" WHERE IATA_PORT = '" + pstnfrStr + "' ");
		sql.append(" AND NTK = 'SITA' ");
		sql.append(" AND OPTN LIKE '%R%' ");
		sql.append(" AND (GRP_NAME = 'FD'||'" + pstnfrStr + "'||'ALL' OR GRP_NAME = 'FD'||'" + pstnfrStr + "'||'" + grpStr + "') ");
		//20141030 ߰
		sql.append(arlnCdStr);
		sql.append(" AND ROWNUM = 1 ");
		sql.append(" UNION ");
		sql.append(" SELECT NTK, ADDR_LIST, ENC_ADDR_LIST ");
		sql.append(" FROM KFOS.FLIGHT_ADDR_T ");
		sql.append(" WHERE IATA_PORT = '" + pstnfrStr + "' ");
		sql.append(" AND NTK = 'AFTN' ");
		sql.append(" AND OPTN LIKE '%R%' ");
		sql.append(" AND (GRP_NAME = 'FD'||'" + pstnfrStr + "'||'ALL' OR GRP_NAME = 'FD'||'" + pstnfrStr + "'||'" + grpStr + "') ");
		//20141030 ߰
		sql.append(arlnCdStr);
		sql.append(" AND ROWNUM = 1 ");
		sql.append(" UNION ");
		sql.append(" SELECT NTK, ADDR_LIST, ENC_ADDR_LIST ");
		sql.append(" FROM KFOS.FLIGHT_ADDR_T ");
		sql.append(" WHERE IATA_PORT = '" + pstnfrStr + "' ");
		sql.append(" AND NTK = 'FAX' ");
		sql.append(" AND OPTN LIKE '%R%' ");
		sql.append(" AND (GRP_NAME = 'FD'||'" + pstnfrStr + "'||'ALL' OR GRP_NAME = 'FD'||'" + pstnfrStr + "'||'" + grpStr + "') ");
		//20141030 ߰
		sql.append(arlnCdStr);
		sql.append(" AND ROWNUM = 1  ");

		System.out.println("[BASE:FfsA260Query:selRlsMsgAddress] sql : "+sql.toString());
		return sql.toString();
	}
	/** 
	  * ACTYP ȸ
	  * 20140903  
	  * sunpark 
	  */
	public String selActyp(FfsA260BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT ACTYP FROM FLIGHT_PLAN_T ");
		sql.append(" WHERE FIRST_LEG_FLT_DT = TO_DATE('" + params.getPFirstLegFltDt() + "','YYYYMMDD') ");
		sql.append(" AND FLT_NUM            = '" + params.getPFltNum() + "' ");
		sql.append(" AND STNFR              = '" + params.getPStnfr() + "' ");
		sql.append(" AND STNTO              = '" + params.getPStnto() + "' ");

		//System.out.println("[BASE:FfsA260Query:selActyp] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * FLIGHT_DOC_T update
	  * 20140903  
	  * sunpark 
	  */
	public String updFlightDocT(FfsA260BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" UPDATE KFOS.FLIGHT_DOC_T ");
		sql.append(" SET ACTIVE = 'N' ");
		sql.append(" WHERE SYSKEY = '" + params.getDocNo() + "' ");
		sql.append(" AND CAT = 'FUEL' ");
		
		//System.out.println("[BASE:FfsA260Query:updFlightDocT] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * FLIGHT_DOC_T update
	  * 20140903  
	  * sunpark 
	  */
	public String insFlightDocT(FfsA260BG params, String filePath, String fileName, String content) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" INSERT INTO KFOS.FLIGHT_DOC_T ");
		sql.append("   ( SYSKEY ");
		sql.append("     , CAT  ");
		sql.append("     , FILE_PATH ");
		sql.append("     , FILE_NAME ");
		sql.append("     , CONT ");
		sql.append("     , ACTIVE ");
		sql.append("     , USERID ");
		sql.append("     , TIMESTMP) ");
		sql.append(" VALUES (  '" + params.getDocNo() + "' ");
		sql.append("         , 'FUEL' ");
		sql.append("         , '" + filePath + "' ");
		sql.append("         , '" + fileName + "' ");
		sql.append("         , '" + content + "' ");
		sql.append("         , 'Y' ");
		sql.append("         , '" + params.getEmpNo() + "' ");
		sql.append("         , SYSDATE) ");
		
		
		//System.out.println("[BASE:FfsA260Query:insFlightDocT] sql : "+sql.toString());
		return sql.toString();
	}
	
	/**
	  * FLIGHT_DOC_LOG_T insert
	  * 20140903
	  * sunpark
	  */
	public String insFlightDocLogT(FfsA260BG params, String sendGbn, String optn, String address) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" INSERT INTO KFOS.FLIGHT_DOC_LOG_T ");
		sql.append("   (FIRST_LEG_FLT_DT ");
		sql.append("   , FLT_NUM ");
		sql.append("   , STNFR ");
		sql.append("   , STNTO ");
		sql.append("   , PLANID ");
		sql.append("   , SYSKEY ");
		sql.append("   , SENT_NTWK ");
		sql.append("   , SENT_CAT ");
		sql.append("   , SENT_ADDR ");
		sql.append("   , SND_TYPE ");
		sql.append("   , USERID ");
		sql.append("   , TIMESTMP) ");
		sql.append(" VALUES ");
		sql.append("   (TO_DATE('" + params.getPFirstLegFltDt() + "', 'yyyyMMdd') ");
		sql.append("   , '" + params.getPFltNum() + "' ");
		sql.append("   , '" + params.getPStnfr() + "' ");
		sql.append("   , '" + params.getPStnto() + "' ");
		sql.append("   , '" + params.getPlanNo() + "' ");
		sql.append("   , '" + params.getDocNo() + "' ");
		sql.append("   , '" + sendGbn + "' ");	//߼۹(Email, SITA, AFTN, FAX)
		sql.append("   , '" + optn + "' ");		// 2 CAT 
		sql.append("   , '" + address + "' ");	//߼ ּ Ʈ(6 Sending Info Query   ADDR_LIST)
		sql.append("   , 'Send' ");
		sql.append("   , '" + params.getEmpNo() + "' ");
		sql.append("   , SYSDATE) ");
		
		//System.out.println("[BASE:FfsQ240Query:insFlightDocLogT] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * FLIGHT_PLAN_T ETOPS_Y, REFILE_Y ȸ
	  * 20140903
	  * sunpark
	  */
	public String selEtopsRefileY(FfsA260BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT ETOPS_Y, REFILE_Y ");
		sql.append(" FROM KFOS.FLIGHT_PLAN_T ");
		sql.append(" WHERE FIRST_LEG_FLT_DT = TO_DATE('"+params.getPFirstLegFltDt()+"','YYYYMMDD') ");
		sql.append(" AND FLT_NUM            = '"+params.getPFltNum()+"' ");
		sql.append(" AND STNFR              = '"+params.getPStnfr()+"' ");
		sql.append(" AND STNTO              = '"+params.getPStnto()+"' ");
		sql.append(" AND ACTIVE             = 'Y' ");
		sql.append(" AND DOC_Y              = 'Y' ");

		//System.out.println("[BASE:FfsA260Query:selEtopsRefileY] sql : "+sql.toString());
		return sql.toString();
	}
	
	/**
	  * FLIGHT_ALERT_T update
	  * 20150608
	  * sunpark
	  */
	public String updFlightAlertT(FfsA260BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" UPDATE KFOS.FLIGHT_ALERT_T ");
		sql.append(" SET RLS_Y = 'Q' ");
		sql.append(" WHERE FIRST_LEG_FLT_DT = TO_DATE('" + params.getPFirstLegFltDt() + "','YYYYMMDD') ");
		sql.append(" AND FLT_NUM = '" + params.getPFltNum() + "' ");
		sql.append(" AND STNFR = '" + params.getPStnfr() + "' ");
		sql.append(" AND STNTO = '" + params.getPStnto() + "' ");
		
		//System.out.println("[BASE:FfsA260Query:updFlightAlertT] sql : "+sql.toString());
		return sql.toString();
	}
	
	/**
	  * FFS_ALERT_T update
	  * 20160706
	  * sunpark
	  */
	public String updFfsAlertT(FfsA260BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" UPDATE KFOS.FFS_ALERT_T ");
		sql.append(" SET RELEASE_FUEL_YN = 'Q' ");
		sql.append(" WHERE FIRST_LEG_FLT_DT = TO_DATE('" + params.getPFirstLegFltDt() + "','YYYYMMDD') ");
		sql.append(" AND FLT_NUM = '" + params.getPFltNum() + "' ");
		sql.append(" AND STNFR = '" + params.getPStnfr() + "' ");
		sql.append(" AND STNTO = '" + params.getPStnto() + "' ");
		
		//System.out.println("[BASE:FfsA260Query:updFfsAlertT] sql : "+sql.toString());
		return sql.toString();
	}
}
	