package kal.base.ffs.query;

import java.util.HashMap;

import kal.base.ffs.dbbean.FfsQ010BG;
import kal.base.ffs.dbbean.FfsQ110BG;
import kal.base.jdf.com.Logger;

 /**
  * Flight Following Chart - Not Released SQL 
  * @author Copyright (c) 2006/12/21  
  */   
public class FfsQ010Query {
	private static FfsQ010Query instance = new FfsQ010Query();
	
	public static FfsQ010Query getInstance() {
		return instance;
	}
	
	/** 
	  * Flight Following Chart - Not Released ȸ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2006/12/21  
	  */
	public String selNotReleased() {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT ");
		//sql.append(" 	   C.REGION_CD, ");
		sql.append(" 	   DECODE(DECODE(SUBSTR(D.FLT_NUM, 1, 1),'4','JNA','KAL'),'JNA','JNA',C.REGION_CD) REGION_CD, ");//@2013-11-07
		sql.append(" 	   NVL(R.EXTR_FUEL, 0) REGNO_EXTR_FUEL, R.EXTR_RSN, "); //2009.10.19 ߰ : UKFOS EXTRA FUEL
		sql.append(" 	   D.FLT_NUM, D.REGNO, D.SACTYP, D.STNFR, D.STNTO, ");
		sql.append(" 	  decode(SUBSTR(D.FLT_NUM, 1, 1),'4','JNA','KAL') GBN,  ");//@2013-11-07
		sql.append(" 	   TO_CHAR(D.EST_DEP_DT,'YYMMDDHH24MI') EST_DEP_DT, ");
		sql.append(" 	   TO_CHAR(D.EST_ARV_DT,'YYMMDDHH24MI') EST_ARV_DT, ");
		sql.append(" 	   A.ALT_PORT, ");
		sql.append(" 	   B.CC_FUEL_50, B.CC_FUEL_75, B.CC_FUEL_95, B.CCF_CALC_Y, TO_CHAR(B.TIMESTAMP,'YYYYMMDD') TIMESTAMP, "); //2008.08.11 ߰ : B.CCF_CALC_Y, B.TIMESTAMP(CM_CITYPAIR_AC_T)
		sql.append(" 	   TRUNC(MOD((D.SCH_ARV_DT - D.SCH_DEP_DT), 1) * 24) BLOCK_TIME, "); //2009.12.08 ߰ : *  FOM ִ  (ð)
		sql.append(" 	   B.CRZ_SPEED, B.ETOP_PORT, ");
		//sql.append(" 	   C.REFILE_PT, C.REFILE_PORT, C.REFILE_ALT_PORT, C.TANKERING_Y, ");
		sql.append(" 	   B.REFILE_PT, B.REFILE_PORT, B.REFILE_ALT_PORT, C.TANKERING_Y, ");//@2014-05-27
		sql.append(" 	   C.ROUTE_NO, "); //2007.06.19 ߰ : Route ȣ
		sql.append(" 	   C.NAI_Y, "); //2008.10.28 ߰ : N
		sql.append(" 	   ROUND(TO_NUMBER((D.SCH_ARV_DT - D.SCH_DEP_DT) * 24 * 60), 0) DIFF_MIN, "); //2008.12.01 ߰ : N  ߰
		//sql.append(" 	   TO_NUMBER((D.SCH_ARV_DT - D.SCH_DEP_DT) * 24 * 60) DIFF_MIN, ");
		sql.append(" 	   P.ACC_ADLT_PAX_Q, P.ACC_CHLD_PAX_Q, P.ACC_INFT_PAX_Q, "); //2008.08.18 ߰
		sql.append(" 	   P.ACC_PAX_PLD_WT, P.ACC_CGO_PLD_WT, P.ACC_OTH_PLD_WT, "); //2008.08.18 ߰
		sql.append(" 	   D.SVC, "); //2008.09.26 ߰ : J,G,C  ,  ȭ
		sql.append(" 	   P.ACC_CGO_PLD_ZERO_Y, "); //2008.10.08 ߰
		sql.append(" 	   TO_CHAR(P.ACC_PAX_DTG - 9/24,'DD/HH24MI') ACC_PAX_DTG,  TO_CHAR(P.ACC_CGO_DTG - 9/24,'DD/HH24MI') ACC_CGO_DTG, "); //2008.10.27 ߰ : PAX/CGO Է½ð ǥ
		//sql.append(" 	   P.ACC_PACK1, P.ACC_PACK2, P.ACC_PACK3, "); //2009.10.20 ߰ : PLD PACK  ߰ => 2012.05.09 ߰  ּ
		//sql.append(" 	   P.ACC_MD_PACK_HIGH, "); //2010.10.01 ߰ : PACK  ACC_MD_PACK_HIGH ߰ => 2012.05.09 ߰  ּ
		
		sql.append(" 	   P.MD_AC_CONFIG, P.LD_AC_CONFIG_FWD, P.LD_AC_CONFIG_AFT, P.MD_LD_RECIR_FAN, P.ANI_PERI_FUEL_ADD, "); //2012.05.09 ߰ : FODIS Payload(PLD)   µ ȭ ž  Է¹ 濡  ʵ ߰ ǥ  
		
		//------------> ʹ  
		//sql.append(" 	   F.FLT_NUM_COLOR, F.EXTRA_FUEL, F.CRZ_MODE, "); 2007.01.29  : .
		sql.append(" 	   F.REGNO REGNO_COLOR, F.WX_STNFR, F.WX_STNTO, F.ETD, F.ETA, ");
		sql.append(" 	   F.WX_ALT_PORT, F.WX_ETOP_PORT, F.WX_REFILE_PORT, F.WX_REFILE_ALT_PORT, ");
		//sql.append(" 	   F.NOTAM_STNFR, F.NOTAM_STNTO, F.NOTAM_ALT_PORT, F.NOTAM_ETOP_PORT, ");
		//sql.append(" 	   F.NOTAM_REFILE_PORT, F.NOTAM_REFILE_ALT_PORT, ");
		sql.append(" 	   F.NOTAM, "); //2007.06.19 : NOTAM  ʵ ߰
		sql.append(" 	   F.MEL, "); //2007.06.20 ߰ : M
		sql.append("       F.MAN_WX_STNFR, F.MAN_WX_STNTO, F.MAN_WX_ALT_PORT, ");//2011.12.06 ߰ : Alert APO߰  ޽ FLIGHT_ALERT_T ߰
		sql.append("   F.ALT_HIGHTIME, ");//@2014-02-21
		sql.append(" 	   T.MEL ACTYP_MEL, "); //2007.06.21 ߰ : 10
		sql.append(" 	   B.RESTRICT_E, "); //2007.06.20 ߰ : R
		sql.append(" 	   F.PMSN, TO_CHAR(D.FIRST_LEG_FLT_DT, 'YYYYMMDD') FIRST_LEG_FLT_DT, TO_CHAR(D.SCH_DEP_DT, 'DDMON') SCH_DEP_DT, "); //2007.06.20 ߰ :P
		sql.append(" 	   F.ALL_COLUMNS, NVL(F.ALT_MTOW, 0) ALT_MTOW ");//2011.12.26 : NVL(F.ALT_MTOW, 0) ALT_MTOW ߰
		//sql.append(" 	   F.ALL_COLUMNS, NVL(3000, 0) ALT_MTOW ");//2011.12.26 : NVL(F.ALT_MTOW, 0) ALT_MTOW ߰
		//2007.06.21 ߰ : CM_ACTYP_T, 2008.08.18 ߰ : PDP_FLT_PAYLOAD_T, 2009.10.19 ߰ : CM_REGNO_T
		/*-------------------------------	2014-05-12 start		*/
		sql.append(" 	,   CASE "); 
		sql.append(" 	       WHEN B.ERA_PORT2 IS NULL THEN  B.ERA_PORT1 ");
		sql.append(" 	       WHEN B.ERA_PORT3 IS NULL THEN  B.ERA_PORT1 || '/' || B.ERA_PORT2 ");
		sql.append(" 	       WHEN B.ERA_PORT4 IS NULL THEN  B.ERA_PORT1 || '/' || B.ERA_PORT2 || '/' || B.ERA_PORT3 "); 
		sql.append(" 	       WHEN B.ERA_PORT5 IS NULL THEN  B.ERA_PORT1 || '/' || B.ERA_PORT2 || '/' || B.ERA_PORT3 || '/' || B.ERA_PORT4 ");
		sql.append(" 	       ELSE B.ERA_PORT1 || '/' || B.ERA_PORT2 || '/' || B.ERA_PORT3 || '/' || B.ERA_PORT4 || '/' || B.ERA_PORT5 ");                                                                   
		sql.append(" 	   END AS ERA_PORT ");
		//20140903 flight document  ߰ : doc_no߰
		sql.append(" 	   , F.DOC_NO ");
		//20150703 ߰
		sql.append(" 	   , D.ACVER ");
		/*-------------------------------	2014-05-30 end		*/	
		sql.append(" FROM ");
		sql.append(" 	   CM_PORT_AC_T A, CM_CITYPAIR_AC_T B, CM_CITYPAIR_DEF_T C, DAILY_SCH_T D, FLIGHT_ALERT_T F, CM_ACTYP_T T, PDP_FLT_PAYLOAD_T P, CM_REGNO_T R ");
		sql.append(" WHERE ");
		sql.append(" 	  D.EST_DEP_DT >= SYSDATE - 9/24 AND ");
		sql.append(" 	  D.EST_DEP_DT <= SYSDATE + 5/24 AND "); // 2007.03.09  - 1/24 -> + 5/24
		sql.append(" 	  D.DEP_STS <> 'INI' AND "); // 2007.03.06 ߰
		sql.append(" 	  D.ACTNID <> 'CNL' AND "); // 2007.03.06 ߰
		//sql.append(" 	  D.ADMRAD <> 'N' AND "); 2010.04.22 ּ ó
		//20140903 flight document  ߰ : ּó
		//sql.append(" 	  D.FLT_PLANNED = 'N' AND "); // 2007.01.02 ּ ó -> 2007.01.16 ٽ ߰
		sql.append(" 	  D.STNFR = C.DEP_PORT AND ");
		sql.append(" 	  D.STNTO = C.ARV_PORT AND ");
		sql.append(" 	  D.FIRST_LEG_FLT_DT = F.FIRST_LEG_FLT_DT AND ");
		sql.append(" 	  D.FLT_NUM = F.FLT_NUM AND ");
		sql.append(" 	  D.STNFR = F.STNFR AND ");
		sql.append(" 	  D.STNTO = F.STNTO AND ");
		//20140903 ߰
		sql.append(" 	  F.PRV_DOC_NO IS NULL AND ");
		
		sql.append(" 	  D.STNTO = A.IATA_PORT AND ");
		sql.append(" 	  D.SACTYP = A.SACTYP AND ");
		sql.append(" 	  D.STNFR = B.DEP_PORT AND ");
		sql.append(" 	  D.STNTO = B.ARV_PORT AND ");
		sql.append(" 	  D.SACTYP = B.SACTYP AND ");
		sql.append(" 	  D.KACTYP = T.KACTYP AND "); //2007.06.21 ߰
		sql.append(" 	  D.FIRST_LEG_FLT_DT = P.FIRST_LEG_FLT_DT(+) AND "); //2008.08.18 ߰
		sql.append(" 	  D.FLT_NUM = P.FLT_NUM(+) AND "); //2008.08.18 ߰
		sql.append(" 	  D.STNFR = P.STNFR(+) AND "); //2008.08.18 ߰
		sql.append(" 	  D.STNTO = P.STNTO(+) "); //2008.08.18 ߰
		sql.append(" 	  AND D.FLT_NUM NOT LIKE '1%' "); //2009.04.24 ߰ :  ׽Ʈ  
		//sql.append("    AND SUBSTR(D.FLT_NUM, 1, 1) <> '4' "); //2009.08.13 ߰ :  FLT   @2013-11-07 
		sql.append("    AND C.REGION_CD !='DOM' ");//@2013-11-07
		
		
		sql.append("    AND D.REGNO = R.REGNO(+) "); //2009.10.19 ߰ : CM_REGNO_T
		
		//sql.append(" ORDER BY D.EST_DEP_DT DESC "); @2013-11-07
		sql.append(" ORDER BY GBN ASC, D.EST_DEP_DT DESC "); //@2013-11-07		

		
		//Logger.debug.println("[BASE:FfsQ010Query:selNotReleased] sql : "+sql.toString());
		//System.out.println("[BASE:FfsQ010Query:selNotReleased] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * Not Released  Alert Ruleȸ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2007/01/24  
	  */
	public String alertRuleNR() {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT ");
		sql.append(" 	COLOR, TAG, REMARKS ");
		sql.append(" FROM ");
		sql.append(" 	ALERT_RULE_T ");
		sql.append(" WHERE ");
		sql.append(" 	PROGRESS IN ('NR','AA','BB') ");

		Logger.debug.println("[BASE:FfsQ010Query:alertRuleNR] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * CM_CITYPAIR_AC_T TIMESTAMP MAX ȸ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2008/08/11  
	  */
	public String maxTimestamp() {
		StringBuffer sql = new StringBuffer();
		
		//sql.append(" SELECT MAX(TO_CHAR(TIMESTAMP,'YYYYMMDD')) MAX_TM ");
		//sql.append(" FROM CM_CITYPAIR_AC_T ");
		//2008.10.27 
		sql.append(" SELECT TO_CHAR(SYSDATE - 15, 'YYYYMMDD') MAX_TM ");
		sql.append(" FROM DUAL ");

		Logger.debug.println("[BASE:FfsQ010Query:maxTimestamp] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * FC_MISC_T  CCF ȸ SQLԼ.
	  * @return String Query  
	  * ۼ ¥ : 2010/07/27
	  */
	public String selFcMiscT(String miscC2) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT MISC_C2, MISC_Q ");
		sql.append(" FROM  FC_MISC_T@COPERA ");//@2014-03-03 sql.append(" FROM FC_MISC_T@FUEL ");
		sql.append(" WHERE MISC_C1='"+miscC2+"' ");
		
		//System.out.println("[BASE:FfsQ010Query:selFcMiscT] sql : "+sql.toString());
		return sql.toString();
	}
	
	/**
	 * 20160301 ߰
	 */
	public String selFlightPlanCheckLogT(FfsQ010BG entity) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT ");
		sql.append("   TO_CHAR(TIMESTMP,'YYYY-MM-DD HH24:MI:SS') TIMESTMP, USERID, REMARKS, UPD_SEQ ");
		sql.append(" FROM KFOS.FFS_COMMENT_LOG_T ");
		sql.append(" WHERE FIRST_LEG_FLT_DT = TO_DATE('" + entity.getFirstLegFltDt() + "','YYYYMMDD') ");
		sql.append(" AND FLT_NUM = '" + entity.getFltNum() + "' ");
		sql.append(" AND STNFR = '" + entity.getStnfr() + "' ");
		sql.append(" AND STNTO = '" + entity.getStnto() + "' ");
		sql.append(" AND VIS_Y <> 'N' ");		
		
		sql.append(" ORDER BY TIMESTMP ASC ");
		
		//System.out.println("[BASE:FfsQ010Query:selFlightPlanCheckLogT] sql : "+sql.toString());
		return sql.toString();
	}
	
	/**
	 * 2016.12.12 ߰
	 */
	public String selOpsSowValue(FfsQ010BG entity) {
		StringBuffer sql = new StringBuffer();
		
		//sql.append(" \n");
		sql.append(" SELECT  DECODE(NVL(EXCEPTION_SOW,'N'), 'JPN', SOW_JPN, 'SEA', SOW_SEA, 'INTL', SOW_INTL, DECODE(OPS_CD, 'JPN', SOW_JPN, 'SEA', SOW_SEA, 'INTL', SOW_INTL)) AS OPS_SOW ");
		sql.append(" FROM (SELECT                                                                           ");
		sql.append("         SOW_INTL, SOW_SEA, SOW_JPN,                                                    ");
		sql.append("         (SELECT DECODE(REGION_CD,'JPN','JPN','CHN','SEA','SEA','SEA','OCN','INTL','AME','INTL','EUR','INTL')  ");
		sql.append("            FROM CM_CITYPAIR_DEF_T                                                      ");
		sql.append("           WHERE DEP_PORT = '" + entity.getStnfr() + "'                                 ");
		sql.append("             AND ARV_PORT = '" + entity.getStnto() + "'                                 ");
		sql.append("         ) AS OPS_CD,                                                                   ");
		sql.append("         (SELECT EXCEPTION_SOW                                                          ");
		sql.append("            FROM CM_CITYPAIR_AC_T                                                       ");
		sql.append("           WHERE DEP_PORT = '" + entity.getStnfr() + "'                                 ");
		sql.append("             AND ARV_PORT = '" + entity.getStnto() + "'                                 ");
		sql.append("             AND SACTYP = '" + entity.getSactyp() + "'                                  ");
		sql.append("         ) AS EXCEPTION_SOW                                                             ");
		sql.append("       FROM KFOS.OC_AIRCRAFT_T                                                               ");
		sql.append("       WHERE REGNO = '" + entity.getRegno() + "'                                        ");
		sql.append("       )                                                                                ");
		
		//System.out.println("[BASE:FfsQ010Query:selOpsSowValue] sql : "+sql.toString());
		return sql.toString();
	}
	
	/**
	 * 2017.05.11 ߰
	 */
	public String selFlightPlanCheckLogTcout(HashMap<String,String> params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT ");
		sql.append("   TO_CHAR(COUNT(*)) AS ROW_CNT ");
		sql.append(" FROM KFOS.FFS_COMMENT_LOG_T ");
		sql.append("	WHERE FIRST_LEG_FLT_DT = TO_DATE('" + (String)params.get("FIRST_LEG_FLT_DT") + "','YYYYMMDD') ");
		sql.append("	AND	FLT_NUM = '" + (String)params.get("FLT_NUM") + "' ");
		sql.append("	AND	STNFR = '" + (String)params.get("STNFR") + "' ");
		sql.append("	AND	STNTO = '" + (String)params.get("STNTO") + "' ");
		
		//System.out.println("[BASE:FfsQ010Query:selFlightPlanCheckLogTcout] sql : "+sql.toString());
		return sql.toString();
	}
	
	
	/**
	 * 2017.05.11 ߰
	 */
	public String selFlightPlanCheckLogTcout_Y(HashMap<String,String> params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT ");
		sql.append("   TO_CHAR(COUNT(*)) AS ROW_CNT ");
		sql.append(" FROM KFOS.FFS_COMMENT_LOG_T ");
		sql.append("	WHERE FIRST_LEG_FLT_DT = TO_DATE('" + (String)params.get("FIRST_LEG_FLT_DT") + "','YYYYMMDD') ");
		sql.append("	AND	FLT_NUM = '" + (String)params.get("FLT_NUM") + "' ");
		sql.append("	AND	STNFR = '" + (String)params.get("STNFR") + "' ");
		sql.append("	AND	STNTO = '" + (String)params.get("STNTO") + "' ");
		sql.append("	AND	VIS_Y <> 'N' ");
		
		//System.out.println("[BASE:FfsQ010Query:selFlightPlanCheckLogTcout] sql : "+sql.toString());
		return sql.toString();
	}
	
	public String insFlightPlanCheckLogT(HashMap<String,String> params) {
		StringBuffer sql = new StringBuffer();

		sql.append(" INSERT INTO KFOS.FFS_COMMENT_LOG_T(FIRST_LEG_FLT_DT, FLT_NUM, STNFR, STNTO, USERID, TIMESTMP, REMARKS, VIS_Y, UPD_SEQ) ");
		sql.append(" VALUES ( ");
		//20160610 
		//sql.append(" 	'" + (String)params.get("FIRST_LEG_FLT_DT") + "' ");
		sql.append(" 	TO_DATE('" + (String)params.get("FIRST_LEG_FLT_DT") + "','YYYYMMDD') ");
		sql.append(" 	, '" + (String)params.get("FLT_NUM") + "' ");
		sql.append(" 	, '" + (String)params.get("STNFR") + "' ");
		sql.append(" 	, '" + (String)params.get("STNTO") + "' ");
		sql.append(" 	, '" + (String)params.get("USERID") + "' ");
		sql.append(" 	, SYSDATE ");
		sql.append(" 	, '" + (String)params.get("REMARKS") + "' ");
		sql.append(" 	, 'Y' ");
		sql.append(" 	, '" + (String)params.get("UPD_SEQ") + "' ");
		sql.append(" ) ");
		
		//System.out.println("[BASE:FfsQ010Query:insFlightPlanCheckLogT] sql : "+sql.toString());
		return sql.toString();
	}
	
	public String updFlightPlanCheckLogT(HashMap<String,String> params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append("	UPDATE KFOS.FFS_COMMENT_LOG_T");
		sql.append("	SET REMARKS = '" + (String)params.get("REMARKS") + "' ");
		sql.append("	   ,USERID = '" + (String)params.get("USERID") + "' ");
		sql.append("	   ,TIMESTMP = SYSDATE ");
		sql.append("	WHERE FIRST_LEG_FLT_DT = TO_DATE('" + (String)params.get("FIRST_LEG_FLT_DT") + "','YYYYMMDD') ");
		sql.append("	AND	FLT_NUM = '" + (String)params.get("FLT_NUM") + "' ");
		sql.append("	AND	STNFR = '" + (String)params.get("STNFR") + "' ");
		sql.append("	AND	STNTO = '" + (String)params.get("STNTO") + "' ");
		sql.append("	AND	UPD_SEQ = '" + (String)params.get("UPD_SEQ") + "' ");
		sql.append("	AND	VIS_Y <> 'N' ");
		
		//System.out.println("[BASE:FfsQ010Query:updFlightPlanCheckLogT] sql : "+sql.toString());
		return sql.toString();
	}
	
	public String delFlightPlanCheckLogT(HashMap<String, String> params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append("	UPDATE KFOS.FFS_COMMENT_LOG_T");
		sql.append("	SET USERID = '" + (String)params.get("USERID") + "' ");
		sql.append("	   ,TIMESTMP = SYSDATE ");
		sql.append("	   ,VIS_Y    = 'N' ");
		sql.append("	WHERE FIRST_LEG_FLT_DT = TO_DATE('" + (String)params.get("FIRST_LEG_FLT_DT") + "','YYYYMMDD') ");
		sql.append("	AND	FLT_NUM = '" + (String)params.get("FLT_NUM") + "' ");
		sql.append("	AND	STNFR = '" + (String)params.get("STNFR") + "' ");
		sql.append("	AND	STNTO = '" + (String)params.get("STNTO") + "' ");
		sql.append("	AND	UPD_SEQ = '" + (String)params.get("UPD_SEQ") + "' ");
		sql.append("	AND	VIS_Y <> 'N' ");
		
		//System.out.println("[BASE:FfsQ010Query:updFlightPlanCheckLogT] sql : "+sql.toString());
		return sql.toString();
	}
	
	public String updCommented(HashMap<String,String> params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append("	UPDATE KFOS.FFS_ALERT_T");
		sql.append("	SET COMMENTED = 'Y'");
		sql.append("	WHERE FIRST_LEG_FLT_DT = TO_DATE('" + (String)params.get("FIRST_LEG_FLT_DT") + "','YYYYMMDD') ");
		sql.append("	AND	FLT_NUM = '" + (String)params.get("FLT_NUM") + "' ");
		sql.append("	AND	LEG_NUM = '" + (String)params.get("LEG_NUM") + "' ");
		sql.append("	AND	STNFR = '" + (String)params.get("STNFR") + "' ");
		sql.append("	AND	STNTO = '" + (String)params.get("STNTO") + "' ");
		
		//System.out.println("[BASE:FfsQ010Query:updCommented] sql : "+sql.toString());
		return sql.toString();
	}
	
	public String delCommented(HashMap<String,String> params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append("	UPDATE KFOS.FFS_ALERT_T");
		sql.append("	SET COMMENTED = 'N' ");
		sql.append("	WHERE FIRST_LEG_FLT_DT = TO_DATE('" + (String)params.get("FIRST_LEG_FLT_DT") + "','YYYYMMDD') ");
		sql.append("	AND	FLT_NUM = '" + (String)params.get("FLT_NUM") + "' ");
		sql.append("	AND	LEG_NUM = '" + (String)params.get("LEG_NUM") + "' ");
		sql.append("	AND	STNFR = '" + (String)params.get("STNFR") + "' ");
		sql.append("	AND	STNTO = '" + (String)params.get("STNTO") + "' ");
		
		System.out.println("[BASE:FfsQ010Query:updCommented] sql : "+sql.toString());
		return sql.toString();
	}
	
	//20160301 ߰
	public String mgrXwAlertUserSetting(FfsQ110BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append("MERGE INTO KFOS.FFS_USER_ALERT_T \n");
		sql.append("USING DUAL \n");
		sql.append("ON (STAFF_NUM = '" + params.getStaffNum() + "' \n");
		sql.append("    AND FIRST_LEG_FLT_DT = TO_DATE('" + params.getFirstLegFltDt() + "', 'YYYYMMDD') \n");
		sql.append("    AND FLT_NUM = '" + params.getFltNum() + "' \n");
		sql.append("    AND STNFR = '" + params.getStnfr() + "' \n");
		sql.append("    AND STNTO = '" + params.getStnto() + "' \n");
		sql.append("   ) \n");
		sql.append("WHEN MATCHED THEN \n");
		sql.append("  UPDATE SET WX_ALERT = WX_ALERT||' '||'" + params.getWxAlert() + "', TIMESTMP = SYSDATE \n");
		sql.append("WHEN NOT MATCHED THEN \n");
		sql.append("  INSERT (STAFF_NUM, FIRST_LEG_FLT_DT, FLT_NUM, STNFR, STNTO, WX_ALERT, TIMESTMP) \n");
		sql.append("  VALUES ('" + params.getStaffNum() + "', TO_DATE('" + params.getFirstLegFltDt() + "', 'YYYYMMDD'), '" + params.getFltNum() 
					+ "', '" + params.getStnfr() + "', '" + params.getStnto() + "', '" + params.getWxAlert() + "', SYSDATE) \n");
		
		//System.out.println(sql.toString());
		return sql.toString();
	}
	public String mgrRegnoAlertUserSetting(FfsQ110BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append("MERGE INTO KFOS.FFS_USER_ALERT_T \n");
		sql.append("USING DUAL \n");
		sql.append("ON (STAFF_NUM = '" + params.getStaffNum() + "' \n");
		sql.append("    AND FIRST_LEG_FLT_DT = TO_DATE('" + params.getFirstLegFltDt() + "', 'YYYYMMDD') \n");
		sql.append("    AND FLT_NUM = '" + params.getFltNum() + "' \n");
		sql.append("    AND STNFR = '" + params.getStnfr() + "' \n");
		sql.append("    AND STNTO = '" + params.getStnto() + "' \n");
		sql.append("   ) \n");
		sql.append("WHEN MATCHED THEN \n");
		sql.append("  UPDATE SET REGNO_ALERT = '" + params.getRegnoAlert() + "', TIMESTMP = SYSDATE \n");
		sql.append("WHEN NOT MATCHED THEN \n");
		sql.append("  INSERT (STAFF_NUM, FIRST_LEG_FLT_DT, FLT_NUM, STNFR, STNTO, REGNO_ALERT, TIMESTMP) \n");
		sql.append("  VALUES ('" + params.getStaffNum() + "', TO_DATE('" + params.getFirstLegFltDt() + "', 'YYYYMMDD'), '" + params.getFltNum() 
					+ "', '" + params.getStnfr() + "', '" + params.getStnto() + "', '" + params.getRegnoAlert() + "', SYSDATE) \n");
		
		//System.out.println(sql.toString());
		return sql.toString();
	}
	public String mgrAtcAlertUserSetting(FfsQ110BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append("MERGE INTO KFOS.FFS_USER_ALERT_T \n");
		sql.append("USING DUAL \n");
		sql.append("ON (STAFF_NUM = '" + params.getStaffNum() + "' \n");
		sql.append("    AND FIRST_LEG_FLT_DT = TO_DATE('" + params.getFirstLegFltDt() + "', 'YYYYMMDD') \n");
		sql.append("    AND FLT_NUM = '" + params.getFltNum() + "' \n");
		sql.append("    AND STNFR = '" + params.getStnfr() + "' \n");
		sql.append("    AND STNTO = '" + params.getStnto() + "' \n");
		sql.append("   ) \n");
		sql.append("WHEN MATCHED THEN \n");
		sql.append("  UPDATE SET ATC_ALERT = 'Y', TIMESTMP = SYSDATE \n");
		sql.append("WHEN NOT MATCHED THEN \n");
		sql.append("  INSERT (STAFF_NUM, FIRST_LEG_FLT_DT, FLT_NUM, STNFR, STNTO, ATC_ALERT, TIMESTMP) \n");
		sql.append("  VALUES ('" + params.getStaffNum() + "', TO_DATE('" + params.getFirstLegFltDt() + "', 'YYYYMMDD'), '" + params.getFltNum() 
					+ "', '" + params.getStnfr() + "', '" + params.getStnto() + "', 'Y', SYSDATE) \n");
		
		//System.out.println(sql.toString());
		return sql.toString();
	}
	//20160706 ߰
	public String mgrPmsnAlertUserSetting(FfsQ110BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append("MERGE INTO KFOS.FFS_USER_ALERT_T \n");
		sql.append("USING DUAL \n");
		sql.append("ON (STAFF_NUM = '" + params.getStaffNum() + "' \n");
		sql.append("    AND FIRST_LEG_FLT_DT = TO_DATE('" + params.getFirstLegFltDt() + "', 'YYYYMMDD') \n");
		sql.append("    AND FLT_NUM = '" + params.getFltNum() + "' \n");
		sql.append("    AND STNFR = '" + params.getStnfr() + "' \n");
		sql.append("    AND STNTO = '" + params.getStnto() + "' \n");
		sql.append("   ) \n");
		sql.append("WHEN MATCHED THEN \n");
		sql.append("  UPDATE SET PMSN_ALERT = 'Y', TIMESTMP = SYSDATE \n");
		sql.append("WHEN NOT MATCHED THEN \n");
		sql.append("  INSERT (STAFF_NUM, FIRST_LEG_FLT_DT, FLT_NUM, STNFR, STNTO, PMSN_ALERT, TIMESTMP) \n");
		sql.append("  VALUES ('" + params.getStaffNum() + "', TO_DATE('" + params.getFirstLegFltDt() + "', 'YYYYMMDD'), '" + params.getFltNum() 
					+ "', '" + params.getStnfr() + "', '" + params.getStnto() + "', 'Y', SYSDATE) \n");
		
		//System.out.println(sql.toString());
		return sql.toString();
	}
	public String mgrMelAlertUserSetting(FfsQ110BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append("MERGE INTO KFOS.FFS_USER_ALERT_T \n");
		sql.append("USING DUAL \n");
		sql.append("ON (STAFF_NUM = '" + params.getStaffNum() + "' \n");
		sql.append("    AND FIRST_LEG_FLT_DT = TO_DATE('" + params.getFirstLegFltDt() + "', 'YYYYMMDD') \n");
		sql.append("    AND FLT_NUM = '" + params.getFltNum() + "' \n");
		sql.append("    AND STNFR = '" + params.getStnfr() + "' \n");
		sql.append("    AND STNTO = '" + params.getStnto() + "' \n");
		sql.append("   ) \n");
		sql.append("WHEN MATCHED THEN \n");
		//20160622 
		//sql.append("  UPDATE SET MEL_ALERT = 'Y', TIMESTMP = SYSDATE \n");
		sql.append("  UPDATE SET MEL_ALERT = '" + params.getMelAlert() + "', TIMESTMP = SYSDATE \n");
		sql.append("WHEN NOT MATCHED THEN \n");
		sql.append("  INSERT (STAFF_NUM, FIRST_LEG_FLT_DT, FLT_NUM, STNFR, STNTO, MEL_ALERT, TIMESTMP) \n");
		//20160622 
		/*
		sql.append("  VALUES ('" + params.getStaffNum() + "', TO_DATE('" + params.getFirstLegFltDt() + "', 'YYYYMMDD'), '" + params.getFltNum() 
					+ "', '" + params.getStnfr() + "', '" + params.getStnto() + "', 'Y', SYSDATE) \n");
		*/
		sql.append("  VALUES ('" + params.getStaffNum() + "', TO_DATE('" + params.getFirstLegFltDt() + "', 'YYYYMMDD'), '" + params.getFltNum() 
				+ "', '" + params.getStnfr() + "', '" + params.getStnto() + "', '" + params.getMelAlert() + "', SYSDATE) \n");
		
		//System.out.println(sql.toString());
		return sql.toString();
	}
	public String mgrAcarsTmpstUserSetting(FfsQ110BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append("MERGE INTO KFOS.FFS_USER_ALERT_T \n");
		sql.append("USING DUAL \n");
		sql.append("ON (STAFF_NUM = '" + params.getStaffNum() + "' \n");
		sql.append("    AND FIRST_LEG_FLT_DT = TO_DATE('" + params.getFirstLegFltDt() + "', 'YYYYMMDD') \n");
		sql.append("    AND FLT_NUM = '" + params.getFltNum() + "' \n");
		sql.append("    AND STNFR = '" + params.getStnfr() + "' \n");
		sql.append("    AND STNTO = '" + params.getStnto() + "' \n");
		sql.append("   ) \n");
		sql.append("WHEN MATCHED THEN \n");
		sql.append("  UPDATE SET ACARS_TMPST = SYSDATE, TIMESTMP = SYSDATE \n");
		sql.append("WHEN NOT MATCHED THEN \n");
		sql.append("  INSERT (STAFF_NUM, FIRST_LEG_FLT_DT, FLT_NUM, STNFR, STNTO, ACARS_TMPST, TIMESTMP) \n");
		sql.append("  VALUES ('" + params.getStaffNum() + "', TO_DATE('" + params.getFirstLegFltDt() + "', 'YYYYMMDD'), '" + params.getFltNum() 
					+ "', '" + params.getStnfr() + "', '" + params.getStnto() + "', SYSDATE, SYSDATE) \n");
		
		//System.out.println(sql.toString());
		return sql.toString();
	}
	public String selUserAlert(FfsQ110BG params) {
		StringBuffer sql = new StringBuffer();

		sql.append("SELECT \n");
		sql.append("  TO_CHAR(IND.FIRST_LEG_FLT_DT, 'YYYYMMDD') FIRST_LEG_FLT_DT, IND.FLT_NUM, IND.STNFR, IND.STNTO, \n");
		sql.append("  IND.REGNO_ALERT, IND.WX_ALERT, IND.MEL_ALERT, IND.ATC_ALERT, TO_CHAR(IND.ACARS_TMPST, 'YYMMDDHH24MISS') AS ACARS_TMPST \n");
		//20160706 ߰
		sql.append("  , IND.PMSN_ALERT \n");
		sql.append("FROM KFOS.FFS_ALERT_T FFS, KFOS.FFS_USER_ALERT_T IND \n");
		sql.append("WHERE IND.STAFF_NUM = '" + params.getStaffNum() + "' \n");
		sql.append("AND FFS.FIRST_LEG_FLT_DT BETWEEN SYSDATE-3 AND SYSDATE+1 \n");
		sql.append("AND FFS.STATUS = '" + params.getCat() + "' \n");
		sql.append("AND FFS.FIRST_LEG_FLT_DT = IND.FIRST_LEG_FLT_DT \n");
		sql.append("AND FFS.FLT_NUM = IND.FLT_NUM \n");
		sql.append("AND FFS.STNFR = IND.STNFR \n");
		sql.append("AND FFS.STNTO = IND.STNTO \n");
		
		//System.out.println(sql.toString());
		return sql.toString();
	}
	public String selAtcMessage(FfsQ110BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append("SELECT \n");
		sql.append("  MSG_CONTENT \n");
		sql.append("FROM BS_AFTNMSG_T \n");
		sql.append("WHERE MSG_DT = TO_DATE('" + params.getMsgDt() + "','YYMMDDHH24MISS') \n");
		sql.append("AND MSG_ID = '" + params.getMsgId() + "' \n");
		/*
		sql.append("SELECT \n");
		sql.append("  MSG_CONTENT \n");
		sql.append("FROM BS_AFTNMSG_T \n");
		sql.append("WHERE MSG_DT = TO_DATE('1605120800','YYMMDDHH24MI') \n");
		sql.append("AND MSG_ID = 'ATA0077' \n");
		*/
		//System.out.println(sql.toString());
		return sql.toString();
	}
	
	/**
	 * 20160415 ߰, 2016.10.25 CCF_99_ROW ÷ ߰
	 */
	public String selNotReleasedRev() {
		StringBuffer sql = new StringBuffer();
		
		sql.append("SELECT ");
		sql.append("  DECODE(DECODE(SUBSTR(ALT.FLT_NUM, 1, 1),'4','JNA','KAL'),'JNA','JNA',DEF.REGION_CD) REGION_CD, ");
		sql.append("  DECODE(SUBSTR(ALT.FLT_NUM, 1, 1),'4','JNA','KAL') GBN, ");
		sql.append("  ALT.FLT_NUM, ALT.TANKERING_ALERT,ALT.RESTRICT_E, ALT.PMSN_ALERT, ALT.SYSKEY, ");
		sql.append("  ALT.REGNO, ALT.MEL_ALERT, NVL(ALT.MULTI_MTOW, 'A0') MTOW, ALT.HIGHTIME_ALERT, ALT.REGNO_CHG_ALERT, ALT.ETD_ALERT,");
		sql.append("  ALT.SACTYP, ALT.STNFR, ALT.STNTO, AC.ALT_PORT, CCF.ETOP_PORT, ");
		sql.append("  CCF.REFILE_PT, CCF.REFILE_PORT, CCF.REFILE_ALT_PORT, ");
		sql.append("  CASE WHEN CCF.ERA_PORT2 IS NULL THEN  CCF.ERA_PORT1 ");
		sql.append("      WHEN CCF.ERA_PORT3 IS NULL THEN  CCF.ERA_PORT1 || ' ' || CCF.ERA_PORT2 ");
		sql.append("      WHEN CCF.ERA_PORT4 IS NULL THEN  CCF.ERA_PORT1 || ' ' || CCF.ERA_PORT2 || ' ' || CCF.ERA_PORT3  ");
		sql.append("      WHEN CCF.ERA_PORT5 IS NULL THEN  CCF.ERA_PORT1 || ' ' || CCF.ERA_PORT2 || ' ' || CCF.ERA_PORT3 || ' ' || CCF.ERA_PORT4 ");
		sql.append("      ELSE CCF.ERA_PORT1 || ' ' || CCF.ERA_PORT2 || ' ' || CCF.ERA_PORT3 || ' ' || CCF.ERA_PORT4 || ' ' || CCF.ERA_PORT5                                                                    ");
		sql.append("  END AS ERA_PORT, ");
		sql.append("  ALT.WEATHER_ALERT, ALT.LEG_NUM, ");
		sql.append("  TO_CHAR(SKD.SCH_DEP_DT,'YYMMDDHH24MI') SCH_DEP_DT, ");
		sql.append("  TO_CHAR(SKD.EST_DEP_DT,'YYMMDDHH24MI') EST_DEP_DT, ");
		sql.append("  TO_CHAR(SKD.SCH_ARV_DT,'YYMMDDHH24MI') SCH_ARV_DT, ");
		sql.append("  TO_CHAR(SKD.EST_ARV_DT,'YYMMDDHH24MI') EST_ARV_DT, ");
		sql.append("  DEF.ROUTE_NO, ");
		sql.append("  CCF.DISC_FUEL_AVG, CCF.DISC_FUEL_USED, ");
		sql.append("  CCF.CC_FUEL_50, CCF.CC_FUEL_75, CCF.CC_FUEL_95, CCF.CCF_CALC_Y, TO_CHAR(CCF.TIMESTAMP,'YYYYMMDD') TIMESTAMP, ");
		sql.append("  TRUNC(MOD((SKD.SCH_ARV_DT - SKD.SCH_DEP_DT), 1) * 24) BLOCK_TIME, ");
		sql.append("  CCF.CRZ_SPEED, ");
		
		sql.append("  NVL(CCF.CCF_50_ROW*100, 0) AS CCF_50_ROW, "); 
		sql.append("  NVL(CCF.CCF_90_ROW*100, 0) AS CCF_90_ROW, ");
		sql.append("  NVL(CCF.CCF_99_ROW*100, 0) AS CCF_99_ROW, ");
		
		sql.append("  NVL(DISC_LOAD_CNT, 0) AS DISC_LOAD_CNT, ");
		sql.append("  NVL(DISC_LOAD_RATE, 0) AS DISC_LOAD_RATE, ");
		
		sql.append("  PDP.ACC_ADLT_PAX_Q, PDP.ACC_CHLD_PAX_Q, PDP.ACC_INFT_PAX_Q, ");
		sql.append("  PDP.ACC_PAX_PLD_WT, PDP.ACC_CGO_PLD_WT, PDP.ACC_OTH_PLD_WT, ");
		sql.append("  SKD.SVC, ");
		sql.append("  TO_CHAR(PDP.ACC_PAX_DTG - 9/24,'DD/HH24MI') ACC_PAX_DTG,  TO_CHAR(PDP.ACC_CGO_DTG - 9/24,'DD/HH24MI') ACC_CGO_DTG, ");
		sql.append("  PDP.MD_AC_CONFIG, PDP.LD_AC_CONFIG_FWD, PDP.LD_AC_CONFIG_AFT, PDP.MD_LD_RECIR_FAN, PDP.ANI_PERI_FUEL_ADD, ");
		sql.append("  ALT.PAYLOAD_ALERT, ALT.COMMENTED, TO_CHAR(ALT.FIRST_LEG_FLT_DT,'YYYYMMDD') FIRST_LEG_FLT_DT, ");
		sql.append("  TO_CHAR(SKD.EST_DEP_DT,'DDMON','NLS_DATE_LANGUAGE=AMERICAN') EST_DATE ");
		sql.append("FROM ");
		sql.append("  KFOS.FFS_ALERT_T ALT, CM_PORT_AC_T AC, CM_CITYPAIR_AC_T CCF, CM_CITYPAIR_DEF_T DEF, DAILY_SCH_T SKD, PDP_FLT_PAYLOAD_T PDP, CM_REGNO_T REG ");
		sql.append("WHERE 1=1 ");
		sql.append("AND ALT.STATUS = 'BRL' ");
		//sql.append("AND SKD.EST_DEP_DT BETWEEN SYSDATE - 9/24 AND SYSDATE + 15/24 ");
		
		//2016.12.12, 48HR->72HR
		//sql.append("AND SKD.EST_DEP_DT BETWEEN SYSDATE - 9/24 AND SYSDATE + 1 ");
		sql.append("AND SKD.EST_DEP_DT BETWEEN SYSDATE - 9/24 AND SYSDATE + 2 ");
		
		sql.append("AND SKD.DEP_STS <> 'INI' ");
		sql.append("AND SKD.ACTNID <> 'CNL' ");
		sql.append("AND ALT.FIRST_LEG_FLT_DT = SKD.FIRST_LEG_FLT_DT ");
		sql.append("AND ALT.FLT_NUM = SKD.FLT_NUM ");
		sql.append("AND ALT.STNFR = SKD.STNFR ");
		sql.append("AND ALT.STNTO = SKD.STNTO ");
		sql.append("AND ALT.STNFR = DEF.DEP_PORT ");
		sql.append("AND ALT.STNTO = DEF.ARV_PORT ");
		sql.append("AND ALT.RELEASE_SYSKEY IS NULL ");
		sql.append("AND ALT.STNTO = AC.IATA_PORT ");
		sql.append("AND ALT.SACTYP = AC.SACTYP ");
		sql.append("AND ALT.STNFR = CCF.DEP_PORT ");
		sql.append("AND ALT.STNTO = CCF.ARV_PORT ");
		sql.append("AND ALT.SACTYP = CCF.SACTYP ");
		sql.append("AND ALT.FIRST_LEG_FLT_DT = PDP.FIRST_LEG_FLT_DT(+) ");
		sql.append("AND ALT.FLT_NUM = PDP.FLT_NUM(+) ");
		sql.append("AND ALT.STNFR = PDP.STNFR(+) ");
		sql.append("AND ALT.STNTO = PDP.STNTO(+) ");
		sql.append("AND ALT.FLT_NUM NOT LIKE '1%' ");
		sql.append("AND DEF.REGION_CD <> 'DOM' ");
		sql.append("AND ALT.REGNO = REG.REGNO(+) ");
		sql.append("ORDER BY GBN DESC, SKD.EST_DEP_DT ASC ");

		//System.out.println("[BASE:FfsQ010Query:selNotReleasedRev] sql : "+sql.toString());
		return sql.toString();
	}
}
