package kal.base.iro.query;

import kal.base.jdf.com.Logger;
import kal.base.iro.dbbean.*;
import kal.base.com.query.*;
import kal.base.com.util.*;

 /**
  * IRR/DSS Current Flight Schedule SQL 
  * @author Copyright (c) 2005/01/31 HIST  
  */   
public class IroA010Query {
	private static IroA010Query instance = new IroA010Query();
	
	public static IroA010Query getInstance() {
		return instance;
	}
	
	/** 
	  * IRR/DSS Current Flight Schedule Desk Select Code ȸ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2005/01/31 HIST 
	  */
	public String selDesk() {
		StringBuffer sql = new StringBuffer();
				
		sql.append(" Select Code_x, Desc_e");
		sql.append(" From Code_T");
		sql.append(" Where Step_x = '0'          And");
		sql.append(" 			Use_y  = 'N'          And");
		sql.append(" 			End_D  > To_Char(Sysdate,'yyyymmdd')");
		sql.append(" Order By Prty_no");
		
		Logger.debug.println("[BASE:IroA010Query:selDesk] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * IRR/DSS Current Flight Schedule Alert Message Է SQLԼ.
	  * @param params IroA010BG Է Parameter
	  * @return String Query  
	  * @author Copyright (c) 2005/01/31 HIST 
	  */
	public String insAlertMsg(IroA010BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" Insert Into Alert_msg_t Values(Sysdate,'"+params.getEmp_no()+"','"+StringUtil.DBInsStr(params.getAlert_msg_e())+"','N','')");
		
		Logger.debug.println("[BASE:IroA010Query:insAlertMsg] sql : "+sql.toString());
		return sql.toString();
	}		
	
	/** 
	  * IRR/DSS Current Flight Schedule Alert Message ȸ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2005/01/31 HIST 
	  */
	public String selAlertMsg() {
		StringBuffer sql = new StringBuffer();

		sql.append(" Select Alert_msg_e,Emp_no,To_char(Alert_dt,'yyyymmddhh24miss') Alert_dt");
		sql.append(" From Alert_Msg_t");
		sql.append(" Where Alert_Dt >= Sysdate-2 And");
		sql.append("       		Expire_y = 'N'");
		sql.append(" Order By 3 Desc");
		
		//Logger.debug.println("[BASE:IroA010Query:selAlertMsg] sql : "+sql.toString());
		return sql.toString();
	}		
	
	/** 
	  * IRR/DSS Current Flight Schedule Alert Message Expire SQLԼ.
	  * @param params IroA010BG  Value  
	  * @return String Query  
	  * @author Copyright (c) 2005/01/31 HIST 
	  */
	public String updAlertMsg(IroA010BG params) {
		StringBuffer sql = new StringBuffer();

		sql.append(" Update Alert_Msg_T");
		sql.append(" Set Expire_y = 'Y', Expire_no = '"+params.getEmp_no()+"'");
		sql.append(" Where Alert_Dt = To_Date('"+params.getAlert_dt()+"','yyyymmddhh24miss')");
		sql.append(" And Emp_no = '"+params.getEmp_no()+"'");
		
		Logger.debug.println("[BASE:IroA010Query:updAlertMsg] sql : "+sql.toString());
		return sql.toString();
	}			
	
	/** 
	  * IRR/DSS Current Flight Schedule Job Select ȸ SQLԼ.
	  * @param params IroA010BG ȸ
	  * @return String Query  
	  * @author Copyright (c) 2005/01/31 HIST 
	  */
	public String selJob(IroA010BG params) {
		StringBuffer sql = new StringBuffer();
				
		sql.append(" Select A.Flt_Num,A.Seq_Num,A.Option_Num,A.Stnfr,A.Stnto,A.Title_x,");
        sql.append(" 		    To_char(A.First_Leg_Flt_Dt,'yyyymmdd') First_Leg_Flt_dt");
		sql.append(" From Irops_Sch_T A,Irops_Desk_T B");
		sql.append(" Where A.Arln_Cd = 'KE' And");
		sql.append("            A.First_Leg_Flt_Dt >= To_Date(To_Char(sysdate-2,'yyyymmdd'),'yyyymmdd') And");
		sql.append("       		A.First_Leg_Flt_Dt <= To_Date(To_Char(sysdate+1,'yyyymmdd'),'yyyymmdd') And");
		sql.append("       		A.Complete_y       = 'N'       And");
		sql.append("      		A.First_Leg_Flt_Dt = B.First_Leg_Flt_Dt And");
		sql.append("      		A.Arln_cd    = B.Arln_cd    And");
		sql.append("      		A.Flt_Num   = B.Flt_Num    And");
		sql.append("      		A.Stnfr       = B.Stnfr      And");
		sql.append("       		A.Stnto       = B.Stnto      And");
		sql.append("       		A.Seq_Num    = B.Seq_Num    And");
		sql.append("       		A.Option_Num = B.Option_Num And");
		if (params.getDesk_x().equals("A")) {
			sql.append("       		B.Desk_x     = '"+params.getDesk_x()+"'");
		} else {
			sql.append("       		B.Desk_x     = '"+params.getDesk_x()+"'  And");
			sql.append("       		B.Decision_x >= '3'");			
		}
		sql.append(" Order By A.Timestamp");
		
		//Logger.debug.println("[BASE:IroA010Query:selJob] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * IRR/DSS Current Flight Schedule Main ȸ SQLԼ.
	  * @param params IroA010BG ȸ
	  * @return String Query  
	  * @author Copyright (c) 2005/01/31 HIST 
	  */
	public String selMain(IroA010BG params) {
		StringBuffer sql = new StringBuffer();
		/*
		sql.append(" Select A.Flt_Num, A.Kactyp, A.Regno, A.Stnfr,  A.Stnto,");
		sql.append("            To_Char(A.Sch_Dep_Dt,'hh24:mi') Sch_Dep_Dt, To_Char(A.Sch_Arv_Dt,'hh24:mi') Sch_Arv_Dt,");
		sql.append("        	To_Char(A.Est_Dep_Dt,'hh24:mi') Est_Dep_Dt, To_Char(A.Est_Arv_Dt,'hh24:mi') Est_Arv_Dt,");
		sql.append("        	A.Del_Rc1, A.Del_Dur1, A.F_Book + A.C_Book + A.Y_Book Book, A.Dep_Sts,");
		sql.append("            To_Char(A.First_Leg_Flt_Dt,'yyyymmdd') First_Leg_Flt_Dt, To_Char(A.Timestamp ,'yyyymmddhh24mi') Timestamp,");
		sql.append("            A.Leg_Num,A.Region_Flt,A.Region_Leg,");
		sql.append("        	To_Char(A.Sch_Dep_Dt,'mmdd') Sch_Dt,To_Char(A.Sch_Dep_Dt,'DDMON YYYY') Dis_Dt,");
		sql.append("        	To_Char(A.Est_Dep_Dt,'yyyymmddhh24mi') Ord_Dt");
		sql.append(" From Daily_Sch_T A , Pe_Acars_Skd_T B");
		sql.append(" Where A.Arln_Cd = 'KE' And");
		if (!params.getStnfr().equals(""))
			sql.append("       		(A.Stnfr = '"+params.getStnfr()+"' Or A.Stnto = '"+params.getStnfr()+"')  And");
		//sql.append("       		NVL(A.Region_Flt,'9') = '"+params.getRegion_flt()+"'  And"); //ڵ  ϳ 
		//DOM/INT/CGO ȸ
		sql.append(IroA010Query.getInstance().selDomIntQ(params.getDom_int_x()));
		if (params.getEnd_tm().equals("90")) {
			//ð UTC  Է½ð-9 Ѵ. ==> Servlet
			sql.append("       		A.Est_Dep_Dt >= sysdate-3 And");	//3
			sql.append("       		A.Dep_Sts = 'ACT' And");
			sql.append("       		A.Arv_Sts In ('SCH','EST') And");
		} else {
			//ð UTC  Է½ð-9 Ѵ. ==> Servlet
			sql.append("       		A.Est_Dep_Dt >= sysdate-3 And");	//3
			sql.append("       		A.Est_Dep_Dt <= sysdate+("+params.getEnd_tm()+"/24) And");
			sql.append("       		A.Dep_Sts In ('SCH','EST') And");
		}
		sql.append("       		A.Actnid    <> 'CNL'       And");
		sql.append("       		A.First_Leg_Flt_Dt = B.First_Leg_Flt_Dt(+)   And");
		sql.append("       		A.Flt_Num = B.Flt_Num(+) And");
		sql.append("       		A.Stnfr   = B.Stnfr(+)   And");
		sql.append("       		A.Stnto   = B.Stnto(+)   And");
		sql.append("       		B.Act_Out_Dt(+) is null");
		sql.append(" Order By Ord_Dt");		
		*/
		
		//NOT CANCEL DATA
		sql.append(" Select A.Flt_Num, A.Kactyp, A.Regno, A.Stnfr,  A.Stnto,");
		sql.append("            To_Char(A.Sch_Dep_Dt,'hh24:mi') Sch_Dep_Dt, To_Char(A.Sch_Arv_Dt,'hh24:mi') Sch_Arv_Dt,");
		sql.append("        	To_Char(A.Est_Dep_Dt,'hh24:mi') Est_Dep_Dt, To_Char(A.Est_Arv_Dt,'hh24:mi') Est_Arv_Dt,");
		sql.append("        	A.Del_Rc1, A.Del_Dur1, A.F_Book + A.C_Book + A.Y_Book Book, A.Dep_Sts,");
		sql.append("            To_Char(A.First_Leg_Flt_Dt,'yyyymmdd') First_Leg_Flt_Dt, To_Char(A.Timestamp ,'yyyymmddhh24mi') Timestamp,");
		sql.append("            A.Leg_Num,A.Region_Flt,A.Region_Leg,A.Actnid,");
		sql.append("        	To_Char(A.Sch_Dep_Dt,'mmdd') Sch_Dt,To_Char(A.Sch_Dep_Dt,'DDMON YYYY') Dis_Dt,");
		sql.append("        	To_Char(A.Est_Dep_Dt,'yyyymmddhh24mi') Ord_Dt");
		sql.append(" From Daily_Sch_T A");
		sql.append(" Where A.Arln_Cd = 'KE' And");
		if (!params.getStnfr().equals(""))
			sql.append("       		(A.Stnfr = '"+params.getStnfr()+"' Or A.Stnto = '"+params.getStnfr()+"')  And");
		//sql.append("       		NVL(A.Region_Flt,'9') = '"+params.getRegion_flt()+"'  And"); //ڵ  ϳ 
		//DOM/INT/CGO ȸ
		sql.append(IroA010Query.getInstance().selDomIntQ(params.getDom_int_x()));
		if (params.getEnd_tm().equals("90")) {
			//ð UTC  Է½ð-9 Ѵ. ==> Servlet
			sql.append("       		A.Est_Dep_Dt >= sysdate-3 And");	//3
			sql.append("       		A.Dep_Sts = 'ACT' And");
			sql.append("       		A.Arv_Sts In ('SCH','EST') And");
		} else {
			//ð UTC  Է½ð-9 Ѵ. ==> Servlet
			sql.append("       		A.Est_Dep_Dt >= sysdate-3 And");	//3
			sql.append("       		A.Est_Dep_Dt <= sysdate+("+params.getEnd_tm()+"/24) And");
			sql.append("       		A.Dep_Sts In ('SCH','EST') And");
		}
		sql.append("       		A.Kactyp Not In ('7FG','79S','7GG','ABH') And");		// 2009.05.21 ߰ : 7GG, ABH
		if (!params.getRegno().equals(""))
			sql.append("       		A.Regno = 'HL"+params.getRegno()+"' And");		//2005.09.05 HL ȸ ߰
		sql.append("       		A.Actnid    <> 'CNL'");
		//In Flight  ƴҰ츸 Ѵ.
		if (!params.getEnd_tm().equals("90")) {
			sql.append(" Union");		
			//CANCEL DATA
			sql.append(" Select A.Flt_Num, A.Kactyp, A.Regno, A.Stnfr,  A.Stnto,");
			sql.append("            To_Char(A.Sch_Dep_Dt,'hh24:mi') Sch_Dep_Dt, To_Char(A.Sch_Arv_Dt,'hh24:mi') Sch_Arv_Dt,");
			sql.append("        	To_Char(A.Est_Dep_Dt,'hh24:mi') Est_Dep_Dt, To_Char(A.Est_Arv_Dt,'hh24:mi') Est_Arv_Dt,");
			sql.append("        	A.Del_Rc1, A.Del_Dur1, A.F_Book + A.C_Book + A.Y_Book Book, A.Dep_Sts,");
			sql.append("            To_Char(A.First_Leg_Flt_Dt,'yyyymmdd') First_Leg_Flt_Dt, To_Char(A.Timestamp ,'yyyymmddhh24mi') Timestamp,");
			sql.append("            A.Leg_Num,A.Region_Flt,A.Region_Leg,A.Actnid,");
			sql.append("        	To_Char(A.Sch_Dep_Dt,'mmdd') Sch_Dt,To_Char(A.Sch_Dep_Dt,'DDMON YYYY') Dis_Dt,");
			sql.append("        	To_Char(A.Est_Dep_Dt,'yyyymmddhh24mi') Ord_Dt");
			sql.append(" From Daily_Sch_T A");
			sql.append(" Where A.Arln_Cd = 'KE' And");
			if (!params.getStnfr().equals(""))
				sql.append("       		(A.Stnfr = '"+params.getStnfr()+"' Or A.Stnto = '"+params.getStnfr()+"')  And");
			//sql.append("       		NVL(A.Region_Flt,'9') = '"+params.getRegion_flt()+"'  And"); //ڵ  ϳ 
			//DOM/INT/CGO ȸ
			sql.append(IroA010Query.getInstance().selDomIntQ(params.getDom_int_x()));
			//ð UTC  Է½ð-9 Ѵ. ==> Servlet
			sql.append("       		A.Est_Dep_Dt >= sysdate-(12/24) And");	//3
			sql.append("       		A.Est_Dep_Dt <= sysdate+("+params.getEnd_tm()+"/24) And");
			sql.append("       		A.Dep_Sts In ('SCH','EST') And");
			sql.append("       		A.Kactyp Not In ('7FG','79S','7GG','ABH') And");		// 2009.05.21 ߰ : 7GG, ABH
			if (!params.getRegno().equals(""))
				sql.append("       		A.Regno = 'HL"+params.getRegno()+"' And");		//2005.09.05 HL ȸ ߰
			/**************************************/
			//캸 48ð ĵʹ 
			sql.append("       		A.Actnid    = 'CNL' And");
			/**************************************/
			sql.append("			TIMESTAMP >= SCH_DEP_DT-(36/24)");
		}
		
		sql.append(" Order By Ord_Dt");		
		
		//System.out.println("[BASE:IroA010Query:selMain] sql : "+sql.toString());
		Logger.debug.println("[BASE:IroA010Query:selMain] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * Dom/Int/Cgo Query ȸԼ.
	  *  ǿ ´ Query Ѵ
	  * @param domIntX String 
	  * @return String Query 
	  * @author Copyright (c) 2005/01/26 HIST 
	  */
	public String selDomIntQ(String domIntX) {

		StringBuffer sql = new StringBuffer();
		if (domIntX != null && domIntX.length() != 0)
			domIntX = domIntX.toUpperCase();
		else 
			domIntX = StringUtil.checkString(domIntX);
		
		if (domIntX.equals("DOM")) {
			//2008.02.22  
			//sql.append(" 	(Substr(A.Flt_Num,1,1) = '1' Or");
			//sql.append(" 		(Substr(A.Flt_Num,1,2) = '01' And");
			//sql.append(" 	(Substr(A.Flt_Num,5,1) >= 'A' And Substr(A.Flt_Num,5,1) <= 'Z') And");
			//sql.append(" 		Not A.Kactyp In('M1F','7FQ','7FR','74Y','7FG','79S'))) And");
			sql.append(" 	SUBSTR(A.FLT_NUM,1,1) = '1' AND ");
			
		} else if (domIntX.equals("INT")) {
			//2008.02.22  
			//sql.append(" 	Not (Substr(A.Flt_Num,1,1) = '1'  Or");
			//sql.append(" 		(Substr(A.Flt_Num,1,2) = '01' And (Substr(A.Flt_Num,5,1) >= 'A' And");
			//sql.append(" 	Substr(A.Flt_Num,5,1) <= 'Z')) or");
			//sql.append(" 	A.Kactyp In('M1F','7FQ','7FR','74Y','7FG','79S')) And");
			sql.append(" 	NOT (SUBSTR(A.FLT_NUM,1,1) = '1' OR ");
			sql.append(" 	A.KACTYP IN('ABF','M1F','7FQ','7FR','74Y','7FG','79S','7GG','ABH','74F','74N','77X')) AND "); //2009.05.21 ߰ : ABH, 2010.03.26 ߰ : 74F, 2012.02.22 ߰ : ,'74N','77X'
			
		} else if (domIntX.equals("CGO")) {
			//2008.02.22  
			//sql.append(" 	Substr(A.Flt_Num,1,1) <> '1'   And");
			//sql.append(" 	A.Kactyp In('M1F','7FQ','7FR','74Y','7FG','79S') And");
			sql.append(" 	A.KACTYP IN('ABF','M1F','7FQ','7FR','74Y','7FG','79S','7GG','ABH','74F','74N','77X') AND "); //2009.05.21 ߰ : ABH, 2010.03.26 ߰ : 74F, 2012.02.22 ߰ : ,'74N','77X'
			
		} else {
			sql.setLength(0);
		}

		return sql.toString();
	}		
	
	/** 
	  * IRR/DSS Current Flight Schedule IROPS Seq ȸ SQLԼ.
	  * @param params IroA010BG ȸ
	  * @return String Query  
	  * @author Copyright (c) 2005/01/31 HIST 
	  */
	public String selIropsSeq(IroA010BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" Select  Seq_Num, Option_Num, Complete_y");
		sql.append("   From  Irops_Sch_T");
		sql.append("  Where First_Leg_Flt_Dt = To_Date('"+params.getFirst_leg_flt_dt()+"','yyyymmdd') And");
		sql.append("             Flt_Num    = '"+params.getFlt_num()+"'  And");
		sql.append("        	 Stnfr      = '"+params.getStnfr()+"'   And");
		sql.append("        	 Stnto      = '"+params.getStnto()+"'");
		//sql.append("        	 Stnto      = '"+params.getStnto()+"'   And");
		//sql.append("        	 Rownum = 1");
		sql.append("  Order By 1 Desc");
		
		Logger.debug.println("[BASE:IroA010Query:selIropsSeq] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * IRR/DSS Current Flight Schedule IROPS Seq  SQLԼ.
	  * @param params IroA010BG ȸ
	  * @return String Query  
	  * @author Copyright (c) 2005/01/31 HIST 
	  */
	public String updIropsSeq(IroA010BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" Update Irops_Sch_T");
		sql.append("       Set Complete_y = 'X'");
		sql.append("  Where First_Leg_Flt_Dt = To_Date('"+params.getFirst_leg_flt_dt()+"','yyyymmdd') And");
		sql.append("             Flt_Num    = '"+params.getFlt_num()+"'  And");
		sql.append("        	 Stnfr      = '"+params.getStnfr()+"'   And");
		sql.append("        	 Stnto      = '"+params.getStnto()+"'   And");
		sql.append("        	 Seq_num = '"+params.getSeq_num()+"'");
		
		Logger.debug.println("[BASE:IroA010Query:updIropsSeq] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * IRR/DSS Current Flight Schedule IROPS_SCH_T Է SQLԼ.
	  * @param params IroA010BG ȸ
	  * @return String Query  
	  * @author Copyright (c) 2005/01/31 HIST 
	  */
	public String insIropsSchT(IroA010BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" Insert Into Irops_Sch_T");
		sql.append("  Values (To_Date('"+params.getFirst_leg_flt_dt()+"','yyyymmdd'),'KE','"+params.getFlt_num()+"','"+params.getStnfr()+"', '"+params.getStnto()+"',");
		sql.append("               '"+params.getLeg_num()+"', '"+params.getSeq_num()+"', '"+params.getOption_num()+"','"+params.getTitle_x()+"','"+StringUtil.DBInsStr(params.getTitle_e())+"', 'X', ' ', ' ', 'N', 'N',");
		sql.append("               '"+params.getRegion_flt()+"', '"+params.getRegion_leg()+"', '"+params.getEmp_no()+"', null,null,null,'X',null,Sysdate,Sysdate)"); //==> 2006.1.4  
		
		Logger.debug.println("[BASE:IroA010Query:insIropsSchT] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * IRR/DSS Current Flight Schedule IROPS_DESK_T Է SQLԼ.
	  * @param params IroA010BG ȸ
	  * @return String Query  
	  * @author Copyright (c) 2005/01/31 HIST 
	  */
	public String insIropsDeskT(IroA010BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" Insert Into Irops_Desk_T");
		sql.append(" Values (To_Date('"+params.getFirst_leg_flt_dt()+"','yyyymmdd'),'KE','"+params.getFlt_num()+"','"+params.getStnfr()+"', '"+params.getStnto()+"','"+params.getSeq_num()+"', '"+params.getOption_num()+"',");
		sql.append("         '"+params.getDesk_x()+"', '4', ' ', ' ', ' ', Sysdate)");
		
		Logger.debug.println("[BASE:IroA010Query:insIropsDeskT] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/*************************************
	 * 
	 * NEW Flight  Query
	 * 
	 * ***********************************/ 
	
	/** 
	  * New Flight Schedule Bs_New_Sch_T Է SQLԼ.
	  * @param params IroA010BG ȸ
	  * @return String Query  
	  * @author Copyright (c) 2005/04/27 HIST 
	  */
	public String insBsNewSchT(IroA010BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" Insert Into Bs_New_Sch_t (First_Leg_Flt_Dt,Arln_Cd,Flt_Num,Leg_Num,Stnfr,Stnto,Sch_Dep_Dt,Sch_Arv_Dt,Kactyp,Regno,Code_x,Expire_y,Timestamp)");
		//2009.04.28  : 1, 2, 3...=> 10, 20, 30...  
		//sql.append(" Values (To_Date('"+params.getFirst_leg_flt_dt()+"','YYYYMMDD'),'KE','"+params.getFlt_num()+"','1','"+params.getStnfr()+"','"+params.getStnto()+"',To_Date('"+params.getSch_dep_dt()+"','YYYYMMDDHH24MI'),To_Date('"+params.getSch_arv_dt()+"','YYYYMMDDHH24MI'),'"+params.getKactyp()+"','"+params.getRegno()+"','"+params.getCode_x()+"','N',Sysdate)");
		sql.append(" Values (To_Date('"+params.getFirst_leg_flt_dt()+"','YYYYMMDD'),'KE','"+params.getFlt_num()+"','10','"+params.getStnfr()+"','"+params.getStnto()+"',To_Date('"+params.getSch_dep_dt()+"','YYYYMMDDHH24MI'),To_Date('"+params.getSch_arv_dt()+"','YYYYMMDDHH24MI'),'"+params.getKactyp()+"','"+params.getRegno()+"','"+params.getCode_x()+"','N',Sysdate)");
		
		Logger.debug.println("[BASE:IroA010Query:insIropsDeskT] sql : "+sql.toString());
		return sql.toString();
	}		
	
}//end of class


