package kal.base.iro.query;

import kal.base.jdf.com.Logger;
import kal.base.iro.dbbean.*;
import kal.base.com.query.*;
import kal.base.com.util.*;

 /**
  * IRR/DSS Decision Making&Action SQL 
  * @author Copyright (c) 2005/02/07 HIST  
  */  
public class IroA040Query {
	private static IroA040Query instance = new IroA040Query();
	
	public static IroA040Query getInstance() {
		return instance;
	}
	
	/** 
	  * IRR/DSS Decision Making&Action ä Data  SQLԼ.
	  * decision_e  'XX' Ѵ
	  * @param params IroA040BG ȸ
	  * @return String Query  
	  * @author Copyright (c) 2005/04/26 HIST 
	  */
	public String updDecisionE(IroA040BG params) {
		StringBuffer sql = new StringBuffer();
		
		//Data holding & Completing
		sql.append(" Update Irops_Sch_t");
		sql.append(" Set Decision_c = 'XX'");
		sql.append(" Where Arln_Cd = 'KE' And");
		sql.append("       First_Leg_Flt_Dt = To_Date('"+params.getFirst_leg_flt_dt()+"','yyyymmdd') And");
		sql.append("       Flt_Num = '"+params.getFlt_num()+"'   And");
		sql.append("       Stnfr   = '"+params.getStnfr()+"'     And");
		sql.append("       Stnto   = '"+params.getStnto()+"'     And");
		sql.append("       Seq_Num = '"+params.getSeq_num()+"' And");
		sql.append("       Option_Num = '"+params.getOption_num()+"'");
		
		Logger.debug.println("[BASE:IroA040Query:updCompleteY] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * IRR/DSS Decision Making&Action Data Holding&Completing  SQLԼ.
	  * params complete_y parameter 'H'/'Y' Ѵ
	  * @param params IroA040BG ȸ
	  * @return String Query  
	  * @author Copyright (c) 2005/02/07 HIST 
	  */
	public String updCompleteY(IroA040BG params) {
		StringBuffer sql = new StringBuffer();
		
		//Data holding & Completing
		sql.append(" Update Irops_Sch_t");
		sql.append(" Set Complete_y = '"+params.getComplete_y()+"'");
		sql.append(" Where Arln_Cd = 'KE' And");
		sql.append("       First_Leg_Flt_Dt = To_Date('"+params.getFirst_leg_flt_dt()+"','yyyymmdd') And");
		sql.append("       Flt_Num = '"+params.getFlt_num()+"'   And");
		sql.append("       Stnfr   = '"+params.getStnfr()+"'     And");
		sql.append("       Stnto   = '"+params.getStnto()+"'     And");
		sql.append("       Seq_Num = '"+params.getSeq_num()+"'");
		
		Logger.debug.println("[BASE:IroA040Query:updCompleteY] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * IRR/DSS Decision Making&Action Shift Manager ID Է SQLԼ.
	  * @param params IroA040BG ȸ
	  * @return String Query  
	  * @author Copyright (c) 2005/04/01 HIST 
	  */
	public String updUserID(IroA040BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" Update Irops_Desk_t");
		sql.append(" Set User_Id = '"+params.getEmp_no()+"',");
		sql.append("       Timestamp = Sysdate");
		sql.append(" Where First_Leg_Flt_Dt = To_Date('"+params.getFirst_leg_flt_dt()+"','YYYYMMDD') And");
		sql.append("       		Flt_Num = '"+params.getFlt_num()+"' And");
		sql.append("       		Stnfr = '"+params.getStnfr()+"' And");
		sql.append("       		Stnto = '"+params.getStnto()+"' And");
		sql.append("       		Seq_Num = '"+params.getSeq_num()+"' And");
		sql.append("       		Option_Num = '"+params.getOption_num()+"' And");
		sql.append("       		User_Id = ' ' And");
		sql.append("       		Decision_e = ' ' And");
		sql.append("       		Checklist_e = ' '");
		
		Logger.debug.println("[BASE:IroA040Query:updUserID] sql : "+sql.toString());
		return sql.toString();
	}	

	/** 
	  * IRR/DSS Decision Making&Action Title_e ȸ SQLԼ.
	  * @param params IroA040BG ȸ
	  * @return String Query  
	  * @author Copyright (c) 2005/02/07 HIST 
	  */
	public String selTitleE(IroA040BG params) {
		StringBuffer sql = new StringBuffer();
		
		//Suggest ȸ
		sql.append(" Select Title_e,Decision_e");
		sql.append(" From Irops_Sch_t");
		sql.append(" Where Arln_Cd = 'KE' And");
		sql.append("       First_Leg_Flt_Dt = To_Date('"+params.getFirst_leg_flt_dt()+"','yyyymmdd') And");
		sql.append("       Flt_Num = '"+params.getFlt_num()+"'   And");
		sql.append("       Stnfr   = '"+params.getStnfr()+"'     And");
		sql.append("       Stnto   = '"+params.getStnto()+"'     And");
		sql.append("       Seq_Num = '"+params.getSeq_num()+"'   And");
		sql.append("       Option_Num = '"+params.getOption_num()+"'   And");
		sql.append("       Complete_y = 'H'");
		
		Logger.debug.println("[BASE:IroA040Query:selTitleE] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * IRR/DSS Decision Making&Action Desk Comment ȸ SQLԼ.
	  * @param params IroA040BG ȸ
	  * @return String Query  
	  * @author Copyright (c) 2005/02/07 HIST 
	  */
	public String selDeskComment(IroA040BG params) {
		StringBuffer sql = new StringBuffer();
		
		//Desk Comment ȸ
		sql.append(" Select C.Code_x, B.Kor_n, To_Char(A.TimeStamp,'hh24:mi:ss') TimeStamp, A.Decision_x,A.Decision_e,A.desk_x");
		sql.append(" From Irops_Desk_T A, Password_T B, Code_T C");
		sql.append(" Where A.Arln_Cd = 'KE' And");
		sql.append("       A.First_Leg_Flt_Dt = To_Date('"+params.getFirst_leg_flt_dt()+"','yyyymmdd') And");
		sql.append("       A.Flt_Num = '"+params.getFlt_num()+"'   And");
		sql.append("       A.Stnfr   = '"+params.getStnfr()+"'     And");
		sql.append("       A.Stnto   = '"+params.getStnto()+"'     And");
		sql.append("       A.Seq_Num = '"+params.getSeq_num()+"'   And");
		sql.append("       A.Option_Num = '"+params.getOption_num()+"'   And");
		sql.append("       A.User_Id    = B.Emp_no(+)   And");
		sql.append("       A.Desk_x     = C.Desc_e      And");
		sql.append("       C.Step_x     = '0'           And");
		sql.append("       C.Code_c     = 'Head'        And");
		sql.append("       C.Use_y      = 'N'           And");
		sql.append("       C.End_d      >= To_Char(Sysdate,'yyyymmdd')");
		sql.append(" Order By A.Desk_x,C.Code_x,A.Decision_x");
		
		Logger.debug.println("[BASE:IroA040Query:selDeskComment] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * IRR/DSS Decision Making&Action ä Data  SQLԼ.
	  * @param params IroA040BG ȸ
	  * @return String Query  
	  * @author Copyright (c) 2005/02/07 HIST 
	  */
	public String updIropsSchT(IroA040BG params) {
		StringBuffer sql = new StringBuffer();
		
		// Data Ϸ (äData ܰ)
		sql.append(" Update Irops_Sch_t");
		sql.append(" Set 	Decision_c = '"+params.getDecision_c()+"',");
		sql.append("     	Title_e = '"+StringUtil.DBInsStr(params.getTitle_e())+"',");
		sql.append("     	Decision_e = '"+StringUtil.DBInsStr(params.getDecision_e())+"',");
		sql.append("     	Remark_e = '"+StringUtil.DBInsStr(params.getRemark_e())+"',");
		sql.append("     	Timestamp_e = Sysdate"); //==> 2006.1.4  
		sql.append(" Where Arln_Cd = 'KE' And");
		sql.append("       		First_Leg_Flt_Dt = To_Date('"+params.getFirst_leg_flt_dt()+"','yyyymmdd') And");
		sql.append("       		Flt_Num = '"+params.getFlt_num()+"'   And");
		sql.append("       		Stnfr   = '"+params.getStnfr()+"'     And");
		sql.append("       		Stnto   = '"+params.getStnto()+"'     And");
		sql.append("       		Seq_Num = '"+params.getSeq_num()+"'   And");
		sql.append("       		Option_Num = '"+params.getOption_num()+"'"); 		
		
		Logger.debug.println("[BASE:IroA040Query:updIropsSchT] sql : "+sql.toString());
		return sql.toString();
	}	
}
