package kal.base.iro.query;

import kal.base.jdf.com.Logger;
import kal.base.iro.dbbean.*;
import kal.base.com.query.*;
import kal.base.com.util.*;

 /**
  * IRR/DSS IROPS MULTI SQL 
  * @author Copyright (c) 2005/07/08 HIST  
  */   
public class IroA080Query {
	private static IroA080Query instance = new IroA080Query();
	
	public static IroA080Query getInstance() {
		return instance;
	}
	
	/** 
	  * IRR/DSS IROPS MULTI  IROPS Seq ȸ SQLԼ.
	  * @param params IroA010BG ȸ
	  * @return String Query  
	  * @author Copyright (c) 2005/07/08 HIST 
	  */
	public String selIropsSeq(IroA010BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" Select  Seq_Num, Option_Num, Complete_y");
		sql.append("   From  Irops_Sch_T");
		sql.append("  Where First_Leg_Flt_Dt = To_Date('"+params.getFirst_leg_flt_dt()+"','yyyymmdd') And");
		sql.append("             Flt_Num    = '"+params.getFlt_num()+"'  And");
		sql.append("        	 Stnfr      = '"+params.getStnfr()+"'   And");
		sql.append("        	 Stnto      = '"+params.getStnto()+"'");
		sql.append("  Order By 1 Desc");
		
		Logger.debug.println("[BASE:IroA080Query:selIropsSeq] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * IRR/DSS IROPS MULTI    IROPS Seq  SQLԼ.
	  * @param params IroA010BG ȸ
	  * @return String Query  
	  * @author Copyright (c) 2005/07/08 HIST 
	  */
	public String updIropsSeq(IroA010BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" Update Irops_Sch_T");
		sql.append("       Set Complete_y = 'X'");
		sql.append("  Where First_Leg_Flt_Dt = To_Date('"+params.getFirst_leg_flt_dt()+"','yyyymmdd') And");
		sql.append("             Flt_Num    = '"+params.getFlt_num()+"'  And");
		sql.append("        	 Stnfr      = '"+params.getStnfr()+"'   And");
		sql.append("        	 Stnto      = '"+params.getStnto()+"'   And");
		sql.append("        	 Seq_num = '"+params.getSeq_num()+"'");
		
		Logger.debug.println("[BASE:IroA080Query:updIropsSeq] sql : "+sql.toString());
		return sql.toString();
	}	

	/** 
	  * IRR/DSS IROPS MULTI   IROPS_SCH_T Է SQLԼ.
	  * @param params IroA010BG ȸ
	  * @return String Query  
	  * @author Copyright (c) 2005/07/08 HIST 
	  */
	public String insIropsSchT(IroA010BG params) {
		StringBuffer sql = new StringBuffer();	
		
		sql.append(" Insert Into Irops_Sch_T");
		sql.append("  Values (To_Date('"+params.getFirst_leg_flt_dt()+"','yyyymmdd'),'KE','"+params.getFlt_num()+"','"+params.getStnfr()+"', '"+params.getStnto()+"',");
		sql.append("               '"+params.getLeg_num()+"', '"+params.getSeq_num()+"', '"+params.getOption_num()+"','"+params.getTitle_x()+"','"+StringUtil.DBInsStr(params.getTitle_e())+"', '"+params.getDecision_c()+"', '"+params.getDecision_e()+"', '"+params.getRemark_e()+"', 'N', 'Y',");
		sql.append("               '"+params.getRegion_flt()+"', '"+params.getRegion_leg()+"', '"+params.getEmp_no()+"', null,null,null,'X',null,Sysdate,Sysdate)"); //==> 2006.1.4  
		
		Logger.debug.println("[BASE:IroA080Query:insIropsSchT] sql : "+sql.toString());
		return sql.toString();
	}		
	
	/** 
	  * IRR/DSS  IROPS MULTI   Desk Select Code ȸ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2005/07/08 HIST 
	  */
	public String selDesk() {
		StringBuffer sql = new StringBuffer();
				
		sql.append(" Select Code_x, Desc_e");
		sql.append(" From Code_T");
		sql.append(" Where Step_x = '0'          And");
		sql.append(" 			Use_y  = 'N'          And");
		sql.append(" 			End_D  > To_Char(Sysdate,'yyyymmdd')");
		sql.append(" Order By Prty_no");
		
		Logger.debug.println("[BASE:IroA080Query:selDesk] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * IRR/DSS  IROPS MULTI   IROPS_DESK_T Է SQLԼ.
	  * @param params IroA010BG ȸ
	  * @return String Query  
	  * @author Copyright (c) 2005/07/08 HIST 
	  */
	public String insIropsDeskT(IroA010BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" Insert Into Irops_Desk_T");
		sql.append(" Values (To_Date('"+params.getFirst_leg_flt_dt()+"','yyyymmdd'),'KE','"+params.getFlt_num()+"','"+params.getStnfr()+"', '"+params.getStnto()+"','"+params.getSeq_num()+"', '"+params.getOption_num()+"',");
		sql.append("         '"+params.getDesk_x()+"', '4', ' ', ' ', '"+params.getEmp_no()+"', Sysdate)");
				
		Logger.debug.println("[BASE:IroA080Query:insIropsDeskT] sql : "+sql.toString());
		return sql.toString();
	}		
}
