package kal.base.iro.query;

import kal.base.jdf.com.Logger;
import kal.base.iro.dbbean.IroA110BG;
import kal.base.com.query.ComQ01Query;

 /**
   * IROPS REPORT SQL 
   * @author Copyright (c) 2005/02/01 
   */    
public class IroA110Query {
	private static IroA110Query instance = new IroA110Query();
	
	public static IroA110Query getInstance() {
		return instance;
	}
	/** 
	  * IROPS REPORT main ȸ SQLԼ.
	  * @param entity IroA110BG IROPS REPORT
	  * @return String Query 
	  * @author Copyright (c) 2005/02/01 
	  */
	public String selMain(IroA110BG entity){
		StringBuffer sql = new StringBuffer();

		sql.append(" Select C.Kor_n, A.Flt_Num, A.Stnfr, A.Stnto, To_Char(A.First_Leg_Flt_Dt,'yyyymmdd') First_Leg_Flt_Dt, ");
		sql.append(" 			To_Char(A.TimeStamp,'hh24miss'), A.Title_e, A.Decision_e, A.Seq_Num, A.Option_Num, A.User_Id ");
		sql.append(" From Irops_Sch_T A, Irops_Desk_T B, Password_T C  ");
		sql.append(" Where A.Arln_Cd = 'KE' And  ");
		sql.append(" 			A.First_Leg_Flt_Dt >= To_Date(To_Char(Sysdate-2,'yyyymmdd'),'yyyymmdd') And  ");
		sql.append(" 			A.Complete_y = 'Y'    And ");
		sql.append(" 			A.Hide_y     = 'N'    And ");
		sql.append(" 			A.Decision_c <> 'X'   And ");
		sql.append(" 			A.Arln_Cd  = B.Arln_Cd  And ");
		sql.append(" 			A.First_Leg_Flt_Dt = B.First_Leg_Flt_Dt And  ");
		sql.append(" 			A.Flt_Num = B.FLT_Num   And  ");
		sql.append(" 			A.Stnfr   = B.STNFR   And ");
		sql.append(" 			A.Stnto  = B.STnto     And ");
		sql.append(" 			A.Seq_Num = B.Seq_Num   And ");     
		sql.append(" 			A.Option_Num = B.Option_Num  And ");    
		sql.append(" 			B.User_Id    = C.Emp_no  And ");
		sql.append(" 			B.Desk_x = 'A'  And ");
		//NEW Flight ʺ̰ 
		sql.append("			A.Title_x != 'NEW' And");
		sql.append(" 			A.TimeStamp >= Sysdate-1 ");
		sql.append(" Order By 3 Desc, 1 ");
			
		Logger.debug.println("[BASE:IroA110Query:selMain] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * IROPS REPORT update SQLԼ.
	  * @param entity IroA110BG IROPS REPORT
	  * @return String Query 
	  * @author Copyright (c) 2005/02/01 
	  */
	public String updMain(IroA110BG entity){
		StringBuffer sql = new StringBuffer();
	
		sql.append(" Update Irops_Sch_T ");
		sql.append(" Set  Hide_y  = 'Y' ");
		sql.append(" Where Arln_Cd = 'KE' And  "); 
		sql.append(" 	First_Leg_Flt_Dt = To_Date('"+entity.getFirst_leg_flt_dt()+"','yyyymmdd') And  ");
		sql.append(" 	Flt_Num = '"+entity.getFlt_num()+"'   And  ");
		sql.append(" 	Stnfr   = '"+entity.getStnfr()+"'     And ");
		sql.append(" 	Stnto   = '"+entity.getStnto()+"'     And  ");
		sql.append(" 	Seq_Num = "+entity.getSeq_num()+"   And ");   
		sql.append(" 	Option_Num = "+entity.getOption_num()+" ");
			
		Logger.debug.println("[BASE:IroA110Query:updMain] sql : "+sql.toString());
		return sql.toString();
	}
}
