package kal.base.iro.query;

import kal.base.jdf.com.Logger;
import kal.base.iro.dbbean.*;
import kal.base.com.query.*;
import kal.base.com.util.*;

 /**
  * Decision Making & Action SQL 
  * @author Copyright (c) 2009/07/31  
  */   
public class IroA330Query {
	private static IroA330Query instance = new IroA330Query();
	
	public static IroA330Query getInstance() {
		return instance;
	}
	
	/** 
	  * DSS_IROPS_T  ȸ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2009/07/31 
	  */
	public String selDssIropsT(IroA330BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT KOR_N, TO_CHAR(IROPS_DT - 9/24,'YYYY/MM/DD HH24:MI') IROPS_DT, TITLE_E "); //2009.10.06  : IROPS_DT KST -> UTC
		sql.append(" FROM DSS_IROPS_T ");
		sql.append(" WHERE DSS_START_DT = TO_DATE('"+params.getDssStartDt()+"','YYYYMMDDHH24MISS') ");
		sql.append(" AND SEQ_NUM = "+params.getSeqNum());
		
		System.out.println("[BASE:IroA330Query:selDssIropsT] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * SKD  ȸ 1 - DAILY_SCH_T    Ȯ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2009/07/31 
	  */
	public String selDailySchT(IroA330BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT B.COMMENT_E, B.COMMENT_X, ");
		sql.append(" C.FLT_NUM, C.STNFR, C.STNTO, ");
		sql.append(" TO_CHAR(C.SCH_DEP_DT,'HH24:MI') SCH_DEP_DT, ");
		sql.append(" TO_CHAR(C.SCH_ARV_DT,'HH24:MI') SCH_ARV_DT, ");
		sql.append(" TO_CHAR(C.EST_DEP_DT,'HH24:MI') EST_DEP_DT, ");
		sql.append(" C.KACTYP, C.REGNO, ");
		sql.append(" C.F_CFG, C.C_CFG, C.Y_CFG, ROUTE_X CGO_X, ");
		sql.append(" C.DEL_RC1, C.DEL_DUR1, C.DEL_RC2, C.DEL_DUR2 ");
		sql.append(" FROM DSS_IROPS_T A, DSS_IROPS_SCH_T B, DAILY_SCH_T C ");
		sql.append(" WHERE B.DSS_START_DT = TO_DATE('"+params.getDssStartDt()+"','YYYYMMDDHH24MISS') ");
		sql.append(" AND B.SEQ_NUM = "+params.getSeqNum());
		sql.append(" AND B.DSS_START_DT = A.DSS_START_DT ");
		sql.append(" AND B.SEQ_NUM = A.SEQ_NUM ");
		sql.append(" AND B.ARLN_CD = C.ARLN_CD ");
		sql.append(" AND B.FIRST_LEG_FLT_DT = C.FIRST_LEG_FLT_DT ");
		sql.append(" AND B.FLT_NUM = C.FLT_NUM ");
		sql.append(" AND B.STNFR = C.STNFR ");
		
		//sql.append(" AND B.STNTO = C.STNTO "); 2009.12.03  : DIV  δ...
		sql.append(" AND C.STNFR <> C.STNTO ");
		
		sql.append(" AND A.PROCESS_X = 'C' ");
		sql.append(" ORDER BY C.SCH_DEP_DT ");
		
		System.out.println("[BASE:IroA330Query:selDailySchT] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * SKD  ȸ 2 - 1    DSS_NEW_SCH_T    Ȯ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2009/07/31 
	  */
	public String selDssNewSchT(IroA330BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT B.COMMENT_E, B.COMMENT_X, ");
		sql.append(" C.FLT_NUM, C.STNFR, C.STNTO, ");
		sql.append(" TO_CHAR(C.SCH_DEP_DT,'HH24:MI') SCH_DEP_DT, ");
		sql.append(" TO_CHAR(C.SCH_ARV_DT,'HH24:MI') SCH_ARV_DT, ");
		sql.append(" TO_CHAR(C.SCH_DEP_DT,'HH24:MI') EST_DEP_DT, ");
		sql.append(" C.KACTYP, C.REGNO, ");
		sql.append(" 0 F_CFG, 0 C_CFG, 0 Y_CFG, 'CGO' CGO_X, ");
		sql.append(" '' DEL_RC1, 0 DEL_DUR1, '' DEL_RC2, 0 DEL_DUR2 ");
		sql.append(" FROM DSS_IROPS_T A, DSS_IROPS_SCH_T B, DSS_NEW_SCH_T C ");
		sql.append(" WHERE B.DSS_START_DT = TO_DATE('"+params.getDssStartDt()+"','YYYYMMDDHH24MISS') ");
		sql.append(" AND B.SEQ_NUM = "+params.getSeqNum());
		sql.append(" AND B.DSS_START_DT = A.DSS_START_DT ");
		sql.append(" AND B.SEQ_NUM = A.SEQ_NUM ");
		sql.append(" AND B.ARLN_CD = C.ARLN_CD ");
		sql.append(" AND B.FIRST_LEG_FLT_DT = C.FIRST_LEG_FLT_DT ");
		sql.append(" AND B.FLT_NUM = C.FLT_NUM ");
		sql.append(" AND B.STNFR = C.STNFR ");
		sql.append(" AND B.STNTO = C.STNTO ");
		sql.append(" AND A.PROCESS_X = 'C' ");
		sql.append(" ORDER BY C.SCH_DEP_DT ");
		
		System.out.println("[BASE:IroA330Query:selDssNewSchT] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * DSS_IROPS_T  SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2009/08/13 
	  */
	public String updDssIropsT(IroA330BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" UPDATE DSS_IROPS_T ");
		sql.append(" SET DECISION_E = '"+params.getDecisionE()+"', ");
		sql.append(" PROCESS_X = '"+params.getArMode()+"', ");
		sql.append(" DSS_DT = SYSDATE "); 
		sql.append(" WHERE DSS_START_DT = TO_DATE('"+params.getDssStartDt()+"','YYYYMMDDHH24MISS') ");
		sql.append(" AND SEQ_NUM = "+params.getSeqNum());
		
		System.out.println("[BASE:IroA330Query:updDssIropsT] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * Approve , DSS_IROPS_DESK_T   Desk Ұ, , Է OK  SQLԼ.(1:OK, 2:Ұ, 3:, 4:Է) -> OK  ʰ ID, ̸, TIMESTAMP ־ش.
	  * @return String Query  
	  * @author Copyright (c) 2009/08/13 
	  */
	public String updDssIropsDeskT(IroA330BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" UPDATE DSS_IROPS_DESK_T ");
		sql.append(" SET USER_ID = '"+params.getEmpNo()+"', ");
		sql.append(" KOR_N = '"+params.getKorN()+"', ");
		sql.append(" TIMESTAMP = SYSDATE ");
		sql.append(" WHERE DSS_START_DT = TO_DATE('"+params.getDssStartDt()+"','YYYYMMDDHH24MISS') ");
		sql.append(" AND SEQ_NUM = "+params.getSeqNum());
		sql.append(" AND DECISION_X = '4' ");
		
		System.out.println("[BASE:IroA330Query:updDssIropsDeskT] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * MSG_NO, LVL_NO ȸ SQLԼ
	  * @return String Query  
	  * @author Copyright (c) 2009/08/13 
	  */
	public String selMsgNoLvlNo(IroA330BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT B.MSG_NO, B.LVL_NO ");
		sql.append(" FROM DSS_MSG_HEAD_T A, DSS_MSG_DETAIL_T B ");
		sql.append(" WHERE B.DSS_START_DT = TO_DATE('"+params.getDssStartDt()+"','YYYYMMDDHH24MISS') ");
		sql.append(" AND B.DSS_LVL_X = 'I' ");
		sql.append(" AND B.DSS_START_DT = A.DSS_START_DT ");
		
		System.out.println("[BASE:IroA330Query:selMsgNoLvlNo] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * MSG_NO ϱ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2009/08/13 
	  */
	public String selMsgNo(IroA330BG params, String msgNo, String lvlNo) {
		StringBuffer sql = new StringBuffer();
		
		if (lvlNo.equals("0")) {
			sql.append(" SELECT LTRIM(TO_CHAR(TO_NUMBER(NVL(MAX(MSG_NO),'00')) + 1,'00')) TMP_MSG_NO ");
		} else {
			sql.append(" SELECT SUBSTR(TO_NUMBER(NVL(MAX(MSG_NO),'100')) + 1,LENGTH(TO_NUMBER(NVL(MAX(MSG_NO),'100')) + 1)-1, 2) TMP_MSG_NO ");  
		}
		sql.append(" FROM DSS_MSG_DETAIL_T ");
		sql.append(" WHERE DSS_START_DT = TO_DATE('"+params.getDssStartDt()+"','YYYYMMDDHH24MISS') ");
		
		if (lvlNo.equals("0")) {
			
			sql.append(" AND MSG_NO BETWEEN '01' AND '99' ");
			sql.append(" AND LVL_NO = 1 ");
			
		} else {
			int intLvlNo = Integer.parseInt(lvlNo) + 1;
			
			sql.append(" AND MSG_NO BETWEEN '"+msgNo+"'||'01' AND '"+msgNo+"'||'99' ");
			sql.append(" AND LVL_NO = "+intLvlNo);
		}
		
		System.out.println("[BASE:IroA330Query:selMsgNo] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * DSS_MSG_HEAD_T  SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2009/08/13 
	  */
	public String updDssMsgHeadT(IroA330BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" UPDATE DSS_MSG_HEAD_T ");
		sql.append(" SET ");
		
		if (params.getArMode().equals("R")) sql.append(" DSS_LINK_X = 'R', "); //Reject ϶
		
		sql.append(" DSS_COMPLETE_Y = 'Y' ");
		sql.append(" WHERE DSS_START_DT = TO_DATE('"+params.getDssStartDt()+"','YYYYMMDDHH24MISS') ");
		
		System.out.println("[BASE:IroA330Query:updDssMsgHeadT] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * DSS_MSG_DETAIL_T  SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2009/08/13 
	  */
	public String updDssMsgDetailT(IroA330BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" UPDATE DSS_MSG_DETAIL_T ");
		sql.append(" SET DSS_LVL_X = 'S' ");
		sql.append(" WHERE DSS_START_DT = TO_DATE('"+params.getDssStartDt()+"','YYYYMMDDHH24MISS') ");
		sql.append(" AND DSS_LVL_X = 'I' ");
		
		System.out.println("[BASE:IroA330Query:updDssMsgDetailT] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * DSS_MSG_DETAIL_T Է SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2009/08/13 
	  */
	public String insDssMsgDetailT(IroA330BG params, String msgNo, String lvlNo) {
		StringBuffer sql = new StringBuffer();
		
		String dssLvlX = "";
		if (params.getArMode().equals("A")) dssLvlX = "Y";
		else dssLvlX = "R";
		
		sql.append(" INSERT INTO DSS_MSG_DETAIL_T (DSS_START_DT, MSG_NO, LVL_NO, DESK_X, MSG_E, USER_ID, KOR_N, DSS_LVL_X, TIMESTAMP) ");
		sql.append(" VALUES (TO_DATE('"+params.getDssStartDt()+"','YYYYMMDDHH24MISS'), '"+msgNo+"', "+lvlNo+", ");
		sql.append(" '"+params.getDeskX()+"', '"+params.getTitleE()+"', '"+params.getEmpNo()+"', '"+params.getKorN()+"', '"+dssLvlX+"', SYSDATE) ");
		
		System.out.println("[BASE:IroA330Query:insDssMsgDetailT] sql : "+sql.toString());
		return sql.toString();
	}
}