package kal.base.iro.query;

import kal.base.jdf.com.Logger;
import kal.base.iro.dbbean.*;
import kal.base.com.query.*;
import kal.base.com.util.*;

 /**
  * Message Board SQL 
  * @author Copyright (c) 2009/08/17  
  */   
public class IroA340Query {
	private static IroA340Query instance = new IroA340Query();
	
	public static IroA340Query getInstance() {
		return instance;
	}
	
	/** 
	  * IROPS SKD  ȸ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2009/08/17 
	  */
	public String selIropsSKD(IroA340BG params) {
		StringBuffer sql = new StringBuffer();
		/*
		sql.append(" SELECT A.TITLE_E, A.DECISION_E, ");
		sql.append(" B.COMMENT_X, B.COMMENT_E, B.ROUTE_X, ");
		sql.append(" B.FLT_NUM, B.STNFR, B.STNTO, ");
		sql.append(" TO_CHAR(B.SCH_DEP_DT,'DDMON') DDMON ");
		sql.append(" FROM DSS_IROPS_T A, DSS_IROPS_SCH_T B ");
		sql.append(" WHERE B.DSS_START_DT = TO_DATE('"+params.getDssStartDt()+"','YYYYMMDDHH24MISS') ");
		sql.append(" AND B.SEQ_NUM = "+params.getSeqNum());
		sql.append(" AND B.DSS_START_DT = A.DSS_START_DT ");
		sql.append(" AND B.SEQ_NUM = A.SEQ_NUM ");
		sql.append(" AND A.PROCESS_X = 'A' ");
		sql.append(" ORDER BY B.SCH_DEP_DT ");
		*/
		//2010.02.11  : SCH_DEP_DT_LOC ߰
		sql.append(" SELECT A.TITLE_E, A.DECISION_E, ");
		sql.append(" B.COMMENT_X, B.COMMENT_E, B.ROUTE_X, ");
		sql.append(" B.FLT_NUM, B.STNFR, B.STNTO, ");
		//sql.append(" TO_CHAR(B.SCH_DEP_DT,'DDMON') DDMON ");
		sql.append(" NVL(TO_CHAR(C.SCH_DEP_DT_LOC,'DDMON'), TO_CHAR(B.SCH_DEP_DT,'DDMON')||'(G)') DDMON ");
		sql.append(" FROM DSS_IROPS_T A, DSS_IROPS_SCH_T B, DAILY_SCH_T C ");
		sql.append(" WHERE B.DSS_START_DT = TO_DATE('"+params.getDssStartDt()+"','YYYYMMDDHH24MISS') ");
		sql.append(" AND B.SEQ_NUM = "+params.getSeqNum());
		sql.append(" AND B.DSS_START_DT = A.DSS_START_DT ");
		sql.append(" AND B.SEQ_NUM = A.SEQ_NUM ");
		sql.append(" AND A.PROCESS_X = 'A' ");
		sql.append(" AND B.ARLN_CD = C.ARLN_CD(+) ");
		sql.append(" AND B.FIRST_LEG_FLT_DT = C.FIRST_LEG_FLT_DT(+) ");
		sql.append(" AND B.FLT_NUM = C.FLT_NUM(+) ");
		sql.append(" AND B.LEG_NUM = C.LEG_NUM(+) ");
		sql.append(" AND B.STNFR = C.STNFR(+) ");
		sql.append(" AND B.STNTO = C.STNTO(+) ");
		sql.append(" AND C.DEP_STS(+) <> 'INI' ");
		sql.append(" ORDER BY B.SCH_DEP_DT ");
		
		System.out.println("[BASE:IroA340Query:selIropsSKD] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * SITA Address Book ȸ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2009/08/17 
	  */
	public String selSitaAddr(String portList) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT GROUP_C, ADDR_E ");
		sql.append(" FROM CM_GROUP_ADDR_T ");
		sql.append(" WHERE PROJECT_C = 'BASEDSS' ");
		//sql.append(" WHERE PROJECT_C = 'TEST' ");//2013-10-29 ӽü
		sql.append(" AND NETWORK_X = 'SITA' ");
		
		if (!portList.equals("")) sql.append(" AND GROUP_C IN ("+portList+") ");
		
		sql.append(" ORDER BY SEQ_NO ");
		
		System.out.println("[BASE:IroA340Query:selSitaAddr] sql : "+sql.toString());
		return sql.toString();
	}
	
	public String selEmailAddr(String portList) {//@2013-06-10 ߰
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT GROUP_C, ADDR_E ");
		sql.append(" FROM CM_GROUP_ADDR_T ");
		sql.append(" WHERE PROJECT_C = 'BASEDSS' ");//2013-10-29 ӽü
		//sql.append(" WHERE PROJECT_C = 'TEST' ");
		sql.append(" AND NETWORK_X = 'EMAIL' ");
		
		if (!portList.equals("")) sql.append(" AND GROUP_C IN ("+portList+") ");
		
		sql.append(" ORDER BY SEQ_NO ");
		
		System.out.println("[BASE:IroA340Query:selEmailAddr] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * DSS_IROPS_T  SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2009/08/19 
	  */
	public String updDssIropsT(IroA340BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" UPDATE DSS_IROPS_T ");
		sql.append(" SET PROCESS_X = 'M', ");
		sql.append(" MSG_DT = SYSDATE ");
		sql.append(" WHERE DSS_START_DT = TO_DATE('"+params.getDssStartDt()+"','YYYYMMDDHH24MISS') ");
		sql.append(" AND SEQ_NUM = "+params.getSeqNum());
		
		System.out.println("[BASE:IroA340Query:updDssIropsT] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * MSG_SEQ_NUM ȸ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2009/08/19 
	  */
	public String selNewNum(IroA340BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT NVL(MAX(MSG_SEQ_NUM), 0) + 1 NEW_NUM ");
		sql.append(" FROM DSS_IROPS_MSG_T ");
		sql.append(" WHERE DSS_START_DT = TO_DATE('"+params.getDssStartDt()+"','YYYYMMDDHH24MISS') ");
		sql.append(" AND SEQ_NUM = "+params.getSeqNum());
		
		System.out.println("[BASE:IroA340Query:selNewNum] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * DSS_IROPS_MSG_T Է SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2009/08/19 
	  */
	public String insDssIropsMsgT(IroA340BG params, String msgSeqNum) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" INSERT INTO DSS_IROPS_MSG_T (DSS_START_DT, SEQ_NUM, MSG_SEQ_NUM, PROCESSED, MESSAGE, TIMESTAMP) ");
		sql.append(" VALUES (TO_DATE('"+params.getDssStartDt()+"','YYYYMMDDHH24MISS'), "+params.getSeqNum()+", "+msgSeqNum+", 'N', '"+params.getMessage()+"', SYSDATE) ");
		
		System.out.println("[BASE:IroA340Query:insDssIropsMsgT] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * MS_TELEX_MSG_T Է SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2009/08/19 
	  */
	public String insMsTelexMsgTORG(IroA340BG params, String projectNo) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" INSERT INTO MS_TELEX_MSG_T (MSG_CAT, MSG_TMPST, UNI_SEQ, MSG_MAX, MSG_POS, ");
		sql.append(" ORIGIN_ADDR, MESSAGE, PRIORITY, PROJECT_NO, PROCESSED, ERROR_REPLY) ");
		sql.append(" VALUES ('BASEDSS', SYSDATE, UNI_SEQ.NEXTVAL, 1, 1, ");
		sql.append(" 'SELOCKE', '"+params.getMessage()+"',1, '"+projectNo+"', 'N', '') "); //<= PROCESSED = 'Y' ̸ ó ʴ´~
		
		System.out.println("[BASE:IroA340Query:insMsTelexMsgT] sql : "+sql.toString());
		return sql.toString();
	}
	//20150428 MHS
	public String insMsTelexMsgT(IroA340BG params, String projectNo, String mhsMessage) {
		
		mhsMessage = mhsMessage != null ? mhsMessage.replace("\"", "") : mhsMessage;
		
		StringBuffer sql = new StringBuffer();
		
		//sql.append(" INSERT INTO KFOS.MS_TELEX_MHS_T_TEST (MSG_CAT, MSG_TMPST, UNI_SEQ, MSG_MAX, MSG_POS, ");
		sql.append(" INSERT INTO KFOS.MS_TELEX_MHS_T (MSG_CAT, MSG_TMPST, UNI_SEQ, MSG_MAX, MSG_POS, ");
		sql.append(" ORIGIN_ADDR, MESSAGE, PRIORITY, PROJECT_NO, PROCESSED, ERROR_REPLY) ");
		sql.append(" VALUES ('BASEDSS', SYSDATE, UNI_SEQ.NEXTVAL, 1, 1, ");
		sql.append(" 'SELOCKE', '"+mhsMessage+"',1, '"+projectNo+"', 'N', '') "); //<= PROCESSED = 'Y' ̸ ó ʴ´~
		
		System.out.println("[BASE:IroA340Query:insMsTelexMsgT] sql : "+sql.toString());
		return sql.toString();
	}

	/** 
	  * PROCESSED ȸ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2009/08/19 
	  */
	public String selProcessedORG(IroA340BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT PROCESSED, NVL(ERROR_REPLY, 'A') ERROR_REPLY ");
		sql.append(" FROM MS_TELEX_MSG_T ");
		sql.append(" WHERE MSG_CAT = 'BASEDSS' ");
		sql.append(" AND MSG_TMPST >= SYSDATE - 1/24 ");
		sql.append(" AND MSG_TMPST <= SYSDATE ");
		sql.append(" AND PROJECT_NO = '"+params.getProjectNo()+"' ");
		
		System.out.println("[BASE:IroA340Query:selProcessed] sql : "+sql.toString());
		return sql.toString();
	}
	//20150428 MHS
	public String selProcessed(IroA340BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT PROCESSED, NVL(ERROR_REPLY, 'A') ERROR_REPLY ");
		//sql.append(" FROM KFOS.MS_TELEX_MHS_T_TEST ");
		sql.append(" FROM KFOS.MS_TELEX_MHS_T ");
		sql.append(" WHERE MSG_CAT = 'BASEDSS' ");
		sql.append(" AND MSG_TMPST >= SYSDATE - 1/24 ");
		sql.append(" AND MSG_TMPST <= SYSDATE ");
		sql.append(" AND PROJECT_NO = '"+params.getProjectNo()+"' ");
		
		System.out.println("[BASE:IroA340Query:selProcessed] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * PROCESSED  SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2009/08/19 
	  */
	public String updProcessed(IroA340BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" UPDATE DSS_IROPS_MSG_T ");
		sql.append(" SET PROCESSED = 'Y' ");
		sql.append(" WHERE DSS_START_DT = TO_DATE('"+params.getDssStartDt()+"','YYYYMMDDHH24MISS') ");
		sql.append(" AND SEQ_NUM = "+params.getSeqNum());
		sql.append(" AND MSG_SEQ_NUM = "+params.getMsgSeqNum());
		
		System.out.println("[BASE:IroA340Query:updProcessed] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * 20151021
	  * UMS  ߰
	  */
	public String selDssIropsMsgStr(IroA340BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT MESSAGE ");
		sql.append(" FROM DSS_IROPS_MSG_T ");
		sql.append(" WHERE DSS_START_DT = TO_DATE('" + params.getDssStartDt() + "', 'YYYYMMDDHH24MISS') ");
		sql.append(" AND SEQ_NUM = " + params.getSeqNum() + " ");
		sql.append(" AND MSG_SEQ_NUM = " + params.getMsgSeqNum() + " ");
		
		System.out.println("[BASE:IroA340Query:selIropsSKD] sql : "+sql.toString());
		return sql.toString();
	}
	
}
