package kal.base.iro.query;

import kal.base.com.util.SecurityUtil;
import kal.base.iro.dbbean.IroA810BG;
import kal.base.jdf.com.Logger;

/*	=====================================================================================
@Author		:	v.bgkim@kalmate.net
@Create		:	2013-10-07	Start designing
@end				:	2013-11-08
@Modify		:	
@Purpose		:		
=====================================================================================	*/
public class IroA810Query {
	/*-------------------------------------------------------------------	Constructor	Singleton
	----------------------------------------------------------------------	*/
	private static IroA810Query instance = new IroA810Query();	
	public static IroA810Query getInstance() {return instance;}
	/*-------------------------------------------------------------------	logPrint
	----------------------------------------------------------------------	*/
	private void  logPrint(StackTraceElement	currentStack, String sql){
		if(currentStack!=null){
			Logger.debug.println("======================================="+currentStack.getClassName() +"."+currentStack.getMethodName());
			Logger.debug.println(sql);
			Logger.debug.println("---------------------------------------");
		}		
	}
	private void  logPrint(String sql){
		logPrint(new Throwable().getStackTrace()[0],sql);
	}	
	/*-------------------------------------------------------------------	sel711DeskInfo
	----------------------------------------------------------------------	*/
	public String selIroA810Main(IroA810BG params){
		StringBuffer sql = new StringBuffer();
		
		sql.append("\n	SELECT ");
		sql.append("\n		A.PROJECT_C");
		sql.append("\n	,	A.NETWORK_X");
		sql.append("\n	,	A.GROUP_C");		
		sql.append("\n	,	SUBSTR(A.GROUP_C,1,3)	GROUP_SVC");
		sql.append("\n	,	SUBSTR(A.GROUP_C,5,3)	GROUP_DEP");
		sql.append("\n	,	SUBSTR(A.GROUP_C,9,3)	GROUP_ARV");
		sql.append("\n	,	A.SEQ_NO");
		sql.append("\n	,	A.REMARKS");
		sql.append("\n	,	TO_CHAR(A.TIMESTAMP,'YYYY-MM-DD HH24:MI')	TIMESTAMP");
		sql.append("\n	,	A.ADDR_E");		
		sql.append("\n	,	A.ENC_ADDR_E");	
		sql.append("\n	FROM ");
		sql.append("\n		CM_GROUP_ADDR_T		A");
		sql.append("\n	,	(");
		sql.append("\n			SELECT");
		sql.append("\n				'"+params.getProjectC()+"'	AS	p_project_c");
		sql.append("\n			,	'"+params.getNetworkX()+"'		AS	p_network_x");
		sql.append("\n			,	'"+params.getGroupSvc()+"'		AS	p_group_svc");
		sql.append("\n			,	'"+params.getGroupDep()+"'		AS	p_group_dep");
		sql.append("\n			,	'"+params.getGroupArv()+"'		AS	p_group_arv");
		sql.append("\n			FROM	DUAL");
		sql.append("\n		)	PARAM");
		sql.append("\n	WHERE ");
		sql.append("\n			A.PROJECT_C = PARAM.p_project_c ");//BASEDSS
		sql.append("\n	AND	A.NETWORK_X IN (PARAM.p_network_x) ");
		sql.append("\n	AND	(");
		sql.append("\n				PARAM.p_group_svc	IS	NULL");
		sql.append("\n			OR	INSTR(SUBSTR(A.GROUP_C,1,3),PARAM.p_group_svc)!=0");
		sql.append("\n			)");
		sql.append("\n	AND	(");
		sql.append("\n				PARAM.p_group_dep	IS	NULL");
		sql.append("\n			OR	INSTR(SUBSTR(A.GROUP_C,5,3),PARAM.p_group_dep)!=0");
		sql.append("\n			)");
		sql.append("\n	AND	(");
		sql.append("\n				PARAM.p_group_arv	IS	NULL");
		sql.append("\n			OR	INSTR(SUBSTR(A.GROUP_C,9,3),PARAM.p_group_arv)!=0");
		sql.append("\n			)");
		sql.append("\n	ORDER BY");
		sql.append("\n		SUBSTR(A.GROUP_C,5,3)");
		sql.append("\n	,	SUBSTR(A.GROUP_C,9,3)");
		sql.append("\n	,	SUBSTR(A.GROUP_C,1,3)");
		/*sql.append("\n		DECODE(PARAM.p_network_x,'SITA',SUBSTR(A.GROUP_C,5,3),'EMAIL',SUBSTR(A.GROUP_C,1,3),A.GROUP_C)");
		sql.append("\n	,	DECODE(PARAM.p_network_x,'SITA',SUBSTR(A.GROUP_C,9,3),'EMAIL',SUBSTR(A.GROUP_C,5,3),A.GROUP_C)");
		sql.append("\n	,	DECODE(PARAM.p_network_x,'SITA',SUBSTR(A.GROUP_C,1,3),'EMAIL',SUBSTR(A.GROUP_C,9,3),A.GROUP_C)");
*/
		//logPrint(new Throwable().getStackTrace()[0], sql.toString());
		logPrint(sql.toString());
		return	sql.toString();
	}
	/*-------------------------------------------------------------------	cntSeqNoIroA810
	----------------------------------------------------------------------	*/
	public String cntSeqNoIroA810(IroA810BG params){
		StringBuffer sql = new StringBuffer();
		
		sql.append("\n	SELECT NVL(COUNT(SEQ_NO),0) CNT");
		sql.append("\n	FROM KPMS.CM_GROUP_ADDR_T");
		sql.append("\n	WHERE");
		sql.append("\n				PROJECT_C		 =	'"+params.getProjectC()+"'");
		sql.append("\n	AND	NETWORK_X		 =	'"+params.getNetworkX()+"'");
		sql.append("\n	AND	GROUP_C			 =	'"+params.getGroupC()+"'");
		//sql.append("\n	AND	SEQ_NO			=	"+params.getSeqNo()+"");
		
		logPrint(sql.toString());
		return	sql.toString();
	}
	/*-------------------------------------------------------------------	maxSeqNoIroA810
	----------------------------------------------------------------------	*/
	public String maxSeqNoIroA810(IroA810BG params){
		StringBuffer sql = new StringBuffer();
		
		sql.append("\n	SELECT NVL(MAX(SEQ_NO),0) SEQ_NO");
		sql.append("\n	FROM KPMS.CM_GROUP_ADDR_T");
		sql.append("\n	WHERE");
		sql.append("\n				PROJECT_C		 =	'"+params.getProjectC()+"'");
		sql.append("\n	AND	NETWORK_X		 =	'"+params.getNetworkX()+"'");
		sql.append("\n	AND	GROUP_C			 =	'"+params.getGroupC()+"'");
		//sql.append("\n	AND	SEQ_NO			=	"+params.getSeqNo()+"");
		
		logPrint(sql.toString());
		return	sql.toString();
	}
	/*-------------------------------------------------------------------	insIroA810Main
	----------------------------------------------------------------------	*/
	public String insIroA810(IroA810BG params){
		StringBuffer sql = new StringBuffer();
		
		//2016.09.07 ȣȭ  ENC_ADDR_E
		String dec_mail_addr = SecurityUtil.self.encrypt(params.getAddrE(), "INT_EML");
		
		sql.append("\n	INSERT INTO KPMS.CM_GROUP_ADDR_T (PROJECT_C, NETWORK_X, GROUP_C, SEQ_NO, ADDR_E, ENC_ADDR_E, REMARKS, TIMESTAMP) ");
		sql.append("\n	VALUES (");
		sql.append("\n		'"+params.getProjectC()+"'");
		sql.append("\n	,	'"+params.getNetworkX()+"'");
		sql.append("\n	,	'"+params.getGroupC()+"'");
		sql.append("\n	,	"+params.getSeqNo()+"");
		sql.append("\n	,	'"+params.getAddrE()+"'");
		sql.append("\n	,	'"+dec_mail_addr+"'");
		sql.append("\n	,	'"+params.getRemarks()+"'");
		sql.append("\n	,	SYSDATE");
		sql.append("\n	)");
		
		logPrint(sql.toString());
		return	sql.toString();
	}
	/*-------------------------------------------------------------------	updIroA810
	----------------------------------------------------------------------	*/
	public String updIroA810(IroA810BG params){
		StringBuffer sql = new StringBuffer();
		
		//2016.09.07 ȣȭ  ENC_ADDR_E
		String dec_mail_addr = SecurityUtil.self.encrypt(params.getAddrE(), "INT_EML");
		
		
		sql.append("\n	UPDATE KPMS.CM_GROUP_ADDR_T");
		sql.append("\n	SET    ");		
		sql.append("\n		ADDR_E			 =	'"+params.getAddrE()+"'");
		//2016.09.07 ȣȭ ENC_ADDR_E
		sql.append("\n	,	ENC_ADDR_E		 =	'"+dec_mail_addr+"'");
		sql.append("\n	,	REMARKS			 =	'"+params.getRemarks()+"'");
		sql.append("\n	,	TIMESTAMP		 =	SYSDATE");
		sql.append("\n	WHERE");
		sql.append("\n		PROJECT_C		 =	'"+params.getProjectC()+"'");
		sql.append("\n	AND	NETWORK_X		 =	'"+params.getNetworkX()+"'");
		sql.append("\n	AND	GROUP_C			 =	'"+params.getGroupC()+"'");
		//sql.append("\n	AND	SEQ_NO		 =	"+params.getSeqNo()+"");
		
		logPrint(sql.toString());
		return	sql.toString();
	}
	
	//2016.09.07 ȣȭ ENC_ADDR_E
	/*-------------------------------------------------------------------	updIroA810
	----------------------------------------------------------------------	*/
	public String updIroA810_Enc(String ProjectC, String NetworkX, String GroupC, String AddrE){
		StringBuffer sql = new StringBuffer();
		
		//2016.09.07 ȣȭ 
		String dec_mail_addr = SecurityUtil.self.encrypt(AddrE, "INT_EML");
		
		sql.append("\n	UPDATE KPMS.CM_GROUP_ADDR_T");
		sql.append("\n	SET    ");		
		sql.append("\n		ENC_ADDR_E		 =	'"+dec_mail_addr+"'");
		sql.append("\n	WHERE");
		sql.append("\n		PROJECT_C		 =	'"+ProjectC+"'");
		sql.append("\n	AND	NETWORK_X		 =	'"+NetworkX+"'");
		sql.append("\n	AND	GROUP_C			 =	'"+GroupC+"'");
		
		logPrint(sql.toString());
		return	sql.toString();
	}
	
	/*-------------------------------------------------------------------	delIroA810
	----------------------------------------------------------------------	*/
	public String delIroA810(IroA810BG params){
		StringBuffer sql = new StringBuffer();
		
		sql.append("\n	DELETE FROM KPMS.CM_GROUP_ADDR_T");
		sql.append("\n	WHERE");
		sql.append("\n				PROJECT_C		 =	'"+params.getProjectC()+"'");
		sql.append("\n	AND	NETWORK_X		 =	'"+params.getNetworkX()+"'");
		sql.append("\n	AND	GROUP_C			 =	'"+params.getGroupC()+"'");
		//sql.append("\n	AND	SEQ_NO				 =	"+params.getSeqNo()+"");
		
		logPrint(sql.toString());
		return	sql.toString();
	}
}
