package kal.base.iro.query;

import kal.base.jdf.com.Logger;
import kal.base.iro.dbbean.*;
import kal.base.com.query.*;
import kal.base.com.util.*;

 /**
  * DSS Messenger SQL 
  * @author Copyright (c) 2009/08/31  
  */ 
public class IroQ450Query {
	private static IroQ450Query instance = new IroQ450Query();
	
	public static IroQ450Query getInstance() {
		return instance;
	}
	
	/** 
	  * DSS Messenger ȸ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2009/08/31 
	  */
	public String selMain(IroQ450BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT A.TITLE_E, B.MSG_E, C.CODE_X, B.KOR_N, A.FLT_NUM, A.SCH_DEP_D, ");
		sql.append(" TO_CHAR(B.TIMESTAMP - 9/24,'YYMMDD HH24:MI') TIMESTAMP, "); //2009.10.07  : TIMESTAMP KST -> UTC
		sql.append(" TO_CHAR(B.DSS_START_DT,'YYYYMMDDHH24MISS') DSS_START_DT, B.MSG_NO, B.LVL_NO, B.DSS_LVL_X ");
		sql.append(" FROM DSS_MSG_HEAD_T A, DSS_MSG_DETAIL_T B, CODE_T C, ");
		sql.append(" (SELECT D.DSS_START_DT ");
		sql.append(" FROM DSS_MSG_HEAD_T D, DSS_MSG_DETAIL_T E ");
		sql.append(" WHERE E.TIMESTAMP >= TO_DATE('20"+params.getTimestamp()+" 000000','YYYYMMDD HH24MISS') ");
		sql.append(" AND E.TIMESTAMP <= TO_DATE('20"+params.getTimestamp()+" 235959','YYYYMMDD HH24MISS') ");
		sql.append(" AND E.DSS_START_DT = D.DSS_START_DT ");
		
		if (!params.getTitle().equals("")) {
			sql.append(" AND D.TITLE_E LIKE '%"+params.getTitle()+"%' ");
		}
		
		if (params.getGubun().equals("IROPS")) {
			sql.append(" AND D.DSS_LINK_X <> 'M' ");
			
		} else if (params.getGubun().equals("MSG")) {
			sql.append(" AND D.DSS_LINK_X = 'M' "); 
		} 
		
		sql.append(" GROUP BY D.DSS_START_DT) F ");
		sql.append(" WHERE F.DSS_START_DT = A.DSS_START_DT ");
		sql.append(" AND A.DSS_START_DT = B.DSS_START_DT ");
		sql.append(" AND B.DESK_X = C.DESC_E(+) ");
		sql.append(" AND C.STEP_X(+) = '0' ");
		sql.append(" AND C.USE_Y(+) = 'N' ");
		sql.append(" AND C.CODE_C(+) = 'Head' ");
		//sql.append(" AND C.END_D(+) > TO_CHAR(SYSDATE,'YYYYMMDD') ");
		sql.append(" ORDER BY A.DSS_START_DT, B.MSG_NO, B.LVL_NO ");
		
		System.out.println("[BASE:IroQ450Query:selMain] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * IROPS Creation Info & DSS Messenger Msg ߻ ȸ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2009/09/04 
	  */
	public String selDssMsg() {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT TO_CHAR(A.DSS_START_DT, 'YYYYMMDDHH24MISS') DSS_START_DT, ");
		sql.append(" A.MSG_NO, NVL(C.TITLE_E, B.TITLE_E) TITLE_E, A.DSS_LVL_X, ");
		sql.append(" A.MSG_E ");//2012.02.27߰ : Alert APO  ޽ Ȯ  ߰
		sql.append(" FROM DSS_MSG_DETAIL_T A, DSS_MSG_HEAD_T B, DSS_IROPS_T C ");
		sql.append(" WHERE A.TIMESTAMP >= SYSDATE - (1/1440) "); //1
		sql.append(" AND A.DSS_START_DT = B.DSS_START_DT ");
		sql.append(" AND A.DSS_START_DT = C.DSS_START_DT(+) ");
		sql.append(" AND C.SEQ_NUM(+) = 1 ");
		sql.append(" ORDER BY A.TIMESTAMP ");
	
		//System.out.println("[BASE:IroQ450Query:selDssMsg] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * IROPS Creation Info  شϴ  ȸ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2009/12/02 
	  */
	public String selFltNum(String dssStartDt) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT FLT_NUM, TO_CHAR(SCH_DEP_DT, 'DDMONYY') SCH_DEP_DT ");
		sql.append(" FROM DSS_IROPS_SCH_T A, ");
		sql.append(" (SELECT MAX(SEQ_NUM) B_SEQ_NUM ");
		sql.append(" FROM DSS_IROPS_T ");
		sql.append(" WHERE DSS_START_DT = TO_DATE('"+dssStartDt+"','YYYYMMDDHH24MISS') ");
		sql.append(" GROUP BY SEQ_NUM) B ");
		sql.append(" WHERE A.DSS_START_DT = TO_DATE('"+dssStartDt+"','YYYYMMDDHH24MISS') ");
		sql.append(" AND A.SEQ_NUM = B_SEQ_NUM ");
	
		//System.out.println("[BASE:IroQ450Query:selFltNum] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  *  IROPS Issue ܰ Ȯϴ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2009/09/07 
	  */
	public String chkIssue(IroQ450BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT SEQ_NUM ");
		sql.append(" FROM DSS_IROPS_T ");
		sql.append(" WHERE DSS_START_DT = TO_DATE('"+params.getDssStartDt()+"','YYYYMMDDHH24MISS') ");
		sql.append(" AND PROCESS_X = '"+params.getProcessX()+"' ");
	
		System.out.println("[BASE:IroQ450Query:chkIssue] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * Message ȸ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2009/09/07 
	  */
	public String selMessage(IroQ450BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT A.TITLE_E, B.MSG_E, C.CODE_X, A.FLT_NUM, A.SCH_DEP_D, ");
		sql.append(" TO_CHAR(B.TIMESTAMP,'HH24:MI:SS') TIMESTAMP, B.LVL_NO ");
		//20160108 DSS_LVL_X ߰
		sql.append(" , B.DSS_LVL_X ");	
		sql.append(" ,	B.KOR_N ");//@2017-10-30
		sql.append(" FROM DSS_MSG_HEAD_T A, DSS_MSG_DETAIL_T B, CODE_T C ");
		sql.append(" WHERE B.DSS_START_DT = TO_DATE('"+params.getDssStartDt()+"','YYYYMMDDHH24MISS') ");
		sql.append(" AND B.MSG_NO = '"+params.getMsgNo()+"' ");
		sql.append(" AND B.DSS_START_DT = A.DSS_START_DT ");
		sql.append(" AND B.DESK_X = C.DESC_E(+) ");
		sql.append(" AND C.STEP_X(+) = '0' ");
		sql.append(" AND C.USE_Y(+) = 'N' ");
		sql.append(" AND C.CODE_C(+) = 'Head' ");
		//sql.append(" AND C.END_D(+) > TO_CHAR(SYSDATE,'YYYYMMDD') ");
	
		System.out.println("[BASE:IroQ450Query:selMessage] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * DSS_LINK_X, DSS_COMPLETE_Y ȸ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2009/09/08 
	  */
	public String chkComplete(IroQ450BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT DSS_LINK_X, DSS_COMPLETE_Y ");
		sql.append(" FROM DSS_MSG_HEAD_T ");
		sql.append(" WHERE DSS_START_DT = TO_DATE('"+params.getDssStartDt()+"','YYYYMMDDHH24MISS') ");
	
		System.out.println("[BASE:IroQ450Query:chkComplete] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * DSS_START_DT ϴ FLT_NUM SCH_DEP_D ȸ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2009/09/10 
	  */
	public String selDssStartDt(IroQ450BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT TO_CHAR(DSS_START_DT,'YYYYMMDDHH24MISS') DSS_START_DT, TITLE_E ");
		sql.append(" FROM DSS_MSG_HEAD_T ");
		sql.append(" WHERE FLT_NUM = '"+params.getFltNum()+"' ");
		sql.append(" AND SCH_DEP_D = '"+params.getSchDepD()+"' ");
		sql.append(" AND (DSS_LINK_X <> 'L' ");
		sql.append(" OR DSS_COMPLETE_Y <> 'Y') ");
	
		System.out.println("[BASE:IroQ450Query:selDssStartDt] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * DSS_MSG_HEAD_T Է SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2009/09/10 
	  */
	public String insDssMsgHeadT(IroQ450BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" INSERT INTO DSS_MSG_HEAD_T (DSS_START_DT, TITLE_E, FLT_NUM, SCH_DEP_D, DSS_LINK_X, DSS_COMPLETE_Y) ");
		sql.append(" VALUES (TO_DATE('"+params.getDssStartDt()+"','YYYYMMDDHH24MISS'), '"+params.getTitleE()+"', '"+params.getFltNum()+"', '"+params.getSchDepD()+"', 'M', 'N') ");
		
		System.out.println("[BASE:IroQ450Query:insDssMsgHeadT] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * DSS_MSG_HEAD_T FLT_NUM SCH_DEP_D Է
	  * @return String Query  
	  * @author Copyright (c) 2009/09/10 
	  */
	public String updFltNum(IroQ450BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" UPDATE DSS_MSG_HEAD_T ");
		sql.append(" SET FLT_NUM = '"+params.getFltNum()+"', ");
		sql.append(" SCH_DEP_D = '"+params.getSchDepD()+"' ");
		sql.append(" WHERE DSS_START_DT = TO_DATE('"+params.getDssStartDt()+"','YYYYMMDDHH24MISS') ");
	
		System.out.println("[BASE:IroQ450Query:updFltNum] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * IROPS Ȳ ȸ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2009/09/10 
	  */
	public String selIropsStatus(IroQ450BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT DSS_LINK_X ");
		sql.append(" FROM DSS_MSG_HEAD_T ");
		sql.append(" WHERE DSS_START_DT = TO_DATE('"+params.getDssStartDt()+"','YYYYMMDDHH24MISS') ");
		sql.append(" AND (DSS_LINK_X <> 'L' ");
		sql.append(" OR DSS_COMPLETE_Y <> 'Y') ");
	
		System.out.println("[BASE:IroQ450Query:selIropsStatus] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * MSG_NO ϱ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2009/09/10 
	  */
	public String selMsgNo(IroQ450BG params) {
		StringBuffer sql = new StringBuffer();
		
		if (params.getLvlNo().equals("0")) {
			sql.append(" SELECT LTRIM(TO_CHAR(TO_NUMBER(NVL(MAX(MSG_NO),'00')) + 1,'00')) TMP_MSG_NO ");
		} else {
			sql.append(" SELECT SUBSTR(TO_NUMBER(NVL(MAX(MSG_NO),'100')) + 1,LENGTH(TO_NUMBER(NVL(MAX(MSG_NO),'100')) + 1)-1, 2) TMP_MSG_NO ");  
		}
		sql.append(" FROM DSS_MSG_DETAIL_T ");
		sql.append(" WHERE DSS_START_DT = TO_DATE('"+params.getDssStartDt()+"','YYYYMMDDHH24MISS') ");
		
		if (params.getLvlNo().equals("0")) {
			
			sql.append(" AND MSG_NO BETWEEN '01' AND '99' ");
			sql.append(" AND LVL_NO = 1 ");
			
		} else {
			int intLvlNo = Integer.parseInt(params.getLvlNo()) + 1;
			
			sql.append(" AND MSG_NO BETWEEN '"+params.getMsgNo()+"'||'01' AND '"+params.getMsgNo()+"'||'99' ");
			sql.append(" AND LVL_NO = "+intLvlNo);
		}
		
		System.out.println("[BASE:IroQ450Query:selMsgNo] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * DSS_MSG_DETAIL_T Է SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2009/09/10 
	  */
	public String insDssMsgDetailT(IroQ450BG params, String msgNo, String lvlNo) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" INSERT INTO DSS_MSG_DETAIL_T (DSS_START_DT, MSG_NO, LVL_NO, DESK_X, MSG_E, USER_ID, KOR_N, DSS_LVL_X, TIMESTAMP) ");
		sql.append(" VALUES (TO_DATE('"+params.getDssStartDt()+"','YYYYMMDDHH24MISS'), '"+msgNo+"', "+lvlNo+", ");
		sql.append(" '"+params.getDeskX()+"', '"+params.getMsgE()+"', '"+params.getEmpNo()+"', '"+params.getKorN()+"', 'M', SYSDATE) ");
		
		System.out.println("[BASE:IroQ450Query:insDssMsgDetailT] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * 20160108 ߰
	  * DSS_LVL_X = A
	  */
	public String insDssMsgDetailTDssLvlXA(IroQ450BG params, String msgNo, String lvlNo) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" INSERT INTO DSS_MSG_DETAIL_T (DSS_START_DT, MSG_NO, LVL_NO, DESK_X, MSG_E, USER_ID, KOR_N, DSS_LVL_X, TIMESTAMP) ");
		sql.append(" VALUES (TO_DATE('"+params.getDssStartDt()+"','YYYYMMDDHH24MISS'), '"+msgNo+"', "+lvlNo+", ");
		sql.append(" '"+params.getDeskX()+"', '"+params.getMsgE()+"', '"+params.getEmpNo()+"', '"+params.getKorN()+"', 'A', SYSDATE) ");
		
		System.out.println("[BASE:IroQ450Query:insDssMsgDetailTDssLvlXA] sql : "+sql.toString());
		return sql.toString();
	}
}
