package kal.base.iro.query;
/*	=====================================================================================
	@Author		:	v.bgkim@kalmate.net
	@Create		:	2013-10-07	Start designing
	@end				:	2013-11-08
	@Modify		:	
	@Purpose		:		
	=====================================================================================	*/
import java.util.Locale;

import kal.base.iro.dbbean.IroQ710BG;
import kal.base.jdf.com.Logger;

public class IroQ710Query {
	/*-------------------------------------------------------------------	Constructor	Singleton
	----------------------------------------------------------------------	*/
	private static IroQ710Query instance = new IroQ710Query();	
	public static IroQ710Query getInstance() {return instance;}
	/*-------------------------------------------------------------------	logPrint
	----------------------------------------------------------------------	*/
	private void  logPrint(StackTraceElement	currentStack, String sql){
		if(currentStack!=null){
			Logger.debug.println("======================================="+currentStack.getClassName() +"."+currentStack.getMethodName());
			Logger.debug.println(sql);
			Logger.debug.println("---------------------------------------");
		}		
	}
	/*-------------------------------------------------------------------	fltNumFilter
	----------------------------------------------------------------------	*/
	private String  fltNumFilter(String fltNum){
		String	newFltNum	=	(fltNum==null)?"":fltNum.toUpperCase(Locale.UK);
		if(newFltNum.length()!=0){			
			int	max	=	4;
			if(newFltNum.replaceAll("[0-9]","").length()!=0){//alphabat
				max	=	5;
			}
			for(int i=newFltNum.length(); i<max; i++){
				newFltNum	=	"0"+newFltNum;
			}
		}
		return newFltNum;
	}
	/*-------------------------------------------------------------------	sel710Main
	----------------------------------------------------------------------	*/
	public String sel710Main(IroQ710BG params, String[] fltNumArray){
		StringBuffer sql = new StringBuffer();

		sql.append("\n	SELECT    ");
		sql.append("\n		DSS_START_DT");
		sql.append("\n	,	SEQ_NUM");
		sql.append("\n	,	TITLE_E");
		sql.append("\n	,	SUBSTR(MAX(SYS_CONNECT_BY_PATH(FLT_NUM, ',')), 2) AS FLT_NUM");
		sql.append("\n	,	PROCESS_X");
		sql.append("\n	,	DECISION_E");
		sql.append("\n	,	IROPS_DT");
		sql.append("\n	,	DSS_DT");
		sql.append("\n	FROM");
		sql.append("\n	(");
		sql.append("\n		SELECT");
		sql.append("\n			RESULT.*");
		sql.append("\n		,	ROW_NUMBER() OVER(");
		sql.append("\n				PARTITION BY RESULT.DSS_START_DT,RESULT.SEQ_NUM ");
		sql.append("\n				ORDER BY RESULT.FLT_NUM");
		sql.append("\n			) AS RNUM");
		sql.append("\n		FROM");
		sql.append("\n		(");
		sql.append("\n			SELECT ");
		sql.append("\n				TO_CHAR(A.DSS_START_DT, 'YYYYMMDDHH24MISS') DSS_START_DT");
		sql.append("\n			,	A.SEQ_NUM");
		sql.append("\n			,	B.FLT_NUM");
		sql.append("\n			,	A.TITLE_E");
		sql.append("\n			,	A.PROCESS_X");
		sql.append("\n			,	A.DECISION_E");
		sql.append("\n			,	TO_CHAR(A.IROPS_DT - 9/24, 'YYMMDD HH24:MI') IROPS_DT");
		sql.append("\n			,	TO_CHAR(A.DSS_DT - 9/24, 'YYMMDD HH24:MI') DSS_DT");
		sql.append("\n			FROM ");
		sql.append("\n				DSS_IROPS_T A");
		sql.append("\n			,	DSS_IROPS_SCH_T B");
		sql.append("\n			WHERE ");
		sql.append("\n				TO_CHAR(A.IROPS_DT,'YYMMDD')		=	'"+params.getIropsDt()+"'");
		sql.append("\n			AND	B.DSS_START_DT		=	A.DSS_START_DT ");
		sql.append("\n			AND	B.SEQ_NUM			=	A.SEQ_NUM  ");
		sql.append("\n			AND	A.PROCESS_X		IN ('R')  ");
		if(fltNumArray!=null) {
			String	result		=	"";
			String	fltNum		=	null;
			for(int i=0; i<fltNumArray.length; i++){
				fltNum	=	fltNumFilter(fltNumArray[i]);				
				result	+=	(result.length()==0 || fltNum.length()==0)?"":",";
				result	+=	(fltNum.length()==0)?"":"'"+fltNum+"'"	;
			}
			if(result.length()!=0){
				sql.append("\n			AND	B.FLT_NUM			IN ("+result+")  ");
			}
		}
		if(params.getDecisionE().length()!=0) {
			sql.append("\n			AND	A.DECISION_E		LIKE	 '%"+params.getDecisionE()+"%'");
		}
		sql.append("\n		)	RESULT");
		sql.append("\n	)");
		sql.append("\n	START WITH RNUM = 1");
		sql.append("\n	CONNECT BY PRIOR RNUM = RNUM - 1 AND PRIOR DSS_START_DT=DSS_START_DT AND SEQ_NUM=SEQ_NUM");
		sql.append("\n	GROUP BY ");
		sql.append("\n		DSS_START_DT");
		sql.append("\n	,	SEQ_NUM");
		sql.append("\n	,	TITLE_E");
		sql.append("\n	,	PROCESS_X");
		sql.append("\n	,	DECISION_E");
		sql.append("\n	,	IROPS_DT");
		sql.append("\n	,	DSS_DT");
		sql.append("\n	ORDER BY	IROPS_DT");
		
		logPrint(new Throwable().getStackTrace()[0], sql.toString());
		return	sql.toString();
	}
	/*-------------------------------------------------------------------	sel711Main1
	----------------------------------------------------------------------	*/
	public String sel711Main1(IroQ710BG params){
		StringBuffer sql = new StringBuffer();
		
		sql.append("\n	SELECT  ");
		sql.append("\n		TO_CHAR(MANAGER_D2 - 9/24,	'YYYY/MM/DD HH24:MI') OCC");
		sql.append("\n	,	TO_CHAR(MANAGER_D1 - 9/24,	'YYYY/MM/DD HH24:MI') GOC");
		sql.append("\n	,	A.DECISION_E");
		sql.append("\n	,	A.KOR_N");
		sql.append("\n	,	A.TITLE_E");
		sql.append("\n	,	TO_CHAR(A.IROPS_DT - 9/24,	'YYYY/MM/DD HH24:MI') IROPS_DT");
		sql.append("\n	,	TO_CHAR(A.DSS_DT - 9/24,	'YYYY/MM/DD HH24:MI') DSS_DT");
		sql.append("\n	,	C.FLT_NUM");
		sql.append("\n	,	C.KACTYP");
		sql.append("\n	,	C.REGNO");
		sql.append("\n	,	C.STNFR");
		sql.append("\n	,	C.STNTO");
		sql.append("\n  ,	TO_CHAR(C.SCH_DEP_DT, 'DDMON','NLS_DATE_LANGUAGE=AMERICAN') SCH_DEP_DM "); // 2017.04.12 ߰
		sql.append("\n	,	TO_CHAR(C.SCH_DEP_DT, 'HH24:MI') SCH_DEP_DT");
		sql.append("\n	,	TO_CHAR(C.SCH_ARV_DT, 'HH24:MI') SCH_ARV_DT");
		sql.append("\n	,	TO_CHAR(C.EST_DEP_DT, 'HH24:MI') EST_DEP_DT");
		sql.append("\n	,	C.F_BOOK");
		sql.append("\n	,	C.C_BOOK");
		sql.append("\n	,	C.Y_BOOK");
		sql.append("\n	,	ROUTE_X CGO_X");
		sql.append("\n	,	B.COMMENT_X");
		sql.append("\n	,	B.COMMENT_E");
		sql.append("\n	,	C.DEL_RC1");
		sql.append("\n	,	C.DEL_DUR1");
		sql.append("\n	,	C.DEL_RC2");
		sql.append("\n	,	C.DEL_DUR2  ");
		sql.append("\n	FROM");
		sql.append("\n		DSS_IROPS_T A");
		sql.append("\n	,	DSS_IROPS_SCH_T B");
		sql.append("\n	,	DAILY_SCH_T C ");
		sql.append("\n	WHERE ");
		sql.append("\n	B.DSS_START_DT = TO_DATE('"+params.getDssStartDt()+"',	'YYYYMMDDHH24MISS')  ");
		sql.append("\n	AND B.SEQ_NUM = "+params.getSeqNum());
		sql.append("\n	AND B.DSS_START_DT = A.DSS_START_DT  ");
		sql.append("\n	AND B.SEQ_NUM = A.SEQ_NUM  ");
		sql.append("\n	AND B.ARLN_CD = C.ARLN_CD  ");
		sql.append("\n	AND B.FIRST_LEG_FLT_DT = C.FIRST_LEG_FLT_DT  ");
		sql.append("\n	AND B.FLT_NUM = C.FLT_NUM  ");
		sql.append("\n	AND B.STNFR = C.STNFR  ");
		sql.append("\n	AND B.STNTO = C.STNTO ");
		sql.append("\n	AND A.PROCESS_X IN ('R')  ");
		sql.append("\n	ORDER BY ");
		sql.append("\n		C.SCH_DEP_DT");

		logPrint(new Throwable().getStackTrace()[0], sql.toString());
		return	sql.toString();
	}
	/*-------------------------------------------------------------------	sel711Main2
	----------------------------------------------------------------------	*/
	public String sel711Main2(IroQ710BG params){
		StringBuffer sql = new StringBuffer();
		
		sql.append("\n	SELECT  ");
		sql.append("\n		TO_CHAR(MANAGER_D2 - 9/24,	'YYYY/MM/DD HH24:MI') OCC");
		sql.append("\n	,	TO_CHAR(MANAGER_D1 - 9/24,	'YYYY/MM/DD HH24:MI') GOC");
		sql.append("\n	,	A.DECISION_E");
		sql.append("\n	,	A.KOR_N");
		sql.append("\n	,	A.TITLE_E");
		sql.append("\n	,	TO_CHAR(A.IROPS_DT - 9/24,	'YYYY/MM/DD HH24:MI') IROPS_DT");
		sql.append("\n	,	TO_CHAR(A.DSS_DT - 9/24,	'YYYY/MM/DD HH24:MI') DSS_DT");
		sql.append("\n	,	C.FLT_NUM");
		sql.append("\n	,	C.KACTYP");
		sql.append("\n	,	C.REGNO");
		sql.append("\n	,	C.STNFR");
		sql.append("\n	,	C.STNTO");
		sql.append("\n  ,	TO_CHAR(C.SCH_DEP_DT, 'DDMON','NLS_DATE_LANGUAGE=AMERICAN') SCH_DEP_DM "); // 2017.04.12 ߰
		sql.append("\n	,	TO_CHAR(C.SCH_DEP_DT, 'HH24:MI') SCH_DEP_DT");
		sql.append("\n	,	TO_CHAR(C.SCH_ARV_DT, 'HH24:MI') SCH_ARV_DT");
		sql.append("\n	,	TO_CHAR(C.SCH_DEP_DT, 'HH24:MI') EST_DEP_DT");
		sql.append("\n	,	0	F_BOOK");//compare with sel711Main1 
		sql.append("\n	,	0	C_BOOK");//compare with sel711Main1 
		sql.append("\n	,	0	Y_BOOK");//compare with sel711Main1 
		sql.append("\n	,	'CGO' CGO_X");//compare with sel711Main1 
		sql.append("\n	,	B.COMMENT_X");
		sql.append("\n	,	B.COMMENT_E");
		sql.append("\n	,	''	DEL_RC1");//compare with sel711Main1 
		sql.append("\n	,	0	DEL_DUR1");//compare with sel711Main1 
		sql.append("\n	,	''	DEL_RC2");//compare with sel711Main1 
		sql.append("\n	,	0	DEL_DUR2  ");//compare with sel711Main1 
		sql.append("\n	FROM");
		sql.append("\n		DSS_IROPS_T A");
		sql.append("\n	,	DSS_IROPS_SCH_T B");
		sql.append("\n	,	DSS_NEW_SCH_T C ");//compare with sel711Main1 
		sql.append("\n	WHERE ");
		sql.append("\n	B.DSS_START_DT = TO_DATE('"+params.getDssStartDt()+"',	'YYYYMMDDHH24MISS')  ");
		sql.append("\n	AND B.SEQ_NUM = "+params.getSeqNum());
		sql.append("\n	AND B.DSS_START_DT = A.DSS_START_DT  ");
		sql.append("\n	AND B.SEQ_NUM = A.SEQ_NUM  ");
		sql.append("\n	AND B.ARLN_CD = C.ARLN_CD  ");
		sql.append("\n	AND B.FIRST_LEG_FLT_DT = C.FIRST_LEG_FLT_DT  ");
		sql.append("\n	AND B.FLT_NUM = C.FLT_NUM  ");
		sql.append("\n	AND B.STNFR = C.STNFR  ");
		sql.append("\n	AND B.STNTO = C.STNTO ");
		sql.append("\n	AND A.PROCESS_X IN ('R')  ");
		sql.append("\n	ORDER BY ");
		sql.append("\n		C.SCH_DEP_DT");

		logPrint(new Throwable().getStackTrace()[0], sql.toString());
		return	sql.toString();
	}
	/*-------------------------------------------------------------------	sel711Main3
	----------------------------------------------------------------------	*/
	public String sel711Main3(IroQ710BG params){
		StringBuffer sql = new StringBuffer();
		
		sql.append("\n	SELECT  ");
		sql.append("\n		TO_CHAR(MANAGER_D2 - 9/24,	'YYYY/MM/DD HH24:MI') OCC");
		sql.append("\n	,	TO_CHAR(MANAGER_D1 - 9/24,	'YYYY/MM/DD HH24:MI') GOC");
		sql.append("\n	,	A.DECISION_E");
		sql.append("\n	,	A.KOR_N");
		sql.append("\n	,	A.TITLE_E");
		sql.append("\n	,	TO_CHAR(A.IROPS_DT - 9/24,	'YYYY/MM/DD HH24:MI') IROPS_DT");
		sql.append("\n	,	TO_CHAR(A.DSS_DT - 9/24,	'YYYY/MM/DD HH24:MI') DSS_DT");
		sql.append("\n	,	C.FLT_NUM");
		sql.append("\n	,	C.KACTYP");
		sql.append("\n	,	C.REGNO");
		sql.append("\n	,	C.STNFR");
		sql.append("\n	,	C.STNTO");
		sql.append("\n  ,	TO_CHAR(C.SCH_DEP_DT, 'DDMON','NLS_DATE_LANGUAGE=AMERICAN') SCH_DEP_DM "); // 2017.04.12 ߰
		sql.append("\n	,	TO_CHAR(C.SCH_DEP_DT,		'HH24:MI') SCH_DEP_DT");
		sql.append("\n	,	TO_CHAR(C.SCH_ARV_DT,	'HH24:MI') SCH_ARV_DT");
		sql.append("\n	,	TO_CHAR(C.EST_DEP_DT,		'HH24:MI') EST_DEP_DT");
		sql.append("\n	,	C.F_BOOK");
		sql.append("\n	,	C.C_BOOK");
		sql.append("\n	,	C.Y_BOOK");
		sql.append("\n	,	ROUTE_X CGO_X");
		sql.append("\n	,	B.COMMENT_X");
		sql.append("\n	,	B.COMMENT_E");
		sql.append("\n	,	C.DEL_RC1");
		sql.append("\n	,	C.DEL_DUR1");
		sql.append("\n	,	C.DEL_RC2");
		sql.append("\n	,	C.DEL_DUR2  ");
		sql.append("\n	FROM");
		sql.append("\n		DSS_IROPS_T A");
		sql.append("\n	,	DSS_IROPS_SCH_T B");
		sql.append("\n	,	DAILY_SCH_T C ");
		sql.append("\n	WHERE ");
		sql.append("\n	B.DSS_START_DT = TO_DATE('"+params.getDssStartDt()+"',	'YYYYMMDDHH24MISS')  ");
		sql.append("\n	AND B.SEQ_NUM = "+params.getSeqNum());
		sql.append("\n	AND B.DSS_START_DT = A.DSS_START_DT  ");
		sql.append("\n	AND B.SEQ_NUM = A.SEQ_NUM  ");
		sql.append("\n	AND B.ARLN_CD = C.ARLN_CD  ");
		sql.append("\n	AND B.FIRST_LEG_FLT_DT = C.FIRST_LEG_FLT_DT  ");
		sql.append("\n	AND B.FLT_NUM = C.FLT_NUM  ");
		sql.append("\n	AND B.STNFR = C.STNFR  ");
		//sql.append("\n	AND C.STNFR <> C.STNTO	");//compare with sel711Main1 @2013-11-14
		sql.append("\n	AND  B.Stnto = C.Stnto	");//@2013-11-14	
		sql.append("\n	AND A.PROCESS_X IN ('R')  ");
		sql.append("\n	ORDER BY ");
		sql.append("\n		C.SCH_DEP_DT");

		logPrint(new Throwable().getStackTrace()[0], sql.toString());
		return	sql.toString();
	}
	/*-------------------------------------------------------------------	sel711DeskInfo
	----------------------------------------------------------------------	*/
	public String sel711DeskInfo(IroQ710BG params){
		StringBuffer sql = new StringBuffer();
		
		sql.append("\n	SELECT ");
		sql.append("\n		A.DESK_X");
		sql.append("\n	,	TO_CHAR(A.TIMESTAMP - 9/24,	'YYYY/MM/DD HH24:MI:SS') SM");
		sql.append("\n	,	B.CODE_X");
		sql.append("\n	,	A.KOR_N");
		sql.append("\n	,	TO_CHAR(A.TIMESTAMP - 9/24,	'HH24:MI') TIMESTAMP");
		sql.append("\n	,	A.DECISION_X");
		sql.append("\n	,	A.DECISION_E");
		sql.append("\n	FROM");
		sql.append("\n		DSS_IROPS_DESK_T A");
		sql.append("\n	,	CODE_T B");
		sql.append("\n	WHERE");
		sql.append("\n		A.DSS_START_DT = TO_DATE('"+params.getDssStartDt()+"',	'YYYYMMDDHH24MISS')");
		sql.append("\n	AND	A.SEQ_NUM = "+params.getSeqNum());
		sql.append("\n	AND	A.DESK_X = B.DESC_E");
		sql.append("\n	AND	B.STEP_X = '0'");
		sql.append("\n	AND	B.CODE_C = 'Head'");
		sql.append("\n	AND	B.USE_Y = 'N' ");
		sql.append("\n	ORDER BY");
		sql.append("\n		A.DESK_X");
		
		logPrint(new Throwable().getStackTrace()[0], sql.toString());
		return	sql.toString();
	}
	/*-------------------------------------------------------------------	other
	----------------------------------------------------------------------	*/
}
