package kal.base.jdf.com;

/**
 *	20150629 
 *	FfsDataDaemon beforeRelease Thread Logger
 */

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.FileWriter;
import java.io.PrintWriter;
import java.nio.channels.FileChannel;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.Locale;
import java.util.TimeZone;

public class BaseLoggerWriter {
    
    private static BaseLoggerWriter instance;
    
    //20151116 xwmoprdap  丮 ߰
    private static String _logFileDir = "/APPL_LOG/baselog";
    
    //prd, stg
    //20151116 xwmoprdap  丮 
    //private static String _logFile = "/usr/apps/applog/BASE.log";
    private static String _logFile = "/APPL_LOG/baselog/BASE.log";
    //local
    //private static String _logFile = "D:/usr/apps/applog/BASE.log";
    
    private final static Object update_lock = new Object();
    
    private static String _today;
    
    public static synchronized BaseLoggerWriter getInstance() {
        
        if (instance == null) {
            instance = new BaseLoggerWriter();
            _today = instance.getCurrentDate(new Date());
        }
        
        return instance;
    }
    
    private BaseLoggerWriter() {
        
        System.out.println("BaseLoggerWriter()");
        
        //20151116 xwmoprdap  丮 ߰
        File logFileDir = null;
        
        File logFile = null;
        
        try{
        	//20151116 xwmoprdap  丮 ߰
        	logFileDir = new File(_logFileDir);
            
            if(!logFileDir.exists()) {
            	logFileDir.mkdir();
            }
            
            logFile = new File(_logFile);
            
            if(!logFile.exists()) {
                logFile.createNewFile();
            }
            
        } catch(Exception e) {
               e.printStackTrace();
        }
    }
    
    private String getCurrentDate(Date date) {
        
        SimpleDateFormat formatter = new SimpleDateFormat("yyyyMMdd");
        return formatter.format(date);
    }
    
    private void logFileDelete(Date current) {
        
        SimpleDateFormat formatter = new SimpleDateFormat("yyyyMMdd");
        Calendar cal = formatter.getCalendar();
        cal.setTime(current);
        cal.add(Calendar.DATE, -10);
        
        String deleteDate = formatter.format(cal.getTime());
        
        File deletedFile = new File(_logFile + "." + deleteDate);
        deletedFile.delete();
    }
    
    private void logFileRename() {
        
        File logFile = new File(_logFile);
        File prevLogFile = new File(_logFile + "." + _today);
        logFile.renameTo(prevLogFile);
    }
    
    private void logFileBackup() {
        
        File logFile = new File(_logFile);
        
        FileInputStream inputStream = null;
        FileOutputStream outputStream = null;
        FileChannel inputChannel = null;
        FileChannel outputChannel = null;
        
        try {
            inputStream = new FileInputStream(logFile);
            outputStream = new FileOutputStream(_logFile + "." + _today);
            
            inputChannel = inputStream.getChannel();
            outputChannel = outputStream.getChannel();
            
            long size = inputChannel.size();
            inputChannel.transferTo(0, size, outputChannel);
            
        } catch(Exception e) {
            
            e.printStackTrace();
        } finally {
            try {   outputChannel.close();  } catch(Exception e) {}
            try {   inputChannel.close();  } catch(Exception e) {}
            try {   outputStream.close();  } catch(Exception e) {}
            try {   inputStream.close();  } catch(Exception e) {}
        }
    }
    
    private void checkDate() {
        
        Date _current = new Date();
        
        String currentDate = getCurrentDate(_current);
        if(currentDate.equals(_today)) {
            return;
        }

        try {
            logFileDelete(_current);
            
            //logFileRename();
            logFileBackup();
            
            resetLog();
            
            _today = currentDate;
            
        } catch(Exception e) {
            e.printStackTrace();
        }
    }
    
    private void resetLog() {
        
        PrintWriter updateLog = null;
        
        try {
        	//clear and write
            updateLog = new PrintWriter(new FileWriter(_logFile, false), true);
            updateLog.print("");
            
        } catch(Exception e) {
            
            e.printStackTrace();
        } finally {
            
        	if(updateLog != null) {
        		updateLog.close();
                updateLog = null;
        	}
        }
    }
    
    public void updateLog(String info) {
        
    	synchronized(update_lock) {
    		
    		checkDate();
    		
    		PrintWriter updateLog = null;
            
            try {
            	//clear and write
                //updateLog = new PrintWriter(new FileWriter(_logFile, false), true);
            	//append
                updateLog = new PrintWriter(new FileWriter(_logFile, true), true);
                updateLog.println("[" + new Date() + "] " + info);
                
                /*
                SimpleDateFormat formatter = new SimpleDateFormat("EEE MMM d HH:mm:ss z yyyy");
                TimeZone tz = TimeZone.getTimeZone("Asia/Seoul");
                formatter.setTimeZone(tz);
                updateLog.println("[" + formatter.format(new Date()) + "] " + info);
                */
                
            } catch(Exception e) {
                
                e.printStackTrace();
            } finally {
                
            	if(updateLog != null) {
            		updateLog.close();
                    updateLog = null;
            	}
            }
    	}
    }
}
