package kal.base.jdf.com;

/**
 * @(#) MessageStore.java
 * Copyright 1999-2000 by  LG-EDS Systems, Inc.,
 * Information Technology Group, Application Architecture Team, 
 * Application Intrastructure Part.
 * 236-1, Hyosung-2dong, Kyeyang-gu, Inchun, 407-042, KOREA.
 * All rights reserved.
 * 
 * NOTICE !      You can copy or redistribute this code freely, 
 * but you should not remove the information about the copyright notice 
 * and the author.
 * 
 * @author  WonYoung Lee, wyounglee@lgeds.lg.co.kr.
 */
import java.io.*;

public class MessageStore extends GeneralMessageStore {
	private static long last_modified = 0;

	/**
	 * MessageStore default constructor.
	 */
	public MessageStore() {
		super();
	}

	/**
	 * MessageStore constructor with the message key code.
	 * @param code java.lang.String
	 */
	public MessageStore(String code) {
		super(code);
	}

	/**
	 * initialize messages from the message definition file to memory.
	 */
	protected void initialize() throws MessageException {
		try{
			//Config conf = new Configuration();
			
			//File file = new File(conf.get("kal.base.jdf.com.message.file"));
			File file = new File("messages.properties");
			
			if ( ! file.canRead() ) throw new MessageException(" Can't read Message Definition File: " + file.getAbsolutePath() );
			
			if ( last_modified == file.lastModified() ) return;

			messages = new java.util.Properties();
			
			FileInputStream fin = new FileInputStream(file);
			messages.load(new java.io.BufferedInputStream(fin));
	
			fin.close();
			last_modified = file.lastModified();
		}
		catch(MessageException e){
			messages = null;
			last_modified = 0;
			throw e;
		}
		catch(Exception e){
			messages = null;
			last_modified = 0;
			throw new MessageException("Can't read Message Definition File:  " + e.getMessage());
		}
	}
}