package kal.base.jdf.db;

/**
 * @(#) ConnectionManager.java
 * Copyright 1999-2000 by  LG-EDS Systems, Inc.,
 * Information Technology Group, Application Architecture Team, 
 * Application Intrastructure Part.
 * 236-1, Hyosung-2dong, Kyeyang-gu, Inchun, 407-042, KOREA.
 * All rights reserved.
 * 
 * NOTICE !      You can copy or redistribute this code freely, 
 * but you should not remove the information about the copyright notice 
 * and the author.
 * 
 * @author  WonYoung Lee, wyounglee@lgeds.lg.co.kr.
 */
public abstract class ConnectionResourceManager implements ConnectionResource {
	protected java.sql.Connection connection = null;

	/**
	* NOTE: you must call the method setConnection(java.sql.Connection conn).<br>
	*
	*   ڸ ϱ Ͽٸ, ݵ setConnection(java.sql.Connection conn) 
	* ȣϿ connection Ҵ  ּž մϴ.<br>
	*  ̷ ۾  Ŭ ӹ sub Ŭ ڿ  super();  ȣ 
	* ٷ ̾ Ҵ ִ    ֽϴ.
	* <xmp>
	* public MyConnectionResource extends ConnectionResourceManager {
	*    public MyConnectionResource() {
	*        super();
	*        java.sql.Conneciton conn = getYourConnectionLogic();
	*        setConnection(conn);
	*    }
	*    ....
	*}
	* </xmp>
	*/
	public ConnectionResourceManager() {
		super();
	}

	/**
	 * 
	 * @param ctx com.lgeds.jdf.db.ConnectionContext
	 */
	public ConnectionResourceManager(ConnectionContext ctx) {
		super();
		setConnection(ctx.getConnection());

	}

	/**
	 * 
	 * @param conn java.sql.Connection
	 */
	public ConnectionResourceManager(java.sql.Connection conn) {
		super();
		setConnection(conn);
	}

	/**
	 * 
	 * @return java.sql.Connection
	 */
	public java.sql.Connection getConnection() {
		return connection;
	}

	/**
	 * 
	 * @return com.lgeds.jdf.db.ConnectionContext
	 */
	public ConnectionContext getConnectionContext() {
		return (ConnectionContext)this;
	}

	/**
	* NOTE: you must call the method setConnection(java.sql.Connection conn).<br>
	*
	*  Ŭ sub Ŭ  ݵ setConnection(java.sql.Connection conn) 
	* ȣϿ connection Ҵ  ּž մϴ.<br>
	*  ̷ ۾  Ŭ ӹ sub Ŭ ڿ  super();  ȣ 
	* ٷ ̾ Ҵ ִ    ֽϴ.<br>
	* <xmp>
	* public MyConnectionResource extends ConnectionResourceManager {
	*    public MyConnectionResource() {
	*        super();
	*        java.sql.Conneciton conn = getYourConnectionLogic();
	*        setConnection(conn);
	*    }
	*    ....
	*}
	* </xmp>
	* @param conn java.sql.Connection
	*/
	public void setConnection(java.sql.Connection conn) {
		connection = conn;
	}
}