package kal.base.jdf.db;

/**
 * 
 * @(#) JDFPreparedStatement.java
 * Copyright 1999-2000 by  LG-EDS Systems, Inc.,
 * Information Technology Group, Application Architecture Team, 
 * Application Intrastructure Part.
 * 236-1, Hyosung-2dong, Kyeyang-gu, Inchun, 407-042, KOREA.
 * All rights reserved.
 *  
 * NOTICE !      You can copy or redistribute this code freely, 
 * but you should not remove the information about the copyright notice 
 * and the author.
 *  
 * @author  WonYoung Lee, wyounglee@lgeds.lg.co.kr.
 */
import java.sql.*;
import kal.base.jdf.com.*;

public class JDFPreparedStatement {
	Object caller = null;
	String query = null;
	java.sql.PreparedStatement pstmt = null;

	/**
	 * JDFStatement constructor comment.
	 */
	public JDFPreparedStatement(Object caller, String s, PreparedStatement pstmt) {
		this.caller = caller;
		this.query = s;
		this.pstmt = pstmt;
	}

	/**
	 * 
	 * @return boolean
	 */
	public boolean execute() throws SQLException {
		boolean result = false;
		StopWatch watch = new StopWatch();
		try {
			result = pstmt.execute();
		}
		finally{
			Logger.dbwrap.println(caller, query+":elapsed="+watch.getElapsed());
		}
		return result;
	}

	/**
	 * 
	 * @return java.sql.ResultSet
	 * @param s java.lang.String
	 */
	public ResultSet executeQuery() throws SQLException {
		ResultSet rs = null;
		StopWatch watch = new StopWatch();
		try {
			rs = pstmt.executeQuery();
		}
		finally{
			boolean mode = true;
			try {
				//mode = (new Configuration()).getBoolean("kal.base.jdf.com.logger.dbwrap.select.trace");
				mode = true;
			}catch(Exception e){}
			if ( mode ) 
				Logger.dbwrap.println(caller, query+":elapsed="+watch.getElapsed());
		}
		return rs;
	}

	/**
	 * 
	 * @return int
	 */
	public int executeUpdate() throws SQLException {
		int result = 0;
		StopWatch watch = new StopWatch();
		try {
			result = pstmt.executeUpdate();
		}
		finally{
			Logger.dbwrap.println(caller, query+":elapsed="+watch.getElapsed());
		}

		return result;
	}
}