package kal.base.not.query;

import kal.base.jdf.com.Logger;
import kal.base.com.util.*;
import kal.base.not.dbbean.*;

 /**
   * New Q-NOTAM List SQL 
   * @author Copyright (c) 2007/09/07 
   */
public class NotA130Query {
	private static NotA130Query instance = new NotA130Query();
	
	public static NotA130Query getInstance() {
		return instance;
	}
	
	/** 
	  * Q-NOTAM List ȸ SQLԼ.
	  * @return String Query 
	  * @author Copyright (c) 2007/09/07 
	  */
	/**
	 * 20150323 
	 * NotA130BG params ߰
	 */
	public String selNOTAMQue(NotA130BG params){
		StringBuffer sql = new StringBuffer();

		/*sql.append(" SELECT TO_CHAR(MSG_DTG,'YYYY/MM/DD HH24:MI') MSG_DTG,NOT_NUM,MSG_A,MSG_E,MSG_B,MSG_C,MSG_D,");
		sql.append(" 	MSG_Q,NOT_CAT,NOT_OLD_NUM,TO_CHAR(TIMESTMP,'YYYYMMDDHH24MISS') TIMESTMP,MSG_SEQ,ERR_NUM,");
		sql.append(" 	DECODE(ERR_NUM,'10','INVALID PORT/FIR','9','INVALID Q-CODE','8','INVALID OLD NOTAM#','7','INVALID ISSUE DATE','3','INVALID LOW/UPP VALUE','INVALID NOTAM') ERR_REASON");
		sql.append(" FROM BS_NOTAM_QUE_T");
		sql.append(" ORDER BY TIMESTMP");*/
		//2007.09.18  : NOT_CLS ߰
		sql.append(" SELECT ");
		sql.append(" 	TO_CHAR(A.MSG_DTG,'YYYY/MM/DD HH24:MI') MSG_DTG, A.NOT_NUM, A.MSG_A, A.MSG_E, A.MSG_B, A.MSG_C, A.MSG_D, ");
		sql.append(" 	A.MSG_Q, A.NOT_CAT, A.NOT_OLD_NUM, TO_CHAR(A.TIMESTMP,'YYYYMMDDHH24MISS') TIMESTMP, A.MSG_SEQ, A.ERR_NUM, ");
		sql.append(" 	DECODE(A.ERR_NUM,'10','INVALID PORT/FIR','9','INVALID Q-CODE','8','INVALID OLD NOTAM#','7','INVALID ISSUE DATE','3','INVALID LOW/UPP VALUE','INVALID NOTAM') ERR_REASON, ");
		sql.append(" 	B.NOT_CLS ");
		sql.append(" FROM BS_NOTAM_QUE_T A, BS_NOTAM_QCD_T B ");
		sql.append(" WHERE MSG_Q LIKE '%/Q'||B.NOT_QCD(+)||'%' AND B.NOT_QSEQ(+)=2 ");
		
		//20150323 ߰
		if (!"".equals(params.getS_text())) {
			//20150415 
			//sql.append(" 	AND A.MSG_E LIKE '%"+params.getS_text()+"%' ");
			sql.append(" 	AND A.MSG_E LIKE '%"+params.getS_text().toUpperCase()+"%' ");
		}
		
		//20150323 
		//sql.append(" ORDER BY A.TIMESTMP ");
		if (!"Y".equals(params.getS_sort())) {
			sql.append(" ORDER BY A.TIMESTMP ");
		} else {
			sql.append(" ORDER BY A.MSG_B ");
		}
		
		Logger.debug.println("[BASE:NotA130Query:selNOTAMQue] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * Q-NOTAM List FIR Edit SQLԼ.
	  * @param firCd String ȸ
	  * @return String Query 
	  * @author Copyright (c) 2007/09/07 
	  */
	public String selFIRCd(String firCd){
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT FIR_CD ");
		sql.append(" FROM BS_FIR_T ");
		sql.append(" WHERE FIR_CD = '"+firCd+"' ");
		
		Logger.debug.println("[BASE:NotA130Query:selFIRCd] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * Q-NOTAM List Q-Code Edit SQLԼ.
	  * @param mode String 2nd or 4th 
	  * @param params NotA130BG ȸ
	  * @return String Query 
	  * @author Copyright (c) 2007/09/07 
	  */
	public String selQCode(String mode, NotA130BG params){
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT NOT_CLS, NOT_QCD");
		sql.append(" FROM BS_NOTAM_QCD_T");
		if (mode.equals("2")) {
			sql.append(" WHERE NOT_QSEQ = 2");
			sql.append(" 	AND NOT_QCD = '"+params.getNot_qcd().substring(0,2)+"'");
		} else {
			sql.append(" WHERE NOT_QSEQ = 4");
			sql.append(" 	AND NOT_QCD = '"+params.getNot_qcd().substring(2)+"'");
		}
		
		Logger.debug.println("[BASE:NotA130Query:selQCode] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * Q-NOTAM List STN Edit SQLԼ.
	  * @param params NotA130BG ȸ
	  * @return String Query 
	  * @author Copyright (c) 2007/09/07 
	  */
	public String selSTNCheck(NotA130BG params){
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT ICAO_PORT, IATA_PORT FROM CM_PORT_T");
		sql.append(" WHERE ICAO_PORT = '"+params.getIcao_port()+"'");
		
		Logger.debug.println("[BASE:NotA130Query:selSTNCheck] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * Q-NOTAM List OLD NOTAM NBR Edit SQLԼ.
	  * @param params NotA130BG ȸ
	  * @return String Query 
	  * @author Copyright (c) 2007/09/07 
	  */
	public String selOldNOTAM(NotA130BG params){
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT NOT_NUM, NOT_EXP_DT ");
		sql.append(" FROM BS_NOTAM_T ");
		sql.append(" WHERE ICAO_PORT = '"+params.getIcao_port()+"'");
		sql.append(" 	AND NOT_NUM = '"+params.getNot_old_num()+"'");
		
		Logger.debug.println("[BASE:NotA130Query:selOldNOTAM] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * Q-NOTAM List NOTAM NBR Edit SQLԼ.
	  * @return String Query 
	  * @author Copyright (c) 2007/09/07 
	  */
	public String selNOTAM(String icaoPort,String notNum){
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT NOT_NUM, NOT_EXP_DT ");
		sql.append(" FROM BS_NOTAM_T ");
		sql.append(" WHERE ICAO_PORT = '"+icaoPort+"'");
		sql.append(" 	AND NOT_NUM = '"+notNum+"'");
		
		Logger.debug.println("[BASE:NotA130Query:selNOTAM] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * Q-NOTAM List PREV BS_NOTAM_T  SQLԼ.
	  * @param params NotA130BG ȸ
	  * @return String Query 
	  * @author Copyright (c) 2007/09/07 
	  */
	public String updPREVNOTAMT(NotA130BG params){
		StringBuffer sql = new StringBuffer();

		sql.append(" UPDATE BS_NOTAM_T");
		sql.append(" SET NOT_CAT = '"+params.getNot_cat()+"',");
		sql.append("     	NOT_MARK_NUM = '"+params.getNot_num()+"',");
		sql.append(" 		NOT_MARK_Y = 'Y',");
		sql.append(" 		NOT_EXP_DT = '"+params.getNot_prev_exp_dt()+"',");				// 2006.03.21 
		sql.append(" 		NOT_PREV_EXP_DT = '"+params.getNot_prev_exp_dt()+"',");	// 2006.03.21 
		sql.append(" 		TIMESTMP = SYSDATE,");
		sql.append("     	NOT_INPUT = 'M',");
		sql.append(" 		USERID = '"+params.getUserid()+"'");
		sql.append(" WHERE ICAO_PORT = '"+params.getIcao_port()+"'");
		sql.append(" 	AND NOT_NUM = '"+params.getNot_old_num()+"'");
		
		System.out.println("[BASE:NotA130Query:updPREVNOTAMT] sql : "+sql.toString());
		//Logger.debug.println("[BASE:NotA130Query:updPREVNOTAMT] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * Q-NOTAM List BS_NOTAM_T  SQLԼ.
	  * @param params NotA130BG ȸ
	  * @return String Query 
	  * @author Copyright (c) 2007/09/07 
	  */
	public String updNOTAMT(NotA130BG params){
		StringBuffer sql = new StringBuffer();

		sql.append(" UPDATE BS_NOTAM_T");
		sql.append(" SET IATA_PORT = '"+StringUtil.checkString(params.getIata_port())+"',");
		sql.append("     	NOT_CAT = '"+StringUtil.checkString(params.getNew_cat())+"',");
		//sql.append(" 		NOT_OLD_CAT = '"+StringUtil.checkString(params.getNot_old_cat())+"',");
		sql.append(" 		NOT_OLD_CAT = '"+StringUtil.checkString(params.getNot_cat())+"',");
		sql.append(" 		NOT_OLD_NUM = '"+StringUtil.checkString(params.getNot_old_num())+"',");
		sql.append(" 		NOT_CLS = '"+StringUtil.checkString(params.getNot_cls())+"',");
		sql.append(" 		NOT_DTG = SYSDATE-(9/24),");
		sql.append(" 		NOT_FIR = '"+StringUtil.checkString(params.getNot_fir())+"',");
		sql.append(" 		NOT_2ND_QCD = '"+StringUtil.checkString(params.getNot_2nd_qcd())+"',");
		sql.append(" 		NOT_4TH_QCD = '"+StringUtil.checkString(params.getNot_4th_qcd())+"',");
		sql.append(" 		NOT_TRAF = '"+StringUtil.checkString(params.getNot_traf())+"',");
		sql.append(" 		NOT_PURP = '"+StringUtil.checkString(params.getNot_purp())+"',");
		sql.append(" 		NOT_SCOP = '"+StringUtil.checkString(params.getNot_scop())+"',");
		sql.append(" 		NOT_LOW = '"+StringUtil.checkString(params.getNot_low())+"',");
		sql.append(" 		NOT_UPP = '"+StringUtil.checkString(params.getNot_upp())+"',");
		sql.append(" 		NOT_LAT_LON = '"+StringUtil.checkString(params.getNot_lat_lon())+"',");
		if ((params.getNot_iss_dt()).equals("WIE"))
			sql.append(" 		NOT_ISS_DT = TO_CHAR(SYSDATE-9/24,'YYMMDDHH24MI'),");
		else
			sql.append(" 		NOT_ISS_DT = '"+StringUtil.checkString(params.getNot_iss_dt())+"',");
		sql.append(" 		NOT_EXP_DT = '"+StringUtil.checkString(params.getNot_exp_dt())+"',");
		sql.append(" 		NOT_VALID = '"+StringUtil.DBInsStr(params.getNot_valid())+"',");
		sql.append(" 		NOT_TEXT = '"+StringUtil.DBInsStr(params.getNot_text())+"',");
		sql.append(" 		NOT_OPEN_Y = '"+StringUtil.checkString(params.getNot_open_y())+"',");
		sql.append(" 		NOT_COMMNT = '"+StringUtil.DBInsStr(params.getNot_commnt())+"',");
		sql.append("     	NOT_REMARK = '"+StringUtil.DBInsStr(params.getNot_remarks())+"',"); //2008.08.08 ߰
		sql.append("     	NOT_INPUT = '"+StringUtil.checkString(params.getNot_input())+"',"); //2008.08.08  : NOT_INPUT = 'M' -> Է
		sql.append(" 		TIMESTMP = SYSDATE,");
		
		sql.append(" 		NOT_EXP_EST_Y = '"+StringUtil.checkString(params.getNot_exp_est())+"', ");//2007.09.19 ߰
		sql.append(" 		NOT_SIG_Y = '"+StringUtil.checkString(params.getNot_sig())+"', ");//2007.09.19 ߰
		
		sql.append("     	NOT_DAY_FR = '"+params.getNot_day_fr()+"',"); //2009.11.09 ߰
		sql.append("     	NOT_DAY_TO = '"+params.getNot_day_to()+"',"); //2009.11.09 ߰
		
		sql.append(" 		USERID = '"+StringUtil.checkString(params.getUserid())+"' ");
		sql.append(" WHERE ICAO_PORT = '"+params.getIcao_port()+"'");
		sql.append(" 	AND NOT_NUM = '"+params.getNot_num()+"'");
		
		Logger.debug.println("[BASE:NotA130Query:updNOTAMT] sql : "+sql.toString());
		return sql.toString();
	}		
	
	/** 
	  * Q-NOTAM List BS_NOTAM_T Է SQLԼ.
	  * @param params NotA130BG ȸ
	  * @return String Query 
	  * @author Copyright (c) 2007/09/07 
	  */
	public String insNOTAMT(NotA130BG params){
		StringBuffer sql = new StringBuffer();
		
		sql.append(" INSERT INTO BS_NOTAM_T ( ");
		sql.append(" 	ICAO_PORT,IATA_PORT,NOT_NUM,NOT_CAT,NOT_OLD_CAT,NOT_OLD_NUM,NOT_CLS,NOT_DTG, ");
		sql.append(" 	NOT_FIR,NOT_2ND_QCD,NOT_4TH_QCD,NOT_TRAF,NOT_PURP,NOT_SCOP,NOT_LOW,NOT_UPP, ");
		sql.append(" 	NOT_LAT_LON,NOT_ISS_DT,NOT_EXP_DT,NOT_VALID,NOT_TEXT,NOT_OPEN_Y,NOT_COMMNT,NOT_REMARK, "); //2008.08.08 ߰ : NOT_REMARK
		sql.append(" 	NOT_INPUT,TIMESTMP,USERID,NOT_TYP, NOT_EXP_EST_Y, NOT_SIG_Y, ");
		sql.append("	NOT_DAY_FR, NOT_DAY_TO) "); //2009.11.09 ߰
		sql.append(" VALUES(");
		sql.append(" 	'"+StringUtil.checkString(params.getIcao_port())+"',");
		sql.append(" 	'"+StringUtil.checkString(params.getIata_port())+"',");
		sql.append(" 	'"+StringUtil.checkString(params.getNot_num())+"',");
		sql.append(" 	'"+StringUtil.checkString(params.getNew_cat())+"',");
		sql.append(" 	'"+StringUtil.checkString(params.getNot_cat())+"',");
		sql.append(" 	'"+StringUtil.checkString(params.getNot_old_num())+"',");
		sql.append(" 	'"+StringUtil.checkString(params.getNot_cls())+"',");
		sql.append(" 	SYSDATE-(9/24),");
		sql.append(" 	'"+StringUtil.checkString(params.getNot_fir())+"',");
		sql.append(" 	'"+StringUtil.checkString(params.getNot_2nd_qcd())+"',");
		sql.append(" 	'"+StringUtil.checkString(params.getNot_4th_qcd())+"',");
		sql.append(" 	'"+StringUtil.checkString(params.getNot_traf())+"',");
		sql.append(" 	'"+StringUtil.checkString(params.getNot_purp())+"',");
		sql.append(" 	'"+StringUtil.checkString(params.getNot_scop())+"',");
		sql.append(" 	'"+StringUtil.checkString(params.getNot_low())+"',");
		sql.append(" 	'"+StringUtil.checkString(params.getNot_upp())+"',");
		sql.append(" 	'"+StringUtil.checkString(params.getNot_lat_lon())+"',");
		if ((params.getNot_iss_dt()).equals("WIE")) {
			sql.append(" 	TO_CHAR(SYSDATE-9/24,'YYMMDDHH24MI'),");
		} else {
			sql.append(" 	'"+StringUtil.checkString(params.getNot_iss_dt())+"',");
		}
		sql.append(" 	'"+StringUtil.checkString(params.getNot_exp_dt())+"',");
		sql.append(" 	'"+StringUtil.DBInsStr(params.getNot_valid())+"',");
		sql.append(" 	'"+StringUtil.DBInsStr(params.getNot_text())+"',");
		sql.append(" 	'"+StringUtil.checkString(params.getNot_open_y())+"',");
		sql.append(" 	'"+StringUtil.DBInsStr(params.getNot_commnt())+"',");
		sql.append(" 	'"+StringUtil.DBInsStr(params.getNot_remarks())+"',"); //2008.08.08 ߰ : NOT_REMARK
		sql.append(" 	'"+StringUtil.checkString(params.getNot_input())+"',"); //2008.08.08  : NOT_INPUT = 'M' -> Է
		sql.append(" 	SYSDATE,");
		sql.append(" 	'"+StringUtil.checkString(params.getUserid())+"',");
		sql.append(" 	'N', ");
		
		sql.append(" 	'"+StringUtil.checkString(params.getNot_exp_est())+"', "); //2007.09.19 ߰
		sql.append(" 	'"+StringUtil.checkString(params.getNot_sig())+"' , "); //2007.09.19 ߰
		sql.append(" 	'"+StringUtil.checkString(params.getNot_day_fr())+"', "); //2009.11.09 ߰
		sql.append(" 	'"+StringUtil.checkString(params.getNot_day_to())+"') "); //2009.11.09 ߰
		
		Logger.debug.println("[BASE:NotA130Query:insNOTAMT] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * Q-NOTAM List BS_NOTAM_QUE_T  SQLԼ.
	  * @param params NotA130BG 
	  * @return String Query 
	  * @author Copyright (c) 2007/09/07 
	  */
	public String delNOTAMQueT(NotA130BG params){
		StringBuffer sql = new StringBuffer();

		sql.append(" DELETE BS_NOTAM_QUE_T");
		sql.append(" WHERE TIMESTMP = TO_DATE('"+params.getTimestmp()+"','YYYYMMDDHH24MISS')");
		sql.append(" 	AND MSG_SEQ = '"+params.getMsg_seq()+"'");
		
		Logger.debug.println("[BASE:NotA130Query:delNOTAMQueT] sql : "+sql.toString());
		return sql.toString();
	}	

	/** 
	  * Q-NOTAM List BS_NOTAM_QUE_T MSG_DTGȸ SQLԼ.
	  * @param params NotA130BG ȸ
	  * @return String Query 
	  * @author Copyright (c) 2007/09/07 
	  */
	public String selMsgDtg(NotA130BG params){
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT TO_CHAR(MSG_DTG, 'YYMMDDHH24MI') MSGDTG");
		sql.append(" FROM BS_NOTAM_QUE_T");
		sql.append(" WHERE TIMESTMP = TO_DATE('"+params.getTimestmp()+"','YYYYMMDDHH24MISS')");
		sql.append(" 	AND MSG_SEQ = '"+params.getMsg_seq()+"'");
		
		Logger.debug.println("[BASE:NotA130Query:selMsgDtg] sql : "+sql.toString());
		return sql.toString();
	}	

	/** 
	  * Q-NOTAM List NOT_NUM 4ڸ  NOTAM ȸ SQLԼ.
	  * @param params NotA130BG ȸ
	  * @return String Query 
	  * @author Copyright (c) 2007/09/07 
	  */
	public String selFourOldNOTAM(NotA130BG params){
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT * ");
		sql.append(" FROM BS_NOTAM_T ");
		sql.append(" WHERE ICAO_PORT = '"+params.getIcao_port()+"' ");
		sql.append(" 	AND NOT_NUM LIKE '"+params.getNot_old_num()+"%' ");
		sql.append(" 	AND NOT_CAT NOT IN ('X', 'C') "); //2006.07.20 ߰
		
		Logger.debug.println("[BASE:NotA130Query:selFourOldNOTAM] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * NOTAM_LOG Է SQLԼ.
	  * @param NotA130BG params
	  * @return String Query 
	  * @author Copyright (c) 2007/12/28 
	  */
	public String insNotLog(NotA130BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" INSERT INTO BS_NOTAM_LOG_T (ICAO_PORT, NOT_NUM, REASON, NOT_LOG_DT, USERID, NOT_REMARK) "); //2008.12.09 ߰ : NOT_REMARK ߰
		sql.append(" VALUES ('"+params.getIcao_port()+"', '"+params.getNot_num()+"', 'Initial Update', SYSDATE, '"+params.getUserid()+"', '"+StringUtil.DBInsStr(StringUtil.checkString(params.getNot_remarks()))+"') ");
		
		Logger.debug.println("[BASE:NotA130Query:insNotLog] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * BS_NOTAM_CARE_T  NOTAM Է.
	  * @return String Query 
	  * @author Copyright (c) 2008/08/06 
	  */
	public String insNotCareT(NotA130BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" INSERT INTO BS_NOTAM_CARE_T ( ");
		sql.append(" ICAO_PORT, NOT_NUM, NOT_CARE_TYP, TIMESTMP, USERID) ");
		sql.append(" VALUES ('"+params.getIcao_port()+"', '"+params.getNot_num()+"', '"+params.getNot_input()+"', SYSDATE, '"+params.getUserid()+"') ");

		System.out.println("[BASE:NotA130Query:insNotCareT] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * BS_NOTAM_CARE_T  NOTAM .
	  * @return String Query 
	  * @author Copyright (c) 2008/12/10 
	  */
	public String delNotCareT(String icao_port, String not_num) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" DELETE FROM BS_NOTAM_CARE_T ");
		sql.append(" WHERE ICAO_PORT = '"+icao_port+"' ");
		sql.append(" 		AND NOT_NUM = '"+not_num+"' ");

		System.out.println("[BASE:NotA130Query:delNotCareT] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * 20150320 ߰
	  * multi update
	  */
	public String updNOTAM_notam_input(NotA130BG params){
		StringBuffer sql = new StringBuffer();
		
		sql.append(" UPDATE BS_NOTAM_T");
		sql.append(" SET 	NOT_OPEN_Y = '"+params.getNot_open_y()+"',");
		sql.append("     	NOT_INPUT = '"+params.getNot_input()+"',"); //2008.08.06  : NOT_INPUT = 'M' -> Է
		sql.append("     	TIMESTMP = SYSDATE,");
		sql.append("     	USERID = '"+params.getUserid()+"'");
		sql.append(" WHERE ICAO_PORT = '"+params.getIcao_port()+"'");
		sql.append(" 	AND NOT_NUM = '"+params.getNot_num()+"'");

		System.out.println("[BASE:NotA110Query:updNOTAM_notam_input] sql : "+sql.toString());
		Logger.debug.println("[BASE:NotA110Query:updNOTAM_notam_input] sql : "+sql.toString());
		return sql.toString();
	}
}
