package kal.base.ocb.query;

import kal.base.jdf.com.Logger;
import kal.base.rep.dbbean.*;
import kal.base.com.query.*;
import kal.base.com.util.*;

/**
 * Operations Control Board ȭ鿡  Query
 * ۼ ¥: 2005-03-16
 * @author: HIST  
 */
public class OcbQ010Query {
	private static OcbQ010Query instance = new OcbQ010Query();
	
	public static OcbQ010Query getInstance() {
		return instance;
	}
	
	/** 
	  * Operations Control Board - KE Flight Status - IROPS ȸ SQLԼ.
	  * @param reportD String yyyymmdd
	  * @return String Query  
	  * @author Copyright (c) 2009/09/17 
	  */
	
	public String selIropsStatus(String reportD) {//@2019-07-17
		StringBuffer sql = new StringBuffer();
		sql.append(" SELECT TO_CHAR(B.FIRST_LEG_FLT_DT,'YYYYMMDD') FIRST_LEG_FLT_DT, ");
		sql.append(" B.FLT_NUM, B.STNFR, B.STNTO, A.TITLE_E, B.COMMENT_X, B.COMMENT_E, ");
		sql.append(" DECODE(B.ROUTE_X,'DOM',1,'INT',2,3) DOM_INT_X, B.ROUTE_X, ");
		sql.append(" NVL(TO_CHAR(C.SCH_DEP_DT_LOC,'DDMON'), TO_CHAR(B.SCH_DEP_DT,'DDMON')||'(G)') DDMON, ");
		sql.append(" TO_CHAR(B.SCH_DEP_DT,'YYYYMMDDHH24MI') SCH_DEP_DT, ");
		sql.append(" TO_CHAR(B.DSS_START_DT,'YYYYMMDDHH24MISS') DSS_START_DT, B.SEQ_NUM, ");
		sql.append(" C.DEP_STS, C.ARV_STS, C.ACTNID, ");		
		sql.append(" DECODE(C.ARV_STS, 'ACT', TRUNC((C.ACT_ARV_DT - C.SCH_ARV_DT)*24*60, 0), TRUNC((C.EST_ARV_DT - C.SCH_ARV_DT)*24*60, 0)) DELAY_MIN, ");		
		sql.append(" DECODE(C.ARV_STS, 'ACT', TO_CHAR(C.ACT_ARV_DT+11/24, 'YYYYMMDDHH24MI'), TO_CHAR(C.EST_ARV_DT+11/24, 'YYYYMMDDHH24MI')) ARV_DT ");		
		sql.append(" FROM DSS_IROPS_T A, DSS_IROPS_SCH_T B, DAILY_SCH_T C ");
		sql.append(" WHERE B.SCH_DEP_DT >= TO_DATE('"+reportD+"0000','YYYYMMDDHH24MI') - 24/24 ");
		sql.append(" AND B.SCH_DEP_DT <= TO_DATE('"+reportD+"2359','YYYYMMDDHH24MI') + 63/24 ");
		sql.append(" AND B.DSS_START_DT = A.DSS_START_DT ");
		sql.append(" AND B.SEQ_NUM = A.SEQ_NUM ");
		sql.append(" AND A.PROCESS_X IN ('A', 'M') ");
		sql.append(" AND B.HIDE_Y = 'N' ");
		sql.append(" AND B.ARLN_CD = C.ARLN_CD");
		sql.append(" AND B.FIRST_LEG_FLT_DT = C.FIRST_LEG_FLT_DT ");
		sql.append(" AND B.FLT_NUM = C.FLT_NUM ");
		sql.append(" AND B.LEG_NUM = C.LEG_NUM ");
		//sql.append(" AND B.STNFR = C.STNFR ");
		//sql.append(" AND B.STNTO = C.STNTO ");
		sql.append(" AND B.SCH_DEP_DT = C.SCH_DEP_DT ");
		sql.append(" AND C.DEP_STS <> 'INI' ");
		sql.append(" AND C.SVC NOT IN ('P','T','K','W') ");
		sql.append(" ORDER BY DOM_INT_X, To_Char(NVL(C.SCH_DEP_DT_LOC , B.SCH_DEP_DT),'yyyymmdd') , B.FLT_NUM, B.SCH_DEP_DT, B.DSS_START_DT  ");
		Logger.debug.println("[BASE:OcbQ010Query:selIropsStatus] sql : "+sql.toString());
		return sql.toString();
	}
	public String selIropsStatus_back(String reportD) {
		StringBuffer sql = new StringBuffer();
		/*
		sql.append(" SELECT B.FLT_NUM, B.STNFR, B.STNTO, A.TITLE_E, B.COMMENT_X, B.COMMENT_E, ");
		sql.append(" DECODE(B.ROUTE_X,'DOM',1,'INT',2,3) DOM_INT_X, B.ROUTE_X, ");
		sql.append(" TO_CHAR(B.SCH_DEP_DT,'DDMON') DDMON, ");
		sql.append(" TO_CHAR(B.SCH_DEP_DT,'YYYYMMDDHH24MI') SCH_DEP_DT, ");
		sql.append(" TO_CHAR(B.DSS_START_DT,'YYYYMMDDHH24MISS') DSS_START_DT, B.SEQ_NUM ");
		sql.append(" FROM DSS_IROPS_T A, DSS_IROPS_SCH_T B ");
		sql.append(" WHERE B.SCH_DEP_DT >= TO_DATE('"+reportD+"0000','YYYYMMDDHH24MI') - 9/24 ");
		sql.append(" AND B.SCH_DEP_DT <= TO_DATE('"+reportD+"2359','YYYYMMDDHH24MI') - 9/24 ");
		sql.append(" AND B.DSS_START_DT = A.DSS_START_DT ");
		sql.append(" AND B.SEQ_NUM = A.SEQ_NUM ");
		sql.append(" AND A.PROCESS_X IN ('A', 'M') ");
		sql.append(" AND B.HIDE_Y = 'N' ");
		sql.append(" ORDER BY DOM_INT_X, B.SCH_DEP_DT, B.DSS_START_DT ");
		*/
		//2010.02.11 
		sql.append(" SELECT TO_CHAR(B.FIRST_LEG_FLT_DT,'YYYYMMDD') FIRST_LEG_FLT_DT, ");
		sql.append(" B.FLT_NUM, B.STNFR, B.STNTO, A.TITLE_E, B.COMMENT_X, B.COMMENT_E, ");
		sql.append(" DECODE(B.ROUTE_X,'DOM',1,'INT',2,3) DOM_INT_X, B.ROUTE_X, ");
		sql.append(" NVL(TO_CHAR(C.SCH_DEP_DT_LOC,'DDMON'), TO_CHAR(B.SCH_DEP_DT,'DDMON')||'(G)') DDMON, ");
		sql.append(" TO_CHAR(B.SCH_DEP_DT,'YYYYMMDDHH24MI') SCH_DEP_DT, ");
		sql.append(" TO_CHAR(B.DSS_START_DT,'YYYYMMDDHH24MISS') DSS_START_DT, B.SEQ_NUM, ");
		sql.append(" C.DEP_STS, C.ARV_STS, C.ACTNID, ");
		
		//sql.append(" TRUNC((C.EST_ARV_DT - C.SCH_ARV_DT)*24*60, 0) DELAY_MIN, "); 2010.02.22 
		//sql.append(" DECODE(C.DEP_STS, 'ACT', TRUNC((C.ACT_DEP_DT - C.SCH_DEP_DT)*24*60, 0), TRUNC((C.EST_DEP_DT - C.SCH_DEP_DT)*24*60, 0)) DELAY_MIN, "); 2010.03.05 
		sql.append(" DECODE(C.ARV_STS, 'ACT', TRUNC((C.ACT_ARV_DT - C.SCH_ARV_DT)*24*60, 0), TRUNC((C.EST_ARV_DT - C.SCH_ARV_DT)*24*60, 0)) DELAY_MIN, ");
		
		//sql.append(" TO_CHAR(C.ACT_ARV_DT+8/24, 'YYYYMMDDHH24MISS') ARV_DT "); 2010.02.22 
		sql.append(" DECODE(C.ARV_STS, 'ACT', TO_CHAR(C.ACT_ARV_DT+11/24, 'YYYYMMDDHH24MI'), TO_CHAR(C.EST_ARV_DT+11/24, 'YYYYMMDDHH24MI')) ARV_DT ");
		
		sql.append(" FROM DSS_IROPS_T A, DSS_IROPS_SCH_T B, DAILY_SCH_T C ");
		sql.append(" WHERE B.SCH_DEP_DT >= TO_DATE('"+reportD+"0000','YYYYMMDDHH24MI') - 24/24 ");
		sql.append(" AND B.SCH_DEP_DT <= TO_DATE('"+reportD+"2359','YYYYMMDDHH24MI') + 63/24 ");
		sql.append(" AND B.DSS_START_DT = A.DSS_START_DT ");
		sql.append(" AND B.SEQ_NUM = A.SEQ_NUM ");
		sql.append(" AND A.PROCESS_X IN ('A', 'M') ");
		sql.append(" AND B.HIDE_Y = 'N' ");
		sql.append(" AND B.ARLN_CD = C.ARLN_CD(+) ");
		sql.append(" AND B.FIRST_LEG_FLT_DT = C.FIRST_LEG_FLT_DT(+) ");
		sql.append(" AND B.FLT_NUM = C.FLT_NUM(+) ");
		sql.append(" AND B.LEG_NUM = C.LEG_NUM(+) ");
		sql.append(" AND B.STNFR = C.STNFR(+) ");
		sql.append(" AND B.STNTO = C.STNTO(+) ");
		sql.append(" AND C.DEP_STS(+) <> 'INI' ");
		
		//2017.03.20  
		sql.append(" AND C.SVC(+) NOT IN ('P','T','K','W') ");//@2019-07-10
		sql.append(" ORDER BY DOM_INT_X, To_Char(NVL(C.SCH_DEP_DT_LOC , B.SCH_DEP_DT),'yyyymmdd') , B.FLT_NUM, B.SCH_DEP_DT, B.DSS_START_DT  ");
		//sql.append(" ORDER BY DOM_INT_X, B.FLT_NUM, B.SCH_DEP_DT, B.DSS_START_DT ");
		
		//System.out.println("[BASE:OcbQ010Query:selIropsStatus] sql : "+sql.toString());
		Logger.debug.println("[BASE:OcbQ010Query:selIropsStatus] sql : "+sql.toString());
		return sql.toString();
	}

	
	/** 
	  * Operations Control Board IROPS Departure ȸ SQLԼ.
	  * @param reportD String yyyymmdd
	  * @return String Query  
	  * @author Copyright (c) 2005/02/21 HIST 
	  */
	public String selIropsDep(String reportD) {
		StringBuffer sql = new StringBuffer();
		
		//KE Flight Status - IROPS ==> ӽ Departure 
		sql.append(" Select 'KE'||A.Flt_Num||' '||A.Stnfr||'/'||A.Stnto Irops_Info,");
		sql.append("        	B.Decision_e||' ['||B.Decision_c||']' Irops_Desc, A.Sch_Dep_Dt");
		sql.append("  From Daily_Sch_t A,  Irops_Sch_t B");
		sql.append(" Where A.Arln_Cd = 'KE' And");
		
		sql.append("       		A.Sch_Dep_Dt >= To_Date('"+reportD+" 0000' ,'yyyymmdd hh24mi')-540/1440 And");
		sql.append("       		A.Sch_Dep_Dt <= To_Date('"+reportD+" 2359' ,'yyyymmdd hh24mi')-540/1440 And");
		
		//Test
		//sql.append("       		A.Sch_Dep_Dt >= To_Date('20050218 0000' ,'yyyymmdd hh24mi')-540/1440 And");
		//sql.append("       		A.Sch_Dep_Dt <= To_Date('20050316 2359' ,'yyyymmdd hh24mi')-540/1440 And");
		
		sql.append("       		B.Arln_Cd = 'KE'   And");
		sql.append("       		B.Hide_y     = 'N'     And");
		sql.append("       		B.Decision_c <> 'X'    And");
		sql.append("       		B.Complete_y = 'Y'     And");
		sql.append("       		A.First_Leg_Flt_Dt = B.First_Leg_Flt_Dt And");
		sql.append("       		A.Flt_Num    = B.Flt_Num    And");
		sql.append("       		A.Stnfr      = B.Stnfr      And");
		sql.append("       		A.Stnto      = B.STnto");
		//NEW Flight IROPS ߰ 2005.04.28
		/*
		sql.append(" Union");
		sql.append(" Select '* KE'||A.Flt_Num||' '||A.Stnfr||'/'||A.Stnto Irops_Info,");
		sql.append("        	B.Decision_e||' ['||B.Decision_c||']' Irops_Desc, A.Sch_Dep_Dt");
		sql.append(" From Bs_New_Sch_t A, Irops_Sch_t B");
		sql.append(" Where A.Arln_Cd = 'KE' ANd");
		sql.append("       		A.Sch_Dep_Dt >= To_Date('"+reportD+" 0000' ,'yyyymmdd hh24mi')-540/1440 And");
		sql.append("       		A.Sch_Dep_Dt <= To_Date('"+reportD+" 2359' ,'yyyymmdd hh24mi')-540/1440 And");
		sql.append("       		B.Arln_Cd = 'KE'   And       		B.Hide_y     = 'N'     And");
		sql.append("       		B.Decision_c <> 'X'    And       		B.Complete_y = 'Y'     And");
		sql.append("       		A.First_Leg_Flt_Dt = B.First_Leg_Flt_Dt And");
		sql.append("       		A.Flt_Num    = B.Flt_Num    And");
		sql.append("       		A.Stnfr      = B.Stnfr      And");
		sql.append("       		A.Stnto      = B.STnto");
		*/
		sql.append(" Order By Sch_Dep_Dt");
		
		System.out.println("[BASE:OcbQ010Query:selIropsDep] sql : "+sql.toString());
		Logger.debug.println("[BASE:OcbQ010Query:selIropsDep] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * Operations Control Board Operational Performace (1) ȸ SQLԼ.
	  * @param reportD String yyyymmdd
	  * @return String Query  
	  * @author Copyright (c) 2005/02/21 HIST 
	  */
	public String selOpPer1(String reportD) {
		StringBuffer sql = new StringBuffer();
		
		//KE Operational Performace (1)
		sql.append(" Select Count(*) Cnt,'ALL'");
		sql.append("   From Daily_Sch_t");
		sql.append("  Where Arln_cd = 'KE' And");
		sql.append("        	 Sch_Dep_Dt >= To_Date('"+reportD+" 0000','yyyymmdd hh24mi')-540/1440 And");
		sql.append("        	 Sch_Dep_Dt <= To_Date('"+reportD+" 2359','yyyymmdd hh24mi')-540/1440 And");
		sql.append("             SUBSTR(FLT_NUM,1,1) <> 4 AND ");//2012.05.30 ߰
		sql.append("        	 Actnid <> 'CNL'  And");
		sql.append("        	 Dep_Sts = 'ACT'  And");
		sql.append("			 Kactyp Not In ('7FG','79S','7GG','ABH') And"); //2009.05.21 ߰ : 7GG, ABH
		sql.append("        	 Dep_Sts <> 'INI'");
		sql.append(" Union All");
		sql.append(" Select Count(*) Cnt,'EA'");
		sql.append("   From Daily_Sch_t");
		sql.append("  Where Arln_cd = 'KE' And");
		sql.append("        	 Sch_Dep_Dt >= To_Date('"+reportD+" 0000','yyyymmdd hh24mi')-540/1440 And");
		sql.append("        	 Sch_Dep_Dt <= To_Date('"+reportD+" 2359','yyyymmdd hh24mi')-540/1440 And");
		// 3̻ 
		// 15̻ 
		/*
		sql.append("        	 ((Region_Flt = '1' And Act_Dep_dt - Sch_Dep_Dt > 03/1440) Or");
		sql.append("         	 (Region_Flt <> '1' And Act_Dep_dt - Sch_Dep_Dt > 15/1440))    And");
		*/
		// 3̻   2005.04.27
		//sql.append("        	 Act_Dep_dt - Sch_Dep_Dt > 03/1440 And");
		
		// /ȭ   2012.05.30
		sql.append("       	 	 ((Kactyp In ('74F','74Y','74N','77X') AND  Act_Dep_dt - Sch_Dep_Dt > 15/1440) OR");
		sql.append("       	 	 (Kactyp NOT In ('74F','74Y','74N','77X') AND Act_Dep_dt - Sch_Dep_Dt > 5/1440)) AND");
		sql.append("             SUBSTR(FLT_NUM,1,1) <> 4 AND ");
		
		sql.append("       	 	 Actnid  <> 'CNL'  And");
		sql.append("        	 Dep_Sts = 'ACT'  And");
		sql.append("			 Kactyp Not In ('7FG','79S','7GG','ABH') And"); //2009.05.21 ߰ : 7GG, ABH
		sql.append("        	 Dep_Sts <> 'INI'");
		sql.append(" Order By 2");
		
		System.out.println("[BASE:OcbQ010Query:selOpPer1] sql : "+sql.toString());
		Logger.debug.println("[BASE:OcbQ010Query:selOpPer1] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * Operations Control Board Operational Performace (2) ȸ SQLԼ.
	  * @param reportD String yyyymmdd
	  * @return String Query  
	  * @author Copyright (c) 2005/02/21 HIST 
	  */
	public String selOpPer2(String reportD) {
		StringBuffer sql = new StringBuffer();
		
		//KE Operational Performace (2)
		sql.append(" Select Count(*) Cnt,'ALL'");
		sql.append("   From Daily_Sch_t");
		sql.append("  Where Arln_cd = 'KE' And");
		sql.append("        	 Sch_Dep_Dt >= To_Date('"+reportD+" 0000','yyyymmdd hh24mi')-540/1440 And");
		sql.append("        	 Sch_Dep_Dt <= To_Date('"+reportD+" 2359','yyyymmdd hh24mi')-540/1440 And");
		sql.append("        	 Sch_Arv_Dt >= To_Date('"+reportD+" 0000','yyyymmdd hh24mi')-540/1440 And");
		sql.append("        	 Sch_Arv_Dt <= To_Date('"+reportD+" 2359','yyyymmdd hh24mi')-540/1440 And");		
		sql.append("             SUBSTR(FLT_NUM,1,1) <> 4 AND ");//2012.05.30 ߰
		sql.append("        	 Actnid <> 'CNL'  And");
		sql.append("        	 Arv_Sts = 'ACT'  And");
		sql.append("			 Kactyp Not In ('7FG','79S','7GG','ABH') And"); //2009.05.21 ߰ : 7GG, ABH
		sql.append("        	 Dep_Sts <> 'INI'");
		sql.append(" Union");
		sql.append(" Select Count(*) Cnt,'EA'");
		sql.append("   From Daily_Sch_t");
		sql.append("  Where Arln_cd = 'KE' And");
		sql.append("        	 Sch_Dep_Dt >= To_Date('"+reportD+" 0000','yyyymmdd hh24mi')-540/1440 And");
		sql.append("        	 Sch_Dep_Dt <= To_Date('"+reportD+" 2359','yyyymmdd hh24mi')-540/1440 And");
		sql.append("        	 Sch_Arv_Dt >= To_Date('"+reportD+" 0000','yyyymmdd hh24mi')-540/1440 And");
		sql.append("        	 Sch_Arv_Dt <= To_Date('"+reportD+" 2359','yyyymmdd hh24mi')-540/1440 And");
		/*
		sql.append("        	 ((Region_Flt = '1' And Act_Arv_dt - Sch_Arv_Dt > 03/1440) Or");
		sql.append("         	 (Region_Flt <> '1' And Act_Arv_dt - Sch_Arv_Dt > 15/1440))    And");
		*/
		
		// 3̻   2005.04.27
		//sql.append("        	 Act_Arv_dt - Sch_Arv_Dt > 03/1440 And");
		
        ///ȭ   2012.05.30
		sql.append("       	 	 ((Kactyp In ('74F','74Y','74N','77X') AND  Act_Dep_dt - Sch_Dep_Dt > 15/1440) OR");
		sql.append("       	 	 (Kactyp NOT In ('74F','74Y','74N','77X') AND Act_Dep_dt - Sch_Dep_Dt > 5/1440)) AND");
		sql.append("             SUBSTR(FLT_NUM,1,1) <> 4 AND ");//2012.05.30 ߰
		
		sql.append("        	 Actnid  <> 'CNL'  And");
		sql.append("        	 Arv_Sts = 'ACT'  And");
		sql.append("			 Kactyp Not In ('7FG','79S','7GG','ABH') And"); //2009.05.21 ߰ : 7GG, ABH
		sql.append("        	 Dep_Sts <> 'INI'");
		sql.append(" Order By 2");
		
		System.out.println("[BASE:OcbQ010Query:selOpPer2] sql : "+sql.toString());
		Logger.debug.println("[BASE:OcbQ010Query:selOpPer2] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * Operations Control Board Operational Performace (3)(6) ȸ SQLԼ.
	  * @param reportD String yyyymmdd
	  * @return String Query  
	  * @author Copyright (c) 2005/02/21 HIST 
	  */
	public String selOpPer36(String reportD) {
		StringBuffer sql = new StringBuffer();
		
		//KE Operational Performace (3)(6)
		sql.append(" Select Dep_Sts ,  Sum(F_Cfg + C_Cfg + Y_Cfg) Cfg_Cnt, Sum(F_Book + C_Book + Y_Book) Book_Cnt, Sum(F_Chkin + C_Chkin + Y_Chkin) Chkin_Cnt");
		sql.append("   From Daily_Sch_t");
		sql.append("  Where Arln_cd = 'KE' And");
		sql.append("        	 Sch_Dep_Dt >= To_Date('"+reportD+" 0000','yyyymmdd hh24mi')-540/1440 And");
		sql.append("        	 Sch_Dep_Dt <= To_Date('"+reportD+" 2359','yyyymmdd hh24mi')-540/1440 And");
		sql.append("        	 Actnid <> 'CNL'  And");
		sql.append("        	 Dep_Sts <> 'INI' And");
		sql.append("        	 Not kactyp in('M1F','7FQ','7FR','74Y','7FG','79S','7GG','ABH','74F','74N','77X') And"); //2009.05.21 ߰ : 7GG, ABH, 2010.03.26 ߰ : 74F, 2012.02.22 ߰ : 74N,77X
		sql.append("        	 Stnfr <> Stnto");
		sql.append("  Group by Dep_Sts");
		
		System.out.println("[BASE:OcbQ010Query:selOpPer36] sql : "+sql.toString());
		Logger.debug.println("[BASE:OcbQ010Query:selOpPer36] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * Operations Control Board Operational Performace (4)(5) ȸ SQLԼ.
	  * @param reportD String yyyymmdd
	  * @return String Query  
	  * @author Copyright (c) 2005/02/21 HIST 
	  */
	public String selOpPer45(String reportD) {
		StringBuffer sql = new StringBuffer();
		
		//KE Operational Performace (4)(5)
		sql.append(" Select Sum(B.Bag_Wt_q) Bag_q, Sum(B.Cgo_Wt_q) Cgo_q");
		sql.append("  From Daily_Sch_t A, Base_Dcs_t B");
		sql.append(" Where A.Arln_Cd = 'KE' And");
		sql.append("       		A.Sch_Dep_Dt >= To_Date('"+reportD+" 0000','yyyymmdd hh24mi')-540/1440 And");
		sql.append("       		A.Sch_Dep_Dt <= To_Date('"+reportD+" 2359','yyyymmdd hh24mi')-540/1440 And");
		//System Performance Tunning => 2005.09.07 
		sql.append("       		B.First_Leg_Flt_Dt >= To_Date('"+reportD+"','yyyymmdd')-2 And");
		sql.append("       		B.First_Leg_Flt_Dt <= To_Date('"+reportD+"','yyyymmdd') And");
		sql.append("       		A.Arln_Cd = 'KE'   And");
		sql.append("       		A.Actnid  <> 'CNL' And");
		sql.append("       		A.Dep_Sts <> 'INI' And");
		sql.append("       		A.Arln_Cd    = B.Arln_Cd    And");
		sql.append("       		A.First_Leg_Flt_Dt = B.First_Leg_Flt_Dt And");
		sql.append("       		A.Flt_Num    = B.Flt_Num    And");
		sql.append("       		A.Stnfr      = B.Stnfr      And");
		sql.append("			A.Kactyp Not In ('7FG','79S','7GG','ABH') And"); //2009.05.21 ߰ : 7GG, ABH
		sql.append("       		A.Stnto      = B.STnto");
		
		System.out.println("[BASE:OcbQ010Query:selOpPer45] sql : "+sql.toString());
		Logger.debug.println("[BASE:OcbQ010Query:selOpPer45] sql : "+sql.toString());
		return sql.toString();
	}	
	
	//KE Operational Performace (7) 
	
	/** 
	  * Operations Control Board Operational Performace T/S PAX ȸ SQLԼ.
	  * @param reportD String yyyymmdd
	  * @return String Query  
	  * @author Copyright (c) 2012/05/30 
	  */
	public String selTsPax(String reportD) {
		StringBuffer sql = new StringBuffer();
		
		//KE Operational Performace (7)
		sql.append(" Select Sum(A.F_Book_q + A.C_Book_q + A.Y_Book_q) BOOK_Q, Sum(A.F_Chkin_q + A.C_Chkin_q + A.Y_Chkin_q) CHKIN_Q");
		sql.append(" From BASE_DCS_TRANS_T A,");
		sql.append("          (Select Distinct First_Leg_Flt_Dt, Flt_Num, Stnfr, Stnto, Sch_Dep_Dt_Loc");
		sql.append("       		From Daily_sch_t");
		sql.append("       		Where Arln_Cd     = 'KE'    And");
		sql.append("       		Substr(Flt_Num,1,1) <> '4'      And");
		sql.append("       		Kactyp   Not In('79S','7GG','7FG','ABH') And");
		sql.append("       		Sch_Dep_Dt Between To_Date('"+reportD+" 0000','yyyymmdd hh24mi')-540/1440 And");
		sql.append("       		                                   To_Date('"+reportD+" 2359','yyyymmdd hh24mi')-540/1440 And");
		sql.append("       		Actnid           <> 'CNL') B");
		sql.append(" Where A.Arln_Cd          = 'KE'      And");
		sql.append("       		A.First_Leg_Flt_Dt = B.First_Leg_Flt_Dt And");
		sql.append("       		A.Flt_Num          = B.Flt_Num And");
		sql.append("       		A.Stnfr            = B.Stnfr   And");
		sql.append("			A.Stnto           = B.Stnto   And"); 
		sql.append("       		A.Dep_Arv_x        = 'D'       And");
		sql.append("       		B.Sch_Dep_Dt_Loc - A.Trans_Dt <= 10/24");
		
		System.out.println("[BASE:OcbQ010Query:selTsPax] sql : "+sql.toString());
		Logger.debug.println("[BASE:OcbQ010Query:selTsPax] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * Operations Control Board Resource Monitor ȸ SQLԼ.
	  * @param reportM String yyyymm
	  * @param reportD String yyyymmdd
	  * @return String Query  
	  * @author Copyright (c) 2005/02/21 HIST 
	  */
	public String selReMonitor(String reportM, String reportD) {
		StringBuffer sql = new StringBuffer();
		
		//KE Resource Monitor
		/* 
		sql.append(" Select 'KE ALL' Desc_e,");
		sql.append("        	Sum(Decode(Flag,'AB',Cnt, 0)) Act,");
		sql.append("        	Sum(Decode(Flag,'BB',Cnt, 0)) Skd,");
		sql.append("        	Sum(Decode(Flag,'AA',Cnt, 0)) Ground");
		sql.append(" From (Select B.Desc_e, Count(*) Cnt,");
		sql.append("              		  Decode(A.Dep_Sts,'ACT','A','B')||Decode(A.Arv_Sts,'ACT','A','B') Flag");
		sql.append("       		From Daily_Sch_t A , Code_T B");
		sql.append("       		Where  A.Arln_Cd = 'KE' And");
		sql.append("             			A.Sch_Dep_Dt >= To_Date('"+reportD+" 0000','yyyymmdd hh24mi')-540/1440 And");
		sql.append("             			A.Sch_Dep_Dt <= To_Date('"+reportD+" 2359','yyyymmdd hh24mi')-540/1440 And");
		sql.append("             			A.Arln_Cd = 'KE'   And");
		sql.append("             			A.Actnid  <> 'CNL' And");
		sql.append("             			A.Dep_Sts <> 'INI' And");
		sql.append("             			B.Step_x = '1'     And");
		sql.append("             			B.Use_y  = 'Y'     And");
		sql.append("             			B.Code_x = 'REPORT ACTYPE' And");
		sql.append("             			A.Kactyp = B.Code_c");
		sql.append("       		Group By B.Desc_e, Decode(A.Dep_Sts,'ACT','A','B')||Decode(A.Arv_Sts,'ACT','A','B')");
		sql.append("       		Order By B.Desc_e, Flag)");
		sql.append(" Union All");
		sql.append(" Select Desc_e,");
		sql.append("        	Sum(Decode(Flag,'AB',Cnt, 0)) Act,");//,
		sql.append("        	Sum(Decode(Flag,'BB',Cnt, 0)) Skd,");//SKD,
		sql.append("        	Sum(Decode(Flag,'AA',Cnt, 0)) Ground");//Ϸ
		sql.append(" From (Select B.Desc_e, Count(*) Cnt,");
		sql.append("           			  Decode(A.Dep_Sts,'ACT','A','B')||Decode(A.Arv_Sts,'ACT','A','B') Flag");
		sql.append("       	   From Daily_Sch_t A , Code_T B");
		sql.append("       	   Where 	A.Arln_Cd = 'KE' And");
		sql.append("             			A.Sch_Dep_Dt >= To_Date('"+reportD+" 0000','yyyymmdd hh24mi')-540/1440 And");
		sql.append("             			A.Sch_Dep_Dt <= To_Date('"+reportD+" 2359','yyyymmdd hh24mi')-540/1440 And");
		sql.append("             			A.Arln_Cd = 'KE'   And");
		sql.append("             			A.Actnid  <> 'CNL' And");
		sql.append("             			A.Dep_Sts <> 'INI' And");
		sql.append("             			B.Step_x = '1'     And");
		sql.append("             			B.Use_y  = 'Y'     And");
		sql.append("             			B.Code_x = 'REPORT ACTYPE' And");
		sql.append("             			A.Kactyp = B.Code_c");
		sql.append("       	   Group By B.Desc_e, Decode(A.Dep_Sts,'ACT','A','B')||Decode(A.Arv_Sts,'ACT','A','B')");
		sql.append("       	   Order By B.Desc_e, Flag)");
		sql.append(" Group By Desc_e");
		*/
		
		//2007.07.04 ּó
		/*sql.append(" Select Code_c3, Sum(Flt_q2) Data_Cnt, 'A' Data_Flag");
		sql.append(" From OPS_report_T");
		sql.append(" Where report_d   = '"+reportM+"'  And");
		sql.append("       		report_x   = 'E' And");
		sql.append("       		Code_c2    = 'A' And");
		sql.append("			Code_c3 != 'M11F'");
		sql.append("  Group By Code_c3");
		sql.append(" union");
		sql.append(" Select B.Desc_e Code_c3, Count(Distinct A.Regno) Data_Cnt,'B' Data_Flag");
		sql.append(" From Daily_Sch_t A , Code_T B");
		sql.append(" Where  A.Arln_Cd = 'KE' And");
		sql.append("              A.Sch_Dep_Dt >= To_Date('"+reportD+" 1500','yyyymmdd hh24mi')-1 And");
		sql.append("              A.Sch_Dep_Dt <= To_Date('"+reportD+" 1459','yyyymmdd hh24mi') And");
		//sql.append("       		  A.Sch_Dep_Dt >= Sysdate - 1620/1440 And");
		//sql.append("       		  A.Sch_Dep_Dt <= Sysdate + 540/1440  And");
		sql.append("              A.Arln_Cd = 'KE'   And");
		sql.append("              A.Actnid  <> 'CNL' And");
		sql.append("              A.Dep_Sts <> 'INI' And");
		sql.append("              B.Step_x = '1'     And");
		sql.append("              B.Use_y  = 'Y'     And");
		sql.append("              B.Code_x = 'REPORT ACTYPE' And");
		sql.append("              A.Kactyp = B.Code_c And");
		sql.append("			  B.Desc_e != 'M11F'");
		sql.append(" Group by B.Desc_e");
		sql.append(" Union");
		sql.append(" Select B.Desc_e Code_c3, Count(Distinct A.Regno) Data_Cnt, 'C' Data_Flag");
		sql.append(" From Daily_Sch_t A , Code_T B");
		sql.append(" Where  A.Arln_Cd = 'KE' And");
		//sql.append("              A.Sch_Dep_Dt >= To_Date('"+reportD+" 1500','yyyymmdd hh24mi')-1 And");
		//sql.append("              A.Sch_Dep_Dt <= To_Date('"+reportD+" 1459','yyyymmdd hh24mi') And");
		//sql.append("       		  A.Sch_Dep_Dt >= Sysdate - 1620/1440 And");
		//sql.append("       		  A.Sch_Dep_Dt <= Sysdate + 540/1440  And");
		//In Flight -24ð ش 2005.05.04
		sql.append("              A.Sch_Dep_Dt >= To_Date('"+reportD+" 1500','yyyymmdd hh24mi')-2 And");
		sql.append("              A.Sch_Dep_Dt <= To_Date('"+reportD+" 1459','yyyymmdd hh24mi') And");
		sql.append("              A.Arln_Cd = 'KE'   And");
		sql.append("              A.Actnid  <> 'CNL' And");
		sql.append("              A.Dep_Sts = 'ACT' And");
		sql.append("              A.Arv_Sts <> 'ACT' And");
		sql.append("              B.Step_x = '1'     And");
		sql.append("              B.Use_y  = 'Y'     And");
		sql.append("              B.Code_x = 'REPORT ACTYPE' And");
		sql.append("              A.Kactyp = B.Code_c And");
		sql.append("			  B.Desc_e != 'M11F'");
		sql.append(" Group by B.Desc_e");
		sql.append(" Order By 1,3");*/
		
		//2007.07.04 
		/*sql.append(" Select Report_Actyp Code_c3, Count(B.Regno) Data_Cnt , 'A' Data_Flag");
		sql.append(" From Cm_Actyp_T A, Cm_Regno_T B");
		sql.append(" Where A.Kactyp = B.Kactyp  And");
		sql.append(" 	A.Owner  = 'KE'      And");
		sql.append(" 	B.Exp_Dt >= Sysdate - 30  And");
		sql.append(" 	A.Kactyp <> 'GRJ'");
		sql.append(" Group By Report_Actyp");
		sql.append(" union");
		sql.append(" Select B.Report_Actyp Code_c3, Count(Distinct A.Regno) Data_Cnt,'B' Data_Flag");
		sql.append(" From Daily_Sch_t A , Cm_Actyp_T B");
		sql.append(" Where  A.Arln_Cd = 'KE' And");
		sql.append(" 	A.Sch_Dep_Dt >= To_Date('"+reportD+" 1500','yyyymmdd hh24mi')-1 And");
		sql.append(" 	A.Sch_Dep_Dt <= To_Date('"+reportD+" 1459','yyyymmdd hh24mi') And");
		sql.append(" 	A.Arln_Cd = 'KE'   And");
		sql.append(" 	A.Actnid  <> 'CNL' And");
		sql.append(" 	A.Dep_Sts <> 'INI' And");
		sql.append(" 	B.Owner  = 'KE'    And");
		sql.append(" 	B.Kactyp <> 'GRJ'  And");
		sql.append(" 	A.Kactyp = B.Kactyp");
		sql.append(" Group by B.Report_Actyp");
		sql.append(" Union");
		sql.append(" Select B.Report_Actyp Code_c3, Count(Distinct A.Regno) Data_Cnt, 'C' Data_Flag");
		sql.append(" From Daily_Sch_t A ,  Cm_Actyp_T B");
		sql.append(" Where  A.Arln_Cd = 'KE' And");
		sql.append(" 	A.Sch_Dep_Dt >= To_Date('"+reportD+" 1500','yyyymmdd hh24mi')-2 And");
		sql.append(" 	A.Sch_Dep_Dt <= To_Date('"+reportD+" 1459','yyyymmdd hh24mi') And");
		sql.append(" 	A.Arln_Cd = 'KE'   And");
		sql.append(" 	A.Actnid  <> 'CNL' And");
		sql.append(" 	A.Dep_Sts = 'ACT' And"); 
		sql.append(" 	A.Arv_Sts <> 'ACT' And"); 
		sql.append(" 	B.Owner  = 'KE'    And");
		sql.append(" 	B.Kactyp <> 'GRJ'  And");
		sql.append(" 	A.Kactyp = B.Kactyp");
		sql.append(" Group by B.Report_Actyp");
		sql.append(" Order By 1,3 ");*/
		
		// 2012.05.30 
		//IATA Aircraft Group Code  ǥ=>װ /  ڵ ݿ
		
		
		/*
		sql.append(" Select Gactyp Code_c3, Count(B.Regno) Data_Cnt , 'A' Data_Flag");
		sql.append(" From Cm_Actyp_T A, Cm_Regno_T B");
		sql.append(" Where A.Kactyp = B.Kactyp  And");
		sql.append(" 	A.Owner  = 'KE'      And");
		sql.append(" 	B.Exp_Dt >= Sysdate - 30");
		sql.append(" Group By Gactyp");
		sql.append(" union");
		sql.append(" Select B.Gactyp Code_c3, Count(Distinct A.Regno) Data_Cnt,'B' Data_Flag");
		sql.append(" From Daily_Sch_t A , Cm_Actyp_T B");
		sql.append(" Where  A.Arln_Cd = 'KE' And");
		sql.append(" 	A.Sch_Dep_Dt >= To_Date('"+reportD+" 1500','yyyymmdd hh24mi')-1 And");
		sql.append(" 	A.Sch_Dep_Dt <= To_Date('"+reportD+" 1459','yyyymmdd hh24mi') And");
		sql.append(" 	A.Arln_Cd = 'KE'   And");
		sql.append(" 	A.Actnid  <> 'CNL' And");
		sql.append(" 	A.Dep_Sts <> 'INI' And");
		sql.append(" 	B.Owner  = 'KE'    And");
		sql.append(" 	A.Kactyp = B.Kactyp");
		sql.append(" Group by B.Gactyp");
		sql.append(" Union");
		sql.append(" Select B.Gactyp Code_c3, Count(Distinct A.Regno) Data_Cnt, 'C' Data_Flag");
		sql.append(" From Daily_Sch_t A ,  Cm_Actyp_T B");
		sql.append(" Where  A.Arln_Cd = 'KE' And");
		sql.append(" 	A.Sch_Dep_Dt >= To_Date('"+reportD+" 1500','yyyymmdd hh24mi')-2 And");
		sql.append(" 	A.Sch_Dep_Dt <= To_Date('"+reportD+" 1459','yyyymmdd hh24mi') And");
		sql.append(" 	A.Arln_Cd = 'KE'   And");
		sql.append(" 	A.Actnid  <> 'CNL' And");
		sql.append(" 	A.Dep_Sts = 'ACT' And"); 
		sql.append(" 	A.Arv_Sts <> 'ACT' And"); 
		sql.append(" 	B.Owner  = 'KE'    And");
		sql.append(" 	A.Kactyp = B.Kactyp");
		sql.append(" Group by B.Gactyp");
		sql.append(" Order By 1,3 ");
		
		@2018-06-11*/
		
		sql.append("	WITH C AS (");
		sql.append("		SELECT");
		sql.append("			CASE	");
		sql.append("				WHEN C.GACTYP='747' AND C.KACTYP IN('74I') THEN '74I'");
		sql.append("				WHEN C.GACTYP='737' AND C.KACTYP IN ('73W') THEN '73W'");
		sql.append("				ELSE");
		sql.append("					C.GACTYP");
		sql.append("			END AS CODE_C3");
		sql.append("		,	C.GACTYP");
		sql.append("		,	C.KACTYP");
		sql.append("		FROM");
		sql.append("			CM_ACTYP_T	C");
		sql.append("		WHERE");
		sql.append("			C.GACTYP	NOT IN ('76F', 'GRJ') ");
		sql.append("		AND	C.KACTYP	NOT IN ('76F', 'GRJ') ");
		sql.append("		AND	C.OWNER = 'KE'");
		sql.append("	)");
		sql.append("SELECT * FROM (");
		//---------------------------
		sql.append("	SELECT");
		sql.append("		C.CODE_C3");
		sql.append("	,	COUNT(A.REGNO) DATA_CNT");
		sql.append("	,	'A' DATA_FLAG");
		sql.append("	FROM");
		sql.append("		CM_REGNO_T A");
		sql.append("	,	C");
		sql.append("	WHERE");
		sql.append("		A.KACTYP = C.KACTYP");
		sql.append("	AND	A.EXP_DT >= SYSDATE - 30");
		sql.append("	GROUP BY");
		sql.append("		C.CODE_C3");
		sql.append("		");
		//---------------------------
		sql.append("	UNION");
		sql.append("	SELECT");
		sql.append("		C.CODE_C3");
		sql.append("	,	COUNT(DISTINCT A.REGNO) DATA_CNT");
		sql.append("	,	'B' DATA_FLAG");
		sql.append("	FROM");
		sql.append("		DAILY_SCH_T A");
		sql.append("	,	C");
		sql.append("	WHERE");
		sql.append("		A.ARLN_CD = 'KE'");
		sql.append("	AND	A.SCH_DEP_DT >= TO_DATE('"+reportD+" 1500' ,	'YYYYMMDD HH24MI')-1");
		sql.append("	AND	A.SCH_DEP_DT <= TO_DATE('"+reportD+" 1459' ,	'YYYYMMDD HH24MI')");
		sql.append("	AND	A.ARLN_CD = 'KE'");
		sql.append("	AND	A.ACTNID <> 'CNL'");
		sql.append("	AND	A.DEP_STS <> 'INI'");
		sql.append("	AND	A.KACTYP = C.KACTYP");
		sql.append("	GROUP BY");
		sql.append("		C.CODE_C3 ");
		//---------------------------
		sql.append("	UNION");
		sql.append("	SELECT");
		sql.append("		C.CODE_C3");
		sql.append("	,	COUNT(DISTINCT A.REGNO) DATA_CNT");
		sql.append("	,	'C' DATA_FLAG");
		sql.append("	FROM");
		sql.append("		DAILY_SCH_T A");
		sql.append("	,	C");
		sql.append("	WHERE");
		sql.append("		A.ARLN_CD = 'KE'");
		sql.append("	AND	A.SCH_DEP_DT >= TO_DATE('"+reportD+" 1500' ,	'YYYYMMDD HH24MI')-2");
		sql.append("	AND	A.SCH_DEP_DT <= TO_DATE('"+reportD+" 1459' ,	'YYYYMMDD HH24MI')");
		sql.append("	AND	A.ARLN_CD = 'KE'");
		sql.append("	AND	A.ACTNID <> 'CNL'");
		sql.append("	AND	A.DEP_STS = 'ACT'");
		sql.append("	AND	A.ARV_STS <> 'ACT'");
		sql.append("	AND	A.KACTYP = C.KACTYP");
		sql.append("	GROUP BY");
		sql.append("		C.CODE_C3");
		//---------------------------
		sql.append(")");
		sql.append("	ORDER BY");
		sql.append("	 DECODE(CODE_C3");
		sql.append("	 ,'380',1");
		sql.append("	 ,'74I',2");
		sql.append("	 ,'747',3");
		sql.append("	 ,'777',4");
		sql.append("	 ,'787',5");
		sql.append("	 ,'330',6");
		sql.append("	 ,'737',7");
		sql.append("	 ,'CSB',8");
		sql.append("	 ,'74F',9");
		sql.append("	 ,'77F',10");
		sql.append("	 ,'CCX',11");
		sql.append("	 ,'73W',12");
		sql.append("	 ,99) ASC");
		//---------------------------
		
		
		System.out.println("[BASE:OcbQ010Query:selReMonitor] sql : "+sql.toString());
		Logger.debug.println("[BASE:OcbQ010Query:selReMonitor] sql : "+sql.toString());
		return sql.toString();
	}		
	
	/** 
	  * Operations Control Board ۾ ȸ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2005/02/21 HIST 
	  */
	public String selWorkMon() {
		StringBuffer sql = new StringBuffer();
		
		//Operational Contral Board
		//۾ ϱ
		sql.append(" Select Code_c");
		sql.append("  From Code_T");
		sql.append(" Where Step_x = '1'  And");
		sql.append("       		Use_y  = 'N' And");
		sql.append("       		Code_x = 'REPORT MONTH'");
		
		System.out.println("[BASE:OcbQ010Query:selWorkMon] sql : "+sql.toString());
		Logger.debug.println("[BASE:OcbQ010Query:selWorkMon] sql : "+sql.toString());
		return sql.toString();
	}		
	
	/** 
	  * Operations Control Board Gauge1 ȸ SQLԼ.
	  * @param repordM String yyyymm
	  * @return String Query  
	  * @author Copyright (c) 2005/02/21 HIST 
	  */
	public String selGauge1(String repordM) {
		StringBuffer sql = new StringBuffer();
		
		//
		sql.append(" Select NVL(Round(((Sum(Flt_q1) - Sum(Flt_Q2))/Sum(Flt_q1))*100,1),0) gag_per");
		sql.append("   From Ops_Report_T");
		sql.append("  Where Report_d = '"+repordM+"' And");
		sql.append("        	 Report_x = 'A'");
		
		System.out.println("[BASE:OcbQ010Query:selGauge1] sql : "+sql.toString());
		Logger.debug.println("[BASE:OcbQ010Query:selGauge1] sql : "+sql.toString());
		return sql.toString();
	}		
	
	/** 
	  * Operations Control Board Gauge2 ȸ SQLԼ.
	  * @param repordM String yyyymm
	  * @return String Query  
	  * @author Copyright (c) 2005/02/21 HIST 
	  */
	public String selGauge2(String repordM) {
		StringBuffer sql = new StringBuffer();
		
		//
		sql.append(" Select NVL(Round(((Sum(Flt_q1) - Sum(Flt_Q2))/Sum(Flt_q1))*100,1),0) gag_per");
		sql.append("   From Ops_Report_T");
		sql.append("  Where Report_d = '"+repordM+"'  And");
		sql.append("        	 Report_x = 'B'  And");
		sql.append("        	 Code_c2  = 'D'");
		
		System.out.println("[BASE:OcbQ010Query:selGauge2] sql : "+sql.toString());
		Logger.debug.println("[BASE:OcbQ010Query:selGauge2] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * Operations Control Board Gauge3 ȸ SQLԼ.
	  * @param repordM String yyyymm
	  * @return String Query  
	  * @author Copyright (c) 2005/02/21 HIST 
	  */
	public String selGauge3(String repordM) {
		StringBuffer sql = new StringBuffer();
		
		//
		sql.append(" Select NVL(Round((Sum(Flt_Q2)/Sum(Flt_q1))*100,1),0) gag_per");
		sql.append("   From Ops_Report_T");
		sql.append("  Where Report_d = '"+repordM+"' And");
		sql.append("        	 Report_x = 'E'  And");
		sql.append("        	 Code_c2 = 'B'");
		
		System.out.println("[BASE:OcbQ010Query:selGauge3] sql : "+sql.toString());
		Logger.debug.println("[BASE:OcbQ010Query:selGauge3] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * Operations Control Board Gauge4 ȸ SQLԼ.
	  * @param repordM String yyyymm
	  * @return String Query  
	  * @author Copyright (c) 2005/02/21 HIST 
	  */
	public String selGauge4(String repordM) {
		StringBuffer sql = new StringBuffer();
		
		//
		sql.append(" Select NVL(Round((Sum(Flt_Q2)/Sum(Flt_q1))*100,1),0) gag_per");
		sql.append("   From Ops_Report_T");
		sql.append("  Where Report_d = '"+repordM+"' And");
		sql.append("       	 	 Report_x = 'I'      And");
		sql.append("        	 Code_c2 = 'A'");
		
		System.out.println("[BASE:OcbQ010Query:selGauge4] sql : "+sql.toString());
		Logger.debug.println("[BASE:OcbQ010Query:selGauge4] sql : "+sql.toString());
		return sql.toString();
	}				
	
	/** 
	  * Operations Control Board Gauge5 ȸ SQLԼ.
	  * @param reportD String yyyymmdd
	  * @return String Query  
	  * @author Copyright (c) 2005/04/01 HIST 
	  */
	public String selGauge5(String reportD) {
		StringBuffer sql = new StringBuffer();
		
		//Ͽ
		sql.append(" Select Decode(Actnid,'CNL','CNL','NEW') Actnid, Count(*) Data_Cnt, 'A' Flag");
		sql.append("   From Daily_Sch_t");
		sql.append("  Where 	Arln_cd = 'KE' And");
		sql.append("        		Sch_Dep_Dt Between 	To_Date('"+reportD+" 1500','yyyymmdd hh24mi')-1 And");
		sql.append("                           							To_Date('"+reportD+" 1459','yyyymmdd hh24mi') And");
		
		//2009.04.28  : 1, 2, 3...=> 10, 20, 30...  
		//sql.append("        		Leg_Num = 1 And");
		sql.append("        		Leg_Num In (1, 10) And");
		
		sql.append("			 	Kactyp Not In ('7FG','79S','7GG','ABH') And"); //2009.05.21 ߰ : 7GG, ABH
		sql.append("        		Dep_Sts <> 'INI'");
		sql.append("  Group By Decode(Actnid,'CNL','CNL','NEW')");
		sql.append(" UNION");
		sql.append(" Select 'CNL' Actnid, Count(*) Data_Cnt, 'B' Flag");
		sql.append("   From Daily_Sch_t");
		sql.append("  Where 	Arln_cd = 'KE' And");
		sql.append("        		Sch_Dep_Dt Between 	To_Date('"+reportD+" 1500','yyyymmdd hh24mi')-1 And");
		sql.append("                           							To_Date('"+reportD+" 1459','yyyymmdd hh24mi') And");
		sql.append("        		Timestamp <= Sch_Dep_Dt - 39/24 And");
		sql.append("        		Dep_Sts <> 'INI'  AND");
		
		//2009.04.28  : 1, 2, 3...=> 10, 20, 30...  
		//sql.append("        		Leg_Num = 1 And");
		sql.append("        		Leg_Num In (1, 10) And");
		
		sql.append("			 	Kactyp Not In ('7FG','79S','7GG','ABH') And"); //2009.05.21 ߰ : 7GG, ABH
		sql.append("        		ACTNID = 'CNL' ");
		
		System.out.println("[BASE:OcbQ010Query:selGauge5] sql : "+sql.toString());
		Logger.debug.println("[BASE:OcbQ010Query:selGauge5] sql : "+sql.toString());
		return sql.toString();
	}		

	/** 
	  * Operations Control Board Gauge7 ȸ SQLԼ.
	  * @param reportD String yyyymmdd
	  * @return String Query  
	  * @author Copyright (c) 2005/12/19 
	  */
	public String selGauge7(String reportD) {
		StringBuffer sql = new StringBuffer();	

		sql.append(" SELECT SUM(F.MACZFW_Q) MACZFWQ, SUM(F.MACZFW_IDEAL_Q) MACZFWIDEALQ ");
		sql.append(" FROM FC_FLT_FUEL_T@COPERA  F, CM_PORT_T P ");//@2014-03-03 sql.append(" FROM FC_FLT_FUEL_T@FUEL F, CM_PORT_T P ");
		sql.append(" WHERE F.ARLN_CD = 'KE' ");
		sql.append(" 	AND F.FIRST_LEG_FLT_DT BETWEEN TO_DATE('"+reportD+"', 'YYYYMMDD')-1 ");
		sql.append(" 										   AND TO_DATE('"+reportD+"', 'YYYYMMDD') ");
		sql.append(" 	AND F.ACT_DEP_DT BETWEEN TO_DATE('"+reportD+" 0101', 'YYYYMMDD HH24MI') - 9/24 ");
		sql.append(" 								 AND SYSDATE - 9/24 ");
		sql.append(" 	AND F.MACZFW_IDEAL_Q > 0 ");
		sql.append(" 	AND F.SACTYP <> 'GRJ' ");
		sql.append(" 	AND F.STNFR <> F.STNTO ");
		sql.append(" 	AND F.STNFR = P.IATA_PORT ");
		sql.append(" 	AND F.MACZFW_IDEAL_Q <= 98 ");
		sql.append(" 	AND NVL(P.DCS_ONLINE_Y, 'Y') = 'Y' ");
	
		System.out.println("[BASE:OcbQ010Query:selGauge7] sql : "+sql.toString());
		Logger.debug.println("[BASE:OcbQ010Query:selGauge7] sql : "+sql.toString());
		return sql.toString();
	}		

	/** 
	  * Operations Control Board Gauge8 ȸ SQLԼ.
	  * @param reportM String yyyymm
	  * @return String Query  
	  * @author Copyright (c) 2005/12/19 
	  */
	public String selGauge8(String repordM) {
		StringBuffer sql = new StringBuffer();	
			
		sql.append(" SELECT SUM(FLT_Q3) FLTQ3 ");
		sql.append(" FROM OPS_REPORT_T ");
		sql.append(" WHERE REPORT_D = '"+repordM+"' ");
		sql.append(" 	AND REPORT_X = 'J' ");
		sql.append(" 	AND CODE_C1 = 'Y' ");
		sql.append(" 	AND CODE_C2 = 'Y' ");
		sql.append(" 	AND CODE_C3 = 'Y' ");
		
		System.out.println("[BASE:OcbQ010Query:selGauge8] sql : "+sql.toString());
		Logger.debug.println("[BASE:OcbQ010Query:selGauge8] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * 10 ̳ IROPS ߻  ȸ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2010/07/13 
	  */
	public String selIropsCheck() {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT COUNT(*) CNT ");
		sql.append(" FROM DSS_IROPS_T A, DSS_IROPS_SCH_T B ");
		sql.append(" WHERE B.SCH_DEP_DT >= TO_DATE(TO_CHAR(SYSDATE,'YYYYMMDD')||'0000','YYYYMMDDHH24MI') - 9/24 ");
		sql.append(" AND B.SCH_DEP_DT <= TO_DATE(TO_CHAR(SYSDATE,'YYYYMMDD')||'2359','YYYYMMDDHH24MI') - 9/24 ");
		sql.append(" AND B.DSS_START_DT = A.DSS_START_DT ");
		sql.append(" AND B.SEQ_NUM = A.SEQ_NUM ");
		sql.append(" AND A.PROCESS_X IN ('A', 'M') ");
		sql.append(" AND B.HIDE_Y = 'N' ");
		sql.append(" AND A.DSS_DT >= SYSDATE - 10/1440 ");
		sql.append(" AND A.DSS_DT <= SYSDATE ");
		
		System.out.println("[BASE:OcbQ010Query:selIropsCheck] sql : "+sql.toString());
		
		Logger.debug.println("[BASE:OcbQ010Query:selIropsCheck] sql : "+sql.toString());
		return sql.toString();
	}

}//end of class
