package kal.base.rep.query;

import kal.base.jdf.com.Logger;
import kal.base.rep.dbbean.*;
import kal.base.com.query.*;
import kal.base.com.util.*;

/**
 * IROPS Report Ҹ ȭ鿡  Query
 * ۼ ¥: 2005-02-21
 * @author: HIST  
 */
public class RepQ070Query {
	private static RepQ070Query instance = new RepQ070Query();
	
	public static RepQ070Query getInstance() {
		return instance;
	}
	
	/** 
	  * IROPS Report Ҹ  ȸ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2005/02/21 HIST 
	  */
	public String selYyyyMm() {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" Select Code_c, Substr(Desc_e,1,6) Desc_e, Substr(Desc_e,7,1) Complete_y");
		sql.append(" From 	Code_T");
		sql.append(" Where Step_x = '1' And");
		sql.append(" 			Use_y  = 'N' And");
		sql.append(" 			Code_x = 'REPORT MONTH' And");
		sql.append(" 			End_D  > To_Char(SYSDATE,'yyyymmdd')");
		sql.append(" Order By Prty_no");
		/*
		sql.append(" Select Code_c, Substr(Desc_e,1,6) Desc_e");
		sql.append("  From Code_T");
		sql.append(" Where Step_x = '1'                 And");
		sql.append("       		Use_y  = 'N'                 And");
		sql.append(" 			Code_x = 'REPORT MONTH'            And");
		sql.append(" 			End_D  > To_Char(SYSDATE,'yyyymmdd')");
		sql.append(" Order By Prty_no");
		*/
		Logger.debug.println("[BASE:RepQ070Query:selYyyyMm] sql : "+sql.toString());
		return sql.toString();
	}		
	
	/** 
	  * IROPS Report Ҹ  ȸ SQLԼ.
	  * @param reportD String ȸ yyyymm
	  * @return String Query  
	  * @author Copyright (c) 2005/02/21 HIST 
	  */
	public String selArea(String reportD) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" Select Decode(Code_c1,'D','A','I','B','C') Flag,");
		sql.append("        	Round(Sum(Flt_q1),-3)/1000 Skd_q, Round(Sum(Flt_q2),-3)/1000 Act_q,");
		sql.append("        	Round((Sum(Flt_q2) - Sum(Flt_q1)),-3)/1000 Rev_q,");
		sql.append("        	Round((((Sum(Flt_q2) - Sum(Flt_q1)) / Sum(Flt_q1)) * 100),1) Rev_p");
		sql.append("   From Ops_Report_T");
		sql.append("  Where 	Report_d = '"+reportD+"' And");
		sql.append("        		Report_x = 'I'      And");
		sql.append("        		Code_c2 = 'A'");
		sql.append(" Group By Decode(Code_c1,'D','A','I','B','C')");
		
		Logger.debug.println("[BASE:RepQ070Query:selArea] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * IROPS Report Ҹ  ȸ SQLԼ.
	  * @param reportD String ȸ yyyymm
	  * @return String Query  
	  * @author Copyright (c) 2005/02/21 HIST 
	  */
	public String selActyp(String reportD) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" Select Decode(Code_c1,'C','B','A') Flag, Code_c3 Actyp, Sum(Flt_q1) Skd_q, Sum(Flt_q2) Act_q,");
		sql.append("        	(Sum(Flt_q2) - Sum(Flt_q1)) Rev_q,");
		sql.append("        	Round((((Sum(Flt_q2) - Sum(Flt_q1)) / Sum(Flt_q1)) * 100),1) Rev_p");
		sql.append("   From Ops_Report_T");
		sql.append("  Where 	Report_d = '"+reportD+"' And");
		sql.append("        		Report_x = 'I'      And");
		sql.append("        		Code_c2 = 'A'");
		sql.append(" Group By Decode(Code_c1,'C','B','A'), Code_c3");
		
		Logger.debug.println("[BASE:RepQ070Query:selActyp] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * IROPS Report Ҹ Fuel Dumping ȸ SQLԼ.
	  * @param mode String 'N' , 'B' 
	  * @param reportD String ȸ yyyymm
	  * @return String Query  
	  * @author Copyright (c) 2005/02/21 HIST 
	  */
	public String selDumping(String mode, String reportD) {
		StringBuffer sql = new StringBuffer();
		/*
		sql.append(" Select Report_d, Flt_q1, Flt_q2");
		sql.append(" From 	Ops_Report_t");
		sql.append(" Where Report_d in ('"+reportD+"',To_Char(To_Date('"+reportD+"','yyyymm')-365,'yyyymm')) And");
		sql.append("       		Report_x = 'I'      And");
		sql.append("       		Code_c2 = 'D'");
		sql.append(" Union All");
		sql.append(" Select Substr(Report_d,1,4) Report_d, Sum(Flt_q1) Flt_q1, Sum(Flt_q2) Flt_q2");
		sql.append(" From 	Ops_Report_t");
		sql.append(" Where ((Report_d Between '"+reportD.substring(0,4)+"01' And '"+reportD+"') OR (Report_d Between To_Char(To_Date('"+reportD.substring(0,4)+"01','yyyymm')-365,'yyyymm') And To_Char(To_Date('"+reportD+"','yyyymm')-365,'yyyymm'))) And");
		sql.append("       		Report_x = 'I' And");
		sql.append("       		Code_C2 = 'D'");
		sql.append(" Group By Substr(Report_d,1,4)");
		*/
		
		sql.append(" Select Report_d, Flt_q1, Flt_q2");
		sql.append(" From 	Ops_Report_t");
		if (mode.equals("N"))	//
			sql.append(" Where	Report_d = '"+reportD+"' And");
		else 							//
			sql.append(" Where	Report_d = To_Char(To_Date('"+reportD+"','yyyymm')-365,'yyyymm') And");
		sql.append("       		Report_x = 'I'      And");
		sql.append("       		Code_c2 = 'D'");

		
		Logger.debug.println("[BASE:RepQ070Query:selDumping] sql : "+sql.toString());
		return sql.toString();
	}		
	
	/** 
	  * IROPS Report Ҹ Fuel Dumping Sum ȸ SQLԼ.
	  * @param mode String 'N' , 'B' 
	  * @param reportD String ȸ yyyymm
	  * @return String Query  
	  * @author Copyright (c) 2005/02/21 HIST 
	  */
	public String selDumpingSum(String mode, String reportD) {
		StringBuffer sql = new StringBuffer();

		sql.append(" Select Substr(Report_d,1,4) Report_d, Sum(Flt_q1) Flt_q1, Sum(Flt_q2) Flt_q2");
		sql.append(" From 	Ops_Report_t");
		if (mode.equals("N"))	//
			sql.append(" Where Report_d Between '"+reportD.substring(0,4)+"01' And '"+reportD+"' And");
		else 							//
			sql.append(" Where Report_d Between To_Char(To_Date('"+reportD.substring(0,4)+"01','yyyymm')-365,'yyyymm') And To_Char(To_Date('"+reportD+"','yyyymm')-365,'yyyymm') And");
		sql.append("       		Report_x = 'I' And");
		sql.append("       		Code_C2 = 'D'");
		sql.append(" Group By Substr(Report_d,1,4)");
		
		Logger.debug.println("[BASE:RepQ070Query:selDumpingSum] sql : "+sql.toString());
		return sql.toString();
	}			
	
}//end of class
