package kal.base.rep.query;

import kal.base.jdf.com.Logger;
import kal.base.rep.dbbean.RepQ310BG;
import kal.base.com.query.*;

 /**
   * Management Board SQL 
   * @author Copyright (c) 2005/07/22 
   */  
public class RepQ310Query {
	private static RepQ310Query instance = new RepQ310Query();
	
	public static RepQ310Query getInstance() {
		return instance;
	}
	
	/** 
	  * Operation ȸ SQLԼ.
	  * @param entity RepQ310BG Operation
	  * @return String Query 
	  * @author Copyright (c) 2005/07/22 
	  */
	public String selOperation(RepQ310BG entity) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" select To_Char(Sch_Dep_Dt+9/24,'yyyymmdd') Sch_Dep_Dt, ");
		sql.append("          Region_Flt, ");
		sql.append(" 	    Decode(kactyp,'M1F','CGO','7FQ','CGO','7FR','CGO','74Y','CGO','7FG','CGO','79S','CGO','7GG','CGO','ABH','CGO','74F','CGO','74N','CGO','77X','CGO', Decode(Region_Flt,1,'DOM','PAX')) Dom_Pax, "); //2009.05.21 ߰ : 7GG, ABH //2009.05.21 ߰ : ABH, 2010.03.26 ߰ : 74F //2012.02.22 ߰ 74N, 77X
		sql.append("          Decode(Actnid,'CNL','CNL','NEW') New_Cnl, ");
		sql.append(" 		Decode(Nvl(Del_Dur1,0),0,'REG','DEL') Reg_Del, "); 
		sql.append(" 		Count(*) Cnt, ");
		sql.append(" 		Sum(Nvl(F_Cfg + C_Cfg + Y_Cfg, 0)) Sum_1, ");
		sql.append(" 		Sum(Nvl(F_Book + C_Book + Y_Book, 0)) Sum_2, "); 
		sql.append(" 		Sum(Nvl(F_Chkin + C_Chkin + Y_Chkin, 0)) Sum_3 ");
		sql.append(" From Daily_Sch_t ");
		sql.append(" Where Sch_Dep_Dt >= To_Date('"+entity.getToday()+" 0000','yyyymmdd hh24mi') - 33/24 And ");
		sql.append("          Sch_Dep_Dt <= To_Date('"+entity.getToday()+" 2359' ,'yyyymmdd hh24mi') - 9/24 And ");
		sql.append("          Stnfr <> Stnto And  ");
		sql.append("          (Dep_Sts = 'ACT' or (Actnid = 'CNL' And Sch_Dep_Dt <= TimeStamp + 36/24)) ");
		sql.append(" Group By To_Char(Sch_Dep_Dt+9/24,'yyyymmdd'), ");
		sql.append("           Region_Flt, Decode(kactyp,'M1F','CGO','7FQ','CGO','7FR','CGO','74Y','CGO','7FG','CGO','79S','CGO','7GG','CGO','ABH','CGO','74F','CGO','74N','CGO','77X','CGO', Decode(Region_Flt,1,'DOM','PAX')), "); //2009.05.21 ߰ : 7GG, ABH //2009.05.21 ߰ : ABH, 2010.03.26 ߰ : 74F //2012.02.22 ߰ 74N, 77X
		sql.append("           Decode(Actnid,'CNL','CNL','NEW'), ");
		sql.append("           Decode(Nvl(Del_Dur1,0),0,'REG','DEL') ");
		
		//System.out.println("[BASE:RepQ310Query:selOperation] sql : "+sql.toString());
		Logger.debug.println("[BASE:RepQ310Query:selOperation] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * ۾ ȸ SQLԼ.
	  * @param entity RepQ310BG Operation
	  * @return String Query 
	  * @author Copyright (c) 2005/07/26 
	  */
	public String selMonth(RepQ310BG entity) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" Select Code_c ");
		sql.append(" From Code_T ");
		sql.append(" Where Step_x = '1' And ");
		sql.append("		Use_y  = 'N' And  ");
		sql.append(" 	Code_x = 'REPORT MONTH' ");
			
		Logger.debug.println("[BASE:RepQ310Query:selMonth] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * Monthly Report ȸ SQLԼ.
	  * @param entity RepQ310BG Operation
	  * @return String Query 
	  * @author Copyright (c) 2005/07/26 
	  */
	public String selMonthlyReport(RepQ310BG entity) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" Select  Report_x, Report_d, Sum(Flt_Q1) Sum1, Sum(Flt_Q2) Sum2, Sum(Flt_Q3) Sum3 ");
		sql.append(" From Ops_Report_T ");
		sql.append(" Where Report_d Between To_Char(add_months(To_Date('"+entity.getReport_d()+"','yyyymm'),-11),'yyyymm') And '"+entity.getReport_d()+"' And ");
		sql.append(" 	Report_x = 'A' ");
		sql.append(" Group By Report_x, Report_d ");
		sql.append(" Union ");
		sql.append(" Select  Report_x, Report_d, Sum(Flt_Q1) Sum1, Sum(Flt_Q2) Sum2, Sum(Flt_Q3) Sum3  ");
		sql.append(" From Ops_Report_T ");
		sql.append(" Where Report_d Between To_Char(add_months(To_Date('"+entity.getReport_d()+"','yyyymm'),-11),'yyyymm') And '"+entity.getReport_d()+"' And ");
		sql.append(" 	Report_x = 'B' And ");
		sql.append(" 	Code_c2 = 'D' ");
		sql.append(" Group By Report_x, Report_d ");
		sql.append(" Union ");
		sql.append(" Select  Report_x, Report_d, Sum(Flt_Q1) Sum1, Sum(Flt_Q2) Sum2, Sum(Flt_Q3) Sum3  ");
		sql.append(" From Ops_Report_T ");
		sql.append(" Where Report_d Between To_Char(add_months(To_Date('"+entity.getReport_d()+"','yyyymm'),-11),'yyyymm') And '"+entity.getReport_d()+"' And ");
		sql.append(" 	Report_x = 'L' ");
		sql.append(" Group By Report_x, Report_d ");
		sql.append(" Order By 1, 2 ");
		
		Logger.debug.println("[BASE:RepQ310Query:selMonthlyReport] sql : "+sql.toString());
		return sql.toString();
	}
}
