package kal.base.skd.query;

import kal.base.jdf.com.Logger;
import kal.base.skd.dbbean.SkdQ020BG;

 /**
   * Flight Progress Information SQL 
   * @author Copyright (c) 2005/01/20 
   */    
public class SkdQ020Query {
	
	private static SkdQ020Query instance = new SkdQ020Query();
	
	public static SkdQ020Query getInstance() {
		return instance;
	}
	/** 
	  * Flight Progress Information main ȸ SQLԼ.
	  * @param entity SkdQ020BG Flight Progress Information
	  * @return String Query 
	  * @author Copyright (c) 2005/01/20 
	  */
	public String selMain(SkdQ020BG entity) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" Select ");
		sql.append(" 	    Est_Dep_Dt Ord_1,Sch_Dep_Dt Ord_2,");
		if(entity.getTime_x().equals("UTC")){			
			sql.append(" 	Flt_Num, To_Char(Sch_Dep_Dt,'yyyy-mm-dd') Sch_Dep_Date, Kactyp, Regno, Stnfr,  Stnto, ");
			sql.append("		Spot_Out, Spot_In, To_Char(Sch_Dep_Dt,'hh24:mi') Sch_Dep_Dt, To_Char(Sch_Arv_Dt,'hh24:mi') Sch_Arv_Dt, ");
			sql.append(" 	To_Char(Est_Dep_Dt,'hh24:mi') Est_Dep_Dt, To_Char(Act_Dep_Dt,'hh24:mi') Act_Dep_Dt, ");
			sql.append(" 	Dep_Gmt_Offset, Dep_Sts, Arv_Sts, To_Char(Est_Arv_Dt,'hh24:mi') Est_Arv_Dt, ");
			sql.append(" 	To_Char(Act_Arv_Dt,'hh24:mi') Act_Arv_Dt, Arv_Gmt_Offset, To_Char(Sch_Dep_Dt,'yyyymmddhh24mi') Sch_Dep_Dt_Full, ");
			sql.append("		(Substr(Tkof_t,1,2)||':'||Substr(Tkof_t,3,2)) Tkof_t, (Substr(Land_t,1,2)||':'||Substr(Land_t,3,2)) Land_t, ");
		}
		else if(entity.getTime_x().equals("KST")){
			sql.append(" 	Flt_Num, To_Char(Sch_Dep_Dt + (540/1440),'yyyy-mm-dd') Sch_Dep_Date, Kactyp, Regno, Stnfr,  Stnto, ");
			sql.append("		Spot_Out, Spot_In, To_Char(Sch_Dep_Dt + (540/1440),'hh24:mi') Sch_Dep_Dt, To_Char(Sch_Arv_Dt + (540/1440),'hh24:mi') Sch_Arv_Dt, ");
			sql.append(" 	To_Char(Est_Dep_Dt + (540/1440),'hh24:mi') Est_Dep_Dt, To_Char(Act_Dep_Dt + (540/1440),'hh24:mi') Act_Dep_Dt, ");
			sql.append(" 	Dep_Gmt_Offset, Dep_Sts, Arv_Sts, To_Char(Est_Arv_Dt + (540/1440),'hh24:mi') Est_Arv_Dt, ");
			sql.append(" 	To_Char(Act_Arv_Dt + (540/1440),'hh24:mi') Act_Arv_Dt, Arv_Gmt_Offset, To_Char(Sch_Dep_Dt + (540/1440),'yyyymmddhh24mi') Sch_Dep_Dt_Full, ");
			//sql.append("		TO_CHAR(TO_DATE(TO_CHAR(SYSDATE,'YYYYMMDD')||NVL(TRIM(Tkof_t),'0000'),'YYYYMMDDHH24MI')+(540/1440),'HH24:MI') Tkof_t,");
			//sql.append(" 	TO_CHAR(TO_DATE(TO_CHAR(SYSDATE,'YYYYMMDD')||NVL(TRIM(Land_t),'0000'),'YYYYMMDDHH24MI')+(540/1440),'HH24:MI') Land_t,");
			//@2018-03-28
			sql.append("	Decode(Nvl(Trim(Tkof_t),'X'),'X',' ', To_Char(To_Date(To_Char(Sysdate,'yyyymmdd') || Tkof_T,'yyyymmddhh24mi') + (540/1440),'hh24:mi')) Tkof_t,");
			sql.append(" 	Decode(Nvl(Trim(Land_t),'X'),'X',' ', To_Char(To_Date(To_Char(Sysdate,'yyyymmdd') || Land_T,'yyyymmddhh24mi') + (540/1440),'hh24:mi')) Land_t,");
		}
		else if(entity.getTime_x().equals("LOC")){
			sql.append(" 	Flt_Num, To_Char(Sch_Dep_Dt_Loc,'yyyy-mm-dd') Sch_Dep_Date, Kactyp, Regno, Stnfr,  Stnto, ");
			sql.append("		Spot_Out, Spot_In, To_Char(Sch_Dep_Dt_Loc,'hh24:mi') Sch_Dep_Dt, To_Char(Sch_Arv_Dt_Loc,'hh24:mi') Sch_Arv_Dt, ");
			sql.append(" 	To_Char(Est_Dep_Dt_Loc,'hh24:mi') Est_Dep_Dt, To_Char(Act_Dep_Dt_Loc,'hh24:mi') Act_Dep_Dt, ");
			sql.append(" 	Dep_Gmt_Offset, Dep_Sts, Arv_Sts, To_Char(Est_Arv_Dt_Loc,'hh24:mi') Est_Arv_Dt, ");
			sql.append(" 	To_Char(Act_Arv_Dt_Loc,'hh24:mi') Act_Arv_Dt, Arv_Gmt_Offset, To_Char(Sch_Dep_Dt_Loc,'yyyymmddhh24mi') Sch_Dep_Dt_Full, ");
			//sql.append("		TO_CHAR(TO_DATE(TO_CHAR(SYSDATE,'YYYYMMDD')||NVL(TRIM(Tkof_t),'0000'),'YYYYMMDDHH24MI')+(DEP_GMT_OFFSET/1440),'HH24:MI') Tkof_t,");
			//sql.append(" 	TO_CHAR(TO_DATE(TO_CHAR(SYSDATE,'YYYYMMDD')||NVL(TRIM(Land_t),'0000'),'YYYYMMDDHH24MI')+(ARV_GMT_OFFSET/1440),'HH24:MI') Land_t,");
			
			//@2018-03-28
			sql.append("	Decode(Nvl(Trim(Tkof_t),'X'),'X',' ', To_Char(To_Date(To_Char(Sysdate,'yyyymmdd') || Tkof_T,'yyyymmddhh24mi') + (Dep_Gmt_Offset/1440),'hh24:mi')) Tkof_t,");
			sql.append(" 	Decode(Nvl(Trim(Land_t),'X'),'X',' ', To_Char(To_Date(To_Char(Sysdate,'yyyymmdd') || Land_T,'yyyymmddhh24mi') + (Arv_Gmt_Offset/1440),'hh24:mi')) Land_t,");
		}
		sql.append(" 	Nvl(Del_Rc1,' ') Del_Rc1, Del_Dur1, Nvl(Del_Rc2,' ') Del_Rc2, Del_Dur2, ");
		sql.append(" 	To_Char(Act_Dep_Dt + (540/1440),'yyyymmddhh24mi') Act_Dep_Dt_Kst, To_Char(First_Leg_Flt_Dt,'yyyymmdd') First_Leg_Flt_Dt, ");
		sql.append("		HIDEINFO, "); // 2006.09.15 ==> ߰
		sql.append("		ADMRAD "); //2008.02.21 ߰ : ADMRAD 'A' or 'R' 츸 REGNO Display
		
		//20150605 ߰
		sql.append("        , To_Char(Sch_Dep_Dt_Loc ,'yyyymmdd') Sch_Dep_Dt_Loc ");
		
		sql.append(" From ");
		sql.append(" 	Daily_Sch_T ");
		sql.append(" Where ");
		sql.append(" 	Arln_Cd = 'KE' And ");
		sql.append(" 	SUBSTR(FLT_NUM, 1, 1) <> '4' AND "); //2008.12.02 ߰ :  FLT 
		if(entity.getTime_x().equals("UTC")){			
			sql.append(" 	Sch_Dep_Dt >= To_Date('"+entity.getStart_date()+" 0000','yyyymmdd hh24mi') And ");
			sql.append(" 	Sch_Dep_Dt <= To_Date('"+entity.getEnd_date()+" 2359','yyyymmdd hh24mi') And ");
		}
		else if(entity.getTime_x().equals("KST")){
			sql.append(" 	Sch_Dep_Dt >= To_Date('"+entity.getStart_date()+" 0000','yyyymmdd hh24mi') - (540/1440) And ");
			sql.append(" 	Sch_Dep_Dt <= To_Date('"+entity.getEnd_date()+" 2359','yyyymmdd hh24mi') - (540/1440) And ");
		}
		else if(entity.getTime_x().equals("LOC")){
			sql.append(" 	Sch_Dep_Dt_Loc >= To_Date('"+entity.getStart_date()+" 0000','yyyymmdd hh24mi') And ");
			sql.append(" 	Sch_Dep_Dt_Loc <= To_Date('"+entity.getEnd_date()+" 2359','yyyymmdd hh24mi') And ");
		}
		sql.append(" 	Dep_Sts    <> 'INI'  And ");
		sql.append(" 	Actnid       <> 'CNL'  ");
		if(!entity.getStnfr().equals("")){
			sql.append("  And (StnFr = '"+entity.getStnfr()+"' Or Stnto = '"+entity.getStnfr()+"')  ");
		}
		if(!entity.getFlt_num().equals("")){
			sql.append("	And Flt_Num = '"+entity.getFlt_num()+"'  ");	
		}
		if(!entity.getRegno().equals("")){
			sql.append("  And Regno = 'HL"+entity.getRegno()+"' ");
		}
		sql.append(" Order By Ord_1,Ord_2");
		
		System.out.println("[BASE:SkdQ020Query:selMain] sql : "+sql.toString());
		//Logger.debug.println("[BASE:SkdQ020Query:selMain] sql : "+sql.toString());
		return sql.toString();
	}
}
