package kal.base.skd.query;

import kal.base.iro.dbbean.IroQ470BG;
import kal.base.jdf.com.Logger;
import kal.base.skd.dbbean.*;

 /**
   * SKD/Detail FLT Status SQL 
   * @author Copyright (c) 2005/01/20 HIST  
   */    
public class SkdQ040Query {
	private static SkdQ040Query instance = new SkdQ040Query();
	
	public static SkdQ040Query getInstance() {
		return instance;
	}
	
	/** 
	  * SKD/Detail FLT Status ⺻ ȸ SQLԼ.
	  * @param params SkdQ040BG ȸ
	  * @return String Query 
	  * @author Copyright (c) 2005/01/20 HIST 
	  */
	public String selBasicInfo(SkdQ040BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" Select Flt_Num,To_Char(Sch_Dep_Dt,'yyyy-mm-dd') Sch_Dep_Dt,Kactyp,Acver,Regno,Stnfr,Stnto");
		sql.append(" From Daily_Sch_t");
		
		if (params.getTime_x().equals("KST")) {
			sql.append(" Where Sch_Dep_Dt = To_Date('"+params.getSch_dep_dt()+"','yyyymmddhh24mi')-(540/1440) And");
		} else if (params.getTime_x().equals("LOC")) {
			sql.append(" Where Sch_Dep_Dt_Loc = To_Date('"+params.getSch_dep_dt()+"','yyyymmddhh24mi') And");
		} else {
			sql.append(" Where Sch_Dep_Dt = To_Date('"+params.getSch_dep_dt()+"','yyyymmddhh24mi') And");
		}
		sql.append("       		Flt_Num    = '"+params.getFlt_num()+"' And");
		sql.append("       		Stnfr      = '"+params.getStnfr()+"' And");
		sql.append("       		Stnto     = '"+params.getStnto()+"' And");
		sql.append("       		Arln_Cd = 'KE'");
		
		Logger.debug.println("[BASE:SkdQ040Query:selBasicInfo] sql : "+sql.toString());
		//System.out.println("[BASE:SkdQ040Query:selBasicInfo] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * SKD/Detail FLT Status  ȸ SQLԼ.
	  * @param params SkdQ040BG ȸ
	  * @return String Query 
	  * @author Copyright (c) 2005/01/20 HIST 
	  */
	public String selFltInfo(SkdQ040BG params) {
		StringBuffer sql = new StringBuffer();
	
		sql.append(" Select A.Flt_Num, A.Kactyp, A.Regno, A.Stnfr, A.Stnto,");
		if (params.getTime_x().equals("KST")) {
			sql.append("		To_Char(A.Sch_Dep_Dt+(540/1440),'yyyy-mm-dd') Sch_Dep_Dt, To_Char(A.Sch_Dep_Dt+(540/1440),'hh24:mi') Sch_Dep_Tm,");
			sql.append("		To_Char(A.Sch_Arv_Dt+(540/1440),'hh24:mi') Sch_Arv_Tm,To_Char(A.Est_Dep_Dt+(540/1440),'hh24:mi') Est_Dep_Tm,");
			sql.append("		To_Char(A.Act_Dep_Dt+(540/1440),'hh24:mi') Act_Dep_Tm,To_Char(A.Est_Arv_Dt+(540/1440),'hh24:mi') Est_Arv_Tm,");
			sql.append("		To_Char(A.Act_Arv_Dt+(540/1440),'hh24:mi') Act_Arv_Tm, ");
			sql.append("      	A.Spot_Out, A.Spot_In,A.Dep_Gmt_Offset,A.Dep_Sts, A.Arv_Sts,A.Arv_Gmt_Offset,");
			// 2006.04.20  ==> TOFF, TDWN, 2017.01.11 DECODE ߰
			sql.append("		DECODE(Nvl(Trim(A.Tkof_t),':'),':','', TO_CHAR(TO_DATE(TO_CHAR(SYSDATE,'YYYYMMDD')||NVL(TRIM(A.Tkof_t),'0000'),'YYYYMMDDHH24MI')+(540/1440),'HH24:MI')) Tkof_t,");
			sql.append(" 		DECODE(Nvl(Trim(A.Land_t),':'),':','', TO_CHAR(TO_DATE(TO_CHAR(SYSDATE,'YYYYMMDD')||NVL(TRIM(A.Land_t),'0000'),'YYYYMMDDHH24MI')+(540/1440),'HH24:MI')) Land_t,");
		} else if (params.getTime_x().equals("LOC")) {
			sql.append("		To_Char(A.Sch_Dep_Dt_Loc,'yyyy-mm-dd') Sch_Dep_Dt, To_Char(A.Sch_Dep_Dt_Loc,'hh24:mi') Sch_Dep_Tm,");
			sql.append("		To_Char(A.Sch_Arv_Dt_Loc,'hh24:mi') Sch_Arv_Tm,To_Char(A.Est_Dep_Dt_Loc,'hh24:mi') Est_Dep_Tm,");
			sql.append("		To_Char(A.Act_Dep_Dt_Loc,'hh24:mi') Act_Dep_Tm,To_Char(A.Est_Arv_Dt_Loc,'hh24:mi') Est_Arv_Tm,");
			sql.append("		To_Char(A.Act_Arv_Dt_Loc,'hh24:mi') Act_Arv_Tm, ");
			sql.append("      A.Spot_Out, A.Spot_In,A.Dep_Gmt_Offset,A.Dep_Sts, A.Arv_Sts,A.Arv_Gmt_Offset,");
			// 2006.04.20  ==> TOFF, TDWN, 2017.01.11 DECODE ߰
			sql.append("		DECODE(Nvl(Trim(A.Tkof_t),':'),':','', TO_CHAR(TO_DATE(TO_CHAR(SYSDATE,'YYYYMMDD')||NVL(TRIM(A.Tkof_t),'0000'),'YYYYMMDDHH24MI')+(A.DEP_GMT_OFFSET/1440),'HH24:MI')) Tkof_t,");
			sql.append(" 		DECODE(Nvl(Trim(A.Land_t),':'),':','', TO_CHAR(TO_DATE(TO_CHAR(SYSDATE,'YYYYMMDD')||NVL(TRIM(A.Land_t),'0000'),'YYYYMMDDHH24MI')+(A.ARV_GMT_OFFSET/1440),'HH24:MI')) Land_t,");
		} else {
			sql.append("		To_Char(A.Sch_Dep_Dt,'yyyy-mm-dd') Sch_Dep_Dt, To_Char(A.Sch_Dep_Dt,'hh24:mi') Sch_Dep_Tm,");
			sql.append("		To_Char(A.Sch_Arv_Dt,'hh24:mi') Sch_Arv_Tm,To_Char(A.Est_Dep_Dt,'hh24:mi') Est_Dep_Tm,");
			sql.append("		To_Char(A.Act_Dep_Dt,'hh24:mi') Act_Dep_Tm,To_Char(A.Est_Arv_Dt,'hh24:mi') Est_Arv_Tm,");
			sql.append("		To_Char(A.Act_Arv_Dt,'hh24:mi') Act_Arv_Tm, ");
			sql.append("      	A.Spot_Out, A.Spot_In,A.Dep_Gmt_Offset,A.Dep_Sts, A.Arv_Sts,A.Arv_Gmt_Offset,");
			// 2006.04.20  ==> TOFF, TDWN
			sql.append("      	DECODE(Nvl(Trim(A.Tkof_t),':'),':','', SUBSTR(A.Tkof_t,1,2)||':'||SUBSTR(A.Tkof_t,3,2)) Tkof_t,");
			sql.append("      	DECODE(Nvl(Trim(A.Land_t),':'),':','', SUBSTR(A.Land_t,1,2)||':'||SUBSTR(A.Land_t,3,2)) Land_t,");
		}
		sql.append("        	Nvl(A.Del_Rc1,' ') Del_Rc1, A.Del_Dur1, Nvl(A.Del_Rc2,' ') Del_Rc2, A.Del_Dur2,");
		
		//@2017-10-26 ߰
		sql.append("        	Nvl(A.Del_Rc3,' ') Del_Rc3, A.Del_Dur3,");
		
		
		sql.append("        	To_Char(A.First_leg_Flt_Dt,'yyymmddhh24mi') First_leg_Flt_Dt");
		sql.append(" From Daily_Sch_T A, Daily_Sch_T B");
		sql.append(" Where B.Arln_Cd = 'KE' And");
		if (params.getTime_x().equals("KST")) {
			sql.append("			B.Sch_Dep_Dt = To_Date('"+params.getSch_dep_dt()+"','yyyymmddhh24mi')-(540/1440) And");
		} else if (params.getTime_x().equals("LOC")) {
			sql.append("          B.Sch_Dep_Dt_Loc = To_Date('"+params.getSch_dep_dt()+"','yyyymmddhh24mi') And");
		} else {
			sql.append("          B.Sch_Dep_Dt = To_Date('"+params.getSch_dep_dt()+"','yyyymmddhh24mi') And");
		}
		sql.append("       		B.Flt_Num    = '"+params.getFlt_num()+"' And");
		sql.append("       		B.Stnfr      = '"+params.getStnfr()+"' And");
		sql.append("       		B.Stnto     <> '"+params.getStnfr()+"' And");
		sql.append("       		A.Arln_Cd = 'KE' And");
		sql.append("       		A.First_Leg_Flt_Dt = B.First_Leg_Flt_Dt And");
		sql.append("       		A.Flt_Num = B.Flt_Num");
		sql.append(" Order By Sch_Dep_Dt, Flt_Num");
		
		Logger.debug.println("[BASE:SkdQ040Query:selFltInfo] sql : "+sql.toString());
		//System.out.println("[BASE:SkdQ040Query:selFltInfo] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * SKD/Detail FLT Status Category  ȸ SQLԼ.
	  * @param params SkdQ040BG ȸ
	  * @return String Query 
	  * @author Copyright (c) 2005/03/11 HIST 
	  */
	public String selCategoryInfo(SkdQ040BG params) {
		StringBuffer sql = new StringBuffer();
	
		sql.append(" Select A.First_Leg_Flt_Dt, A.aactyp, 'KE'||A.Flt_Num Flt_Num, A.Stnfr, A.Stnto,");
		sql.append("        	A.Regno, A.Cat_x, To_Char(B.Latest_Autodt,'yyyy-mm-dd') Cat_Date,");
		sql.append("        	To_Char(B.Latest_Autodt,'hh24:mi') Cat_Time,To_Char(B.Latest_Autodt,'mondd') Cat_Mon,");
		sql.append("        	To_Char(B.Cat2_Expdt,'yyyy-mm-dd') Cat2_Exp_Date,");
		sql.append("        	To_Char(B.Cat2_Expdt,'hh24:mi') Cat2_Time, To_Char(B.Cat2_Expdt,'mondd') Cat2_Mon,");
		sql.append("        	To_Char(B.Cat3_Expdt,'yyyy-mm-dd') Cat3_Date,");
		sql.append("        	To_Char(B.Cat3_Expdt,'hh24:mi') Cat3_Time, To_Char(B.Cat3_Expdt,'mondd') Cat3_Mon");
		sql.append("   From PE_ACARS_SKD_T A, PE_ACREG_INFO_T B,");
		sql.append("        	(Select Max(Act_On_Dt) Act_On_Dt, Regno");
		sql.append("           	 From PE_ACARS_SKD_T");
		sql.append("          	 Where CAT_x = 'Y'");
		sql.append(" 				 AND REGNO = '"+params.getRegno()+"' "); //2009.10.12 ߰
		sql.append("          	 Group By Regno) C");
		sql.append("  Where 	A.Regno = B.Regno And");
		sql.append("        		A.Regno = C.Regno And");
		sql.append("        		A.Regno = '"+params.getRegno()+"'  And");
		sql.append("        		A.Cat_x = 'Y'     And");
		sql.append("        		A.Act_On_Dt = C.Act_On_Dt And");
		sql.append("        		RowNum = 1");
		sql.append("  Order By A.Act_On_Dt Desc");
		
		Logger.debug.println("[BASE:SkdQ040Query:selCategoryInfo] sql : "+sql.toString());
		//System.out.println("[BASE:SkdQ040Query:selCategoryInfo] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * CREW INFORMATION(CREW INFO, CREW PREV, NEXT FLT INFO) ȸ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2009/10/12 
	  */
	public String selCrewInfoNew(SkdQ040BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT B.STAFF_NUM, SUBSTR(B.ENG_NAME,1,30) ENG_NAME, ");
		sql.append(" DECODE(B.RANK_NR, '11', 'CAP', '12', 'F/O', 'F/E') RANK, ");
		sql.append(" DECODE(B.RANK_NR, '11', 'FLY', '12', 'FLY', '13', 'FLY', 'EXT') DUTY, ");
		sql.append(" PRV_ARLN_CD||PRV_FLT_NUM||'/'||TO_CHAR(PRV_DEP_LDT, 'DDMONYY')||' - '||PRV_STNFR||'/'||PRV_STNTO PREV_INFO, ");
		sql.append(" NXT_ARLN_CD||NXT_FLT_NUM||'/'||TO_CHAR(NXT_DEP_LDT, 'DDMONYY')||' - '||NXT_STNFR||'/'||NXT_STNTO NEXT_INFO ");
		sql.append(" FROM GD_SKD_T A, GD_CREW_T B ");
		sql.append(" WHERE A.FIRST_LEG_FLT_DT = TO_DATE('"+params.getFirst_leg_flt_dt()+"','YYYYMMDD') ");
		sql.append(" AND A.FLT_NUM = '"+params.getFlt_num()+"' ");
		sql.append(" AND (A.STNFR = '"+params.getStnfr()+"' OR A.STNTO = '"+params.getStnto()+"') ");
		sql.append(" AND A.FLT_SEQ_NR = B.FLT_SEQ_NR ");
		sql.append(" AND B.RANK_NR LIKE '1%' ");
		sql.append(" AND DA_IND = 'A' ");
		sql.append(" AND (B.CREW_SEQ_NR, B.STAFF_NUM) IN ");
		sql.append(" (SELECT MAX(CREW_SEQ_NR), STAFF_NUM ");
		sql.append(" FROM GD_CREW_T ");
		sql.append(" WHERE FLT_SEQ_NR = A.FLT_SEQ_NR ");
		sql.append(" GROUP BY STAFF_NUM) ");
		sql.append(" ORDER BY B.RANK_NR, B.STAFF_NUM ");
		
		//System.out.println("[BASE:SkdQ040Query:selCrewInfoNew] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * SKD/Detail FLT Status ¹ ȸ SQLԼ. -- 2009/10/12 : 
	  * @param params SkdQ040BG ȸ
	  * @return String Query 
	  * @author Copyright (c) 2005/01/20 HIST 
	  */
	public String selCrewInfo(SkdQ040BG params) {
		StringBuffer sql = new StringBuffer();
	
		sql.append(" Select C.Staff_Num, Substr(D.Surname,1,30) Surname,B.Duty_Cd,");
		sql.append(" Decode(B.Cop_Duty_Cd,'P1',Decode(C.Acting_Rank,'CAP','PIC',C.Acting_Rank),'CM',Decode(C.Acting_Rank,'CAP','PIC',C.Acting_Rank),C.Acting_Rank) Acting_Rank,");
		sql.append(" 			Decode(C.Acting_Rank,'CAP','1','RC','2','F/O','3','F/E','4','5') Ord_Rank1,");
		sql.append("			Decode(B.Cop_Duty_Cd,'P1','1','CM','1','P2','2','3') Ord_Rank2");
		sql.append(" From DUTY_PRD_SEG_V B,ROSTER_V C, CREW_V D");
		sql.append(" Where B.Delete_Ind = 'N' And");
		sql.append("            B.First_Leg_Flt_Dt = To_Date('"+params.getFirst_leg_flt_dt()+"','yyyymmdd') And");
		sql.append("       		B.Flt_Num    = '"+params.getFlt_num()+"'      And");
		sql.append("       		B.Port_a     = '"+params.getStnfr()+"'        And");
		sql.append("       		B.Port_b     = '"+params.getStnto()+"'       And");
		sql.append("       		B.Series_num = C.Series_Num And");
		sql.append("       		C.Delete_Ind = 'N' And");
		sql.append("       		C.Staff_Num  = D.Staff_Num");
		sql.append(" Order By B.Duty_Cd, Ord_Rank1, Ord_Rank2");
		
		Logger.debug.println("[BASE:SkdQ040Query:selCrewInfo] sql : "+sql.toString());
		//System.out.println("[BASE:SkdQ040Query:selCrewInfo] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * SKD/Detail FLT Status ¹ / FLT  ȸ SQLԼ. -- 2009/10/12 : 
	  * @param params SkdQ040BG ȸ
	  * @return String Query 
	  * @author Copyright (c) 2005/01/20 HIST 
	  */
	public String selCrewFLTInfo(String staffNum,String actDepDtKst) {
		StringBuffer sql = new StringBuffer();
		
		//KST  Act_End_Dt_Tm_Gmt
		//LOC  End_Dt_Tm_Loc
		sql.append(" Select 'PREV' Flt_Seq,'KE'||Flt_Num Flt_Num,To_Char(Act_End_Dt_Tm_Gmt,'DDMONYY') Flt_Date,");
		sql.append("            Port_a,Port_b,Duty_Cd,Acting_Rank,'' Regno");
		sql.append(" From (Select Flt_Num,Act_End_Dt_Tm_Gmt,Port_a,Port_b,A.Duty_Cd,Acting_Rank");
		sql.append("           From Duty_Prd_Seg_v A,Roster_v B");
		sql.append("           Where Staff_Num = '"+staffNum+"' And");
		sql.append("           			  B.Series_Num = A.Series_Num And");
		sql.append("                      Act_End_Dt_Tm_Gmt < To_Date('"+actDepDtKst+"','yyyymmddhh24mi') And");
		sql.append("             		  Act_End_Dt_Tm_Gmt > To_Date('"+actDepDtKst+"','yyyymmddhh24mi')-30 And");
		sql.append("             		  A.Duty_Cd in ('FLY','TVL') And");
		sql.append("             		  B.Delete_Ind = 'N' And");
		sql.append("             		  A.Delete_Ind = 'N' And");
		sql.append("             		  Duty_Published = 'Y'");
		sql.append("          Order By Act_End_Dt_Tm_Gmt desc)");
		sql.append(" Where Rownum = 1");
		sql.append(" Union All");
		//KST  Act_Str_Dt_Tm_Gmt
		//LOC  Str_Dt_Tm_Loc
		sql.append(" Select 'NEXT' Flt_Seq,'KE'||Flt_Num Flt_Num,To_Char(Act_Str_Dt_Tm_Gmt,'DDMONYY') Flt_Date,");
		sql.append("             Port_a,Port_b,A.Duty_Cd Duty_Cd,Acting_Rank,'' Regno");
		sql.append(" From Duty_Prd_Seg_v A,Roster_v B");
		sql.append(" Where Act_Str_Dt_Tm_Gmt > To_Date('"+actDepDtKst+"','yyyymmddhh24mi') And");
		sql.append("            Act_Str_Dt_Tm_Gmt < To_Date('"+actDepDtKst+"','yyyymmddhh24mi')+30 And");
		sql.append("            A.Series_Num = B.Series_Num And");
		sql.append("       		Staff_Num = '"+staffNum+"' And");
		sql.append("       		A.Duty_Cd in ('FLY','TVL') And");
		sql.append("       		Duty_Published = 'Y' And");
		sql.append("       		B.Delete_Ind = 'N' And");
		sql.append("       		A.Delete_Ind = 'N' And");
		sql.append("       		Rownum = 1");
		
		Logger.debug.println("[BASE:SkdQ040Query:selCrewFLTInfo] sql : "+sql.toString());
		//System.out.println("[BASE:SkdQ040Query:selCrewFLTInfo] sql : "+sql.toString());
		return sql.toString();
	}		
	
	/** 
	  * SKD/Detail FLT Status ¹ / FLT  ȸ PreparedStmt SQLԼ. -- 2009/10/12 : 
	  * @return String Query 
	  * @author Copyright (c) 2005/01/20 HIST 
	  */
	public String selCrewFLTInfoPre() {
		StringBuffer sql = new StringBuffer();
		
		//KST  Act_End_Dt_Tm_Gmt
		//LOC  End_Dt_Tm_Loc
		sql.append(" Select 'PREV' Flt_Seq,'KE'||Flt_Num Flt_Num,To_Char(Act_End_Dt_Tm_Gmt,'DDMONYY') Flt_Date,");
		sql.append("            Port_a,Port_b,Duty_Cd,Acting_Rank,'' Regno");
		sql.append(" From (Select Flt_Num,Act_End_Dt_Tm_Gmt,Port_a,Port_b,A.Duty_Cd,Acting_Rank");
		sql.append("           From Duty_Prd_Seg_v A,Roster_v B");
		sql.append("           Where Staff_Num = ? And");
		sql.append("           			  B.Series_Num = A.Series_Num And");
		sql.append("                      Act_End_Dt_Tm_Gmt < To_Date(?,'yyyymmddhh24mi') And");
		sql.append("             		  Act_End_Dt_Tm_Gmt > To_Date(?,'yyyymmddhh24mi')-30 And");
		sql.append("             		  A.Duty_Cd in ('FLY','TVL') And");
		sql.append("             		  B.Delete_Ind = 'N' And");
		sql.append("             		  A.Delete_Ind = 'N' And");
		sql.append("             		  Duty_Published = 'Y'");
		sql.append("          Order By Act_End_Dt_Tm_Gmt desc)");
		sql.append(" Where Rownum = 1");
		sql.append(" Union All");
		//KST  Act_Str_Dt_Tm_Gmt
		//LOC  Str_Dt_Tm_Loc
		sql.append(" Select 'NEXT' Flt_Seq,'KE'||Flt_Num Flt_Num,To_Char(Act_Str_Dt_Tm_Gmt,'DDMONYY') Flt_Date,");
		sql.append("             Port_a,Port_b,A.Duty_Cd Duty_Cd,Acting_Rank,'' Regno");
		sql.append(" From Duty_Prd_Seg_v A,Roster_v B");
		sql.append(" Where Act_Str_Dt_Tm_Gmt > To_Date(?,'yyyymmddhh24mi') And");
		sql.append("            Act_Str_Dt_Tm_Gmt < To_Date(?,'yyyymmddhh24mi')+30 And");
		sql.append("            A.Series_Num = B.Series_Num And");
		sql.append("       		Staff_Num = ? And");
		sql.append("       		A.Duty_Cd in ('FLY','TVL') And");
		sql.append("       		Duty_Published = 'Y' And");
		sql.append("       		B.Delete_Ind = 'N' And");
		sql.append("       		A.Delete_Ind = 'N' And");
		sql.append("       		Rownum = 1");
		
		Logger.debug.println("[BASE:SkdQ040Query:selCrewFLTInfoPre] sql : "+sql.toString());
		//System.out.println("[BASE:SkdQ040Query:selCrewFLTInfoPre] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * SKD/Detail FLT Status ¹ LAST FLT  ȸ SQLԼ. -- .
	  * @param params SkdQ040BG ȸ
	  * @return String Query 
	  * @author Copyright (c) 2005/01/20 HIST 
	  */
	public String selCrewLastInfo(String staffNum) {
		StringBuffer sql = new StringBuffer();
		
		//LAST INFO 2005.03.11
		sql.append(" Select 'LAST' Flt_Seq, ARln_Cd||Flt_Num Flt_Num,To_Char(Land_on_Dt,'DDMONYY') Flt_Date,");
		sql.append("    		  Stnfr Port_a, Stnto Port_b, '' Duty_Cd, '' Acting_Rank, Regno, Land_on_Dt");
		sql.append(" From Fs_Log_Skd_T");
		sql.append(" Where Land_On_Crew = '"+staffNum+"'   And");
		sql.append("       		Landing_Type = 'A' And");
		sql.append(" 			RowNum = 1");
		sql.append(" Order By Land_on_Dt Desc");
		
		Logger.debug.println("[BASE:SkdQ040Query:selCrewLastInfo] sql : "+sql.toString());
		//System.out.println("[BASE:SkdQ040Query:selCrewLastInfo] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * SKD/Detail FLT Status ¹ LAST FLT  ȸ PreparedStmt SQLԼ.
	  * @return String Query 
	  * @author Copyright (c) 2005/01/20 HIST 
	  */
	public String selCrewLastInfoPre() {
		StringBuffer sql = new StringBuffer();
		
		//LAST INFO 2005.03.11
		sql.append(" Select 'LAST' Flt_Seq, ARln_Cd||Flt_Num Flt_Num,To_Char(Land_on_Dt,'DDMONYY') Flt_Date,");
		sql.append("    		  Stnfr Port_a, Stnto Port_b, '' Duty_Cd, '' Acting_Rank, Regno, Land_on_Dt");
		sql.append(" From Fs_Log_Skd_T");
		sql.append(" Where Land_On_Crew = ?   And");
		sql.append("       		Landing_Type = 'A' And");
		sql.append(" 			RowNum = 1");
		sql.append(" Order By Land_on_Dt Desc");
		
		Logger.debug.println("[BASE:SkdQ040Query:selCrewLastInfoPre] sql : "+sql.toString());
		System.out.println("[BASE:SkdQ040Query:selCrewLastInfoPre] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * ¹ CAT  ر/ڰ ð  ȸ SQLԼ.
	  * @param String staffNum
	  * @return String Query 
	  * @ۼ¥ : 2010-07-22
	  */
	public String selCatRankTm(String staffNum) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT A.STAFF_NUM, A.CATEGORY, TO_CHAR(A.ISSUE_DT,'YYYY-MM-DD') ISSUE_DT, NVL(B.FLEETRANKTM, 0) FLEETRANKTM ");
		sql.append(" FROM (SELECT AA.STAFF_NUM, AA.FRANK_CD, BB.CATEGORY, BB.ISSUE_DT ");
		sql.append(" FROM FS_EMP_INFO_T AA, FS_CAT_ISSUE_T BB ");
		sql.append(" WHERE AA.STAFF_NUM = '"+staffNum+"' ");
		sql.append(" AND BB.ISSUE_DT IS NOT NULL ");
		sql.append(" AND AA.STAFF_NUM = BB.STAFF_NUM(+) ");
		sql.append(" AND AA.FRANK_CD = BB.RANK_CD(+) ");
		sql.append(" AND AA.OACTYP = BB.FLEET_CD(+) ");
		sql.append(" AND AA.EMP_STATUS IN ('1','6')) A, ");
		sql.append(" (SELECT B.STAFF_NUM, B.FRANK_CD, DECODE(B.FRANK_CD,'CAP',SUM(DLCP_MIN+LCP_MIN+CAP_MIN),SUM(FO_MIN)) FLEETRANKTM ");
		sql.append(" FROM FS_FLYING_CUMHR_T A, FS_EMP_INFO_T B ");
		sql.append(" WHERE A.STAFF_NUM = B.STAFF_NUM ");
		sql.append(" AND A.STAFF_NUM = '"+staffNum+"' ");
		sql.append(" AND A.OACTYP = B.OACTYP ");
		sql.append(" GROUP BY B.STAFF_NUM, B.FRANK_CD) B ");
		sql.append(" WHERE A.STAFF_NUM = B.STAFF_NUM(+) ");
		sql.append(" AND A.FRANK_CD = B.FRANK_CD(+) ");
		sql.append(" ORDER BY A.STAFF_NUM ");
				
		System.out.println("[BASE:SkdQ040Query:selCatRankTm] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * SKD/Detail FLT Status  ȸ SQLԼ.
	  * @param params SkdQ040BG ȸ
	  * @return String Query 
	  * @author Copyright (c) 2005/01/20 HIST 
	  */
	public String selDcsInfo(SkdQ040BG params) {
		StringBuffer sql = new StringBuffer();
	
		sql.append(" Select Nvl(F_Cfg_q,0)||' / '||Nvl(C_Cfg_q,0)||' / '||Nvl(Y_Cfg_q,0) Cfg,");
		sql.append("            Nvl(F_Book_q,0)||' / '||Nvl(C_Book_q,0)||' / '||Nvl(Y_Book_q,0) Rsvn,");
		sql.append("            Nvl(F_Check_q,0)||' / '||Nvl(C_Check_q,0)||' / '||Nvl(Y_Check_q,0) Chk_In,");
		sql.append(" 	     	Nvl(Capt_Crew_q,0)||' / '||Nvl(Cbn_Crew_Man_q,0)||' / '||Nvl(Cbn_Crew_Woman_q,0) Crew,");
		sql.append("        	Max_PayLoad_q, Act_Payload_q, Act_Bew_q, Act_Sow_q,");
		sql.append("        	Act_Zfw_q, Act_Tow_q, Est_Ldw_q, Tof_q, Tif_q,");
		sql.append("        	Cgo_Wt_q, Mail_Wt_q, Bag_Wt_q");
		sql.append(" From BASE_DCS_T");
		sql.append(" Where First_Leg_Flt_Dt = To_Date('"+params.getFirst_leg_flt_dt()+"','yyyymmdd') And");
		sql.append("            Flt_Num = '"+params.getFlt_num()+"'    And");
		sql.append("       		Stnfr   = '"+params.getStnfr()+"'     And");
		sql.append("       		Stnto   = '"+params.getStnto()+"'");
		
		Logger.debug.println("[BASE:SkdQ040Query:selDcsInfo] sql : "+sql.toString());
		//System.out.println("[BASE:SkdQ040Query:selDcsInfo] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * SKD/Detail FLT Status Aircraft Connection  ȸ SQLԼ.
	  * @param params SkdQ040BG ȸ
	  * @return String Query 
	  * @author Copyright (c) 2005/01/20 HIST 
	  */
	public String selAircraftInfo(SkdQ040BG params) {
		StringBuffer sql = new StringBuffer();
	
		sql.append(" Select Flt_Num,  Stnfr,  Stnto, Dep_Sts, Arv_Sts,");
		if (params.getTime_x().equals("KST")) {
			sql.append("		To_Char(Sch_Dep_Dt+(540/1440),'yyyymmddhh24mi') Sch_Dep_Dt,");
			sql.append("		To_Char(Sch_Dep_Dt+(540/1440),'hh24:mi') Sch_Dep_Tm, To_Char(Sch_Arv_Dt+(540/1440),'hh24:mi') Sch_Arv_Tm,");
			sql.append("		To_Char(Est_Dep_Dt+(540/1440),'hh24:mi') Est_Dep_Tm, To_Char(Act_Dep_Dt+(540/1440),'hh24:mi') Act_Dep_Tm,");
			sql.append("    	To_Char(Est_Arv_Dt+(540/1440),'hh24:mi') Est_Arv_Tm,To_Char(Act_Arv_Dt+(540/1440),'hh24:mi') Act_Arv_Tm,");
			// 2006.04.20  ==> TOFF, TDWN
			sql.append("		TO_CHAR(TO_DATE(TO_CHAR(SYSDATE,'YYYYMMDD')||NVL(TRIM(Tkof_t),'0000'),'YYYYMMDDHH24MI')+(540/1440),'HH24:MI') Tkof_t,");
			sql.append(" 	TO_CHAR(TO_DATE(TO_CHAR(SYSDATE,'YYYYMMDD')||NVL(TRIM(Land_t),'0000'),'YYYYMMDDHH24MI')+(540/1440),'HH24:MI') Land_t,");
		} else if (params.getTime_x().equals("LOC")) {	
			sql.append("      To_Char(Sch_Dep_Dt_Loc,'yyyymmddhh24mi') Sch_Dep_Dt,");
			sql.append("      To_Char(Sch_Dep_Dt_Loc,'hh24:mi') Sch_Dep_Tm, To_Char(Sch_Arv_Dt_Loc,'hh24:mi') Sch_Arv_Tm,");
			sql.append(" 	To_Char(Est_Dep_Dt_Loc,'hh24:mi') Est_Dep_Tm, To_Char(Act_Dep_Dt_Loc,'hh24:mi') Act_Dep_Tm,");
			sql.append("		To_Char(Est_Arv_Dt_Loc,'hh24:mi') Est_Arv_Tm,To_Char(Act_Arv_Dt_Loc,'hh24:mi') Act_Arv_Tm,");
			// 2006.04.20  ==> TOFF, TDWN
			sql.append("		TO_CHAR(TO_DATE(TO_CHAR(SYSDATE,'YYYYMMDD')||NVL(TRIM(Tkof_t),'0000'),'YYYYMMDDHH24MI')+(DEP_GMT_OFFSET/1440),'HH24:MI') Tkof_t,");
			sql.append(" 	TO_CHAR(TO_DATE(TO_CHAR(SYSDATE,'YYYYMMDD')||NVL(TRIM(Land_t),'0000'),'YYYYMMDDHH24MI')+(ARV_GMT_OFFSET/1440),'HH24:MI') Land_t,");
		} else {	
			sql.append("		To_Char(Sch_Dep_Dt,'yyyymmddhh24mi') Sch_Dep_Dt,");
			sql.append("		To_Char(Sch_Dep_Dt,'hh24:mi') Sch_Dep_Tm, To_Char(Sch_Arv_Dt,'hh24:mi') Sch_Arv_Tm,");
			sql.append("		To_Char(Est_Dep_Dt,'hh24:mi') Est_Dep_Tm, To_Char(Act_Dep_Dt,'hh24:mi') Act_Dep_Tm,");
			sql.append("		To_Char(Est_Arv_Dt,'hh24:mi') Est_Arv_Tm,To_Char(Act_Arv_Dt,'hh24:mi') Act_Arv_Tm,");
			// 2006.04.20  ==> TOFF, TDWN
			sql.append("		SUBSTR(Tkof_t,1,2)||':'||SUBSTR(Tkof_t,3,2) Tkof_t, ");
			sql.append("		SUBSTR(Land_t,1,2)||':'||SUBSTR(Land_t,3,2) Land_t, ");
		}
		sql.append("        	Dep_Gmt_Offset, Arv_Gmt_Offset, Spot_Out, Spot_In ");
		sql.append(" From Daily_Sch_T");
		sql.append(" Where Arln_Cd = 'KE' And");
		if (params.getTime_x().equals("KST")) {
			sql.append("          Sch_Dep_Dt >= To_Date('"+params.getSch_dep_dt().substring(0,8)+"0000','yyyymmddhh24mi')-(540/1440) And");
			sql.append("       	Sch_Dep_Dt <= To_Date('"+params.getSch_dep_dt().substring(0,8)+"2359','yyyymmddhh24mi')-(540/1440) And");
		} else if (params.getTime_x().equals("LOC")) {		
			sql.append("          Sch_Dep_Dt_Loc >= To_Date('"+params.getSch_dep_dt().substring(0,8)+"0000','yyyymmddhh24mi') And");
			sql.append("       	Sch_Dep_Dt_Loc <= To_Date('"+params.getSch_dep_dt().substring(0,8)+"2359','yyyymmddhh24mi') And");
		} else {		
			sql.append("          Sch_Dep_Dt >= To_Date('"+params.getSch_dep_dt().substring(0,8)+"0000','yyyymmddhh24mi') And");
			sql.append("       	Sch_Dep_Dt <= To_Date('"+params.getSch_dep_dt().substring(0,8)+"2359','yyyymmddhh24mi') And");
		}
		sql.append("       		Dep_Sts <> 'INI'  And");
		sql.append("       		Actnid <> 'CNL' And");
		sql.append("       		Regno = '"+params.getRegno()+"'");
		sql.append("       		And Regno <> 'ZZZZZ' "); //2008.02.05 ߰
		sql.append(" Order By Sch_Dep_Dt,Flt_Num");
		
		Logger.debug.println("[BASE:SkdQ040Query:selAircraftInfo] sql : "+sql.toString());
		//System.out.println("[BASE:SkdQ040Query:selAircraftInfo] sql : "+sql.toString());
		return sql.toString();
	}		
	
	/** 
	  * SKD/Detail FLT Status PAX Conx  ȸ SQLԼ.
	  * @param params SkdQ040BG ȸ
	  * @return String Query 
	  * @author Copyright (c) 2005/01/20 HIST 
	  */
	/*public String selPaxConxInfo(SkdQ040BG params) {
		StringBuffer sql = new StringBuffer();
			
		Logger.debug.println("[BASE:SkdQ040Query:selPaxConxInfo] sql : "+sql.toString());
		return sql.toString();
	}*/
}
