package kal.base.skd.query;

import kal.base.jdf.com.Logger;
import kal.base.skd.dbbean.SkdQ050BG;
import kal.base.com.query.*;

 /**
   * HUB Station Information SQL 
   * @author Copyright (c) 2005/02/02 
   */    
public class SkdQ050Query {
	private static SkdQ050Query instance = new SkdQ050Query();
	
	public static SkdQ050Query getInstance() {
		return instance;
	}
	
	/** 
	  * HUB Station Information main ICN ȸ SQLԼ.
	  * @param entity SkdQ050BG HUB Station Information
	  * @return String Query 
	  * @author Copyright (c) 2005/02/02 
	  */
	public String selMainICN(SkdQ050BG entity) {
		StringBuffer sql = new StringBuffer();

		sql.append(" Select Arln_Cd, Flt_Num, Stn, DepArv_x, Sactyp, Regno, Spot, ");
		sql.append(" DECODE(DepArv_x, 'D', Gate, Caroulateral) Gate, "); //2008.04.16  : DEP϶ Gate, ARR϶ CRSL
		sql.append(" CdSflt, DepArv_Sts, ");
		sql.append(" 	Nvl(FIRSTARPTSTOP,'') FIRSTARPTSTOP, Nvl(SCDARPTSTOP,'') SCDARPTSTOP, Nvl(THIRDARPTSTOP,'') THIRDARPTSTOP, ConxStn,  ");
		sql.append(" 	To_Char(Sch_Dt_Loc,'yyyymmdd hh24mi') Sch_Dt_Loc_Full, ");
		sql.append(" 	To_Char(Sch_Dt_Loc,'hh24:mi') Sch_Dt_Loc, To_Char(Est_Dt_Loc,'hh24:mi') Est_Dt_Loc, ");
		sql.append(" 	To_Char(Act_Dt_Loc,'hh24:mi') Act_Dt_Loc, To_Char(TkofLand_t,'hh24:mi') TkofLand_t ");
		sql.append(" From Fo_Daily_Ramp_T "); //2007.04.11  : Daily_Ramp_T-> Fo_Daily_Ramp_T
		sql.append(" Where ");
		if (entity.getStart_time().equals("")) {
			sql.append(" Sch_Dt_Loc >= To_Date('"+entity.getSch_dt_loc()+" 0000','yyyymmdd hh24mi') And ");
		} else {
			sql.append(" Sch_Dt_Loc >= To_Date('"+entity.getSch_dt_loc()+" "+entity.getStart_time()+"','yyyymmdd hh24mi') And ");
		}
		if (entity.getEnd_time().equals("")) {
			sql.append(" Sch_Dt_Loc <= To_Date('"+entity.getSch_dt_loc()+" 2359','yyyymmdd hh24mi') And ");
		} else {
			sql.append(" Sch_Dt_Loc <= To_Date('"+entity.getSch_dt_loc()+" "+entity.getEnd_time()+"','yyyymmdd hh24mi') And ");
		}
		if (entity.getDeparv_x().equals("DEP")) {
			sql.append("	DepArv_x = 'D' And ");
		} else if(entity.getDeparv_x().equals("ARR")) {
			sql.append("  DepArv_x = 'A' And");
		}
		if (!entity.getCarrier().equals("")) {
			if (entity.getCarrier().equals("00")) {
				sql.append(" Arln_Cd <> 'KE' And");
			} else {
				sql.append(" Arln_Cd = '"+entity.getCarrier()+"' And");
			}
		}
		sql.append(" 	Stn = '"+entity.getStn()+"' ");
		sql.append(" Order By Sch_Dt_Loc_Full ");
		
		//Logger.debug.println("[BASE:SkdQ050Query:selMainICN] sql : "+sql.toString());
		System.out.println("[BASE:SkdQ050Query:selMainICN] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * HUB Station Information sub ȸ SQLԼ.
	  * @param entity SkdQ050BG HUB Station Information
	  * @return String Query 
	  * @author Copyright (c) 2005/02/02 
	  */
	public String selSub(SkdQ050BG entity) {
		StringBuffer sql = new StringBuffer();

		sql.append(" Select Nvl(FIRSTARPTSTOP,'') FIRSTARPTSTOP, DepArv_Sts, Spot, Flt_Num,  ");
		sql.append(" 	To_Char(Sch_Dt_Loc,'hh24:mi') Sch_Dt_Loc, To_Char(Est_Dt_Loc,'hh24:mi') Est_Dt_Loc,  ");
		sql.append(" 	To_Char(Act_Dt_Loc,'hh24:mi') Act_Dt_Loc  ");
		sql.append(" From Fo_Daily_Ramp_T  "); //2007.04.11  : Daily_Ramp_T-> Fo_Daily_Ramp_T
		if(entity.getDeparv_x().equals("D")){
			sql.append(" Where Sch_Dt_Loc >= To_Date(?, 'yyyymmdd hh24mi') And  ");
			sql.append(" 	Sch_Dt_Loc < To_Date(?, 'yyyymmdd hh24mi') And ");
		}
		else if(entity.getDeparv_x().equals("A")){
			sql.append(" Where Sch_Dt_Loc > To_Date(?, 'yyyymmdd hh24mi') And  ");
			sql.append(" 	Sch_Dt_Loc <= To_Date(?, 'yyyymmdd hh24mi') And ");
		}
		sql.append(" 	Arln_cd = ? And  ");
		sql.append(" 	Regno = ? And  ");
		sql.append(" 	Stn = ? And  ");
		sql.append(" 	RowNum = 1  ");
		if(entity.getDeparv_x().equals("D")){
			sql.append(" Order By 5 Desc ");
		}
		else if(entity.getDeparv_x().equals("A")){
			sql.append(" Order By 5 ");
		}
		
		//Logger.debug.println("[BASE:SkdQ050Query:selSub] sql : "+sql.toString());
		//System.out.println("[BASE:SkdQ050Query:selSub] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * HUB Station Information main GMP ȸ SQLԼ.
	  * @param entity SkdQ050BG HUB Station Information
	  * @return String Query 
	  * @author Copyright (c) 2007/10/18 
	  */
	public String selMainGMP(SkdQ050BG entity) {
		StringBuffer sql = new StringBuffer();
		
		/*
		sql.append(" SELECT ARLN_CD, FLT_NUM, ARLN_CD||FLT_NUM FLT, DECODE(STNFR, 'GMP', 'D', 'A') DA, SACTYP, ");
		sql.append(" 	DECODE(STNFR, 'GMP', SPOT_OUT, SPOT_IN) SPOT, ");
		sql.append(" 	DECODE(STNFR, 'GMP', GATE_OUT, GATE_IN) GATE, ");
		sql.append(" 	REGNO, ");
		sql.append(" 	DECODE(STNFR, 'GMP', DEP_STS, ARV_STS) STS, ");
		sql.append(" 	TO_CHAR(DECODE(STNFR, 'GMP', SCH_DEP_DT_LOC, SCH_ARV_DT_LOC), 'YYYYMMDD HH24MI') SCH_DT_LOC_FULL, ");
		sql.append(" 	TO_CHAR(DECODE(STNFR, 'GMP', SCH_DEP_DT_LOC, SCH_ARV_DT_LOC), 'HH24:MI') SCH, ");
		sql.append(" 	TO_CHAR(DECODE(STNFR, 'GMP', EST_DEP_DT_LOC, EST_ARV_DT_LOC), 'HH24:MI') EST, ");
		sql.append(" 	TO_CHAR(DECODE(STNFR, 'GMP', ACT_DEP_DT_LOC, ACT_ARV_DT_LOC), 'HH24:MI') ACT, ");
		sql.append(" 	TO_CHAR(TO_DATE(DECODE(STNFR, 'GMP', TKOF_T, LAND_T), 'HH24MI') + 9/24, 'HH24:MI') OFFON, ");
		sql.append(" 	STNFR||'-'||STNTO ITN ");
		sql.append(" FROM DAILY_SCH_T ");
		sql.append(" WHERE STNFR <> STNTO ");
		sql.append(" 	AND ACTNID <> 'CNL' ");
		if (!entity.getCarrier().equals("")) {
			if (entity.getCarrier().equals("00")) {
				sql.append(" AND ARLN_CD <> 'KE' ");
			} else {
				sql.append(" AND ARLN_CD = '"+entity.getCarrier()+"' ");
			}
		}
		String startTime = "";
		if (entity.getStart_time().equals("")) startTime = "0000";
		else startTime = entity.getStart_time();
		String endTime = "";
		if (entity.getEnd_time().equals("")) endTime = "2359";
		else endTime = entity.getEnd_time();
		if (entity.getDeparv_x().equals("DEP")) {
			sql.append("  AND SCH_DEP_DT >= TO_DATE('"+entity.getSch_dt_loc()+" "+startTime+"', 'YYYYMMDD HH24MI') - 9/24 ");
			sql.append("  AND SCH_DEP_DT <= TO_DATE('"+entity.getSch_dt_loc()+" "+endTime+"', 'YYYYMMDD HH24MI') - 9/24 ");
			sql.append("  AND STNFR = 'GMP' ");
		} else if (entity.getDeparv_x().equals("ARR")) {
			sql.append("  AND SCH_DEP_DT >= TO_DATE('"+entity.getSch_dt_loc()+" "+startTime+"', 'YYYYMMDD HH24MI') - 9/24 - 1 ");
			sql.append("  AND SCH_DEP_DT <= TO_DATE('"+entity.getSch_dt_loc()+" "+endTime+"', 'YYYYMMDD HH24MI') - 9/24 ");
			sql.append("  AND SCH_ARV_DT >= TO_DATE('"+entity.getSch_dt_loc()+" "+startTime+"', 'YYYYMMDD HH24MI') - 9/24 ");
			sql.append("  AND SCH_ARV_DT <= TO_DATE('"+entity.getSch_dt_loc()+" "+endTime+"', 'YYYYMMDD HH24MI') - 9/24 ");
			sql.append("  AND STNTO = 'GMP' ");
		} else if (entity.getDeparv_x().equals("ALL")) {
			sql.append("  AND ((SCH_DEP_DT >= TO_DATE('"+entity.getSch_dt_loc()+" "+startTime+"', 'YYYYMMDD HH24MI') - 9/24 ");
			sql.append("  AND SCH_DEP_DT <= TO_DATE('"+entity.getSch_dt_loc()+" "+endTime+"', 'YYYYMMDD HH24MI') - 9/24 ");
			sql.append("  AND STNFR = 'GMP') ");
			sql.append("  OR (SCH_DEP_DT >= TO_DATE('"+entity.getSch_dt_loc()+" "+startTime+"', 'YYYYMMDD HH24MI') - 9/24 - 1 ");
			sql.append("  AND SCH_DEP_DT <= TO_DATE('"+entity.getSch_dt_loc()+" "+endTime+"', 'YYYYMMDD HH24MI') - 9/24 ");
			sql.append("  AND SCH_ARV_DT >= TO_DATE('"+entity.getSch_dt_loc()+" "+startTime+"', 'YYYYMMDD HH24MI') - 9/24 ");
			sql.append("  AND SCH_ARV_DT <= TO_DATE('"+entity.getSch_dt_loc()+" "+endTime+"', 'YYYYMMDD HH24MI') - 9/24 ");
			sql.append("  AND STNTO = 'GMP')) ");
		}
		sql.append(" ORDER BY SCH, FLT ");
		*/
		//2008.10.14  : PE_ACARS_SKD_T ߰
		sql.append(" SELECT A.ARLN_CD, A.FLT_NUM, A.ARLN_CD||A.FLT_NUM FLT, DECODE(A.STNFR, 'GMP', 'D', 'A') DA, A.SACTYP, ");
		sql.append(" 	DECODE(A.STNFR, 'GMP', A.SPOT_OUT, A.SPOT_IN) SPOT, ");
		sql.append(" 	DECODE(A.STNFR, 'GMP', A.GATE_OUT, A.GATE_IN) GATE, ");
		sql.append(" 	A.REGNO, ");
		sql.append(" 	DECODE(A.STNFR, 'GMP', A.DEP_STS, A.ARV_STS) STS, ");
		sql.append(" 	TO_CHAR(DECODE(A.STNFR, 'GMP', A.SCH_DEP_DT_LOC, A.SCH_ARV_DT_LOC), 'YYYYMMDD HH24MI') SCH_DT_LOC_FULL, ");
		sql.append(" 	TO_CHAR(DECODE(A.STNFR, 'GMP', A.SCH_DEP_DT_LOC, A.SCH_ARV_DT_LOC), 'HH24:MI') SCH, ");
		sql.append(" 	TO_CHAR(DECODE(A.STNFR, 'GMP', A.EST_DEP_DT_LOC, A.EST_ARV_DT_LOC), 'HH24:MI') EST, ");
		sql.append(" 	TO_CHAR(DECODE(A.STNFR, 'GMP', A.ACT_DEP_DT_LOC, A.ACT_ARV_DT_LOC), 'HH24:MI') ACT, ");
		sql.append(" 	TO_CHAR(TO_DATE(DECODE(A.STNFR, 'GMP', A.TKOF_T, A.LAND_T), 'HH24MI') + 9/24, 'HH24:MI') OFFON, ");
		sql.append(" 	A.STNFR||'-'||A.STNTO ITN, ");
		sql.append(" 	DECODE(A.STNFR, 'GMP', NVL(TO_CHAR(B.ACT_OUT_DT + 9/24, 'HH24:MI'), ''), NVL(TO_CHAR(B.ACT_IN_DT + 9/24, 'HH24:MI'), ''))  ACT_ACARS, ");
		sql.append(" 	DECODE(A.STNFR, 'GMP', NVL(TO_CHAR(B.ACT_OFF_DT + 9/24, 'HH24:MI'), ''), NVL(TO_CHAR(B.ACT_ON_DT + 9/24, 'HH24:MI'), ''))  OFFON_ACAR ");
		sql.append(" FROM DAILY_SCH_T A, PE_ACARS_SKD_T B ");
		sql.append(" WHERE A.STNFR <> A.STNTO ");
		sql.append(" 	AND A.ACTNID <> 'CNL' ");
		if (!entity.getCarrier().equals("")) {
			if (entity.getCarrier().equals("00")) {
				sql.append(" AND A.ARLN_CD <> 'KE' ");
			} else {
				sql.append(" AND A.ARLN_CD = '"+entity.getCarrier()+"' ");
			}
		}
		String startTime = "";
		if (entity.getStart_time().equals("")) startTime = "0000";
		else startTime = entity.getStart_time();
		String endTime = "";
		if (entity.getEnd_time().equals("")) endTime = "2359";
		else endTime = entity.getEnd_time();
		if (entity.getDeparv_x().equals("DEP")) {
			sql.append("  AND A.SCH_DEP_DT >= TO_DATE('"+entity.getSch_dt_loc()+" "+startTime+"', 'YYYYMMDD HH24MI') - 9/24 ");
			sql.append("  AND A.SCH_DEP_DT <= TO_DATE('"+entity.getSch_dt_loc()+" "+endTime+"', 'YYYYMMDD HH24MI') - 9/24 ");
			sql.append("  AND A.STNFR = 'GMP' ");
		} else if (entity.getDeparv_x().equals("ARR")) {
			sql.append("  AND A.SCH_DEP_DT >= TO_DATE('"+entity.getSch_dt_loc()+" "+startTime+"', 'YYYYMMDD HH24MI') - 9/24 - 1 ");
			sql.append("  AND A.SCH_DEP_DT <= TO_DATE('"+entity.getSch_dt_loc()+" "+endTime+"', 'YYYYMMDD HH24MI') - 9/24 ");
			sql.append("  AND A.SCH_ARV_DT >= TO_DATE('"+entity.getSch_dt_loc()+" "+startTime+"', 'YYYYMMDD HH24MI') - 9/24 ");
			sql.append("  AND A.SCH_ARV_DT <= TO_DATE('"+entity.getSch_dt_loc()+" "+endTime+"', 'YYYYMMDD HH24MI') - 9/24 ");
			sql.append("  AND A.STNTO = 'GMP' ");
		} else if (entity.getDeparv_x().equals("ALL")) {
			sql.append("  AND ((A.SCH_DEP_DT >= TO_DATE('"+entity.getSch_dt_loc()+" "+startTime+"', 'YYYYMMDD HH24MI') - 9/24 ");
			sql.append("  AND A.SCH_DEP_DT <= TO_DATE('"+entity.getSch_dt_loc()+" "+endTime+"', 'YYYYMMDD HH24MI') - 9/24 ");
			sql.append("  AND A.STNFR = 'GMP') ");
			sql.append("  OR (A.SCH_DEP_DT >= TO_DATE('"+entity.getSch_dt_loc()+" "+startTime+"', 'YYYYMMDD HH24MI') - 9/24 - 1 ");
			sql.append("  AND A.SCH_DEP_DT <= TO_DATE('"+entity.getSch_dt_loc()+" "+endTime+"', 'YYYYMMDD HH24MI') - 9/24 ");
			sql.append("  AND A.SCH_ARV_DT >= TO_DATE('"+entity.getSch_dt_loc()+" "+startTime+"', 'YYYYMMDD HH24MI') - 9/24 ");
			sql.append("  AND A.SCH_ARV_DT <= TO_DATE('"+entity.getSch_dt_loc()+" "+endTime+"', 'YYYYMMDD HH24MI') - 9/24 ");
			sql.append("  AND A.STNTO = 'GMP')) ");
		}	     
		sql.append(" AND A.FIRST_LEG_FLT_DT = B.FIRST_LEG_FLT_DT(+) ");
		sql.append(" AND A.FLT_NUM = B.FLT_NUM(+) ");
		sql.append(" AND A.STNFR = B.STNFR(+) ");
		sql.append(" AND A.STNTO = B.STNTO(+) ");
		sql.append(" ORDER BY SCH, FLT ");
		
		//Logger.debug.println("[BASE:SkdQ050Query:selMainGMP] sql : "+sql.toString());
		System.out.println("[BASE:SkdQ050Query:selMainGMP] sql : "+sql.toString());
		return sql.toString();
	}
	
}