package kal.base.skd.query;

import kal.base.jdf.com.Logger;
import kal.base.skd.dbbean.SkdQ070BG;
import kal.base.com.query.*;
import kal.base.com.util.StringUtil;

 /**
   * Weekly SKD Display SQL 
   * @author Copyright (c) 2009/10/13 
   */    
public class SkdQ070Query {
	private static SkdQ070Query instance = new SkdQ070Query();
	
	public static SkdQ070Query getInstance() {
		return instance;
	}
	
	/** 
	  * SEASON ȸ SQLԼ.
	  * @return String Query 
	  * @author Copyright (c) 2009/10/13 
	  */
	public String selSeason() {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT CODE_C, ");
		sql.append(" TO_CHAR(TO_DATE(SUBSTR(OTHRS_E,1,8),'YYYYMMDD'),'YYYY-MM-DD') PERIOD_FR, ");
		sql.append(" TO_CHAR(TO_DATE(SUBSTR(OTHRS_E,10,8),'YYYYMMDD'),'YYYY-MM-DD') PERIOD_TO, ");
		sql.append(" SUBSTR(OTHRS_E,1,8) DATE_FR, ");
		sql.append(" SUBSTR(OTHRS_E,10,8) DATE_TO ");
		sql.append(" FROM CODE_T ");
		sql.append(" WHERE STEP_X = '1' ");
		sql.append(" AND USE_Y = 'Y' ");
		sql.append(" AND END_D > TO_CHAR(SYSDATE,'YYYYMMDD') "); //<- ʰڴ -_-
		sql.append(" AND CODE_X = 'SEASON PERIOD' ");
		sql.append(" ORDER BY PRTY_NO ");
		
		System.out.println("[BASE:SkdQ070Query:selSeason] sql : "+sql.toString());
		return sql.toString();
	}
	public String selKactyp() {//@2017-07-10
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT DISTINCT KACTYP");
		sql.append(" FROM CM_REGNO_T");
		sql.append(" WHERE ARLN_CD IN ('KE','LJ') ");
		sql.append(" ORDER BY KACTYP ASC");
		
		System.out.println("[BASE:SkdQ010Query:selKactyp] sql : "+sql.toString());
		return sql.toString();
	}
	/** 
	  * Weekly SKD Display Main ȸ SQLԼ.
	  * @return String Query 
	  * @author Copyright (c) 2009/10/13 
	  */
	public String selMain(SkdQ070BG params, String fltId) {
		StringBuffer sql = new StringBuffer();
		
		if (params.getPTimeX().equals("UTC")) {
			sql.append(" SELECT FLT_NUM, TO_CHAR(EFF_GMT_DT,'YYMMDD')||' - '||TO_CHAR(EXP_GMT_DT,'YYMMDD') PERIOD, ");
			sql.append(" GMT_FREQ FRQ, NEXT_FLT_NUM, SVC, KACTYP, LEG_NUM, STNFR, STNTO, ");
			sql.append(" TO_CHAR(EFF_GMT_DT,'HH24:MI') STD, TO_CHAR(EXP_GMT_DT,'HH24:MI') STA, ");
			sql.append(" TO_CHAR(TIMESTAMP,'YYYY-MM-DD HH24:MI') TIMESTAMP ");
		} else { //LOC
			sql.append(" SELECT FLT_NUM, TO_CHAR(EFF_LOC_DT,'YYMMDD')||' - '||TO_CHAR(EXP_LOC_DT,'YYMMDD') PERIOD, ");
			sql.append(" FREQ FRQ, NEXT_FLT_NUM, SVC, KACTYP, LEG_NUM, STNFR, STNTO, ");
			sql.append(" TO_CHAR(EFF_LOC_DT,'HH24:MI') STD, TO_CHAR(EXP_LOC_DT,'HH24:MI') STA, ");
			sql.append(" TO_CHAR(TIMESTAMP,'YYYY-MM-DD HH24:MI') TIMESTAMP ");
		}
		
		sql.append(" FROM WEEKLY_SCH_T ");
		sql.append(" WHERE ARLN_CD = 'KE' ");
		sql.append(" AND SEASON = '"+params.getPSeason()+"' ");
		
		if (!fltId.equals("")) {
			sql.append(" AND FLT_NUM IN("+fltId+") ");
		}
		
		if (!params.getPStnfr().equals("") && params.getPStnto().equals("")) {
			sql.append(" AND STNFR = '"+params.getPStnfr()+"' ");
		} else if (params.getPStnfr().equals("") && !params.getPStnto().equals("")) {
			sql.append(" AND STNTO = '"+params.getPStnto()+"' ");
		} else if (!params.getPStnfr().equals("") && !params.getPStnto().equals("") && params.getPRoundTrip().equals("")) {
			sql.append(" AND STNFR = '"+params.getPStnfr()+"' ");
			sql.append(" AND STNTO = '"+params.getPStnto()+"' ");
		} else if (!params.getPStnfr().equals("") && !params.getPStnto().equals("") && params.getPRoundTrip().equals("on")) {
			sql.append(" AND ((STNFR = '"+params.getPStnfr()+"' ");
			sql.append(" AND STNTO = '"+params.getPStnto()+"') ");
			sql.append(" OR (STNFR = '"+params.getPStnto()+"' ");
			sql.append(" AND STNTO = '"+params.getPStnfr()+"')) ");
		}
		if("JNA".equals(params.getPGubun())){
			sql.append(" 	AND	SUBSTR(FLT_NUM,1,1) = '4'  ");//@2013-11-08
		}else{
			sql.append(SkdQ070Query.getInstance().selDomIntQ(params.getPGubun()));
		}
		//@2017-07-07 kactyp
		if (!params.getTyp().equals("")){
			sql.append(" AND Kactyp='"+params.getTyp()+"'");
		}
		
		sql.append(" AND ACTIVE = 'Y' ");
		//sql.append(" ORDER BY 1,2,7 ");
		sql.append(" ORDER BY FLT_NUM, FIRST_LEG_FLT_DT, LEG_NUM ");
		
		System.out.println("[BASE:SkdQ070Query:selMain] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * DOM/INT/CGO Query ȸԼ.
	  *  ǿ ´ Query Ѵ
	  * @param domIntX String 
	  * @return String Query 
	  * @author Copyright (c) 2009/10/14 
	  */
	public String selDomIntQ(String domIntX) {

		StringBuffer sql = new StringBuffer();
		if (domIntX != null && domIntX.length() != 0)
			domIntX = domIntX.toUpperCase();
		else 
			domIntX = StringUtil.checkString(domIntX);
		
		if (domIntX.equals("DOM")) {
			sql.append(" AND SUBSTR(FLT_NUM,1,1) = '1' ");
			
		} else if (domIntX.equals("INT")) {
			sql.append(" AND NOT (SUBSTR(FLT_NUM,1,1) = '1' ");
			sql.append(" OR KACTYP IN('ABF','M1F','7FQ','7FR','74Y','7FG','79S','7GG','ABH','74F', '74N', '77X')) "); //2010.03.26 ߰ : 74F, 2012.02.22 ߰ : 74N, 77X
			
		} else if (domIntX.equals("CGO")) {
			sql.append(" AND SUBSTR(FLT_NUM,1,1) <> '1' ");
			sql.append(" AND KACTYP IN('ABF','M1F','7FQ','7FR','74Y','7FG','79S','7GG','ABH','74F', '74N', '77X') "); //2010.03.26 ߰ : 74F, 2012.02.22 ߰ : 74N, 77X
			
		} else {
			sql.setLength(0);
		}
		
		return sql.toString();
	}
}
