package kal.base.skd.query;

import kal.base.jdf.com.Logger;
import kal.base.skd.dbbean.SkdQ110BG;
import kal.base.com.query.*;

 /**
   * Gantt Chart SQL 
   * @author Copyright (c) 2006/04/24 
   */    
public class SkdQ110Query {
	private static SkdQ110Query instance = new SkdQ110Query();
	
	public static SkdQ110Query getInstance() {
		return instance;
	}
	
	/** 
	  * Gantt Chart ȸ SQLԼ.
	  * @param entity SkdQ110BG
	  * @return String Query 
	  * @author Copyright (c) 2006/04/24 
	  */
	public String selMain(SkdQ110BG entity) {
		StringBuffer sql = new StringBuffer();
		
		if ((entity.getTimeX()).equals("UTC")) {
		
			sql.append(" SELECT ");
			sql.append(" 	FLT_NUM, REGNO, STNFR, STNTO, KACTYP, TO_CHAR(FIRST_LEG_FLT_DT, 'YYYY-MM-DD') FIRST_LEG_FLT_DT, ");
			sql.append(" 	DEP_STS, ARV_STS, ");
			sql.append(" 	DECODE(TO_CHAR(SCH_DEP_DT, 'YYYYMMDD'), TO_CHAR(SYSDATE - 9/24, 'YYYYMMDD'), TO_CHAR(SCH_DEP_DT, 'HH24MI'), '0000') SCH_DEP, ");
			sql.append(" 	DECODE(TO_CHAR(ACT_DEP_DT, 'YYYYMMDD'), TO_CHAR(SYSDATE - 9/24, 'YYYYMMDD'), TO_CHAR(ACT_DEP_DT, 'HH24MI'), '0000') ACT_DEP, ");
			sql.append(" 	DECODE(TO_CHAR(EST_DEP_DT, 'YYYYMMDD'), TO_CHAR(SYSDATE - 9/24, 'YYYYMMDD'), TO_CHAR(EST_DEP_DT, 'HH24MI'), '0000') EST_DEP, ");
			// 2006.05.02 
			// 
			sql.append(" 	ROUND(( ");
			sql.append(" 	TO_DATE(DECODE(TO_CHAR(ACT_ARV_DT, 'YYYYMMDD'), TO_CHAR(SYSDATE - 9/24, 'YYYYMMDD'), TO_CHAR(ACT_ARV_DT, 'YYYYMMDDHH24MI'), TO_CHAR(SYSDATE + 15/24, 'YYYYMMDD')||'0000'), 'YYYYMMDDHH24MI') ");
			sql.append(" 	 - ");
			sql.append(" 	TO_DATE(DECODE(TO_CHAR(ACT_DEP_DT, 'YYYYMMDD'), TO_CHAR(SYSDATE - 9/24, 'YYYYMMDD'), TO_CHAR(ACT_DEP_DT, 'YYYYMMDDHH24MI'), TO_CHAR(SYSDATE - 9/24, 'YYYYMMDD')||'0000'), 'YYYYMMDDHH24MI') ");
			sql.append(" 	) * 24 * 60, 0) ACTACT_MIN, ");
			// 
			sql.append(" 	ROUND(( ");
			sql.append(" 	TO_DATE(DECODE(TO_CHAR(SCH_ARV_DT, 'YYYYMMDD'), TO_CHAR(SYSDATE - 9/24, 'YYYYMMDD'), TO_CHAR(SCH_ARV_DT, 'YYYYMMDDHH24MI'), TO_CHAR(SYSDATE + 15/24, 'YYYYMMDD')||'0000'), 'YYYYMMDDHH24MI') ");
			sql.append(" 	 - ");
			sql.append(" 	TO_DATE(DECODE(TO_CHAR(SCH_DEP_DT, 'YYYYMMDD'), TO_CHAR(SYSDATE - 9/24, 'YYYYMMDD'), TO_CHAR(SCH_DEP_DT, 'YYYYMMDDHH24MI'), TO_CHAR(SYSDATE - 9/24, 'YYYYMMDD')||'0000'), 'YYYYMMDDHH24MI') ");
			sql.append(" 	) * 24 * 60, 0) SCHSCH_MIN, ");
			// 
			sql.append(" 	ROUND(( ");
			sql.append(" 	TO_DATE(DECODE(TO_CHAR(EST_ARV_DT, 'YYYYMMDD'), TO_CHAR(SYSDATE - 9/24, 'YYYYMMDD'), TO_CHAR(EST_ARV_DT, 'YYYYMMDDHH24MI'), TO_CHAR(SYSDATE + 15/24, 'YYYYMMDD')||'0000'), 'YYYYMMDDHH24MI') ");
			sql.append(" 	 - ");
			sql.append(" 	TO_DATE(DECODE(TO_CHAR(EST_DEP_DT, 'YYYYMMDD'), TO_CHAR(SYSDATE - 9/24, 'YYYYMMDD'), TO_CHAR(EST_DEP_DT, 'YYYYMMDDHH24MI'), TO_CHAR(SYSDATE - 9/24, 'YYYYMMDD')||'0000'), 'YYYYMMDDHH24MI') ");
			sql.append(" 	) * 24 * 60, 0) ESTEST_MIN, ");
			//  ( )
			sql.append(" 	ROUND(( ");
			sql.append(" 	TO_DATE(DECODE(TO_CHAR(SCH_ARV_DT, 'YYYYMMDD'), TO_CHAR(SYSDATE - 9/24, 'YYYYMMDD'), TO_CHAR(SCH_ARV_DT, 'YYYYMMDDHH24MI'), TO_CHAR(SYSDATE + 15/24, 'YYYYMMDD')||'0000'), 'YYYYMMDDHH24MI') ");
			sql.append(" 	 - ");
			sql.append(" 	TO_DATE(DECODE(TO_CHAR(ACT_DEP_DT, 'YYYYMMDD'), TO_CHAR(SYSDATE - 9/24, 'YYYYMMDD'), TO_CHAR(ACT_DEP_DT, 'YYYYMMDDHH24MI'), TO_CHAR(SYSDATE - 9/24, 'YYYYMMDD')||'0000'), 'YYYYMMDDHH24MI') ");
			sql.append(" 	) * 24 * 60, 0) ACTSCH_MIN, ");
			//  ( )
			sql.append(" 	ROUND(( ");
			sql.append(" 	TO_DATE(DECODE(TO_CHAR(EST_ARV_DT, 'YYYYMMDD'), TO_CHAR(SYSDATE - 9/24, 'YYYYMMDD'), TO_CHAR(EST_ARV_DT, 'YYYYMMDDHH24MI'), TO_CHAR(SYSDATE + 15/24, 'YYYYMMDD')||'0000'), 'YYYYMMDDHH24MI') ");
			sql.append(" 	 - ");
			sql.append(" 	TO_DATE(DECODE(TO_CHAR(ACT_DEP_DT, 'YYYYMMDD'), TO_CHAR(SYSDATE - 9/24, 'YYYYMMDD'), TO_CHAR(ACT_DEP_DT, 'YYYYMMDDHH24MI'), TO_CHAR(SYSDATE - 9/24, 'YYYYMMDD')||'0000'), 'YYYYMMDDHH24MI') ");
			sql.append(" 	) * 24 * 60, 0) ACTEST_MIN, ");
			
			sql.append(" 	NVL(F_CFG, 0) F_CFG, NVL(C_CFG, 0) C_CFG, NVL(Y_CFG, 0) Y_CFG, ");
			sql.append(" 	NVL(F_BOOK, 0) F_BOOK, NVL(C_BOOK, 0) C_BOOK, NVL(Y_BOOK, 0) Y_BOOK, ");
			sql.append(" 	NVL(F_CHKIN, 0) F_CHKIN, NVL(C_CHKIN, 0) C_CHKIN, NVL(Y_CHKIN, 0) Y_CHKIN, ");
			
			sql.append(" 	 TO_CHAR(ACT_DEP_DT, 'DDMONRR HH24:MI')||' - '||TO_CHAR(ACT_ARV_DT, 'DDMONRR HH24:MI') ACTACT_UTC, ");
			sql.append(" 	 TO_CHAR(SCH_DEP_DT, 'DDMONRR HH24:MI')||' - '||TO_CHAR(SCH_ARV_DT, 'DDMONRR HH24:MI') SCHSCH_UTC, ");
			sql.append(" 	 TO_CHAR(EST_DEP_DT, 'DDMONRR HH24:MI')||' - '||TO_CHAR(EST_ARV_DT, 'DDMONRR HH24:MI') ESTEST_UTC, ");
			sql.append(" 	 TO_CHAR(ACT_DEP_DT, 'DDMONRR HH24:MI')||' - '||TO_CHAR(SCH_ARV_DT, 'DDMONRR HH24:MI') ACTSCH_UTC, ");
			sql.append(" 	 TO_CHAR(ACT_DEP_DT, 'DDMONRR HH24:MI')||' - '||TO_CHAR(EST_ARV_DT, 'DDMONRR HH24:MI') ACTEST_UTC, ");
	
			sql.append(" 	 TO_CHAR(ACT_DEP_DT_LOC, 'DDMONRR HH24:MI')||' - '||TO_CHAR(ACT_ARV_DT_LOC, 'DDMONRR HH24:MI') ACTACT_LOC, ");
			sql.append(" 	 TO_CHAR(SCH_DEP_DT_LOC, 'DDMONRR HH24:MI')||' - '||TO_CHAR(SCH_ARV_DT_LOC, 'DDMONRR HH24:MI') SCHSCH_LOC, ");
			sql.append(" 	 TO_CHAR(EST_DEP_DT_LOC, 'DDMONRR HH24:MI')||' - '||TO_CHAR(EST_ARV_DT_LOC, 'DDMONRR HH24:MI') ESTEST_LOC, ");
			sql.append(" 	 TO_CHAR(ACT_DEP_DT_LOC, 'DDMONRR HH24:MI')||' - '||TO_CHAR(SCH_ARV_DT_LOC, 'DDMONRR HH24:MI') ACTSCH_LOC, ");
			sql.append(" 	 TO_CHAR(ACT_DEP_DT_LOC, 'DDMONRR HH24:MI')||' - '||TO_CHAR(EST_ARV_DT_LOC, 'DDMONRR HH24:MI') ACTEST_LOC ");
			
			sql.append(" FROM DAILY_SCH_T ");
			sql.append(" WHERE ARLN_CD = 'KE' ");
			if (!entity.getKactyp().equals("")) {
				sql.append("  AND KACTYP = '" + entity.getKactyp() + "' ");
			}
			sql.append(" 	AND ((SCH_DEP_DT >= TO_DATE(TO_CHAR(SYSDATE - 9/24, 'YYYYMMDD')||'0000' , 'YYYYMMDDHH24MI') ");
			sql.append(" 		AND SCH_DEP_DT <= TO_DATE(TO_CHAR(SYSDATE - 9/24, 'YYYYMMDD')||'2359' , 'YYYYMMDDHH24MI')) ");
			sql.append(" 		OR (ACT_ARV_DT >= TO_DATE(TO_CHAR(SYSDATE - 9/24, 'YYYYMMDD')||'0000' , 'YYYYMMDDHH24MI') ");
			sql.append(" 		AND ACT_ARV_DT <= TO_DATE(TO_CHAR(SYSDATE - 9/24, 'YYYYMMDD')||'2359' , 'YYYYMMDDHH24MI'))) ");
			sql.append(" 	AND REGNO <> 'ZZZZZ' ");
			sql.append(" 	AND ACTNID <> 'CNL' ");
			sql.append(" 	AND DEP_STS <> 'INI' ");
			sql.append(" ORDER BY REGNO, SCH_DEP_DT ");
		
		} else if ((entity.getTimeX()).equals("KST")) {
			
			sql.append(" SELECT ");
			sql.append(" 	FLT_NUM, REGNO, STNFR, STNTO, KACTYP, TO_CHAR(FIRST_LEG_FLT_DT, 'YYYY-MM-DD') FIRST_LEG_FLT_DT, ");
			sql.append(" 	DEP_STS, ARV_STS, ");
			sql.append(" 	DECODE(TO_CHAR(SCH_DEP_DT + 9/24, 'YYYYMMDD'), TO_CHAR(SYSDATE, 'YYYYMMDD'), TO_CHAR(SCH_DEP_DT + 9/24, 'HH24MI'), '0000') SCH_DEP, ");
			sql.append(" 	DECODE(TO_CHAR(ACT_DEP_DT + 9/24, 'YYYYMMDD'), TO_CHAR(SYSDATE, 'YYYYMMDD'), TO_CHAR(ACT_DEP_DT + 9/24, 'HH24MI'), '0000') ACT_DEP, ");
			sql.append(" 	DECODE(TO_CHAR(EST_DEP_DT + 9/24, 'YYYYMMDD'), TO_CHAR(SYSDATE, 'YYYYMMDD'), TO_CHAR(EST_DEP_DT + 9/24, 'HH24MI'), '0000') EST_DEP, ");
			// 2006.05.02 
			// 
			sql.append(" 	ROUND(( ");
			sql.append(" 	TO_DATE(DECODE(TO_CHAR(ACT_ARV_DT + 9/24, 'YYYYMMDD'), TO_CHAR(SYSDATE, 'YYYYMMDD'), TO_CHAR(ACT_ARV_DT + 9/24, 'YYYYMMDDHH24MI'), TO_CHAR(SYSDATE + 1440/1440, 'YYYYMMDD')||'0000'), 'YYYYMMDDHH24MI') ");
			sql.append(" 	 - ");
			sql.append(" 	TO_DATE(DECODE(TO_CHAR(ACT_DEP_DT + 9/24, 'YYYYMMDD'), TO_CHAR(SYSDATE, 'YYYYMMDD'), TO_CHAR(ACT_DEP_DT + 9/24, 'YYYYMMDDHH24MI'), TO_CHAR(SYSDATE, 'YYYYMMDD')||'0000'), 'YYYYMMDDHH24MI') ");
			sql.append(" 	) * 24 * 60, 0) ACTACT_MIN, ");
			// 
			sql.append(" 	ROUND(( ");
			sql.append(" 	TO_DATE(DECODE(TO_CHAR(SCH_ARV_DT + 9/24, 'YYYYMMDD'), TO_CHAR(SYSDATE, 'YYYYMMDD'), TO_CHAR(SCH_ARV_DT + 9/24, 'YYYYMMDDHH24MI'), TO_CHAR(SYSDATE + 1440/1440, 'YYYYMMDD')||'0000'), 'YYYYMMDDHH24MI') ");
			sql.append(" 	 - ");
			sql.append(" 	TO_DATE(DECODE(TO_CHAR(SCH_DEP_DT + 9/24, 'YYYYMMDD'), TO_CHAR(SYSDATE, 'YYYYMMDD'), TO_CHAR(SCH_DEP_DT + 9/24, 'YYYYMMDDHH24MI'), TO_CHAR(SYSDATE, 'YYYYMMDD')||'0000'), 'YYYYMMDDHH24MI') ");
			sql.append(" 	) * 24 * 60, 0) SCHSCH_MIN, ");
			// 
			sql.append(" 	ROUND(( ");
			sql.append(" 	TO_DATE(DECODE(TO_CHAR(EST_ARV_DT + 9/24, 'YYYYMMDD'), TO_CHAR(SYSDATE, 'YYYYMMDD'), TO_CHAR(EST_ARV_DT + 9/24, 'YYYYMMDDHH24MI'), TO_CHAR(SYSDATE + 1440/1440, 'YYYYMMDD')||'0000'), 'YYYYMMDDHH24MI') ");
			sql.append(" 	 - ");
			sql.append(" 	TO_DATE(DECODE(TO_CHAR(EST_DEP_DT + 9/24, 'YYYYMMDD'), TO_CHAR(SYSDATE, 'YYYYMMDD'), TO_CHAR(EST_DEP_DT + 9/24, 'YYYYMMDDHH24MI'), TO_CHAR(SYSDATE, 'YYYYMMDD')||'0000'), 'YYYYMMDDHH24MI') ");
			sql.append(" 	) * 24 * 60, 0) ESTEST_MIN, ");
			//  ( )
			sql.append(" 	ROUND(( ");
			sql.append(" 	TO_DATE(DECODE(TO_CHAR(SCH_ARV_DT + 9/24, 'YYYYMMDD'), TO_CHAR(SYSDATE, 'YYYYMMDD'), TO_CHAR(SCH_ARV_DT + 9/24, 'YYYYMMDDHH24MI'), TO_CHAR(SYSDATE + 1440/1440, 'YYYYMMDD')||'0000'), 'YYYYMMDDHH24MI') ");
			sql.append(" 	 - ");
			sql.append(" 	TO_DATE(DECODE(TO_CHAR(ACT_DEP_DT + 9/24, 'YYYYMMDD'), TO_CHAR(SYSDATE, 'YYYYMMDD'), TO_CHAR(ACT_DEP_DT + 9/24, 'YYYYMMDDHH24MI'), TO_CHAR(SYSDATE, 'YYYYMMDD')||'0000'), 'YYYYMMDDHH24MI') ");
			sql.append(" 	) * 24 * 60, 0) ACTSCH_MIN, ");
			//  ( )
			sql.append(" 	ROUND(( ");
			sql.append(" 	TO_DATE(DECODE(TO_CHAR(EST_ARV_DT + 9/24, 'YYYYMMDD'), TO_CHAR(SYSDATE, 'YYYYMMDD'), TO_CHAR(EST_ARV_DT + 9/24, 'YYYYMMDDHH24MI'), TO_CHAR(SYSDATE + 1440/1440, 'YYYYMMDD')||'0000'), 'YYYYMMDDHH24MI') ");
			sql.append(" 	 - ");
			sql.append(" 	TO_DATE(DECODE(TO_CHAR(ACT_DEP_DT + 9/24, 'YYYYMMDD'), TO_CHAR(SYSDATE, 'YYYYMMDD'), TO_CHAR(ACT_DEP_DT + 9/24, 'YYYYMMDDHH24MI'), TO_CHAR(SYSDATE, 'YYYYMMDD')||'0000'), 'YYYYMMDDHH24MI') ");
			sql.append(" 	) * 24 * 60, 0) ACTEST_MIN, ");
			
			sql.append(" 	NVL(F_CFG, 0) F_CFG, NVL(C_CFG, 0) C_CFG, NVL(Y_CFG, 0) Y_CFG, ");
			sql.append(" 	NVL(F_BOOK, 0) F_BOOK, NVL(C_BOOK, 0) C_BOOK, NVL(Y_BOOK, 0) Y_BOOK, ");
			sql.append(" 	NVL(F_CHKIN, 0) F_CHKIN, NVL(C_CHKIN, 0) C_CHKIN, NVL(Y_CHKIN, 0) Y_CHKIN, ");
			
			sql.append(" 	 TO_CHAR(ACT_DEP_DT, 'DDMONRR HH24:MI')||' - '||TO_CHAR(ACT_ARV_DT, 'DDMONRR HH24:MI') ACTACT_UTC, ");
			sql.append(" 	 TO_CHAR(SCH_DEP_DT, 'DDMONRR HH24:MI')||' - '||TO_CHAR(SCH_ARV_DT, 'DDMONRR HH24:MI') SCHSCH_UTC, ");
			sql.append(" 	 TO_CHAR(EST_DEP_DT, 'DDMONRR HH24:MI')||' - '||TO_CHAR(EST_ARV_DT, 'DDMONRR HH24:MI') ESTEST_UTC, ");
			sql.append(" 	 TO_CHAR(ACT_DEP_DT, 'DDMONRR HH24:MI')||' - '||TO_CHAR(SCH_ARV_DT, 'DDMONRR HH24:MI') ACTSCH_UTC, ");
			sql.append(" 	 TO_CHAR(ACT_DEP_DT, 'DDMONRR HH24:MI')||' - '||TO_CHAR(EST_ARV_DT, 'DDMONRR HH24:MI') ACTEST_UTC, ");
	
			sql.append(" 	 TO_CHAR(ACT_DEP_DT_LOC, 'DDMONRR HH24:MI')||' - '||TO_CHAR(ACT_ARV_DT_LOC, 'DDMONRR HH24:MI') ACTACT_LOC, ");
			sql.append(" 	 TO_CHAR(SCH_DEP_DT_LOC, 'DDMONRR HH24:MI')||' - '||TO_CHAR(SCH_ARV_DT_LOC, 'DDMONRR HH24:MI') SCHSCH_LOC, ");
			sql.append(" 	 TO_CHAR(EST_DEP_DT_LOC, 'DDMONRR HH24:MI')||' - '||TO_CHAR(EST_ARV_DT_LOC, 'DDMONRR HH24:MI') ESTEST_LOC, ");
			sql.append(" 	 TO_CHAR(ACT_DEP_DT_LOC, 'DDMONRR HH24:MI')||' - '||TO_CHAR(SCH_ARV_DT_LOC, 'DDMONRR HH24:MI') ACTSCH_LOC, ");
			sql.append(" 	 TO_CHAR(ACT_DEP_DT_LOC, 'DDMONRR HH24:MI')||' - '||TO_CHAR(EST_ARV_DT_LOC, 'DDMONRR HH24:MI') ACTEST_LOC ");
			
			sql.append(" FROM DAILY_SCH_T ");
			sql.append(" WHERE ARLN_CD = 'KE' ");
			if (!entity.getKactyp().equals("")) {
				sql.append("  AND KACTYP = '" + entity.getKactyp() + "' ");
			}
			sql.append(" 	AND ((SCH_DEP_DT >= TO_DATE(TO_CHAR(SYSDATE, 'YYYYMMDD')||'0000' , 'YYYYMMDDHH24MI') - 9/24 ");
			sql.append(" 		AND SCH_DEP_DT <= TO_DATE(TO_CHAR(SYSDATE, 'YYYYMMDD')||'2359' , 'YYYYMMDDHH24MI') - 9/24) ");
			sql.append(" 		OR (ACT_ARV_DT >= TO_DATE(TO_CHAR(SYSDATE, 'YYYYMMDD')||'0000' , 'YYYYMMDDHH24MI') - 9/24 ");
			sql.append(" 		AND ACT_ARV_DT <= TO_DATE(TO_CHAR(SYSDATE, 'YYYYMMDD')||'2359' , 'YYYYMMDDHH24MI') - 9/24)) ");
			sql.append(" 	AND REGNO <> 'ZZZZZ' ");
			sql.append(" 	AND ACTNID <> 'CNL' ");
			sql.append(" 	AND DEP_STS <> 'INI' ");
			sql.append(" ORDER BY REGNO, SCH_DEP_DT ");
		}

		Logger.debug.println("[BASE:SkdQ110Query:selMain] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * Gantt Chart ˾ ȸ SQLԼ.
	  * @param entity SkdQ110BG
	  * @return String Query 
	  * @author Copyright (c) 2006/05/09 
	  */
	public String selCrew(SkdQ110BG entity) {
		StringBuffer sql = new StringBuffer();

		if ((entity.getTimeX()).equals("UTC")) {
			
			sql.append(" SELECT A.FIRST_LEG_FLT_DT, A.STAFF_NUM, A.ENG_NAME, A.RANK_CD, A.GISU_NR ");
			sql.append(" FROM ");
			sql.append(" 	(SELECT FIRST_LEG_FLT_DT, ARLN_CD, FLT_NUM, STNFR, STNTO, STAFF_NUM, ENG_NAME,  ");
			sql.append(" 		S.FLT_SEQ_NR, RANK_CD, RANK_NR, DECODE(GISU_NR, '009', 'TVL', 'FLY') AS GISU_NR ");
			sql.append(" 	 FROM GD_SKD_T S, GD_CREW_T C ");
			sql.append(" 	 WHERE S.FLT_SEQ_NR = C.FLT_SEQ_NR ");
			sql.append(" 	 	AND RANK_CD IN ('CAP', 'F/O', 'F/E', 'RC')) A, DAILY_SCH_T B ");
			sql.append(" WHERE A.FIRST_LEG_FLT_DT = B.FIRST_LEG_FLT_DT ");
			sql.append(" 	AND A.FLT_NUM = B.FLT_NUM ");
			sql.append(" 	AND ((SCH_DEP_DT >= TO_DATE(TO_CHAR(SYSDATE - 9/24, 'YYYYMMDD')||'0000' , 'YYYYMMDDHH24MI') "); 		
			sql.append(" 	AND SCH_DEP_DT <= TO_DATE(TO_CHAR(SYSDATE - 9/24, 'YYYYMMDD')||'2359' , 'YYYYMMDDHH24MI')) ");		
			sql.append(" 	OR (ACT_ARV_DT >= TO_DATE(TO_CHAR(SYSDATE - 9/24, 'YYYYMMDD')||'0000' , 'YYYYMMDDHH24MI') ");		
			sql.append(" 	AND ACT_ARV_DT <= TO_DATE(TO_CHAR(SYSDATE - 9/24, 'YYYYMMDD')||'2359' , 'YYYYMMDDHH24MI'))) ");
			sql.append(" 	AND A.FIRST_LEG_FLT_DT = TO_DATE('" + entity.getFirstLegFltDt() + "', 'YYYY-MM-DD') ");
			sql.append(" 	AND A.FLT_NUM = '" + entity.getFltNum() + "' ");
			sql.append(" 	AND A.STNFR = B.STNFR ");
			sql.append(" 	AND A.STNTO = B.STNTO ");
			sql.append(" ORDER BY RANK_NR ");	
			
		} else if ((entity.getTimeX()).equals("KST")) {
			
			sql.append(" SELECT A.FIRST_LEG_FLT_DT, A.STAFF_NUM, A.ENG_NAME, A.RANK_CD, A.GISU_NR ");
			sql.append(" FROM ");
			sql.append(" 	(SELECT FIRST_LEG_FLT_DT, ARLN_CD, FLT_NUM, STNFR, STNTO, STAFF_NUM, ENG_NAME,  ");
			sql.append(" 		S.FLT_SEQ_NR, RANK_CD, RANK_NR, DECODE(GISU_NR, '009', 'TVL', 'FLY') AS GISU_NR ");
			sql.append(" 	 FROM GD_SKD_T S, GD_CREW_T C ");
			sql.append(" 	 WHERE S.FLT_SEQ_NR = C.FLT_SEQ_NR ");
			sql.append(" 	 	AND RANK_CD IN ('CAP', 'F/O', 'F/E', 'RC')) A, DAILY_SCH_T B ");
			sql.append(" WHERE A.FIRST_LEG_FLT_DT = B.FIRST_LEG_FLT_DT ");
			sql.append(" 	AND A.FLT_NUM = B.FLT_NUM ");
			sql.append(" 	AND ((SCH_DEP_DT >= TO_DATE(TO_CHAR(SYSDATE, 'YYYYMMDD')||'0000' , 'YYYYMMDDHH24MI') - 9/24 "); 		
			sql.append(" 	AND SCH_DEP_DT <= TO_DATE(TO_CHAR(SYSDATE, 'YYYYMMDD')||'2359' , 'YYYYMMDDHH24MI') - 9/24) ");		
			sql.append(" 	OR (ACT_ARV_DT >= TO_DATE(TO_CHAR(SYSDATE, 'YYYYMMDD')||'0000' , 'YYYYMMDDHH24MI') - 9/24 ");		
			sql.append(" 	AND ACT_ARV_DT <= TO_DATE(TO_CHAR(SYSDATE, 'YYYYMMDD')||'2359' , 'YYYYMMDDHH24MI') - 9/24)) ");
			sql.append(" 	AND A.FIRST_LEG_FLT_DT = TO_DATE('" + entity.getFirstLegFltDt() + "', 'YYYY-MM-DD') ");
			sql.append(" 	AND A.FLT_NUM = '" + entity.getFltNum() + "' ");
			sql.append(" 	AND A.STNFR = B.STNFR ");
			sql.append(" 	AND A.STNTO = B.STNTO ");
			sql.append(" ORDER BY RANK_NR ");
		}
		
		Logger.debug.println("[BASE:SkdQ110Query:selCrew] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  *  KACTYP ȸ SQLԼ.
	  * @param entity SkdQ110BG
	  * @return String Query 
	  * @author Copyright (c) 2006/05/09 
	  */
	public String selKactyp(SkdQ110BG entity) {
		StringBuffer sql = new StringBuffer();
		
		if ((entity.getTimeX()).equals("UTC")) {
			
			sql.append(" SELECT DISTINCT KACTYP ");
			sql.append(" FROM DAILY_SCH_T ");
			sql.append(" WHERE ARLN_CD = 'KE' ");	
			sql.append(" 	AND ((SCH_DEP_DT >= TO_DATE(TO_CHAR(SYSDATE - 9/24, 'YYYYMMDD')||'0000' , 'YYYYMMDDHH24MI') ");		
			sql.append(" 	AND SCH_DEP_DT <= TO_DATE(TO_CHAR(SYSDATE - 9/24, 'YYYYMMDD')||'2359' , 'YYYYMMDDHH24MI'))  ");
			sql.append(" 	OR (ACT_ARV_DT >= TO_DATE(TO_CHAR(SYSDATE - 9/24, 'YYYYMMDD')||'0000' , 'YYYYMMDDHH24MI') ");
			sql.append(" 	AND ACT_ARV_DT <= TO_DATE(TO_CHAR(SYSDATE - 9/24, 'YYYYMMDD')||'2359' , 'YYYYMMDDHH24MI'))) ");
			//sql.append(" 	AND REGNO <> 'ZZZZZ' ");
			sql.append(" 	AND ACTNID <> 'CNL' ");
			sql.append(" 	AND DEP_STS <> 'INI' ");
			sql.append(" ORDER BY KACTYP ");	
			
		} else if ((entity.getTimeX()).equals("KST")) {
			
			sql.append(" SELECT DISTINCT KACTYP ");
			sql.append(" FROM DAILY_SCH_T ");
			sql.append(" WHERE ARLN_CD = 'KE' ");	
			sql.append(" 	AND ((SCH_DEP_DT >= TO_DATE(TO_CHAR(SYSDATE, 'YYYYMMDD')||'0000' , 'YYYYMMDDHH24MI') - 9/24 ");		
			sql.append(" 	AND SCH_DEP_DT <= TO_DATE(TO_CHAR(SYSDATE, 'YYYYMMDD')||'2359' , 'YYYYMMDDHH24MI') - 9/24)  ");
			sql.append(" 	OR (ACT_ARV_DT >= TO_DATE(TO_CHAR(SYSDATE, 'YYYYMMDD')||'0000' , 'YYYYMMDDHH24MI') - 9/24 ");
			sql.append(" 	AND ACT_ARV_DT <= TO_DATE(TO_CHAR(SYSDATE, 'YYYYMMDD')||'2359' , 'YYYYMMDDHH24MI') - 9/24)) ");
			//sql.append(" 	AND REGNO <> 'ZZZZZ' ");
			sql.append(" 	AND ACTNID <> 'CNL' ");
			sql.append(" 	AND DEP_STS <> 'INI' ");
			sql.append(" ORDER BY KACTYP ");	
		}

		Logger.debug.println("[BASE:SkdQ110Query:selKactyp] sql : "+sql.toString());
		return sql.toString();
	}
}