package kal.base.sta.query;

import kal.base.jdf.com.Logger;
import kal.base.sta.dbbean.*;
import kal.base.com.query.*;

 /**
   * OPS Statistics/Operation Status SQL 
   * @author Copyright (c) 2005/01/25 HIST  
   */   
public class StaQ020Query {
	
	private static StaQ020Query instance = new StaQ020Query();
	
	public static StaQ020Query getInstance() {
		return instance;
	}
	
	/** 
	  * OPS Statistics/Operation Status Main ȸ SQLԼ.
	  * @param params StaQ020BG ȸ
	  * @return String Query  
	  * @author Copyright (c) 2005/01/25 HIST 
	  */
	public String selMain(StaQ020BG params, String domAirport) {
		StringBuffer sql = new StringBuffer();
		
		// D/A ǿ  ȸ Ǻ
		String station = "Stnfr";
		String schDt = "Sch_Dep_Dt";
		String actDt = "Act_Dep_Dt";
		if (params.getDep_arr_x().equals("ARR")) {
			station = "Stnto";
			schDt = "Sch_Arv_Dt";
			actDt = "Act_Arv_Dt";
		}
				
		sql.append(" Select "+station+" Stn,Decode(SVC,'J','AR','F','AR','M','AR','G','NR','A','NR','C','NR','H','NR','NV') Svc,");
		sql.append("          Decode(Actnid,'CNL','CNL','NEW') Actnid, Count(*) Data_Cnt,'A' Flt_Mode");
		sql.append(" From Daily_Sch_t");
		sql.append(" Where Arln_cd = 'KE' And");
		sql.append(" 			SUBSTR(FLT_NUM, 1, 1) <> '4' AND "); //2008.10.29 ߰ :  FLT 
		if (params.getTime_x().equals("KST")) {
			sql.append("      Sch_Dep_Dt >= To_Date('"+params.getFrom_date()+" 0000','yyyymmdd hh24mi') - 9/24 And");
			sql.append("      Sch_Dep_Dt <= To_Date('"+params.getTo_date()+" 2359','yyyymmdd hh24mi') - 9/24 And");
		} else { //UTC
			sql.append("      Sch_Dep_Dt >= To_Date('"+params.getFrom_date()+" 0000','yyyymmdd hh24mi') And");
			sql.append("      Sch_Dep_Dt <= To_Date('"+params.getTo_date()+" 2359','yyyymmdd hh24mi') And");
		}
		sql.append("       	Timestamp >= Sch_Dep_Dt - 39/24 And");
		if (!params.getStn().equals("")) {
			if (params.getStn().equals("DOM")) {
				sql.append(" "+ (params.getDep_arr_x().equals("DEP") ? "Stnfr" : "Stnto") +" IN ("+domAirport+") And"); //2010.09.06 ߰ : STN DOM Է½  /  ü ȸ
			} else {
				sql.append(" "+ (params.getDep_arr_x().equals("DEP") ? "Stnfr" : "Stnto") +" = '"+params.getStn()+"' And");
			}
		}
		//DOM/INT/CGO ȸ
		sql.append(ComQ01Query.getInstance().selDomIntQ(params.getDom_int_x()));
		sql.append("       		Stnfr <> Stnto And");
		sql.append("       		Dep_Sts <> 'INI'");
		sql.append("       		AND KACTYP NOT IN ('79S','7GG','ABH') "); //2010.09.06 ߰ :  
		sql.append("       		AND SUBSTR(FLT_NUM, -1, 1) NOT IN ('M','F','T','D') "); //2010.09.06 ߰ : M/F/T/D  FLT 
		sql.append(" Group By "+station+",Decode(SVC,'J','AR','F','AR','M','AR','G','NR','A','NR','C','NR','H','NR','NV'),");
		sql.append("                 Decode(Actnid,'CNL','CNL','NEW')");
		sql.append(" Union");
		sql.append(" Select "+station+" Stn,Decode(SVC,'J','AR','F','AR','M','AR','G','NR','A','NR','C','NR','H','NR','NV') Svc,");
		sql.append("            Decode(Actnid,'CNL','CNL','NEW') Actnid, Count(*) Data_Cnt, 'B' Flt_Mode");
		sql.append(" From Daily_Sch_t");
		sql.append(" Where Arln_cd = 'KE' And");
		sql.append(" 			SUBSTR(FLT_NUM, 1, 1) <> '4' AND "); //2008.10.29 ߰ :  FLT 
		if (params.getTime_x().equals("KST")) {
			sql.append("      Sch_Dep_Dt >= To_Date('"+params.getFrom_date()+" 0000','yyyymmdd hh24mi') - 9/24 And");
			sql.append("      Sch_Dep_Dt <= To_Date('"+params.getTo_date()+" 2359','yyyymmdd hh24mi') - 9/24 And");
		} else { //UTC
			sql.append("      Sch_Dep_Dt >= To_Date('"+params.getFrom_date()+" 0000','yyyymmdd hh24mi') And");
			sql.append("      Sch_Dep_Dt <= To_Date('"+params.getTo_date()+" 2359','yyyymmdd hh24mi') And");
		}
		if (!params.getStart_tm().equals(""))
			sql.append("       		"+actDt+" - "+schDt+" > "+params.getStart_tm()+"/1440 And");
		else 
			sql.append("       		"+actDt+" - "+schDt+" > 3/1440 And");
		if (!params.getEnd_tm().equals(""))	
			sql.append("       		"+actDt+" - "+schDt+" < "+params.getEnd_tm()+"/1440 And");
		sql.append(" 			Actnid  <> 'CNL'  And");
		if (!params.getStn().equals("")) {
			if (params.getStn().equals("DOM")) {
				sql.append(" "+ (params.getDep_arr_x().equals("DEP") ? "Stnfr" : "Stnto") +" IN ("+domAirport+") And"); //2010.09.06 ߰ : STN DOM Է½  /  ü ȸ
			} else {
				sql.append(" "+ (params.getDep_arr_x().equals("DEP") ? "Stnfr" : "Stnto") +" = '"+params.getStn()+"' And");
			}
		}
		//DOM/INT/CGO ȸ
		sql.append(ComQ01Query.getInstance().selDomIntQ(params.getDom_int_x()));
		sql.append("       		Stnfr <> Stnto And");
		sql.append(" 				Dep_Sts <> 'INI'");
		sql.append("       		AND KACTYP NOT IN ('79S','7GG','ABH') "); //2010.09.06 ߰ :  
		sql.append("       		AND SUBSTR(FLT_NUM, -1, 1) NOT IN ('M','F','T','D') "); //2010.09.06 ߰ : M/F/T/D  FLT 
		sql.append(" Group By "+station+",Decode(SVC,'J','AR','F','AR','M','AR','G','NR','A','NR','C','NR','H','NR','NV'),");
		sql.append("        		 Decode(Actnid,'CNL','CNL','NEW')");
		sql.append(" Order By 1,2,5,3");
		
		//Logger.debug.println("[BASE:StaQ020Query:selMain] sql : "+sql.toString());
		System.out.println("[BASE:StaQ020Query:selMain] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  *   ȸ SQLԼ.
	  * @return String Query 
	  * ۼ ¥ : 2010.09.06
	  */
	public String getDomAirport() {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT IATA_PORT ");
		sql.append(" FROM CM_PORT_T ");
		sql.append(" WHERE REGION_X = '1' ");
		
		return sql.toString();
	}
}
