package kal.base.sta.query;

import kal.base.jdf.com.Logger;
import kal.base.sta.dbbean.StaQ130BG;
import kal.base.com.query.ComQ01Query;

 /**
   * Legs Summary(LEG) SQL 
   * @author Copyright (c) 2010/01/18 
   */  
public class StaQ130Query {
	private static StaQ130Query instance = new StaQ130Query();
	
	public static StaQ130Query getInstance() {
		return instance;
	}
	
	/** 
	  * Legs Summary(LEG) main ȸ SQLԼ.
	  * @param params StaQ130BG
	  * @return String Query 
	  * @author Copyright (c) 2010/01/18 
	  */
	public String selMain(StaQ130BG params){
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT TO_CHAR(A.FIRST_LEG_FLT_DT, 'YYYYMMDD') FIRST_LEG_FLT_DT, ");
		sql.append(" A.FLT_NUM, A.LEG_NUM, A.STNFR, A.STNTO, A.KACTYP, A.DEP_STS, A.SVC, A.ACTNID, ");
		sql.append(" (A.ACT_DEP_DT - A.SCH_DEP_DT) * 24 * 60 DEL_MM ");
		sql.append(" FROM DAILY_SCH_T A, ");
		sql.append(" (SELECT DISTINCT FIRST_LEG_FLT_DT, FLT_NUM ");
		sql.append(" FROM DAILY_SCH_T ");
		sql.append(" WHERE ARLN_CD = 'KE' ");
		sql.append(" AND SUBSTR(FLT_NUM,1,1) <> '4' ");
		sql.append(" AND LEG_NUM IN (1,10) ");
		sql.append(" AND DEP_STS <> 'INI' ");
		sql.append(" AND FIRST_LEG_FLT_DT = TO_DATE('20"+params.getDt()+"','YYYYMMDD') ");
		sql.append(" AND TIMESTAMP >= SCH_DEP_DT - 63/24) B ");
		sql.append(" WHERE A.ARLN_CD = 'KE' ");
		sql.append(" AND A.DEP_STS <> 'INI' ");
		sql.append(" AND A.FIRST_LEG_FLT_DT = TO_DATE('20"+params.getDt()+"','YYYYMMDD') ");
		sql.append(" AND A.FIRST_LEG_FLT_DT = B.FIRST_LEG_FLT_DT ");
		sql.append(" AND A.FLT_NUM = B.FLT_NUM ");
		sql.append(" ORDER BY 1, 2, 3 ");
		
		System.out.println("[BASE:StaQ130Query:selMain] sql : "+sql.toString());
		return sql.toString();
	}
}
