package kal.base.sta.query;

import kal.base.jdf.com.Logger;
import kal.base.sta.dbbean.StaQ420BG;
import kal.base.com.query.ComQ01Query;

 /**
   * ASM Status(IRR) SQL 
   * @author Copyright (c) 2010/01/20 
   */
public class StaQ420Query {
	private static StaQ420Query instance = new StaQ420Query();
	
	public static StaQ420Query getInstance() {
		return instance;
	}
	
	/** 
	  * AD-HOC MSG CODE ȸ SQLԼ.
	  * @return String Query 
	  * @author Copyright (c) 2010/01/20 
	  */
	public String selCode(){
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT CODE_C ");
		sql.append(" FROM CODE_T ");
		sql.append(" WHERE STEP_X = '1' ");
		sql.append(" AND USE_Y = 'Y' ");
		sql.append(" AND CODE_X = 'AD-HOC MSG CODE' ");
		sql.append(" ORDER BY PRTY_NO ");
		
		System.out.println("[BASE:StaQ420Query:selCode] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * ASM Status(IRR) main ȸ SQLԼ.
	  * @param params StaQ420BG
	  * @return String Query 
	  * @author Copyright (c) 2010/01/20 
	  */
	public String selMain(StaQ420BG params){
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT TO_CHAR(FIRST_LEG_FLT_DT,'YYYYMMDD') FIRST_LEG_FLT_DT, ");
		sql.append(" TO_CHAR(SCH_DEP_DT,'YYMMDD') SCH_DT, ");
		sql.append(" TO_CHAR(SCH_DEP_DT,'HH24:MI') STD, ");
		sql.append(" TO_CHAR(SCH_ARV_DT,'HH24:MI') STA, ");
		sql.append(" FLT_NUM, STNFR, STNTO, KACTYP, ACTNID, SUBSTR(CHGREAS,1,4) REASON ");
		sql.append(" FROM DAILY_SCH_T ");
		sql.append(" WHERE ARLN_CD = 'KE' ");
		sql.append(" AND SCH_DEP_DT >= TO_DATE('20"+params.getStart_dt()+" 0000','YYYYMMDD HH24MI') ");
		sql.append(" AND SCH_DEP_DT <= TO_DATE('20"+params.getEnd_dt()+" 2359','YYYYMMDD HH24MI') ");
		
		if (!params.getAsm().equals("ALL")) {
			sql.append(" AND ACTNID = '"+params.getAsm()+"' ");
		}
		if (!params.getStn().equals("")) {
			sql.append(" AND (STNFR = '"+params.getStn()+"' OR STNTO = '"+params.getStn()+"') ");
		}
		if (!params.getFlt_id().equals("")) {
			sql.append(" AND FLT_NUM = '"+params.getFlt_id()+"' ");
		}
		sql.append(" AND ADHOC = 'Y' ");
		sql.append(" AND SUBSTR(FLT_NUM,1,1) <> '4' ");
		sql.append(" ORDER BY SCH_DEP_DT ");
		
		System.out.println("[BASE:StaQ420Query:selMain] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * ASM Status(IRR) sub ȸ SQLԼ.
	  * @param params StaQ420BG
	  * @return String Query 
	  * @author Copyright (c) 2010/01/20 
	  */
	public String selSub(String firstLegFltDt, String fltNum, String stnfr, String stnto){
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT TO_CHAR(FIRST_LEG_FLT_DT,'YYYYMMDD') FIRST_LEG_FLT_DT, ");
		sql.append(" TO_CHAR(SCH_DEP_DT,'HH24:MI') STD, ");
		sql.append(" TO_CHAR(SCH_ARV_DT,'HH24:MI') STA, ");
		sql.append(" FLT_NUM, STNFR, STNTO, KACTYP ");
		sql.append(" FROM DAILY_SCH_LOG_T ");
		sql.append(" WHERE ARLN_CD = 'KE' ");
		sql.append(" AND FIRST_LEG_FLT_DT = TO_DATE('"+firstLegFltDt+"','YYYYMMDD') ");
		sql.append(" AND FLT_NUM = '"+fltNum+"' ");
		sql.append(" AND STNFR = '"+stnfr+"' ");
		sql.append(" AND STNTO = '"+stnto+"' ");
		sql.append(" AND ACTIVE = 'N' ");
		sql.append(" ORDER BY TIMESTAMP DESC ");
		
		System.out.println("[BASE:StaQ420Query:selSub] sql : "+sql.toString());
		return sql.toString();
	}
}
