package kal.base.sta.query;

import kal.base.jdf.com.Logger;
import kal.base.sta.dbbean.StaQ430BG;
import kal.base.com.query.ComQ01Query;

 /**
   * Delay Status(IRR) SQL 
   * @author Copyright (c) 2010/01/21 
   */  
public class StaQ430Query {
	private static StaQ430Query instance = new StaQ430Query();
	
	public static StaQ430Query getInstance() {
		return instance;
	}
	
	/** 
	  * Delay Status(IRR) main ȸ SQLԼ.
	  * @param params StaQ430BG
	  * @return String Query 
	  * @author Copyright (c) 2010/01/21 
	  */
	public String selMain(StaQ430BG params){
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT FLT_NUM, KACTYP, REGNO, STNFR, STNTO, ");
		if (params.getTm().equals("UTC")) {
			sql.append(" TO_CHAR(SCH_DEP_DT,'YYYY-MM-DD') SCH_DT, ");
			sql.append(" TO_CHAR(SCH_DEP_DT,'HH24:MI') STD, TO_CHAR(SCH_ARV_DT,'HH24:MI') STA, ");
			sql.append(" TO_CHAR(ACT_DEP_DT,'HH24:MI') ATD, TO_CHAR(ACT_ARV_DT,'HH24:MI') ATA, ");
		} else { //LOC
			sql.append(" TO_CHAR(SCH_DEP_DT_LOC,'YYYY-MM-DD') SCH_DT, ");
			sql.append(" TO_CHAR(SCH_DEP_DT_LOC,'HH24:MI') STD, TO_CHAR(SCH_ARV_DT_LOC,'HH24:MI') STA, ");
			sql.append(" TO_CHAR(ACT_DEP_DT_LOC,'HH24:MI') ATD, TO_CHAR(ACT_ARV_DT_LOC,'HH24:MI') ATA, ");
		}
		sql.append(" TO_CHAR(ACT_DEP_DT,'YYYYMMDDHH24MI') ATD_DT, ");
		sql.append(" TO_CHAR(ACT_DEP_DT + 1,'YYYYMMDD') ATD_NEXT, ");
		sql.append(" TKOF_T, LAND_T, DEP_GMT_OFFSET, ARV_GMT_OFFSET, DEP_STS, ARV_STS, ");
		sql.append(" DEL_RC1, DEL_DUR1, DEL_RC2, DEL_DUR2, DEL_RC3, DEL_DUR3, DEL_RC4, DEL_DUR4 ");
		sql.append(" FROM DAILY_SCH_T ");
		sql.append(" WHERE ARLN_CD = 'KE' ");
		
		if (params.getTm().equals("UTC")) {
			sql.append(" AND SCH_DEP_DT >= TO_DATE('20"+params.getStart_dt()+" 0000','YYYYMMDD HH24MI') ");
			sql.append(" AND SCH_DEP_DT <= TO_DATE('20"+params.getEnd_dt()+" 2359','YYYYMMDD HH24MI') ");
		} else { //LOC
			sql.append(" AND SCH_DEP_DT_LOC >= TO_DATE('20"+params.getStart_dt()+" 0000','YYYYMMDD HH24MI') ");
			sql.append(" AND SCH_DEP_DT_LOC <= TO_DATE('20"+params.getEnd_dt()+" 2359','YYYYMMDD HH24MI') ");
		}
		sql.append(" AND DEP_STS <> 'INI' ");
		sql.append(" AND ACTNID <> 'CNL' ");
		
		if (!params.getFlt_id().equals("")) {
			sql.append(" AND FLT_NUM = '"+params.getFlt_id()+"' ");
		}
		if (!params.getApt_fr().equals("")) {
			sql.append(" AND STNFR = '"+params.getApt_fr()+"' ");
		}
		if (!params.getApt_to().equals("")) {
			sql.append(" AND STNTO = '"+params.getApt_to()+"' ");
		}
		if (params.getDla_fr().equals("")) { //ð  ⺻ 3
			sql.append(" AND (ACT_DEP_DT - SCH_DEP_DT)*1440 >= 3 ");
		} else {
			sql.append(" AND (ACT_DEP_DT - SCH_DEP_DT)*1440 >= "+params.getDla_fr()+" ");
		}
		if (params.getDla_to().equals("")) { //ð  ⺻ 3000
			sql.append(" AND (ACT_DEP_DT - SCH_DEP_DT)*1440 <= 3000 ");
		} else {
			sql.append(" AND (ACT_DEP_DT - SCH_DEP_DT)*1440 <= "+params.getDla_to()+" ");
		}
		sql.append(" AND SUBSTR(FLT_NUM,1,1) <> '4' ");
		
		if (params.getSort().equals("FLT")) {
			sql.append(" ORDER BY FLT_NUM, SCH_DEP_DT ");
			
		} else if (params.getSort().equals("TYP")) {
			sql.append(" ORDER BY KACTYP, REGNO, SCH_DEP_DT ");
			
		} else if (params.getSort().equals("DEP")) {
			sql.append(" ORDER BY STNFR, SCH_DEP_DT ");
			
		} else if (params.getSort().equals("ARR")) {
			sql.append(" ORDER BY STNTO, SCH_ARV_DT ");
			
		} else if (params.getSort().equals("STD")) {
			sql.append(" ORDER BY SCH_DEP_DT, FLT_NUM ");
		}
		
		System.out.println("[BASE:StaQ430Query:selMain] sql : "+sql.toString());
		return sql.toString();
	}
}
