package kal.base.sta.query;

import kal.base.jdf.com.Logger;
import kal.base.sta.dbbean.StaQ610BG;
import kal.base.com.query.ComQ01Query;

 /**
   * Operation Status(A/C REG) SQL 
   * @author Copyright (c) 2010/01/19 
   */  
public class StaQ610Query {
	private static StaQ610Query instance = new StaQ610Query();
	
	public static StaQ610Query getInstance() {
		return instance;
	}
	
	/** 
	  * Operation Status(A/C REG) main ȸ SQLԼ.
	  * @param params StaQ610BG
	  * @return String Query 
	  * @author Copyright (c) 2010/01/19 
	  */
	public String selMain(StaQ610BG params, String reg){
		StringBuffer sql = new StringBuffer();
				
		sql.append(" SELECT REGNO, FLT_NUM, LEG_NUM, STNFR, STNTO, ");
		
		if (params.getTm().equals("UTC")) {
			sql.append(" TO_CHAR(SCH_DEP_DT,'YYMMDD') SCH_DT, ");
			sql.append(" TO_CHAR(SCH_DEP_DT,'HH24:MI') STD, ");
			sql.append(" TO_CHAR(SCH_ARV_DT,'HH24:MI') STA, ");
			sql.append(" TO_CHAR(ACT_DEP_DT,'HH24:MI') ATD, ");
			sql.append(" TO_CHAR(ACT_ARV_DT,'HH24:MI') ATA, ");
			
		} else { //LOC
			sql.append(" TO_CHAR(SCH_DEP_DT_LOC,'YYMMDD') SCH_DT, ");
			sql.append(" TO_CHAR(SCH_DEP_DT_LOC,'HH24:MI') STD, ");
			sql.append(" TO_CHAR(SCH_ARV_DT_LOC,'HH24:MI') STA, ");
			sql.append(" TO_CHAR(ACT_DEP_DT_LOC,'HH24:MI') ATD, ");
			sql.append(" TO_CHAR(ACT_ARV_DT_LOC,'HH24:MI') ATA, ");
		}
		sql.append(" TKOF_T, LAND_T, DEP_GMT_OFFSET, ARV_GMT_OFFSET, ");
		sql.append(" TO_CHAR(ACT_DEP_DT,'YYYYMMDDHH24MI') ATD_DT, ");
		sql.append(" TO_CHAR(ACT_DEP_DT + 1,'YYYYMMDD') ATD_NEXT, ");
		sql.append(" TO_CHAR(ACT_ARV_DT,'YYYYMMDDHH24MI') ATA_DT, ");
		sql.append(" TO_CHAR(ACT_ARV_DT - 1,'YYYYMMDD') ATA_PREV, ");
		sql.append(" TRUNC((ACT_ARV_DT - ACT_DEP_DT)*1440, 0) BLHR, ");
		sql.append(" TRUNC((ACT_DEP_DT - SCH_DEP_DT)*1440, 0) DEP_T, ");
		sql.append(" TRUNC((ACT_ARV_DT - SCH_ARV_DT)*1440, 0) ARR_T, ");
		sql.append(" DEL_RC1, DEL_DUR1, DEL_RC2, DEL_DUR2, ");
		sql.append(" DEP_STS, ARV_STS ");
		sql.append(" FROM DAILY_SCH_T ");
		sql.append(" WHERE ARLN_CD = 'KE' ");
		
		if (params.getTm().equals("UTC")) {
			sql.append(" AND SCH_DEP_DT >= TO_DATE('20"+params.getStart_dt()+" 0000','YYYYMMDD HH24MI') ");
			sql.append(" AND SCH_DEP_DT <= TO_DATE('20"+params.getEnd_dt()+" 2359','YYYYMMDD HH24MI') ");
			
		} else { //LOC
			sql.append(" AND SCH_DEP_DT_LOC >= TO_DATE('20"+params.getStart_dt()+" 0000','YYYYMMDD HH24MI') ");
			sql.append(" AND SCH_DEP_DT_LOC <= TO_DATE('20"+params.getEnd_dt()+" 2359','YYYYMMDD HH24MI') ");
		}
		
		if (!reg.equals("")) {
			sql.append(" AND REGNO IN ("+reg+") ");
		}
		sql.append(" AND ACTNID <> 'CNL' ");
		sql.append(" AND ACTNID <> 'RTR' ");
		sql.append(" AND DEP_STS <> 'INI' ");
		sql.append(" AND SUBSTR(FLT_NUM,1,1) <> '4' ");
		
		if (params.getTm().equals("UTC")) {
			sql.append(" ORDER BY TO_CHAR(SCH_DEP_DT,'YYYYMMDD'), REGNO, SCH_DEP_DT ");
		
		} else { //LOC
			sql.append(" ORDER BY TO_CHAR(SCH_DEP_DT_LOC,'YYYYMMDD'), REGNO, SCH_DEP_DT ");
		}
		
		System.out.println("[BASE:StaQ610Query:selMain] sql : "+sql.toString());
		return sql.toString();
	}
}
