package kal.base.sup.query;

import kal.base.jdf.com.Logger;
import kal.base.com.util.*;
import kal.base.sup.dbbean.*;

 /**
   * NOTAM Knowledge Base  SQL 
   * @author Copyright (c) 2005/07/28 
   */
public class SupA140Query {
	private static SupA140Query instance = new SupA140Query();
	
	public static SupA140Query getInstance() {
		return instance;
	}
	
	/** 
	  * Airport ȸ SQLԼ.
	  * @return String Query 
	  * @author Copyright (c) 2005/07/28 
	  */
	public String selPORT(SupA140BG params){
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT ICAO_PORT ");
		sql.append(" FROM CM_PORT_T ");
		sql.append(" WHERE ICAO_PORT='" + params.getAirport() + "' OR IATA_PORT='" + params.getAirport() + "' ");
		
		Logger.debug.println("[BASE:SupA140Query:selPORT] sql : "+sql.toString());
		return sql.toString();
	}

	/** 
	  * FIR ȸ SQLԼ.
	  * @return String Query 
	  * @author Copyright (c) 2005/07/28 
	  */
	public String selFIR(SupA140BG params){
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT FIR_CD ");
		sql.append(" FROM BS_FIR_T ");
		sql.append(" WHERE FIR_CD='" + params.getAirport() +  "' ");
		
		Logger.debug.println("[BASE:SupA140Query:selFIR] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * Company Route List ȸ SQLԼ. -- 
	  * @return String Query 
	  * @author Copyright (c) 2005/07/28 
	  */
	/*public String selROUTEList(SupA140BG params){
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT DEP_STN||'-'||ARR_STN||'-'||RTE_CD ROUTE ");
		sql.append(" FROM BS_COMP_ROUTE_T ");
		sql.append(" WHERE RTE_STN LIKE '%" + params.getIcao_port() +"%' ");
		sql.append(" ORDER BY DEP_STN,ARR_STN,RTE_CD ");

		Logger.debug.println("[BASE:SupA140Query:selROUTEList] sql : "+sql.toString());
		return sql.toString();
	}*/
	
	/** 
	  * New Company Route List ȸ SQLԼ.
	  * @return String Query 
	  * @author Copyright (c) 2009/12/24 
	  */
	public String selCompRoute(SupA140BG params, String mode){
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT DEP_STN||'-'||ARR_STN||'-'||RTE_CD ROUTE ");
		sql.append(" FROM BS_COMP_ROUTE_T ");
		
		//20160308 
		/*
		if (mode.equals("1")) {
			sql.append(" WHERE ETOPS_STN LIKE '%"+params.getIcao_port()+"%' ");
			sql.append(" OR ENRTE_STN LIKE '%"+params.getIcao_port()+"%' ");
			sql.append(" OR REFILE_STN LIKE '%"+params.getIcao_port()+"%' ");
			sql.append(" OR OTHERS_STN LIKE '%"+params.getIcao_port()+"%' ");
		
		} else if (mode.equals("2")) {
			sql.append(" WHERE RTE_FIR LIKE '%"+params.getIcao_port()+"%' ");
		}
		*/
		sql.append(" WHERE ETOPS_STN LIKE '%"+params.getIcao_port()+"%' ");
		sql.append(" OR ENRTE_STN LIKE '%"+params.getIcao_port()+"%' ");
		sql.append(" OR REFILE_STN LIKE '%"+params.getIcao_port()+"%' ");
		sql.append(" OR OTHERS_STN LIKE '%"+params.getIcao_port()+"%' ");
		sql.append(" OR RTE_FIR LIKE '%"+params.getIcao_port()+"%' ");
		
		
		sql.append(" ORDER BY DEP_STN,ARR_STN,RTE_CD ");

		System.out.println("[BASE:SupA140Query:selCompRoute] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * NOTAM Knowledge ȸ SQLԼ.
	  * @return String Query 
	  * @author Copyright (c) 2005/07/28 
	  */
	public String selNOTAMKnowledge(SupA140BG params){
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT HIST_INFO ");
		sql.append(" FROM BS_NOTAM_HISTORY_T ");
		sql.append(" WHERE ICAO_PORT = '"+params.getIcao_port() + "'");

		Logger.debug.println("[BASE:SupA140Query:selNOTAMKnowledge] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * NOTAM Knowledge  Է SQLԼ.
	  * @return String Query 
	  * @author Copyright (c) 2005/07/28 
	  */
	public String insNOTAMKnowledge(SupA140BG params){
		StringBuffer sql = new StringBuffer();

		sql.append(" INSERT INTO BS_NOTAM_HISTORY_T");
		sql.append(" (ICAO_PORT,HIST_INFO,TIMESTMP,USERID)");
		sql.append(" VALUES('"+params.getIcao_port()+"','"+params.getKnowledge()+"',SYSDATE,'"+params.getUserid()+"')" );

		Logger.debug.println("[BASE:SupA140Query:insNOTAMKnowledge] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * NOTAM Knowledge  SQLԼ.
	  * @return String Query 
	  * @author Copyright (c) 2005/07/28 
	  */
	public String updNOTAMKnowledge(SupA140BG params){
		StringBuffer sql = new StringBuffer();

		sql.append(" UPDATE BS_NOTAM_HISTORY_T");
		sql.append(" SET HIST_INFO = '"+params.getKnowledge()+"',");
		sql.append("     	TIMESTMP = SYSDATE,");
		sql.append("     	USERID = '"+params.getUserid()+"'" );
		sql.append(" WHERE ICAO_PORT = '"+params.getIcao_port() +"'");

		Logger.debug.println("[BASE:SupA140Query:updNOTAMKnowledge] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * NOTAM Knowledge  SQLԼ.
	  * @return String Query 
	  * @author Copyright (c) 2005/07/28 
	  */
	public String delNOTAMKnowledge(SupA140BG params){
		StringBuffer sql = new StringBuffer();

		sql.append(" DELETE BS_NOTAM_HISTORY_T");
		sql.append(" WHERE ICAO_PORT = '"+params.getIcao_port()+"'");

		Logger.debug.println("[BASE:SupA140Query:delNOTAMKnowledge] sql : "+sql.toString());
		return sql.toString();
	}	
	
}