package kal.base.sup.query;

import kal.base.jdf.com.Logger;
import kal.base.sup.dbbean.SupA310BG;
import kal.base.com.query.ComQ01Query;

 /**
   * WEATHER LIST SQL 
   * @author Copyright (c) 2005/06/21 
   */
public class SupA310Query {
	private static SupA310Query instance = new SupA310Query();
	
	public static SupA310Query getInstance() {
		return instance;
	}
	
	/** 
	  * WEATHER LIST main ȸ SQLԼ.
	  * @param entity SupA310BG WEATHER LIST
	  * @return String Query 
	  * @author Copyright (c) 2005/06/21 
	  */
	public String selMain(SupA310BG entity){
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT ICAO_PORT, TO_CHAR(WX_DTG,'yymmdd hh24mi') WX_DTG, WX_TYP, WX_TEXT ");
		sql.append(" FROM BS_WEATHER_T ");
		sql.append(" WHERE ICAO_PORT = '"+ entity.getIcao_port() +"' AND ");
		sql.append(" 		   WX_TYP IN ("+ entity.getWx_typ() +") AND ");
		sql.append(" 		   WX_DTG BETWEEN TO_DATE('"+ entity.getWx_dtg() +"','yymmddhh24mi') + ("+ entity.getTimestep() +"/24) ");
		sql.append(" 		   AND TO_DATE('"+ entity.getWx_dtg() +"','yymmddhh24mi')");
		sql.append(" ORDER BY WX_DTG DESC ");
		
		Logger.debug.println("[BASE:SupA310Query:selMain] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * WEATHER LIST Airport ȸ SQLԼ.
	  * @param entity SupA310BG WEATHER LIST
	  * @return String Query 
	  * @author Copyright (c) 2005/06/21 
	  */
	public String selAirport(SupA310BG entity){
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT ICAO_PORT, IATA_PORT ");
		sql.append(" FROM CM_PORT_T ");
		sql.append(" WHERE ");
		if(entity.getIcao_port().length() == 3){
			// IATA
			sql.append(" 	IATA_PORT = '"+ entity.getIcao_port() +"' ");
		}else{
			// ICAO
			sql.append(" 	ICAO_PORT = '"+ entity.getIcao_port() +"' ");
		}
		
		Logger.debug.println("[BASE:SupA310Query:selAirport] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * WEATHER LIST  SQLԼ.
	  * @param entity SupA310BG WEATHER LIST
	  * @return String Query 
	  * @author Copyright (c) 2005/06/21 
	  */
	public String delMain(SupA310BG entity){
		StringBuffer sql = new StringBuffer();

		sql.append(" DELETE FROM BS_WEATHER_T ");
		sql.append(" WHERE ICAO_PORT = '"+ entity.getIcao_port() +"' AND ");
		sql.append(" 		   TYP_SEQ >= 1 AND  ");
		sql.append(" 		   WX_TYP = '"+ entity.getWx_typ() +"' AND ");
		sql.append(" 		   WX_DTG = TO_DATE('"+ entity.getWx_dtg() +"','yymmdd hh24mi') ");
		
		Logger.debug.println("[BASE:SupA310Query:delMain] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * WEATHER LIST 翩 ȸ SQLԼ.
	  * @param entity SupA310BG WEATHER LIST
	  * @return String Query 
	  * @author Copyright (c) 2005/07/14 
	  */
	public String selExist(SupA310BG entity){
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT * ");
		sql.append(" FROM BS_WEATHER_T ");
		sql.append(" WHERE ICAO_PORT = '"+ entity.getIcao_port() +"' AND ");
		sql.append(" 		   WX_TYP = '"+ entity.getWx_typ() +"' AND ");
		sql.append(" 		   WX_DTG = TO_DATE('"+ entity.getWx_dtg() +"','yymmddhh24mi') ");
		
		Logger.debug.println("[BASE:SupA310Query:selExist] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * WEATHER LIST Է SQLԼ.
	  * @param entity SupA310BG WEATHER LIST
	  * @return String Query 
	  * @author Copyright (c) 2005/07/14 
	  */
	public String insMain(SupA310BG entity){
		StringBuffer sql = new StringBuffer();

		//sql.append(" INSERT INTO BS_WEATHER_T ");
		sql.append(" INSERT INTO BS_WEATHER_T ( ICAO_PORT, IATA_PORT, TYP_SEQ, WX_TYP, ");
		sql.append(" WX_DTG, ACT_WDIR, ACT_WIND, CRS_WIND, TAIL_WIND, RWY_VIS, RVR_VIS, CIG, QNH, WX_COND1, WX_COND2, ");
		sql.append(" WX_TEXT, COMMNT, COR_Y, TIMESTMP, USERID ) ");
		sql.append(" VALUES ('"+ entity.getIcao_port() +"', '"+ entity.getIata_port() +"', "+ entity.getTyp_seq() +", '"+ entity.getWx_typ() +"', ");
		sql.append(" 	TO_DATE('"+ entity.getWx_dtg() +"','yymmddhh24mi'), 0, 0, 0, 0, 0, 0, 0, 0, '', '', ");
		sql.append(" 	'"+ entity.getWx_text() +"', '', 'Y', SYSDATE, '"+ entity.getEmp_no() +"')");
		
		//Logger.debug.println("[BASE:SupA310Query:insMain] sql : "+sql.toString());
		System.out.println("[BASE:SupA310Query:insMain] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * WEATHER LIST  SQLԼ.
	  * @param entity SupA310BG WEATHER LIST
	  * @return String Query 
	  * @author Copyright (c) 2005/07/14 
	  */
	public String updMain(SupA310BG entity){
		StringBuffer sql = new StringBuffer();

		sql.append(" UPDATE BS_WEATHER_T ");
		sql.append(" SET WX_TEXT = '"+ entity.getWx_text() +"', ");
		sql.append(" 	  COR_Y = 'Y', ");
		sql.append(" 	  TIMESTMP = SYSDATE, ");
		sql.append(" 	  USERID = '"+ entity.getEmp_no() +"' ");
		sql.append(" WHERE ICAO_PORT = '"+ entity.getIcao_port() +"' AND ");
		sql.append(" 		   WX_TYP = '"+ entity.getWx_typ() +"' AND ");
		sql.append(" 		   WX_DTG = TO_DATE('"+ entity.getWx_dtg() +"','yymmddhh24mi') ");
		
		Logger.debug.println("[BASE:SupA310Query:updMain] sql : "+sql.toString());
		return sql.toString();
	}
}
