package kal.base.sup.query;

import kal.base.jdf.com.Logger;
import kal.base.sup.dbbean.SupA330BG;
import kal.base.com.query.ComQ01Query;

 /**
   * SIG WEATHER LIST SQL 
   * @author Copyright (c) 2005/06/30 
   */
public class SupA330Query {
	private static SupA330Query instance = new SupA330Query();
	
	public static SupA330Query getInstance() {
		return instance;
	}
	
	/** 
	  * SIG WEATHER LIST AREA_CD ȸ SQLԼ.	
	  * @param entity SupA330BG SIG WEATHER LIST
	  * @return String Query 
	  * @author Copyright (c) 2005/07/04 
	  */
	public String selAreaCd(SupA330BG entity){
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT AREA_CD ");
		sql.append(" FROM BS_AREA_T ");
		sql.append(" ORDER BY AREA_CD ");

		Logger.debug.println("[BASE:SupA330Query:selAreaCd] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * SIG WEATHER LIST WX CONDITION ȸ SQLԼ.	
	  * @param entity SupA330BG SIG WEATHER LIST
	  * @return String Query 
	  * @author Copyright (c) 2005/07/04 
	  */
	public String selWxCond(SupA330BG entity){
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT CODE_C ");
		sql.append(" FROM CODE_T ");
		sql.append(" WHERE STEP_X = '9' AND ");
		sql.append(" 	CODE_X = 'WXR STS' AND ");
		sql.append(" 	USE_Y = 'S' ");
		sql.append(" ORDER BY PRTY_NO ");
		
		Logger.debug.println("[BASE:SupA330Query:selWxCond] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * SIG WEATHER LIST Airport ȸ SQLԼ.
	  * @param entity SupA330BG SIG WEATHER LIST
	  * @return String Query 
	  * @author Copyright (c) 2005/07/04 
	  */
	public String selAirport(SupA330BG entity){
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT ICAO_PORT ");
		sql.append(" FROM CM_PORT_T ");
		sql.append(" WHERE ");
		if(entity.getIcao_port().length() == 3){
			// IATA
			sql.append(" 	IATA_PORT = '"+ entity.getIcao_port() +"' ");
		}else{
			// ICAO
			sql.append(" 	ICAO_PORT = '"+ entity.getIcao_port() +"' ");
		}
		
		Logger.debug.println("[BASE:SupA330Query:selAirport] sql : "+sql.toString());
		return sql.toString();
	}
		
	/** 
	  * SIG WEATHER LIST AREA_STN ȸ SQLԼ.	
	  * @param entity SupA330BG SIG WEATHER LIST
	  * @return String Query 
	  * @author Copyright (c) 2005/07/04 
	  */
	public String selAreaStn(SupA330BG entity){
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT AREA_STN ");
		sql.append(" FROM BS_AREA_T ");
		sql.append(" WHERE AREA_CD = '"+ entity.getArea_cd() +"' ");

		Logger.debug.println("[BASE:SupA330Query:selAreaStn] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * SIG WEATHER LIST main ȸ SQLԼ.	
	  * @param entity SupA330BG SIG WEATHER LIST
	  * @return String Query 
	  * @author Copyright (c) 2005/07/04 
	  */
	public String selMain(SupA330BG entity){
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT ICAO_PORT, WX_TYP, TO_CHAR(BEGIN_DT,'yymmdd hh24mi') BEGIN_DT, TO_CHAR(END_DT,'yymmdd hh24mi') END_DT, DUR_TM, WX_COND1, WX_COND2, WX_TEXT ");
		sql.append(" FROM BS_SIG_WEATHER_T ");
		sql.append(" WHERE ");
		 
		if(entity.getRadio_bu().equals("rb1")){
			//AIRPORT Է½
			sql.append(" 	ICAO_PORT = '"+ entity.getIcao_port() +"' AND ");
		}else{
			//AREA Է½
			sql.append(" 	ICAO_PORT IN ("+ entity.getArea_stn() +") AND ");
		}
		sql.append(" 	WX_TYP IN ('A', "+ entity.getType() +") AND ");
		sql.append(" 	((BEGIN_DT BETWEEN TO_DATE('"+ entity.getBegin_dt() +"','yymmddhh24mi') AND TO_DATE('"+ entity.getEnd_dt() +"','yymmddhh24mi')) OR ");
		sql.append(" 	(BEGIN_DT < TO_DATE('"+ entity.getBegin_dt() +"','yymmddhh24mi') AND END_DT >= TO_DATE('"+ entity.getEnd_dt() +"','yymmddhh24mi'))) ");
		if(!entity.getWx_cond().equals("")){
			sql.append(" 	AND ((WX_COND1 IN ("+ entity.getWx_cond() +")) OR (WX_COND2 IN ("+ entity.getWx_cond() +"))) ");
		}
		sql.append(" ORDER BY ICAO_PORT, BEGIN_DT DESC ");

		Logger.debug.println("[BASE:SupA330Query:selMain] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * SIG WEATHER LIST  SQLԼ.	
	  * @param entity SupA330BG SIG WEATHER LIST
	  * @return String Query 
	  * @author Copyright (c) 2005/07/06 
	  */
	public String delMain(SupA330BG entity){
		StringBuffer sql = new StringBuffer();

		sql.append(" DELETE FROM BS_SIG_WEATHER_T ");
		sql.append(" WHERE ICAO_PORT = '"+ entity.getIcao_port() +"' AND ");
		sql.append(" 	WX_TYP = '"+ entity.getType() +"' AND ");
		sql.append(" 	BEGIN_DT = TO_DATE('"+ entity.getBegin_dt() +"','yymmdd hh24mi') ");

		Logger.debug.println("[BASE:SupA330Query:delMain] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * SIG WEATHER LIST ȸ SQLԼ.	
	  * @param entity SupA330BG SIG WEATHER LIST
	  * @return String Query 
	  * @author Copyright (c) 2005/07/11 
	  */
	public String selExist(SupA330BG entity){
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT * ");
		sql.append(" FROM BS_SIG_WEATHER_T ");
		sql.append(" WHERE ICAO_PORT = '"+ entity.getIcao_port() +"' AND ");
		sql.append(" 	WX_TYP = '"+ entity.getType() +"' AND ");
		sql.append(" 	BEGIN_DT = TO_DATE('"+ entity.getBegin_dt() +"','yymmddhh24mi') ");

		Logger.debug.println("[BASE:SupA330Query:selExist] sql : "+sql.toString());
		return sql.toString();
	}
	
		/** 
	  * SIG WEATHER LIST Է SQLԼ.	
	  * @param entity SupA330BG SIG WEATHER LIST
	  * @return String Query 
	  * @author Copyright (c) 2005/07/11 
	  */
	public String insMain(SupA330BG entity){
		StringBuffer sql = new StringBuffer();

		sql.append(" INSERT INTO BS_SIG_WEATHER_T ");
		sql.append(" VALUES ('"+ entity.getIcao_port() +"', '"+ entity.getType() +"', TO_DATE('"+ entity.getBegin_dt() +"','yymmddhh24mi'), ");
		sql.append(" 			 TO_DATE('"+ entity.getEnd_dt() +"','yymmddhh24mi'), '"+ entity.getDuration() +"', '"+ entity.getWx_cond1() +"', ");
		sql.append(" 			 '"+ entity.getWx_cond2() +"', '"+ entity.getWx_text() +"', SYSDATE, '"+ entity.getEmp_no() +"') ");

		Logger.debug.println("[BASE:SupA330Query:insMain] sql : "+sql.toString());
		return sql.toString();
	}
	
		/** 
	  * SIG WEATHER LIST  SQLԼ.	
	  * @param entity SupA330BG SIG WEATHER LIST
	  * @return String Query 
	  * @author Copyright (c) 2005/07/11 
	  */
	public String updMain(SupA330BG entity){
		StringBuffer sql = new StringBuffer();

		sql.append(" UPDATE BS_SIG_WEATHER_T ");
		sql.append(" SET END_DT = TO_DATE('"+ entity.getEnd_dt() +"','yymmddhh24mi'), ");
		sql.append(" 	  DUR_TM = '"+ entity.getDuration() +"', ");
		sql.append(" 	  WX_COND1 = '"+ entity.getWx_cond1() +"', ");
		sql.append(" 	  WX_COND2 = '"+ entity.getWx_cond2() +"', ");
		sql.append(" 	  WX_TEXT = '"+ entity.getWx_text() +"', ");
		sql.append(" 	  TIMESTMP = SYSDATE, ");
		sql.append(" 	  USERID = '"+ entity.getEmp_no() +"' ");
		sql.append(" WHERE ICAO_PORT = '"+ entity.getIcao_port() +"' AND ");
		sql.append(" 	WX_TYP = '"+ entity.getType() +"' AND ");
		sql.append(" 	BEGIN_DT = TO_DATE('"+ entity.getBegin_dt() +"','yymmddhh24mi') ");

		Logger.debug.println("[BASE:SupA330Query:updMain] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * SIG WEATHER LIST  ȸ SQLԼ.	
	  * @param entity SupA330BG SIG WEATHER LIST
	  * @return String Query 
	  * @author Copyright (c) 2005/07/11 
	  */
	public String selChart(SupA330BG entity){
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT * ");
		sql.append(" FROM BS_SIG_CHART_T ");
		sql.append(" WHERE ICAO_PORT = '"+ entity.getIcao_port() +"' AND ");
		sql.append(" 	WX_TYP = '"+ entity.getType() +"' AND ");
		sql.append(" 	BEGIN_DT = TO_DATE('"+ entity.getBegin_dt() +"','yymmddhh24mi') ");
		sql.append(" ORDER BY CHART_SEQ ");

		Logger.debug.println("[BASE:SupA330Query:selChart] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * SIG WEATHER LIST  SEQ ȸ SQLԼ.	
	  * @param entity SupA330BG SIG WEATHER LIST
	  * @return String Query 
	  * @author Copyright (c) 2005/07/11 
	  */
	public String selMaxSeq(SupA330BG entity){
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT NVL(MAX(CHART_SEQ) ,0) MAX_SEQ ");
		sql.append(" FROM BS_SIG_CHART_T ");
		sql.append(" WHERE ICAO_PORT = '"+ entity.getIcao_port() +"' AND ");
		sql.append(" 	WX_TYP = '"+ entity.getType() +"' AND ");
		sql.append(" 	BEGIN_DT = TO_DATE('"+ entity.getBegin_dt() +"','yymmddhh24mi') ");

		Logger.debug.println("[BASE:SupA330Query:selMaxSeq] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * SIG WEATHER LIST  Է SQLԼ.	
	  * @param entity SupA330BG SIG WEATHER LIST
	  * @return String Query 
	  * @author Copyright (c) 2005/07/11 
	  */
	public String insChart(SupA330BG entity){
		StringBuffer sql = new StringBuffer();

		sql.append(" INSERT INTO BS_SIG_CHART_T ");
		sql.append(" VALUES ('"+ entity.getIcao_port() +"', '"+ entity.getType() +"', TO_DATE('"+ entity.getBegin_dt() +"','yymmddhh24mi'), ");
		sql.append(" 			 '"+ entity.getChart_seq() +"', '"+ entity.getChart_file() +"', SYSDATE, '"+ entity.getEmp_no() +"') ");

		Logger.debug.println("[BASE:SupA330Query:insChart] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * SIG WEATHER LIST   SQLԼ.	
	  * @param entity SupA330BG SIG WEATHER LIST
	  * @return String Query 
	  * @author Copyright (c) 2005/07/11 
	  */
	public String delChartSeq(SupA330BG entity){
		StringBuffer sql = new StringBuffer();

		sql.append(" DELETE FROM BS_SIG_CHART_T ");
		sql.append(" WHERE ICAO_PORT = '"+ entity.getIcao_port() +"' AND ");
		sql.append(" 	WX_TYP = '"+ entity.getType() +"' AND ");
		sql.append(" 	BEGIN_DT = TO_DATE('"+ entity.getBegin_dt() +"','yymmddhh24mi') AND ");
		sql.append(" 	CHART_SEQ = '"+ entity.getChart_seq() +"' ");

		Logger.debug.println("[BASE:SupA330Query:delChartSeq] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * SIG WEATHER LIST   SQLԼ.	
	  * @param entity SupA330BG SIG WEATHER LIST
	  * @return String Query 
	  * @author Copyright (c) 2005/07/12 
	  */
	public String delChart(SupA330BG entity){
		StringBuffer sql = new StringBuffer();

		sql.append(" DELETE FROM BS_SIG_CHART_T ");
		sql.append(" WHERE ICAO_PORT = '"+ entity.getIcao_port() +"' AND ");
		sql.append(" 	WX_TYP = '"+ entity.getType() +"' AND ");
		sql.append(" 	BEGIN_DT = TO_DATE('"+ entity.getBegin_dt() +"','yymmddhh24mi') ");

		Logger.debug.println("[BASE:SupA330Query:delChart] sql : "+sql.toString());
		return sql.toString();
	}
}
