package kal.base.sup.query;

import kal.base.jdf.com.Logger;
import kal.base.com.util.*;
import kal.base.sup.dbbean.SupA610BG;
import kal.base.com.query.ComQ01Query;

 /**
   * Airport Information SQL 
   * @author Copyright (c) 2005/05/31 
   */
public class SupA610Query {
	private static SupA610Query instance = new SupA610Query();
	
	public static SupA610Query getInstance() {
		return instance;
	}
	
	/** 
	  * Airport Information main ȸ SQLԼ.
	  * @param entity SupA610BG Airport Information
	  * @return String Query 
	  * @author Copyright (c) 2005/05/31 
	  */
	public String selMain(SupA610BG entity){
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT * ");
		sql.append(" FROM CM_PORT_T ");
		sql.append(" WHERE ");
		if(entity.getAirport().length() == 3){
			// IATA
			sql.append(" 	IATA_PORT = '"+ entity.getAirport() +"' ");
		}else{
			// ICAO
			sql.append(" 	ICAO_PORT = '"+ entity.getAirport() +"' ");
		}
		Logger.debug.println("[BASE:SupA610Query:selMain] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * ICAO ȸ SQLԼ.
	  * @param entity SupA610BG Airport Information
	  * @return String Query 
	  * @author Copyright (c) 2005/05/31 
	  */
	public String selIcao(SupA610BG entity){
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT ICAO_PORT ");
		sql.append(" FROM CM_PORT_T ");
		sql.append(" WHERE ICAO_PORT = '"+ entity.getIcao_port() +"' ");
		
		Logger.debug.println("[BASE:SupA610Query:selIcao] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * IATA ȸ SQLԼ.
	  * @param entity SupA610BG Airport Information
	  * @return String Query 
	  * @author Copyright (c) 2005/05/31 
	  */
	public String selIata(SupA610BG entity){
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT IATA_PORT ");
		sql.append(" FROM CM_PORT_T ");
		sql.append(" WHERE IATA_PORT = '"+ entity.getIata_port() +"' ");
		
		Logger.debug.println("[BASE:SupA610Query:selIata] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * ICAO, IATA ȸ SQLԼ.
	  * @param entity SupA610BG Airport Information
	  * @return String Query 
	  * @author Copyright (c) 2005/05/31 
	  */
	public String selIcaoIata(SupA610BG entity){
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT ICAO_PORT, IATA_PORT ");
		sql.append(" FROM CM_PORT_T ");
		sql.append(" WHERE ICAO_PORT = '"+ entity.getIcao_port() +"' AND IATA_PORT = '"+ entity.getIata_port() +"' ");
		
		Logger.debug.println("[BASE:SupA610Query:selIcaoIata] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * NATION_T ȸ SQLԼ.
	  * @param entity SupA610BG Airport Information
	  * @return String Query 
	  * @author Copyright (c) 2005/05/31 
	  */
	public String selNationC(SupA610BG entity){
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT NATION_C ");
		sql.append(" FROM NATION_T ");
		sql.append(" WHERE NATION_C = '"+ entity.getNat_cd() +"' ");
		
		Logger.debug.println("[BASE:SupA610Query:selNationC] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * FIR_CD ȸ SQLԼ.
	  * @param entity SupA610BG Airport Information
	  * @return String Query 
	  * @author Copyright (c) 2005/05/31 
	  */
	public String selFirCd(SupA610BG entity){
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT FIR_CD ");
		sql.append(" FROM BS_FIR_T ");
		sql.append(" WHERE FIR_CD = '"+ entity.getFir_cd() +"' ");
		
		Logger.debug.println("[BASE:SupA610Query:selFirCd] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * Airport Information Է SQLԼ.
	  * @param entity SupA610BG Airport Information
	  * @return String Query 
	  * @author Copyright (c) 2005/05/31 
	  */
	public String insMain(SupA610BG entity){
		StringBuffer sql = new StringBuffer();
		
		//2006.02.22  -> CM_PORT_T ̺ .
		//2008.02.01  : ÷ .
		sql.append(" INSERT INTO CM_PORT_T( ");
		sql.append(" IATA_PORT, ICAO_PORT, CITY_CD, PORT_E, ");
		sql.append(" IS_STATION, PDC_WAY, SVC_ON, LATITUDE, LONGITUDE, "); 
		sql.append(" CHG_DATE, AREA_CD, REGION_CD, CTRY_CD, GMT_OFFSET, "); 
		sql.append(" DST_GRP_CD, ARMY_Y, REMARKS, REGION_X, DCS_ONLINE_Y, ");
		sql.append(" FIR_CD, CURFEW, ETOP_VIS_LIMIT, ETOP_CIG_LIMIT, ETOP_WIND_LIMIT, ");
		sql.append(" OP_COMPANY1, OP_CALLSIGN1, OP_FREQ1, OP_TEL1, OP_FAX1, ");   
		sql.append(" OP_1ST_SITA1, OP_2ND_SITA1, OP_EMAIL1, HTL_CRW_LOV1, HTL_TEL1, HTL_FAX1, ");
		sql.append(" OP_COMPANY2, OP_CALLSIGN2, OP_FREQ2, OP_TEL2, OP_FAX2, ");
		sql.append(" OP_1ST_SITA2, OP_2ND_SITA2, OP_EMAIL2, HTL_CRW_LOV2, HTL_TEL2, HTL_FAX2, ");
		sql.append(" COORD_X1, COORD_Y1, COORD_X2, COORD_Y2, NOT_ACTIVE, WX_ACTIVE, ");
		sql.append(" WX_ADDR, USERID, RWY_INFO ) "); //2010.02.10 ߰ : RWY_INFO
		sql.append(" VALUES ('"+ entity.getIata_port() +"','"+ entity.getIcao_port() +"','','"+ StringUtil.DBInsStr(entity.getPort_e()) +"' ");
		sql.append(" ,'N','N','N','','' ");
		sql.append(" ,SYSDATE,'','','"+ entity.getNat_cd() +"',0 ");
		sql.append(" ,' ','N','','9','' ");
		sql.append(" ,'"+ entity.getFir_cd() +"','"+ entity.getCurfew() +"','2400','600','30' ");
		sql.append(" ,'"+ entity.getOp_company1() +"','"+ entity.getOp_callsign1() +"','"+ entity.getOp_freq1() +"','"+ entity.getOp_tel1() +"','"+ entity.getOp_fax1() +"' ");
		sql.append(" ,'"+ entity.getOp_1st_sita1() +"','"+ entity.getOp_2nd_sita1() +"','"+ entity.getOp_email1() +"','"+ entity.getHtl_crw_lov1() +"','"+ entity.getHtl_tel1() +"','"+ entity.getHtl_fax1() +"' ");
		sql.append(" ,'"+ entity.getOp_company2() +"','"+ entity.getOp_callsign2() +"','"+ entity.getOp_freq2() +"','"+ entity.getOp_tel2() +"','"+ entity.getOp_fax2() +"' ");
		sql.append(" ,'"+ entity.getOp_1st_sita2() +"','"+ entity.getOp_2nd_sita2() +"','"+ entity.getOp_email2() +"','"+ entity.getHtl_crw_lov2() +"','"+ entity.getHtl_tel2() +"','"+ entity.getHtl_fax2() +"' ");
		sql.append(" ,'"+ entity.getCoord_x1() +"','"+ entity.getCoord_y1() +"','"+ entity.getCoord_x2() +"','"+ entity.getCoord_y2() +"','"+ entity.getNot_active() +"','"+ entity.getWx_active() +"' ");
		sql.append(" ,'','"+ entity.getEmp_no() +"', '"+entity.getRwy_info()+"') ");
		
		Logger.debug.println("[BASE:SupA610Query:insMain] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * Airport Information  SQLԼ.
	  * @param entity SupA610BG Airport Information
	  * @return String Query 
	  * @author Copyright (c) 2005/05/31 
	  */
	public String updMain(SupA610BG entity){
		StringBuffer sql = new StringBuffer();

		// 2006.02.22  -> CM_PORT_T ̺ .
		sql.append(" UPDATE CM_PORT_T ");
		sql.append(" SET  ");
		
		sql.append(" ICAO_PORT = '"+ entity.getIcao_port() +"', ");
		sql.append(" PORT_E = '"+ entity.getPort_e() +"', ");
		sql.append(" CTRY_CD = '"+ entity.getNat_cd() +"', "); //
		sql.append(" FIR_CD = '"+ entity.getFir_cd() +"', ");
		sql.append(" CURFEW = '"+ entity.getCurfew() +"', ");
		sql.append(" COORD_X1 = '"+ entity.getCoord_x1() +"', ");
		sql.append(" COORD_Y1 = '"+ entity.getCoord_y1() +"', ");
		sql.append(" COORD_X2 = '"+ entity.getCoord_x2() +"', ");
		sql.append(" COORD_Y2 = '"+ entity.getCoord_y2() +"', ");
		
		sql.append(" OP_COMPANY1 = '"+ entity.getOp_company1() +"', ");
		sql.append(" OP_CALLSIGN1 = '"+ entity.getOp_callsign1() +"', ");
		sql.append(" OP_FREQ1 = '"+ entity.getOp_freq1() +"', ");
		sql.append(" OP_TEL1 = '"+ entity.getOp_tel1() +"', ");
		sql.append(" OP_FAX1 = '"+ entity.getOp_fax1() +"', ");
		sql.append(" OP_1ST_SITA1 = '"+ entity.getOp_1st_sita1() +"', ");
		sql.append(" OP_2ND_SITA1 = '"+ entity.getOp_2nd_sita1() +"', ");
		sql.append(" OP_EMAIL1 = '"+ entity.getOp_email1() +"', ");
		sql.append(" HTL_CRW_LOV1 = '"+ entity.getHtl_crw_lov1() +"', ");
		sql.append(" HTL_TEL1 = '"+ entity.getHtl_tel1() +"', ");
		sql.append(" HTL_FAX1 = '"+ entity.getHtl_fax1() +"', ");
		sql.append(" OP_COMPANY2 = '"+ entity.getOp_company2() +"', ");
		sql.append(" OP_CALLSIGN2 = '"+ entity.getOp_callsign2() +"', ");
		sql.append(" OP_FREQ2 = '"+ entity.getOp_freq2() +"', ");
		sql.append(" OP_TEL2 = '"+ entity.getOp_tel2() +"', ");
		sql.append(" OP_FAX2 = '"+ entity.getOp_fax2() +"', ");
		sql.append(" OP_1ST_SITA2 = '"+ entity.getOp_1st_sita2() +"', ");
		sql.append(" OP_2ND_SITA2 = '"+ entity.getOp_2nd_sita2() +"', ");
		sql.append(" OP_EMAIL2 = '"+ entity.getOp_email2() +"', ");
		sql.append(" HTL_CRW_LOV2 = '"+ entity.getHtl_crw_lov2() +"', ");
		sql.append(" HTL_TEL2 = '"+ entity.getHtl_tel2() +"', ");
		sql.append(" HTL_FAX2 = '"+ entity.getHtl_fax2() +"', ");
		
		sql.append(" NOT_ACTIVE = '"+ entity.getNot_active() +"', ");
		sql.append(" WX_ACTIVE = '"+ entity.getWx_active() +"', ");
		sql.append(" CHG_DATE = SYSDATE, "); //
		sql.append(" USERID = '"+ entity.getEmp_no() +"', ");
		
		sql.append(" RWY_INFO = '"+ entity.getRwy_info() +"' "); //2010.02.10 ߰ : RWY_INFO
		
		sql.append(" WHERE IATA_PORT = '"+ entity.getIata_port() +"' ");
		
		Logger.debug.println("[BASE:SupA610Query:updMain] sql : "+sql.toString());
		return sql.toString();
	}

	/** 
	  * Airport Information  SQLԼ.
	  * @param entity SupA610BG Airport Information
	  * @return String Query 
	  * @author Copyright (c) 2005/05/31 
	  */
	public String delMain(SupA610BG entity){
		StringBuffer sql = new StringBuffer();
		
		// 2006.02.22  -> CM_PORT_T ̺ .
		sql.append(" DELETE FROM CM_PORT_T ");
		sql.append(" WHERE IATA_PORT = '"+ entity.getIata_port() +"' ");
		
		Logger.debug.println("[BASE:SupA610Query:delMain] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * BS_PORT_RWY_T ȸ SQLԼ.
	  * @param entity SupA610BG Airport Information
	  * @return String Query 
	  * @author Copyright (c) 2005/06/07 
	  */
	public String selPortRwy(SupA610BG entity){
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT ICAO_PORT FROM BS_PORT_RWY_T ");
		sql.append(" WHERE ICAO_PORT = '"+ entity.getIcao_port() +"' ");
		
		Logger.debug.println("[BASE:SupA610Query:selPortRwy] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * BS_PORT_RWY_T  SQLԼ.
	  * @param entity SupA610BG Airport Information
	  * @return String Query 
	  * @author Copyright (c) 2005/05/31 
	  */
	public String delPortRwy(SupA610BG entity){
		StringBuffer sql = new StringBuffer();

		sql.append(" DELETE FROM BS_PORT_RWY_T ");
		sql.append(" WHERE ICAO_PORT = '"+ entity.getIcao_port() +"' ");
		
		Logger.debug.println("[BASE:SupA610Query:delPortRwy] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * RWY_DIR  ȸ SQLԼ.
	  * @param icaoPort String ȸ
	  * @return String Query 
	  * @author Copyright (c) 2010/02/05 
	  */
	public String selRwyDir(String icaoPort) {
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT RWY_DIR ");
		sql.append(" FROM BS_PORT_RWY_T ");
		sql.append(" WHERE ICAO_PORT = '"+icaoPort+"' ");
		sql.append(" ORDER BY RWY_SEQ ");
		
		Logger.debug.println("[BASE:SupA610Query:selRwyDir] sql : "+sql.toString());
		return sql.toString();
	}	
}
