package kal.base.sup.query;

import kal.base.jdf.com.Logger;
import kal.base.sup.dbbean.*;
import kal.base.com.query.*;
import kal.base.com.util.*;

/**
 * BASE2 Company Route Information  Query -- 2010.02.02 .
 * ۼ ¥: 2005-05-23
 * @author: HIST  
 */
public class SupA640Query {
	private static SupA640Query instance = new SupA640Query();
	
	public static SupA640Query getInstance() {
		return instance;
	}
	
	/** 
	  * BASE2 IATA Station Check ȸ SQLԼ.
	  * @param selStn String Station
	  * @return String Query  
	  * @author Copyright (c) 2005/05/23 HIST 
	  */
	public String selIataStn(String selStn) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT * FROM CM_PORT_T");
		sql.append(" WHERE IATA_PORT = '"+selStn+"'");
		
		Logger.debug.println("[BASE:SupA640Query:selIataStn] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * BASE2 ICAO Station Check ȸ SQLԼ.
	  * @param selStn String Station
	  * @return String Query  
	  * @author Copyright (c) 2005/05/23 HIST 
	  */
	public String selIcaoStn(String selStn) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT * FROM CM_PORT_T");
		sql.append(" WHERE ICAO_PORT = '"+selStn+"'");
		
		Logger.debug.println("[BASE:SupA640Query:selIcaoStn] sql : "+sql.toString());
		return sql.toString();
	}	

	/** 
	  * BASE2 Company Route Information ȸ SQLԼ.
	  * @param params SupA640BG Parameter Object
	  * @return String Query  
	  * @author Copyright (c) 2005/05/23 HIST 
	  */
	public String selCRInfo(SupA640BG params) {
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT * ");
		sql.append(" FROM BS_COMP_ROUTE_T ");
		sql.append(" WHERE DEP_STN = '"+params.getDep_stn()+"' ");
		sql.append(" AND ARR_STN = '"+params.getArr_stn()+"' ");
		sql.append(" AND RTE_CD = '"+params.getRte_cd()+"' ");
		
		Logger.debug.println("[BASE:SupA640Query:selCRInfo] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * BASE2 Company Route Information  SQLԼ.
	  * @param params SupA640BG Parameter Object
	  * @return String Query  
	  * @author Copyright (c) 2005/05/23 HIST 
	  */
	public String delCRInfo(SupA640BG params) {
		StringBuffer sql = new StringBuffer();

		sql.append(" DELETE BS_COMP_ROUTE_T");
		sql.append(" WHERE DEP_STN = '"+params.getDep_stn()+"'");
		sql.append(" AND ARR_STN = '"+params.getArr_stn()+"'");
		sql.append(" AND RTE_CD = '"+params.getRte_cd()+"'");
		
		Logger.debug.println("[BASE:SupA640Query:delCRInfo] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * BASE2 Company Route Information Է SQLԼ.
	  * @param params SupA640BG Parameter Object
	  * @param rte_stn String Compay Route Station's
	  * @return String Query  
	  * @author Copyright (c) 2005/05/23 HIST 
	  */
	public String insCRInfo(SupA640BG params, String rte_stn) {
		StringBuffer sql = new StringBuffer();

		sql.append(" INSERT INTO BS_COMP_ROUTE_T (DEP_STN, ARR_STN, RTE_CD, RTE_STN, TIMESTMP, USERID) ");
		sql.append(" VALUES ('"+params.getDep_stn()+"','"+params.getArr_stn()+"','"+params.getRte_cd()+"','"+rte_stn+"',SYSDATE,'"+params.getUser_id()+"') ");
		
		Logger.debug.println("[BASE:SupA640Query:insCRInfo] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * BASE2 Company Route Information / Port ȸ SQLԼ.
	  * @param mode String 'A' : STN+FIR , 'S' : STN
	  * @return String Query  
	  * @author Copyright (c) 2005/05/23 HIST 
	  */
	public String selPortList(String mode) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" 	SELECT ICAO_PORT,IATA_PORT");
		sql.append(" 	FROM CM_PORT_T");
		if (mode.equals("A")) {
			sql.append(" 	UNION");
			sql.append(" 	SELECT FIR_CD ICAO_PORT,'FIR' IATA_PORT");
			sql.append(" 	FROM BS_FIR_T");
		}
		
		Logger.debug.println("[BASE:SupA640Query:selPortList] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * RTE_CD ȸ SQLԼ.
	  * @param params SupA640BG Parameter Object
	  * @return String Query  
	  * @author Copyright (c) 2005/10/05 
	  */
	public String selRteCd(SupA640BG params) {
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT RTE_CD");
		sql.append(" FROM BS_COMP_ROUTE_T");
		sql.append(" WHERE DEP_STN = '"+params.getDep_stn()+"'");
		sql.append(" AND ARR_STN = '"+params.getArr_stn()+"'");
		
		Logger.debug.println("[BASE:SupA640Query:selRteCd] sql : "+sql.toString());
		return sql.toString();
	}
	
}//end of class
