package kal.base.sup.query;

import kal.base.com.util.SecurityUtil;
import kal.base.com.util.StringUtil;
import kal.base.jdf.com.Logger;
import kal.base.sup.dbbean.SupA710BG;
import kal.base.sup.dbbean.SupA810BG;

/**
 * 20140918
 * sunpark
 * FFS Manager Address Management
 */
public class SupA810Query {
	private static SupA810Query instance = new SupA810Query();
	
	public static SupA810Query getInstance() {
		return instance;
	}
	
	/** 
	  *  Ʈ   ȸ 
	  */
	public String selCmPortT() {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT REGION_CD, IATA_PORT ");
		sql.append(" FROM CM_PORT_T ");
		sql.append(" WHERE REGION_CD is not null ");
		sql.append(" ORDER BY REGION_CD, IATA_PORT ASC ");
		
		Logger.debug.println("[BASE:SupA810Query:selCmPortT] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  *   FLIGHT_ADDR_T ׸ ȸ
	  */
	public String selPortAddress(SupA810BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT GRP_NAME, NTK, ADDR_LIST, OPTN, ENC_ADDR_LIST ");
		sql.append(" FROM KFOS.FLIGHT_ADDR_T ");
		sql.append(" WHERE IATA_PORT = '" + params.getIataPort() + "' ");
		//20141030 ߰
		sql.append(" AND ARLN_CD = '" + params.getArlnCd() + "' ");
		sql.append(" ORDER BY GRP_NAME, NTK ");

		Logger.debug.println("[BASE:SupA810Query:selPortAddress] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * FLIGHT_ADDR_T ׸ update, insert
	  */
	public String mrgPortAddress(SupA810BG params) {
		StringBuffer sql = new StringBuffer();
		
		//2016.09.07 ȣȭ  ENC_ADDR_E
		String enc_mail_addr = SecurityUtil.self.encrypt(params.getAddrList(), "INT_EML");

		sql.append(" MERGE INTO KFOS.FLIGHT_ADDR_T A ");
		sql.append(" USING DUAL ");
		sql.append(" ON (IATA_PORT = '" + params.getIataPort() + "' ");
		//20141030 ߰
		sql.append(" AND ARLN_CD  = '" + params.getArlnCd() + "' ");
		sql.append(" AND GRP_NAME = 'FD'||'" + params.getIataPort() + "'||'" + params.getGrpName() + "' ");
		sql.append(" AND NTK = '" + params.getNtk() + "') ");
		sql.append(" WHEN MATCHED THEN ");
		sql.append(" UPDATE SET ");
		sql.append(" ADDR_LIST = '" + params.getAddrList() + "', ");
		sql.append(" ENC_ADDR_LIST = '" + enc_mail_addr + "', ");
		sql.append(" OPTN = '" + params.getOptn() + "', ");
		sql.append(" USERID = '" + params.getUserId() + "', ");
		sql.append(" TIMESTMP = SYSDATE ");
		sql.append(" WHEN NOT MATCHED THEN ");
		//20141030 
		//sql.append(" INSERT (IATA_PORT, GRP_NAME ,NTK, ADDR_LIST, OPTN, USERID, TIMESTMP) ");
		sql.append(" INSERT (IATA_PORT, ARLN_CD, GRP_NAME ,NTK, ADDR_LIST, ENC_ADDR_LIST, OPTN, USERID, TIMESTMP) ");
		sql.append(" VALUES('" + params.getIataPort() + "', ");
		//20141030߰
		sql.append(" '" + params.getArlnCd() + "', ");
		sql.append(" 'FD'||'" + params.getIataPort() + "'||'" + params.getGrpName() + "', ");
		sql.append(" '" + params.getNtk() + "', ");
		sql.append(" '" + params.getAddrList() + "', ");
		sql.append(" '" + enc_mail_addr + "', ");
		sql.append(" '" + params.getOptn() + "', ");
		sql.append(" '" + params.getUserId() + "' ");
		sql.append(" , SYSDATE) ");
		
		Logger.debug.println("[BASE:SupA810Query:mrgPortAddress] sql : "+sql.toString());
		System.out.println("[BASE:SupA810Query:mrgPortAddress] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * FLIGHT_ADDR_T ׸ delete
	  */
	public String delPortAddress(SupA810BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" DELETE FROM KFOS.FLIGHT_ADDR_T ");
		sql.append(" WHERE IATA_PORT = '" + params.getIataPort() + "' ");
		//20141030 ߰
		sql.append(" AND ARLN_CD  = '" + params.getArlnCd() + "' ");
		sql.append(" AND GRP_NAME = 'FD'||'" + params.getIataPort() + "'||'" + params.getGrpName() + "' ");
		sql.append(" AND NTK = '" + params.getNtk()+ "' ");

		Logger.debug.println("[BASE:SupA810Query:delPortAddress] sql : "+sql.toString());
		return sql.toString();
	}	
}
