package kal.base.sup.query;

import kal.base.com.util.SecurityUtil;
import kal.base.com.util.StringUtil;
import kal.base.jdf.com.Logger;
import kal.base.sup.dbbean.SupA710BG;
import kal.base.sup.dbbean.SupA810BG;

/**
 * 20140918
 * sunpark
 * FFS Manager SI Info Management
 */

public class SupA820Query {
	private static SupA820Query instance = new SupA820Query();
	
	public static SupA820Query getInstance() {
		return instance;
	}
	
	/** 
	  *   ȸ
	  */
	public String selPortList(SupA810BG params) {
		StringBuffer sql = new StringBuffer();
		
		if(params.getStnto() == null || "".equals(params.getStnto())){
			sql.append(" SELECT DEP_PORT, ARV_PORT ");
			sql.append(" FROM ( ");
			sql.append(" 	SELECT '" + params.getStnfr() + "' DEP_PORT, '' ARV_PORT ");
			sql.append(" 	FROM DUAL ");
			sql.append(" 	UNION ALL ");
			sql.append(" 	SELECT DEP_PORT, ARV_PORT ");
			sql.append(" 	FROM KFOS.BS_SIINFO_T ");
			sql.append(" 	WHERE DEP_PORT = '" + params.getStnfr() + "' ");
			sql.append(" 	AND ARV_PORT IS NOT NULL ");
			sql.append(" ) ");
			sql.append(" ORDER BY NVL(ARV_PORT, '0') ");
		} else {
			sql.append(" SELECT DEP_PORT, ARV_PORT ");
			sql.append(" FROM KFOS.BS_SIINFO_T ");
			sql.append(" WHERE DEP_PORT = '" + params.getStnfr() + "' ");
			sql.append(" AND ARV_PORT = '" + params.getStnto() + "' ");
		}
		
		Logger.debug.println("[BASE:SupA820Query:selPortList] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  *   BS_SIINFO_T ׸ ȸ
	  */
	public String selSiinfoT(SupA810BG params) {
		
		StringBuffer sql = new StringBuffer();
		
		//2016.09.07 ȣȭ  ENC_TEL
		sql.append(" SELECT SIINFO, TEL, ENC_TEL ");
		sql.append(" FROM KFOS.BS_SIINFO_T ");
		sql.append(" WHERE DEP_PORT = '" + params.getSelectedStnfr() + "' ");
		if(params.getSelectedStnto() == null || "".equals(params.getSelectedStnto())){
			sql.append(" AND ARV_PORT IS NULL ");
		} else {
			sql.append(" AND ARV_PORT = '" + params.getSelectedStnto() + "' ");
		}

		Logger.debug.println("[BASE:SupA820Query:selSiInfoT] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * BS_SIINFO_T ׸ update, insert
	  */
	public String mrgSiinfoT(SupA810BG params) {

		StringBuffer sql = new StringBuffer();
		
		//2016.09.07 ȣȭ  Enc_Tel_No, Enc_Mail_Addr 
		String enc_tel = SecurityUtil.self.encrypt(params.getTel(), "INT_TEL");
		
		sql.append(" MERGE INTO KFOS.BS_SIINFO_T A ");
		sql.append(" USING DUAL ");
		sql.append(" ON (DEP_PORT = '" + params.getSelectedStnfr() + "' ");
		if(params.getSelectedStnto() == null || "".equals(params.getSelectedStnto())){
			sql.append(" AND ARV_PORT IS NULL) ");
		} else {
			sql.append(" AND ARV_PORT = '" + params.getSelectedStnto() + "') ");
		}
		sql.append(" WHEN MATCHED THEN ");
		sql.append(" UPDATE SET ");
		sql.append(" SIINFO = '" + params.getSiinfo() + "', TEL = '" + params.getTel() + "', ENC_TEL = '" + enc_tel + "' ");
		sql.append(" WHEN NOT MATCHED THEN ");
		sql.append(" INSERT (DEP_PORT, ARV_PORT, SIINFO, USERID, TEL, ENC_TEL, TIMESTMP) ");
		sql.append(" VALUES('" + params.getSelectedStnfr() + "', ");
		sql.append(" 		'" + params.getSelectedStnto() + "', ");
		sql.append(" 		'" + params.getSiinfo() + "', ");
		sql.append(" 		'" + params.getUserId() + "', ");
		sql.append(" 		'" + params.getTel() + "', ");
		sql.append(" 		'" + enc_tel + "', ");
		sql.append(" 		SYSDATE) ");
		
		Logger.debug.println("[BASE:SupA820Query:mrgSiinfoT] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * BS_SIINFO_T ׸ delete
	  */
	public String delSiinfoT(SupA810BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" DELETE FROM KFOS.BS_SIINFO_T ");
		sql.append(" WHERE DEP_PORT = '" + params.getSelectedStnfr() + "' ");
		if(params.getSelectedStnto() == null || "".equals(params.getSelectedStnto())){
			sql.append(" AND ARV_PORT IS NULL ");
		} else {
			sql.append(" AND ARV_PORT = '" + params.getSelectedStnto()  + "' ");
		}

		Logger.debug.println("[BASE:SupA820Query:delSiinfoT] sql : "+sql.toString());
		return sql.toString();
	}	
}
