package kal.base.sup.query;

import kal.base.jdf.com.Logger;
import kal.base.com.util.*;
import kal.base.sup.dbbean.*;

 /**
   * Current Weather Request SQL 
   * @author Copyright (c) 2005/07/13 
   */
public class SupQ210Query {
	private static SupQ210Query instance = new SupQ210Query();
	
	public static SupQ210Query getInstance() {
		return instance;
	}

	/** 
	  * Current Weather Request Area Station ȸ SQLԼ.
	  * @param params SupQ210BG ȸ
	  * @return String Query 
	  * @author Copyright (c) 2005/07/13 
	  */
	public String selAreaStn(SupQ210BG params){
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT AREA_STN");
		sql.append(" FROM BS_AREA_T");
		sql.append(" WHERE AREA_CD = '"+params.getArea_cd()+"'");
		
		Logger.debug.println("[BASE:SupQ210Query:selAreaStn] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * Current Weather Request Weekly SKD ȸ SQLԼ.
	  * @param params SupQ210BG ȸ
	  * @return String Query 
	  * @author Copyright (c) 2005/07/13 
	  */
	public String selWeekSchT(String mode,SupQ210BG params){
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT DISTINCT FLT_NUM,STNFR,STNTO");
		sql.append(" FROM WEEKLY_SCH_T");
		sql.append(" WHERE FLT_NUM = '"+params.getFlt_num()+"'");
		sql.append(" AND EFF_LOC_DT <= SYSDATE");
		sql.append(" AND EXP_LOC_DT >= SYSDATE");
		//1) FLT# Էϰ DEPSTN/ARRSTN Է¾ 
		if (mode.equals("1"))
			//2009.04.28  : 1, 2, 3...=> 10, 20, 30...  
			//sql.append(" AND LEG_NUM=1");
			sql.append(" AND LEG_NUM IN (1, 10) ");
		//2) FLT#/DEPSTN/ARRSTN Է 
		else if (mode.equals("2"))
			sql.append(" AND STNFR = '"+params.getStnfr()+"' AND STNTO = '"+params.getStnto()+"'");
		//3) FLT#/DEPSTN Է 
		else if (mode.equals("3"))
			sql.append(" AND STNFR = '"+params.getStnfr()+"'");
		//1),2),3) ==>  DEPSTN=STNFR,ARRSTN=STNTO DISPLAY
		
		System.out.println("[BASE:SupQ210Query:selWeekSchT] sql : "+sql.toString());
		//Logger.debug.println("[BASE:SupQ210Query:selWeekSchT] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * Current Weather Request Route Station ȸ SQLԼ. -- 
	  * @param params SupQ210BG ȸ
	  * @return String Query 
	  * @author Copyright (c) 2005/07/13 
	  */
	/*public String selRteStn(SupQ210BG params){
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT RTE_STN");
		sql.append(" FROM BS_COMP_ROUTE_T");
		sql.append(" WHERE DEP_STN = '"+params.getStnfr()+"'");
		sql.append(" AND ARR_STN = '"+params.getStnto()+"'");
		sql.append(" AND RTE_CD = '"+params.getRte_id()+"'");
		
		System.out.println("[BASE:SupQ210Query:selRteStn] sql : "+sql.toString());
		//Logger.debug.println("[BASE:SupQ210Query:selRteStn] sql : "+sql.toString());
		return sql.toString();
	}*/
	
	/** 
	  * Current Weather Request Alternate  ȸ SQLԼ.
	  * @param params SupQ210BG ȸ
	  * @return String Query 
	  * @author Copyright (c) 2009/12/28 
	  */
	public String selAltnPort(SupQ210BG params) {
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT ALTN_STN ");
		sql.append(" FROM BS_ALTN_PORT_T ");
		sql.append(" WHERE IATA_PORT = '"+params.getStnto()+"' ");
		
		System.out.println("[BASE:SupQ210Query:selAltnPort] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * Current Weather Request New Company Route ȸ SQLԼ.
	  * @param params SupQ210BG ȸ
	  * @return String Query 
	  * @author Copyright (c) 2009/12/28 
	  */
	public String selCompRoute(SupQ210BG params) {
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT ETOPS_STN, ENRTE_STN, REFILE_STN, OTHERS_STN ");
		sql.append(" FROM BS_COMP_ROUTE_T ");
		sql.append(" WHERE DEP_STN = '"+params.getStnfr()+"' ");
		sql.append(" AND ARR_STN = '"+params.getStnto()+"' ");
		sql.append(" AND RTE_CD = '"+params.getRte_id()+"' ");
		
		System.out.println("[BASE:SupQ210Query:selCompRoute] sql : "+sql.toString());
		return sql.toString();
	}
	
	/********************* DATA VIEW ********************/
	
	/** 
	  * Current Weather Request  Input Station ȸ SQLԼ.
	  * @param stn String ȸ
	  * @return String Query 
	  * @author Copyright (c) 2005/06/27 
	  */
	public String selStation(String stn){
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT ICAO_PORT, IATA_PORT FROM CM_PORT_T ");
		if (stn.length() == 4)
			sql.append(" WHERE ICAO_PORT = '"+stn+"' ");		//(STN 4ڸ )
		else
			sql.append(" WHERE IATA_PORT = '"+stn+"' "); 	//(STN 3ڸ )
		
		System.out.println("[BASE:SupQ210Query:selStation] sql : "+sql.toString());
		Logger.debug.println("[BASE:SupQ210Query:selStation] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * Current Weather Request   ȸ SQLԼ.
	  * @param stn String ȸ
	  * @return String Query 
	  * @author Copyright (c) 2005/06/27 
	  */
	public String selStationInfo(String stn){
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT ICAO_PORT, IATA_PORT, PORT_E, CURFEW, ");
		sql.append(" NVL(GMT_OFFSET,0)/60 GMT_OFFSET, TO_CHAR(SYSDATE-(9/24),'DD/MM/YY HH24:MI') NOW_TIME, ");
		sql.append(" RWY_INFO "); //2010.02.04 ߰
		sql.append(" FROM CM_PORT_T ");
		sql.append(" WHERE ICAO_PORT = '"+stn+"' ");
		
		Logger.debug.println("[BASE:SupQ210Query:selStationInfo] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * Current Weather Request  RWY  ȸ SQLԼ.
	  * @param stn String ȸ
	  * @return String Query 
	  * @author Copyright (c) 2005/06/27 
	  */
	public String selRwyInfo(String stn){
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT RWY_DIR,RWY_VIS_LIMIT,RWY_RVR_LIMIT,RWY_CIG_LIMIT");
		sql.append(" FROM BS_PORT_RWY_T");
		sql.append(" WHERE ICAO_PORT = '"+stn+"'");
		//sql.append(" AND RWY_SEQ <= 2");
		//RWY INFO : RWY_SEQ=1  RWY ̿ => 2005.08.03 
		sql.append(" AND RWY_SEQ = 1");
		
		Logger.debug.println("[BASE:SupQ210Query:selRwyInfo] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * Current Weather Request  RWY  ȸ SQLԼ.
	  * @param stn String ȸ
	  * @return String Query 
	  * @author Copyright (c) 2010/02/04 
	  */
	public String selRwyInfo2(String stn){
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT RWY_DIR ");
		sql.append(" FROM BS_PORT_RWY_T ");
		sql.append(" WHERE ICAO_PORT = '"+stn+"' ");
		sql.append(" ORDER BY RWY_SEQ ");
		
		Logger.debug.println("[BASE:SupQ210Query:selRwyInfo2] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * Current Weather Request  Sequence  ȸ SQLԼ.
	  * @return String Query 
	  * @author Copyright (c) 2005/06/27 
	  */
	public String selUniSeq(){
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT TO_CHAR(UNI_SEQ.NEXTVAL) UNI_SEQ FROM DUAL");
		
		//Logger.debug.println("[BASE:SupQ210Query:selUniSeq] sql : "+sql.toString());
		return sql.toString();	
	}
	
	/** 
	  * Current Weather Request  Sequence  ȸ SQLԼ.
	  * @return String Query 
	  * @author Copyright (c) 2005/06/27 
	  */
	public String insMsTelexMsgORG(String seq, int msgMax, int msgPos, String msg, String dbTime, String originText, String projectNo){
		StringBuffer sql = new StringBuffer();

		//==> 2005.12.09 
		//sql.append(" INSERT INTO MS_TELEX_MSG_T (MSG_CAT,MSG_TMPST,UNI_SEQ,MSG_MAX,MSG_POS,ORIGIN_ADDR,MESSAGE,PRIORITY,PROJECT_NO,PROCESSED,ERROR_REPLY)");
		//sql.append(" VALUES ('WEATHER',SYSDATE-(9/24),"+seq+","+msgMax+","+msgPos+",'"+originText+"','"+msg+"',1,'"+projectNo+"','N',' ')");
		
		sql.append(" INSERT INTO MS_TELEX_MSG_T (MSG_CAT,MSG_TMPST,UNI_SEQ,MSG_MAX,MSG_POS,ORIGIN_ADDR,MESSAGE,PRIORITY,SYS_MQID,PROJECT_NO,PROCESSED,ERROR_REPLY)");
		sql.append(" VALUES ('WEATHER',SYSDATE-(9/24),"+seq+","+msgMax+","+msgPos+",'"+originText+"','"+msg+"',1,"+dbTime+"||TRIM(TO_CHAR("+seq+",'00000')),'"+projectNo+"','N',' ')");
		
		//Logger.debug.println("[BASE:SupQ210Query:insMsTelexMsg] sql : "+sql.toString());
		return sql.toString();	
	}
	//20150428 MHS
	public String insMsTelexMsg(String seq, int msgMax, int msgPos, String msg, String dbTime, String originText, String projectNo){
		
		msg = msg != null ? msg.replace("\"", "") : msg;
		
		StringBuffer sql = new StringBuffer();

		//sql.append(" INSERT INTO KFOS.MS_TELEX_MHS_T_TEST (MSG_CAT,MSG_TMPST,UNI_SEQ,MSG_MAX,MSG_POS,ORIGIN_ADDR,MESSAGE,PRIORITY,SYS_MQID,PROJECT_NO,PROCESSED,ERROR_REPLY)");
		sql.append(" INSERT INTO KFOS.MS_TELEX_MHS_T (MSG_CAT,MSG_TMPST,UNI_SEQ,MSG_MAX,MSG_POS,ORIGIN_ADDR,MESSAGE,PRIORITY,SYS_MQID,PROJECT_NO,PROCESSED,ERROR_REPLY)");
		sql.append(" VALUES ('WEATHER',SYSDATE-(9/24),"+seq+","+msgMax+","+msgPos+",'"+originText+"','"+msg+"',1,"+dbTime+"||TRIM(TO_CHAR("+seq+",'00000')),'"+projectNo+"','N',' ')");
		
		Logger.debug.println("[BASE:SupQ210Query:insMsTelexMsg] sql : "+sql.toString());
		return sql.toString();	
	}
	
	//@2018-04-12
	public String updEdtoConfirm(){
		StringBuffer sql = new StringBuffer();
		
		sql.append("	UPDATE KFOS.FFS_ALERT_T");
		sql.append("	SET");
		sql.append("		EDTO_CONFIRM = ?||'/'||TO_CHAR(SYSDATE,'HH24:MI')");
		sql.append("	WHERE ");
		sql.append("		FIRST_LEG_FLT_DT = TO_DATE(?,'YYYYMMDD')");
		sql.append("	AND FLT_NUM	=	?");
		sql.append("	AND STNFR	=	?");
		sql.append("	AND STNTO	=	?");
		
		Logger.debug.println("[BASE:SupQ210Query:updEdtoConfirm] sql : "+sql.toString());
		return sql.toString();
	}
}
