package kal.base.sup.query;

import kal.base.jdf.com.Logger;
import kal.base.com.util.*;
import kal.base.sup.dbbean.*;

 /**
   * Weather Watch Regional SQL 
   * @author Copyright (c) 2005/07/21 
   */
public class SupQ510Query{
	private static SupQ510Query instance = new SupQ510Query();
	
	public static SupQ510Query getInstance() {
		return instance;
	}
	
	/** 
	  * Weather Watch Regional Area Station ȸ SQLԼ.
	  * @param params SupQ510BG ȸ
	  * @return String Query 
	  * @author Copyright (c) 2005/07/21 
	  */
	public String selAreaStn(SupQ510BG params){
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT AREA_STN");
		sql.append(" FROM BS_AREA_T");
		sql.append(" WHERE AREA_CD = '"+params.getArea_cd()+"'");
		sql.append(" AND AREA_TYP='S'");
		
		Logger.debug.println("[BASE:SupQ510Query:selAreaStn] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * Weather Watch Regional Main ȸ SQLԼ.
	  * @param params SupQ510BG ȸ
	  * @return String Query 
	  * @author Copyright (c) 2005/07/21 
	  */
	public String selWeatherWatch(SupQ510BG params){
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT 	A.ICAO_PORT,A.IATA_PORT,A.WX_STS,DECODE(A.VIS,'9999','More than 10Km',A.VIS||'m') VIS,A.WIND,A.TEMP,");
		//sql.append("        		DECODE(A.WDIR,'NW','ϼǳ','N','ǳ','NE','ϵǳ','E','ǳ','SE','ǳ','S','ǳ','SW','ǳ','W','ǳ') WDIR,");
		sql.append("        		A.WDIR, "); //2010.01.26  : ǥ 
		sql.append("        		B.PORT_E,NVL(B.COORD_X2,0) COORD_X2,NVL(B.COORD_Y2,0) COORD_Y2,C.DESC_E,C.OTHRS_E,C.CODE_C,");
		
		if (params.getUtc_loc().equals("UTC")) {
			sql.append("        		TO_CHAR(A.METAR_DTG,'DDMONYY HH24MI')||'Z' METAR_DTG");
		} else { //LOC
			sql.append("        		TO_CHAR(A.METAR_DTG+(B.GMT_OFFSET/1440),'DDMONYY HH24MI')||'L' METAR_DTG");
		}
		sql.append(" FROM  BS_WEATHER_WATCH_T A, CM_PORT_T B,");
		sql.append("     		(SELECT CODE_C,DESC_E,OTHRS_E");
		sql.append("      		  FROM CODE_T");
		sql.append("      		  WHERE STEP_X = '9' ");
		//sql.append("      		  AND CODE_X = 'WXR STS') C");
		sql.append("      		  AND CODE_X = 'WXR STS2') C");
		sql.append(" WHERE A.ICAO_PORT = B.ICAO_PORT");
		sql.append(" AND A.WX_STS = C.CODE_C(+)");
		sql.append(" AND B.WX_ACTIVE = 'W'");
		sql.append(" AND (B.COORD_X2 > 0 AND B.COORD_Y2 > 0)");
		sql.append(" AND A.ICAO_PORT IN ("+params.getIcao_port()+")");
		sql.append(" AND (A.METAR_DTG >= SYSDATE-9/24-3/24 OR A.TAF_DTG >= SYSDATE-9/24-2)");

		Logger.debug.println("[BASE:SupQ510Query:selWeatherWatch] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * Weather Watch Regional DB DATE ȸ SQLԼ.
	  * @return String Query 
	  * @author Copyright (c) 2005/07/25 
	  */
	public String selSysDate(){
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT TO_CHAR(SYSDATE-(9/24),'YYYYMMDDHH24MI') NOW_DATE FROM DUAL");

		Logger.debug.println("[BASE:SupQ510Query:selSysDate] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * Weather Watch Regional METAR м ȸ SQLԼ.
	  * @return String Query 
	  * @author Copyright (c) 2005/07/25 
	  */
	public String selMetarData(){
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT A.ICAO_PORT,A.IATA_PORT,A.METAR_BELOW_CD,A.METAR_WARN_CD,A.METAR_SIG_WX,A.METAR_WIND_Y,TO_CHAR(A.METAR_DTG,'YYYYMMDDHH24MI') METAR_DTG");
		sql.append(" FROM BS_WEATHER_WATCH_T A, CM_PORT_T B");
		sql.append(" WHERE A.ICAO_PORT = B.ICAO_PORT");
		sql.append(" AND B.WX_ACTIVE = 'W'");
		sql.append(" AND (A.METAR_DTG >= SYSDATE-9/24-3/24 AND A.METAR_DTG <= SYSDATE-9/24)");
		sql.append(" AND ((A.METAR_BELOW_CD IS NOT NULL) OR (A.METAR_WARN_CD IS NOT NULL) OR (A.METAR_SIG_WX IS NOT NULL) OR (A.METAR_WIND_Y = 'Y'))");

		Logger.debug.println("[BASE:SupQ510Query:selMetarData] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * Weather Watch Regional TAF м ȸ SQLԼ.
	  * @return String Query 
	  * @author Copyright (c) 2005/07/25 
	  */
	public String selTafData(){
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT A.ICAO_PORT,A.IATA_PORT,A.TAF_BELOW_PRD,A.TAF_WARN_PRD,A.ETOP_BELOW_PRD,A.TAF_BELOW_Y,A.TAF_WARN_Y,A.ETOP_BELOW_Y");
		sql.append(" FROM BS_WEATHER_WATCH_T A, CM_PORT_T B");
		sql.append(" WHERE A.ICAO_PORT = B.ICAO_PORT");
		sql.append(" AND B.WX_ACTIVE = 'W'");
		sql.append(" AND A.TAF_DTG >= SYSDATE-9/24-2");
		sql.append(" AND ((A.TAF_BELOW_Y = 'Y') OR (A.TAF_WARN_Y = 'Y') OR (A.ETOP_BELOW_Y = 'Y'))");

		Logger.debug.println("[BASE:SupQ510Query:selTafData] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * Weather Watch Regional TAF м - BELOW STN   ȿ Ⱓ  츮  ִ ȸ SQLԼ.
	  * @return String Query 
	  * @author Copyright (c) 2010/01/27 
	  */
	public String cntBelowStnFlt(String fromDt, String toDt, String iataPort){
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT COUNT(*) CNT ");
		sql.append(" FROM DAILY_SCH_T ");
		sql.append(" WHERE FIRST_LEG_FLT_DT BETWEEN TO_DATE('"+fromDt.substring(0,8)+"','YYYYMMDD')-2 ");
		sql.append(" AND TO_DATE('"+toDt.substring(0,8)+"','YYYYMMDD')+2 ");
		sql.append(" AND ACTNID <> 'CNL' ");
		sql.append(" AND ((STNFR='"+iataPort+"' ");
		sql.append(" AND EST_DEP_DT BETWEEN TO_DATE('"+fromDt+"','YYYYMMDDHH24MI')-4/24 ");
		sql.append(" AND TO_DATE('"+toDt+"','YYYYMMDDHH24MI')+4/24) ");
		sql.append(" OR (STNTO='"+iataPort+"' ");
		sql.append(" AND EST_ARV_DT BETWEEN TO_DATE('"+fromDt+"','YYYYMMDDHH24MI')-4/24 ");
		sql.append(" AND TO_DATE('"+toDt+"','YYYYMMDDHH24MI')+4/24)) ");
		sql.append(" AND ARV_STS <> 'ACT' "); //2010.02.16 ߰

		//System.out.println("[BASE:SupQ510Query:cntBelowStnFlt] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * Weather Watch Regional METAR BELOW м ȸ SQLԼ.
	  * @return String Query 
	  * @author Copyright (c) 2005/07/25 
	  */
	public String selMetarBelow(){
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT A.IATA_PORT,TO_CHAR(A.METAR_DTG,'YYYYMMDDHH24MI') METAR_DTG");
		sql.append(" FROM BS_WEATHER_WATCH_T A, CM_PORT_T B");
		sql.append(" WHERE A.ICAO_PORT = B.ICAO_PORT");
		sql.append(" AND B.WX_ACTIVE = 'W'");
		sql.append(" AND (A.METAR_DTG >= SYSDATE-9/24-3/24 AND A.METAR_DTG <= SYSDATE-9/24)");
		sql.append(" AND A.METAR_BELOW_CD IS NOT NULL");

		Logger.debug.println("[BASE:SupQ510Query:selMetarBelow] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * Weather Watch Regional ش METAR м ȸ SQLԼ.
	  * @return String Query 
	  * @author Copyright (c) 2005/07/25 
	  */
	public String selMetarAnalysis(){
		StringBuffer sql = new StringBuffer();

		// ==> WHERE  ߰ (2006/02/06)
		sql.append(" SELECT FLT_NUM,STNTO,TO_CHAR(EST_ARV_DT,'HH24MI') ARV_TM");
		sql.append(" FROM DAILY_SCH_T");
		sql.append(" WHERE EST_DEP_DT >= TO_DATE(?,'YYYYMMDDHH24MI') - 1");
		sql.append(" 	AND EST_DEP_DT <= TO_DATE(?,'YYYYMMDDHH24MI') + 3/24");
		sql.append(" 	AND EST_ARV_DT >= TO_DATE(?,'YYYYMMDDHH24MI')");
		sql.append(" 	AND EST_ARV_DT <= TO_DATE(?,'YYYYMMDDHH24MI') + 3/24");
		sql.append(" 	AND STNTO = ? ");
		sql.append("  AND ARV_STS <> 'ACT' "); //2010.02.16 ߰

		Logger.debug.println("[BASE:SupQ510Query:selMetarAnalysis] sql : "+sql.toString());
		return sql.toString();
	}		
	
	/** 
	  * Weather Watch Regional TAF BELOW м ȸ SQLԼ.
	  * @return String Query 
	  * @author Copyright (c) 2005/07/25 
	  */
	public String selTafBelow(){
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT A.IATA_PORT,A.TAF_BELOW_PRD,A.TAF_BELOW_Y");
		sql.append(" FROM BS_WEATHER_WATCH_T A, CM_PORT_T B");
		sql.append(" WHERE A.ICAO_PORT = B.ICAO_PORT");
		sql.append(" AND B.WX_ACTIVE = 'W'");
		sql.append(" AND A.TAF_DTG >= SYSDATE-9/24-2");
		sql.append(" AND A.TAF_BELOW_Y = 'Y'");

		Logger.debug.println("[BASE:SupQ510Query:selTafBelow] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * Weather Watch Regional ش TAF м ȸ SQLԼ.
	  * @return String Query 
	  * @author Copyright (c) 2005/07/25 
	  */
	public String selTafAnalysis(){
		StringBuffer sql = new StringBuffer();

		// ==> WHERE  ߰ (2006/02/06)
		sql.append(" SELECT FLT_NUM,STNTO,TO_CHAR(EST_ARV_DT,'HH24MI') ARV_TM");
		sql.append(" FROM DAILY_SCH_T");
		sql.append(" WHERE STNTO = ?");
		sql.append(" 	AND EST_DEP_DT >= TO_DATE(?,'YYMMDDHH24MI') - 1");
		sql.append(" 	AND EST_DEP_DT < TO_DATE(?,'YYMMDDHH24MI')");
		sql.append(" 	AND EST_ARV_DT >= TO_DATE(?,'YYMMDDHH24MI')");
		sql.append(" 	AND EST_ARV_DT < TO_DATE(?,'YYMMDDHH24MI')");
		sql.append("  AND ARV_STS <> 'ACT' "); //2010.02.16 ߰

		Logger.debug.println("[BASE:SupQ510Query:selTafAnalysis] sql : "+sql.toString());
		return sql.toString();
	}	

	/** 
	  * Weather Watch Regional Station Info ȸ SQLԼ.
	  * @return String Query 
	  * @author Copyright (c) 2005/07/25 
	  */
	public String selStnInfo(String icaoPort){
		StringBuffer sql = new StringBuffer();	
	
		sql.append(" SELECT ICAO_PORT,WX_TYP,TYP_SEQ,WX_TEXT ");
		sql.append(" FROM (SELECT ICAO_PORT,WX_DTG,TYP_SEQ,WX_TYP,WX_TEXT ");
		sql.append("            FROM BS_WEATHER_T ");
		sql.append("            WHERE ICAO_PORT = '"+icaoPort+"' AND TYP_SEQ=1 AND WX_TYP<>'SB' "); //2010.07.13 ߰ : AND WX_TYP<>'SB'
		sql.append("            AND WX_DTG=(SELECT MAX(WX_DTG) FROM BS_WEATHER_T ");
		sql.append("                      WHERE ICAO_PORT='"+icaoPort+"' AND TYP_SEQ=1 AND WX_TYP<>'SB' AND WX_DTG>=(SYSDATE-9/24)-3/24) "); //2010.07.13 ߰ : AND WX_TYP<>'SB'
		sql.append("            UNION ");
		sql.append("            SELECT ICAO_PORT,WX_DTG,TYP_SEQ,WX_TYP,WX_TEXT ");
		sql.append("            FROM BS_WEATHER_T ");
		sql.append("            WHERE ICAO_PORT = '"+icaoPort+"' AND TYP_SEQ=2 ");
		sql.append("            AND WX_DTG=(SELECT MAX(WX_DTG) FROM BS_WEATHER_T ");
		sql.append("                      WHERE ICAO_PORT='"+icaoPort+"' AND TYP_SEQ=2 AND WX_DTG>=(SYSDATE-9/24)-12/24)) ");
		sql.append(" ORDER BY TYP_SEQ,WX_TYP ");
		
		Logger.debug.println("[BASE:SupQ510Query:selStnInfo] sql : "+sql.toString());
		return sql.toString();
	}	

}
