package kal.base.sys.ejb;

//ڹ 
import java.io.*;
import java.sql.*;
import java.text.DecimalFormat;
import java.text.NumberFormat;
import java.util.*;

//Project 
import kal.base.jdf.com.*;
import kal.base.jdf.db.*;
import kal.base.pbf.db.*;
import kal.base.jdf.jtx.*;
import kal.base.com.util.*;
import kal.base.jdf.ejb.*;
import kal.base.jdf.serv.Box;

//System
import kal.base.sys.query.*;
import kal.base.sys.dbbean.*;

/**
 * Bean implementation class for Enterprise Bean: SysAllSL
 */
public class SysAllSLBean extends BeanAdapter {

	/** 
	  * <b>BASE2 User Log On & Info ȸԼ</b>. 
	  * @param params SysA010BG ȸ
	  * @return SysA010BG ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2005/04/04 HIST 
	  */
	public SysA010BG selSysA010Main(SysA010BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    boolean mode = false;
	    
	    //Return ü
	    SysA010BG entity = null;
	   
	    try {
			//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//User Info ȸ
			stmt = conn.createStatement();
			//sql = SysA010Query.getInstance().selUserInfo(params.getEmp_no(),params.getPswd_no());
			sql = SysA010Query.getInstance().selUserInfo(params.getEmp_no(),params.getRandom_c());
			rs = stmt.executeQuery(sql);
			
			if (rs.next()) {
				mode = true;
				entity =  new SysA010BG();
				entity.setEmp_no(StringUtil.checkString(rs.getString("Emp_No")));
				entity.setKor_n(StringUtil.to8859_1(rs.getString("Kor_N")));
				entity.setDept_c(StringUtil.checkString(rs.getString("Dept_C")));
				entity.setAuth_pmsn(StringUtil.checkString(rs.getString("Auth_Pmsn")));
			}			
			
			if (stmt != null) stmt.close();
			if (rs != null) rs.close();
			if (sql != null) sql = null;
			
			if (mode) {
				//User Log In  
				stmt = conn.createStatement();
				sql = SysA010Query.getInstance().updUserInfo(params);
				int updCnt = stmt.executeUpdate(sql);
				
				if (updCnt != 1) throw new BusinessException("User Log In Update Exception");
			}
			
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:SysAllSLBean:selSysA010Main:SQLException] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
	    } catch(BusinessException be) {
	    	Logger.debug.println("[BASE:SysAllSLBean:selSysA010Main:BusinessException] "+((BusinessException)be).getMessage());
			throw new BusinessException(be.getMessage());
		} catch(Exception e) {
			Logger.debug.println("[BASE:SysAllSLBean:selSysA010Main:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return entity;
	}//end of function	

	/** 
	  * <b>BASE2 User Log Out Լ</b>. 
	  * @param params SysA010BG User Info
	  * @return SysA010BG Log Out  EmpNo & RandomCode 
	  * @exception Exception
	  * @author Copyright (c) 2005/04/06 HIST 
	  */
	public SysA010BG updSysA010Main(SysA010BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
	    String sql = null;
	    
	    //Return ü
	    SysA010BG entity = new SysA010BG();
	   
	    try {
	    	Random rd = new Random();
	    	String randomC = String.valueOf(rd.nextInt(999999999)).toString();
	    	params.setRandom_c(randomC);
	    	entity.setRandom_c(params.getRandom_c());
	    	entity.setEmp_no(params.getEmp_no());
	    	
			//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//User Logout
			stmt = conn.createStatement();
			sql = SysA010Query.getInstance().updUserOut(params);
			int updCnt = stmt.executeUpdate(sql);
			if (updCnt != 1) throw new BusinessException("User Log Out Update Exception");
			
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:SysAllSLBean:updSysA010Main:SQLException] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
	    } catch(BusinessException be) {
	    	Logger.debug.println("[BASE:SysAllSLBean:updSysA010Main:BusinessException] "+((BusinessException)be).getMessage());
			throw new BusinessException(be.getMessage());
		} catch(Exception e) {
			Logger.debug.println("[BASE:SysAllSLBean:updSysA010Main:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().UPDATE_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return entity;
	}//end of function
	
	/** 
	  * <b>BASE2 User Information ȸԼ</b>. 
	  * @param params SysA020BG ȸ
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2005/04/11 HIST 
	  */
	public Hashtable selSysA020Main(SysA020BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;

	    //Return ü
	    Hashtable hashData = new Hashtable();
	    List listData = new LinkedList();
	    ArrayList<Box> list = new ArrayList<Box>();
	    
	    String encTelNo = "";
	    String encMailAddr = "";
	   
	    try {
			//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//User Info ȸ
			stmt = conn.createStatement();
			sql = SysA020Query.getInstance().selUserInfo(params);
			rs = stmt.executeQuery(sql);
			
			while (rs.next()) {
				

				Box box = new Box("");
				
				box.put("Emp_No", StringUtil.checkString(rs.getString("Emp_No")));
				box.put("Kor_N", StringUtil.checkString(rs.getString("Kor_N")));
				box.put("Dept_C", StringUtil.checkString(rs.getString("Dept_C")));
				box.put("Auth_Pmsn", StringUtil.checkString(rs.getString("Auth_Pmsn")));
				box.put("Ip_n", StringUtil.checkString(rs.getString("Ip_n")));
				box.put("Login_d", StringUtil.checkString(rs.getString("Login_d")));
				box.put("Pswd_No", StringUtil.checkString(rs.getString("Pswd_No")));
				box.put("Update_d", StringUtil.checkString(rs.getString("Update_d")));
				box.put("Tel_No", StringUtil.checkString(rs.getString("Tel_No")));
				box.put("Mail_Addr", StringUtil.checkString(rs.getString("Mail_Addr")));
				box.put("Project_c", StringUtil.checkString(rs.getString("Project_c")));
				box.put("Favor_c", StringUtil.checkString(rs.getString("Favor_c")));
				box.put("USE_CNT", StringUtil.checkString(rs.getString("USE_CNT")));
				
				//2016.09.07 ȣȭ 
				if("".equals(StringUtil.checkString(rs.getString("Enc_Tel_No")))){
					encTelNo = SecurityUtil.self.encrypt("null", "INT_TEL");
					System.out.println("selUserInfo encTelNo:"+encTelNo);
					
				}else{
					encTelNo = StringUtil.checkString(rs.getString("Enc_Tel_No"));
				}
				
				box.put("dec_tel_no", encTelNo);
				
				if("".equals(StringUtil.checkString(rs.getString("Enc_Mail_Addr")))){
					encMailAddr = SecurityUtil.self.encrypt("null", "INT_EML");
					System.out.println("selUserInfo encMailAddr:"+encMailAddr);
				}else{
					encMailAddr = StringUtil.checkString(rs.getString("Enc_Mail_Addr"));
				}
				
				box.put("dec_mail_addr", encMailAddr);

				box.put("Enc_Tel_No", StringUtil.checkString(rs.getString("Enc_Tel_No")));
				
				list.add(box);
				
			}
			
			System.out.println("----------------Bean decrypt start -------------");
			//2016.09.07 ȣȭ 
			ArrayList<Box> boxs	= SecurityUtil.self.decrypts(list,new String[][]{
					{"INT_TEL","dec_tel_no"}
        		  , {"INT_EML","dec_mail_addr"}
			});
			
			
			Box  box;//HashMap 
			for(int i=0; boxs!=null && i<boxs.size(); i++){//@2019-04-17
                box = boxs.get(i);
                
                //System.out.println("box dec_tel_no:"+box.get("dec_tel_no"));
                
				SysA020BG entity =  new SysA020BG();
				entity.setEmp_no(box.get("Emp_No"));
				entity.setKor_n(StringUtil.to8859_1(box.get("Kor_N")));
				entity.setDept_c(box.get("Dept_C"));
				entity.setAuth_pmsn(box.get("Auth_Pmsn"));
				entity.setIp_n(box.get("Ip_n"));
				entity.setLogin_d(box.get("Login_d"));
				entity.setPswd_no(box.get("Pswd_No"));
				entity.setUpdate_d(box.get("Update_d"));
				entity.setTel_no(box.get("Tel_No"));
				entity.setMail_addr(box.get("Mail_Addr"));
				entity.setProject_c(box.get("Project_c"));
				entity.setFavor_c(box.get("Favor_c"));
				entity.setUse_cnt(box.get("USE_CNT")); //2007.08.22 ߰
				
				
				//2016.09.07 ȣȭ 
				String dec_tel_no = "";
				entity.setDec_tel_no(box.get("dec_tel_no")); 
				entity.setDec_mail_addr(box.get("dec_mail_addr")); 

				//System.out.println("Bean dec_tel_no:::"+dec_tel_no);
				
				entity.setEnc_tel_no(box.get("Enc_Tel_No"));
				
                listData.add(entity);

            }
			
			if (listData.size() > 0) hashData.put("USERINFO",listData);
			
			
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:SysAllSLBean:selSysA020Main:SQLException] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:SysAllSLBean:selSysA020Main:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}//end of function	
	
	/** 
	  * <b>BASE2 User Information Է/ Լ</b>. 
	  * @param params SysA020BG User Info
	  * @return void
	  * @exception Exception
	  * @author Copyright (c) 2005/04/11 HIST 
	  */
	public void updSysA020Main(SysA020BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    boolean pswdT = false;
	    boolean pswdAuthT = false;
	   
	    try {
			//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//---------------------------------------------------------------------------------------
			//2007.08.23 ߰ :  ýۿ Admin  password 8ڸ ̻ Ǿ Ѵ.
			int aCnt = 0;
			
			stmt = conn.createStatement();
			sql = SysA020Query.getInstance().cntAdmin(params);
			rs = stmt.executeQuery(sql);
			if (rs.next()) aCnt = rs.getInt("ADMIN_CNT");
			
			int pswdLen = StringUtil.checkString(params.getPswd_no()).length();
			if (aCnt > 0 && (pswdLen > 0 &&  pswdLen < 8)) { 
				//aCnt 1 ̸̻  ýۿ Admin̹Ƿ йȣ 8ڸ ̻Ǿ.
				//йȣ 0ڸ ϶  (ο ڸ ϰų йȣ ʱȭ ִ ̹Ƿ)
				throw new BusinessException("ٸ ýۿ Admin̹Ƿ йȣ 8ڸ ̻ 10 ڸ Ǿ մϴ.");
	    	} 
			
			if (stmt != null) stmt.close();
			if (rs != null) rs.close();
			if (sql != null) sql = null;
			//---------------------------------------------------------------------------------------
			
			//Password_t  A ȸ
			stmt = conn.createStatement();
			sql = SysA020Query.getInstance().selPasswordT(params);
			rs = stmt.executeQuery(sql);
			String empNo = params.getEmp_no();// 2012.06.22 ߰
			String pswdNo = "";// 2012.06.22 ߰
			if (rs.next()){
				pswdT = true;
				pswdNo = rs.getString("PSWD_NO");// 2012.06.22 ߰
			}
			
			if (stmt != null) stmt.close();
			if (rs != null) rs.close();
			if (sql != null) sql = null;
						
			//Password_Auth_t  B ȸ
			stmt = conn.createStatement();
			sql = SysA020Query.getInstance().selPasswordAuthT(params);
			rs = stmt.executeQuery(sql);			
			//if (rs.next()) pswdAuthT = true;			
			while(rs!=null && rs.next()){//@2019-04-22
				if("BASE2".equals(rs.getString("PROJECT_C"))){
					pswdAuthT = true;
					break;
				}
			}
			
			if (stmt != null) stmt.close();
			if (rs != null) rs.close();
			if (sql != null) sql = null;
			
			Logger.debug.println("[User Info Update] Mode : "+params.getMode()+", Emp : "+params.getEmp_no()+", pswdT : "+pswdT+", pswdAuthT : "+pswdAuthT);
			
			//Auto Commit Mode False
			conn.setAutoCommit(false);
			
			//1. A,B    User  
			if (pswdT == true && pswdAuthT == true) {	
				Logger.debug.println(StringUtil.toKSC5601("1. A,B    User  "));
				if(empNo.equals("GUEST")&&!params.getPswd_no().equals(pswdNo)){
					throw new BusinessException("ش ID PWD   ϴ.");
				}
				//Password_t 
				stmt = conn.createStatement();
				sql = SysA020Query.getInstance().updPasswordT(params);
				int updPswd = stmt.executeUpdate(sql);
				if (updPswd != 1) throw new BusinessException("Password_t Update Exception");
				
				if (stmt != null) stmt.close();
				if (sql != null) sql = null;
				
				//Password_Auth_t 
				stmt = conn.createStatement();
				sql = SysA020Query.getInstance().updPasswordAuthT(params);
				int updPswdAuth = stmt.executeUpdate(sql);
				if (updPswdAuth != 1) throw new BusinessException("Password_Auth_t Update Exception");
				
				if (stmt != null) stmt.close();
				if (sql != null) sql = null;
			} 
			//2. A    User ű Է (Password_Auth_t)
			else if (pswdT == true && pswdAuthT == false) {
				Logger.debug.println(StringUtil.toKSC5601("2. A    User ű Է (Password_Auth_t)"));
				//Password_Auth_t Է
				stmt = conn.createStatement();
				sql = SysA020Query.getInstance().insPasswordAuthT(params);
				int insPswdAuth = stmt.executeUpdate(sql);
				if (insPswdAuth != 1) throw new BusinessException("Password_Auth_t Update Exception");
				
				if (stmt != null) stmt.close();
				if (sql != null) sql = null;
			}
			//3. A,B    User ű Է (Password_Auth_t,Password_t)
			else if (pswdT == false && pswdAuthT == false) {
				Logger.debug.println(StringUtil.toKSC5601("3. A,B    User ű Է (Password_Auth_t,Password_t)"));
				//Password_t Է
				stmt = conn.createStatement();
				sql = SysA020Query.getInstance().insPasswordT(params);
				int insPswd = stmt.executeUpdate(sql);
				if (insPswd != 1) throw new BusinessException("Password_t Update Exception");
				
				if (stmt != null) stmt.close();
				if (sql != null) sql = null;
				
				//Password_Auth_t Է
				stmt = conn.createStatement();
				sql = SysA020Query.getInstance().insPasswordAuthT(params);
				int insPswdAuth = stmt.executeUpdate(sql);
				if (insPswdAuth != 1) throw new BusinessException("Password_Auth_t Update Exception");
				
				if (stmt != null) stmt.close();
				if (sql != null) sql = null;
			} 
			//  
			else  throw new BusinessException("User Update Exception");
			
			//All Data Commit
			conn.commit();
			
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:SysAllSLBean:updSysA020Main:SQLException] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
	    } catch(BusinessException be) {
	    	Logger.debug.println("[BASE:SysAllSLBean:updSysA020Main:BusinessException] "+((BusinessException)be).getMessage());
			throw new BusinessException(be.getMessage());
		} catch(Exception e) {
			Logger.debug.println("[BASE:SysAllSLBean:updSysA020Main:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().UPDATE_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
	}//end of function	

	/** 
	  * <b>BASE2 User Information  Լ</b>. 
	  * @param params SysA020BG User Info
	  * @return void
	  * @exception Exception
	  * @author Copyright (c) 2005/04/11 HIST 
	  */
	public void delSysA020Main(SysA020BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    int authCnt = 0;
	   
	    try {
			//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			// Password_Auth_t Է Ǽ ȸ
			stmt = conn.createStatement();
			sql = SysA020Query.getInstance().selPswdAuthTCnt(params);
			rs = stmt.executeQuery(sql);
			if (rs.next()) authCnt = rs.getInt("Cnt");
			else throw new BusinessException("Password_Auth_t Count Exception");
			
			if (stmt != null) stmt.close();
			if (rs != null) rs.close();
			if (sql != null) sql = null;
			
			//Auto Commit Mode False
			conn.setAutoCommit(false);
			
			//Only Base    Ѵ
			if (authCnt == 1) {
				//Password_Auth_t   => 2008.05.29 : ٽ .
				stmt = conn.createStatement();
				sql = SysA020Query.getInstance().delPasswordT(params);
				int delT = stmt.executeUpdate(sql);
				if (delT != 1) throw new BusinessException("Password_T Delete Exception");
				
				if (stmt != null) stmt.close();
				if (sql != null) sql = null;
								
				//Password_Auth_t  
				stmt = conn.createStatement();
				sql = SysA020Query.getInstance().delPasswordAuthT(params);
				int delAuthT = stmt.executeUpdate(sql);
				if (delAuthT != 1) throw new BusinessException("Password_Auth_t Delete Exception");
				
				if (stmt != null) stmt.close();
				if (sql != null) sql = null;
			} else {
				//Password_Auth_t  
				stmt = conn.createStatement();
				sql = SysA020Query.getInstance().delPasswordAuthT(params);
				int delAuthT = stmt.executeUpdate(sql);
				if (delAuthT != 1) throw new BusinessException("Password_Auth_t Delete Exception");
				
				if (stmt != null) stmt.close();
				if (sql != null) sql = null;
			}
			
			//2007.07.24 ߰
			//User Information Ҷ Password_t  ȣ Project ϵǾ ִ  ȣ Project ش.
			String projectC = "";
			
			stmt = conn.createStatement();
			sql = SysA020Query.getInstance().selPasswordT(params);
			rs = stmt.executeQuery(sql);
			if (rs.next()) projectC = StringUtil.checkString(rs.getString("PROJECT_C"));
			
			if (stmt != null) stmt.close();
			if (rs != null) rs.close();
			if (sql != null) sql = null;
			
			if (projectC.equals("BASE2")) {
				//Password_t  PROJECT_C update ش.
				stmt = conn.createStatement();
				sql = SysA020Query.getInstance().updProjectC(params);
				int updPrjC = stmt.executeUpdate(sql);
				if (updPrjC != 1) throw new BusinessException("Project_c Update Exception");
				
				if (stmt != null) stmt.close();
				if (sql != null) sql = null;
			}
			
			//All Data Commit
			conn.commit();
			
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:SysAllSLBean:delSysA020Main:SQLException] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
	    } catch(BusinessException be) {
	    	Logger.debug.println("[BASE:SysAllSLBean:delSysA020Main:BusinessException] "+((BusinessException)be).getMessage());
			throw new BusinessException(be.getMessage());
		} catch(Exception e) {
			Logger.debug.println("[BASE:SysAllSLBean:delSysA020Main:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().UPDATE_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
	}//end of function	

	/** 
	  * Ȳ
	  * @param params SysQ010BG
	  * @return hashData Hashtable
	  * @exception Exception
	  * @author Copyright (c) 2006/03/30 
	  */
	public Hashtable selSysCode(SysQ010BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		PreparedStatement pstmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    Hashtable hashData = new Hashtable();
	   	List listData1 = new LinkedList();
	   	List listData2 = new LinkedList();	   	
	    
	    try {
			//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			sql = SysQ010Query.getInstance().selCode1(params);
			pstmt = conn.prepareStatement(sql);
			rs = pstmt.executeQuery();
			
			while (rs.next()) {
				SysQ010BG entity = new SysQ010BG();
				
				entity.setSkd_nm(StringUtil.checkString(rs.getString("SCHED_NM")));
				
				listData1.add(entity);
			}
			hashData.put("SKDTYPE1", listData1);
			
			if (pstmt != null) pstmt.close();
			if (rs != null) rs.close();
			if (sql != null) sql = null;
			
			//2008.05.07 ߰ :  ¥ ִ season sch_eff_dt, sch_dis_dt  ´.
			String oag = "";
			
			sql = SysQ010Query.getInstance().selTodayEffDis(params);
			pstmt = conn.prepareStatement(sql);
			rs = pstmt.executeQuery();
			
			if (rs.next()) {
				oag = StringUtil.checkString(rs.getString("oag"));
			}
			
			if (pstmt != null) pstmt.close();
			if (rs != null) rs.close();
			if (sql != null) sql = null;
			
			sql = SysQ010Query.getInstance().selCode2(params);
			pstmt = conn.prepareStatement(sql);
			rs = pstmt.executeQuery();
			
			while (rs.next()) {
				SysQ010BG entity = new SysQ010BG();
				
				if (StringUtil.checkString(rs.getString("SCHED_NM")).equals("OAG-SCHEDULE")) {
					entity.setSkd_nm(StringUtil.checkString(rs.getString("SCHED_NM")));
					entity.setPeriod(oag);
				} else {
					entity.setSkd_nm(StringUtil.checkString(rs.getString("SCHED_NM")));
					entity.setPeriod(StringUtil.checkString(rs.getString("period")));
				}
				
				listData2.add(entity);
			}
			hashData.put("SKDTYPE2", listData2);
			
			if (pstmt != null) pstmt.close();
			if (rs != null) rs.close();
			if (sql != null) sql = null;			
			
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:SysAllSLBean:selSysCode:Exception] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:SysAllSLBean:selSysCode:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (pstmt != null) try {pstmt.close();} catch(Exception e) {}
		}
		return hashData;
	}//end of function
	
	/** 
	  * Ȳ
	  * @param params SysQ010BG
	  * @return hashData Hashtable
	  * @exception Exception
	  * @author Copyright (c) 2006/03/30 
	  */
	public Hashtable selSysQ010Main1(SysQ010BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    Hashtable hashData = new Hashtable();
	    List listData = new LinkedList();
	   
	    try {
	   		//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			stmt = conn.createStatement();
			if (params.getCar().equals("KE") || params.getCar().equals("OZ")) {
				sql = SysQ010Query.getInstance().selMain3(params);
			}
			else {
				sql = SysQ010Query.getInstance().selMain4(params);				
			}								
			rs = stmt.executeQuery(sql);
			
			while (rs.next()) {
				SysQ010BG entity = new SysQ010BG();
				
				entity.setFlt_num(StringUtil.checkString(rs.getString("flt_num")));
				entity.setEff(StringUtil.checkString(rs.getString("eff")));
				entity.setExp(StringUtil.checkString(rs.getString("exp")));
				entity.setFreq(StringUtil.checkString(rs.getString("freq")));
				entity.setKactyp(StringUtil.checkString(rs.getString("kactyp")));
				entity.setSector(StringUtil.checkString(rs.getString("sector")));
				entity.setBlock(StringUtil.checkString(rs.getString("block")));
				entity.setStatus(StringUtil.checkString(rs.getString("status")));
				entity.setIntdom(StringUtil.checkString(rs.getString("intdom")));
				entity.setOprnowner(StringUtil.checkString(rs.getString("oprnowner")));			
				entity.setMarketcarriers(StringUtil.checkString(rs.getString("marketcarriers")));
				entity.setDistkm(StringUtil.checkString(rs.getString("distkm")));

				listData.add(entity);
			}

			hashData.put("SYSLIST",listData);
			
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:SysAllSLBean:selSysQ010Main:Exception] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:SysAllSLBean:selSysQ010Main:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}//end of function

	/** 
	  * Ȳ
	  * @param params SysQ010BG
	  * @return hashData Hashtable
	  * @exception Exception
	  * @author Copyright (c) 2006/03/30 
	  */
	public Hashtable selSysQ010Main2(SysQ010BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    Hashtable hashData = new Hashtable();
	    List listData = new LinkedList();
	   
	    try {
	   		//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			stmt = conn.createStatement();
			if (params.getCar().equals("ALL")) {
					
				/*params.setCar("KE");
				sql = SysQ010Query.getInstance().selMain5(params);				
				rs = stmt.executeQuery(sql);
				
				while (rs.next()) {
					SysQ010BG entity = new SysQ010BG();
				
					entity.setFlt_num(StringUtil.checkString(rs.getString("flt_num")));
					entity.setEff(StringUtil.checkString(rs.getString("eff")));
					entity.setExp(StringUtil.checkString(rs.getString("exp")));
					entity.setFreq(StringUtil.checkString(rs.getString("freq")));
					entity.setKactyp(StringUtil.checkString(rs.getString("kactyp")));
					entity.setSector(StringUtil.checkString(rs.getString("sector")));
					entity.setBlock(StringUtil.checkString(rs.getString("block")));
					entity.setStatus(StringUtil.checkString(rs.getString("status")));
					entity.setIntdom(StringUtil.checkString(rs.getString("intdom")));
					entity.setOprnowner(StringUtil.checkString(rs.getString("oprnowner")));			
					entity.setMarketcarriers(StringUtil.checkString(rs.getString("marketcarriers")));
					entity.setDistkm(StringUtil.checkString(rs.getString("distkm")));
	
					listData.add(entity);
				}

				params.setCar("CS");
				sql = SysQ010Query.getInstance().selMain6(params);				
				rs = stmt.executeQuery(sql);
				
				while (rs.next()) {
					SysQ010BG entity = new SysQ010BG();
				
					entity.setFlt_num(StringUtil.checkString(rs.getString("flt_num")));
					entity.setEff(StringUtil.checkString(rs.getString("eff")));
					entity.setExp(StringUtil.checkString(rs.getString("exp")));
					entity.setFreq(StringUtil.checkString(rs.getString("freq")));
					entity.setKactyp(StringUtil.checkString(rs.getString("kactyp")));
					entity.setSector(StringUtil.checkString(rs.getString("sector")));
					entity.setBlock(StringUtil.checkString(rs.getString("block")));
					entity.setStatus(StringUtil.checkString(rs.getString("status")));
					entity.setIntdom(StringUtil.checkString(rs.getString("intdom")));
					entity.setOprnowner(StringUtil.checkString(rs.getString("oprnowner")));			
					entity.setMarketcarriers(StringUtil.checkString(rs.getString("marketcarriers")));
					entity.setDistkm(StringUtil.checkString(rs.getString("distkm")));
	
					listData.add(entity);
				}

				params.setCar("OZ");
				sql = SysQ010Query.getInstance().selMain5(params);				
				rs = stmt.executeQuery(sql);
				
				while (rs.next()) {
					SysQ010BG entity = new SysQ010BG();
				
					entity.setFlt_num(StringUtil.checkString(rs.getString("flt_num")));
					entity.setEff(StringUtil.checkString(rs.getString("eff")));
					entity.setExp(StringUtil.checkString(rs.getString("exp")));
					entity.setFreq(StringUtil.checkString(rs.getString("freq")));
					entity.setKactyp(StringUtil.checkString(rs.getString("kactyp")));
					entity.setSector(StringUtil.checkString(rs.getString("sector")));
					entity.setBlock(StringUtil.checkString(rs.getString("block")));
					entity.setStatus(StringUtil.checkString(rs.getString("status")));
					entity.setIntdom(StringUtil.checkString(rs.getString("intdom")));
					entity.setOprnowner(StringUtil.checkString(rs.getString("oprnowner")));			
					entity.setMarketcarriers(StringUtil.checkString(rs.getString("marketcarriers")));
					entity.setDistkm(StringUtil.checkString(rs.getString("distkm")));
	
					listData.add(entity);
				}*/
				
				//2008.06.10 
				sql = SysQ010Query.getInstance().selMain7(params);				
				rs = stmt.executeQuery(sql);
				
				while (rs.next()) {
					SysQ010BG entity = new SysQ010BG();
				
					entity.setFlt_num(StringUtil.checkString(rs.getString("flt_num")));
					entity.setEff(StringUtil.checkString(rs.getString("eff")));
					entity.setExp(StringUtil.checkString(rs.getString("exp")));
					entity.setFreq(StringUtil.checkString(rs.getString("freq")));
					entity.setKactyp(StringUtil.checkString(rs.getString("kactyp")));
					entity.setSector(StringUtil.checkString(rs.getString("sector")));
					entity.setBlock(StringUtil.checkString(rs.getString("block")));
					entity.setStatus(StringUtil.checkString(rs.getString("status")));
					entity.setIntdom(StringUtil.checkString(rs.getString("intdom")));
					entity.setOprnowner(StringUtil.checkString(rs.getString("oprnowner")));			
					entity.setMarketcarriers(StringUtil.checkString(rs.getString("marketcarriers")));
					entity.setDistkm(StringUtil.checkString(rs.getString("distkm")));
	
					listData.add(entity);
				}
				
			}				
			else {
				if (params.getCar().equals("KE") || params.getCar().equals("OZ")) {
					sql = SysQ010Query.getInstance().selMain5(params);
				}
				else {			
					sql = SysQ010Query.getInstance().selMain6(params);
				}								
				rs = stmt.executeQuery(sql);
				
				while (rs.next()) {
					SysQ010BG entity = new SysQ010BG();
					
				
					entity.setFlt_num(StringUtil.checkString(rs.getString("flt_num")));
					entity.setEff(StringUtil.checkString(rs.getString("eff")));
					entity.setExp(StringUtil.checkString(rs.getString("exp")));
					entity.setFreq(StringUtil.checkString(rs.getString("freq")));
					entity.setKactyp(StringUtil.checkString(rs.getString("kactyp")));
					entity.setSector(StringUtil.checkString(rs.getString("sector")));
					entity.setBlock(StringUtil.checkString(rs.getString("block")));
					entity.setStatus(StringUtil.checkString(rs.getString("status")));
					entity.setIntdom(StringUtil.checkString(rs.getString("intdom")));
					entity.setOprnowner(StringUtil.checkString(rs.getString("oprnowner")));			
					entity.setMarketcarriers(StringUtil.checkString(rs.getString("marketcarriers")));
					entity.setDistkm(StringUtil.checkString(rs.getString("distkm")));
	
					listData.add(entity);
				}
			}	
			hashData.put("SYSLIST",listData);
			
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:SysAllSLBean:selSysQ010Main:Exception] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:SysAllSLBean:selSysQ010Main:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}//end of function
				
	/** 
	  * Ȳ
	  * @param params SysQ120BG 
	  * @return void
	  * @exception Exception
	  * @author Copyright (c) 2006/04/07 
	  */
	public SysQ120BG selSysQ120Main(SysQ120BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    SysQ120BG entity = null;
	   
	    try {
			//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//̵ Ǿ ==> KALMAN
			if (!params.getExeId().equals("KALMAN")) throw new BusinessException("̵ ƲȽϴ.");
			
			//Password_t йȣ ȸ ==> KALE0001
			stmt = conn.createStatement();
			sql = SysQ120Query.getInstance().selMain(params);
			rs = stmt.executeQuery(sql);
			
			if (rs.next()) {
				if (!StringUtil.checkString(rs.getString("PSWD_NO")).equals(params.getExePw())) {
					throw new BusinessException("йȣ ƲȽϴ.");
				} else {
					entity = new SysQ120BG();
					entity.setSesId(StringUtil.checkString(rs.getString("EMP_NO")));
					entity.setSesPw(StringUtil.checkString(rs.getString("PSWD_NO")));
				}
			}
			
			if (stmt != null) stmt.close();
			if (rs != null) rs.close();
			if (sql != null) sql = null;
			
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:SysAllSLBean:selSysQ120Main:SQLException] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
	    } catch(BusinessException be) {
			Logger.debug.println("[BASE:SysAllSLBean:selSysQ120Main:BusinessException] "+((BusinessException)be).getMessage());
			throw new BusinessException(((BusinessException)be).getMessage());
		} catch(Exception e) {
			Logger.debug.println("[BASE:SysAllSLBean:selSysQ120Main:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().UPDATE_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return entity;
	}//end of function	
	
	/** 
	  * PASSWORD_AUTH_T  Random Code Է/ Լ.
	  * @return String returnValue
	  * @exception Exception
	  * @author Copyright (c) 2007/12/21 
	  */
	public String updRndmCd(String empNo, String projectC, String rndmCd) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
		String sql = null;
	    
		//Return ü
		String returnValue = "";
	    
		try {
			//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//Auto Commit Mode False
			conn.setAutoCommit(false);
			
			//Random Code Update
			stmt = conn.createStatement();
			sql = SysA010Query.getInstance().updRndmCd(empNo, projectC, rndmCd);
			int updCnt = stmt.executeUpdate(sql);
			
			if (updCnt != 1) returnValue = "N";
			else returnValue = "Y";
			
			//All Data Commit
			conn.commit();
			
		} catch (SQLException se) {
			if (conn != null) try { conn.rollback(); } catch (Exception e) {}
			Logger.debug.println("[BASE:SysAllSLBean:updRndmCd:SQLException] " + ((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch (Exception e) {
			if (conn != null) try { conn.rollback(); } catch (Exception ce) {}
			Logger.debug.println("[BASE:SysAllSLBean:updRndmCd:Exception] " + ((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().UPDATE_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if (cr != null) try { cr.release(); } catch (Exception e) {}
			if (conn != null) try { conn.close(); } catch (Exception e) {}
			if (rs != null) try { rs.close(); } catch (Exception e) {}
			if (stmt != null) try { stmt.close(); } catch (Exception e) {}
		}
		return returnValue;
	}//end of function
	
	/** 
	  * PASSWORD_AUTH_T Random Code ȸ Լ.
	  * @return String returnValue
	  * @exception Exception
	  * @author Copyright (c) 2007/12/21 
	  */
	public String selRndmCd(String empNo, String projectC) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
		String sql = null;
	    
		//Return ü
		String returnValue = "";
	    
		try {
			//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//Random Code ȸ
			stmt = conn.createStatement();
			sql = SysA010Query.getInstance().selRndmCd(empNo, projectC);
			rs = stmt.executeQuery(sql);
			
			if (rs.next()) returnValue = StringUtil.checkString(rs.getString("RANDOM_C"));
			
		} catch (SQLException se) {
			if (conn != null) try { conn.rollback(); } catch (Exception e) {}
			Logger.debug.println("[BASE:SysAllSLBean:selRndmCd:SQLException] " + ((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch (Exception e) {
			if (conn != null) try { conn.rollback(); } catch (Exception ce) {}
			Logger.debug.println("[BASE:SysAllSLBean:selRndmCd:Exception] " + ((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().UPDATE_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if (cr != null) try { cr.release(); } catch (Exception e) {}
			if (conn != null) try { conn.close(); } catch (Exception e) {}
			if (rs != null) try { rs.close(); } catch (Exception e) {}
			if (stmt != null) try { stmt.close(); } catch (Exception e) {}
		}
		return returnValue;
	}//end of function
	
	/** 
	  * CMPS.T_USR ̺ TEL4_N  ִ Random Code  Է/ Լ.
	  * @return String returnValue
	  * @exception Exception
	  * @author Copyright (c) 2008/11/26 
	  */
	public String updTusrRndmCd(String emp_n, String rndmCd) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
		String sql = null;
	    
		//Return ü
		String returnValue = "";
	    
		try {
			//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//Auto Commit Mode False
			conn.setAutoCommit(false);
			
			//T_USR ̺ Random Code Update
			stmt = conn.createStatement();
			sql = " UPDATE T_USR SET TEL4_N = '" + rndmCd + "' WHERE EMP_N = '" + emp_n + "' ";
			
			System.out.println("updTusrRndmCd [sql] : " + sql);
			
			int updCnt = stmt.executeUpdate(sql);
			
			if (updCnt != 1) returnValue = "N";
			else returnValue = "Y";
			
			//All Data Commit
			conn.commit();
			
		} catch (SQLException se) {
			if (conn != null) try { conn.rollback(); } catch (Exception e) {}
			Logger.debug.println("[BASE:SysAllSLBean:updTusrRndmCd:SQLException] " + ((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch (Exception e) {
			if (conn != null) try { conn.rollback(); } catch (Exception ce) {}
			Logger.debug.println("[BASE:SysAllSLBean:updTusrRndmCd:Exception] " + ((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().UPDATE_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if (cr != null) try { cr.release(); } catch (Exception e) {}
			if (conn != null) try { conn.close(); } catch (Exception e) {}
			if (rs != null) try { rs.close(); } catch (Exception e) {}
			if (stmt != null) try { stmt.close(); } catch (Exception e) {}
		}
		return returnValue;
	}//end of function
	
	/** 
	  * CMPS.T_USR ̺ TEL4_N  ִ Random Code  ȸ Լ.
	  * @return String returnValue
	  * @exception Exception
	  * @author Copyright (c) 2008/11/26 
	  */
	public String selTusrRndmCd(String emp_n) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
		String sql = null;
	    
		//Return ü
		String returnValue = "";
	    
		try {
			//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//T_USR ̺ Random Code ȸ
			stmt = conn.createStatement();
			sql = " SELECT TEL4_N FROM T_USR WHERE EMP_N = '" + emp_n + "' ";
			
			System.out.println("selTusrRndmCd [sql] : " + sql);
			
			rs = stmt.executeQuery(sql);
			
			if (rs.next()) returnValue = StringUtil.checkString(rs.getString("TEL4_N"));
			
		} catch (SQLException se) {
			if (conn != null) try { conn.rollback(); } catch (Exception e) {}
			Logger.debug.println("[BASE:SysAllSLBean:selTusrRndmCd:SQLException] " + ((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch (Exception e) {
			if (conn != null) try { conn.rollback(); } catch (Exception ce) {}
			Logger.debug.println("[BASE:SysAllSLBean:selTusrRndmCd:Exception] " + ((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().UPDATE_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if (cr != null) try { cr.release(); } catch (Exception e) {}
			if (conn != null) try { conn.close(); } catch (Exception e) {}
			if (rs != null) try { rs.close(); } catch (Exception e) {}
			if (stmt != null) try { stmt.close(); } catch (Exception e) {}
		}
		return returnValue;
	}//end of function
	
	public SysA020BG selSysPasswordT(SysA020BG params) throws BusinessException {//@2019-04-17
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
		String sql = null;

		//Return ü
		SysA020BG entity =  new SysA020BG();
		try {
			//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//User Info ȸ
			stmt = conn.createStatement();
			sql = SysA020Query.getInstance().selPasswordT(params);
			rs = stmt.executeQuery(sql);
			String empNo = params.getEmp_no();
			String pswdNo = "";
			if (rs!=null && rs.next()){
				String	encMailAddr = StringUtil.checkString(rs.getString("ENC_MAIL_ADDR"));
				String	encTelNo = StringUtil.checkString(rs.getString("ENC_TEL_NO"));
				if(encMailAddr.length()!=0){
					entity.setDec_mail_addr(SecurityUtil.self.decrypt(encMailAddr,"INT_EML"));
				}
				if(encTelNo.length()!=0){
					entity.setDec_tel_no(SecurityUtil.self.decrypt(encTelNo,"INT_TEL"));
				}

				entity.setEmp_no(empNo);
				//entity.setKor_n(StringUtil.to8859_1(rs.getString("KOR_N")));
				entity.setKor_n(rs.getString("KOR_N"));
				entity.setDept_c(rs.getString("DEPT_C"));
				entity.setProject_c(rs.getString("PROJECT_C"));

			}
			
			if (stmt != null) stmt.close();
			if (rs != null) rs.close();
			if (sql != null) sql = null;		
			
		} catch(SQLException se) {
			Logger.debug.println("[BASE:SysAllSLBean:selSysPasswordT:SQLException] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:SysAllSLBean:selSysPasswordT:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return entity;
	}//end of function	
	
}//end of class