package kal.base.com.serv;

import java.util.*;
import kal.base.jdf.com.Logger;
import kal.base.com.ejb.*;
import kal.base.iro.ejb.*;
import kal.base.com.util.*;
import kal.base.sup.ejb.*;
import kal.base.sup.dbbean.*;
import kal.base.jdf.ejb.*;
import javax.servlet.http.HttpServletRequest;

/**
 *  ȸ Լ .
 * @author Copyright (c) 2005 HIST 
 */
public class ComUtil {

	/**
	 * <b>ComUtil Instance</b>
	 * @author Copyright (c) 2005 HIST 
	 */
	private static ComUtil instance = null;
	
	/**
	 * <b>CodeUtil Instanceȹ</b>
	 * @author Copyright (c) 2005 HIST 
	 */
	public static ComUtil getInstance() {
		if(instance==null)
			instance = new ComUtil();
		return instance;
	}
	
	/**
	 * <b> DB ð ȸ SQLԼ.</b>
	 * @param format String Return Date Format  ex) YYYYMMDD
     * @param setTime String  ð ex) GMT : 540/1440   KST : 0
	 * @return String ȸ DB Time
	 * @exception Exception
	 * @author Copyright (c) 2005 HIST 
	 */
	public static String selDbTime(String format,String setTime) throws Exception {
		try {
			ComAllSL sl = (ComAllSL)EJBFinder.lookup("ejb/ComAllSL");
			String dbTime = sl.selDbTime(format,setTime);

			return dbTime;
		} catch(Exception e) {
			e.printStackTrace();
			if(e instanceof Exception) {
				throw new Exception(e.getMessage());
			} else {
				throw new Exception(MessageCode.getInstance().ETC_EXPT);
			}
		}
	}//end of function
	
	/**
	 * <b>DB Table ȸ Լ.</b>
	 * @param arrParam String[] ȸ  [0]SELECT [1]TABLE 
	 * [2]WHERE [3]ORDERBY [4]SELECT
	 * @return List ȸ Data
	 * @exception Exception
	 * @author Copyright (c) 2005 HIST 
	 */
	public static List selDbTable(String[] arrParam) throws Exception {
		try {
			ComAllSL sl = (ComAllSL)EJBFinder.lookup("ejb/ComAllSL");
			//listData ȿ listRow ִ.
			List listData = sl.selDbTable(arrParam);

			return listData;
		} catch(Exception e) {
			if(e instanceof Exception) {
				throw new Exception(e.getMessage());
			} else {
				throw new Exception(MessageCode.getInstance().ETC_EXPT);
			}
		}
	}//end of function
	
	/**
	 * <b>Sucess Message </b>
	 * @param pgmID String Program 
	 * @param hashData Hashtable ȸ
	 * @param hashKey String Hashtable Key
	 * @param fMsg String Message Footer
	 * @param msgFooter ȸ  ޼
	 * @return String Message Header
	 * @exception ApplicationException
	 * @author Copyright (c) 2005 HIST 
	 */
	public static String getMessage(String pgmID, Hashtable hashData, String hashKey, String fMsg) throws Exception {
		try {
			String hMsg = null;			
			ComAllSL sl = (ComAllSL)EJBFinder.lookup("ejb/ComAllSL");
			String dbTime = sl.selDbTime("MM/DD HH24:MI:SS","0");
			
			if (hashData == null) {
				hMsg = "["+pgmID+" | "+dbTime+"] "+fMsg;
			} else {
				long dataCnt = StringUtil.hashCount(hashData,hashKey);
				if (dataCnt == 0) hMsg = "["+pgmID+" | "+dbTime+"] "+MessageCode.getInstance().NULLDATA_MSG;
				else hMsg = "["+pgmID+" | "+dbTime+"] "+dataCnt+MessageCode.getInstance().DATA_MSG;
			}

			return hMsg;
		} catch(Exception e) {
			if(e instanceof Exception) {
				throw new Exception(e.getMessage());
			} else {
				throw new Exception(MessageCode.getInstance().ETC_EXPT);
			}
		}
	}	

	/**
	 * <b>ACTYP ȸ Լ.</b>
	 * @return Vector ȸ Data
	 * @exception Exception
	 * @author Copyright (c) 2005 HIST 
	 */
	public static Vector selActyp() throws Exception {
		try {
			ComAllSL sl = (ComAllSL)EJBFinder.lookup("ejb/ComAllSL");
			Vector vtData = sl.selActyp();

			return vtData;
		} catch(Exception e) {
			if(e instanceof Exception) {
				throw new Exception(e.getMessage());
			} else {
				throw new Exception(MessageCode.getInstance().ETC_EXPT);
			}
		}
	}//end of function	
	
	/**
	 * <b>Desk Description ȸ Լ.</b>
	 * @param String descE Desk_Code
	 * @return Vector ȸ Data
	 * @exception Exception
	 * @author Copyright (c) 2005 HIST 
	 */
	public static String selDesk(String deskX) throws Exception {
		try {
			ComAllSL sl = (ComAllSL)EJBFinder.lookup("ejb/ComAllSL");
			String codeX = sl.selDesk(deskX);

			return codeX;
		} catch(Exception e) {
			if(e instanceof Exception) {
				throw new Exception(e.getMessage());
			} else {
				throw new Exception(MessageCode.getInstance().ETC_EXPT);
			}
		}
	}//end of function
	
	/**
	 * <b>FTS  ȸԼ.</b>
	 * @param empNo String USER ID
	 * @return String ȸ FTS 
	 * @exception Exception
	 * @author Copyright (c) 2005 HIST 
	 */
	public static String selFtsAuth(String empNo) throws Exception {
		try {
			ComAllSL sl = (ComAllSL)EJBFinder.lookup("ejb/ComAllSL");
			String authPmsn = StringUtil.checkString(sl.selFtsAuth(empNo));

			return authPmsn;
		} catch(Exception e) {
			if(e instanceof Exception) {
				throw new Exception(e.getMessage());
			} else {
				throw new Exception(MessageCode.getInstance().ETC_EXPT);
			}
		}
	}//end of function	
	
	/**
	 * <b>FTS Menu ȸԼ.</b>
	 * @return Hashtable ȸ FTS Menu
	 * @exception Exception
	 * @author Copyright (c) 2005 HIST 
	 */
	public static Hashtable selFtsMenu() throws Exception {
		try {
			ComAllSL sl = (ComAllSL)EJBFinder.lookup("ejb/ComAllSL");
			Hashtable hashData = sl.selFtsMenu();
			
			return hashData;
		} catch(Exception e) {
			if(e instanceof Exception) {
				throw new Exception(e.getMessage());
			} else {
				throw new Exception(MessageCode.getInstance().ETC_EXPT);
			}
		}
	}//end of function
	
	/**
	 * <b>Region Flight ȸԼ.</b>
	 * @param fltNum String Flight Number
	 * @return String ȸ Region Flight Code
	 * @exception Exception
	 * @author Copyright (c) 2005 HIST 
	 */
	public static String getRegionFlt(String fltNum) throws Exception {
		try {
			ComAllSL sl = (ComAllSL)EJBFinder.lookup("ejb/ComAllSL");
			String regionFlt = StringUtil.checkString(sl.getRegionFlt(fltNum));

			return regionFlt;
		} catch(Exception e) {
			if(e instanceof Exception) {
				throw new Exception(e.getMessage());
			} else {
				throw new Exception(MessageCode.getInstance().ETC_EXPT);
			}
		}
	}//end of function		
	
	/**
	 * <b>Region X  ȸԼ.</b>
	 * @param stnFr String  Station From
	  * @param stnTo String  Station To
	 * @return String ȸ Region X Code
	 * @exception Exception
	 * @author Copyright (c) 2005 HIST 
	 */
	public static String getRegionX(String stnFr, String stnTo) throws Exception {
		try {
			ComAllSL sl = (ComAllSL)EJBFinder.lookup("ejb/ComAllSL");
			String regionX = StringUtil.checkString(sl.getRegionX(stnFr,stnTo));

			return regionX;
		} catch(Exception e) {
			if(e instanceof Exception) {
				throw new Exception(e.getMessage());
			} else {
				throw new Exception(MessageCode.getInstance().ETC_EXPT);
			}
		}
	}//end of function	
	
	/**
	 * <b>IP Check Լ.</b>
	 * @param arrIP String[]  IP Code
	 * @return boolean  
	 * @exception Exception
	 * @author Copyright (c) 2005 HIST 
	 */
	public static boolean selIpCheck(String[] arrIP) throws Exception {
		try {
			ComAllSL sl = (ComAllSL)EJBFinder.lookup("ejb/ComAllSL");
			boolean ipFlag = sl.selIpCheck(arrIP);

			return ipFlag;
		} catch(Exception e) {
			if(e instanceof Exception) {
				throw new Exception(e.getMessage());
			} else {
				throw new Exception(MessageCode.getInstance().ETC_EXPT);
			}
		}
	}//end of function	

	/**
	 * <b>OLD NOTAM ȸԼ.</b>
	 * @param icaoPort String ICAO STN
	 * @param notNum String Old NOTAM Number
	 * @return SupA110BG ȸ Data
	 * @exception Exception
	 * @author Copyright (c) 2005 HIST 
	 */
	public static SupA110BG selOldNOTAM(String icaoPort, String notNum) throws Exception {
		try {
			SupAllSL sl = (SupAllSL)EJBFinder.lookup("ejb/SupAllSL");
			SupA110BG entity = sl.selOldNOTAM(icaoPort,notNum);

			return entity;
		} catch(Exception e) {
			if(e instanceof Exception) {
				throw new Exception(e.getMessage());
			} else {
				throw new Exception(MessageCode.getInstance().ETC_EXPT);
			}
		}
	}//end of function
	
	/**
	 * <b>Station Information ȸԼ.</b>
	 * @param airport String Airport Code [ICAO,IATA]
	 * @return Hashtable ȸ Data
	 * @exception Exception
	 * @author Copyright (c) 2005 HIST 
	 */
	public static Hashtable selStnInfo(String airport) throws Exception {
		try {
			SupA610BG params = new SupA610BG();
			params.setAirport(airport);
			
			//EJB LookUp
			SupAllSL sl = (SupAllSL)EJBFinder.lookup("ejb/SupAllSL");
			Hashtable hashData  = sl.selSupA610Main(params);

			return hashData;
		} catch(Exception e) {
			if(e instanceof Exception) {
				throw new Exception(e.getMessage());
			} else {
				throw new Exception(MessageCode.getInstance().ETC_EXPT);
			}
		}
	}//end of function	
	
	/**
	 * <b>Area Code ȸ Լ.</b>
	 * @return List ȸ Data
	 * @exception Exception
	 * @author Copyright (c) 2005 HIST 
	 */
	public static List selAreaList(String mode) throws Exception {
		try {
			ComAllSL sl = (ComAllSL)EJBFinder.lookup("ejb/ComAllSL");
			List listData = sl.selAreaList(mode);

			return listData;
		} catch(Exception e) {
			if(e instanceof Exception) {
				throw new Exception(e.getMessage());
			} else {
				throw new Exception(MessageCode.getInstance().ETC_EXPT);
			}
		}
	}//end of function	
	
	/**
	 * <b>WX Condition Code ȸ Լ.</b>
	 * @return List ȸ Data
	 * @exception Exception
	 * @author Copyright (c) 2005 HIST 
	 */
	public static List selWxCondList() throws Exception {
		try {
			SupA330BG params = new SupA330BG();
			SupAllSL sl = (SupAllSL)EJBFinder.lookup("ejb/SupAllSL");
			Hashtable hashData = sl.selAreaWxCond(params);
			List listData = (List)hashData.get("WX_COND");

			return listData;
		} catch(Exception e) {
			if(e instanceof Exception) {
				throw new Exception(e.getMessage());
			} else {
				throw new Exception(MessageCode.getInstance().ETC_EXPT);
			}
		}
	}//end of function	
	
	
	/**
	 * FFS  CODE_T ȸ
	 * @return String
	 * @exception Exception
	 * @author Copyright (c) 2008/12/01 
	 */
	public static String getNaiRange() throws Exception {
		try {
			ComAllSL sl = (ComAllSL)EJBFinder.lookup("ejb/ComAllSL");
			String returnValue = sl.getNaiRange();

			return returnValue;
		} catch(Exception e) {
			if(e instanceof Exception) {
				throw new Exception(e.getMessage());
			} else {
				throw new Exception(MessageCode.getInstance().SELECT_EXPT);
			}
		}
	}//end of function	
	
	public static String sendMailFax(String host, String from,String[] to,String subject,String content) throws Exception {
		try {
			ComAllSL sl = (ComAllSL)EJBFinder.lookup("ejb/ComAllSL");
			String flagMail = StringUtil.checkString(sl.sendMail(host,from,to,subject,content));

			return flagMail;
		} catch(Exception e) {
			if(e instanceof Exception) {
				throw new Exception(e.getMessage());
			} else {
				throw new Exception(MessageCode.getInstance().ETC_EXPT);
			}
		}
	}//end of function	
	
	/**
	 * IROPS/DSS Option Comparision Title ȸ
	 * @return String
	 * @exception Exception
	 * @author Copyright (c) 2009/07/30 
	 */
	public static String getTitleE(String dssStartDt, String seqNum) throws Exception {
		try {
			IroAllSL sl = (IroAllSL)EJBFinder.lookup("ejb/IroAllSL");
			String returnValue = sl.selIroA320TitleE(dssStartDt, seqNum);

			return returnValue;
		} catch(Exception e) {
			if(e instanceof Exception) {
				throw new Exception(e.getMessage());
			} else {
				throw new Exception(MessageCode.getInstance().SELECT_EXPT);
			}
		}
	}//end of function
	
	/**
	 * IROPS ̹ ŸƲ ȸ
	 * @return String
	 * @exception Exception
	 * @author Copyright (c) 2012/01/15 
	 */
	public static ArrayList getIropsImgTitles() throws Exception {
		try{
			ComAllSL sl = (ComAllSL)EJBFinder.lookup("ejb/ComAllSL");
			Hashtable hashData = sl.selIropsImgTitles();
			
			ArrayList listData = (ArrayList)hashData.get("listTitle");
			
			return listData;
		}catch(Exception e){
			if(e instanceof Exception){
				throw new Exception(e.getMessage());
			}else{
				throw new Exception(MessageCode.getInstance().SELECT_EXPT);
			}
		}
	}//end of function
	
}//end of class
