package kal.base.ffs.daemon;
/*	=====================================================================================
@Author				:	v.bgkim@kalmate.net
@Create				:	2014-05-20
@File ID					:	FfsDataDaemon
@Purpose				:	
	=====================================================================================	*/
import java.util.Date;
import java.util.HashMap;
import java.util.Timer;
import java.util.TimerTask;

import kal.base.ffs.ejb.FfsAllSL;
import kal.base.jdf.com.BaseLoggerWriter;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;

public class FfsDataDaemon{
	/*-------------------------------------------------------------------	Field	
	----------------------------------------------------------------------	*/
	private	HashMap<String,Timer>				timerMap			=	new HashMap<String,Timer>(10);

	public	HashMap				beforeReleaseMap				=	new HashMap();//new HashMap<Integer,EntityData>(10);
	public	HashMap				releasedMap							=	new HashMap();//new HashMap<Integer,EntityData>(10);
	public	HashMap				enrouteMap							=	new HashMap();//new HashMap<Integer,EntityData>(10);
	public	HashMap				enrouteDetailMap				=	new HashMap();//new HashMap<Integer,EntityData>(10);
	public	HashMap				landedMap							=	new HashMap();//new HashMap<Integer,EntityData>(10);
	

	public	HashMap				beforeReleaseAlertMap		=	new HashMap();//new HashMap<Integer,EntityData>(10);
	public	HashMap				releasedAlertMap				=	new HashMap();//new HashMap<Integer,EntityData>(10);
	public	HashMap				enrouteAlertMap					=	new HashMap();//new HashMap<Integer,EntityData>(10);
	
	//20160415 ߰
	public	HashMap				beforeReleaseRevMap				=	new HashMap();
	public	HashMap				releasedRevMap					=	new HashMap();
	public	HashMap				enrouteRevMap					=	new HashMap();
	public	HashMap				landedRevMap					=	new HashMap();
	
	/*-------------------------------------------------------------------	Constructor	Singleton
	----------------------------------------------------------------------	*/
	public static FfsDataDaemon self = FfsDataDaemon.getInstance();	
	private static FfsDataDaemon getInstance(){return new FfsDataDaemon();}	
	private FfsDataDaemon(){
		debugPrint("Constructor","FfsDataDaemon");
	}
	/*-------------------------------------------------------------------	debugPrint
	----------------------------------------------------------------------	*/	
	protected void debugPrint(String title, String value){
		Logger.debug.println("[FfsDataDaemon.debugPrint.String]	===========	"+(title==null?"no title":title)+"	 : "+(value==null?"no value":value));
	}
	/*-------------------------------------------------------------------	isValid
	----------------------------------------------------------------------	*/
	public boolean isValid(String jobName){
		return timerMap.containsKey(jobName);
	}
	/*-------------------------------------------------------------------	about Timer
	----------------------------------------------------------------------	*/	
	public Timer getTimer(String jobName){
		Timer	timer	=	null;
		try{
			if(jobName!=null){
				timer	=	timerMap.get(jobName);
			}
		}catch(Exception e){
			debugPrint("getTimer.Exception",e.toString());
		}
		return timer;
	}	
	public void setTimer(String jobName){
		setTimer(jobName,60);
	}
	public void setTimer(String jobName, int second){
		try{
			if(	getTimer(jobName)==null  && 0<second){
				FfsTask		ffsTask	=	new FfsTask(jobName);

				debugPrint("setTimer.ffsTask",""+ffsTask.valid);
				if(ffsTask!=null && ffsTask.valid){
					Timer timer			=	new Timer();					
					timer.scheduleAtFixedRate(ffsTask,0,second*1000);
					timerMap.put(jobName,timer);
					debugPrint("Timer Start",jobName);
				}
			}
		}catch(Exception e){
			debugPrint("setTimer.Exception",e.toString());
		}
	}
	public void removeTimer(String jobName){
		try{
			Timer	timer			=	getTimer(jobName);
			if(timer!=null){
				timer.cancel();
				timer.purge();
				timerMap.remove(jobName);
				debugPrint("Timer remove",jobName);
			}
		}catch(Exception e){
			debugPrint("removeTimer.Exception",e.toString());
		}
	}
	/*-------------------------------------------------------------------	about Task
	----------------------------------------------------------------------	*/	
	protected class FfsTask extends TimerTask{
		public boolean valid	=	false;
		private String jobName	=	null;
		public FfsTask(String jobName){
			super();
			this.jobName	=	jobName;
			this.run();
		}
		public void run(){
			try{
				FfsAllSL	sl									=	(FfsAllSL)EJBFinder.lookup("ejb/FfsAllSL");

				if("beforeRelease".equals(jobName)){
					FfsDataDaemon.self.beforeReleaseMap				=	sl.allNotReleased();
					FfsDataDaemon.self.beforeReleaseAlertMap		= sl.selAlertRule("1");
					 valid	=	true;

					//20150629 ߰
					//20150827  released  αϵ 
					/*
					if(FfsDataDaemon.self.beforeReleaseMap != null) {
						BaseLoggerWriter.getInstance().updateLog("beforeRelease excute - map size:" + String.valueOf(FfsDataDaemon.self.beforeReleaseMap.size()));
					} else {
						BaseLoggerWriter.getInstance().updateLog("BeforeRelease excute - map size:null");
					}
					*/
					
				}else if("released".equals(jobName)){
					FfsDataDaemon.self.releasedMap								=	sl.allReleased();
					FfsDataDaemon.self.releasedAlertMap					= sl.selAlertRule("2");
					 valid	=	true;
					
					//20150827 ߰
					if(FfsDataDaemon.self.releasedMap != null) {
						BaseLoggerWriter.getInstance().updateLog("released excute - map size:" + String.valueOf(FfsDataDaemon.self.releasedMap.size()));
					} else {
						BaseLoggerWriter.getInstance().updateLog("released excute - map size:null");
					}
					
				}else if("enroute".equals(jobName)){
					FfsDataDaemon.self.enrouteMap								=	sl.allEnroute();
					FfsDataDaemon.self.enrouteAlertMap						= sl.selAlertRule("3");
					 valid	=	true;
				}else if("enrouteDetail".equals(jobName)){
					FfsDataDaemon.self.enrouteDetailMap					=	sl.allEnrouteDetail();
					 valid	=	true;
				}else if("landed".equals(jobName)){
					FfsDataDaemon.self.landedMap								=	sl.allLanded();
					 valid	=	true;
					 
				//20160415 ߰
				}else if("beforeReleaseRev".equals(jobName)){
					FfsDataDaemon.self.beforeReleaseRevMap = sl.allNotReleasedRev();
					 valid	=	true;
				}else if("releasedRev".equals(jobName)){
					FfsDataDaemon.self.releasedRevMap = sl.allReleasedRev();
					 valid	=	true;
				}else if("enrouteRev".equals(jobName)){
					FfsDataDaemon.self.enrouteRevMap = sl.allEnrouteRev();
					 valid	=	true;
				}else if("landedRev".equals(jobName)){
					FfsDataDaemon.self.landedRevMap = sl.allLandedRev();
					 valid	=	true;	
					 
				}else{
					 valid	=	false;
				}				
			}catch(Exception te){
				debugPrint("TaskTask.Exception",te.toString());
				cancel();
				valid	=	false;
			}
		}
	}	
}
