package kal.base.ffs.serv;

import java.rmi.RemoteException;
import java.util.Hashtable;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import kal.base.com.util.StringUtil;
import kal.base.ffs.dbbean.CdmA010BG;
import kal.base.ffs.ejb.FfsAllSL;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.Box;
import kal.base.jdf.serv.HttpUtility;
import kal.base.pbf.serv.PublicBaseServlet;

public class CdmA010Serv extends PublicBaseServlet{
	
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);
		
		String frDate = StringUtil.checkString(box.getString("fr_date"));
		String toDate = StringUtil.checkString(box.getString("to_date"));
		
		String returnPage = StringUtil.checkString(box.getString("returnPage"));
		
		try{
			CdmA010BG params = new CdmA010BG();
			
			params.setFr_date(frDate);
			params.setTo_date(toDate);
			
			FfsAllSL sl = (FfsAllSL)EJBFinder.lookup("ejb/FfsAllSL");
			Hashtable hashData = sl.selCdmSendList(params);
			
			req.setAttribute("hashData", hashData);
			
			//  
			printJspPage(req, res, returnPage);
		}catch(Exception e){
			if(e instanceof RemoteException){
				Logger.debug.println("[BASE:CdmA010Serv:selectTask]"+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(), returnPage, "select");
			}else{
				Logger.debug.println("[BASE:CdmA010Serv:selectTask]"+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(), returnPage,"select");
			}
		}
		
	}
	
	public void insertTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);
		
		String sender_txt = StringUtil.checkString(box.getString("sender_txt"));
		String origin_txt = StringUtil.checkString(box.getString("origin_txt"));
		String contents = StringUtil.checkString(box.getString("contents"));
		
		String returnPage = StringUtil.checkString(box.getString("returnPage"));
		
		try{
			CdmA010BG params = new CdmA010BG();
			
			params.setSender_txt(sender_txt);
			params.setOrigin_txt(origin_txt);
			params.setContents(contents);
			
			//EJB LookUp
			FfsAllSL sl = (FfsAllSL)EJBFinder.lookup("ejb/FfsAllSL");
			sl.sendCdmMsg(params);
			
			req.setAttribute("sndOK", "Y");
			
//			  
			printJspPage(req, res, returnPage);
		}catch(Exception e){
			if(e instanceof RemoteException){
				Logger.debug.println("[BASE:CdmA010Serv:insertTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(), returnPage, "select");
			}else{
				Logger.debug.println("[BASE:CdmA010Serv:insertTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(), returnPage, "select");
			}
		}
    }

}
