package kal.base.ffs.serv;

import java.rmi.RemoteException;
import java.util.Hashtable;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import kal.base.com.util.StringUtil;
import kal.base.ffs.dbbean.FfsA080BG;
import kal.base.ffs.ejb.FfsAllSL;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.Box;
import kal.base.jdf.serv.HttpUtility;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.sys.dbbean.SysA010BG;

public class FfsA080Serv extends PublicBaseServlet{
    public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception{
    	Box box = HttpUtility.getBox(req);
    	
    	String pRegionCd = StringUtil.checkString(box.getString("pRegionCd"));
    	String pFirstLegFltDt = StringUtil.checkString(box.getString("pFirstLegFltDt"));
    	String pFltNum = StringUtil.checkString(box.getString("pFltNum"));
    	String pStnFr  = StringUtil.checkString(box.getString("pStnFr"));
    	String pStnTo = StringUtil.checkString(box.getString("pStnTo"));
    	String pLegNum = StringUtil.checkString(box.get("pLegNum"));
    	String pRegNo = StringUtil.checkString(box.getString("pRegNo"));
    	String pSacTyp = StringUtil.checkString(box.getString("pSacTyp"));
    	
    	String returnPage = StringUtil.checkString(box.getString("returnPage"));
    	
    	try{
    		FfsA080BG params = new FfsA080BG();
    		
    		params.setPFirstLegFltDt(pFirstLegFltDt);
    		params.setPFltNum(pFltNum);
    		params.setPStnFr(pStnFr);
    		params.setPStnTo(pStnTo);
    		params.setPRegNo(pRegNo);
    		params.setPSacTyp(pSacTyp);

			params.setLegNum(pLegNum);
    		
    		params.setPRegionCd(pRegionCd);// AME / SEA ׷θ ..
    		
            // EJB LookUp
			FfsAllSL sl = (FfsAllSL)EJBFinder.lookup("ejb/FfsAllSL");
			Hashtable hashData  = sl.selEnabledRouteList(params);
			
			req.setAttribute("returnParam","Y");
			req.setAttribute("hashData", hashData);
			
			// 2012.11.22 ߰ : COMPARE TO KAM   AME, SEA  Ī ϱ ..
			req.setAttribute("regionCd", pRegionCd);
			req.setAttribute("params", params);
			
			printJspPage(req, res, returnPage);
    	}catch(Exception e){
    		if(e instanceof RemoteException){
    			Logger.debug.println();
    			if(e instanceof RemoteException) {
    				Logger.debug.println("[BASE:TarQ010Serv:selectTask] "+((RemoteException)e).getMessage());
    				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
    				return;
    			} else {
    				Logger.debug.println("[BASE:TarQ010Serv:selectTask] "+((Exception)e).getMessage());
    				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
    				return;
    			}
    		}
    	}
    }
    
    public void updateTask(HttpServletRequest req, HttpServletResponse res) throws Exception{
        Box box = HttpUtility.getBox(req);
        
        HttpSession session = req.getSession();
        
        String firstLegFltDt = StringUtil.checkString(box.get("pFirstLegFltDt1"));
        String fltNum         = StringUtil.checkString(box.get("pFltNum1"));
        String legNum      = StringUtil.checkString(box.get("pLegNum1"));
        String stnFr          = StringUtil.checkString(box.get("pStnFr1"));
        String stnTo         = StringUtil.checkString(box.get("pStnTo1"));
        String regNo        = StringUtil.checkString(box.get("pRegNo1"));
        String sacTyp      = StringUtil.checkString(box.get("pSacTyp1"));
        String abhr           = StringUtil.checkString(box.get("abhr1"));
        String plnTripFuel = StringUtil.checkString(box.get("plnTripFuel1"));
        String fuelCost      = StringUtil.checkString(box.get("fuelCost1"));
        String overfltCost   = StringUtil.checkString(box.get("overfltCost1"));
        String crewCost    = StringUtil.checkString(box.get("crewCost1"));
        String maintCost    = StringUtil.checkString(box.get("maintenceCost1"));
        String costAmount = StringUtil.checkString(box.get("costAmount1"));
        String compareTo = StringUtil.checkString(box.get("compareTo1"));
        String route = StringUtil.checkString(box.get("route1"));
        String reason1 = new String(StringUtil.checkString(box.get("reason11")).getBytes("ISO-8859-1"),"KSC_5601");
        String reason2 = new String(StringUtil.checkString(box.get("reason21")).getBytes("ISO-8859-1"),"KSC_5601");
        String rtGrouping = StringUtil.checkString(box.get("rtGrouping1"));
        
        String returnPage = StringUtil.checkString(box.getString("returnPage"));
        try{
        	SysA010BG UserInfo = (SysA010BG)session.getAttribute("USERINFO");
        	
        	FfsA080BG params = new FfsA080BG();
        	params.setPFirstLegFltDt(firstLegFltDt);
        	params.setPFltNum(fltNum);
        	params.setPLegNum(legNum);
        	params.setPStnFr(stnFr);
        	params.setPStnTo(stnTo);
        	params.setPRegNo(regNo);
        	params.setPSacTyp(sacTyp);
        	params.setAbhr(abhr);
        	params.setPlnTripFuel(plnTripFuel);
        	params.setFuelCost(fuelCost);
        	params.setOverfltCost(overfltCost);
        	params.setCrewCost(crewCost);
        	params.setMaintCost(maintCost);
        	params.setCostAmount(costAmount);
        	params.setCompareTo(compareTo);
        	params.setRtGrouping(rtGrouping);
        	params.setReason1(reason1);
        	params.setReason2(reason2);
        	params.setUserId(UserInfo.getEmp_no());
        	
        	FfsAllSL sl = (FfsAllSL)EJBFinder.lookup("ejb/FfsAllSL");
        	boolean upd = sl.updErsMasterT(params);
        	req.setAttribute("upd","Y");
        	
        	printJspPage(req, res, returnPage);
        }catch(Exception e){
    		if(e instanceof RemoteException){
    			Logger.debug.println();
    			if(e instanceof RemoteException) {
    				Logger.debug.println("[BASE:TarQ010Serv:selectTask] "+((RemoteException)e).getMessage());
    				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
    				return;
    			} else {
    				Logger.debug.println("[BASE:TarQ010Serv:selectTask] "+((Exception)e).getMessage());
    				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
    				return;
    			}
    		}
        }
    }
    
    public void insertTask(HttpServletRequest req, HttpServletResponse res) throws Exception{
        Box box = HttpUtility.getBox(req);
        
        HttpSession session = req.getSession();
        
        String firstLegFltDt = StringUtil.checkString(box.get("pFirstLegFltDt"));
        String fltNum         = StringUtil.checkString(box.get("pFltNum"));
        String legNum      = StringUtil.checkString(box.get("pLegNum"));
        String stnFr          = StringUtil.checkString(box.get("pStnFr"));
        String stnTo         = StringUtil.checkString(box.get("pStnTo"));
        String regNo        = StringUtil.checkString(box.get("pRegNo"));
        String sacTyp      = StringUtil.checkString(box.get("pSacTyp"));
        String[] arrAbhr      = req.getParameterValues("abhr");
        String[] arrPlnTripFuel = req.getParameterValues("plnTripFuel");
        String[] arrFuelCost      = req.getParameterValues("fuelCost");
        String[] arrOverfltCost  = req.getParameterValues("charge");
        String[] arrCrewCost   = req.getParameterValues("crewCost");
        String[] arrMaintCost  = req.getParameterValues("maintenceCost");
        String[] arrCostAmount = req.getParameterValues("costAmount");
        String[] arrCompareTo = req.getParameterValues("compareTo");
        String[] arrReason1 = req.getParameterValues("reason1");
        String[] arrReason2 = req.getParameterValues("reason2");
        String[] arrConf = req.getParameterValues("confY");
        String[] arrChk = req.getParameterValues("chkY");
        String[] arrRoute      = req.getParameterValues("route");//@2014-04-16
        
        
		for(int i=0;arrChk!=null && i<arrChk.length; i++){
			System.out.println("=============================arrChk_"+i+" : "+arrChk[i]);
		}
		
		String[] arrRtGrouping = req.getParameterValues("rtGrouping");
        
        String returnPage = StringUtil.checkString(box.getString("returnPage"));
        try{
        	SysA010BG UserInfo = (SysA010BG)session.getAttribute("USERINFO");
        	
        	FfsA080BG params = new FfsA080BG();
        	params.setPFirstLegFltDt(firstLegFltDt);
        	params.setPFltNum(fltNum);
        	params.setPLegNum(legNum);
        	params.setPStnFr(stnFr);
        	params.setPStnTo(stnTo);
        	params.setPRegNo(regNo);
        	params.setPSacTyp(sacTyp);
        	params.setArrAbhr(arrAbhr);
        	params.setArrPlnTripFuel(arrPlnTripFuel);
        	params.setArrFuelCost(arrFuelCost);
        	params.setArrOverfltCost(arrOverfltCost);
        	params.setArrCrewCost(arrCrewCost);
        	params.setArrMaintenceCost(arrMaintCost);
        	params.setArrCostAmount(arrCostAmount);
        	params.setArrCompareTo(arrCompareTo);
        	params.setArrRtGrouping(arrRtGrouping);
        	params.setArrReason1(arrReason1);
        	params.setArrReason2(arrReason2);
        	params.setArrConf(arrConf);
        	params.setArrChk(arrChk);
        	params.setUserId(UserInfo.getEmp_no());
        	params.setArrRoute(arrRoute);//@2014-04-16
        	
        	FfsAllSL sl = (FfsAllSL)EJBFinder.lookup("ejb/FfsAllSL");
        	boolean upd = sl.insErsMasterT(params);
        	req.setAttribute("upd","Y");
        	
        	printJspPage(req, res, returnPage);
        }catch(Exception e){
    		if(e instanceof RemoteException){
    			Logger.debug.println();
    			if(e instanceof RemoteException) {
    				Logger.debug.println("[BASE:TarQ010Serv:selectTask] "+((RemoteException)e).getMessage());
    				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
    				return;
    			} else {
    				Logger.debug.println("[BASE:TarQ010Serv:selectTask] "+((Exception)e).getMessage());
    				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
    				return;
    			}
    		}
        }
    }
}
