package kal.base.ffs.serv;

import java.rmi.RemoteException;
import java.util.Hashtable;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import kal.base.com.util.*;
import kal.base.com.serv.*;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.Box;
import kal.base.jdf.serv.HttpUtility;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.ffs.dbbean.FfsA240BG;
import kal.base.ffs.ejb.FfsAllSL;

/**
 * Position Report Է Servlet Class
 * @version 	1.0
 * @author Copyright (c) 2007/07/12 
 */
public class FfsA240Serv extends PublicBaseServlet {
	/** 
	  * Position Report Է(Waypoint Name̳ /浵   ) Servlet Class - updateTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2007/07/12 
	  */	
	public void updateTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 											//Box ü 
		
		String ata = StringUtil.checkString(box.getString("ata"));
		String actFobFuel = StringUtil.checkString(box.getString("actFobFuel"));
		String actLevel = StringUtil.checkString(box.getString("actLevel"));
		
		String syskey = StringUtil.checkString(box.getString("syskey"));
		String seq = StringUtil.checkString(box.getString("seq"));
		
		String firstLegFltDt = StringUtil.checkString(box.getString("firstLegFltDt"));
		String fltNum = StringUtil.checkString(box.getString("fltNum"));
		String stnfr = StringUtil.checkString(box.getString("stnfr"));
		String stnto = StringUtil.checkString(box.getString("stnto"));
		
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		try {
			FfsA240BG params = new FfsA240BG();
			
			params.setAta(ata);
			params.setActFobFuel(actFobFuel);
			params.setActLevel(actLevel);
			params.setSyskey(syskey);
			params.setSeq(seq);
			params.setFirstLegFltDt(firstLegFltDt);
			params.setFltNum(fltNum);
			params.setStnfr(stnfr);
			params.setStnto(stnto);
			
			//EJB LookUp
			FfsAllSL sl = (FfsAllSL)EJBFinder.lookup("ejb/FfsAllSL");
			int returnValue = sl.updWaypoint(params);
			if (returnValue == 1) req.setAttribute("returnValue","1");
			else req.setAttribute("returnValue","0");
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:FfsA240Serv:updateTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"update");
				return;
			} else {
				Logger.debug.println("[BASE:FfsA240Serv:updateTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"update");
				return;
			}
		} 
	}//end updateTask
	
	/** 
	  * Position Report Է(Waypoint Name̳ /浵  ) Servlet Class - insertTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2007/07/12 
	  */	
	public void insertTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 											//Box ü 
		
		String fltNum = StringUtil.checkString(box.getString("fltNum"));
		String acReg = StringUtil.checkString(box.getString("acReg"));
		String stnfr = StringUtil.checkString(box.getString("stnfr"));
		String stnto = StringUtil.checkString(box.getString("stnto"));
		String schDdMonYy = StringUtil.checkString(box.getString("schDdMonYy"));
		
		String lat_ns = StringUtil.checkString(box.getString("lat_ns"));
		String lat_1 = StringUtil.checkString(box.getString("lat_1"));
		String lat_2 = StringUtil.checkString(box.getString("lat_2"));
		String lat_3 = StringUtil.checkString(box.getString("lat_3"));
		
		String lon_ew = StringUtil.checkString(box.getString("lon_ew"));
		String lon_1 = StringUtil.checkString(box.getString("lon_1"));
		String lon_2 = StringUtil.checkString(box.getString("lon_2"));
		String lon_3 = StringUtil.checkString(box.getString("lon_3"));
		
		String ata = StringUtil.checkString(box.getString("ata"));
		String actFobFuel = StringUtil.checkString(box.getString("actFobFuel"));
		String actLevel = StringUtil.checkString(box.getString("actLevel"));
		
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		try {
			FfsA240BG params = new FfsA240BG();
			
			params.setFltNum(fltNum);
			params.setAcReg(acReg);
			params.setStnfr(stnfr);
			params.setStnto(stnto);
			params.setSchDdMonYy(schDdMonYy);
			params.setLat_ns(lat_ns);
			params.setLat_1(lat_1);
			params.setLat_2(lat_2);
			params.setLat_3(lat_3);
			params.setLon_ew(lon_ew);
			params.setLon_1(lon_1);
			params.setLon_2(lon_2);
			params.setLon_3(lon_3);
			params.setAta(ata);
			params.setActFobFuel(actFobFuel);
			params.setActLevel(actLevel);
			
			/*System.out.println("fltNum=>"+fltNum);
			System.out.println("acReg=>"+acReg);
			System.out.println("stnfr=>"+stnfr);
			System.out.println("stnto=>"+stnto);
			System.out.println("schDdMonYy=>"+schDdMonYy);
			System.out.println("lat_ns=>"+lat_ns);
			System.out.println("lat_1=>"+lat_1);
			System.out.println("lat_2=>"+lat_2);
			System.out.println("lat_3=>"+lat_3);
			System.out.println("lon_ew=>"+lon_ew);
			System.out.println("lon_1=>"+lon_1);
			System.out.println("lon_2=>"+lon_2);
			System.out.println("lon_3=>"+lon_3);
			System.out.println("ata=>"+ata);
			System.out.println("actFobFuel=>"+actFobFuel);
			System.out.println("actLevel=>"+actLevel);*/			
			
			//EJB LookUp
			FfsAllSL sl = (FfsAllSL)EJBFinder.lookup("ejb/FfsAllSL");
			String returnValue = sl.msgCRS(params);
			if (returnValue.equals("succ")) req.setAttribute("returnValue","2");
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:FfsA240Serv:insertTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"insert");
				return;
			} else {
				Logger.debug.println("[BASE:FfsA240Serv:insertTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"insert");
				return;
			}
		} 
	}//end insertTask
}
