package kal.base.ffs.serv;

import java.rmi.RemoteException;
import java.util.Hashtable;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import kal.base.com.util.*;
import kal.base.com.serv.*;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.Box;
import kal.base.jdf.serv.HttpUtility;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.ffs.dbbean.FfsA260BG;
import kal.base.ffs.ejb.FfsAllSL;

/**
 * Release Message ȸ,  Servlet Class
 * @version 	1.0
 * @author Copyright (c) 2009/01/02  
 */
public class FfsA260Serv extends PublicBaseServlet {
	/** 
	  * Release Message ȸ Servlet Class - selectTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2009/01/02  
	  */	
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 											//Box ü 
		
		String firstLegFltDt = StringUtil.checkString(box.getString("firstLegFltDt"));
		String fltNum = StringUtil.checkString(box.getString("fltNum"));
		String stnfr = StringUtil.checkString(box.getString("stnfr"));
		String stnto = StringUtil.checkString(box.getString("stnto"));
		String msgSeq = StringUtil.checkString(box.getString("sel_msgSeq"));
		
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		try {
			FfsA260BG params = new FfsA260BG();
			
			params.setPFirstLegFltDt(firstLegFltDt);
			params.setPFltNum(fltNum);
			params.setPStnfr(stnfr);
			params.setPStnto(stnto);
			params.setPMsgSeq(msgSeq);
			
			//EJB LookUp
			FfsAllSL sl = (FfsAllSL)EJBFinder.lookup("ejb/FfsAllSL");
			Hashtable hashData  = sl.selRlsMsgMain(params);
			req.setAttribute("hashData",hashData);
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:FfsA260Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
				return;
			} else {
				Logger.debug.println("[BASE:FfsA260Serv:selectTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
				return;
			}
		} 
	}//end selectTask
	
	/** 
	  * Release Message RE-SEND Servlet Class - updateTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2009/01/09  
	  */	
	public void updateTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 											//Box ü 
		
		String firstLegFltDt = StringUtil.checkString(box.getString("firstLegFltDt"));
		String fltNum = StringUtil.checkString(box.getString("fltNum"));
		String stnfr = StringUtil.checkString(box.getString("stnfr"));
		String stnto = StringUtil.checkString(box.getString("stnto"));
		
		String msgSeq = StringUtil.checkString(box.getString("s_msgSeq"));
		
		String planNo = StringUtil.checkString(box.getString("s_planNo"));
		String regno = StringUtil.checkString(box.getString("s_regno"));	// 'HL' (4ڸ)
		String estDepT = StringUtil.checkString(box.getString("s_estDepT"));
		String estDepD = StringUtil.checkString(box.getString("s_estDepD"));
		
		String addFuelQ = StringUtil.checkString(box.getString("s_addFuelQ"));
		String addRsnCd = StringUtil.checkString(box.getString("s_addRsnCd"));
		
		//2018-08-07
		String plnExtrFuel1	=	StringUtil.checkString(box.getString("s_plnExtrFuel1"));
		String plnExtrFuel2	=	StringUtil.checkString(box.getString("s_plnExtrFuel2"));
		String plnExtrRsn1 = StringUtil.checkString(box.getString("s_plnExtrRsn1"));
		String plnExtrRsn2 = StringUtil.checkString(box.getString("s_plnExtrRsn2"));
		addRsnCd	=	plnExtrRsn1;
		
		String rampFuelQ = StringUtil.checkString(box.getString("s_rampFuelQ"));
		String vcRampFuelQ = StringUtil.checkString(box.getString("s_vcRampFuelQ"));
		String taxiFuelQ = StringUtil.checkString(box.getString("s_taxiFuelQ"));
		String tofQ = StringUtil.checkString(box.getString("s_tofQ"));
		String tifQ = StringUtil.checkString(box.getString("s_tifQ"));
		String pldQ = StringUtil.checkString(box.getString("s_pldQ"));
		String towQ = StringUtil.checkString(box.getString("s_towQ"));
		
		String dispName = StringUtil.checkString(box.getString("s_dispName"));
		String ccFuel95Q = StringUtil.checkString(box.getString("s_ccFuel95Q"));
		String ccFuel75Q = StringUtil.checkString(box.getString("s_ccFuel75Q"));
		String ccFuel50Q = StringUtil.checkString(box.getString("s_ccFuel50Q")); //2010.07.21 ߰ : CC_FUEL50_Q
		String addInfo = StringUtil.checkString(box.getString("s_addInfo"));
		String siInfo = StringUtil.checkString(box.getString("s_siInfo"));
		
		String email_txt = StringUtil.checkString(box.getString("email_txt"));
		String sita_txt = StringUtil.checkString(box.getString("sita_txt"));
		String aftn_txt = StringUtil.checkString(box.getString("aftn_txt"));
		String acars_txt = StringUtil.checkString(box.getString("acars_txt"));
		String fax_txt = StringUtil.checkString(box.getString("fax_txt"));
		String sender_txt = StringUtil.checkString(box.getString("sender_txt"));
		String origin_txt = StringUtil.checkString(box.getString("origin_txt"));
		
		String dsp_cd = StringUtil.checkString(box.getString("dsp_cd")); //2009.07.01 ߰
		
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		//20140903 docNo ߰
		String docNo = StringUtil.checkString(box.getString("docNo"));
		String empNo = StringUtil.checkString(box.getString("empNo"));
		
		try {
			
			//ĸ 
			addFuelQ = StringUtil.unFormatComma(addFuelQ);
			//@2018-08-07
			plnExtrFuel1 = StringUtil.unFormatComma(plnExtrFuel1);
			plnExtrFuel2 = StringUtil.unFormatComma(plnExtrFuel2);
			
			rampFuelQ = StringUtil.unFormatComma(rampFuelQ);
			vcRampFuelQ = StringUtil.unFormatComma(vcRampFuelQ);
			taxiFuelQ = StringUtil.unFormatComma(taxiFuelQ);
			tofQ = StringUtil.unFormatComma(tofQ);
			tifQ = StringUtil.unFormatComma(tifQ);
			pldQ = StringUtil.unFormatComma(pldQ);
			towQ = StringUtil.unFormatComma(towQ);
			ccFuel95Q = StringUtil.unFormatComma(ccFuel95Q);
			ccFuel75Q = StringUtil.unFormatComma(ccFuel75Q);
			ccFuel50Q = StringUtil.unFormatComma(ccFuel50Q); //2010.07.21 ߰ : CC_FUEL50_Q
			
			/*System.out.println(" :"+firstLegFltDt);
			System.out.println(" :"+fltNum);
			System.out.println(" :"+stnfr);
			System.out.println(" :"+stnto);
			System.out.println(" :"+msgSeq);
			System.out.println(" :"+planNo);
			System.out.println(" :"+regno);
			System.out.println(" :"+estDepT);
			System.out.println(" :"+estDepD);
			System.out.println(" :"+addFuelQ);
			System.out.println(" :"+addRsnCd);
			System.out.println(" :"+rampFuelQ);
			System.out.println(" :"+vcRampFuelQ);
			System.out.println(" :"+taxiFuelQ);
			System.out.println(" :"+tofQ);
			System.out.println(" :"+tifQ);
			System.out.println(" :"+pldQ);
			System.out.println(" :"+towQ);
			System.out.println(" :"+dispName);
			System.out.println(" :"+ccFuel95Q);
			System.out.println(" :"+ccFuel75Q);
			System.out.println(" :"+ccFuel50Q);
			System.out.println(" :"+addInfo);
			System.out.println(" :"+siInfo);
			System.out.println(" :"+email_txt);
			System.out.println(" :"+sita_txt);
			System.out.println(" :"+aftn_txt);
			System.out.println(" :"+acars_txt);
			System.out.println(" :"+fax_txt);
			System.out.println(" :"+sender_txt);
			System.out.println(" :"+origin_txt);*/
			
			FfsA260BG params = new FfsA260BG();
			
			params.setPFirstLegFltDt(firstLegFltDt);
			params.setPFltNum(fltNum);
			params.setPStnfr(stnfr);
			params.setPStnto(stnto);
			params.setPMsgSeq(msgSeq);
			
			params.setPlanNo(planNo);
			params.setRegno(regno);
			params.setEstDepT(estDepT);
			params.setEstDepD(estDepD);
			params.setAddFuelQ(addFuelQ);
			params.setAddRsnCd(addRsnCd);			
			//@2018-08-07
			params.setPlnExtrFuel1(plnExtrFuel1);
			params.setPlnExtrFuel2(plnExtrFuel2);	
			//@2018-11-01
			params.setPlnExtrRsn1(plnExtrRsn1);
			params.setPlnExtrRsn2(plnExtrRsn2);	
			
			params.setRampFuelQ(rampFuelQ);
			params.setVcRampFuelQ(vcRampFuelQ);
			params.setTaxiFuelQ(taxiFuelQ);
			params.setTofQ(tofQ);
			params.setTifQ(tifQ);
			params.setPldQ(pldQ);
			params.setTowQ(towQ);
			params.setDispName(dispName);
			params.setCcFuel95Q(ccFuel95Q);
			params.setCcFuel75Q(ccFuel75Q);
			params.setCcFuel50Q(ccFuel50Q); //2010.07.21 ߰ : CC_FUEL50_Q
			params.setAddInfo(addInfo);
			params.setSiInfo(siInfo);
			
			params.setEmail_txt(email_txt);
			//20150717 
			//params.setSita_txt(sita_txt);
			String sitaTxtAddedOrigin = !"".equals(sita_txt) ? sita_txt + " " + origin_txt : "";
			params.setSita_txt(sitaTxtAddedOrigin);
			
			params.setAftn_txt(aftn_txt);
			params.setAcars_txt(acars_txt);
			params.setFax_txt(fax_txt);
			params.setSender_txt(sender_txt);
			params.setOrigin_txt(origin_txt);
			
			params.setDsp_cd(dsp_cd); //2009.07.01 ߰
			
			//20140903 docNo ߰
			params.setDocNo(docNo);
			params.setEmpNo(empNo);
			
			//EJB LookUp
			FfsAllSL sl = (FfsAllSL)EJBFinder.lookup("ejb/FfsAllSL");
			String returnValue = sl.reSendRlsMsg(params);
			if (returnValue.equals("succ")) req.setAttribute("returnValue","S");
			req.setAttribute("insMsgSeq", msgSeq);
			
			//  
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:FfsA260Serv:updateTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"update");
				return;
			} else {
				Logger.debug.println("[BASE:FfsA260Serv:updateTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"update");
				return;
			}
		} 
	}//end updateTask
	
	/** 
	  * Release Message SEND Servlet Class - insertTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2009/01/08  
	  */	
	public void insertTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 											//Box ü 
		
		String firstLegFltDt = StringUtil.checkString(box.getString("firstLegFltDt"));
		String fltNum = StringUtil.checkString(box.getString("fltNum"));
		String stnfr = StringUtil.checkString(box.getString("stnfr"));
		String stnto = StringUtil.checkString(box.getString("stnto"));
		
		String msgSeq = StringUtil.checkString(box.getString("h_msgSeq")); // ο MSG_SEQ   ߿ϴ!!
		
		String planNo = StringUtil.checkString(box.getString("s_planNo"));
		String regno = StringUtil.checkString(box.getString("s_regno"));	// 'HL' (4ڸ)
		String estDepT = StringUtil.checkString(box.getString("s_estDepT"));
		String estDepD = StringUtil.checkString(box.getString("s_estDepD"));
		
		String addFuelQ = StringUtil.checkString(box.getString("s_addFuelQ"));
		String addRsnCd = StringUtil.checkString(box.getString("s_addRsnCd"));
		//2018-08-07
		String plnExtrFuel1	=	StringUtil.checkString(box.getString("s_plnExtrFuel1"));
		String plnExtrFuel2	=	StringUtil.checkString(box.getString("s_plnExtrFuel2"));
		String plnExtrRsn1 = StringUtil.checkString(box.getString("s_plnExtrRsn1"));
		String plnExtrRsn2 = StringUtil.checkString(box.getString("s_plnExtrRsn2"));
		addRsnCd	=	plnExtrRsn1;
		
		String rampFuelQ = StringUtil.checkString(box.getString("s_rampFuelQ"));
		String vcRampFuelQ = StringUtil.checkString(box.getString("s_vcRampFuelQ"));
		String taxiFuelQ = StringUtil.checkString(box.getString("s_taxiFuelQ"));
		String tofQ = StringUtil.checkString(box.getString("s_tofQ"));
		String tifQ = StringUtil.checkString(box.getString("s_tifQ"));
		String pldQ = StringUtil.checkString(box.getString("s_pldQ"));
		String towQ = StringUtil.checkString(box.getString("s_towQ"));
		
		String dispName = StringUtil.checkString(box.getString("s_dispName"));
		String ccFuel95Q = StringUtil.checkString(box.getString("s_ccFuel95Q"));
		String ccFuel75Q = StringUtil.checkString(box.getString("s_ccFuel75Q"));
		String ccFuel50Q = StringUtil.checkString(box.getString("s_ccFuel50Q")); //2010.07.21 ߰ : CC_FUEL50_Q
		String addInfo = StringUtil.checkString(box.getString("s_addInfo"));
		String siInfo = StringUtil.checkString(box.getString("s_siInfo"));
		
		String email_txt = StringUtil.checkString(box.getString("email_txt"));
		String sita_txt = StringUtil.checkString(box.getString("sita_txt"));
		String aftn_txt = StringUtil.checkString(box.getString("aftn_txt"));
		String acars_txt = StringUtil.checkString(box.getString("acars_txt"));
		String fax_txt = StringUtil.checkString(box.getString("fax_txt"));
		String sender_txt = StringUtil.checkString(box.getString("sender_txt"));
		String origin_txt = StringUtil.checkString(box.getString("origin_txt"));
		
		String empNo = StringUtil.checkString(box.getString("empNo"));
		
		String dsp_cd = StringUtil.checkString(box.getString("dsp_cd")); //2009.07.01 ߰
		
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		//20140903 docNo ߰
		String docNo = StringUtil.checkString(box.getString("docNo"));
		
		//20160706 ߰
		String isRev = StringUtil.checkString(box.getString("isRev"));
		
		try {
			
			//ĸ 
			addFuelQ = StringUtil.unFormatComma(addFuelQ);
			//@2018-08-07
			plnExtrFuel1 = StringUtil.unFormatComma(plnExtrFuel1);
			plnExtrFuel2 = StringUtil.unFormatComma(plnExtrFuel2);
			
			rampFuelQ = StringUtil.unFormatComma(rampFuelQ);
			vcRampFuelQ = StringUtil.unFormatComma(vcRampFuelQ);
			taxiFuelQ = StringUtil.unFormatComma(taxiFuelQ);
			tofQ = StringUtil.unFormatComma(tofQ);
			tifQ = StringUtil.unFormatComma(tifQ);
			pldQ = StringUtil.unFormatComma(pldQ);
			towQ = StringUtil.unFormatComma(towQ);
			ccFuel95Q = StringUtil.unFormatComma(ccFuel95Q);
			ccFuel75Q = StringUtil.unFormatComma(ccFuel75Q);
			ccFuel50Q = StringUtil.unFormatComma(ccFuel50Q); //2010.07.21 ߰ : CC_FUEL50_Q
			
			FfsA260BG params = new FfsA260BG();
			
			params.setPFirstLegFltDt(firstLegFltDt);
			params.setPFltNum(fltNum);
			params.setPStnfr(stnfr);
			params.setPStnto(stnto);
			params.setPMsgSeq(msgSeq);
			
			params.setPlanNo(planNo);
			params.setRegno(regno);
			params.setEstDepT(estDepT);
			params.setEstDepD(estDepD);
			params.setAddFuelQ(addFuelQ);
			params.setAddRsnCd(addRsnCd);
			//@2018-08-07
			params.setPlnExtrFuel1(plnExtrFuel1);
			params.setPlnExtrFuel2(plnExtrFuel2);	
			//@2018-11-01
			params.setPlnExtrRsn1(plnExtrRsn1);
			params.setPlnExtrRsn2(plnExtrRsn2);	
			
			params.setRampFuelQ(rampFuelQ);
			params.setVcRampFuelQ(vcRampFuelQ);
			params.setTaxiFuelQ(taxiFuelQ);
			params.setTofQ(tofQ);
			params.setTifQ(tifQ);
			params.setPldQ(pldQ);
			params.setTowQ(towQ);
			params.setDispName(dispName);
			params.setCcFuel95Q(ccFuel95Q);
			params.setCcFuel75Q(ccFuel75Q);
			params.setCcFuel50Q(ccFuel50Q); //2010.07.21 ߰ : CC_FUEL50_Q
			params.setAddInfo(addInfo);
			params.setSiInfo(siInfo);
			
			params.setEmail_txt(email_txt);
			//20150717 
			//params.setSita_txt(sita_txt);
			String sitaTxtAddedOrigin = !"".equals(sita_txt) ? sita_txt + " " + origin_txt : "";
			params.setSita_txt(sitaTxtAddedOrigin);
			
			params.setAftn_txt(aftn_txt);
			params.setAcars_txt(acars_txt);
			params.setFax_txt(fax_txt);
			params.setSender_txt(sender_txt);
			params.setOrigin_txt(origin_txt);
			
			params.setOrgnAddr(origin_txt); //2009.01.16 ߰ : ORGN_ADDR
			params.setRcvAddr(sita_txt);
			params.setEmpNo(empNo);
			
			params.setDsp_cd(dsp_cd); //2009.07.01 ߰
			
			//20140903 docNo ߰
			params.setDocNo(docNo);
			params.setEmpNo(empNo);
			
			//EJB LookUp
			FfsAllSL sl = (FfsAllSL)EJBFinder.lookup("ejb/FfsAllSL");
			//20160706 
			//String returnValue = sl.sendRlsMsg(params);
			String returnValue = "";
			if("Y".equals(isRev)) {
				returnValue = sl.sendRlsMsgRev(params);
			} else {
				returnValue = sl.sendRlsMsg(params);
			}
			
			if (returnValue.equals("succ")) req.setAttribute("returnValue","S");
			req.setAttribute("insMsgSeq", msgSeq);
			
			//  
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:FfsA260Serv:insertTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"insert");
				return;
			} else {
				Logger.debug.println("[BASE:FfsA260Serv:insertTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"insert");
				return;
			}
		} 
	}//end insertTask
	
	/** 
	  * Release Message DSP_CD ȸ Servlet Class - checkTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2009/06/24  
	  */	
	public void checkTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 											//Box ü 
		
		String regno = StringUtil.checkString(box.getString("regno"));
		
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		try {
			//EJB LookUp
			FfsAllSL sl = (FfsAllSL)EJBFinder.lookup("ejb/FfsAllSL");
			
			String returnValue  = sl.getRlsMsgDspCd(regno);
			
			req.setAttribute("returnValue",returnValue);
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:FfsA260Serv:checkTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"check");
				return;
			} else {
				Logger.debug.println("[BASE:FfsA260Serv:checkTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"check");
				return;
			}
		} 
	}//end checkTask
}