package kal.base.ffs.serv;

import java.rmi.RemoteException;
import java.util.Hashtable;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import kal.base.com.util.StringUtil;
import kal.base.ffs.dbbean.FfsQ110BG;
import kal.base.ffs.ejb.FfsAllSL;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.Box;
import kal.base.jdf.serv.HttpUtility;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.sys.dbbean.SysA010BG;

/**
 * 20160301 ߰
 */
public class FfsQ010Serv extends PublicBaseServlet {
	
	public void checkTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);
		
		String cat = "XWAlert";
		String returnPage = StringUtil.checkString(box.getString("returnPage"));
		
		SysA010BG userInfo = (SysA010BG)req.getSession().getAttribute("USERINFO");
		String staffNum = userInfo.getEmp_no();
		
		String firstLegFltDt = StringUtil.checkString(box.getString("firstLegFltDt"));
		String fltNum = StringUtil.checkString(box.getString("fltNum"));
		String stnfr = StringUtil.checkString(box.getString("stnfr"));
		String stnto = StringUtil.checkString(box.getString("stnto"));
		String wxAlert = StringUtil.checkString(box.getString("wxAlert"));
		
		try {
			FfsQ110BG params = new FfsQ110BG();
			params.setCat(cat);
			params.setStaffNum(staffNum);
			params.setFirstLegFltDt(firstLegFltDt);
			params.setFltNum(fltNum);
			params.setStnfr(stnfr);
			params.setStnto(stnto);
			params.setWxAlert(wxAlert);
			
			FfsAllSL sl = (FfsAllSL)EJBFinder.lookup("ejb/FfsAllSL");
			boolean flag = sl.setUserAlert(params);
			if (flag) req.setAttribute("dataComplete","S");
			else throw new Exception(" ߻.");
			
			printJspPage(req, res, returnPage);
			
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:FfsQ010Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
				return;
			} else {
				Logger.debug.println("[BASE:FfsQ010Serv:selectTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
				return;
			}
		} 
	}
	
	public void updateTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);
		
		String cat = "REGNOAlert";
		String returnPage = StringUtil.checkString(box.getString("returnPage"));
		
		SysA010BG userInfo = (SysA010BG)req.getSession().getAttribute("USERINFO");
		String staffNum = userInfo.getEmp_no();
		
		String firstLegFltDt = StringUtil.checkString(box.getString("firstLegFltDt"));
		String fltNum = StringUtil.checkString(box.getString("fltNum"));
		String stnfr = StringUtil.checkString(box.getString("stnfr"));
		String stnto = StringUtil.checkString(box.getString("stnto"));
		String regnoAlert = StringUtil.checkString(box.getString("regnoAlert"));
		
		try {
			FfsQ110BG params = new FfsQ110BG();
			params.setCat(cat);
			params.setStaffNum(staffNum);
			params.setFirstLegFltDt(firstLegFltDt);
			params.setFltNum(fltNum);
			params.setStnfr(stnfr);
			params.setStnto(stnto);
			params.setRegnoAlert(regnoAlert);
			
			FfsAllSL sl = (FfsAllSL)EJBFinder.lookup("ejb/FfsAllSL");
			boolean flag = sl.setUserAlert(params);
			if (flag) req.setAttribute("dataComplete","S");
			else throw new Exception(" ߻.");
			
			printJspPage(req, res, returnPage);
			
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:FfsQ010Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
				return;
			} else {
				Logger.debug.println("[BASE:FfsQ010Serv:selectTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
				return;
			}
		} 
	}
	
	public void insertTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);
		
		String returnPage = StringUtil.checkString(box.getString("returnPage"));
		
		SysA010BG userInfo = (SysA010BG)req.getSession().getAttribute("USERINFO");
		String staffNum = userInfo.getEmp_no();
		
		String firstLegFltDt = StringUtil.checkString(box.getString("firstLegFltDt"));
		String fltNum = StringUtil.checkString(box.getString("fltNum"));
		String stnfr = StringUtil.checkString(box.getString("stnfr"));
		String stnto = StringUtil.checkString(box.getString("stnto"));
		String gbnAlert = StringUtil.checkString(box.getString("gbnAlert"));
		//20160622 ߰
		String melAlert = StringUtil.checkString(box.getString("melAlert"));
		
		//20160706 
		//String cat = "ATC".equals(gbnAlert) ? "ATCAlert" : "MEL".equals(gbnAlert) ? "MELAlert" : "";
		String cat = "ATC".equals(gbnAlert) ? "ATCAlert" : "MEL".equals(gbnAlert) ? "MELAlert" : "PMSN".equals(gbnAlert) ? "PMSNAlert" : "";
		
		try {
			FfsQ110BG params = new FfsQ110BG();
			params.setCat(cat);
			params.setStaffNum(staffNum);
			params.setFirstLegFltDt(firstLegFltDt);
			params.setFltNum(fltNum);
			params.setStnfr(stnfr);
			params.setStnto(stnto);
			//20160622 ߰
			if("MEL".equals(gbnAlert)) {
				params.setMelAlert(melAlert);
			}
			
			FfsAllSL sl = (FfsAllSL)EJBFinder.lookup("ejb/FfsAllSL");
			boolean flag = sl.setUserAlert(params);
			if (flag) req.setAttribute("dataComplete","S");
			else throw new Exception(" ߻.");
			
			printJspPage(req, res, returnPage);
			
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:FfsQ010Serv:insertTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
				return;
			} else {
				Logger.debug.println("[BASE:FfsQ010Serv:insertTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
				return;
			}
		} 
	}
}
