package kal.base.ffs.serv;

import java.rmi.RemoteException;
import java.util.Hashtable;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import kal.base.com.util.*;
import kal.base.com.serv.*;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.Box;
import kal.base.jdf.serv.HttpUtility;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.ffs.dbbean.FfsQ050BG;
import kal.base.ffs.ejb.FfsAllSL;

/**
 * Enroute  Flight   Remarks ó Servlet Class
 * @version 	1.0
 * @author Copyright (c) 2007/01/19 
 */
public class FfsQ050Serv extends PublicBaseServlet{

	/** 
	  * Enroute  Flight   Remarks ȸ Servlet Class - selectTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2007/01/19 
	  */	
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 											//Box ü 
		
		String rSyskey = StringUtil.checkString(box.getString("rSyskey"));
		String rSeq = StringUtil.checkString(box.getString("rSeq"));
		
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		try {
			FfsQ050BG params = new FfsQ050BG();
			
			params.setRSyskey(rSyskey);
			params.setRSeq(rSeq);
			
			//EJB LookUp
			FfsAllSL sl = (FfsAllSL)EJBFinder.lookup("ejb/FfsAllSL");
			Hashtable hashData  = sl.selRemarks(params);
			req.setAttribute("hashData",hashData);
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:FfsQ050Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
				return;
			} else {
				Logger.debug.println("[BASE:FfsQ050Serv:selectTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
				return;
			}
		} 
	}//end selectTask
	
	/** 
	  * Enroute  Flight   Remarks  Servlet Class - updateTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2007/01/19 
	  */	
	public void updateTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 											//Box ü 
		
		String rSyskey = StringUtil.checkString(box.getString("rSyskey"));
		String rSeq = StringUtil.checkString(box.getString("rSeq"));
		String rRemarks = StringUtil.toKSC5601(StringUtil.checkString(box.getString("rRemarks")));
		
		//2007.07.25 ߰
		String fltNum = StringUtil.checkString(box.getString("fltNum"));
		String firstLegFltDt = StringUtil.checkString(box.getString("firstLegFltDt"));
		String stnfr = StringUtil.checkString(box.getString("stnfr"));
		String stnto = StringUtil.checkString(box.getString("stnto"));
		
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		try {
			FfsQ050BG params = new FfsQ050BG();
			
			params.setRSyskey(rSyskey);
			params.setRSeq(rSeq);
			params.setRRemarks(rRemarks);
			
			//2007.07.25 ߰
			params.setPFltNum(fltNum);
			params.setPFirstLegFltDt(firstLegFltDt);
			params.setPStnfr(stnfr);
			params.setPStnto(stnto);
			
			//EJB LookUp
			FfsAllSL sl = (FfsAllSL)EJBFinder.lookup("ejb/FfsAllSL");
			String returnValue = sl.updRemarks(params);
			req.setAttribute("returnValue",returnValue);
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:FfsQ050Serv:updateTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"update");
				return;
			} else {
				Logger.debug.println("[BASE:FfsQ050Serv:updateTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"update");
				return;
			}
		} 
	}//end updateTask
	
	/** 
	  * Landed Flight Watch Log ȸ Servlet Class - checkTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2007/07/06 
	  */	
	public void checkTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 											//Box ü 
		
		String syskey = StringUtil.checkString(box.getString("syskey"));
		
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		try {
			FfsQ050BG params = new FfsQ050BG();
			
			params.setSyskey(syskey);
			
			//EJB LookUp
			FfsAllSL sl = (FfsAllSL)EJBFinder.lookup("ejb/FfsAllSL");
			Hashtable hashData  = sl.selLandedDetail(params);
			req.setAttribute("hashData",hashData);
			req.setAttribute("returnValue","Y");
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:FfsQ050Serv:checkTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"check");
				return;
			} else {
				Logger.debug.println("[BASE:FfsQ050Serv:checkTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"check");
				return;
			}
		} 
	}//end checkTask
}
