package kal.base.ffs.serv;

import java.rmi.RemoteException;
import java.util.Hashtable;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import kal.base.com.util.StringUtil;
import kal.base.ffs.dbbean.FfsQ110BG;
import kal.base.ffs.ejb.FfsAllSL;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.Box;
import kal.base.jdf.serv.HttpUtility;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.sys.dbbean.SysA010BG;

/**
 * 20160301 ߰
 */
public class FfsQ090Serv extends PublicBaseServlet {

	public void updateTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);
		
		String staffNum = StringUtil.checkString(box.getString("kEmpNo"));
		String firstLegFltDt = StringUtil.checkString(box.getString("kFirstLegFltDt"));
		String fltNum = StringUtil.checkString(box.getString("kFltNum"));
		String stnfr = StringUtil.checkString(box.getString("kStnfr"));
		String stnto = StringUtil.checkString(box.getString("kStnto"));
		String regno = StringUtil.checkString(box.getString("kRegno"));
		String cat = "ACARSTmpst";
		String smi = StringUtil.checkString(box.getString("kSmi"));
		
		String returnPage = StringUtil.checkString(box.getString("returnPage"));
		
		try {
			FfsQ110BG params = new FfsQ110BG();
			params.setCat(cat);
			params.setStaffNum(staffNum);
			params.setFirstLegFltDt(firstLegFltDt);
			params.setFltNum(fltNum);
			params.setStnfr(stnfr);
			params.setStnto(stnto);
			
			//2016.07.27 ߰
			params.setRegno(regno);
			
			FfsAllSL sl = (FfsAllSL)EJBFinder.lookup("ejb/FfsAllSL");
			boolean flag = sl.setUserAlert(params);
			if (flag) req.setAttribute("dataComplete","S");
			else throw new Exception(" ߻.");
			
			params.setSmi(smi);
			//Hashtable hashData  = sl.selAcarsRawMsgRE(fltNum, smi);
			Hashtable hashData  = sl.selAcarsRawMsgRERev(params);
			
			req.setAttribute("hashData",hashData);
			
			printJspPage(req, res, returnPage);
			
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:FfsQ090Serv:updateTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
				return;
			} else {
				Logger.debug.println("[BASE:FfsQ090Serv:updateTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
				return;
			}
		} 
	}
	
	//20160715 ߰
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);
		
		String staffNum = StringUtil.checkString(box.getString("kEmpNo"));
		String firstLegFltDt = StringUtil.checkString(box.getString("kFirstLegFltDt"));
		String regno = StringUtil.checkString(box.getString("kRegno"));
		String fltNum = StringUtil.checkString(box.getString("kFltNum"));
		String stnfr = StringUtil.checkString(box.getString("kStnfr"));
		String stnto = StringUtil.checkString(box.getString("kStnto"));
		
		String returnPage = StringUtil.checkString(box.getString("returnPage"));
		
		try {
			FfsQ110BG params = new FfsQ110BG();
			params.setStaffNum(staffNum);
			params.setFirstLegFltDt(firstLegFltDt);
			params.setRegno(regno);
			params.setFltNum(fltNum);
			params.setStnfr(stnfr);
			params.setStnto(stnto);
			
			//2016.07.27 ߰
			params.setRegno(regno);
			
			params.setQueryFlag("UP");
			
			FfsAllSL sl = (FfsAllSL)EJBFinder.lookup("ejb/FfsAllSL");
			Hashtable hashData  = sl.selAcarsRawMsgRERev(params);
			
			req.setAttribute("hashData",hashData);
			
			printJspPage(req, res, returnPage);
			
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:FfsQ090Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
				return;
			} else {
				Logger.debug.println("[BASE:FfsQ090Serv:selectTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
				return;
			}
		} 
	}
	
	//20160715 ߰
	public void insertTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		
		Box box = HttpUtility.getBox(req);
		HttpSession session = req.getSession();
		
		
		String p_firstLegFltDt = StringUtil.checkString(box.getString("firstLegFltDt"));
		String p_regno = StringUtil.checkString(box.getString("regno"));
		String p_fltNum = StringUtil.checkString(box.getString("fltNum"));
		String p_stnfr = StringUtil.checkString(box.getString("stnfr"));
		String p_stnto = StringUtil.checkString(box.getString("stnto"));
		String p_empNo = StringUtil.checkString(box.getString("empNo"));
		String p_msg = StringUtil.checkString(box.getString("msg"));
		
		String returnPage = StringUtil.checkString(box.getString("returnPage"));
		/*
		System.out.println("p_firstLegFltDt -> " + p_firstLegFltDt);
		System.out.println("p_regno -> " + p_regno);
		System.out.println("p_fltNum -> " + p_fltNum);
		System.out.println("p_stnfr -> " + p_stnfr);
		System.out.println("p_stnto -> " + p_stnto);
		System.out.println("p_empNo -> " + p_empNo);
		System.out.println("p_msg -> " + p_msg);
		*/
		
		try {
			
			String result = "N:";
			
			SysA010BG UserInfo = (SysA010BG)session.getAttribute("USERINFO");
			
			//2016.08.17 ޽  ϴܿ From μ  ߰
			p_msg = p_msg + "\n From "+ UserInfo.getDept_c()+ " " +UserInfo.getEmp_no();

			if(p_firstLegFltDt.length()==0||p_regno.length()==0||p_fltNum.length()==0||p_stnfr.length()==0||p_empNo.length()==0||p_msg.length()==0) {
				result = "N:need a field values";
			} else {			
				FfsAllSL sl = (FfsAllSL)EJBFinder.lookup("ejb/FfsAllSL");			
				result = sl.selFuncSendToAcars(p_firstLegFltDt, p_regno, p_fltNum, p_stnfr,p_stnto, p_empNo, p_msg);
			}

			req.setAttribute("dataComplete", result);
			
			printJspPage(req, res, returnPage);
			
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:FfsQ090Serv:insertTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
				return;
			} else {
				Logger.debug.println("[BASE:FfsQ090Serv:insertTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
				return;
			}
		} 
	}
}
