package kal.base.ffs.serv;

import java.rmi.RemoteException;
import java.util.Hashtable;
import java.util.List;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import kal.base.com.util.*;
import kal.base.com.serv.*;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.Box;
import kal.base.jdf.serv.HttpUtility;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.sys.dbbean.SysA010BG;
import kal.base.ffs.dbbean.FfsQ230BG;
import kal.base.ffs.ejb.FfsAllSL;

/**
 * Flight Plan ȸ Servlet Class
 * @version 	1.0
 * @author Copyright (c) 2007/07/02 
 */
public class FfsQ230Serv extends PublicBaseServlet {
	/** 
	  * Flight Plan ȸ Servlet Class - selectTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2007/07/02 
	  */	
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 											//Box ü 
		
		String firstLegFltDt = StringUtil.checkString(box.getString("firstLegFltDt"));
		String fltNum = StringUtil.checkString(box.getString("fltNum"));
		String stnfr = StringUtil.checkString(box.getString("stnfr"));
		String stnto = StringUtil.checkString(box.getString("stnto"));
		
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		try {
			FfsQ230BG params = new FfsQ230BG();
			
			params.setFirstLegFltDt(firstLegFltDt);
			params.setFltNum(fltNum);
			params.setStnfr(stnfr);
			params.setStnto(stnto);
			
			//EJB LookUp
			FfsAllSL sl = (FfsAllSL)EJBFinder.lookup("ejb/FfsAllSL");
			Hashtable hashData  = sl.selFltPlanInfo(params);
			req.setAttribute("hashData",hashData);
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:FfsQ230Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
				return;
			} else {
				Logger.debug.println("[BASE:FfsQ230Serv:selectTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
				return;
			}
		} 
	}//end selectTask
	
	/**
	 * Flight Plan transmission Servlet Class
	 * @version 	1.0
	 * @author Copyright (c) 2012/07/04 
	 */
	public void checkTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);
		
		String returnPage = StringUtil.checkString(box.getString("returnPage"));
		
		try {
			
			//EJB LookUp
			FfsAllSL sl = (FfsAllSL)EJBFinder.lookup("ejb/FfsAllSL");
			List dspCdList = sl.selDspCdList();
			req.setAttribute("dspCdList",dspCdList);
			
			//  
			printJspPage(req, res, returnPage);
		} catch(Exception e){
			if(e instanceof RemoteException){
				Logger.debug.println("[BASE:FfsQ230Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(), returnPage,"select");
				return;
			} else {
				Logger.debug.println("[BASE:FfsQ230Serv:selectTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(), returnPage,"select");
				return;
			}
		} 
	}//end selectTask
	
	/**
	 * Flight Plan transmission Servlet Class
	 * @version 	1.0
	 * @author Copyright (c) 2012/07/04 
	 */
	public void insertTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);
		
		String firstLegFltDt = StringUtil.checkString(box.getString("firstLegFltDt"));
		String fltNum = StringUtil.checkString(box.getString("fltNum"));
		String stnfr = StringUtil.checkString(box.getString("stnfr"));
		String stnto = StringUtil.checkString(box.getString("stnto"));
		
        //	Message Send Params
		String emailTxt = StringUtil.checkString(box.getString("email_txt"));
		String sitaTxt = StringUtil.checkString(box.getString("sita_txt"));
		String aftnTxt = StringUtil.checkString(box.getString("aftn_txt"));
		String acarsTxt = StringUtil.checkString(box.getString("acars_txt"));
		String faxTxt = StringUtil.checkString(box.getString("fax_txt"));
		String senderTxt = StringUtil.checkString(box.getString("sender_txt"));
		String originTxt = StringUtil.checkString(box.getString("origin_txt"));
		String dspCd = StringUtil.checkString(box.getString("dsp_cd"));
		
		String returnPage = StringUtil.checkString(box.getString("returnPage"));
		
		HttpSession session = req.getSession();
		
		try {
			FfsQ230BG params = new FfsQ230BG();
			
			params.setFirstLegFltDt(firstLegFltDt);
			params.setFltNum(fltNum);
			params.setStnfr(stnfr);
			params.setStnto(stnto);
			
			
			FfsAllSL sl = (FfsAllSL)EJBFinder.lookup("ejb/FfsAllSL");
			
			Hashtable hashData = sl.selFltPlanInfo(params);
			
			FfsQ230BG sendParam = (FfsQ230BG)hashData.get("FPLINFO");
			
			sendParam.setFirstLegFltDt(firstLegFltDt);
			sendParam.setFltNum(fltNum);
			sendParam.setStnfr(stnfr);
			sendParam.setStnto(stnto);
			
			sendParam.setEmail_txt(emailTxt);
			sendParam.setSita_txt(sitaTxt);
			sendParam.setAftn_txt(aftnTxt);
			sendParam.setFax_txt(faxTxt);
			sendParam.setSender_txt(senderTxt);
			sendParam.setOrigin_txt(originTxt);
			sendParam.setDsp_cd(dspCd);
			
			SysA010BG UserInfo = (SysA010BG)session.getAttribute("USERINFO");
			String empNo = StringUtil.checkString(UserInfo.getEmp_no());
			
			sendParam.setEmpNo(empNo);
			
			boolean returnValue = sl.sendFplMsg(sendParam);
			
			if(returnValue) req.setAttribute("dataComplete", "S");
			else throw new Exception(" ");
			
			//  
			printJspPage(req, res, returnPage);
		} catch(Exception e){
			if(e instanceof RemoteException){
				Logger.debug.println("[BASE:FfsQ230Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(), returnPage,"select");
				return;
			} else {
				Logger.debug.println("[BASE:FfsQ230Serv:selectTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(), returnPage,"select");
				return;
			}
		} 
	}//end selectTask
	
}
