package kal.base.ffs.serv;

import java.io.PrintWriter;
import java.net.URLDecoder;
import java.rmi.RemoteException;
import java.util.Hashtable;
import java.util.List;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import kal.base.com.util.StringUtil;
import kal.base.ffs.dbbean.FfsQ240BG;
import kal.base.ffs.ejb.FfsAllSL;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.Box;
import kal.base.jdf.serv.HttpUtility;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.sys.dbbean.SysA010BG;

/**
 * Flight Plan ȸ Servlet Class
 * @version 	1.0
 * @author sunpark
 * 20140903
 */
public class FfsQ240ServRev extends PublicBaseServlet {
	/** 
	  * Flight Plan ȸ Servlet Class - selectTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author sunpark
	  */	
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 											//Box ü 
		
		String firstLegFltDt = StringUtil.checkString(box.getString("firstLegFltDt"));
		String fltNum = StringUtil.checkString(box.getString("fltNum"));
		String stnfr = StringUtil.checkString(box.getString("stnfr"));
		String stnto = StringUtil.checkString(box.getString("stnto"));
		String docNo = StringUtil.checkString(box.getString("docNo"));
		String prvDocNo = StringUtil.checkString(box.getString("prvDocNo"));
		
		String popupType = StringUtil.checkString(box.getString("popupType"));
		
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		try {
			FfsQ240BG params = new FfsQ240BG();
			
			params.setFirstLegFltDt(firstLegFltDt);
			params.setFltNum(fltNum);
			params.setStnfr(stnfr);
			params.setStnto(stnto);
			params.setDocNo(docNo);
			params.setPrvDocNo(prvDocNo);
			
			params.setPopupType(popupType);
			
			//EJB LookUp
			FfsAllSL sl = (FfsAllSL)EJBFinder.lookup("ejb/FfsAllSL");
			Hashtable hashData  = sl.selFltPlanWithDocInfo(params);
			req.setAttribute("hashData",hashData);
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:FfsQ240Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
				return;
			} else {
				Logger.debug.println("[BASE:FfsQ240Serv:selectTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
				return;
			}
		} 
	}//end selectTask
	
	/**
	 * Flight Plan transmission Servlet Class
	 * @version 	1.0
	 * @author sunpark
	 */
	public void checkTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);
		
		String returnPage = StringUtil.checkString(box.getString("returnPage"));
		
		try {
			
			//EJB LookUp
			FfsAllSL sl = (FfsAllSL)EJBFinder.lookup("ejb/FfsAllSL");
			List dspCdList = sl.selDspCdList();
			req.setAttribute("dspCdList",dspCdList);
			
			//  
			printJspPage(req, res, returnPage);
		} catch(Exception e){
			if(e instanceof RemoteException){
				Logger.debug.println("[BASE:FfsQ240Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(), returnPage,"select");
				return;
			} else {
				Logger.debug.println("[BASE:FfsQ240Serv:selectTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(), returnPage,"select");
				return;
			}
		} 
	}//end selectTask
	
	/**
	 * Flight Plan transmission Servlet Class
	 * @version 	1.0
	 * @author sunpark
	 */
	public void insertTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);
		
		String firstLegFltDt = StringUtil.checkString(box.getString("firstLegFltDt"));
		String fltNum = StringUtil.checkString(box.getString("fltNum"));
		String stnfr = StringUtil.checkString(box.getString("stnfr"));
		String stnto = StringUtil.checkString(box.getString("stnto"));
		String docNo = StringUtil.checkString(box.getString("docNo"));
		String prvDocNo = StringUtil.checkString(box.getString("prvDocNo"));
		String acType = StringUtil.checkString(box.getString("acType"));
		String planid = StringUtil.checkString(box.getString("planid"));
		
		String popupType = StringUtil.checkString(box.getString("popupType"));
		
		String emailTxt = StringUtil.checkString(box.getString("email_txt"));
		String sitaTxt = StringUtil.checkString(box.getString("sita_txt"));
		String aftnTxt = StringUtil.checkString(box.getString("aftn_txt"));
		String faxTxt = StringUtil.checkString(box.getString("fax_txt"));
		String senderTxt = StringUtil.checkString(box.getString("sender_txt"));
		String originSitaTxt = StringUtil.checkString(box.getString("origin_sita_txt"));
		
		//String noteTextArea = StringUtil.checkString(box.getString("noteTextArea"));
		String noteTextArea = StringUtil.checkString(box.getString("noteTextAreaEncode"));
		
		String emailChkOptn = StringUtil.checkString(box.getString("emailChkOptn"));
		String sitaChkOptn = StringUtil.checkString(box.getString("sitaChkOptn"));
		String aftnChkOptn = StringUtil.checkString(box.getString("aftnChkOptn"));
		String faxChkOptn = StringUtil.checkString(box.getString("faxChkOptn"));
		
		//20141210 ߰
		String isMove = StringUtil.checkString(box.getString("isMove"));
		
		String returnPage = StringUtil.checkString(box.getString("returnPage"));
		
		HttpSession session = req.getSession();
		
		try {
			FfsQ240BG params = new FfsQ240BG();
			
			params.setFirstLegFltDt(firstLegFltDt);
			params.setFltNum(fltNum);
			params.setStnfr(stnfr);
			params.setStnto(stnto);
			params.setDocNo(docNo);
			
			FfsAllSL sl = (FfsAllSL)EJBFinder.lookup("ejb/FfsAllSL");
			
			Hashtable hashData = sl.selFltPlanDocInfoForRelease(params);
			
			FfsQ240BG releaseParam = (FfsQ240BG)hashData.get("FPLINFO");
			
			releaseParam.setFirstLegFltDt(firstLegFltDt);
			releaseParam.setFltNum(fltNum);
			releaseParam.setStnfr(stnfr);
			releaseParam.setStnto(stnto);
			releaseParam.setDocNo(docNo);
			releaseParam.setPrvDocNo(prvDocNo);
			releaseParam.setActyp(acType);
			releaseParam.setPlanid(planid);
			
			releaseParam.setPopupType(popupType);
			
			releaseParam.setEmailTxt(emailTxt);
			//20150717 
			//releaseParam.setSitaTxt(sitaTxt);
			String sitaTxtAddedOrigin = !"".equals(sitaTxt) ? sitaTxt + " " + originSitaTxt : "";
			releaseParam.setSitaTxt(sitaTxtAddedOrigin);
			
			releaseParam.setAftnTxt(aftnTxt);
			releaseParam.setFaxTxt(faxTxt);
			releaseParam.setSenderTxt(senderTxt);
			releaseParam.setOriginSitaTxt(originSitaTxt);
			
			releaseParam.setEmailOptn(emailChkOptn);
			releaseParam.setSitaOptn(sitaChkOptn);
			releaseParam.setAftnOptn(aftnChkOptn);
			releaseParam.setFaxOptn(faxChkOptn);
			
			noteTextArea = URLDecoder.decode(noteTextArea, "UTF-8");
			//noteTextArea = noteTextArea.replaceAll("'", "''");
			releaseParam.setNote(noteTextArea);
			
			//20141210 ߰
			releaseParam.setIsMove(isMove);
			
			SysA010BG UserInfo = (SysA010BG)session.getAttribute("USERINFO");
			String empNo = StringUtil.checkString(UserInfo.getEmp_no());
			
			releaseParam.setEmpNo(empNo);
			
			boolean returnValue = sl.releaseFltPlanDocInfo(releaseParam);
			
			//20141210 
			//if(returnValue) req.setAttribute("dataComplete", "S");
			//else throw new Exception(" ");
			if(returnValue) {
				if("Y".equals(isMove)){
					req.setAttribute("dataComplete", "MS");
				} else {
					req.setAttribute("dataComplete", "RS");
				}
			} else {
				throw new Exception(" ");
			}
			
			//  
			printJspPage(req, res, returnPage);
		} catch(Exception e){
			e.printStackTrace();
			if(e instanceof RemoteException){
				Logger.debug.println("[BASE:FfsQ240Serv:selectTask] "+((RemoteException)e).getMessage());
				req.setAttribute("isError", "Y");
				printMessagePage2(req, res, e.getMessage(), returnPage,"select");
				return;
			} else {
				Logger.debug.println("[BASE:FfsQ240Serv:selectTask] "+((Exception)e).getMessage());
				req.setAttribute("isError", "Y");
				printMessagePage2(req, res, e.getMessage(), returnPage,"select");
				return;
			}
		} 
	}//end selectTask
	
	//20160301 ߰
	public void updateTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);
		
		String firstLegFltDt = StringUtil.checkString(box.getString("firstLegFltDt"));
		String fltNum = StringUtil.checkString(box.getString("fltNum"));
		String stnfr = StringUtil.checkString(box.getString("stnfr"));
		String stnto = StringUtil.checkString(box.getString("stnto"));
		String altPort = StringUtil.checkString(box.getString("altPort"));
		String edtoPort = StringUtil.checkString(box.getString("edtoPort"));
		String refile = StringUtil.checkString(box.getString("refile"));
		String actyp = StringUtil.checkString(box.getString("actyp"));
		
		try {
			FfsQ240BG params = new FfsQ240BG();
			params.setFirstLegFltDt(firstLegFltDt);
			params.setFltNum(fltNum);
			params.setStnfr(stnfr);
			params.setStnto(stnto);
			params.setAltPort(altPort);
			params.setEdtoPort(edtoPort);
			params.setRefile(refile);
			params.setActyp(actyp);
			
			FfsAllSL sl = (FfsAllSL)EJBFinder.lookup("ejb/FfsAllSL");
			Hashtable hashtable = sl.selFlightPlanCheck(params);
			String checkList = (String)hashtable.get("CHECK_LIST");
			
			res.setContentType("text/html;charset=UTF-8");
			res.setHeader("Cache-Control", "no-cache");
			PrintWriter out = res.getWriter();
			out.write(checkList);
			out.close();
			
			//RequestDispatcher dispatcher = getServletContext().getRequestDispatcher(null);
			//dispatcher.forward(req, res);
			
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:FfsQ240Serv:selectTask] "+((RemoteException)e).getMessage());
				return;
			} else {
				Logger.debug.println("[BASE:FfsQ240Serv:selectTask] "+((Exception)e).getMessage());
				return;
			}
		} 
	}
}
