package kal.base.ffs.serv;

import java.rmi.RemoteException;
import java.util.Hashtable;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import kal.base.com.serv.ComUtil;
import kal.base.com.util.*;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.Box;
import kal.base.jdf.serv.HttpUtility;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.ffs.dbbean.FfsQ410BG;
import kal.base.ffs.ejb.FfsAllSL;

/**
 * Fuel & Weight ȸ Servlet Class
 * @version 	1.0
 * @author Copyright (c) 2009/06/05 
 */
public class FfsQ410Serv extends PublicBaseServlet {
	/** 
	  * Fuel & Weight ȸ Servlet Class - selectTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2009/06/05 
	  */	
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 											//Box ü 
		
		String frDate = StringUtil.checkString(box.getString("fr_date"));
		String toDate = StringUtil.checkString(box.getString("to_date"));
		String fltNum = StringUtil.checkString(box.getString("flt_num"));
		String stnfr = StringUtil.checkString(box.getString("stnfr"));
		String stnto = StringUtil.checkString(box.getString("stnto"));
		String RegionCdAll = StringUtil.checkString(box.getString("region_cd"));
		
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		try {
			
			String regionCd = "";
			
			if (!RegionCdAll.equals("")) {
				int cnt = RegionCdAll.length() / 3;
				for (int n=1; n<=cnt; n++) {
					if (regionCd.equals("")) regionCd = "'" + RegionCdAll.substring((n*3)-3,n*3) + "'";
					else regionCd = regionCd + ", '" + RegionCdAll.substring((n*3)-3,n*3) + "'";
				}
			}
			
			//System.out.println("RegionCdAll====>" + RegionCdAll);
			//System.out.println("regionCd====>" + regionCd);
			
			FfsQ410BG params = new FfsQ410BG();
			
			params.setPFrDate(frDate);
			params.setPToDate(toDate);
			params.setPFltNum(fltNum);
			params.setPStnfr(stnfr);
			params.setPStnto(stnto);
			params.setPRegionCd(regionCd);
			
			//EJB LookUp
			FfsAllSL sl = (FfsAllSL)EJBFinder.lookup("ejb/FfsAllSL");
			Hashtable hashData  = sl.selFuelWeight(params);
			if (hashData != null){
				req.setAttribute("successMessage",ComUtil.getInstance().getMessage("Fuel & Weight", hashData, "FUEL_WEIGHT_LIST", MessageCode.getInstance().DATA_MSG));
			}
			req.setAttribute("hashData",hashData);
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:FfsQ410Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
				return;
			} else {
				Logger.debug.println("[BASE:FfsQ410Serv:selectTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
				return;
			}
		} 
	}//end selectTask
}
