package kal.base.ffs.serv;

import java.io.BufferedOutputStream;
import java.io.BufferedWriter;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.rmi.RemoteException;
import java.util.Hashtable;
import java.util.LinkedList;
import java.util.List;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import kal.base.com.serv.ComUtil;
import kal.base.com.util.MessageCode;
import kal.base.com.util.StringUtil;
import kal.base.ffs.dbbean.TrkQ010BG;
import kal.base.ffs.ejb.FfsAllSL;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.Box;
import kal.base.jdf.serv.HttpUtility;
import kal.base.pbf.serv.PublicBaseServlet;

public class TrkQ010Serv extends PublicBaseServlet{
    
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
    	Box box = HttpUtility.getBox(req);
    	
    	String returnPage = StringUtil.checkString(box.getString("returnPage"));
    	
    	try{
    		//EJB Parameter 
    		TrkQ010BG params = new TrkQ010BG();
    		
    		params.setStart_date(box.getString("start_date"));
    		params.setEnd_date(box.getString("end_date"));
    		params.setFlt_num(box.getString("flt_num"));
    		params.setStn_fr(box.getString("stn_fr"));
    		params.setStn_to(box.getString("stn_to"));
    		params.setRegNo(box.getString("regNo"));
    		params.setRoute(box.getString("route"));//@2013-08-23 params.setRoute(box.get("route"));
    		
    		//EJB LookUp
    		FfsAllSL sl = (FfsAllSL)EJBFinder.lookup("ejb/FfsAllSL");
    		Hashtable hashData = sl.selTrkQ010Main(params);
    		
    		if(hashData!=null) req.setAttribute("successMessage", ComUtil.getInstance().getMessage("Flight Track", hashData, "HASHDATA", MessageCode.getInstance().DATA_MSG));////@=================Hashtable Ѱִ 
    		req.setAttribute("hashData", hashData);
    		
    		//  
    		printJspPage(req, res, returnPage);
    	}catch(Exception e){
    		if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SkdQ010Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			} else {
				Logger.debug.println("[BASE:SkdQ010Serv:selectTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			}
    	}
    }
	
	/*public void checkTask(HttpServletRequest req, HttpServletResponse res) throws Exception{
		Box box = HttpUtility.getBox(req);
		
		String returnPage = StringUtil.checkString(box.get("returnPage"));
		
		String[] plan = req.getParameterValues("h_plan");
		String[] act = req.getParameterValues("h_act");
		String[] first_leg_flt_dt = req.getParameterValues("h_first_leg_flt_dt");
		String[] flt_num = req.getParameterValues("h_flt_num");
		String[] stn_fr = req.getParameterValues("h_stn_fr");
		
		try{
            //	EJB Parameter 
			List trkList = new LinkedList();
			
			for(int i=0;i<plan.length;i++){
				if(plan[i].equals("Y")||act[i].equals("Y")){				
					TrkQ010BG params = new TrkQ010BG();
					
					if(plan[i].equals("N")){
						params.setPlan("N");
					}else{
						params.setPlan("Y");
					}
					if(act[i].equals("N")){
						params.setAct("N");
					}else{
						params.setAct("Y");
					}
					
					params.setFirst_leg_flt_dt(first_leg_flt_dt[i]);
					params.setFlt_num(flt_num[i]);
					params.setStn_fr(stn_fr[i]);
					
					trkList.add(params);
				}
			}
			
            //	EJB LookUp
    		FfsAllSL sl = (FfsAllSL)EJBFinder.lookup("ejb/FfsAllSL");
    		Hashtable hashtable = sl.downloadTrkKml(trkList);
    		String fileName = (String)hashtable.get("fileName");
    		String kmlContent = (String)hashtable.get("KmlContent");
    		
    		res.setContentType("text/html");
    		res.setHeader("Content-Disposition", "attachment;filename="+fileName);
    		BufferedWriter bw= new BufferedWriter(new OutputStreamWriter(res.getOutputStream()));
    		bw.write(kmlContent);    		
    		bw.flush();
    		
    		//  
    		//printJspPage(req, res, returnPage);
		}catch(Exception e){
			if(e instanceof RemoteException) {
				Logger.err.println("[BASE:SkdQ010Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(), returnPage, "check");
			}else{
				Logger.err.println("[BASE:TrkQ010Serv:checkTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(), returnPage, "check");
			}
		}
	}
	*/
	
	public void checkTask(HttpServletRequest req, HttpServletResponse res) throws Exception{
		Box box = HttpUtility.getBox(req);
		
		String returnPage = StringUtil.checkString(box.get("returnPage"));
		
		String type = StringUtil.checkString(box.getString("type"));
		String[] h_plan = req.getParameterValues("h_plan");
		String[] h_foqa = req.getParameterValues("h_foqa");
		String[] h_turbulence = req.getParameterValues("h_turbulence");
		String[] h_noise = req.getParameterValues("h_noise");
		String[] first_leg_flt_dt = req.getParameterValues("h_first_leg_flt_dt");
		String[] flt_num = req.getParameterValues("h_flt_num");
		String[] stn_fr = req.getParameterValues("h_stn_fr");
		String[] stn_to = req.getParameterValues("h_stn_to");
		
		List trkList = new LinkedList();
		
		List planList				= new LinkedList();//@2013-12-04
		List foqaList				= new LinkedList();//@2013-12-04
		List turbulenceList	= new LinkedList();//@2013-12-04
		List noiseList				= new LinkedList();//@2013-12-04
		
		try{
			if(type.equals("row")){//@2013-12-04	row ߰
				TrkQ010BG params = new TrkQ010BG();
				
				params.setFirst_leg_flt_dt(first_leg_flt_dt[0]);
				params.setFlt_num(flt_num[0]);
				params.setStn_fr(stn_fr[0]);
				params.setStn_to(stn_to[0]);
				
				if(h_plan[0].equals("Y")){
					planList.add(params);
				}
				if(h_foqa[0].equals("Y")){
					foqaList.add(params);
				}
				if(h_turbulence[0].equals("Y")){
					turbulenceList.add(params);
				}
				if(h_noise[0].equals("Y")){
					noiseList.add(params);
				}				
			}else{
		        //	EJB Parameter 
				for(int i=0;i<first_leg_flt_dt.length;i++){
					if(type.equals("plan")){
						if(h_plan[i].equals("Y")){
							TrkQ010BG params = new TrkQ010BG();
							
							params.setFirst_leg_flt_dt(first_leg_flt_dt[i]);
							params.setFlt_num(flt_num[i]);
							params.setStn_fr(stn_fr[i]);
							params.setStn_to(stn_to[i]);
							
							trkList.add(params);
						}
					}else if(type.equals("foqa")){
						if(h_foqa[i].equals("Y")){
							TrkQ010BG params = new TrkQ010BG();
							
							params.setFirst_leg_flt_dt(first_leg_flt_dt[i]);
							params.setFlt_num(flt_num[i]);
							params.setStn_fr(stn_fr[i]);
							params.setStn_to(stn_to[i]);
							
							trkList.add(params);
						}
					}else if(type.equals("turbulence")){
						if(h_turbulence[i].equals("Y")){
							TrkQ010BG params = new TrkQ010BG();
							
							params.setFirst_leg_flt_dt(first_leg_flt_dt[i]);
							params.setFlt_num(flt_num[i]);
							params.setStn_fr(stn_fr[i]);
							params.setStn_to(stn_to[i]);
							
							trkList.add(params);
						}
					}else if(type.equals("noise")){
						if(h_noise[i].equals("Y")){
							TrkQ010BG params = new TrkQ010BG();
							
							params.setFirst_leg_flt_dt(first_leg_flt_dt[i]);
							params.setFlt_num(flt_num[i]);
							params.setStn_fr(stn_fr[i]);
							params.setStn_to(stn_to[i]);
							
							trkList.add(params);
						}
					}				
			    }				
			}
	 
				
			
            //	EJB LookUp
    		FfsAllSL sl = (FfsAllSL)EJBFinder.lookup("ejb/FfsAllSL");
    		Hashtable hashtable = null;
    		String fileName = "";
    		String kmlContent ="";
    		if(type.equals("row")){//@2013-12-04	row ߰
    			String temp="";
    			fileName = first_leg_flt_dt[0] + "_" +  stn_fr[0]+ "_" +stn_to[0]+ "_KE"+flt_num[0];//+"_ALL"+".kml";

				if(h_plan[0].equals("Y")){
					 hashtable = sl.downloadPlanKml(planList);        		
					 temp += (String)hashtable.get("KmlContent");
					 fileName	+="_P";
				}
				if(h_foqa[0].equals("Y")){
					hashtable = sl.downloadFoqaKml(foqaList);        	
					 temp += (String)hashtable.get("KmlContent");
					 fileName	+="_F";
				}
				if(h_turbulence[0].equals("Y")){
					hashtable = sl.downloadTurbulenceKml(turbulenceList);
					temp += (String)hashtable.get("KmlContent");
					 fileName	+="_T";
				}
				if(h_noise[0].equals("Y")){
					hashtable = sl.downloadNoiseKml(noiseList);
					 temp += (String)hashtable.get("KmlContent");
					 fileName	+="_N";
				}	
				fileName	+=".kml";
				temp	=	temp.replaceAll("<kml xmns=\"http://earth.google.com/kml/2.2\">", "").replaceAll("</kml>", "").replaceAll("<Document>", "").replaceAll("</Document>", "");
				kmlContent =	"<kml xmns=\"http://earth.google.com/kml/2.2\">\n\t<Document>" +temp+"\n\t</Document>\n</kml>";

			}else{
	    		if(type.equals("plan")){
	    		    hashtable = sl.downloadPlanKml(trkList);        		
	    		}else if(type.equals("foqa")){
	    			hashtable = sl.downloadFoqaKml(trkList);        		
	    		}else if(type.equals("turbulence")){
	    			hashtable = sl.downloadTurbulenceKml(trkList);
	    		}else if(type.equals("noise")){
	    			hashtable = sl.downloadNoiseKml(trkList);
	    		}    
	    		fileName = (String)hashtable.get("fileName");
	    		kmlContent = (String)hashtable.get("KmlContent");
			}				
    		
    		res.setContentType("application/octet-stream");
    		res.setHeader("Content-Disposition", "attachment;filename="+fileName);
    		BufferedWriter bw= new BufferedWriter(new OutputStreamWriter(res.getOutputStream()));
    		bw.write(kmlContent);    		
    		bw.flush();
    		
    		//  
    		//printJspPage(req, res, returnPage);
		}catch(Exception e){
			if(e instanceof RemoteException) {
				Logger.err.println("[BASE:SkdQ010Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(), returnPage, "check");
			}else{
				Logger.err.println("[BASE:TrkQ010Serv:checkTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(), returnPage, "check");
			}
		}
	}
	
	public void performTask(HttpServletRequest req, HttpServletResponse res) throws Exception{
		Box box = HttpUtility.getBox(req);
		
		String returnPage = StringUtil.checkString(box.get("returnPage"));
		
		String first_leg_flt_dt = StringUtil.checkString(box.get("first_leg_flt_dt"));
		String flt_num = StringUtil.checkString(box.get("flt_num"));
		String stn_fr = StringUtil.checkString(box.get("stn_fr"));
		String stn_to = StringUtil.checkString(box.get("stn_to"));
		
		List trkList = new LinkedList();
		
		try{
            //	EJB Parameter 
			TrkQ010BG params = new TrkQ010BG();
			params.setFirst_leg_flt_dt(first_leg_flt_dt);
			params.setFlt_num(flt_num);
			params.setStn_fr(stn_fr);
			params.setStn_to(stn_to);
			
            //	EJB LookUp
    		FfsAllSL sl = (FfsAllSL)EJBFinder.lookup("ejb/FfsAllSL");
    		Hashtable hashData =  sl.selWptInfoForExcel(params);
    		
    		req.setAttribute("hashData",hashData);
    		
    		//  
    		printJspPage(req, res, returnPage);
		}catch(Exception e){
			if(e instanceof RemoteException) {
				Logger.err.println("[BASE:SkdQ010Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(), returnPage, "check");
			}else{
				Logger.err.println("[BASE:TrkQ010Serv:checkTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(), returnPage, "check");
			}
		}
	}
}
