package kal.base.iro.serv;

import java.rmi.RemoteException;
import java.util.*;
import javax.servlet.http.*;

import kal.base.com.util.*;
import kal.base.com.serv.*;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.*;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.iro.dbbean.*;
import kal.base.iro.ejb.IroAllSL;
import kal.base.sys.dbbean.*;

/**
 * IRR/DSS Decision Option Comparison Servlet Class
 * @version 	1.0
 * @author Copyright (c) 2005/02/07 HIST  
 */
public class IroA030Serv extends PublicBaseServlet{
	
	/** 
	  *  IRR/DSS Decision Option Comparison Flight Info ȸ Servlet Class - checkTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/02/07 HIST  
	  */		
	public void checkTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 															//Box ü 
		String mode = StringUtil.checkString(box.getString("p_mode"));							// / NEW 
		String deskX = StringUtil.checkString(box.getString("p_desk_x"));						//Desk 
		String firstLegFltDt = StringUtil.checkString(box.getString("p_first_leg_flt_dt"));		//First Leg Flt Dt
		String fltNum = StringUtil.checkString(box.getString("p_flt_num"));							//Flt Num
		String stnFr = StringUtil.checkString(box.getString("p_stnfr"));								//Station From
		String stnTo = StringUtil.checkString(box.getString("p_stnto"));							//Station To
		String seqNum = StringUtil.checkString(box.getString("p_seq_num"));					//Seq Number
		String optionNum = StringUtil.checkString(box.getString("p_option_num"));			//Option Number
		String returnPage = StringUtil.checkString(box.getString("returnPage"));				//Return Page ȹ
		HttpSession session = req.getSession();
		//String empNo = StringUtil.checkString((String)session.getAttribute("emp_no"));
		//String empNo = "0000180";
		
		try {
			SysA010BG UserInfo = (SysA010BG)session.getAttribute("USERINFO");
			//Desk  SessionԷ
			if (deskX != null && !deskX.equals("")) {
				session = req.getSession();
				session.setAttribute("desk_x",deskX);
			} else throw new Exception("Desk  ϴ.");
			//ʱ Number 
			req.setAttribute("seqNum",seqNum);
			req.setAttribute("optionNum",optionNum);
			req.setAttribute("mode",mode);
			
			//EJB Parameter 
			IroA030BG params = new IroA030BG();
			params.setMode(mode);
			params.setFirst_leg_flt_dt(firstLegFltDt);
			params.setFlt_num(fltNum);
			params.setStnfr(stnFr);
			params.setStnto(stnTo);
			params.setSeq_num(seqNum);
			params.setEmp_no(UserInfo.getEmp_no());
			
			//EJB LookUp
			IroAllSL sl = (IroAllSL)EJBFinder.lookup("ejb/IroAllSL");
			Hashtable hashData  = sl.selIroA030FltInfo(params);
			req.setAttribute("hashData",hashData);
			req.setAttribute("returnParam","Y");
			if (hashData != null) req.setAttribute("successMessage",ComUtil.getInstance().getMessage("Option Comparison", null, "", "KE"+fltNum+" "+MessageCode.getInstance().SELECT_MSG));
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:IroA030Serv:checkTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"v");
			} else {
				Logger.debug.println("[BASE:IroA030Serv:checkTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"check");
			}
		} 
	}//end checkTask	
	
	/** 
	  *  IRR/DSS Option Comparison Main Servlet Class - selectTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/02/07 HIST  
	  */		
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 														//Box ü 
		String firstLegFltDt = StringUtil.checkString(box.getString("first_leg_flt_dt"));		//First Leg Flt Dt
		String fltNum = StringUtil.checkString(box.getString("flt_num"));						//Flt Num
		String stnFr = StringUtil.checkString(box.getString("stnfr"));								//Station From
		String stnTo = StringUtil.checkString(box.getString("stnto"));							//Station To
		String returnPage = StringUtil.checkString(box.getString("returnPage"));			//Return Page ȹ
		//ġ
		String seqNum = StringUtil.checkString(box.getString("r_seq_num"));					//Seq Number
		String optionNum = StringUtil.checkString(box.getString("r_option_num"));			//Option Number
		
		try {
			req.setAttribute("seqNum",seqNum);
			req.setAttribute("optionNum",optionNum);
			
			//EJB Parameter 
			IroA030BG params = new IroA030BG();
			params.setFirst_leg_flt_dt(firstLegFltDt);
			params.setFlt_num(fltNum);
			params.setStnfr(stnFr);
			params.setStnto(stnTo);
			params.setSeq_num(seqNum);
			
			//EJB LookUp
			IroAllSL sl = (IroAllSL)EJBFinder.lookup("ejb/IroAllSL");
			Hashtable hashData  = sl.selIroA030Main(params);
			req.setAttribute("hashData",hashData);
			req.setAttribute("returnParam","Y");
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:IroA030Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			} else {
				Logger.debug.println("[BASE:IroA030Serv:selectTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			}
		} 
	}//end selectTask	
	
	/** 
	  *  IRR/DSS Option Comparison Option Suggest  Servlet Class - insertTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/02/07 HIST  
	  */		
	public void insertTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 														//Box ü 
		HttpSession session = null;
		String firstLegFltDt = StringUtil.checkString(box.getString("h_first_leg_flt_dt"));	//First Leg Flt Dt
		String fltNum = StringUtil.checkString(box.getString("h_flt_num"));						//Flt Num
		String stnFr = StringUtil.checkString(box.getString("h_stnfr"));							//Station From
		String stnTo = StringUtil.checkString(box.getString("h_stnto"));						//Station To
		String seqNum = StringUtil.checkString(box.getString("h_seq_num"));				//Seq Number
		String titleX = StringUtil.checkString(box.getString("h_title_x"));							//Title X ==> DLY/......
		String titleE = StringUtil.checkString(box.getString("h_title_e"));							//Title E
		String legNum = StringUtil.checkString(box.getString("h_leg_num"));				//Leg Number
		String regionFlt = StringUtil.checkString(box.getString("h_region_flt"));				//Region Flight
		String regionLeg = StringUtil.checkString(box.getString("h_region_leg"));		//Region Leg
		String returnPage = StringUtil.checkString(box.getString("returnPage"));			//Return Page ȹ
		//ġ
		String rSeqNum = StringUtil.checkString(box.getString("r_seq_num"));			//Seq Number
		String rOptionNum = StringUtil.checkString(box.getString("r_option_num"));		//Option Number
		
		try {
			session = req.getSession();
			//String empNo = StringUtil.checkString((String)session.getAttribute("emp_no"));
			SysA010BG UserInfo = (SysA010BG)session.getAttribute("USERINFO");
			String empNo = UserInfo.getEmp_no();
			
			if (empNo.equals("")) throw new Exception(MessageCode.getInstance().ID_EXPT);
			
			req.setAttribute("seqNum",rSeqNum);
			req.setAttribute("optionNum",rOptionNum);
			
			//EJB Parameter 
			IroA030BG params = new IroA030BG();
			params.setFirst_leg_flt_dt(firstLegFltDt);
			params.setFlt_num(fltNum);
			params.setStnfr(stnFr);
			params.setStnto(stnTo);
			params.setSeq_num(seqNum);
			params.setTitle_x(titleX);
			params.setTitle_e(StringUtil.toKSC5601(titleE));
			params.setLeg_num(legNum);
			params.setRegion_flt(regionFlt);
			params.setRegion_leg(regionLeg);
			params.setEmp_no(empNo);
			
			//EJB LookUp
			IroAllSL sl = (IroAllSL)EJBFinder.lookup("ejb/IroAllSL");
			String insMsg  = sl.insIroA030OptionDesk(params);
			if (insMsg.equals("Y")) {
				Hashtable hashData  = sl.selIroA030Main(params);
				req.setAttribute("hashData",hashData);
				req.setAttribute("returnParam","Y");
				if (hashData != null) req.setAttribute("successMessage",ComUtil.getInstance().getMessage("Option Comparison", null, "", "Suggest Option Data Inserted"));
			}
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:IroA030Serv:insertTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"insert");
			} else {
				Logger.debug.println("[BASE:IroA030Serv:insertTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"insert");
			}
		} 
	}//end selectTask	
	
}//end of Class
