package kal.base.iro.serv;

import java.rmi.RemoteException;
import java.util.*;
import javax.servlet.http.*;

import kal.base.com.util.*;
import kal.base.com.serv.*;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.*;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.iro.dbbean.IroA030BG;
import kal.base.iro.ejb.IroAllSL;
import kal.base.sys.dbbean.*;

/**
 * IRR/DSS Option Comparison Servlet Class
 * @version 	1.0
 * @author Copyright (c) 2005/02/03 HIST  
 */
public class IroA035Serv extends PublicBaseServlet{

	/** 
	  *  IRR/DSS Option Comparison Comments Servlet Class - selectTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/02/03 HIST  
	  */		
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 														//Box ü 
		// ȭ Parameter
		String firstLegFltDt = StringUtil.checkString(box.getString("first_leg_flt_dt"));		//First Leg Flt Dt
		String fltNum = StringUtil.checkString(box.getString("flt_num"));						//Flt Num
		String stnFr = StringUtil.checkString(box.getString("stnfr"));								//Station From
		String stnTo = StringUtil.checkString(box.getString("stnto"));							//Station To
		String returnPage = StringUtil.checkString(box.getString("returnPage"));			//Return Page ȹ
		//Grid ġ --  iFrame Parameter
		String seqNum = StringUtil.checkString(box.getString("seq_num"));
		String optionNum = StringUtil.checkString(box.getString("option_num"));
		
		try {
			//EJB Parameter 
			IroA030BG params = new IroA030BG();
			params.setFirst_leg_flt_dt(firstLegFltDt);
			params.setFlt_num(fltNum);
			params.setStnfr(stnFr);
			params.setStnto(stnTo);
			params.setSeq_num(seqNum);
			params.setOption_num(optionNum);
			
			//EJB LookUp
			IroAllSL sl = (IroAllSL)EJBFinder.lookup("ejb/IroAllSL");
			Hashtable hashData  = sl.selIroA030Comments(params);
			req.setAttribute("hashData",hashData);
			req.setAttribute("returnParam","Y");
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:IroA035Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			} else {
				Logger.debug.println("[BASE:IroA035Serv:selectTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			}
		} 
	}//end selectTask
	
	/** 
	  *  IRR/DSS Option Comparison CheckList Servlet Class - checkTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/02/03 HIST  
	  */		
	public void checkTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 														//Box ü 
		// ȭ Parameter
		String firstLegFltDt = StringUtil.checkString(box.getString("first_leg_flt_dt"));		//First Leg Flt Dt
		String fltNum = StringUtil.checkString(box.getString("flt_num"));						//Flt Num
		String stnFr = StringUtil.checkString(box.getString("stnfr"));								//Station From
		String stnTo = StringUtil.checkString(box.getString("stnto"));							//Station To
		String codeX = StringUtil.checkString(box.getString("code_x"));						//Code X : SHIFT MANAGER
		String deskX = StringUtil.checkString(box.getString("desk_x"));						//Desk_x : A
		String titleX =  StringUtil.checkString(box.getString("title_x"));						//Desk_x : A
		//Grid ġ --  iFrame Parameter
		String seqNum = StringUtil.checkString(box.getString("seq_num"));
		String optionNum = StringUtil.checkString(box.getString("option_num"));
		String returnPage = StringUtil.checkString(box.getString("returnPage"));			//Return Page ȹ
		
		try {
			//EJB Parameter 
			IroA030BG params = new IroA030BG();
			params.setFirst_leg_flt_dt(firstLegFltDt);
			params.setFlt_num(fltNum);
			params.setStnfr(stnFr);
			params.setStnto(stnTo);
			params.setSeq_num(seqNum);
			params.setOption_num(optionNum);
			params.setCode_x(codeX);
			params.setDesk_x(deskX);
			params.setTitle_x(titleX);
			
			//EJB LookUp
			IroAllSL sl = (IroAllSL)EJBFinder.lookup("ejb/IroAllSL");
			Hashtable hashData  = sl.selIroA030Check(params);
			req.setAttribute("hashData",hashData);
			req.setAttribute("seqNum",seqNum);
			req.setAttribute("optionNum",optionNum);
			req.setAttribute("returnParam","Y");
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:IroA035Serv:checkTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"check");
			} else {
				Logger.debug.println("[BASE:IroA035Serv:checkTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"check");
			}
		} 
	}//end checkTask	
	
	/** 
	  *  IRR/DSS Option Comparison Comment  Servlet Class - updateTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/02/05 HIST  
	  */		
	public void updateTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 														//Box ü 
		/*
		First_Leg_Flt_Dt,Flt_Num,StnFr,StnTo,Seq_Num,Desk_x --> ʹٲ Param
		Option_Num,Decision_x,Decision_e,Checklist_e,User_Id --> ٲ Param
		*/
		String firstLegFltDt = StringUtil.checkString(box.getString("first_leg_flt_dt"));		//First Leg Flt Dt
		String fltNum = StringUtil.checkString(box.getString("flt_num"));						//Flt Num
		String stnFr = StringUtil.checkString(box.getString("stnfr"));								//Station From
		String stnTo = StringUtil.checkString(box.getString("stnto"));							//Station To
		String seqNum = StringUtil.checkString(box.getString("seq_num"));
		String deskX = StringUtil.checkString(box.getString("desk_x"));						//Desk_x : A
		String optionNum = StringUtil.checkString(box.getString("option_num"));
		String decisionX = StringUtil.checkString(box.getString("decision_x"));
		String decisionE = StringUtil.checkString(box.getString("decision_e"));
		String checkListE = StringUtil.checkString(box.getString("checklist_e"));
		//String empNo = StringUtil.checkString(box.getString("emp_no"));
		String returnPage = StringUtil.checkString(box.getString("returnPage"));			//Return Page ȹ
		HttpSession session = req.getSession();
		
		try {
			//EJB Parameter 
			SysA010BG UserInfo = (SysA010BG)session.getAttribute("USERINFO");
			IroA030BG params = new IroA030BG();
			params.setFirst_leg_flt_dt(firstLegFltDt);
			params.setFlt_num(fltNum);
			params.setStnfr(stnFr);
			params.setStnto(stnTo);
			params.setSeq_num(seqNum);
			params.setDesk_x(deskX);
			params.setOption_num(optionNum);
			params.setDecision_x(decisionX);
			params.setDecision_e(StringUtil.toKSC5601(decisionE));
			params.setChecklist_e(checkListE);
			params.setEmp_no(UserInfo.getEmp_no());
			
			//EJB LookUp
			IroAllSL sl = (IroAllSL)EJBFinder.lookup("ejb/IroAllSL");
			String updMsg  = sl.updIroA030Comments(params);
			if (updMsg.equals("Y")) req.setAttribute("successMessage",ComUtil.getInstance().getMessage("Option Comparison", null, "", "Check List Inserted"));
			req.setAttribute("updMsg",updMsg);
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:IroA035Serv:updateTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"update");
			} else {
				Logger.debug.println("[BASE:IroA035Serv:updateTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"update");
			}
		} 
	}//end updateTask	
	
}//end of class
