package kal.base.iro.serv;

import java.rmi.RemoteException;
import java.util.*;
import javax.servlet.http.*;

import kal.base.com.util.*;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.*;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.iro.dbbean.*;
import kal.base.iro.ejb.IroAllSL;
import kal.base.sys.dbbean.*;

/**
 * IRR/DSS Decision Making&Action Servlet Class
 * @version 	1.0
 * @author Copyright (c) 2005/02/07 HIST  
 */
public class IroA040Serv extends PublicBaseServlet{
	
	/** 
	  *  IRR/DSS Decision Making&Action Main Servlet Class - selectTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/02/07 HIST  
	  */		
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 															//Box ü 
		String firstLegFltDt = StringUtil.checkString(box.getString("p_first_leg_flt_dt"));		//First Leg Flt Dt
		String fltNum = StringUtil.checkString(box.getString("p_flt_num"));							//Flt Num
		String stnFr = StringUtil.checkString(box.getString("p_stnfr"));								//Station From
		String stnTo = StringUtil.checkString(box.getString("p_stnto"));							//Station To
		String seqNum = StringUtil.checkString(box.getString("p_seq_num"));					//Seq Number
		String optionNum = StringUtil.checkString(box.getString("p_option_num"));			//Option Number
		//String empNo = StringUtil.checkString(box.getString("emp_no"));						//Emp Number
		String returnPage = StringUtil.checkString(box.getString("returnPage"));				//Return Page ȹ
		HttpSession session = req.getSession();
		
		try {
			//EJB Parameter 
			SysA010BG UserInfo = (SysA010BG)session.getAttribute("USERINFO");
			IroA040BG params = new IroA040BG();
			params.setFirst_leg_flt_dt(firstLegFltDt);
			params.setFlt_num(fltNum);
			params.setStnfr(stnFr);
			params.setStnto(stnTo);
			params.setSeq_num(seqNum);
			params.setOption_num(optionNum);
			params.setComplete_y("H");
			params.setEmp_no(UserInfo.getEmp_no());
			
			//EJB LookUp
			IroAllSL sl = (IroAllSL)EJBFinder.lookup("ejb/IroAllSL");
			Hashtable hashData  = sl.selIroA040Main(params);
			req.setAttribute("hashData",hashData);
			req.setAttribute("returnParam","Y");
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:IroA040Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			} else {
				Logger.debug.println("[BASE:IroA040Serv:selectTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			}
		} 
	}//end selectTask	
	
	/** 
	  *  IRR/DSS Decision Making&Action Main Servlet Class - updateTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/02/07 HIST  
	  */		
	public void updateTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 														//Box ü 
		// Parameter
		String firstLegFltDt = StringUtil.checkString(box.getString("first_leg_flt_dt"));		//First Leg Flt Dt
		String fltNum = StringUtil.checkString(box.getString("flt_num"));						//Flt Num
		String stnFr = StringUtil.checkString(box.getString("stnfr"));								//Station From
		String stnTo = StringUtil.checkString(box.getString("stnto"));							//Station To
		String seqNum = StringUtil.checkString(box.getString("seq_num"));					//Seq Number
		String optionNum = StringUtil.checkString(box.getString("option_num"));			//Option Number
		//Է Parameter
		String completeY = "Y";
		String decisionC = StringUtil.checkString(box.getString("decision_c"));			//Decision Code
		String titleE = StringUtil.checkString(box.getString("title_e"));								//Title Desc
		String decisionE = StringUtil.checkString(box.getString("decision_e"));			//Decision Desc
		String remarkE = StringUtil.checkString(box.getString("remark_e"));					//Remark Desc
		String returnPage = StringUtil.checkString(box.getString("returnPage"));			//Return Page ȹ
		
		try {
			//EJB Parameter 
			IroA040BG params = new IroA040BG();
			params.setFirst_leg_flt_dt(firstLegFltDt);
			params.setFlt_num(fltNum);
			params.setStnfr(stnFr);
			params.setStnto(stnTo);
			params.setSeq_num(seqNum);
			params.setOption_num(optionNum);
			params.setComplete_y(completeY);
			params.setDecision_c(StringUtil.toKSC5601(decisionC));
			params.setTitle_e(StringUtil.toKSC5601(titleE));
			params.setDecision_e(StringUtil.toKSC5601(decisionE));
			params.setRemark_e(StringUtil.toKSC5601(remarkE));
			
			//EJB LookUp
			IroAllSL sl = (IroAllSL)EJBFinder.lookup("ejb/IroAllSL");
			String updMsg  = sl.updIroA040Main(params);
			req.setAttribute("updMsg",updMsg);
			req.setAttribute("params",params);
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:IroA040Serv:updateTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"update");
			} else {
				Logger.debug.println("[BASE:IroA040Serv:updateTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"update");
			}
		} 
	}//end updateTask	
	
}//end of Class
