package kal.base.iro.serv;

import java.rmi.RemoteException;
import java.util.Hashtable;
import java.util.Vector;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import kal.base.com.util.StringUtil;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.Box;
import kal.base.jdf.serv.HttpUtility;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.iro.dbbean.IroA050BG;
import kal.base.iro.ejb.IroAllSL;

/**
 * ADDR BOOK Servlet Class
 * @version 	1.0
 * @author Copyright (c) 2005/02/04  
 */
public class IroA050Serv extends PublicBaseServlet{
	/** 
	  * ADDR BOOK Servlet Class - selectTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/02/04  
	  */	
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		
		Box box = HttpUtility.getBox(req);				 										    //Box ü 
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
				
		try {
			IroA050BG params = new IroA050BG();	
			//EJB LookUp
			IroAllSL sl = (IroAllSL)EJBFinder.lookup("ejb/IroAllSL");
			Hashtable hashData  = sl.selIroA050Addr(params);
			req.setAttribute("hashData",hashData);
			req.setAttribute("selFlg","Y");
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:IroA050Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			} else {
				Logger.debug.println("[BASE:IroA050Serv:selectTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			}
		} 
	}//end selectTask
	
	/** 
	  * Message Board Insert Servlet Class - insertTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/02/04  
	  */	
	public void insertTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		
		Box box = HttpUtility.getBox(req);				 										    		//Box ü 
		//IROPS Parameter
		String firstLegFltDt = StringUtil.checkString(box.getString("p_first_leg_flt_dt"));		//origin Address
		String fltNum = StringUtil.checkString(box.getString("p_flt_num"));		//origin Address
		String stnFr = StringUtil.checkString(box.getString("p_stnfr"));		//origin Address
		String stnTo = StringUtil.checkString(box.getString("p_stnto"));		//origin Address
		String seqNum = StringUtil.checkString(box.getString("p_seq_num"));		//origin Address
		String optionNum = StringUtil.checkString(box.getString("p_option_num"));		//origin Address
		//Message Parameter
		String originAddr = StringUtil.checkString(box.getString("origin_addr"));		//origin Address
		String projectNo = StringUtil.checkString(box.getString("project_no"));			//Project Number
		String msgData = StringUtil.checkString(box.getString("confirm_txt"));			//Message
		String returnPage = StringUtil.checkString(box.getString("returnPage"));		//Return Page ȹ
		
		//Logger.debug.println("[IroA050Serv] originAddr : "+originAddr);
		//Logger.debug.println("[IroA050Serv] projectNo : "+projectNo);
		//Logger.debug.println("[IroA050Serv] msgData : "+msgData);
				
		try {
			IroA050BG params = new IroA050BG();	
			params.setFirst_leg_flt_dt(firstLegFltDt);
			params.setFlt_num(fltNum);
			params.setStnfr(stnFr);
			params.setStnto(stnTo);
			params.setSeq_num(seqNum);
			params.setOption_num(optionNum);
			params.setOrigin_addr(originAddr);
			params.setProject_no(projectNo);
			params.setMsg_data(StringUtil.toKSC5601(msgData));
			
			//EJB LookUp
			IroAllSL sl = (IroAllSL)EJBFinder.lookup("ejb/IroAllSL");
			String insMsg  = sl.insIroA050Message(params);
			req.setAttribute("insMsg",insMsg);
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:IroA050Serv:insertTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),"/jsp/iro/IroA050UI.jsp","insert");
			} else {
				Logger.debug.println("[BASE:IroA050Serv:insertTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),"/jsp/iro/IroA050UI.jsp","insert");
			}
		} 
	}//end selectTask	
}
