package kal.base.iro.serv;

import java.rmi.RemoteException;
import java.util.Hashtable;
import java.util.Vector;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import kal.base.com.util.*;
import kal.base.com.serv.*;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.Box;
import kal.base.jdf.serv.HttpUtility;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.iro.dbbean.IroA110BG;
import kal.base.iro.ejb.IroAllSL;

/**
 * IROPS REPORT Servlet Class
 * @version 	1.0
 * @author Copyright (c) 2005/02/01  
 */
public class IroA110Serv extends PublicBaseServlet{
	/** 
	  * IROPS REPORT Servlet Class - selectTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/02/01  
	  */	
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		
		Box box = HttpUtility.getBox(req);				 										    //Box ü 
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
				
		try {
			IroA110BG params = new IroA110BG();	
			//EJB LookUp
			IroAllSL sl = (IroAllSL)EJBFinder.lookup("ejb/IroAllSL");
			Hashtable hashData  = sl.selIroA110Main(params);
			if (hashData != null){
				req.setAttribute("successMessage",ComUtil.getInstance().getMessage("IROPS REPORT", hashData, "IROPSINFO", MessageCode.getInstance().DATA_MSG));
			}
			req.setAttribute("hashData",hashData);
			req.setAttribute("returnParam","Y");
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:IroA110Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			} else {
				Logger.debug.println("[BASE:IroA110Serv:selectTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			}
		} 
	}//end selectTask
	
	/** 
	  * IROPS REPORT Servlet Class - updateTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/02/01  
	  */	
	public void updateTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		
		Box box = HttpUtility.getBox(req);				 										    //Box ü 
		String firstLegFltDt = StringUtil.checkString(box.getString("first_leg_flt_dt"));
		String fltNum = StringUtil.checkString(box.getString("flt_num"));
		String stnfr = StringUtil.checkString(box.getString("stnfr"));
		String stnto = StringUtil.checkString(box.getString("stnto"));
		String seqNum = StringUtil.checkString(box.getString("seq_num"));
		String optionNum = StringUtil.checkString(box.getString("option_num"));
					
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
				
		try {
			IroA110BG params = new IroA110BG();	
			
			params.setFirst_leg_flt_dt(firstLegFltDt);
			params.setFlt_num(fltNum);
			params.setStnfr(stnfr);
			params.setStnto(stnto);
			params.setSeq_num(seqNum);
			params.setOption_num(optionNum);
			
			//EJB LookUp
			IroAllSL sl = (IroAllSL)EJBFinder.lookup("ejb/IroAllSL");
			int returnValue = sl.updIroA110Main(params);
			if (returnValue == 1){
				req.setAttribute("successMessage",ComUtil.getInstance().getMessage("IROPS REPORT", null, "", MessageCode.getInstance().UPDATE_MSG));
			}
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:IroA110Serv:updateTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"update");
			} else {
				Logger.debug.println("[BASE:IroA110Serv:updateTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"update");
			}
		} 
	}//end updateTask

}
