package kal.base.iro.serv;

import java.rmi.RemoteException;
import java.util.Hashtable;
import java.util.Vector;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import kal.base.com.util.StringUtil;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.Box;
import kal.base.jdf.serv.HttpUtility;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.iro.dbbean.IroA110BG;
import kal.base.iro.dbbean.IroA010BG;
import kal.base.iro.ejb.IroAllSL;
import kal.base.sys.dbbean.*;

/**
 * IROPS REPORT Alert Message Servlet Class
 * @version 	1.0
 * @author Copyright (c) 2005/02/01  
 */
public class IroA115Serv extends PublicBaseServlet{
	
	/** 
	  * IROPS REPORT Alert Message Servlet Class - selectTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/02/01  
	  */	
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		
		Box box = HttpUtility.getBox(req);				 										    //Box ü 
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
				
		try {
		
			//EJB LookUp	
			IroAllSL sl = (IroAllSL)EJBFinder.lookup("ejb/IroAllSL");
			Hashtable hashAlert  = sl.selIroA010AlertMsg();
			req.setAttribute("hashAlert",hashAlert);
			req.setAttribute("returnParam","Y");

			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:IroA110SubServ:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			} else {
				Logger.debug.println("[BASE:IroA110SubServ:selectTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			}
		} 
	}//end selectTask
	
	/** 
	  * IROPS REPORT Alert Message Servlet Class - insertTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/02/01  
	  */	
	public void insertTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		
		Box box = HttpUtility.getBox(req);				 										    //Box ü 
		//String empNo = StringUtil.checkString(box.getString("emp_no"));				//Է»
		String alertMsgE = StringUtil.checkString(box.getString("alert_msg_e"));	//Է ޼
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		HttpSession session = req.getSession();
				
		try {	
			//EJB Parameter 
			SysA010BG UserInfo = (SysA010BG)session.getAttribute("USERINFO");
			IroA010BG params = new IroA010BG();
			params.setEmp_no(UserInfo.getEmp_no());
			params.setAlert_msg_e(StringUtil.toKSC5601(alertMsgE));
			
			//EJB LookUp
			IroAllSL sl = (IroAllSL)EJBFinder.lookup("ejb/IroAllSL");
			String insMsg  = sl.insIroA010AlertMsg(params);
			req.setAttribute("INSMSG",insMsg);
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:IroA110SubServ:insertTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"insert");
			} else {
				Logger.debug.println("[BASE:IroA110SubServ:insertTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"insert");
			}
		} 
	}//end insertTask
	
	/** 
	  * IROPS REPORT Alert Message Servlet Class - updateTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/02/01  
	  */	
	public void updateTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		
		Box box = HttpUtility.getBox(req);				 										    //Box ü 
		//String empNo = StringUtil.checkString(box.getString("emp_no"));				//Expire 
		String alertDt = StringUtil.checkString(box.getString("alert_dt"));				//¥
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		HttpSession session = req.getSession();
				
		try {		
			//EJB Parameter 
			SysA010BG UserInfo = (SysA010BG)session.getAttribute("USERINFO");
			IroA010BG params = new IroA010BG();
			params.setEmp_no(UserInfo.getEmp_no());
			params.setAlert_dt(alertDt);
			
			//EJB LookUp
			IroAllSL sl = (IroAllSL)EJBFinder.lookup("ejb/IroAllSL");
			String updMsg  = sl.updIroA010AlertMsg(params);
			req.setAttribute("updMsg",updMsg);
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:IroA110SubServ:updateTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"update");
			} else {
				Logger.debug.println("[BASE:IroA110SubServ:updateTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"update");
			}
		} 
	}//end updateTask
}
