package kal.base.iro.serv;

import java.rmi.RemoteException;
import java.util.Hashtable;
import java.util.Vector;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import kal.base.com.util.*;
import kal.base.com.serv.*;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.Box;
import kal.base.jdf.serv.HttpUtility;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.iro.dbbean.*;
import kal.base.iro.ejb.IroAllSL;

/**
 * DSS Messenger Է Servlet Class
 * @version 	1.0
 * @author Copyright (c) 2005/12/20  
 */
public class IroA270Serv extends PublicBaseServlet {
	
	/** 
	  * DSS Messenger Է Servlet Class - insertTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/12/20  
	  */	
	public void insertTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		
		Box box = HttpUtility.getBox(req);				 										    //Box ü 
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		String p_deskX = StringUtil.checkString(box.getString("p_deskX"));
		String p_userN = StringUtil.checkString(StringUtil.toKSC5601(box.getString("p_userN")));
		String titleE = StringUtil.checkString(StringUtil.toKSC5601(box.getString("titleE")));
		String commentE = StringUtil.checkString(StringUtil.toKSC5601(box.getString("commentE")));
		String p_replyDtg = StringUtil.checkString(box.getString("p_replyDtg"));
		
		try {
			IroA270BG params = new IroA270BG();
			params.setDeskX(p_deskX);
			params.setUserN(p_userN);
			params.setTitleE(titleE);
			params.setCommnetE(commentE);
			params.setReplyDtg(p_replyDtg);
			
			//EJB LookUp
			IroAllSL sl = (IroAllSL)EJBFinder.lookup("ejb/IroAllSL");
			int returnValue  = sl.insIroA270Main(params);
			
			req.setAttribute("returnValue", String.valueOf(returnValue).toString());
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:IroA270Serv:insertTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"insert");
			} else {
				Logger.debug.println("[BASE:IroA270Serv:insertTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"insert");
			}
		} 
	}//end insertTask

}
