package kal.base.iro.serv;

import java.rmi.RemoteException;
import java.util.Hashtable;
import java.util.LinkedList;
import java.util.List;
import java.util.Vector;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import kal.base.com.util.*;
import kal.base.com.serv.*;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.Box;
import kal.base.jdf.serv.HttpUtility;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.iro.dbbean.*;
import kal.base.iro.ejb.IroAllSL;

/**
 * Decision Making & Action Servlet Class
 * @version 	1.0
 * @author Copyright (c) 2009/07/31  
 */
public class IroA330Serv extends PublicBaseServlet {	
	/** 
	  * Irops Info ȸ Servlet Class - checkTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2009/07/31 
	  */	
	public void checkTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		
		Box box = HttpUtility.getBox(req);				 										    //Box ü 
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		String dssStartDt = StringUtil.checkString(box.getString("pDssStartDt"));
		String seqNum = StringUtil.checkString(box.getString("pSeqNum"));
		
		try {
			IroA330BG params = new IroA330BG();
			
			params.setDssStartDt(dssStartDt);
			params.setSeqNum(seqNum);
			
			//EJB LookUp
			IroAllSL sl = (IroAllSL)EJBFinder.lookup("ejb/IroAllSL");
			Hashtable hashData = sl.selIroA330IropsInfo(params);
			req.setAttribute("hashData", hashData);
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:IroA330Serv:checkTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"check");
			} else {
				Logger.debug.println("[BASE:IroA330Serv:checkTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"check");
			}
		} 
	}//end checkTask
	
	/** 
	  * SKD Info ȸ Servlet Class - selectTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2009/07/31 
	  */	
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		
		Box box = HttpUtility.getBox(req);				 										    //Box ü 
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		String dssStartDt = StringUtil.checkString(box.getString("pDssStartDt"));
		String seqNum = StringUtil.checkString(box.getString("pSeqNum"));
		
		try {
			IroA330BG params = new IroA330BG();
			
			params.setDssStartDt(dssStartDt);
			params.setSeqNum(seqNum);
			
			//EJB LookUp
			IroAllSL sl = (IroAllSL)EJBFinder.lookup("ejb/IroAllSL");
			Hashtable hashData = sl.selIroA330Main(params);
			req.setAttribute("hashData", hashData);
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:IroA330Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			} else {
				Logger.debug.println("[BASE:IroA330Serv:selectTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			}
		} 
	}//end selectTask
	
	/** 
	  * Approve Ǵ Reject  Servlet Class - updateTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2009/08/12 
	  */	
	public void updateTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		
		Box box = HttpUtility.getBox(req);				 										    //Box ü 
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		String arMode = StringUtil.checkString(box.getString("ar_mode")); //Approve : A, Reject : R
		
		String dssStartDt = StringUtil.checkString(box.getString("pDssStartDt"));
		String seqNum = StringUtil.checkString(box.getString("pSeqNum"));
		
		String deskX = StringUtil.checkString(box.getString("desk_x"));
		String empNo = StringUtil.checkString(box.getString("empNo"));
		String korN = StringUtil.DBInsStr(StringUtil.toKSC5601(StringUtil.checkString(box.getString("korN"))));
		String titleE = StringUtil.DBInsStr(StringUtil.toKSC5601(StringUtil.checkString(box.getString("title_e"))));
		String decisionE = StringUtil.DBInsStr(StringUtil.toKSC5601(StringUtil.checkString(box.getString("decision_e"))));
		
		try {
			IroA330BG params = new IroA330BG();
			
			params.setArMode(arMode);
			
			params.setDssStartDt(dssStartDt);
			params.setSeqNum(seqNum);
			
			params.setDeskX(deskX);
			params.setEmpNo(empNo);
			params.setKorN(korN);
			params.setTitleE(titleE);
			params.setDecisionE(decisionE);
			
			//EJB LookUp
			IroAllSL sl = (IroAllSL)EJBFinder.lookup("ejb/IroAllSL");
			Hashtable hashData = sl.updIroA330AppRej(params);
			
			String msgNo = "";
			String lvlNo = "";
			
			if (hashData != null) {
				msgNo = (String)hashData.get("MSG_NO");
				lvlNo = (String)hashData.get("LVL_NO");
			}
			
			req.setAttribute("arParam", arMode);
			req.setAttribute("msgNo", msgNo);
			req.setAttribute("lvlNo", lvlNo);
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:IroA330Serv:updateTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"update");
			} else {
				Logger.debug.println("[BASE:IroA330Serv:updateTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"update");
			}
		} 
	}//end updateTask
	
}