package kal.base.iro.serv;

import java.rmi.RemoteException;
import java.util.*;
import javax.servlet.http.*;

import kal.base.com.util.*;
import kal.base.com.serv.*;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.*;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.iro.dbbean.*;
import kal.base.iro.ejb.IroAllSL;
import kal.base.sys.dbbean.*;

/**
 * IROPS Queue Servlet Class
 * @version 	1.0
 * @author Copyright (c) 2005/04/26 HIST  
 */
public class IroQ060Serv extends PublicBaseServlet{
	/** 
	  *   IROPS Queue Main Servlet Class - selectTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/04/26 HIST  
	  */		
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 															//Box ü 
		String timeStamp = StringUtil.checkString(box.getString("timestamp"));				//ȸ
		String fltNum = StringUtil.checkString(box.getString("flt_num"));							//Flt Num
		String returnPage = StringUtil.checkString(box.getString("returnPage"));				//Return Page ȹ
		
		try {
			//EJB Parameter 
			IroQ060BG params = new IroQ060BG();
			params.setTimestamp(timeStamp);
			params.setFlt_num(fltNum);
			
			//EJB LookUp
			IroAllSL sl = (IroAllSL)EJBFinder.lookup("ejb/IroAllSL");
			Hashtable hashData  = sl.selIroQ060Main(params);
			if (hashData != null) req.setAttribute("successMessage",ComUtil.getInstance().getMessage("IROPS Queue", hashData, "HASHDATA", MessageCode.getInstance().DATA_MSG));
			req.setAttribute("hashData",hashData);
			req.setAttribute("returnParam","Y");
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:IroQ060Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			} else {
				Logger.debug.println("[BASE:IroQ060Serv:selectTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			}
		} 
	}//end selectTask	
}//end of class
