package kal.base.iro.serv;

import java.rmi.RemoteException;
import java.util.Hashtable;
import java.util.Vector;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import kal.base.com.util.*;
import kal.base.com.serv.*;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.Box;
import kal.base.jdf.serv.HttpUtility;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.iro.dbbean.IroQ130BG;
import kal.base.iro.ejb.IroAllSL;

/**
 * SKD   Servlet Class
 * @version 	1.0
 * @author Copyright (c) 2005/04/22  
 */
public class IroQ130Serv extends PublicBaseServlet {
	/** 
	  * SKD   Servlet Class - updateTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/04/22  
	  */	
	public void updateTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		
		Box box = HttpUtility.getBox(req);				 										    //Box ü 

		String authPmsn = StringUtil.checkString(box.getString("authPmsn"));		//project 
		String firstLegFltDt = StringUtil.checkString(box.getString("firstLegFltDt"));	//First_Leg_Flt_Dt
		String fltNum = StringUtil.checkString(box.getString("fltNum"));					//Flt_Num
		String stnfr = StringUtil.checkString(box.getString("stnfr"));						//Stnfr
		String stnto = StringUtil.checkString(box.getString("stnto"));						//Stnto
		String seqNum = StringUtil.checkString(box.getString("seqNum"));			//Seq_Num
		String optionNum = StringUtil.checkString(box.getString("optionNum"));		//Option_Num
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
				
		try {
			IroQ130BG params = new IroQ130BG();	
			params.setAuth_pmsn(authPmsn);
			params.setFirst_leg_flt_dt(firstLegFltDt);
			params.setFlt_num(fltNum);
			params.setStnfr(stnfr);
			params.setStnto(stnto);
			params.setSeq_num(seqNum);
			params.setOption_num(optionNum);

			//EJB LookUp
			IroAllSL sl = (IroAllSL)EJBFinder.lookup("ejb/IroAllSL");
			int returnValue = sl.updIroQ130Process(params);
			
			if (returnValue == 1) {
				req.setAttribute("updOk","A");
				req.setAttribute("firstLegFltDt",firstLegFltDt);
				req.setAttribute("fltNum",fltNum);
				req.setAttribute("stnfr",stnfr);
				req.setAttribute("stnto",stnto);
				req.setAttribute("seqNum",seqNum);
				req.setAttribute("optionNum",optionNum);
			}
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:IroQ130Serv:updateTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"update");
			} else {
				Logger.debug.println("[BASE:IroQ130Serv:updateTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"update");
			}
		} 
	}//end updateTask
	
	/** 
	  * SKD   Servlet Class - selectTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/04/25  
	  */	
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		
		Box box = HttpUtility.getBox(req);				 										    //Box ü 

		String firstLegFltDt = StringUtil.checkString(box.getString("firstLegFltDt"));	//First_Leg_Flt_Dt
		String fltNum = StringUtil.checkString(box.getString("fltNum"));					//Flt_Num
		String stnfr = StringUtil.checkString(box.getString("stnfr"));						//Stnfr
		String stnto = StringUtil.checkString(box.getString("stnto"));						//Stnto
		String seqNum = StringUtil.checkString(box.getString("seqNum"));			//Seq_Num
		String optionNum = StringUtil.checkString(box.getString("optionNum"));		//Option_Num
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
				
		try {
			IroQ130BG params = new IroQ130BG();	
			params.setFirst_leg_flt_dt(firstLegFltDt);
			params.setFlt_num(fltNum);
			params.setStnfr(stnfr);
			params.setStnto(stnto);
			params.setSeq_num(seqNum);
			params.setOption_num(optionNum);

			//EJB LookUp
			IroAllSL sl = (IroAllSL)EJBFinder.lookup("ejb/IroAllSL");
			Hashtable hashData = sl.selIroQ130Main(params);
			req.setAttribute("hashData", hashData);
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:IroQ130Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			} else {
				Logger.debug.println("[BASE:IroQ130Serv:selectTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			}
		} 
	}//end updateTask
}
