package kal.base.iro.serv;

import java.rmi.RemoteException;
import java.util.Hashtable;
import java.util.Vector;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import kal.base.com.util.*;
import kal.base.com.serv.*;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.Box;
import kal.base.jdf.serv.HttpUtility;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.iro.dbbean.IroQ140BG;
import kal.base.iro.ejb.IroAllSL;

/**
 * Monthly IROPS REPORT Servlet Class
 * @version 	1.0
 * @author Copyright (c) 2005/07/13  
 */
public class IroQ140Serv extends PublicBaseServlet {
	
	/** 
	  * Monthly IROPS REPORT Servlet Class - selectTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/07/13  
	  */	
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		
		Box box = HttpUtility.getBox(req);				 										    //Box ü 
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		String thisMonth = StringUtil.checkString(box.getString("thisMonth"));	//MONTH(input data)
		String domIntCgo = StringUtil.checkString(box.getString("domIntCgo"));	//
		String titleX = StringUtil.checkString(box.getString("titleX"));	//ġ
		
		int y = 0;
		int m = 0;
		if(!thisMonth.equals("") && thisMonth.length() == 6){
			y = Integer.parseInt(thisMonth.substring(0,4));
			m = Integer.parseInt(thisMonth.substring(4,6));
		}
		String monthStartD = thisMonth + "01";
		String monthEndD = thisMonth + String.valueOf(StringUtil.daysPerMonth(y,m)).toString();
				
		try {
			IroQ140BG params = new IroQ140BG();
			params.setMonth_start_d(monthStartD);
			params.setMonth_end_d(monthEndD);
			params.setDom_int_x(domIntCgo);
			params.setTitle_x(titleX);
			
			//EJB LookUp
			IroAllSL sl = (IroAllSL)EJBFinder.lookup("ejb/IroAllSL");
			Hashtable hashData  = sl.selIroQ140Main(params);
			if (hashData != null){
				req.setAttribute("successMessage",ComUtil.getInstance().getMessage("Monthly IROPS REPORT", hashData, "IROPSMONTHLY", MessageCode.getInstance().DATA_MSG));
			}
			req.setAttribute("hashData",hashData);
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:IroQ140Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			} else {
				Logger.debug.println("[BASE:IroQ140Serv:selectTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			}
		} 
	}//end selectTask

}
