package kal.base.iro.serv;

import java.rmi.RemoteException;
import java.util.Hashtable;
import java.util.LinkedList;
import java.util.List;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import kal.base.com.util.*;
import kal.base.com.serv.*;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.Box;
import kal.base.jdf.serv.HttpUtility;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.iro.dbbean.*;
import kal.base.iro.ejb.IroAllSL;

/**
 * IROPS FLT Report Servlet Class
 * @version 	1.0
 * @author Copyright (c) 2009/08/24  
 */
public class IroQ420Serv  extends PublicBaseServlet {
	/** 
	  * IROPS FLT Report ȸ Servlet Class - selectTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2009/08/24 
	  */	
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		
		Box box = HttpUtility.getBox(req);				 										    //Box ü 
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		String startDate = StringUtil.checkString(box.getString("start_date"));
		String endDate = StringUtil.checkString(box.getString("end_date"));
		String gubun = StringUtil.checkString(box.getString("gubun"));
		String flt = StringUtil.checkString(box.getString("flt"));
		String dep = StringUtil.checkString(box.getString("dep"));
		String arr = StringUtil.checkString(box.getString("arr"));
		String acreg = StringUtil.checkString(box.getString("acreg"));
		
		try {
			IroQ420BG params = new IroQ420BG();
			
			params.setStartDate(startDate);
			params.setEndDate(endDate);
			params.setGubun(gubun);
			params.setFlt(flt);
			params.setDep(dep);
			params.setArr(arr);
			params.setAcreg(acreg);
			
			//EJB LookUp
			IroAllSL sl = (IroAllSL)EJBFinder.lookup("ejb/IroAllSL");
			Hashtable hashData = sl.selIroQ420Main(params);
			
			if (hashData != null) req.setAttribute("successMessage",ComUtil.getInstance().getMessage("IROPS FLT Report", hashData, "FLT_LIST", MessageCode.getInstance().DATA_MSG));
			req.setAttribute("hashData", hashData);
			
			//  
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:IroQ420Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			} else {
				Logger.debug.println("[BASE:IroQ420Serv:selectTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			}
		} 
	}//end selectTask
	
	/** 
	  * Ư IROPS SKD HIDE Ŵ Servlet Class - updateTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2009/09/24 
	  */	
	public void updateTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		
		Box box = HttpUtility.getBox(req);				 										    //Box ü 
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		String hideY = StringUtil.checkString(box.getString("hideY"));
		String dssStartDt = StringUtil.checkString(box.getString("dssStartDt"));
		String seqNum = StringUtil.checkString(box.getString("seqNum"));
		String arlnCd = StringUtil.checkString(box.getString("arlnCd"));
		String firstLegFltDt = StringUtil.checkString(box.getString("firstLegFltDt"));
		String fltNum = StringUtil.checkString(box.getString("fltNum"));
		String stnfr = StringUtil.checkString(box.getString("stnfr"));
		String stnto = StringUtil.checkString(box.getString("stnto"));		
		
		try {
			IroQ420BG params = new IroQ420BG();
			
			params.setHideY(hideY);
			params.setDssStartDt(dssStartDt);
			params.setSeqNum(seqNum);
			params.setArlnCd(arlnCd);
			params.setFirstLegFltDt(firstLegFltDt);
			params.setFltNum(fltNum);
			params.setStnfr(stnfr);
			params.setStnto(stnto);
			
			//EJB LookUp
			IroAllSL sl = (IroAllSL)EJBFinder.lookup("ejb/IroAllSL");
			String returnValue = sl.updIroQ420HideY(params);
			
			//  
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:IroQ420Serv:updateTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"update");
			} else {
				Logger.debug.println("[BASE:IroQ420Serv:updateTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"update");
			}
		} 
	}//end updateTask
}
