package kal.base.iro.serv;

import java.rmi.RemoteException;
import java.util.Hashtable;
import java.util.LinkedList;
import java.util.List;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import kal.base.com.util.*;
import kal.base.com.serv.*;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.Box;
import kal.base.jdf.serv.HttpUtility;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.iro.dbbean.*;
import kal.base.iro.ejb.IroAllSL;

/**
 * Pre-Determination Servlet Class
 * @version 	1.0
 * @author Copyright (c) 2009/08/26  
 */
public class IroQ430Serv  extends PublicBaseServlet {
	
	private static IroQ430Serv instance = new IroQ430Serv();
	
	public static IroQ430Serv getInstance() {
		return instance;
	}
	
	/**
	 *  ȸ
	 * @author Copyright (c) 2009/09/25 
	 */
	public static Hashtable selIropsUser() throws Exception {
		try {
			IroAllSL sl = (IroAllSL)EJBFinder.lookup("ejb/IroAllSL");
			Hashtable hashData = sl.selIroQ430User();

			return hashData;
		} catch(Exception e) {
			if(e instanceof Exception) {
				throw new Exception(e.getMessage());
			} else {
				throw new Exception(MessageCode.getInstance().ETC_EXPT);
			}
		}
	}
	
	/** 
	  * Pre-Determination ȸ Servlet Class - selectTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2009/08/26 
	  */	
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		
		Box box = HttpUtility.getBox(req);				 										    //Box ü 
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		String startDate = StringUtil.checkString(box.getString("start_date"));
		String endDate = StringUtil.checkString(box.getString("end_date"));
		String userId = StringUtil.checkString(box.getString("user_id")); //DESK_X + USER_ID
		String routeX = StringUtil.checkString(box.getString("route_x"));
		
		try {
			IroQ430BG params = new IroQ430BG();
			
			params.setStartDate(startDate);
			params.setEndDate(endDate);
			params.setUserId(userId);
			params.setRouteX(routeX);
			
			//EJB LookUp
			IroAllSL sl = (IroAllSL)EJBFinder.lookup("ejb/IroAllSL");
			Hashtable hashData = sl.selIroQ430Main(params);
			
			req.setAttribute("hashData", hashData);
			req.setAttribute("startDate", startDate);
			req.setAttribute("endDate", endDate);
			req.setAttribute("userId", userId);
			req.setAttribute("routeX", routeX);
			
			//  
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:IroQ430Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			} else {
				Logger.debug.println("[BASE:IroQ430Serv:selectTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			}
		} 
	}//end selectTask
	
	/** 
	  * IROPS REPORT ȸ Servlet Class - checkTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2009/08/28 
	  */	
	public void checkTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		
		Box box = HttpUtility.getBox(req);				 										    //Box ü 
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		String gubun = StringUtil.checkString(box.getString("gubun"));
		String startDate = StringUtil.checkString(box.getString("startDate"));
		String endDate = StringUtil.checkString(box.getString("endDate"));
		String userId = StringUtil.checkString(box.getString("userId"));
		String tm = StringUtil.checkString(box.getString("tm"));
		String commentX = StringUtil.checkString(box.getString("commentX"));
		String routeX = StringUtil.checkString(box.getString("routeX"));
		
		try {
			IroQ430BG params = new IroQ430BG();
			
			params.setGubun(gubun);
			params.setStartDate(startDate);
			params.setEndDate(endDate);
			params.setUserId(userId);
			params.setTm(tm);
			params.setCommentX(commentX);
			params.setRouteX(routeX);
			
			//EJB LookUp
			IroAllSL sl = (IroAllSL)EJBFinder.lookup("ejb/IroAllSL");
			Hashtable hashData = sl.selIroQ430IropsReport(params);
			
			req.setAttribute("hashData", hashData);
			req.setAttribute("returnParam", "Y");
			
			//  
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:IroQ430Serv:checkTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"check");
			} else {
				Logger.debug.println("[BASE:IroQ430Serv:checkTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"check");
			}
		} 
	}//end checkTask
}
