package kal.base.iro.serv;

import java.rmi.RemoteException;
import java.util.Hashtable;
import java.util.LinkedList;
import java.util.List;
import java.util.Vector;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import kal.base.com.util.*;
import kal.base.com.serv.*;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.Box;
import kal.base.jdf.serv.HttpUtility;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.iro.dbbean.*;
import kal.base.iro.ejb.IroAllSL;

/**
 * FLT Progress Information Servlet Class
 * @version 	1.0
 * @author Copyright (c) 2009/09/15 
 */
public class IroQ470Serv extends PublicBaseServlet {
	
	/** 
	  * FLT Progress Information ȸ Servlet Class - selectTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2009/09/15 
	  */	
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		
		Box box = HttpUtility.getBox(req);				 										    //Box ü 
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		String schDepDt = StringUtil.xssEncode(box.getString("pSchDepDt"));//@2013-06-21	XSS 	-	 : StringUtil.checkString(box.getString("pSchDepDt"));
		String fltNum = 	StringUtil.xssEncode(box.getString("pFltNum"));//@2013-06-21	XSS 	-	 : StringUtil.checkString(box.getString("pFltNum"));
		String stnfr = StringUtil.xssEncode(box.getString("pStnfr"));//@2013-06-21	XSS 	-	 : StringUtil.checkString(box.getString("pStnfr"));
		String stnto = StringUtil.xssEncode(box.getString("pStnto"));//@2013-06-21	XSS 	-	 : StringUtil.checkString(box.getString("pStnto"));
		
		String iropsY = 	StringUtil.xssEncode(box.getString("iropsY"));//@2013-06-21	XSS 	-	 : StringUtil.checkString(box.getString("iropsY")); //2010.04.22 ߰ : irops_status ˾ ؼ  
		
		//2012.03.15 ߰
		String searchY = StringUtil.xssEncode(box.getString("searchY"));//@2013-06-21	XSS 	-	 : StringUtil.checkString(box.getString("searchY"));
		String firstLegFltDt = 	StringUtil.xssEncode(box.getString("pFirstLegFltDt"));//@2013-06-21	XSS 	-	 : StringUtil.checkString(box.getString("pFirstLegFltDt"));
        //2012.03.15 ߰[]
		
		try {
			IroQ470BG params = new IroQ470BG();
			
			params.setSchDepDt(schDepDt);
			params.setFltNum(fltNum);
			params.setStnfr(stnfr);
			params.setStnto(stnto);
			
			params.setIropsY(iropsY); //2010.04.22 ߰
			
			params.setSearchY(searchY);//2012.03.05 ߰
			params.setFirstLegFltDt(firstLegFltDt);//2012.03.05 ߰
			
			//EJB LookUp
			IroAllSL sl = (IroAllSL)EJBFinder.lookup("ejb/IroAllSL");
			Hashtable hashData = sl.selIroQ470Main(params);
			
			req.setAttribute("hashData", hashData);
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:IroQ470Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			} else {
				Logger.debug.println("[BASE:IroQ470Serv:selectTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			}
		} 
	}//end selectTask
}