package kal.base.not.serv;

import java.rmi.RemoteException;
import java.util.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import kal.base.com.util.*;
import kal.base.com.serv.*;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.Box;
import kal.base.jdf.serv.HttpUtility;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.sys.dbbean.SysA010BG;
import kal.base.not.dbbean.*;
import kal.base.not.ejb.NotAllSL;

/**
 * New Q-NOTAM List Servlet Class
 * @version 	1.0
 * @author Copyright (c) 2007/09/07 
 */
public class NotA130Serv extends PublicBaseServlet {

	/** 
	  * New Q-NOTAM List ȸ Servlet Class - selectTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2007/09/07 
	  */	
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 										    //Box ü 
		String returnPage = StringUtil.checkString(box.getString("returnPage"));		//Return Page ȹ
		
		//20150323 ߰
		String s_text = StringUtil.checkString(box.getString("s_text"));
		String s_sort = StringUtil.checkString(box.getString("s_sort"));
		
		try {
			
			//20150323 ߰
			NotA130BG params = new NotA130BG();
			params.setS_text(s_text);
			params.setS_sort(s_sort);
			
			//EJB LookUp
			NotAllSL sl = (NotAllSL)EJBFinder.lookup("ejb/NotAllSL");
			Hashtable hashData  = sl.selNotA130Main(params);
			
			if (hashData != null) req.setAttribute("successMessage",ComUtil.getInstance().getMessage("Q-NOTAM List", hashData, "HASHDATA", MessageCode.getInstance().DATA_MSG));
			
			req.setAttribute("hashData", hashData);
			req.setAttribute("dataComplete","S");
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:NotA130Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			} else {
				Logger.debug.println("[BASE:NotA130Serv:selectTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			}
		} 
	}//end selectTask
	
	/** 
	  * New Q-NOTAM List Է Servlet Class - insertTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2007/09/07 
	  */	
	public void insertTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 										   			 //Box ü 
		
		String msgSeq = StringUtil.checkString(box.getString("msg_seq"));
		String timeStmp = StringUtil.checkString(box.getString("timestmp"));
		
		//String msgQ = StringUtil.checkString(box.getString("msg_q")); //2007.09.19  msg_q -> 8 и
		String notFir = StringUtil.checkString(box.getString("not_fir"));
		String notQcd = StringUtil.checkString(box.getString("not_qcd"));
		
		String notTraf = ""; //2007.09.06 
		if (StringUtil.checkString(box.getString("traf_I")).equals("Y")) notTraf = notTraf + "I";
		if (StringUtil.checkString(box.getString("traf_V")).equals("Y")) notTraf = notTraf + "V";
		
		String notPurp = ""; //2007.09.06 
		if (StringUtil.checkString(box.getString("purp_N")).equals("Y")) notPurp = notPurp + "N";
		if (StringUtil.checkString(box.getString("purp_B")).equals("Y")) notPurp = notPurp + "B";
		if (StringUtil.checkString(box.getString("purp_O")).equals("Y")) notPurp = notPurp + "O";
		if (StringUtil.checkString(box.getString("purp_M")).equals("Y")) notPurp = notPurp + "M";
		
		String notScop = ""; //2007.09.06 
		if (StringUtil.checkString(box.getString("scop_A")).equals("Y")) notScop = notScop + "A";
		if (StringUtil.checkString(box.getString("scop_E")).equals("Y")) notScop = notScop + "E";
		if (StringUtil.checkString(box.getString("scop_W")).equals("Y")) notScop = notScop + "W";
		
		String notLow = StringUtil.checkString(box.getString("not_low"));
		String notUpp = StringUtil.checkString(box.getString("not_upp"));
		String notLat_lon = StringUtil.checkString(box.getString("not_lat_lon"));

		String msgA = StringUtil.checkString(box.getString("icao_port"));
		String notNum = StringUtil.checkString(box.getString("not_num"));
		
		String notCat = ""; //2007.09.06 
		if (StringUtil.checkString(box.getString("cat_N")).equals("Y")) notCat = "N";
		if (StringUtil.checkString(box.getString("cat_R")).equals("Y")) notCat = "R";
		if (StringUtil.checkString(box.getString("cat_C")).equals("Y")) notCat = "C";
		
		String notOldNum = StringUtil.checkString(box.getString("not_old_num"));
		
		String notIss_dt = StringUtil.checkString(box.getString("not_iss_dt"));
		String notExp_dt = StringUtil.checkString(box.getString("not_exp_dt"));
		
		//2007.09.18 ߰
		String notEst = ""; //2007.09.06 ߰
		if (StringUtil.checkString(box.getString("est_Y")).equals("Y")) notEst = "Y";
		else notEst = "N";
				
		String notValid = StringUtil.checkString(box.getString("not_valid")).toUpperCase();
				
		String notCls = ""; //2007.09.06 ߰
		/*
		if (StringUtil.checkString(box.getString("cls_RWY")).equals("Y")) notCls = "RWY";
		if (StringUtil.checkString(box.getString("cls_TWY")).equals("Y")) notCls = "TWY";
		if (StringUtil.checkString(box.getString("cls_ILS")).equals("Y")) notCls = "ILS";
		if (StringUtil.checkString(box.getString("cls_LGT")).equals("Y")) notCls = "LGT";
		if (StringUtil.checkString(box.getString("cls_AGA")).equals("Y")) notCls = "AGA";
		if (StringUtil.checkString(box.getString("cls_COM")).equals("Y")) notCls = "COM";
		if (StringUtil.checkString(box.getString("cls_RAC")).equals("Y")) notCls = "RAC";
		if (StringUtil.checkString(box.getString("cls_WARN")).equals("Y")) notCls = "WARN";
		if (StringUtil.checkString(box.getString("cls_AIP")).equals("Y")) notCls = "AIP";
		if (StringUtil.checkString(box.getString("cls_OTHR")).equals("Y")) notCls = "OTHR";
		*/
		//2009.11.10  : Category ȭ
		if (StringUtil.checkString(box.getString("cls_n_RWY")).equals("Y")) notCls = "RWY";
		if (StringUtil.checkString(box.getString("cls_n_RWY_LGT")).equals("Y")) notCls = "RWY LGT";
		if (StringUtil.checkString(box.getString("cls_n_TWY")).equals("Y")) notCls = "TWY";
		if (StringUtil.checkString(box.getString("cls_n_TWY_LGT")).equals("Y")) notCls = "TWY LGT";
		if (StringUtil.checkString(box.getString("cls_n_RAMP")).equals("Y")) notCls = "RAMP";
		if (StringUtil.checkString(box.getString("cls_n_NAVAID")).equals("Y")) notCls = "NAVAID";
		if (StringUtil.checkString(box.getString("cls_n_DEP")).equals("Y")) notCls = "DEP";
		if (StringUtil.checkString(box.getString("cls_n_APP")).equals("Y")) notCls = "APP";
		if (StringUtil.checkString(box.getString("cls_n_APP_LGT")).equals("Y")) notCls = "APP LGT";
		if (StringUtil.checkString(box.getString("cls_n_COMM")).equals("Y")) notCls = "COMM";
		if (StringUtil.checkString(box.getString("cls_n_CHRT")).equals("Y")) notCls = "CHRT";
		if (StringUtil.checkString(box.getString("cls_n_ARPT")).equals("Y")) notCls = "ARPT";
		if (StringUtil.checkString(box.getString("cls_n_OBST")).equals("Y")) notCls = "OBST";
		if (StringUtil.checkString(box.getString("cls_n_GPS")).equals("Y")) notCls = "GPS";
		if (StringUtil.checkString(box.getString("cls_n_AIRWAY")).equals("Y")) notCls = "AIRWAY";
		if (StringUtil.checkString(box.getString("cls_n_AIRSPACE")).equals("Y")) notCls = "AIRSPACE";
		if (StringUtil.checkString(box.getString("cls_n_OTHER")).equals("Y")) notCls = "OTHER";
		if (StringUtil.checkString(box.getString("cls_n_AIP")).equals("Y")) notCls = "AIP";
		
		//String notOpen_y = StringUtil.checkString(box.getString("not_open_y"));
		/*String notOpen_y = ""; //2007.09.06 
		if (StringUtil.checkString(box.getString("hid_not_open")).equals("Y")) notOpen_y = "Y";
		else notOpen_y = "N";*/
		//2008.08.08  : OPEN -> STATUS
		String prevNotStatus = StringUtil.checkString(box.getString("prev_not_status"));
		String notStatus = StringUtil.checkString(box.getString("not_status"));
				
		String notSig_y = ""; //2007.09.06 ߰
		if (StringUtil.checkString(box.getString("hid_not_sig")).equals("Y")) notSig_y = "Y";
		else notSig_y = "N";
		
		String notText = StringUtil.checkString(box.getString("not_text")).toUpperCase();
		String notCommnt = StringUtil.checkString(box.getString("not_commnt")).toUpperCase();
		
		String notRemarks = StringUtil.toKSC5601(StringUtil.checkString(box.getString("not_remarks"))).toUpperCase(); //2008.08.08 ߰, 2008.12.09  : ѱó
		
		String notDayFr = StringUtil.checkString(box.getString("not_day_fr")); //2009.11.09 ߰
		String notDayTo = StringUtil.checkString(box.getString("not_day_to")); //2009.11.09 ߰
		
		String returnPage = StringUtil.checkString(box.getString("returnPage"));		//Return Page ȹ
		HttpSession session = req.getSession();
		
		try {
			//User Info
			SysA010BG UserInfo = (SysA010BG)session.getAttribute("USERINFO");
			
			//Parameter 
			NotA130BG params = new NotA130BG();
			
			params.setMsg_seq(msgSeq);
			params.setTimestmp(timeStmp);
			
			//params.setMsg_q(msgQ);
			params.setNot_fir(notFir); //2007.09.19  msg_q -> 8 и
			params.setNot_qcd(notQcd);
			params.setNot_traf(notTraf);
			params.setNot_purp(notPurp);
			params.setNot_scop(notScop);
			params.setNot_low(notLow);
			params.setNot_upp(notUpp);
			params.setNot_lat_lon(notLat_lon);
			
			params.setNot_num(notNum);
			params.setNot_cat(notCat);
			params.setNot_old_num(notOldNum);
			params.setMsg_a(msgA);
			params.setNot_iss_dt(notIss_dt);
			params.setNot_exp_dt(notExp_dt);
			params.setNot_valid(notValid);
			params.setNot_text(notText);
			params.setNot_commnt(notCommnt);
			
			//params.setNot_open_y(notOpen_y); 2008.08.08 
			params.setPrev_not_status(prevNotStatus); //2008.08.08 ߰
			params.setNot_status(notStatus); //2008.08.08 ߰
			
			params.setNot_remarks(notRemarks); //2008.08.08 ߰
			
			params.setUserid(UserInfo.getEmp_no());
			
			params.setNot_exp_est(notEst); //2007.09.18 ߰
			params.setNot_cls(notCls); 	//2007.09.18 ߰
			params.setNot_sig(notSig_y); //2007.09.18 ߰
			
			params.setNot_day_fr(notDayFr); //2009.11.09 ߰
			params.setNot_day_to(notDayTo); //2009.11.09 ߰
			
			//EJB LookUp
			NotAllSL sl = (NotAllSL)EJBFinder.lookup("ejb/NotAllSL");
			boolean insFlag = sl.updNotA130Main(params);
			req.setAttribute("notInput","D");
			req.setAttribute("dataComplete","U");
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:NotA130Serv:insertTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"insert");
			} else {
				Logger.debug.println("[BASE:NotA130Serv:insertTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"insert");
			}
		} 
	}//end updateTask		
	
	/** 
	  * New Q-NOTAM List  Servlet Class - deleteTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2007/09/07 
	  */	
	public void deleteTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 										   			 //Box ü 
		String msgSeq = StringUtil.checkString(box.getString("msg_seq"));
		String timeStmp = StringUtil.checkString(box.getString("timestmp"));
		String returnPage = StringUtil.checkString(box.getString("returnPage"));		//Return Page ȹ
		
		try {
			//Parameter 
			NotA130BG params = new NotA130BG();
			params.setMsg_seq(msgSeq);
			params.setTimestmp(timeStmp);
			
			//EJB LookUp
			NotAllSL sl = (NotAllSL)EJBFinder.lookup("ejb/NotAllSL");
			boolean delFlag = sl.delNotA130Item(params);
			req.setAttribute("notInput","D");
			req.setAttribute("dataComplete","D");
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:NotA130Serv:deleteTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"delete");
			} else {
				Logger.debug.println("[BASE:NotA130Serv:deleteTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"delete");
			}
		} 
	}//end deleteTask	
	
	/** 
	  * New Q-NOTAM - OLD NOTAM   4ڸ ȸ Servlet Class - checkTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2007/09/07 
	  */	
	public void checkTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 										    //Box ü 
		
		String msgA = StringUtil.checkString(box.getString("msg_a"));
		String notOldNum = StringUtil.checkString(box.getString("not_old_num"));
		
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		try {
			//Parameter 
			NotA130BG params = new NotA130BG();
			
			params.setMsg_a(msgA);
			params.setNot_old_num(notOldNum);
			
			//EJB LookUp
			NotAllSL sl = (NotAllSL)EJBFinder.lookup("ejb/NotAllSL");
			Hashtable hashData  = sl.selNotA130OldNotam(params);
			req.setAttribute("hashData",hashData);
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:NotA130Serv:checkTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"check");
			} else {
				Logger.debug.println("[BASE:NotA130Serv:checkTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"check");
			}
		} 
	}//end checkTask
	
	/** 
	  * New Q-NOTAM - OLD NOTAM   ó Servlet Class - updateTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2007/09/07 
	  */	
	public void updateTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		
		Box box = HttpUtility.getBox(req);				 										    //Box ü 
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		String msgSeq = StringUtil.checkString(box.getString("msg_seq"));
		String timeStmp = StringUtil.checkString(box.getString("timestmp"));
		
		//String msgQ = StringUtil.checkString(box.getString("msg_q")); //2007.09.19  msg_q -> 8 и
		String notFir = StringUtil.checkString(box.getString("not_fir"));
		String notQcd = StringUtil.checkString(box.getString("not_qcd"));
		String notTraf = StringUtil.checkString(box.getString("not_traf"));
		String notPurp = StringUtil.checkString(box.getString("not_purp"));
		String notScop = StringUtil.checkString(box.getString("not_scop"));
		String notLow = StringUtil.checkString(box.getString("not_low"));
		String notUpp = StringUtil.checkString(box.getString("not_upp"));
		String notLat_lon = StringUtil.checkString(box.getString("not_lat_lon"));
		
		String notNum = StringUtil.checkString(box.getString("not_num"));
		String notCat = StringUtil.checkString(box.getString("not_cat"));	
		String notIss_dt = StringUtil.checkString(box.getString("msg_b"));
		String notExp_dt = StringUtil.checkString(box.getString("msg_c"));
		String notValid = StringUtil.checkString(box.getString("msg_d")).toUpperCase();
		String notText = StringUtil.checkString(box.getString("msg_e")).toUpperCase();
		
		//2008.08.08  : OPEN -> STATUS
		//String notOpenY = StringUtil.checkString(box.getString("not_open_y"));
		String prevNotStatus = StringUtil.checkString(box.getString("prev_not_status"));
		String notStatus = StringUtil.checkString(box.getString("not_status"));
		
		String notCommnt = StringUtil.checkString(box.getString("not_commnt")).toUpperCase();
		
		String notRemarks = StringUtil.toKSC5601(StringUtil.checkString(box.getString("not_remarks"))).toUpperCase(); //2008.08.08 ߰, 2008.12.09  : ѱó
		
		String notCls = StringUtil.checkString(box.getString("not_cls")); //2007.09.19 ߰
		String notEst = StringUtil.checkString(box.getString("not_exp_est_y")); //2007.09.19 ߰
		String notSigY = StringUtil.checkString(box.getString("not_sig_y")); //2007.09.19 ߰
		
		String notDayFr = StringUtil.checkString(box.getString("not_day_fr")); //2009.11.09 ߰
		String notDayTo = StringUtil.checkString(box.getString("not_day_to")); //2009.11.09 ߰
		
		String[] chkData = req.getParameterValues("chkData");
		
		//User Info
		HttpSession session = req.getSession();
		SysA010BG UserInfo = (SysA010BG)session.getAttribute("USERINFO");
		
		try {
			
			for(int i=0 ; i<chkData.length ; i++){
				//Logger.debug.println(chkData[i]);
				String icaoPort = chkData[i].substring(0,4);
				String notOldNum = chkData[i].substring(4);
				
				//Parameter 
				NotA130BG params = new NotA130BG();
				
				params.setNot_old_num(notOldNum); //
				params.setMsg_a(icaoPort); 			//
				
				params.setMsg_seq(msgSeq);
				params.setTimestmp(timeStmp);
				
				//params.setMsg_q(msgQ);
				params.setNot_fir(notFir); //2007.09.19  msg_q -> 8 и
				params.setNot_qcd(notQcd);
				params.setNot_traf(notTraf);
				params.setNot_purp(notPurp);
				params.setNot_scop(notScop);
				params.setNot_low(notLow);
				params.setNot_upp(notUpp);
				params.setNot_lat_lon(notLat_lon);
				
				params.setNot_num(notNum);
				params.setNot_cat(notCat);
				params.setNot_iss_dt(notIss_dt);
				params.setNot_exp_dt(notExp_dt);
				params.setNot_valid(notValid);
				params.setNot_text(notText);
				params.setNot_commnt(notCommnt);
				
				//params.setNot_open_y(notOpenY); 2008.08.08 
				params.setPrev_not_status(prevNotStatus); //2008.08.08 ߰
				params.setNot_status(notStatus); //2008.08.08 ߰
				
				params.setNot_remarks(notRemarks); //2008.08.08 ߰
				
				params.setUserid(UserInfo.getEmp_no());
				
				params.setNot_cls(notCls); 	//2007.09.18 ߰
				params.setNot_exp_est(notEst); //2007.09.18 ߰
				params.setNot_sig(notSigY); //2007.09.18 ߰
				
				params.setNot_day_fr(notDayFr); //2009.11.09 ߰
				params.setNot_day_to(notDayTo); //2009.11.09 ߰
				
				//EJB LookUp
				NotAllSL sl = (NotAllSL)EJBFinder.lookup("ejb/NotAllSL");
				boolean insFlg = sl.updNotA130OldNotam(params);
			}
			
			//Parameter 
			NotA130BG pa = new NotA130BG();
				
			pa.setMsg_seq(msgSeq);
			pa.setTimestmp(timeStmp);
			
			//EJB LookUp
			NotAllSL sl = (NotAllSL)EJBFinder.lookup("ejb/NotAllSL");
			boolean delFlg = sl.delNotA130Item(pa);

			req.setAttribute("returnParam","Y");
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:NotA130Serv:updateTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"update");
			} else {
				Logger.debug.println("[BASE:NotA130Serv:updateTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"update");
			}
		} 
	}//end updateTask

}//end of class
