package kal.base.not.serv;

import java.rmi.RemoteException;
import java.util.Hashtable;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import kal.base.com.serv.ComUtil;
import kal.base.com.util.MessageCode;
import kal.base.com.util.StringUtil;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.Box;
import kal.base.jdf.serv.HttpUtility;
import kal.base.not.dbbean.NotA110BG;
import kal.base.not.dbbean.NotQ010BG;
import kal.base.not.ejb.NotAllSL;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.sys.dbbean.SysA010BG;

/**
 * 20150324 ߰
 * sunpark
 */
public class NotA200Serv extends PublicBaseServlet {
	/** 
	  * 20150324
	  * sunpark
	  */	
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);
		String returnPage = StringUtil.checkString(box.getString("returnPage"));
		
		String dtg_range = StringUtil.checkString(box.getString("dtg_range"));
		
		String hid_rd_dtg = StringUtil.checkString(box.getString("hid_rd_dtg"));
		String dtgFr = StringUtil.checkString(box.getString("dtgFr")) + StringUtil.checkString(box.getString("dtgFrTime"));
		String dtgTo = StringUtil.checkString(box.getString("dtgTo")) + StringUtil.checkString(box.getString("dtgToTime"));
		String c_stn = StringUtil.checkString(box.getString("c_stn"));
		String c_status = StringUtil.checkString(box.getString("c_status"));

		String s_text = StringUtil.checkString(box.getString("s_text"));
		String s_sort = StringUtil.checkString(box.getString("s_sort"));
		
		try {

			NotA110BG params = new NotA110BG();
			params.setDtg_range(dtg_range);
			
			params.setHid_rd_dtg(hid_rd_dtg);
			params.setDtgFr(dtgFr);
			params.setDtgTo(dtgTo);
			params.setC_stn(c_stn);
			params.setC_status(c_status);

			params.setS_text(s_text);
			params.setS_sort(s_sort);
			
			params.setIs_history("Y");
			
			NotAllSL sl = (NotAllSL)EJBFinder.lookup("ejb/NotAllSL");
			Hashtable hashData  = sl.selNotA110Main(params);
			if (hashData != null) req.setAttribute("successMessage",ComUtil.getInstance().getMessage("NOTAM List", hashData, "HASHDATA", MessageCode.getInstance().DATA_MSG));
			req.setAttribute("hashData",hashData);
			req.setAttribute("dataComplete","S");
			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			/*if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:NotA200Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			} else {
				Logger.debug.println("[BASE:NotA200Serv:selectTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			}
			@2018-03-06
			*/
			Logger.debug.println("[BASE:NotA200Serv:selectTask] "+e.getMessage());
			printMessagePage2(req, res, e.getMessage(),returnPage,"select");
		} 
	}//end selectTask
	
	/** 
	  * 20150324
	  * sunpark
	  */	
	public void checkTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);
		String returnPage = StringUtil.checkString(box.getString("returnPage"));
		
		String icao_port = StringUtil.checkString(box.getString("icao_port"));
		String not_num = StringUtil.checkString(box.getString("not_num"));
		
		try {

			NotA110BG params = new NotA110BG();
			params.setIcao_port(icao_port);
			params.setNot_num(not_num);
			
			NotAllSL sl = (NotAllSL)EJBFinder.lookup("ejb/NotAllSL");
			Hashtable hashData  = sl.selNotA200Sub(params);
			if (hashData != null) req.setAttribute("successMessage",ComUtil.getInstance().getMessage("NOTAM List", hashData, "HASHDATA", MessageCode.getInstance().DATA_MSG));
			req.setAttribute("hashData",hashData);
			req.setAttribute("dataComplete","S");
			
			printJspPage(req, res, returnPage);
		/*} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:NotA200Serv:checkTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			} else {
				Logger.debug.println("[BASE:NotA200Serv:checkTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			}
			@2018-03-06
			*/
		} catch(Exception e) {
			Logger.debug.println("[BASE:NotA200Serv:checkTask] "+e.getMessage());
			printMessagePage2(req, res, e.getMessage(),returnPage,"select");
		} 
	}//end checkTask
	
	/** 
	  * 20150324
	  * sunpark
	  */	
	public void updateTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);
		
		String icao_port = StringUtil.checkString(box.getString("icao_port"));
		String not_num = StringUtil.checkString(box.getString("not_num"));
		String sub_not_old_num = StringUtil.checkString(box.getString("sub_not_old_num"));
		String selected_level = StringUtil.checkString(box.getString("selected_level"));
		//20150415 ߰
		String parent_icao_port = StringUtil.checkString(box.getString("parent_icao_port"));
		String parent_not_num = StringUtil.checkString(box.getString("parent_not_num"));
		String not_old_cat = StringUtil.checkString(box.getString("not_old_cat"));
		
		String returnPage = StringUtil.checkString(box.getString("returnPage"));
		HttpSession session = req.getSession();
		
		try {
			SysA010BG UserInfo = (SysA010BG)session.getAttribute("USERINFO");
			
			NotA110BG params = new NotA110BG();
			params.setIcao_port(icao_port);
			params.setNot_num(not_num);
			params.setSub_not_old_num(sub_not_old_num);
			params.setKey_str(selected_level);
			
			//20150415 ߰
			params.setNot_old_cat(not_old_cat);
			params.setParent_icao_port(parent_icao_port);
			params.setParent_not_num(parent_not_num);
			
			NotAllSL sl = (NotAllSL)EJBFinder.lookup("ejb/NotAllSL");
			boolean updFlag = sl.updNotA200Main(params);

			req.setAttribute("userID",UserInfo.getEmp_no());
			req.setAttribute("dataComplete","U");
			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			/*
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:NotA200Serv:updateTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"update");
			} else {
				Logger.debug.println("[BASE:NotA200Serv:updateTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"update");
			}
			@2018-03-06
			*/
			Logger.debug.println("[BASE:NotA200Serv:updateTask] "+e.getMessage());
			printMessagePage2(req, res, e.getMessage(),returnPage,"update");
		} 
	}//end updateTask		
	
	/** 
	  * 20150324
	  * sunpark
	 	
	public void deleteTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);
		
		String icao_port = StringUtil.checkString(box.getString("icao_port"));
		String not_num = StringUtil.checkString(box.getString("not_num"));
		String sub_not_old_num = StringUtil.checkString(box.getString("sub_not_old_num"));
		String selected_level = StringUtil.checkString(box.getString("selected_level"));
		//20150415 ߰
		String parent_icao_port = StringUtil.checkString(box.getString("parent_icao_port"));
		String parent_not_num = StringUtil.checkString(box.getString("parent_not_num"));
		String not_old_cat = StringUtil.checkString(box.getString("not_old_cat"));
		
		String returnPage = StringUtil.checkString(box.getString("returnPage"));
		
		try {
			NotA110BG params = new NotA110BG();
			params.setIcao_port(icao_port);
			params.setNot_num(not_num);
			params.setSub_not_old_num(sub_not_old_num);
			params.setKey_str(selected_level);
			//20150415 ߰
			params.setNot_old_cat(not_old_cat);
			params.setParent_icao_port(parent_icao_port);
			params.setParent_not_num(parent_not_num);

			NotAllSL sl = (NotAllSL)EJBFinder.lookup("ejb/NotAllSL");
			boolean delFlag = sl.delNotA200Item(params);

			if("1".equals(selected_level)){
				req.setAttribute("dataComplete","D1");				
			} else if("2".equals(selected_level)){
				req.setAttribute("dataComplete","D2");
			}

			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:NotA200Serv:deleteTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"delete");
			} else {
				Logger.debug.println("[BASE:NotA200Serv:deleteTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"delete");
			}
		} 
	}//end deleteTask		
	 */
	public void deleteTask(HttpServletRequest req, HttpServletResponse res) throws Exception {//@2018-03-06
		Box box = HttpUtility.getBox(req);		
		String returnPage = StringUtil.checkString(box.getString("returnPage"));		
		String not_status = StringUtil.checkString(box.getString("notStatus"));
		String key_str = StringUtil.checkString(box.getString("keyStr"));
		String not_follow = StringUtil.checkString(box.getString("notFollow"));
		String selected_level = StringUtil.checkString(box.getString("selected_level"));
		
		HttpSession session = req.getSession();		

		try {
			SysA010BG UserInfo = (SysA010BG)session.getAttribute("USERINFO");			
			NotA110BG params = new NotA110BG();
			params.setNot_status(not_status);
			params.setKey_str(key_str);
			params.setNot_follow(not_follow);
			params.setPageId(selected_level);
			params.setUserid(UserInfo.getEmp_no());
			
			NotAllSL sl = (NotAllSL)EJBFinder.lookup("ejb/NotAllSL");
			boolean delFlag = sl.delNotA200Item(params);
			if("1".equals(selected_level)){
				req.setAttribute("dataComplete","D1");				
			} else if("2".equals(selected_level)){
				req.setAttribute("dataComplete","D2");
			}
			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			/*if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:NotA200Serv:deleteTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"delete");
			} else {
				Logger.debug.println("[BASE:NotA200Serv:deleteTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"delete");
			}
			@2018-03-06
			*/
			Logger.debug.println("[BASE:NotA200Serv:deleteTask] "+((Exception)e).getMessage());
			printMessagePage2(req, res, e.getMessage(),returnPage,"delete");
		} 
	}//end deleteTask
}
