package kal.base.not.serv;

import java.rmi.RemoteException;
import java.util.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import kal.base.com.util.*;
import kal.base.com.serv.*;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.Box;
import kal.base.jdf.serv.HttpUtility;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.sys.dbbean.SysA010BG;
import kal.base.not.dbbean.*;
import kal.base.not.ejb.NotAllSL;

/**
 * Archived NOTAM Servlet Class
 * @version 	1.0
 * @author Copyright (c) 2008/01/22 
 */
public class NotQ730Serv extends PublicBaseServlet {
		
	/** 
	  * REGION_CD ȸ Servlet Class - checkTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2008/01/22 
	  */	
	public void checkTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 															//Box ü 
		
		String returnPage = StringUtil.checkString(box.getString("returnPage"));					//Return Page ȹ
		
		try {
			//Parameter 
			NotQ730BG params = new NotQ730BG();
			
			//EJB LookUp
			NotAllSL sl = (NotAllSL)EJBFinder.lookup("ejb/NotAllSL");
			Hashtable hashData = sl.selNotQ730RCd(params);
			
			req.setAttribute("hashData", hashData);
			req.setAttribute("areaValue", "Y");
			
			//  			
			printJspPage(req, res, returnPage);
		
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:NotQ730Serv:checkTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"check");
			} else {
				Logger.debug.println("[BASE:NotQ730Serv:checkTask] "+StringUtil.toKSC5601(((Exception)e).getMessage()));
				printMessagePage2(req, res, e.getMessage(),returnPage,"check");
			}
		} 
	}//end of function
	
	/** 
	  * ARCHIVED NOTAM ȸ Servlet Class - selectTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2008/01/23 
	  */	
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 															//Box ü 
		
		String fromDt = StringUtil.checkString(box.getString("fromDt"));
		String toDt = StringUtil.checkString(box.getString("toDt"));
		String fltId = StringUtil.checkString(box.getString("fltId")).toUpperCase();
		String dep = StringUtil.checkString(box.getString("dep")).toUpperCase();
		String arr = StringUtil.checkString(box.getString("arr")).toUpperCase();
		String area = StringUtil.checkString(box.getString("area"));
		
		String returnPage = StringUtil.checkString(box.getString("returnPage"));					//Return Page ȹ
		
		try {
			//Parameter 
			NotQ730BG params = new NotQ730BG();
			
			params.setPFromDt(fromDt);
			params.setPToDt(toDt);
			params.setPFltId(fltId);
			params.setPDep(dep);
			params.setPArr(arr);
			params.setPArea(area);
			
			//EJB LookUp
			NotAllSL sl = (NotAllSL)EJBFinder.lookup("ejb/NotAllSL");
			Hashtable hashData = sl.selNotQ730Main(params);
			if (hashData != null){
				req.setAttribute("successMessage",ComUtil.getInstance().getMessage("Archived NOTAM", hashData, "ARCHIVELIST", MessageCode.getInstance().DATA_MSG));
			}
			req.setAttribute("hashData", hashData);
			
			//  			
			printJspPage(req, res, returnPage);
		
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:NotQ730Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			} else {
				Logger.debug.println("[BASE:NotQ730Serv:selectTask] "+StringUtil.toKSC5601(((Exception)e).getMessage()));
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			}
		} 
	}//end of function
	
	/** 
	  * ARCHIVED NOTAM NOT_NUM ȸ Servlet Class - performTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2008/01/24 
	  */	
	public void performTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 															//Box ü 
		
		String pSendDt = StringUtil.checkString(box.getString("pSendDt"));
		String pFltId = StringUtil.checkString(box.getString("pFltId"));
		String pDep = StringUtil.checkString(box.getString("pDep"));
		String pArr = StringUtil.checkString(box.getString("pArr"));
		
		String returnPage = StringUtil.checkString(box.getString("returnPage"));					//Return Page ȹ
		
		try {
			//Parameter 
			NotQ730BG params = new NotQ730BG();
			
			params.setPSendDt(pSendDt);
			params.setPFltId(pFltId);
			params.setPDep(pDep);
			params.setPArr(pArr);
			
			//EJB LookUp
			NotAllSL sl = (NotAllSL)EJBFinder.lookup("ejb/NotAllSL");
			Hashtable hashData = sl.selNotQ730NotNum(params);
			
			req.setAttribute("hashData", hashData);
			req.setAttribute("returnChk", "Y");
			
			//  			
			printJspPage(req, res, returnPage);
		
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:NotQ730Serv:performTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"perform");
			} else {
				Logger.debug.println("[BASE:NotQ730Serv:performTask] "+StringUtil.toKSC5601(((Exception)e).getMessage()));
				printMessagePage2(req, res, e.getMessage(),returnPage,"perform");
			}
		} 
	}//end of function
}
