package kal.base.ocb.serv;

import java.rmi.RemoteException;
import java.util.Hashtable;
import java.util.Vector;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import kal.base.com.util.*;
import kal.base.com.serv.*;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.Box;
import kal.base.jdf.serv.HttpUtility;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.ocb.dbbean.OcbA025BG;
import kal.base.ocb.ejb.OcbAllSL;

/**
 * Restriction Airport Popup Servlet Class
 * @version 	1.0
 * @author Copyright (c) 2005/03/28  
 */
public class OcbA025Serv extends PublicBaseServlet{

	/** 
	  * Restriction Airport Popup Servlet Class - insertTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/03/28  
	  */	
	public void insertTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		
		Box box = HttpUtility.getBox(req);				 										    //Box ü 
		
		String apo = StringUtil.checkString(box.getString("apo"));						//APT_C
		String prob = StringUtil.checkString(box.getString("prob"));						//PROB_C
		String reason = StringUtil.checkString(box.getString("reason"));				//REASON_E
		String from = StringUtil.checkString(box.getString("from"));						//START_T
		String to = StringUtil.checkString(box.getString("to"));								//END_T
		String remarks = StringUtil.checkString(box.getString("remarks"));				//REMARK_E				
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
				
		try {
			OcbA025BG params = new OcbA025BG();	
			
			params.setApt_c(apo);
			params.setProb_c(prob);
			params.setReason_e(reason);
			params.setStart_t(from);
			params.setEnd_t(to);
			params.setRemark_e(remarks);
			
			//EJB LookUp
			OcbAllSL sl = (OcbAllSL)EJBFinder.lookup("ejb/OcbAllSL");
			int returnValue = sl.insOcbA025Main(params);
			if (returnValue == 1){
				req.setAttribute("successMessage",ComUtil.getInstance().getMessage("Restriction Airport", null, "", MessageCode.getInstance().INSERT_MSG));
			}else{
				req.setAttribute("errorMessage",MessageCode.getInstance().INSERT_MSG);
			}
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:OcbA025Serv:insertTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"insert");
			} else {
				Logger.debug.println("[BASE:OcbA025Serv:insertTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"insert");
			}
		} 
	}//end insertTask
}
