package kal.base.ocb.serv;

import java.rmi.RemoteException;
import java.util.*;

import javax.servlet.http.*;

import kal.base.com.util.*;
import kal.base.iro.dbbean.IroQ460BG;
import kal.base.iro.ejb.IroAllSL;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.*;
import kal.base.com.serv.*;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.sup.ejb.SupAllSL;
import kal.base.ocb.dbbean.*;
import kal.base.ocb.ejb.OcbAllSL;
import kal.base.com.ejb.ComAllSL;

/**
 * Operations Control Board Servlet Class
 * @version 	1.0
 * @author Copyright (c) 2005/03/16 HIST  
 */
public class OcbQ010Serv extends PublicBaseServlet{
	/** 
	  * Operations Control Board Main Servlet Class - selectTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/03/16 HIST  
	  */		
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		String returnPage = "/jsp/ocb/OcbQ010UI.jsp";		//Return Page ȹ
		
		try {
			//EJB LookUp
			ComAllSL comSL = (ComAllSL)EJBFinder.lookup("ejb/ComAllSL");
			String reportD = comSL.selDbTime("yyyymmdd","0");	//ȸ KST
			
			OcbAllSL ocbSL = (OcbAllSL)EJBFinder.lookup("ejb/OcbAllSL");
			Hashtable hashData  = ocbSL.selOcbQ010Main(reportD);
			
			if (hashData != null) req.setAttribute("successMessage",ComUtil.getInstance().getMessage("Operations Control Board", null, "", MessageCode.getInstance().SELECT_MSG));
			req.setAttribute("hashData",hashData);
			req.setAttribute("reportD",reportD);
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:OcbQ010Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			} else {
				Logger.debug.println("[BASE:OcbQ010Serv:selectTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			}
		} 
	}//end of function
	
	/** 
	  * KE Flight Status - IROPS -  IROPS REPORT ˾ ȸ Servlet Class - checkTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2009/09/17 
	  */	
	public void checkTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		
		Box box = HttpUtility.getBox(req);				 										    //Box ü 
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		try {
			//EJB LookUp
			ComAllSL comSL = (ComAllSL)EJBFinder.lookup("ejb/ComAllSL");
			String reportD = comSL.selDbTime("yyyymmdd","0");	//ȸ KST
			
			OcbAllSL ocbSL = (OcbAllSL)EJBFinder.lookup("ejb/OcbAllSL");
			Hashtable hashData  = ocbSL.selOcbQ010IropsDetail(reportD);
			
			req.setAttribute("hashData", hashData);
			
			//  
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:OcbQ010Serv:checkTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"check");
			} else {
				Logger.debug.println("[BASE:OcbQ010Serv:checkTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"check");
			}
		} 
	}//end checkTask
	
}//end of class
