package kal.base.ocb.serv;

import java.rmi.RemoteException;
import java.util.Hashtable;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import kal.base.com.util.*;
import kal.base.com.serv.*;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.Box;
import kal.base.jdf.serv.HttpUtility;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.ocb.dbbean.OcbQ140BG;
import kal.base.ocb.ejb.OcbAllSL;

/**
 *  Departure On Time Pcnt Detail II Servlet Class
 * @version 	1.0
 * @author Copyright (c) 2005/04/29 
 */
public class OcbQ140Serv extends PublicBaseServlet {
	/** 
	  * Departure On Time Pcnt Detail II Main Servlet Class - selectTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/04/29  
	  */	
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 										    //Box ü 
		
		String startDate = ComUtil.getInstance().selDbTime("YYYYMMDD","0");  	//UTC : 540/1440, KST : 0
		String endDate = ComUtil.getInstance().selDbTime("YYYYMMDD","0");  	//UTC : 540/1440, KST : 0
		String station = StringUtil.checkString(box.getString("station"));				//station
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		try {
			OcbQ140BG params = new OcbQ140BG();
			params.setStart_date(startDate);
			params.setEnd_date(endDate);
			params.setStnfr(station);
			params.setTime_x("KST");
			
			//EJB LookUp
			OcbAllSL sl = (OcbAllSL)EJBFinder.lookup("ejb/OcbAllSL");
			Hashtable hashData  = sl.selOcbQ140Main(params);
			if (hashData != null){
				req.setAttribute("successMessage",ComUtil.getInstance().getMessage("Departure On Time Pcnt Detail II", hashData, "FLTINFO", MessageCode.getInstance().DATA_MSG));
			}
			req.setAttribute("hashData",hashData);
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:OcbQ140Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			} else {
				Logger.debug.println("[BASE:OcbQ140Serv:selectTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			}
		} 
	}//end selectTask
}
