package kal.base.rep.serv;

import java.rmi.RemoteException;
import java.util.Hashtable;
import java.util.Vector;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import kal.base.com.util.*;
import kal.base.com.serv.*;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.Box;
import kal.base.jdf.serv.HttpUtility;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.rep.dbbean.RepQ330BG;
import kal.base.rep.ejb.RepAllSL;

/**
 * PAX Load Factor Servlet Class
 * @version 	1.0
 * @author Copyright (c) 2005/07/27  
 */
public class RepQ330Serv extends PublicBaseServlet {
	/** 
	  * PAX Load Factor Servlet Class - selectTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/07/22  
	  */	
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		
		Box box = HttpUtility.getBox(req);				 										    //Box ü 
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		String yyyymmdd = StringUtil.checkString(box.getString("yyyymmdd"));		// ¥yyyymmdd
				
		try {
			RepQ330BG params = new RepQ330BG();	
			params.setToday(yyyymmdd);
			
			//EJB LookUp
			RepAllSL sl = (RepAllSL)EJBFinder.lookup("ejb/RepAllSL");
			Hashtable hashData  = sl.selRepQ330Main(params);
			if (hashData != null){
				req.setAttribute("successMessage",ComUtil.getInstance().getMessage("PAX Load Factor", null, "", MessageCode.getInstance().SELECT_MSG));
			}
			req.setAttribute("hashData",hashData);
			req.setAttribute("returnParam","Y");
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:RepQ330Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			} else {
				Logger.debug.println("[BASE:RepQ330Serv:selectTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			}
		} 
	}//end selectTask
}
