package kal.base.skd.serv;

import java.rmi.RemoteException;
import java.util.Hashtable;
import java.util.LinkedList;
import java.util.List;
import java.util.Vector;
import javax.servlet.http.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import kal.base.com.util.*;
import kal.base.com.serv.*;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.Box;
import kal.base.jdf.serv.HttpUtility;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.skd.dbbean.SkdA080BG;
import kal.base.skd.ejb.SkdAllSL;

/**
 * RAD Servlet Class
 * @version 	1.0
 * @author Copyright (c) 2009/10/15 
 */
public class SkdA080Serv extends PublicBaseServlet{
	
	private static SkdA080Serv instance = new SkdA080Serv();
	
	public static SkdA080Serv getInstance() {
		return instance;
	}
	
	/**
	 * KACTYP ȸ
	 * @author Copyright (c) 2009/10/15 
	 */
	public static Hashtable selKactyp() throws Exception {
		try {
			SkdAllSL sl = (SkdAllSL)EJBFinder.lookup("ejb/SkdAllSL");
			Hashtable hashData = sl.selSkdA080Kactyp();
			
			return hashData;
		} catch(Exception e) {
			if(e instanceof Exception) {
				throw new Exception(e.getMessage());
			} else {
				throw new Exception(MessageCode.getInstance().ETC_EXPT);
			}
		}
	}
	
	/** 
	  * RAD ȸ Servlet Class - selectTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2009/10/15 
	  */		
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 													//Box ü 
		
		String dt = StringUtil.checkString(box.getString("dt"));					//YYMMDD
		String kactyp = StringUtil.checkString(box.getString("kactyp"));		//77A,332 739... 
		
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		try {
			//EJB Parameter 
			SkdA080BG params = new SkdA080BG();
			
			params.setDt(dt);
			params.setKactyp(kactyp);
			
			//EJB LookUp
			SkdAllSL sl = (SkdAllSL)EJBFinder.lookup("ejb/SkdAllSL");
			Hashtable hashData  = sl.selSkdA080Main(params);
			
			if (hashData != null) req.setAttribute("successMessage",ComUtil.getInstance().getMessage("RAD", hashData, "RAD_LIST", MessageCode.getInstance().DATA_MSG));
			req.setAttribute("hashData", hashData);
			
			req.setAttribute("dt", dt);
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SkdA080Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			} else {
				Logger.debug.println("[BASE:SkdA080Serv:selectTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			}
		} 
	}//end selectTask	
	
	/** 
	  * RAD SEND Servlet Class - insertTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2009/10/20 
	  */		
	public void insertTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 													//Box ü 
		
		String dt = StringUtil.checkString(box.getString("dt"));							//YYMMDD
		String ddMon = StringUtil.checkString(box.getString("ddMon"));			//DDMON
		String timestamp = StringUtil.checkString(box.getString("timestamp"));	//YYYYMMDDHH24MISS
		String utcTime = StringUtil.checkString(box.getString("utcTime"));			//DDHH24MI
		String deptC = StringUtil.checkString(box.getString("deptC"));
		
		String[] sKactyp = req.getParameterValues("sKactyp");
		String[] sRegno = req.getParameterValues("sRegno");
		String[] sFltNum = req.getParameterValues("sFltNum");
		
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		try {
			//EJB Parameter 
			SkdA080BG timeData = new SkdA080BG();
			
			timeData.setDt(dt);
			timeData.setDdMon(ddMon);
			timeData.setTimestamp(timestamp);
			timeData.setUtcTime(utcTime);
			timeData.setDeptC(deptC);
			
			// Flight óѴ.			
			Hashtable hashParam = new Hashtable();
			List listParam = new LinkedList();
			
			for (int i=0 ; i<sKactyp.length ; i++) {
				
				SkdA080BG params = new SkdA080BG();
				
				params.setSKactyp(sKactyp[i]);
				params.setSRegno(sRegno[i]);
				params.setSFltNum(sFltNum[i]);
				/*
				System.out.println(sKactyp[i]);
				System.out.println(sRegno[i]);
				System.out.println(sFltNum[i]);
				System.out.println("-------------------------------------");
				*/
				listParam.add(params);
			}
			hashParam.put("listParam", listParam);
			
			//EJB LookUp
			SkdAllSL sl = (SkdAllSL)EJBFinder.lookup("ejb/SkdAllSL");
			String returnValue = sl.insSkdA080Send(timeData, hashParam);
			
			req.setAttribute("returnValue", returnValue);
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SkdA080Serv:insertTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"insert");
			} else {
				Logger.debug.println("[BASE:SkdA080Serv:insertTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"insert");
			}
		}
	}//end insertTask
	
}//end class
