package kal.base.skd.serv;

import java.rmi.RemoteException;
import java.util.Hashtable;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import kal.base.com.util.*;
import kal.base.com.serv.*;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.Box;
import kal.base.jdf.serv.HttpUtility;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.skd.dbbean.SkdQ020BG;
import kal.base.skd.ejb.SkdAllSL;

/**
 *  Flight Progress Information Servlet Class
 * @version 	1.0
 * @author Copyright (c) 2005/01/20 
 */
public class SkdQ020Serv  extends PublicBaseServlet{
	
	/** 
	  * Flight Progress Information Servlet Class - selectTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/01/20 
	  */	
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 										    //Box ü 

		String startDate = StringUtil.checkString(box.getString("start_date"));			//˻
		if(startDate.length()==6) startDate = "20"+startDate;	
		String endDate = StringUtil.checkString(box.getString("end_date"));			//˻ 
		if(endDate.length()==6) endDate = "20"+endDate;
		String fltId = StringUtil.checkString(box.getString("flt_id"));						//FLT ID
		String acReg = StringUtil.checkString(box.getString("acreg"));					//ACREG
		String station = StringUtil.checkString(box.getString("station"));				//station
		String timeX = StringUtil.checkString(box.getString("time_x"));					//KST/UTC/LOC 
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		try {
			SkdQ020BG params = new SkdQ020BG();
			params.setStart_date(startDate);
			params.setEnd_date(endDate);
			params.setFlt_num(fltId);
			params.setRegno(acReg);
			params.setStnfr(station);
			params.setTime_x(timeX);
			
			//EJB LookUp
			SkdAllSL sl = (SkdAllSL)EJBFinder.lookup("ejb/SkdAllSL");
			Hashtable hashData  = sl.selSkdQ020Main(params);
			if (hashData != null){
				req.setAttribute("successMessage",ComUtil.getInstance().getMessage("Flight Progress Information", hashData, "FLTINFO", MessageCode.getInstance().DATA_MSG));
			}
			req.setAttribute("hashData",hashData);
			req.setAttribute("station",station); //2007.06.18 ߰
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SkdQ020Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			} else {
				Logger.debug.println("[BASE:SkdQ020Serv:selectTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			}
		} 
	}//end selectTask

}
