package kal.base.skd.serv;

import java.rmi.RemoteException;
import java.util.Hashtable;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import kal.base.com.util.*;
import kal.base.com.serv.*;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.Box;
import kal.base.jdf.serv.HttpUtility;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.skd.dbbean.SkdQ030BG;
import kal.base.skd.ejb.SkdAllSL;

/**
 * Planning SKD INFO Servlet Class
 * @version 	1.0
 * @author Copyright (c) 2005/01/17 
 */
public class SkdQ030Serv extends PublicBaseServlet{

	/** 
	  * Planning SKD INFO Servlet Class - selectTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/01/17 
	  */	
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 													//Box ü 

		String allDate = StringUtil.checkString(box.getString("all_date"));               //ȸ
		if(allDate.length()==6)
		{
			allDate = "20"+allDate;
		}
		String station = StringUtil.checkString(box.getString("station"));				//station
		String domIntX = StringUtil.checkString(box.getString("dom_int_x"));			//DOM/INT/CRG 
		String timeX = StringUtil.checkString(box.getString("time_x"));					//KST/UTC/LOC 
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		try {
			SkdQ030BG params = new SkdQ030BG();
			params.setSch_dep_dt(allDate);
			params.setStnfr(station);
			params.setDom_int_x(domIntX);
			params.setTime_x(timeX);
			//EJB LookUp
			SkdAllSL sl = (SkdAllSL)EJBFinder.lookup("ejb/SkdAllSL");
			Hashtable hashData  = sl.selSkdQ030Main(params);
			if (hashData != null){
				req.setAttribute("successMessage",ComUtil.getInstance().getMessage("Planning SKD INFO", hashData, "SKDINFO", MessageCode.getInstance().DATA_MSG));
			}
			req.setAttribute("hashData",hashData);
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SkdQ030Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			} else {
				Logger.debug.println("[BASE:SkdQ030Serv:selectTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			}
		} 
	}//end selectTask
}
