package kal.base.skd.serv;

import java.net.URL;
import java.rmi.RemoteException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Hashtable;
import java.util.LinkedList;
import java.util.List;
import java.util.Locale;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import kal.base.com.serv.ComUtil;
import kal.base.com.util.MessageCode;
import kal.base.com.util.StringUtil;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.Box;
import kal.base.jdf.serv.HttpUtility;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.skd.dbbean.SkdQ040BG;
import kal.base.skd.dbbean.SkdQ045BG;
import kal.base.skd.ejb.SkdAllSL;

import org.tempuri.CaSKD2006ServiceSoapStub;
import org.tempuri.Crew_Info;
import org.tempuri.CrewsOnFlight_Info;
import org.tempuri.Flight_info;
import org.tempuri.Pattern_Info;


/**
 *SKD/Detail FLT Status Servlet Class
 * @version 	1.0
 * @author Copyright (c) 2005/01/20 HIST  
 */
public class SkdQ040Serv extends PublicBaseServlet{
	/** 
	  * SKD/Detail FLT Status Servlet Class - checkTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/01/18 HIST  
	  */		
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 														//Box ü 
		String fltNum = StringUtil.checkString(box.getString("fltNum"));							//Flight Number
		String schDepDt = StringUtil.checkString(box.getString("schDepDt"));				//SCH_DEP_DT
		String actDepDtKst = StringUtil.checkString(box.getString("actDepDtKst"));		//ACT_DEP_DT_KST
		String firstLegFltDt = StringUtil.checkString(box.getString("firstLegFltDt"));			//FIRST_LEG_FLT_DT
		String timeX = StringUtil.checkString(box.getString("timeX"));							//Timeڵ UTC/KST/LOC
		String stnFr = StringUtil.checkString(box.getString("stnFr"));								//߰
		String stnTo = StringUtil.checkString(box.getString("stnTo"));							//
		String returnPage = StringUtil.checkString(box.getString("returnPage"));			//Return Page ȹ
		
		//20150603 ߰
		String schDepDtLoc = StringUtil.checkString(box.getString("schDepDtLoc"));		//SCH_DEP_DT_LOC
		
		try {
			//EJB Parameter 
			SkdQ040BG params = new SkdQ040BG();
			params.setFlt_num(fltNum);
			params.setSch_dep_dt(schDepDt);
			//params.setSch_dep_dt_kst(actDepDtKst);
			params.setAct_dep_dt_kst(actDepDtKst);
			params.setFirst_leg_flt_dt(firstLegFltDt);
			params.setTime_x(timeX);
			params.setStnfr(stnFr);
			params.setStnto(stnTo);
			
			//EJB LookUp
			SkdAllSL sl = (SkdAllSL)EJBFinder.lookup("ejb/SkdAllSL");
			Hashtable hashData  = sl.selSkdQ040Main(params);
			if (hashData != null) req.setAttribute("successMessage",ComUtil.getInstance().getMessage("Detail FLT Status", null, "", "KE"+fltNum+" "+MessageCode.getInstance().SELECT_MSG));
			
			//20150603 ߰
			params.setSch_dep_dt_loc(schDepDtLoc);
			List listData = getCabinInformation(params);
			hashData.put("CABININFO",listData);
			
			req.setAttribute("hashData",hashData);
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SkdQ040Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			} else {
				Logger.debug.println("[BASE:SkdQ040Serv:selectTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			}
		} 
	}//end selectTask	
	
	//20150603 ߰
	public LinkedList getCabinInformation(SkdQ040BG params) {
		LinkedList cabinInfoList = new LinkedList();
		
		try {

			String pDurFr = params.getSch_dep_dt_loc();
			String pDurTo = params.getSch_dep_dt_loc();
			String pFltNo = params.getFlt_num();
			boolean pKE = true;
			
			//STG Server
			//URL endpointURL = new URL("http://10.1.21.179:81/CabinService/CaSKD2006Service.asmx");
			//PRD Server
			//URL endpointURL = new URL("http://10.1.21.200/CabinService/CaSKD2006Service.asmx");
			//20150722 ukfos domain ȣϵ 
			URL endpointURL = new URL("http://ukfos.koreanair.com/CabinService/CaSKD2006Service.asmx");
			
			CaSKD2006ServiceSoapStub stub = new CaSKD2006ServiceSoapStub(endpointURL, null);
			CrewsOnFlight_Info cofInfo = stub.retriveCrewsOnFlight(pDurFr, pDurTo, pFltNo, pKE);
			
			Pattern_Info[] patternInfos = cofInfo.getPatterns();
			if(patternInfos != null) {
				
				SimpleDateFormat lclFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm");
				SimpleDateFormat dateFormat = new SimpleDateFormat("dd-MMM-yy", Locale.ENGLISH);
				SimpleDateFormat timeFormat = new SimpleDateFormat("HHmm", Locale.ENGLISH);
				Date tempTime = null;
				String dateStr = null;
				String stdStr = null;
				String staStr = null;
				
				LinkedList flightInfoList = null;
				LinkedList crewInfoList = null;
				SkdQ045BG flightInfoObj = null;
				SkdQ045BG crewInfoObj = null;
				SkdQ045BG cabinInfoObj = null;
				
				for(int patternInfoIdx = 0; patternInfoIdx < patternInfos.length; patternInfoIdx++) {
				
					Pattern_Info patternsInfo = patternInfos[patternInfoIdx];
					
					int patternId = patternsInfo.getPattern_id();
					System.out.println("patternId : " + (patternId + 1));
					
					flightInfoList = new LinkedList();
					
					Flight_info[] flightInfos = patternsInfo.getFlightInfos();
					if(flightInfos != null) {
						
						tempTime = null;
						dateStr = "";
						stdStr = "";
						staStr = "";
						
						Flight_info flightInfo = null;
						for(int flightInfoIdx = 0; flightInfoIdx < flightInfos.length; flightInfoIdx++) {
							
							flightInfo = flightInfos[flightInfoIdx];
							
							if(flightInfo.getStdLCL() != null && flightInfo.getStdLCL().length() == 16) {
								tempTime = lclFormat.parse(flightInfo.getStdLCL());
								dateStr = dateFormat.format(tempTime);
								stdStr = timeFormat.format(tempTime);
							}

							if(flightInfo.getStaLCL() != null && flightInfo.getStaLCL().length() == 16) {
								tempTime = lclFormat.parse(flightInfo.getStaLCL());
								staStr = timeFormat.format(tempTime);	
							}
							
							flightInfoObj = new SkdQ045BG();
							flightInfoObj.setHl(flightInfo.getHLNo());
							flightInfoObj.setDate(dateStr);
							flightInfoObj.setAc(flightInfo.getAC());
							flightInfoObj.setFltNo(flightInfo.getFltNo());
							flightInfoObj.setDuty(flightInfo.getDuty());
							flightInfoObj.setDep(flightInfo.getStnFr());
							flightInfoObj.setStd(stdStr);
							flightInfoObj.setArv(flightInfo.getStnTo());
							flightInfoObj.setSta(staStr);
							flightInfoObj.setFt(flightInfo.getFT());
							flightInfoObj.setDt(flightInfo.getDT());
							flightInfoObj.setLt(flightInfo.getLT());
							
							flightInfoList.add(flightInfoObj);
							
							/*
							System.out.println("flightInfoIdx : " + (flightInfoIdx + 1) + "\n");
							System.out.println("HL		: " + flightInfo.getHLNo());
							System.out.println("DATE		: " + dateStr);
							System.out.println("A/C		: " + flightInfo.getAC());
							System.out.println("FLT#		: " + flightInfo.getFltNo());
							System.out.println("DUTY		: " + flightInfo.getDuty());
							System.out.println("DEP		: " + flightInfo.getStnFr());
							System.out.println("STD		: " + stdStr);
							System.out.println("ARV		: " + flightInfo.getStnTo());
							System.out.println("STA		: " + staStr);
							System.out.println("F/T		: " + flightInfo.getFT());
							System.out.println("D/T		: " + flightInfo.getDT());
							System.out.println("L/T		: " + flightInfo.getLT());
							System.out.println("\n");
							*/
						}
					}

					crewInfoList = new LinkedList();
					
					Crew_Info[] crewInfos = patternsInfo.getRosteredCrews();
					if(crewInfos != null) {
						
						Crew_Info crewInfo = null;
						for(int crewInfoIdx = 0; crewInfoIdx < crewInfos.length; crewInfoIdx++) {
							
							crewInfo = crewInfos[crewInfoIdx];

							crewInfoObj = new SkdQ045BG();
							crewInfoObj.setTeam(crewInfo.getTeam());
							crewInfoObj.setStaff(crewInfo.getStaffNo());
							crewInfoObj.setRank(crewInfo.getRank());
							crewInfoObj.setQual1(crewInfo.getQualCD1());
							crewInfoObj.setQual2(crewInfo.getQualCD2());
							crewInfoObj.setQual3(crewInfo.getQualCD3());
							crewInfoObj.setQual4(crewInfo.getQualCD4());
							crewInfoObj.setQual5(crewInfo.getQualCD5());
							crewInfoObj.setQual6(crewInfo.getQualCD6());
							crewInfoObj.setName(crewInfo.getName());
							
							crewInfoList.add(crewInfoObj);
							
							/*
							System.out.println("crewInfoIdx : " + (crewInfoIdx + 1) + "\n");
							System.out.println("TEAM	: " + crewInfo.getTeam());
							System.out.println("STAFF	: " + crewInfo.getStaffNo());
							System.out.println("RANK	: " + crewInfo.getRank());
							System.out.println("QUAL1	: " + crewInfo.getQualCD1());
							System.out.println("QUAL2	: " + crewInfo.getQualCD2());
							System.out.println("QUAL3	: " + crewInfo.getQualCD3());
							System.out.println("QUAL4	: " + crewInfo.getQualCD4());
							System.out.println("QUAL5	: " + crewInfo.getQualCD5());
							System.out.println("QUAL6	: " + crewInfo.getQualCD6());
							System.out.println("NAME	: " + crewInfo.getName());
							System.out.println("\n");
							*/
						}
					}
					
					if(flightInfoList.size() >= crewInfoList.size()) {
						
						for(int idx = 0; idx < flightInfoList.size(); idx++) {
							flightInfoObj = (SkdQ045BG)flightInfoList.get(idx);

							if(idx < crewInfoList.size()) {
								crewInfoObj = (SkdQ045BG)crewInfoList.get(idx);
							} else {
								crewInfoObj = new SkdQ045BG();
							}
							
							cabinInfoObj = getCabinInfoObj(flightInfoObj, crewInfoObj);
							cabinInfoObj.setPatternId(patternId % 2 == 0 ? "odd" : "even");

							cabinInfoList.add(cabinInfoObj);
						}
					} else {
						
						for(int idx = 0; idx < crewInfoList.size(); idx++) {
							crewInfoObj = (SkdQ045BG)crewInfoList.get(idx);

							if(idx < flightInfoList.size()) {
								flightInfoObj = (SkdQ045BG)flightInfoList.get(idx);
							} else {
								flightInfoObj = new SkdQ045BG();
							}
							
							cabinInfoObj = getCabinInfoObj(flightInfoObj, crewInfoObj);
							cabinInfoObj.setPatternId(patternId % 2 == 0 ? "odd" : "even");

							cabinInfoList.add(cabinInfoObj);
						}
						
					}
				}
			}
		} catch(Exception e){
			Logger.debug.println("[BASE:SkdQ040Serv:selectTask] "+((Exception)e).getMessage());
			e.printStackTrace();
		}
		
		return cabinInfoList;
	}
	public SkdQ045BG getCabinInfoObj(SkdQ045BG flightInfoObj, SkdQ045BG crewInfoObj) {
		SkdQ045BG cabinInfoObj = new SkdQ045BG();

		cabinInfoObj.setHl(flightInfoObj.getHl());
		cabinInfoObj.setDate(flightInfoObj.getDate());
		cabinInfoObj.setAc(flightInfoObj.getAc());
		cabinInfoObj.setFltNo(flightInfoObj.getFltNo());
		cabinInfoObj.setDuty(flightInfoObj.getDuty());
		cabinInfoObj.setDep(flightInfoObj.getDep());
		cabinInfoObj.setStd(flightInfoObj.getStd());
		cabinInfoObj.setArv(flightInfoObj.getArv());
		cabinInfoObj.setSta(flightInfoObj.getSta());
		cabinInfoObj.setFt(flightInfoObj.getFt());
		cabinInfoObj.setDt(flightInfoObj.getDt());
		cabinInfoObj.setLt(flightInfoObj.getLt());
		
		cabinInfoObj.setTeam(crewInfoObj.getTeam());
		cabinInfoObj.setStaff(crewInfoObj.getStaff());
		cabinInfoObj.setRank(crewInfoObj.getRank());
		cabinInfoObj.setQual1(crewInfoObj.getQual1());
		cabinInfoObj.setQual2(crewInfoObj.getQual2());
		cabinInfoObj.setQual3(crewInfoObj.getQual3());
		cabinInfoObj.setQual4(crewInfoObj.getQual4());
		cabinInfoObj.setQual5(crewInfoObj.getQual5());
		cabinInfoObj.setQual6(crewInfoObj.getQual6());
		cabinInfoObj.setName(crewInfoObj.getName());
		
		return cabinInfoObj;
	}
	
}//end class
