package kal.base.skd.serv;

import java.rmi.RemoteException;
import java.util.Hashtable;
import java.util.Vector;

import javax.servlet.http.*;

import kal.base.com.util.*;
import kal.base.com.serv.*;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.Box;
import kal.base.jdf.serv.HttpUtility;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.skd.dbbean.SkdQ070BG;
import kal.base.skd.ejb.SkdAllSL;

/**
 * Weekly SKD Display Servlet Class
 * @version 	1.0
 * @author Copyright (c) 2009/10/14 
 */
public class SkdQ070Serv extends PublicBaseServlet{
	
	private static SkdQ070Serv instance = new SkdQ070Serv();
	
	public static SkdQ070Serv getInstance() {
		return instance;
	}
	
	/**
	 * SEASON ȸ
	 * @author Copyright (c) 2009/10/14 
	 */
	public static Hashtable selSeason() throws Exception {
		try {
			SkdAllSL sl = (SkdAllSL)EJBFinder.lookup("ejb/SkdAllSL");
			Hashtable hashData = sl.selSkdQ070Season();

			return hashData;
		} catch(Exception e) {
			if(e instanceof Exception) {
				throw new Exception(e.getMessage());
			} else {
				throw new Exception(MessageCode.getInstance().ETC_EXPT);
			}
		}
	}
	//@2017-07-07
	public static Hashtable selKactyp() throws Exception {
		try {
			SkdAllSL sl = (SkdAllSL)EJBFinder.lookup("ejb/SkdAllSL");
			Hashtable hashData = sl.selSkdQ070Kactyp();
			
			return hashData;
		} catch(Exception e) {
			if(e instanceof Exception) {
				throw new Exception(e.getMessage());
			} else {
				throw new Exception(MessageCode.getInstance().ETC_EXPT);
			}
		}
	}
	
	/** 
	  * Weekly SKD Display ȸ Servlet Class - selectTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2009/10/14 
	  */		
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 													//Box ü 
		
		String season = StringUtil.checkString(box.getString("season")).substring(0,3); //ڸ ( : S09)
		String stnfr = StringUtil.checkString(box.getString("stnfr"));
		String stnto = StringUtil.checkString(box.getString("stnto"));
		String roundTrip = StringUtil.checkString(box.getString("roundTrip"));
		String timeX = StringUtil.checkString(box.getString("timeX"));
		String gubun = StringUtil.checkString(box.getString("gubun"));
		String fltId = StringUtil.checkString(box.getString("fltId"));
		
		String returnPage = StringUtil.checkString(box.getString("returnPage"));			//Return Page ȹ
		
		
		String kactyp = StringUtil.checkString(box.getString("kactyp"));	//@2017-07-07
		
		//System.out.println("@@@@@@@@@@@@@ roundTrip====>"+roundTrip);
		
		try {
			//EJB Parameter 
			SkdQ070BG params = new SkdQ070BG();
			
			params.setPSeason(season);
			params.setPStnfr(stnfr);
			params.setPStnto(stnto);
			params.setPRoundTrip(roundTrip);
			params.setPTimeX(timeX);
			params.setPGubun(gubun);
			params.setPFltId(fltId);
			params.setTyp(kactyp);//@2017-07-10
			
			//EJB LookUp
			SkdAllSL sl = (SkdAllSL)EJBFinder.lookup("ejb/SkdAllSL");
			Hashtable hashData  = sl.selSkdQ070Main(params);
			
			if (hashData != null) req.setAttribute("successMessage",ComUtil.getInstance().getMessage("Weekly SKD Display", hashData, "WEEKLY_LIST", MessageCode.getInstance().DATA_MSG));
			req.setAttribute("hashData", hashData);
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SkdQ070Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			} else {
				Logger.debug.println("[BASE:SkdQ070Serv:selectTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			}
		} 
	}//end selectTask	
	
}//end class
