package kal.base.skd.serv;

import java.rmi.RemoteException;
import java.util.Hashtable;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import kal.base.com.util.*;
import kal.base.com.serv.*;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.Box;
import kal.base.jdf.serv.HttpUtility;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.skd.dbbean.SkdQ110BG;
import kal.base.skd.ejb.SkdAllSL;

/**
 * Gantt Chart Servlet Class
 * @version 	1.0
 * @author Copyright (c) 2006/04/24 
 */
public class SkdQ110Serv extends PublicBaseServlet{
	/** 
	  * Gantt Chart Servlet Class - selectTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2006/04/24 
	  */	
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		
		Box box = HttpUtility.getBox(req);				 										    //Box ü 
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		String kactyp = StringUtil.checkString(box.getString("kactyp"));
		String refreshYN = StringUtil.checkString(box.getString("refreshYN"));
		
		String color_1 = StringUtil.checkString(box.getString("color_1"));
		String color_2 = StringUtil.checkString(box.getString("color_2"));
		String color_3 = StringUtil.checkString(box.getString("color_3"));
		String color_4 = StringUtil.checkString(box.getString("color_4"));
		String color_5 = StringUtil.checkString(box.getString("color_5"));
		String color_6 = StringUtil.checkString(box.getString("color_6"));
		String color_7 = StringUtil.checkString(box.getString("color_7"));
		
		// 2006.05.25 ߰
		String timeX = StringUtil.checkString(box.getString("timeX"));
		
		//String chkOk = StringUtil.checkString(box.getString("chkOk"));
		//Logger.debug.println("refreshYN ====> "+ refreshYN);
		
		try {
			SkdQ110BG params = new SkdQ110BG();
			params.setKactyp(kactyp);
			params.setTimeX(timeX);
			
			//EJB LookUp
			SkdAllSL sl = (SkdAllSL)EJBFinder.lookup("ejb/SkdAllSL");
			Hashtable hashData  = sl.selSkdQ110Main(params);
			
			req.setAttribute("hashData", hashData);
			req.setAttribute("returnParam", "Y");
			req.setAttribute("refreshYN", refreshYN);
			req.setAttribute("kactypParam", kactyp);
			
			req.setAttribute("color_1", color_1);
			req.setAttribute("color_2", color_2);
			req.setAttribute("color_3", color_3);
			req.setAttribute("color_4", color_4);
			req.setAttribute("color_5", color_5);
			req.setAttribute("color_6", color_6);
			req.setAttribute("color_7", color_7);
			
			// 2006.05.25 ߰
			req.setAttribute("timeXParam", timeX);
			
			//req.setAttribute("chkOk", chkOk);
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SkdQ110Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			} else {
				Logger.debug.println("[BASE:SkdQ110Serv:selectTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			}
		} 
	}//end selectTask
	
	/** 
	  * Gantt Chart ˾ Servlet Class - checkTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2006/05/09 
	  */	
	public void checkTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		
		Box box = HttpUtility.getBox(req);				 										    //Box ü 
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		String fltNum = StringUtil.checkString(box.getString("fltNum"));
		String timeX = StringUtil.checkString(box.getString("timeX"));// 2006.05.25 ߰
		String firstLegFltDt = StringUtil.checkString(box.getString("firstLegFltDt"));// 2006.05.26 ߰
		String returnParam = StringUtil.checkString(box.getString("returnParam"));
		
		try {
			SkdQ110BG params = new SkdQ110BG();
			params.setFltNum(fltNum);
			params.setTimeX(timeX);
			params.setFirstLegFltDt(firstLegFltDt);
			
			//EJB LookUp
			SkdAllSL sl = (SkdAllSL)EJBFinder.lookup("ejb/SkdAllSL");
			Hashtable hashData  = sl.selSkdQ110Crew(params);
			
			req.setAttribute("hashData", hashData);
			req.setAttribute("returnParam", "Y");
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SkdQ110Serv:checkTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"check");
			} else {
				Logger.debug.println("[BASE:SkdQ110Serv:checkTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"check");
			}
		} 
	}//end checkTask
}
