package kal.base.sta.serv;

import java.rmi.RemoteException;
import java.util.Hashtable;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import kal.base.com.util.*;
import kal.base.com.serv.*;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.Box;
import kal.base.jdf.serv.HttpUtility;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.sta.dbbean.StaQ010BG;
import kal.base.sta.ejb.StaAllSL;

/**
 *  Delay Status(Airport) Servlet Class
 * @version 	1.0
 * @author Copyright (c) 2005/01/25 
 */
public class StaQ010Serv extends PublicBaseServlet {
	/** 
	  * Delay Status(Airport) Servlet Class - selectTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/01/25 
	  */	
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 										    //Box ü 

		String startDate = StringUtil.checkString(box.getString("start_date"));			//˻
		if(startDate.length()==6) startDate = "20"+startDate;	
		String endDate = StringUtil.checkString(box.getString("end_date"));			//˻ 
		if(endDate.length()==6) endDate = "20"+endDate;
		String station = StringUtil.checkString(box.getString("station"));				//station
		String domIntX = StringUtil.checkString(box.getString("dom_int_x"));			//DOM/INT/CRG 
		String regular = StringUtil.checkString(box.getString("regular"));                //ALL/REGULAR/NON_REG/NON_REV
		String startTime = StringUtil.checkString(box.getString("start_time"));          // ּҽð()
		String endTime = StringUtil.checkString(box.getString("end_time"));            // ִð()
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		try {
			StaQ010BG params = new StaQ010BG();
			params.setStart_date(startDate);
			params.setEnd_date(endDate);
			params.setStnfr(station);
			params.setDom_int_x(domIntX);
			params.setRegular(regular);
			params.setStart_time(startTime);
			params.setEnd_time(endTime);
						
			//EJB LookUp
			StaAllSL sl = (StaAllSL)EJBFinder.lookup("ejb/StaAllSL");
			Hashtable hashData  = sl.selStaQ010Main(params);
			if (hashData != null){
				req.setAttribute("successMessage",ComUtil.getInstance().getMessage("Delay Status(Airport)", hashData, "DELAYINFO", MessageCode.getInstance().DATA_MSG));
			}
			req.setAttribute("hashData",hashData);
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:StaQ010Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			} else {
				Logger.debug.println("[BASE:StaQ010Serv:selectTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			}
		} 
	}//end selectTask
}
