package kal.base.sta.serv;

import java.rmi.RemoteException;
import java.util.Hashtable;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import kal.base.com.util.*;
import kal.base.com.serv.*;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.Box;
import kal.base.jdf.serv.HttpUtility;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.sta.dbbean.StaQ330BG;
import kal.base.sta.ejb.StaAllSL;

/**
 *  Cancel Status(A/C TYPE) Servlet Class
 * @version 	1.0
 * @author Copyright (c) 2005/01/27 
 */
public class StaQ330Serv extends PublicBaseServlet{
	/** 
	  * Cancel Status(A/C TYPE) Servlet Class - selectTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/01/27 
	  */	
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 										    //Box ü 

		String startDate = StringUtil.checkString(box.getString("start_date"));			//˻
		if(startDate.length()==6) startDate = "20"+startDate;	
		String endDate = StringUtil.checkString(box.getString("end_date"));			//˻ 
		if(endDate.length()==6) endDate = "20"+endDate;
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		try {
			StaQ330BG params = new StaQ330BG();
			params.setStart_date(startDate);
			params.setEnd_date(endDate);

			//EJB LookUp
			StaAllSL sl = (StaAllSL)EJBFinder.lookup("ejb/StaAllSL");
			Hashtable hashData  = sl.selStaQ330Main(params);
			if (hashData != null){
				req.setAttribute("successMessage",ComUtil.getInstance().getMessage("Cancel Status(A/C TYPE)", hashData, "CNLACTYPINFO", MessageCode.getInstance().DATA_MSG));
			}
			req.setAttribute("hashData",hashData);
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:StaQ330Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			} else {
				Logger.debug.println("[BASE:StaQ330Serv:selectTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			}
		} 
	}//end selectTask
}
