package kal.base.sta.serv;

import java.rmi.RemoteException;
import java.util.Hashtable;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import kal.base.com.util.*;
import kal.base.com.serv.*;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.Box;
import kal.base.jdf.serv.HttpUtility;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.sta.dbbean.StaQ410BG;
import kal.base.sta.ejb.StaAllSL;

/**
 *  ASM Summary Servlet Class
 * @version 	1.0
 * @author Copyright (c) 2005/01/27 
 */
public class StaQ410Serv extends PublicBaseServlet{
	/** 
	  * ASM Summary Servlet Class - selectTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/01/27 
	  */	
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 										    //Box ü 

		String startDate = StringUtil.checkString(box.getString("start_date"));			//˻
		if(startDate.length()==6) startDate = "20"+startDate;	
		String endDate = StringUtil.checkString(box.getString("end_date"));			//˻ 
		if(endDate.length()==6) endDate = "20"+endDate;
		String domIntX = StringUtil.checkString(box.getString("dom_int_x"));			//DOM/INT/CRG 
		String regular = StringUtil.checkString(box.getString("regular"));                //ALL/REGULAR/NON_REG/NON_REV
		String unit = StringUtil.checkString(box.getString("unit"));                         //FLT/LEG
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		try {
			StaQ410BG params = new StaQ410BG();
			params.setStart_date(startDate);
			params.setEnd_date(endDate);
			params.setDom_int_x(domIntX);
			params.setRegular(regular);
			params.setUnit(unit);

			//EJB LookUp
			StaAllSL sl = (StaAllSL)EJBFinder.lookup("ejb/StaAllSL");
			Hashtable hashData  = sl.selStaQ410Main(params);
			if (hashData != null){
				req.setAttribute("successMessage",ComUtil.getInstance().getMessage("ASM Summary", null, "", MessageCode.getInstance().SELECT_MSG));
			}
			req.setAttribute("hashData",hashData);
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:StaQ410Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			} else {
				Logger.debug.println("[BASE:StaQ410Serv:selectTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			}
		} 
	}//end selectTask
}
