package kal.base.sta.serv;

import java.rmi.RemoteException;
import java.util.Hashtable;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import kal.base.com.util.*;
import kal.base.com.serv.*;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.Box;
import kal.base.jdf.serv.HttpUtility;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.sta.dbbean.StaQ420BG;
import kal.base.sta.dbbean.StaQ610BG;
import kal.base.sta.ejb.StaAllSL;

/**
 * ASM Status(IRR) Servlet Class
 * @version 	1.0
 * @author Copyright (c) 2010/01/20 
 */
public class StaQ420Serv extends PublicBaseServlet {
	
	private static StaQ420Serv instance = new StaQ420Serv();
	
	public static StaQ420Serv getInstance() {
		return instance;
	}
	
	/**
	 * AD-HOC MSG CODE ȸ
	 * @author Copyright (c) 2010/01/20 
	 */
	public static Hashtable selAdhocMsgCode() throws Exception {
		try {
			StaAllSL sl = (StaAllSL)EJBFinder.lookup("ejb/StaAllSL");
			Hashtable hashData = sl.selStaQ420AdhocMsgCode();

			return hashData;
		} catch(Exception e) {
			if(e instanceof Exception) {
				throw new Exception(e.getMessage());
			} else {
				throw new Exception(MessageCode.getInstance().ETC_EXPT);
			}
		}
	}
	
	/** 
	  * ASM Status(IRR) Servlet Class - selectTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2010/01/20 
	  */	
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 										    //Box ü 

		String start_dt = StringUtil.checkString(box.getString("start_dt"));
		String end_dt = StringUtil.checkString(box.getString("end_dt"));
		String stn = StringUtil.checkString(box.getString("stn"));
		String flt_id = StringUtil.checkString(box.getString("flt_id"));
		String asm = StringUtil.checkString(box.getString("asm"));
		
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		try {
			StaQ420BG params = new StaQ420BG();
			
			params.setStart_dt(start_dt);
			params.setEnd_dt(end_dt);
			params.setStn(stn);
			params.setFlt_id(flt_id);
			params.setAsm(asm);
						
			//EJB LookUp
			StaAllSL sl = (StaAllSL)EJBFinder.lookup("ejb/StaAllSL");
			
			Hashtable hashData = sl.selStaQ420Main(params);
			if (hashData != null){
				req.setAttribute("successMessage",ComUtil.getInstance().getMessage("ASM Status(IRR)", hashData, "ASM_STATUS", MessageCode.getInstance().DATA_MSG));
			}
			req.setAttribute("hashData",hashData);
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:StaQ420Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			} else {
				Logger.debug.println("[BASE:StaQ420Serv:selectTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			}
		} 
	}//end selectTask
}
