package kal.base.sta.serv;

import java.rmi.RemoteException;
import java.util.Hashtable;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import kal.base.com.util.*;
import kal.base.com.serv.*;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.Box;
import kal.base.jdf.serv.HttpUtility;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.sta.dbbean.StaQ430BG;
import kal.base.sta.ejb.StaAllSL;

/**
 * Delay Status(IRR) Servlet Class
 * @version 	1.0
 * @author Copyright (c) 2010/01/21 
 */
public class StaQ430Serv extends PublicBaseServlet {
	/** 
	  * Delay Status(IRR) Servlet Class - selectTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2010/01/21 
	  */	
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 										    //Box ü 

		String start_dt = StringUtil.checkString(box.getString("start_dt"));
		String end_dt = StringUtil.checkString(box.getString("end_dt"));
		String flt_id = StringUtil.checkString(box.getString("flt_id"));
		String apt_fr = StringUtil.checkString(box.getString("apt_fr"));
		String apt_to = StringUtil.checkString(box.getString("apt_to"));
		String dla_fr = StringUtil.checkString(box.getString("dla_fr"));
		String dla_to = StringUtil.checkString(box.getString("dla_to"));
		String sort = StringUtil.checkString(box.getString("sort"));
		String tm = StringUtil.checkString(box.getString("tm"));
		
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		try {
			StaQ430BG params = new StaQ430BG();
			
			params.setStart_dt(start_dt);
			params.setEnd_dt(end_dt);
			params.setFlt_id(flt_id);
			params.setApt_fr(apt_fr);
			params.setApt_to(apt_to);
			params.setDla_fr(dla_fr);
			params.setDla_to(dla_to);
			params.setSort(sort);
			params.setTm(tm);
						
			//EJB LookUp
			StaAllSL sl = (StaAllSL)EJBFinder.lookup("ejb/StaAllSL");
			
			Hashtable hashData = sl.selStaQ430Main(params);
			if (hashData != null){
				req.setAttribute("successMessage",ComUtil.getInstance().getMessage("Delay Status(IRR)", hashData, "DELAY_STATUS", MessageCode.getInstance().DATA_MSG));
			}
			req.setAttribute("hashData",hashData);
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:StaQ430Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			} else {
				Logger.debug.println("[BASE:StaQ430Serv:selectTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			}
		} 
	}//end selectTask
}
