package kal.base.sta.serv;

import java.rmi.RemoteException;
import java.util.Hashtable;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import kal.base.com.util.*;
import kal.base.com.serv.*;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.Box;
import kal.base.jdf.serv.HttpUtility;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.sta.dbbean.StaQ610BG;
import kal.base.sta.ejb.StaAllSL;

/**
 * Operation Status(A/C REG) Servlet Class
 * @version 	1.0
 * @author Copyright (c) 2010/01/19 
 */
public class StaQ610Serv extends PublicBaseServlet {
	/** 
	  * Operation Status(A/C REG) Servlet Class - selectTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2010/01/19 
	  */	
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 										    //Box ü 

		String start_dt = StringUtil.checkString(box.getString("start_dt"));
		String end_dt = StringUtil.checkString(box.getString("end_dt"));
		String reg_1 = StringUtil.checkString(box.getString("reg_1"));
		String reg_2 = StringUtil.checkString(box.getString("reg_2"));
		String reg_3 = StringUtil.checkString(box.getString("reg_3"));
		String reg_4 = StringUtil.checkString(box.getString("reg_4"));
		String tm = StringUtil.checkString(box.getString("tm"));
		
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		try {
			StaQ610BG params = new StaQ610BG();
			
			params.setStart_dt(start_dt);
			params.setEnd_dt(end_dt);
			params.setReg_1(reg_1);
			params.setReg_2(reg_2);
			params.setReg_3(reg_3);
			params.setReg_4(reg_4);
			params.setTm(tm);
						
			//EJB LookUp
			StaAllSL sl = (StaAllSL)EJBFinder.lookup("ejb/StaAllSL");
			
			Hashtable hashData = sl.selStaQ610Main(params);
			if (hashData != null){
				req.setAttribute("successMessage",ComUtil.getInstance().getMessage("Operation Status(A/C REG)", hashData, "OPERATION_STATUS", MessageCode.getInstance().DATA_MSG));
			}
			req.setAttribute("hashData",hashData);
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:StaQ610Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			} else {
				Logger.debug.println("[BASE:StaQ610Serv:selectTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			}
		} 
	}//end selectTask
}
