package kal.base.sup.serv;

import java.rmi.RemoteException;
import java.util.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import kal.base.com.util.*;
import kal.base.com.serv.*;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.Box;
import kal.base.jdf.serv.HttpUtility;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.sys.dbbean.SysA010BG;
import kal.base.sup.dbbean.SupA310BG;
import kal.base.sup.ejb.SupAllSL;

/**
 * WEATHER LIST Servlet Class
 * @version 	1.0
 * @author Copyright (c) 2005/06/22 
 */
public class SupA310Serv extends PublicBaseServlet {
	/** 
	  * WEATHER LIST Servlet Class - selectTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/06/22 
	  */	
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 										    //Box ü 
    	
    	String[] wx_typ = new String[5];
    	wx_typ[0] = StringUtil.checkString(box.getString("wx_typ1"));				//WX_TYP1
    	wx_typ[1] = StringUtil.checkString(box.getString("wx_typ2"));				//WX_TYP2
    	wx_typ[2] = StringUtil.checkString(box.getString("wx_typ3"));				//WX_TYP3
    	wx_typ[3] = StringUtil.checkString(box.getString("wx_typ4"));				//WX_TYP4
    	wx_typ[4] = StringUtil.checkString(box.getString("wx_typ5"));				//WX_TYP5
    	
    	String wx_typ_tot = "";
		for(int i = 0 ; i <5 ; i++){
	    	if(!wx_typ[i].equals("")){
	    		if(wx_typ_tot.equals(""))	wx_typ_tot =  "'" + wx_typ[i] + "'";
	    		else wx_typ_tot = wx_typ_tot + ",'" + wx_typ[i] + "'";
	    	}
		}
    	
		String airport = StringUtil.checkString(box.getString("airport"));					//AIRPORT
		String validdate1 = StringUtil.checkString(box.getString("validdate1"));		//WX_DTG
		String validdate2 = StringUtil.checkString(box.getString("validdate2"));		//WX_DTG
		String timestep = StringUtil.checkString(box.getString("timestep"));			//TIMESTEP
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		try {
			SupA310BG params = new SupA310BG();
			
			params.setIcao_port(airport);
			params.setWx_typ(wx_typ_tot);
			params.setWx_dtg(validdate1+validdate2);
			params.setTimestep(timestep);

			//EJB LookUp
			SupAllSL sl = (SupAllSL)EJBFinder.lookup("ejb/SupAllSL");
			Hashtable hashData  = sl.selSupA310Main(params);
			if (hashData != null){
				req.setAttribute("successMessage",ComUtil.getInstance().getMessage("WEATHER LIST", hashData, "WEATHER", MessageCode.getInstance().DATA_MSG));
			}
			req.setAttribute("hashData",hashData);
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SupA310Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			} else {
				Logger.debug.println("[BASE:SupA310Serv:selectTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			}
		} 
	}//end selectTask
	
	/** 
	  * WEATHER LIST Servlet Class - deleteTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/06/24 
	  */	
	public void deleteTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 										    //Box ü 
		
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		String[] chkDel = req.getParameterValues("chkDel");
		String[] icao_arr = new String[chkDel.length];
		String[] typ_arr = new String[chkDel.length];
		String[] dtg_arr = new String[chkDel.length];
		
		for(int i=0 ; i<chkDel.length ; i++){
			icao_arr[i] = StringUtil.checkString(box.getString("icao_hid"+chkDel[i]));
			typ_arr[i] = StringUtil.checkString(box.getString("typ_hid"+chkDel[i]));
			dtg_arr[i] = StringUtil.checkString(box.getString("dtg_hid"+chkDel[i]));
		}
		
		try {
			
			SupA310BG params = new SupA310BG();
			params.setIcao_arr(icao_arr);
			params.setTyp_arr(typ_arr);
			params.setDtg_arr(dtg_arr);
			
			//EJB LookUp
			SupAllSL sl = (SupAllSL)EJBFinder.lookup("ejb/SupAllSL");
			int returnValue = sl.delSupA310Main(params);
			
			req.setAttribute("returnValue",String.valueOf(returnValue).toString());
			if (returnValue == 1){
				req.setAttribute("successMessage",ComUtil.getInstance().getMessage("WEATHER LIST", null, "", MessageCode.getInstance().DELETE_MSG));
			}else{
				req.setAttribute("errorMessage",MessageCode.getInstance().DELETE_MSG);
			}
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SupA310Serv:deleteTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"delete");
			} else {
				Logger.debug.println("[BASE:SupA310Serv:deleteTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"delete");
			}
		} 
	}//end deleteTask
	
	/** 
	  * WEATHER LIST Servlet Class - updateTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/06/27 
	  */	
	public void updateTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 										    //Box ü 
		
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		String radio_typ = StringUtil.checkString(box.getString("radio_typ"));
		String airportDetail = StringUtil.checkString(box.getString("airportDetail"));
		String time1 = StringUtil.checkString(box.getString("time1"));
		String time2 = StringUtil.checkString(box.getString("time2"));
		String detail = StringUtil.checkString(box.getString("detail"));
		
		if(!detail.equals("")){
			detail = detail.toUpperCase();
		}
		
		String typSeq = "";
		if(radio_typ.equals("SA") || radio_typ.equals("SP") || radio_typ.equals("SB"))   typSeq = "1";
		else if(radio_typ.equals("FC") || radio_typ.equals("FT"))	typSeq = "2";
		
		HttpSession session = req.getSession();
		
		try {
			
			SysA010BG UserInfo = (SysA010BG)session.getAttribute("USERINFO");
			String empNo = null;
			if (UserInfo != null) empNo = UserInfo.getEmp_no();
			
			SupA310BG params = new SupA310BG();
			params.setIcao_port(airportDetail);
			params.setTyp_seq(typSeq);
			params.setWx_typ(radio_typ);
			params.setWx_dtg(time1+time2);
			params.setWx_text(detail);
			params.setEmp_no(empNo);
			
			//EJB LookUp
			SupAllSL sl = (SupAllSL)EJBFinder.lookup("ejb/SupAllSL");
			int returnValue = sl.updSupA310Main(params);
			
			req.setAttribute("returnValue",String.valueOf(returnValue).toString());
			if (returnValue == 3){
				req.setAttribute("successMessage",ComUtil.getInstance().getMessage("WEATHER LIST", null, "", MessageCode.getInstance().INSERT_MSG));
			}else if (returnValue == 4){
				req.setAttribute("successMessage",ComUtil.getInstance().getMessage("WEATHER LIST", null, "", MessageCode.getInstance().UPDATE_MSG));
			}else if (returnValue != 2 && returnValue != 3  && returnValue != 4){
				req.setAttribute("errorMessage",MessageCode.getInstance().UPDATE_MSG);
			}
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SupA310Serv:updateTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"update");
			} else {
				Logger.debug.println("[BASE:SupA310Serv:updateTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"update");
			}
		} 
	}//end updateTask
}
