package kal.base.sup.serv;

import java.rmi.RemoteException;
import java.util.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import kal.base.com.util.*;
import kal.base.com.serv.*;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.Box;
import kal.base.jdf.serv.HttpUtility;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.sys.dbbean.SysA010BG;
import kal.base.sup.dbbean.SupA320BG;
import kal.base.sup.ejb.SupAllSL;

/**
 * Q-LIST WEATHER LIST Servlet Class
 * @version 	1.0
 * @author Copyright (c) 2005/06/28 
 */
public class SupA320Serv extends PublicBaseServlet {
	/** 
	  * Q-LIST WEATHER LIST Servlet Class - selectTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/06/28 
	  */	
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 										    //Box ü 
    	
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		try {
			SupA320BG params = new SupA320BG();

			//EJB LookUp
			SupAllSL sl = (SupAllSL)EJBFinder.lookup("ejb/SupAllSL");
			Hashtable hashData  = sl.selSupA320Main(params);
			if (hashData != null){
				req.setAttribute("successMessage",ComUtil.getInstance().getMessage("Q-LIST WEATHER LIST",  hashData, "QLIST", MessageCode.getInstance().DATA_MSG));
			}
			req.setAttribute("hashData",hashData);
			req.setAttribute("chkParam", "Y");
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SupA320Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			} else {
				Logger.debug.println("[BASE:SupA320Serv:selectTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			}
		} 
	}//end selectTask
	
	/** 
	  * Q-LIST WEATHER LIST Servlet Class - deleteTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/06/29 
	  */	
	public void deleteTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 										    //Box ü 
		
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		String[] chkDel = req.getParameterValues("chkDel");
		String[] seq_arr = new String[chkDel.length];
		String[] time_arr = new String[chkDel.length];
		
		for(int i=0 ; i<chkDel.length ; i++){
			seq_arr[i] = StringUtil.checkString(box.getString("seq_hid"+chkDel[i]));
			time_arr[i] = StringUtil.checkString(box.getString("time_hid"+chkDel[i]));
		}
		
		try {
			
			SupA320BG params = new SupA320BG();
			params.setSeq_arr(seq_arr);
			params.setTime_arr(time_arr);
			
			//EJB LookUp
			SupAllSL sl = (SupAllSL)EJBFinder.lookup("ejb/SupAllSL");
			int returnValue = sl.delSupA320Main(params);
			
			req.setAttribute("returnValue",String.valueOf(returnValue).toString());
			if (returnValue == 1){
				req.setAttribute("successMessage",ComUtil.getInstance().getMessage("Q-LIST WEATHER LIST", null, "", MessageCode.getInstance().DELETE_MSG));
			}else{
				req.setAttribute("errorMessage",MessageCode.getInstance().DELETE_MSG);
			}
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SupA310Serv:deleteTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"delete");
			} else {
				Logger.debug.println("[BASE:SupA310Serv:deleteTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"delete");
			}
		} 
	}//end deleteTask
	
	/** 
	  * Q-LIST WEATHER LIST Servlet Class - updateTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/06/30 
	  */	
	public void updateTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 										    //Box ü 
		
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		String timestmp = StringUtil.checkString(box.getString("timestmp"));
		String msg_seq = StringUtil.checkString(box.getString("msg_seq"));
		String msg_text = StringUtil.checkString(box.getString("msg_text"));
		
		String msg_typ = StringUtil.checkString(box.getString("msg_typ")); //2010.02.08 ߰
		
		System.out.println("msg_typ : "+msg_typ);
		
		if(!msg_text.equals("")){
			msg_text = msg_text.toUpperCase();
		}
		
		try {
			
			SupA320BG params = new SupA320BG();
			params.setTimestmp(timestmp);
			params.setMsg_seq(msg_seq);
			params.setMsg_text(msg_text);
			params.setMsg_typ(msg_typ); //2010.02.08 ߰
						
			//EJB LookUp
			SupAllSL sl = (SupAllSL)EJBFinder.lookup("ejb/SupAllSL");
			int returnValue = sl.updSupA320Main(params);
			
			if (returnValue == 2) {
				req.setAttribute("successMessage",ComUtil.getInstance().getMessage("Q-LIST WEATHER LIST", null, "", MessageCode.getInstance().UPDATE_MSG));
			} else if (returnValue != 2 && returnValue != 3) {
				req.setAttribute("errorMessage",MessageCode.getInstance().UPDATE_MSG);
			}
			
			req.setAttribute("returnValue",String.valueOf(returnValue).toString());
			req.setAttribute("msg_typ",msg_typ); //2010.02.08 ߰
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SupA310Serv:updateTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"update");
			} else {
				Logger.debug.println("[BASE:SupA310Serv:updateTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"update");
			}
		} 
	}//end updateTask
}
