package kal.base.sup.serv;

import java.rmi.RemoteException;
import java.util.*;
import java.io.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import kal.base.com.util.*;
import kal.base.com.serv.*;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.*;
import kal.base.jdf.serv.HttpUtility;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.sys.dbbean.SysA010BG;
import kal.base.sup.dbbean.SupA330BG;
import kal.base.sup.ejb.SupAllSL;

/**
 * SIG WEATHER LIST Servlet Class
 * @version 	1.0
 * @author Copyright (c) 2005/07/11 
 */
public class SupA335Serv extends PublicBaseServlet {
	/** 
	  * SIG WEATHER LIST Servlet Class - selectTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/07/12 
	  */	
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 										    //Box ü 
    	
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		String airport_detail = StringUtil.checkString(box.getString("airport_detail"));
		String type_detail = StringUtil.checkString(box.getString("type_detail"));
		String begin_dt1_detail = StringUtil.checkString(box.getString("begin_dt1_detail"));
		String begin_dt2_detail = StringUtil.checkString(box.getString("begin_dt2_detail"));
		
		try {
			SupA330BG params = new SupA330BG();
			
			params.setIcao_port(airport_detail);
			params.setType(type_detail);
			params.setBegin_dt(begin_dt1_detail + begin_dt2_detail);

			//EJB LookUp
			SupAllSL sl = (SupAllSL)EJBFinder.lookup("ejb/SupAllSL");
			Hashtable hashData  = sl.selectFile(params);
			
			req.setAttribute("hashData",hashData);
			req.setAttribute("chkParam", "Y");
					
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SupA335Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			} else {
				Logger.debug.println("[BASE:SupA335Serv:selectTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			}
		} 
	}//end selectTask
}
