package kal.base.sup.serv;

import java.rmi.RemoteException;
import java.util.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import kal.base.com.util.*;
import kal.base.com.serv.*;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.Box;
import kal.base.jdf.serv.HttpUtility;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.sup.dbbean.SupA360BG;
import kal.base.sup.ejb.SupAllSL;
import kal.base.sys.dbbean.SysA010BG;
import kal.base.not.dbbean.NotA110BG;
import kal.base.not.dbbean.NotQ010BG;
import kal.base.wea.ejb.WeaAllSL;
import kal.base.not.ejb.NotAllSL;

/**
 * Alert Apo Servlet Class
 * @version 	1.0
 * @author Copyright (c) 2011/11/04 
 */
public class SupA360Serv extends PublicBaseServlet {
	
	
	/** 
	  * Alert APO Info Servlet Class - selectTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2011/12/06 
	  */	
	public void performTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);
		String mode = StringUtil.checkString(box.getString("mode"));
		String returnPage = StringUtil.checkString(box.getString("returnPage"));
		
		HttpSession session = req.getSession();
		
		try{
			
			if(mode.equals("FFS")){
				SupA360BG params = new SupA360BG();
				params.setFlt_num(StringUtil.checkString(box.getString("flt_num")));
				params.setStnfr(StringUtil.checkString(box.getString("stnfr")));
				params.setStnto(StringUtil.checkString(box.getString("stnto")));
				
				SupAllSL sl = (SupAllSL)EJBFinder.lookup("ejb/SupAllSL");
				
				Hashtable hashData = sl.selSupA360Ffs(params);
				
				if(hashData != null){
					req.setAttribute("hashData", hashData);
					req.setAttribute("dataComplete","S");
					
					/*String wxKey = StringUtil.getKST("yyyyMMddHHmmss");
					session.setAttribute(wxKey,hashData);
					
					req.setAttribute("wxKey",wxKey);
					req.setAttribute("dataComplete", "V");*/
				}
			}else if(mode.equals("ALERT")){
				SupA360BG params = new SupA360BG();
				params.setTimestmp(StringUtil.checkString(box.getString("timestmp")));
				params.setIata_port(StringUtil.checkString(box.getString("iata_port")));
				
				SupAllSL sl = (SupAllSL)EJBFinder.lookup("ejb/SupAllSL");
				
				Hashtable hashData = sl.selSupA360AlertInfo(params);
				
				if(hashData != null){
					req.setAttribute("wx", "Y");
					req.setAttribute("hashData", hashData);
					req.setAttribute("dataComplete","S");
					
				}
			}
			
			printJspPage(req, res, returnPage);
		}catch(Exception e){
			if(e instanceof RemoteException){
				Logger.err.println("[BASE:SupA360Serv:performTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(), returnPage, "select");
			}else{
				Logger.err.println("[BASE:SupA360Serv:performTask] "+e.getMessage());
				printMessagePage2(req, res, e.getMessage(), returnPage, "select");
			}
		}
	}
	
	/** 
	  * Alert APO Display_y  Servlet Class - updateTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2011/12/06 
	  */	
	public void checkTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);
		
		String returnPage = StringUtil.checkString(box.getString("returnPage"));
		
		HttpSession session = req.getSession();
		
		try{
						
			String[] arr_timestmp = req.getParameterValues("h_timestmp");
			String[] arr_display_y = req.getParameterValues("h_display_y");
			
			SupA360BG params = new SupA360BG();
			params.setArr_timestmp(arr_timestmp);
			params.setArr_display_y(arr_display_y);
			
			SupAllSL sl = (SupAllSL)EJBFinder.lookup("ejb/SupAllSL");
			boolean updOk = sl.updSupA360Display_y(params);
			
			if (updOk == true){
				req.setAttribute("successMessage",ComUtil.getInstance().getMessage("Alert APO List", null, "", MessageCode.getInstance().UPDATE_MSG));
			}
			
			req.setAttribute("dataComplete","U");
			
			printJspPage(req, res, returnPage);
		}catch(Exception e){
			if(e instanceof RemoteException){
				Logger.err.println("[BASE:SupA360Serv:checkTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(), returnPage, "select");
			}else{
				Logger.err.println("[BASE:SupA360Serv:checkTask] "+e.getMessage());
				printMessagePage2(req, res, e.getMessage(), returnPage, "select");
			}
		}
	}
	/** 
	  * Alert APO List ȸ Servlet Class - selectTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2011/11/04 
	  */	
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 										    //Box ü 
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		String dtg_range = StringUtil.checkString(box.getString("dtg_range")); 
		
		String hid_rd_dtg = StringUtil.checkString(box.getString("hid_rd_dtg")); 
		String dtgFr = StringUtil.checkString(box.getString("dtgFr")) + StringUtil.checkString(box.getString("dtgFrTime")); 
		String dtgTo = StringUtil.checkString(box.getString("dtgTo")) + StringUtil.checkString(box.getString("dtgToTime")); 
		
		try {
			
			SupA360BG params = new SupA360BG();
			params.setDtg_range(dtg_range);
			
			params.setHid_rd_dtg(hid_rd_dtg); 
			params.setDtgFr(dtgFr); 
			params.setDtgTo(dtgTo);
			
			//EJB LookUp
			SupAllSL sl = (SupAllSL)EJBFinder.lookup("ejb/SupAllSL");
			Hashtable hashData  = sl.selSupA360Main(params);
			if (hashData != null) req.setAttribute("successMessage",ComUtil.getInstance().getMessage("Alert APO List", hashData, "ALERTAPO", MessageCode.getInstance().DATA_MSG));
			req.setAttribute("hashData",hashData);
			//req.setAttribute("dataComplete","S");
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.err.println("[BASE:SupA360Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			} else {
				Logger.err.println("[BASE:SupA360Serv:selectTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			}
		} 
	}//end selectTask
	
	/** 
	  * Alert APO Item  Servlet Class - updateTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2011/11/04 
	  */	
	public void updateTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);                                         //Box ü 
		
		//  ˱ request ĶͿ null   ʴ (׷ Ȳ ,Ʈũ ?)
		// jsp  Ķ͸ getString() ޾Ƶ null  ʴ´.
		// ׷ ʸ ..
		String iata_port = StringUtil.checkString(box.getString("iata_port"));
		String wx_typ = StringUtil.checkString(box.getString("wx_typ"));
		String dtg = StringUtil.checkString(box.getString("dtg"));
		String man_display = StringUtil.checkString(box.getString("man_display"));
		String man_iss_dt = StringUtil.checkString(box.getString("man_iss_dt"));
		String man_exp_dt = StringUtil.checkString(box.getString("man_exp_dt"));
		String man_prev_iss_dt = StringUtil.checkString(box.getString("man_prev_iss_dt"));
		String man_prev_exp_dt = StringUtil.checkString(box.getString("man_prev_exp_dt"));
		String commnt = StringUtil.checkString(box.getString("commnt"));
		String timestmp = StringUtil.checkString(box.getString("timestmp"));
		
		// Ʈ ˻ ´.
        String dtg_range = StringUtil.checkString(box.getString("dtg_range")); 		
		String hid_rd_dtg = StringUtil.checkString(box.getString("hid_rd_dtg")); 
		String dtgFr = StringUtil.checkString(box.getString("dtgFr"));
		String dtgFrTime = StringUtil.checkString(box.getString("dtgFrTime"));		
		String dtgTo = StringUtil.checkString(box.getString("dtgTo")); 
		String dtgToTime = StringUtil.checkString(box.getString("dtgToTime"));
		
		String mode = StringUtil.checkString(box.getString("mode"));
		
		String returnPage = StringUtil.checkString(box.getString("returnPage"));
		HttpSession session = req.getSession();
		
		try{
			//User Info
			SysA010BG UserInfo = (SysA010BG)session.getAttribute("USERINFO");
			
			//Parameter 
			SupA360BG params = new SupA360BG();
			
			System.out.println("###################encoding:"+req.getCharacterEncoding());
			params.setIata_port(iata_port);
			params.setWx_typ(wx_typ);
			params.setDtg(dtg);
			params.setMan_display(man_display);
			params.setMan_iss_dt(man_iss_dt);
			params.setMan_exp_dt(man_exp_dt);
			//params.setMan_prev_iss_dt(man_prev_iss_dt);
			//params.setMan_prev_exp_dt(man_prev_exp_dt);
			params.setCommnt(StringUtil.toKSC5601(commnt));
			params.setUserid(UserInfo.getEmp_no());
			params.setTimestmp(timestmp);
			
			params.setMode(mode);
			
			SupAllSL sl = (SupAllSL)EJBFinder.lookup("ejb/SupAllSL");
			int returnValue = sl.updSupA360Main(params);
			
			if (returnValue == 1){
				req.setAttribute("successMessage",ComUtil.getInstance().getMessage("Alert APO List", null, "", MessageCode.getInstance().INSERT_MSG));
			}else if (returnValue == 2){
				req.setAttribute("successMessage",ComUtil.getInstance().getMessage("Alert APO List", null, "", MessageCode.getInstance().UPDATE_MSG));
			}else if (returnValue != 1 && returnValue != 2  ){
				req.setAttribute("errorMessage",MessageCode.getInstance().ETC_EXPT);
			}
			
			req.setAttribute("hid_rd_dtg", hid_rd_dtg);
			req.setAttribute("dtg_range", dtg_range);
			req.setAttribute("dtgFr", dtgFr);
			req.setAttribute("dtgFrTime", dtgFrTime);
			req.setAttribute("dtgTo", dtgTo);
			req.setAttribute("dtgToTime", dtgToTime);
			req.setAttribute("dataComplete", "U");
			
			printJspPage(req, res, returnPage);
		}catch(Exception e){
			if(e instanceof RemoteException){
				Logger.err.println("[BASE:SupA360Serv:updateTask] "+e.getMessage());
				//printMessagePage2(req, res, e.getMessage(), returnPage, "update");
				printMessagePage2(req, res, "serv:RemoteException:"+e.getMessage(), returnPage, "update");
			}else{
				Logger.err.println("[BASE:SupA360Serv:updateTask] "+e.getMessage());
				//printMessagePage2(req, res, e.getMessage(), returnPage, "update");
				printMessagePage2(req, res, "serv:Exception:"+e.getMessage(), returnPage, "update");
			}
		}
	}//end updateTask	
	
	/** 
	  * Alert APO Item  Servlet Class - deleteTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2011/11/04 
	  */	
	public void deleteTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);
		
		String timestmp = StringUtil.checkString(box.getString("timestmp"));
		
		String returnPage = StringUtil.checkString(box.getString("returnPage"));
		
		try{
			SupA360BG params = new SupA360BG();
			params.setTimestmp(timestmp);
			
			SupAllSL sl = (SupAllSL)EJBFinder.lookup("ejb/SupAllSL");
			boolean delFlag = sl.delSupA360Main(params);
			
			if (delFlag == true){
				req.setAttribute("successMessage",ComUtil.getInstance().getMessage("Alert APO List", null, "", MessageCode.getInstance().DELETE_MSG));
			}
			
			req.setAttribute("dataComplete", "D");
			
			//  
			printJspPage(req, res, returnPage);
		}catch(Exception e){
			if(e instanceof RemoteException){
				Logger.err.println("[BASE:SupA360Serv:deleteTask] "+e.getMessage());
				printMessagePage2(req, res, e.getMessage(), returnPage, "delete");
			}else{
				Logger.err.println("[BASE:SupA360Serv:deleteTask] "+e.getMessage());
				printMessagePage2(req, res, e.getMessage(), returnPage, "delete");
			}
		}
	}//end d
	
	/** 
	  * Alert APO List Send Servlet Class - insertTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2011/11/04 
	  */	
	public void insertTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);
		
		//˻ Ķ
		String timestmp = StringUtil.checkString(box.get("timestmp"));
		
		// Ķ
		String email_txt = StringUtil.checkString(box.getString("email_txt"));
		String sita_txt = StringUtil.checkString(box.getString("sita_txt"));
		String sender_txt = StringUtil.checkString(box.getString("sender_txt"));
		String origin_txt = StringUtil.checkString(box.getString("origin_txt"));
		String email_title = StringUtil.checkString(StringUtil.toKSC5601(box.getString("email_title")));
		
		String returnPage = StringUtil.checkString(box.getString("returnPage"));
		
		try{
			//Parameter 
			SupA360BG params = new SupA360BG();
			
			params.setTimestmp(timestmp);
			params.setEmail_title(email_title);
			params.setEmail_txt(email_txt);
			params.setSita_txt(sita_txt);
			params.setSender_txt(sender_txt);
			params.setOrigin_txt(origin_txt);
			SupAllSL sl = (SupAllSL)EJBFinder.lookup("ejb/SupAllSL");
			SupA360BG sendParam = sl.selSupA360Detail(params);
			
			if(sendParam!=null){
				sendParam.setEmail_title(email_title);
				sendParam.setEmail_txt(email_txt);
				sendParam.setSita_txt(sita_txt);
				sendParam.setSender_txt(sender_txt);
				sendParam.setOrigin_txt(origin_txt);
				
				//20151021 UMS  ߰ 
				sendParam.setTimestmp(timestmp);
				
				boolean sendFlag = sl.sendAlertAPO(sendParam);
				
				if(sendFlag) req.setAttribute("dataComplete","S");
				else{
					throw new Exception("۽");
				}
			}else{
				throw new Exception("Ƹ ejb ȣ   null     ̴.");
			}
			
			//  
			printJspPage(req, res, returnPage);
		}catch(Exception e){
			if(e instanceof RemoteException){
				Logger.err.println("[BASE:SubA360Serv:insertTask] "+((RemoteException)e).getMessage());
				//printMessagePage2(req, res, e.getMessage(), returnPage, "insert");
				printMessagePage2(req, res, "[RemoteException] Please Contact To Admin", returnPage, "insert");
			}else{
				Logger.err.println("[BASE:SubA360Serv:insertTask] "+e.getMessage());
				printMessagePage2(req, res, e.getMessage(), returnPage, "insert");
			}
		}
	}//end d
}
