package kal.base.sup.serv;

import java.rmi.RemoteException;
import java.util.*;
import javax.servlet.http.*;

import kal.base.com.util.*;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.*;
import kal.base.com.serv.*;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.sup.dbbean.*;
import kal.base.sup.ejb.SupAllSL;

/**
 * Alternate Airport Information ȸ / Է /  Servlet Class
 * @version 	1.0
 * @author Copyright (c) 2009/12/14 
 */
public class SupA670Serv extends PublicBaseServlet{
	/** 
	  * Alternate Airport Information ȸ Servlet Class - selectTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2009/12/14 
	  */		
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 													//Box ü 
		
		String iata_port = StringUtil.checkString(box.getString("iata_port"));
		
		String returnPage = StringUtil.checkString(box.getString("returnPage"));
		
		try {			
			//Parameter Return
			req.setAttribute("iata_port",iata_port);
			
			//Parameter 
			SupA670BG params = new SupA670BG();
			params.setIata_port(iata_port);
			
			//EJB LookUp
			SupAllSL sl = (SupAllSL)EJBFinder.lookup("ejb/SupAllSL");
			Hashtable hashData = sl.selSupA670Main(params);
			if (hashData != null) {
				SupA670BG entity = (SupA670BG)hashData.get("ALTN_INFO");
				if (entity != null) req.setAttribute("successMessage",ComUtil.getInstance().getMessage("Alternate Airport Information", null, "", MessageCode.getInstance().SELECT_MSG));
				else req.setAttribute("successMessage",ComUtil.getInstance().getMessage("Alternate Airport Information", null, "", MessageCode.getInstance().NULLDATA_MSG));
			}
			
			req.setAttribute("hashData",hashData);
			req.setAttribute("mode","select");
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SupA670Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			} else {
				Logger.debug.println("[BASE:SupA670Serv:selectTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			}
		} 
	}//end of function
	
	/** 
	  * Alternate Airport Information Է Servlet Class - updateTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2009/12/14 
	  */		
	public void updateTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 													//Box ü 
		
		String iata_port = StringUtil.checkString(box.getString("iata_port"));
		String altn_stn = StringUtil.checkString(box.getString("altn_stn"));
		String userid = StringUtil.checkString(box.getString("userid"));
		
		String returnPage = StringUtil.checkString(box.getString("returnPage"));
		
		try {
			//Parameter 
			SupA670BG params = new SupA670BG();
			params.setIata_port(iata_port);
			params.setAltn_stn(altn_stn);
			params.setUserid(userid);
			
			//EJB LookUp
			SupAllSL sl = (SupAllSL)EJBFinder.lookup("ejb/SupAllSL");
			boolean updFlg = sl.updSupA670Main(params);
			
			req.setAttribute("successMessage",ComUtil.getInstance().getMessage("Alternate Airport Information", null, "", MessageCode.getInstance().INSERT_MSG));
			req.setAttribute("mode","update");
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SupA670Serv:updateTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"update");
			} else {
				Logger.debug.println("[BASE:SupA670Serv:updateTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"update");
			}
		} 
	}//end of function
	
	/** 
	  * Alternate Airport Information  Servlet Class - deleteTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2009/12/14 
	  */		
	public void deleteTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 													//Box ü 
		
		String iata_port = StringUtil.checkString(box.getString("iata_port"));
		
		String returnPage = StringUtil.checkString(box.getString("returnPage"));
		
		try {
			//Parameter 
			SupA670BG params = new SupA670BG();
			params.setIata_port(iata_port);
			
			//EJB LookUp
			SupAllSL sl = (SupAllSL)EJBFinder.lookup("ejb/SupAllSL");
			boolean updFlg = sl.delSupA670Main(params);
			
			req.setAttribute("successMessage",ComUtil.getInstance().getMessage("Alternate Airport Information", null, "", MessageCode.getInstance().DELETE_MSG));
			req.setAttribute("mode","delete");
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SupA670Serv:deleteTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"delete");
			} else {
				Logger.debug.println("[BASE:SupA670Serv:deleteTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"delete");
			}
		} 
	}//end of function
	
}//end of class
