package kal.base.sup.serv;

import java.rmi.RemoteException;
import java.util.*;
import javax.servlet.http.*;

import kal.base.com.util.*;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.*;
import kal.base.com.serv.*;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.sup.dbbean.*;
import kal.base.sup.ejb.SupAllSL;
import kal.base.sys.dbbean.*;

/**
 * Company Route Information ȸ / Է /  Servlet Class
 * @version 	1.0
 * @author Copyright (c) 2009/12/15 
 */
public class SupA680Serv extends PublicBaseServlet{

	/** 
	  * Company Route Information ȸ Main Servlet Class - selectTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2009/12/15 
	  */		
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 														//Box ü 
		
		String dep_stn = StringUtil.checkString(box.getString("dep_stn")).toUpperCase();		//DEP Station
		String arr_stn = StringUtil.checkString(box.getString("arr_stn")).toUpperCase();			//ARR Station
		String rte_cd = StringUtil.checkString(box.getString("rte_cd")).toUpperCase();				//RTE Code
		String hid_rte_cd = StringUtil.checkString(box.getString("hid_rte_cd")).toUpperCase();	//Selected RTE Code
		
		String returnPage = StringUtil.checkString(box.getString("returnPage"));				//Return Page ȹ
		
		try {
 			//rte_cd ĭ ƴ 쿡 rte_cd ,
 			//rte_cd ĭ 쿡 sel_rte_cd ,
 			String s_rte_cd = "";
			
			if (rte_cd.equals("")) s_rte_cd = hid_rte_cd;
			else s_rte_cd = rte_cd;
			
			//Parameter 
			SupA680BG params = new SupA680BG();
			params.setDep_stn(dep_stn);
			params.setArr_stn(arr_stn);
			params.setRte_cd(s_rte_cd);
			
			//EJB LookUp
			SupAllSL sl = (SupAllSL)EJBFinder.lookup("ejb/SupAllSL");
			Hashtable hashData = sl.selSupA680Main(params);
			if (hashData != null) {
				SupA680BG entity = (SupA680BG)hashData.get("COMP_INFO");
				if (entity != null) req.setAttribute("successMessage",ComUtil.getInstance().getMessage("Company Route Information", null, "", MessageCode.getInstance().SELECT_MSG));
				else req.setAttribute("successMessage",ComUtil.getInstance().getMessage("Company Route Information", null, "", MessageCode.getInstance().NULLDATA_MSG));
			}
			req.setAttribute("hashData",hashData);
			req.setAttribute("mode","select");
			
			//Parameter Return
			req.setAttribute("dep_stn",dep_stn);
			req.setAttribute("arr_stn",arr_stn);
			req.setAttribute("rte_cd",s_rte_cd);
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SupA680Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			} else {
				Logger.debug.println("[BASE:SupA680Serv:selectTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			}
		} 
	}//end of function
	
	/** 
	  * Company Route Information Է Servlet Class - updateTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2009/12/15 
	  */		
	public void updateTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 																		//Box ü 
		
		String dep_stn = StringUtil.checkString(box.getString("dep_stn")).toUpperCase();					//DEP Station
		String arr_stn = StringUtil.checkString(box.getString("arr_stn")).toUpperCase();						//ARR Station
		String rte_cd = StringUtil.checkString(box.getString("rte_cd")).toUpperCase();							//RTE Code
		String hid_rte_cd = StringUtil.checkString(box.getString("hid_rte_cd")).toUpperCase();				//Selected RTE Code
		
		String userid = StringUtil.checkString(box.getString("userid"));
		
		String etops_stn = StringUtil.checkString(box.getString("etops_stn")).toUpperCase();
		String enrte_stn = StringUtil.checkString(box.getString("enrte_stn")).toUpperCase();
		String refile_stn = StringUtil.checkString(box.getString("refile_stn")).toUpperCase();
		String others_stn = StringUtil.checkString(box.getString("others_stn")).toUpperCase();
		String rte_fir = StringUtil.checkString(box.getString("rte_fir")).toUpperCase();
		
		String returnPage = StringUtil.checkString(box.getString("returnPage"));								//Return Page ȹ
		
		try {
 			//rte_cd ĭ ƴ 쿡 rte_cd ,
 			//rte_cd ĭ 쿡 sel_rte_cd ,
 			String s_rte_cd = "";
			
			if (rte_cd.equals("")) s_rte_cd = hid_rte_cd;
			else s_rte_cd = rte_cd;
			
			//Parameter 
			SupA680BG params = new SupA680BG();
			params.setDep_stn(dep_stn);
			params.setArr_stn(arr_stn);
			params.setRte_cd(s_rte_cd);
			params.setEtops_stn(etops_stn);
			params.setEnrte_stn(enrte_stn);
			params.setRefile_stn(refile_stn);
			params.setOthers_stn(others_stn);
			params.setRte_fir(rte_fir);			
			params.setUserid(userid);
			
			//EJB LookUp
			SupAllSL sl = (SupAllSL)EJBFinder.lookup("ejb/SupAllSL");
			boolean updFlg = sl.updSupA680Main(params);
			
			req.setAttribute("successMessage",ComUtil.getInstance().getMessage("Company Route Information", null, "", MessageCode.getInstance().INSERT_MSG));
			req.setAttribute("mode","update");
			
			//Parameter Return
			req.setAttribute("dep_stn",dep_stn);
			req.setAttribute("arr_stn",arr_stn);
			req.setAttribute("rte_cd",s_rte_cd);
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SupA680Serv:updateTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"update");
			} else {
				Logger.debug.println("[BASE:SupA680Serv:updateTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"update");
			}
		} 
	}//end of function	
	
	/** 
	  * Company Route Information  Servlet Class - deleteTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2009/12/15 
	  */		
	public void deleteTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 													//Box ü 
		
		String dep_stn = StringUtil.checkString(box.getString("dep_stn")).toUpperCase();					//DEP Station
		String arr_stn = StringUtil.checkString(box.getString("arr_stn")).toUpperCase();						//ARR Station
		String rte_cd = StringUtil.checkString(box.getString("rte_cd")).toUpperCase();							//RTE Code
		String hid_rte_cd = StringUtil.checkString(box.getString("hid_rte_cd")).toUpperCase();				//Selected RTE Code
		
		String returnPage = StringUtil.checkString(box.getString("returnPage"));						//Return Page ȹ
		
		try {
 			//rte_cd ĭ ƴ 쿡 rte_cd ,
 			//rte_cd ĭ 쿡 sel_rte_cd ,
 			String s_rte_cd = "";
			
			if (rte_cd.equals("")) s_rte_cd = hid_rte_cd;
			else s_rte_cd = rte_cd;
			
			//Parameter 
			SupA680BG params = new SupA680BG();
			params.setDep_stn(dep_stn);
			params.setArr_stn(arr_stn);
			params.setRte_cd(s_rte_cd);
			
			//EJB LookUp
			SupAllSL sl = (SupAllSL)EJBFinder.lookup("ejb/SupAllSL");
			boolean delFlg = sl.delSupA680Main(params);
			
			req.setAttribute("successMessage",ComUtil.getInstance().getMessage("Company Route Information", null, "", MessageCode.getInstance().DELETE_MSG));
			req.setAttribute("mode","delete");
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SupA680Serv:deleteTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"delete");
			} else {
				Logger.debug.println("[BASE:SupA680Serv:deleteTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"delete");
			}
		} 
	}//end of function	
		
	/** 
	  * Route Id ȸ Servlet Class - checkTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2009/12/15 
	  */		
	public void checkTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 															//Box ü 
		
		String returnPage = StringUtil.checkString(box.getString("returnPage"));					//Return Page ȹ
		
		String dep_stn = StringUtil.checkString(box.getString("dep_hid")).toUpperCase();		//DEP Station
		String arr_stn = StringUtil.checkString(box.getString("arr_hid")).toUpperCase();			//ARR Station
		String rte_cd = StringUtil.checkString(box.getString("rte_cd"));
		
		try {
			//Parameter 
			SupA680BG params = new SupA680BG();
			params.setDep_stn(dep_stn);
			params.setArr_stn(arr_stn);
			
			//EJB LookUp
			SupAllSL sl = (SupAllSL)EJBFinder.lookup("ejb/SupAllSL");
			Hashtable hashData = sl.selSupA680RteCd(params);
			
			req.setAttribute("hashData",hashData);
			req.setAttribute("rte_cd", rte_cd);
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SupA680Serv:checkTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"check");
			} else {
				Logger.debug.println("[BASE:SupA680Serv:checkTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"check");
			}
		} 
	}//end of function
	
}//end of class
