package kal.base.sup.serv;

import java.rmi.RemoteException;
import java.util.*;
import javax.servlet.http.*;

import kal.base.com.util.*;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.*;
import kal.base.com.serv.*;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.sup.dbbean.*;
import kal.base.sup.ejb.SupAllSL;
import kal.base.sys.dbbean.*;

/**
 * BASE2 ABBR Information ȸ / Է /  Servlet Class
 * @version 	1.0
 * @author Copyright (c) 2005/05/30 HIST  
 */
public class SupA710Serv extends PublicBaseServlet{
	/** 
	  * BASE2 ABBR Information ȸ Main Servlet Class - selectTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/05/30 HIST  
	  */		
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 												//Box ü 
		String abbrCd = StringUtil.checkString(box.getString("abbr_cd")).toUpperCase();			//ABBR Code
		String orgnCd = StringUtil.checkString(box.getString("orgn_cd")).toUpperCase();			//ORGN Code
		String siGn = StringUtil.checkString(box.getString("sign"));												//Signfication
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		try {
			//Parameter Return
			SupA710BG params = new SupA710BG();
			params.setAbbr_cd(abbrCd);
			params.setOrgn_cd(orgnCd);
			params.setSign(siGn);
		
			//EJB LookUp
			SupAllSL sl = (SupAllSL)EJBFinder.lookup("ejb/SupAllSL");
			Hashtable hashData = sl.selSupA710Main(params);
			if (hashData != null) req.setAttribute("successMessage",ComUtil.getInstance().getMessage("ABBR Information", hashData, "HASHDATA", MessageCode.getInstance().DATA_MSG));
			req.setAttribute("hashData",hashData);
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SupA710Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			} else {
				Logger.debug.println("[BASE:SupA710Serv:selectTask] "+StringUtil.toKSC5601(((Exception)e).getMessage()));
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			}
		} 
	}//end of function
	
	/** 
	  * BASE2 ABBR Information Է/ Main Servlet Class - updateTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/05/30 HIST  
	  */		
	public void updateTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 												//Box ü 
		String abbrCd = StringUtil.checkString(box.getString("abbr_cd")).toUpperCase();			//ABBR Code
		String orgnCd = StringUtil.checkString(box.getString("orgn_cd"));			//ORGN Code
		String sign = StringUtil.checkString(box.getString("sign"));						//SIGN
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		HttpSession session = req.getSession();
		
		try {
			//User Info
			SysA010BG UserInfo = (SysA010BG)session.getAttribute("USERINFO");
			
			//Parameter 
			SupA710BG params = new SupA710BG();
			params.setAbbr_cd(abbrCd);
			params.setOrgn_cd(orgnCd);
			params.setSign(sign);
			params.setUserid(UserInfo.getEmp_no());
		
			//EJB LookUp
			SupAllSL sl = (SupAllSL)EJBFinder.lookup("ejb/SupAllSL");
			boolean updFlag = sl.updSupA710Main(params);

			//ABBR Information ȸ
			if (updFlag) {
				Hashtable hashData = sl.selSupA710Main(params);
				if (hashData != null) req.setAttribute("successMessage",ComUtil.getInstance().getMessage("ABBR Information", hashData, "HASHDATA", MessageCode.getInstance().DATA_MSG));
				req.setAttribute("hashData",hashData);
			}
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SupA710Serv:updateTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"update");
			} else {
				Logger.debug.println("[BASE:SupA710Serv:updateTask] "+StringUtil.toKSC5601(((Exception)e).getMessage()));
				printMessagePage2(req, res, e.getMessage(),returnPage,"update");
			}
		} 
	}//end of function	
	
	/** 
	  * BASE2 ABBR Information  Main Servlet Class - deleteTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/05/30 HIST  
	  */		
	public void deleteTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 												//Box ü 
		String abbrCd = StringUtil.checkString(box.getString("abbr_cd")).toUpperCase();			//ABBR Code
		String orgnCd = StringUtil.checkString(box.getString("orgn_cd"));			//ORGN Code
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		HttpSession session = req.getSession();
		
		try {
			//User Info
			SysA010BG UserInfo = (SysA010BG)session.getAttribute("USERINFO");
			
			//Parameter 
			SupA710BG params = new SupA710BG();
			params.setAbbr_cd(abbrCd);
			params.setOrgn_cd(orgnCd);
			params.setUserid(UserInfo.getEmp_no());
		
			//EJB LookUp
			SupAllSL sl = (SupAllSL)EJBFinder.lookup("ejb/SupAllSL");
			boolean delFlag = sl.delSupA710Main(params);
			
			//ABBR Information ȸ
			if (delFlag) {
				Hashtable hashData = sl.selSupA710Main(params);
				if (hashData != null) req.setAttribute("successMessage",ComUtil.getInstance().getMessage("ABBR Information", hashData, "HASHDATA", MessageCode.getInstance().DATA_MSG));
				req.setAttribute("hashData",hashData);
			}
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SupA710Serv:deleteTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"delete");
			} else {
				Logger.debug.println("[BASE:SupA710Serv:deleteTask] "+StringUtil.toKSC5601(((Exception)e).getMessage()));
				printMessagePage2(req, res, e.getMessage(),returnPage,"delete");
			}
		} 
	}//end of function		
	
}//end of class
