package kal.base.sup.serv;

import java.rmi.RemoteException;
import java.util.*;
import javax.servlet.http.*;

import kal.base.com.util.*;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.*;
import kal.base.com.serv.*;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.sup.dbbean.*;
import kal.base.sup.ejb.SupAllSL;
import kal.base.sys.dbbean.*;

/**
 * BASE2 Q-Code Information ȸ / Է /  Servlet Class
 * @version 	1.0
 * @author Copyright (c) 2005/05/30 HIST 
 */
public class SupA720Serv extends PublicBaseServlet{
	/**
	  * BASE2 Q-Code Information ȸ Main Servlet Class - selectTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/05/30 HIST 
	  */
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 												//Box ü 
		String q23NotQcd = StringUtil.checkString(box.getString("q23_not_qcd")).toUpperCase();			//Q23-Code
		String q23NotCls = StringUtil.checkString(box.getString("q23_not_cls")).toUpperCase();				//Q23-Class
		String q23NotAbbr = StringUtil.checkString(box.getString("q23_not_abbr"));									//Q23-ABBR
		String q23NotSign = StringUtil.checkString(box.getString("q23_not_sign"));									//Q23-Signification
		String q45NotQcd = StringUtil.checkString(box.getString("q45_not_qcd")).toUpperCase();			//q45-Code
		String q45NotCls = StringUtil.checkString(box.getString("q45_not_cls")).toUpperCase();				//q45-Class
		String q45NotAbbr = StringUtil.checkString(box.getString("q45_not_abbr"));									//q45-ABBR
		String q45NotSign = StringUtil.checkString(box.getString("q45_not_sign"));									//q45-Signification
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ

		try {
			SupA720BG params = new SupA720BG();
			params.setQ23_not_qcd(q23NotQcd);
			params.setQ23_not_cls(q23NotCls);
			params.setQ23_not_abbr(q23NotAbbr);
			params.setQ23_not_sign(q23NotSign);
			params.setQ45_not_qcd(q45NotQcd);
			params.setQ45_not_cls(q45NotCls);
			params.setQ45_not_abbr(q45NotAbbr);
			params.setQ45_not_sign(q45NotSign);
			
			//EJB LookUp
			SupAllSL sl = (SupAllSL)EJBFinder.lookup("ejb/SupAllSL");
			Hashtable hashData = sl.selSupA720Main(params);
			if (hashData != null) req.setAttribute("successMessage",ComUtil.getInstance().getMessage("Q-Code Information", null, "", MessageCode.getInstance().SELECT_MSG));
			req.setAttribute("hashData",hashData);

			//  
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SupA720Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			} else {
				Logger.debug.println("[BASE:SupA720Serv:selectTask] "+StringUtil.toKSC5601(((Exception)e).getMessage()));
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			}
		}
	}//end of function

	/**
	  * BASE2 Q-Code Information Է/ Main Servlet Class - updateTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/05/30 HIST 
	  */
	public void updateTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 																					//Box ü 
		String q23Mode = StringUtil.checkString(box.getString("q23_mode"));											//Q23-Mode
		String q23NotQcd = StringUtil.checkString(box.getString("q23_not_qcd")).toUpperCase();			//Q23-Code
		String q23NotCls = StringUtil.checkString(box.getString("q23_not_cls")).toUpperCase();				//Q23-Class
		String q23NotAbbr = StringUtil.checkString(box.getString("q23_not_abbr"));									//Q23-ABBR
		String q23NotSign = StringUtil.checkString(box.getString("q23_not_sign"));									//Q23-Signification
		String q45Mode = StringUtil.checkString(box.getString("q45_mode"));											//Q45-Mode
		String q45NotQcd = StringUtil.checkString(box.getString("q45_not_qcd")).toUpperCase();			//q45-Code
		String q45NotCls = StringUtil.checkString(box.getString("q45_not_cls")).toUpperCase();				//q45-Class
		String q45NotAbbr = StringUtil.checkString(box.getString("q45_not_abbr"));									//q45-ABBR
		String q45NotSign = StringUtil.checkString(box.getString("q45_not_sign"));									//q45-Signification
		String returnPage = StringUtil.checkString(box.getString("returnPage"));										//Return Page ȹ
		HttpSession session = req.getSession();

		try {
			//User Info
			SysA010BG UserInfo = (SysA010BG)session.getAttribute("USERINFO");

			//Parameter 
			SupA720BG params = new SupA720BG();
			params.setQ23_mode(q23Mode);
			params.setQ23_not_qcd(q23NotQcd);
			params.setQ23_not_cls(q23NotCls);
			params.setQ23_not_abbr(q23NotAbbr);
			params.setQ23_not_sign(q23NotSign);
			params.setQ45_mode(q45Mode);
			params.setQ45_not_qcd(q45NotQcd);
			params.setQ45_not_cls(q45NotCls);
			params.setQ45_not_abbr(q45NotAbbr);
			params.setQ45_not_sign(q45NotSign);
			params.setUserid(UserInfo.getEmp_no());

			//EJB LookUp
			SupAllSL sl = (SupAllSL)EJBFinder.lookup("ejb/SupAllSL");
			boolean updFlag = sl.updSupA720Main(params);
			if (updFlag) {
				req.setAttribute("dataComplete","U");
				req.setAttribute("successMessage"," ϷǾϴ.");
			}

			//  
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SupA720Serv:updateTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"update");
			} else {
				Logger.debug.println("[BASE:SupA720Serv:updateTask] "+StringUtil.toKSC5601(((Exception)e).getMessage()));
				printMessagePage2(req, res, e.getMessage(),returnPage,"update");
			}
		}
	}//end of function

	/**
	  * BASE2 Q-Code Information  Main Servlet Class - deleteTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/05/30 HIST 
	  */
	public void deleteTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 																					//Box ü 
		String q23Mode = StringUtil.checkString(box.getString("q23_mode"));											//Q23-Mode
		String q23NotQcd = StringUtil.checkString(box.getString("q23_not_qcd")).toUpperCase();			//Q23-Code
		String q23NotCls = StringUtil.checkString(box.getString("q23_not_cls")).toUpperCase();				//Q23-Class
		String q45Mode = StringUtil.checkString(box.getString("q45_mode"));											//Q45-Mode
		String q45NotQcd = StringUtil.checkString(box.getString("q45_not_qcd")).toUpperCase();			//q45-Code
		String q45NotCls = StringUtil.checkString(box.getString("q45_not_cls")).toUpperCase();				//q45-Class
		String returnPage = StringUtil.checkString(box.getString("returnPage"));										//Return Page ȹ
		HttpSession session = req.getSession();

		try {
			//User Info
			SysA010BG UserInfo = (SysA010BG)session.getAttribute("USERINFO");

			//Parameter 
			SupA720BG params = new SupA720BG();
			params.setQ23_mode(q23Mode);
			params.setQ23_not_qcd(q23NotQcd);
			params.setQ23_not_cls(q23NotCls);
			params.setQ45_mode(q45Mode);
			params.setQ45_not_qcd(q45NotQcd);
			params.setQ45_not_cls(q45NotCls);
			params.setUserid(UserInfo.getEmp_no());

			//EJB LookUp
			SupAllSL sl = (SupAllSL)EJBFinder.lookup("ejb/SupAllSL");
			boolean delFlag = sl.delSupA720Main(params);
			if (delFlag) {
				req.setAttribute("dataComplete","D");
				req.setAttribute("successMessage"," ϷǾϴ.");
			}

			//  
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SupA720Serv:deleteTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"delete");
			} else {
				Logger.debug.println("[BASE:SupA720Serv:deleteTask] "+StringUtil.toKSC5601(((Exception)e).getMessage()));
				printMessagePage2(req, res, e.getMessage(),returnPage,"delete");
			}
		}
	}//end of function

}//end of class