package kal.base.sup.serv;

import java.net.URLDecoder;
import java.rmi.RemoteException;
import java.util.Hashtable;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import kal.base.com.serv.ComUtil;
import kal.base.com.util.MessageCode;
import kal.base.com.util.StringUtil;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.Box;
import kal.base.jdf.serv.HttpUtility;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.sup.dbbean.SupA810BG;
import kal.base.sup.ejb.SupAllSL;
import kal.base.sys.dbbean.SysA010BG;

/**
 * 20140918
 * sunpark
 * FFS Manager SI Info Management
 */
public class SupA820Serv extends PublicBaseServlet{
	
	/** 
	  *   ׸ ȸ
	  */		
	public void checkTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);
		String stnfr = StringUtil.checkString(box.getString("stnfr")).toUpperCase();
		String stnto = StringUtil.checkString(box.getString("stnto")).toUpperCase();
		String returnPage = StringUtil.checkString(box.getString("returnPage"));
		
		try {
			//Parameter Return
			SupA810BG params = new SupA810BG();
			params.setStnfr(stnfr);
			params.setStnto(stnto);
			params.setFlag("check");
		
			//EJB LookUp
			SupAllSL sl = (SupAllSL)EJBFinder.lookup("ejb/SupAllSL");
			Hashtable hashData = sl.selSupA820Main(params);
			if (hashData != null) req.setAttribute("successMessage",ComUtil.getInstance().getMessage("SI Info Management", hashData, "HASHDATA", MessageCode.getInstance().DATA_MSG));
			req.setAttribute("hashData",hashData);
			
			req.setAttribute("stnfr", stnfr);
			req.setAttribute("stnto", stnto);
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SupA820Serv:checkTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"check");
			} else {
				Logger.debug.println("[BASE:SupA820Serv:checkTask] "+StringUtil.toKSC5601(((Exception)e).getMessage()));
				printMessagePage2(req, res, e.getMessage(),returnPage,"check");
			}
		} 
	}//end of function
	
	/** 
	  *   BS_SIINFO_T ׸ ȸ
	  */		
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);
		String selectedStnfr = StringUtil.checkString(box.getString("selectedStnfr")).toUpperCase();
		String selectedStnto = StringUtil.checkString(box.getString("selectedStnto")).toUpperCase();
		String returnPage = StringUtil.checkString(box.getString("returnPage"));
		
		try {
			//Parameter Return
			SupA810BG params = new SupA810BG();
			params.setSelectedStnfr(selectedStnfr);
			params.setSelectedStnto(selectedStnto);
			params.setFlag("select");
		
			//EJB LookUp
			SupAllSL sl = (SupAllSL)EJBFinder.lookup("ejb/SupAllSL");
			Hashtable hashData = sl.selSupA820Main(params);
			if (hashData != null) req.setAttribute("successMessage",ComUtil.getInstance().getMessage("SI Info Management", hashData, "HASHDATA", MessageCode.getInstance().DATA_MSG));
			req.setAttribute("hashData",hashData);
			
			req.setAttribute("selectedStnfr", selectedStnfr);
			req.setAttribute("selectedStnto", selectedStnto);
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SupA820Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			} else {
				Logger.debug.println("[BASE:SupA820Serv:selectTask] "+StringUtil.toKSC5601(((Exception)e).getMessage()));
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			}
		} 
	}//end of function
	
	/** 
	  * BS_SIINFO_T ׸ update, insert
	  */		
	public void updateTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);
		String selectedStnfr = StringUtil.checkString(box.getString("selectedStnfr")).toUpperCase();
		String selectedStnto = StringUtil.checkString(box.getString("selectedStnto")).toUpperCase();
		//String siinfo = StringUtil.checkString(box.getString("siinfo"));
		String siinfo = StringUtil.checkString(box.getString("siinfoEncode"));
		String tel = StringUtil.checkString(box.getString("tel"));
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		HttpSession session = req.getSession();
		
		try {
			//User Info
			SysA010BG UserInfo = (SysA010BG)session.getAttribute("USERINFO");
			
			//Parameter 
			SupA810BG params = new SupA810BG();
			params.setSelectedStnfr(selectedStnfr);
			params.setSelectedStnto(selectedStnto);
			
			siinfo = URLDecoder.decode(siinfo, "UTF-8");
			siinfo = siinfo.replaceAll("'", "''");
			params.setSiinfo(siinfo);
			
			params.setTel(tel);
			params.setUserId(UserInfo.getEmp_no());
		
			//EJB LookUp
			SupAllSL sl = (SupAllSL)EJBFinder.lookup("ejb/SupAllSL");
			boolean updFlag = sl.updSupA820Main(params);

			if (updFlag) {
				params.setFlag("select");
				Hashtable hashData = sl.selSupA820Main(params);
				if (hashData != null) req.setAttribute("successMessage",ComUtil.getInstance().getMessage("SI Info Management", hashData, "HASHDATA", MessageCode.getInstance().DATA_MSG));
				req.setAttribute("hashData",hashData);
			}
			
			req.setAttribute("selectedStnfr", selectedStnfr);
			req.setAttribute("selectedStnto", selectedStnto);
			
			req.setAttribute("reqResult", "U");
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SupA820Serv:updateTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"update");
			} else {
				Logger.debug.println("[BASE:SupA820Serv:updateTask] "+StringUtil.toKSC5601(((Exception)e).getMessage()));
				printMessagePage2(req, res, e.getMessage(),returnPage,"update");
			}
		} 
	}//end of function	
	
	/** 
	  * BS_SIINFO_T ׸ delete
	  */	
	public void deleteTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 												//Box ü 
		String selectedStnfr = StringUtil.checkString(box.getString("selectedStnfr")).toUpperCase();
		String selectedStnto = StringUtil.checkString(box.getString("selectedStnto")).toUpperCase();
		String returnPage = StringUtil.checkString(box.getString("returnPage"));
		HttpSession session = req.getSession();
		
		try {
			//User Info
			SysA010BG UserInfo = (SysA010BG)session.getAttribute("USERINFO");
			
			//Parameter 
			SupA810BG params = new SupA810BG();
			params.setSelectedStnfr(selectedStnfr);
			params.setSelectedStnto(selectedStnto);
			params.setUserId(UserInfo.getEmp_no());
		
			//EJB LookUp
			SupAllSL sl = (SupAllSL)EJBFinder.lookup("ejb/SupAllSL");
			boolean delFlag = sl.delSupA820Main(params);
			
			//ABBR Information ȸ
			if (delFlag) {
				params.setFlag("select");
				Hashtable hashData = sl.selSupA820Main(params);
				if (hashData != null) req.setAttribute("successMessage",ComUtil.getInstance().getMessage("SI Info Management", hashData, "HASHDATA", MessageCode.getInstance().DATA_MSG));
				req.setAttribute("hashData",hashData);
			}
			
			req.setAttribute("selectedStnfr", selectedStnfr);
			req.setAttribute("selectedStnto", selectedStnto);
			
			req.setAttribute("reqResult", "D");
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SupA820Serv:deleteTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"delete");
			} else {
				Logger.debug.println("[BASE:SupA820Serv:deleteTask] "+StringUtil.toKSC5601(((Exception)e).getMessage()));
				printMessagePage2(req, res, e.getMessage(),returnPage,"delete");
			}
		} 
	}//end of function		
	
}//end of class
