package kal.base.sup.serv;

import java.rmi.RemoteException;
import java.util.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import kal.base.com.util.*;
import kal.base.com.serv.*;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.Box;
import kal.base.jdf.serv.HttpUtility;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.sys.dbbean.SysA010BG;
import kal.base.sup.dbbean.*;
import kal.base.sup.ejb.SupAllSL;
import kal.base.wea.ejb.WeaAllSL;

/**
 * NOTAM Request Servlet Class
 * @version 	1.0
 * @author Copyright (c) 2005/06/24 
 */
public class SupQ010Serv extends PublicBaseServlet {

	/** 
	  * NOTAM Request ȸ Servlet Class - selectTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/06/24 
	  */	
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 										    		//Box ü 
		
		String notEtd = StringUtil.checkString(box.getString("notEtd")); // 2007.01.31 ߰
		
		/******************************************************************************/
		/*  Data Mode																													*/
		/*  1 : NOTAM NBR Է , 2 : FLT Է STN Է , 3 : FLT Է DEP Է ARR Է , 	*/
		/*  4 : FLT Է DEP Է ARR Է , 5 : FLT Է DEP Է ARR Է								*/
		/*  6 : AREA CODE 																									*/
		/******************************************************************************/
		String mode = StringUtil.checkString(box.getString("mode"));
		
		//1st Line Value
		String fltNum = StringUtil.checkString(box.getString("flt_num"));
		String depStn = StringUtil.checkString(box.getString("dep_stn"));
		String arrStn = StringUtil.checkString(box.getString("arr_stn"));
		String rteId = StringUtil.checkString(box.getString("rte_id"));
		String notNum = StringUtil.checkString(box.getString("not_num"));
		String areaCd = StringUtil.toKSC5601(box.getString("area_cd"));
		
		//2nd Line Value
		String hCatAll = StringUtil.checkString(box.getString("h_cat_all"));
		String hCatNo = StringUtil.checkString(box.getString("h_cat_no"));
		String hCatIn = StringUtil.checkString(box.getString("h_cat_in"));
		String hCatAip = StringUtil.checkString(box.getString("h_cat_aip"));
		String hCatSnow = StringUtil.checkString(box.getString("h_cat_snow"));
		String hCatComm = StringUtil.checkString(box.getString("h_cat_comm"));
		
		//3rd Line Value
		String notRdo = StringUtil.checkString(box.getString("not_rdo"));						// P : Period Combo   ,  T : From ~ To 
		//Logger.debug.println("[Servlet] notRdo : "+notRdo);
		String notTraf = StringUtil.checkString(box.getString("not_traf"));
		String notPeriod = StringUtil.checkString(box.getString("not_period"));
		String notIssDt = StringUtil.checkString(box.getString("not_iss_dt"));
		String notIssTm = StringUtil.checkString(box.getString("not_iss_tm"));
		String notExpDt = StringUtil.checkString(box.getString("not_exp_dt"));
		String notExpTm =StringUtil.checkString(box.getString("not_exp_tm"));
		
		//etc
		String notStn = StringUtil.checkString(box.getString("not_stn"));
		//String notFir = StringUtil.checkString(box.getString("not_fir"));  //2006.05.12 
		String notCommnt = StringUtil.toKSC5601(box.getString("not_commnt"));
		
		String returnPage = StringUtil.checkString(box.getString("returnPage"));		//Return Page ȹ
		HttpSession session = req.getSession();
		
		try {
			//ȸ 
			notStn = StringUtil.icaoChk(notStn); //ڸ ĸ  ٲ.
			//notFir = StringUtil.icaoChk(notFir);
			
			SupQ010BG params = new SupQ010BG();
			
			params.setNotEtd(notEtd); // 2007.01.31 ߰
			
			params.setMode(mode);
			params.setFlt_num(fltNum);
			params.setDep_stn(depStn);
			params.setArr_stn(arrStn);
			params.setRte_id(rteId);
			params.setNot_num(notNum);
			params.setH_cat_all(hCatAll);
			params.setH_cat_no(hCatNo);
			params.setH_cat_in(hCatIn);
			params.setH_cat_aip(hCatAip);
			params.setH_cat_snow(hCatSnow);
			params.setH_cat_comm(hCatComm);
			params.setNot_rdo(notRdo);
			params.setNot_traf(notTraf);
			params.setNot_period(notPeriod);
			params.setNot_iss_dt(notIssDt);
			params.setNot_iss_tm(notIssTm);
			params.setNot_exp_dt(notExpDt);
			params.setNot_exp_tm(notExpTm);
			params.setNot_stn(notStn);
			//params.setNot_fir(notFir);
			params.setNot_commnt(notCommnt);
			//2005.08.05 
			params.setArea_cd(areaCd);
			
			//EJB LookUp
			SupAllSL sl = (SupAllSL)EJBFinder.lookup("ejb/SupAllSL");
			Hashtable hashData  = sl.selSupQ010Main(params);
						
			//Data Session Input
			if (hashData != null) {
				//DEP_ARR STN Return ==> 2005.08.02 
				SupQ010BG rparam = (SupQ010BG)hashData.get("params");
				if (rparam != null) {
					req.setAttribute("dep_stn",rparam.getDep_stn());
					req.setAttribute("arr_stn",rparam.getArr_stn());
				}
				
				String errorMessage = StringUtil.checkString((String)hashData.get("errorMessage"));
				if (!errorMessage.equals("")) throw new Exception(errorMessage);
				
				//String head = StringUtil.checkString((String)hashData.get("HEAD"));
				SupQ010BG head = (SupQ010BG)hashData.get("HEAD");
				if (head != null) {
					//User Session Information
					SysA010BG UserInfo = (SysA010BG)session.getAttribute("USERINFO");
					
					// 2007.01.31 ߰
					String empNoKey = "";
					if (UserInfo != null) empNoKey = StringUtil.checkString(UserInfo.getEmp_no());
					else req.setAttribute("errorMessage","ð  ʾ α ʿմϴ.");
					
					String sessionKey = StringUtil.getKST("yyyyMMddHHmmss") + empNoKey;
					session.setAttribute(sessionKey,hashData);
					//߿ Popup JSP ͸ ̰   ؿ ٷ  !!!
					//session.removeAttribute(sessionKey);
					req.setAttribute("sessionKey",sessionKey);
				}
			}
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SupQ010Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
				return;
			} else {
				Logger.debug.println("[BASE:SupQ010Serv:selectTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
				return;
			}
		} 
	}//end selectTask
	
	/** 
	  * NOTAM Request Send Servlet Class - insertTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/08/22 
	  */	
	public void insertTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 										    		//Box ü 
		
		/******************************************************************************/
		/*  Data Mode																													*/
		/*  1 : NOTAM NBR Է , 2 : FLT Է STN Է , 3 : FLT Է DEP Է ARR Է , 	*/
		/*  4 : FLT Է DEP Է ARR Է , 5 : FLT Է DEP Է ARR Է								*/
		/*  6 : AREA CODE 																									*/
		/******************************************************************************/
		String mode = StringUtil.checkString(box.getString("mode"));
		
		//1st Line Value
		String fltNum = StringUtil.checkString(box.getString("flt_num"));
		String depStn = StringUtil.checkString(box.getString("dep_stn"));
		String arrStn = StringUtil.checkString(box.getString("arr_stn"));
		String rteId = StringUtil.checkString(box.getString("rte_id"));
		String notNum = StringUtil.checkString(box.getString("not_num"));
		String areaCd = StringUtil.toKSC5601(box.getString("area_cd"));
		
		//2nd Line Value
		String hCatAll = StringUtil.checkString(box.getString("h_cat_all"));
		String hCatNo = StringUtil.checkString(box.getString("h_cat_no"));
		String hCatIn = StringUtil.checkString(box.getString("h_cat_in"));
		String hCatAip = StringUtil.checkString(box.getString("h_cat_aip"));
		String hCatSnow = StringUtil.checkString(box.getString("h_cat_snow"));
		String hCatComm = StringUtil.checkString(box.getString("h_cat_comm"));
		
		//3rd Line Value
		String notRdo = StringUtil.checkString(box.getString("not_rdo"));						// P : Period Combo   ,  T : From ~ To 
		//Logger.debug.println("[Servlet] notRdo : "+notRdo);
		String notTraf = StringUtil.checkString(box.getString("not_traf"));
		String notPeriod = StringUtil.checkString(box.getString("not_period"));
		String notIssDt = StringUtil.checkString(box.getString("not_iss_dt"));
		String notIssTm = StringUtil.checkString(box.getString("not_iss_tm"));
		String notExpDt = StringUtil.checkString(box.getString("not_exp_dt"));
		String notExpTm =StringUtil.checkString(box.getString("not_exp_tm"));
		
		//etc
		String notStn = StringUtil.checkString(box.getString("not_stn"));
		//String notFir = StringUtil.checkString(box.getString("not_fir"));
		String notCommnt = StringUtil.toKSC5601(box.getString("not_commnt"));
		
		//Message Send Params
		String addrTxt = StringUtil.checkString(box.getString("addr_txt"));
		String originTxt = StringUtil.checkString(box.getString("origin_txt"));
		String acarsTxt = StringUtil.checkString(box.getString("acars_txt"));
		String mailFax = StringUtil.checkString(box.getString("mail_fax"));
		
		String returnPage = StringUtil.checkString(box.getString("returnPage"));		//Return Page ȹ
		HttpSession session = req.getSession();
		
		try {
			//ȸ 
			notStn = StringUtil.icaoChk(notStn);
			//notFir = StringUtil.icaoChk(notFir);
			
			SupQ010BG params = new SupQ010BG();
						
			params.setMode(mode);
			params.setFlt_num(fltNum);
			params.setDep_stn(depStn);
			params.setArr_stn(arrStn);
			params.setRte_id(rteId);
			params.setNot_num(notNum);
			params.setH_cat_all(hCatAll);
			params.setH_cat_no(hCatNo);
			params.setH_cat_in(hCatIn);
			params.setH_cat_aip(hCatAip);
			params.setH_cat_snow(hCatSnow);
			params.setH_cat_comm(hCatComm);
			params.setNot_rdo(notRdo);
			params.setNot_traf(notTraf);
			params.setNot_period(notPeriod);
			params.setNot_iss_dt(notIssDt);
			params.setNot_iss_tm(notIssTm);
			params.setNot_exp_dt(notExpDt);
			params.setNot_exp_tm(notExpTm);
			params.setNot_stn(notStn);
			//params.setNot_fir(notFir);
			params.setNot_commnt(notCommnt);
			//2005.08.05 
			params.setArea_cd(areaCd);
			
			//EJB LookUp
			SupAllSL sl = (SupAllSL)EJBFinder.lookup("ejb/SupAllSL");
			Hashtable hashData  = sl.selSupQ010Main(params);
			
			if (hashData != null) {
				SupQ010BG sendParam = new SupQ010BG();
				sendParam.setMode(mode);
				sendParam.setFlt_num(fltNum);
				sendParam.setNot_num(notNum);
				sendParam.setDep_stn(depStn);
				sendParam.setArr_stn(arrStn);
				sendParam.setRte_id(rteId);
				sendParam.setArea_cd(areaCd);
				sendParam.setNot_stn(notStn);  //2005.10.07 
				//sendParam.setNot_fir(notFir);	 //2005.10.07  --> 2006.05.12 
				sendParam.setAddr_txt(addrTxt);
				sendParam.setOrigin_txt(originTxt);
				sendParam.setAcars_txt(acarsTxt);
				sendParam.setMail_fax(mailFax);
				
				//2007.04.10 ߰ :  EMS ٲ鼭 Contents Mapping Ŀ URL ȣ  .
				// ׿  ʿ parameter ߰.
				sendParam.setH_cat_all(hCatAll);
				sendParam.setH_cat_no(hCatNo);
				sendParam.setH_cat_in(hCatIn);
				sendParam.setH_cat_aip(hCatAip);
				sendParam.setH_cat_snow(hCatSnow);
				sendParam.setH_cat_comm(hCatComm);
				sendParam.setNot_rdo(notRdo);
				sendParam.setNot_traf(notTraf);
				sendParam.setNot_period(notPeriod);
				sendParam.setNot_iss_dt(notIssDt);
				sendParam.setNot_iss_tm(notIssTm);
				sendParam.setNot_exp_dt(notExpDt);
				sendParam.setNot_exp_tm(notExpTm);
				sendParam.setNot_commnt(notCommnt);
				//
				
				WeaAllSL wea = (WeaAllSL)EJBFinder.lookup("ejb/WeaAllSL");
				boolean wxFlag = wea.sendNotamReq(sendParam,hashData);
				if (wxFlag) req.setAttribute("dataComplete","S");
				else throw new Exception("۽");
			} else throw new Exception("۽");
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SupQ010Serv:insertTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"insert");
			} else {
				Logger.debug.println("[BASE:SupQ010Serv:insertTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"insert");
			}
		} 
	}//end insertTask	

	/** 
	  * Route Id ȸ Servlet Class - checkTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/10/07  
	  */		
	public void checkTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 															//Box ü 
		
		String returnPage = StringUtil.checkString(box.getString("returnPage"));					//Return Page ȹ
		
		String depStn = StringUtil.checkString(box.getString("dep_hid")).toUpperCase();		//DEP Station
		String arrStn = StringUtil.checkString(box.getString("arr_hid")).toUpperCase();			//ARR Station
		
		try {	
			//EJB LookUp
			SupAllSL sl = (SupAllSL)EJBFinder.lookup("ejb/SupAllSL");
			
			//Parameter 
			SupQ010BG params = new SupQ010BG();
			params.setDep_stn(depStn);
			params.setArr_stn(arrStn);
			
			//EJB LookUp
			Hashtable hashData = sl.selSupQ010RteCd(params);
			
			req.setAttribute("hashData",hashData);
			req.setAttribute("chkValue","Y");
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SupQ010Serv:checkTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"check");
			} else {
				Logger.debug.println("[BASE:SupQ010Serv:checkTask] "+StringUtil.toKSC5601(((Exception)e).getMessage()));
				printMessagePage2(req, res, e.getMessage(),returnPage,"check");
			}
		} 
	}//end of function
	
}//end of class
