package kal.base.sup.serv;

import java.rmi.RemoteException;
import java.util.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import kal.base.com.util.*;
import kal.base.com.serv.*;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.Box;
import kal.base.jdf.serv.HttpUtility;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.sys.dbbean.SysA010BG;
import kal.base.sup.dbbean.*;
import kal.base.sup.ejb.SupAllSL;
import kal.base.wea.ejb.WeaAllSL;

/**
 * Past Weather Request  Servlet Class
 * @version 	1.0
 * @author Copyright (c) 2005/08/11 
 */
public class SupQ220Serv extends PublicBaseServlet {
	
	private static SupQ220Serv instance = null;
	
	public static SupQ220Serv getInstance() {
		if(instance==null)
			instance = new SupQ220Serv();
		return instance;
	}
	
	/**
	 * <b>Past Weather Request Weather Condition Code ȸԼ.</b>
	 * @return Hashtable ȸ 
	 * @exception Exception
	 * @author Copyright (c) 2005 HIST 
	 */
	public static Hashtable selWxCond() throws Exception {
		try {
			SupAllSL sl = (SupAllSL)EJBFinder.lookup("ejb/SupAllSL");
			Hashtable hashData = sl.selSupQ220WxCond();
			
			return hashData;
		} catch(Exception e) {
			if(e instanceof Exception) {
				throw new Exception(e.getMessage());
			} else {
				throw new Exception(MessageCode.getInstance().ETC_EXPT);
			}
		}
	}//end of function	
	
	/** 
	  * Past Weather Request Servlet Class - selectTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/08/11 
	  */	
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 										    	//Box ü 
		String metarTyp = StringUtil.checkString(box.getString("metar_typ"));
		String tafTyp = StringUtil.checkString(box.getString("taf_typ"));
		String textTyp = StringUtil.checkString(box.getString("text_typ"));
		String icaoPort = StringUtil.checkString(box.getString("icao_port"));
		String fromDt = StringUtil.checkString(box.getString("from_dt"));
		String toDt = StringUtil.checkString(box.getString("to_dt"));
		String wxCond1 = StringUtil.checkString(box.getString("wx_cond1"));
		String wxCond2 = StringUtil.checkString(box.getString("wx_cond2"));
		String title = StringUtil.checkString(box.getString("title"));
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		// 2006.01.26 ߰
		String rwy_yn = StringUtil.checkString(box.getString("rwy_yn"));
		
		HttpSession session = req.getSession();
		
		try {
			//ȸ Parameter 
			SupQ220BG params = new SupQ220BG();
			params.setMetar_typ(metarTyp);
			params.setTaf_typ(tafTyp);
			params.setText_typ(textTyp);
			params.setIcao_port(icaoPort);
			params.setFrom_dt(fromDt);
			params.setTo_dt(toDt);
			params.setWx_cond1(wxCond1);
			params.setWx_cond2(wxCond2);
			params.setTitle(StringUtil.toKSC5601(title));
			
			//EJB LookUp
			SupAllSL sl = (SupAllSL)EJBFinder.lookup("ejb/SupAllSL");
			Hashtable hashData = sl.selSupQ220Main(params);
			
			//Data Session Input
			if (hashData != null) {
				//User Session Information
				SysA010BG UserInfo = (SysA010BG)session.getAttribute("USERINFO");
				String wxKey = StringUtil.getKST("yyyyMMddHHmmss")+StringUtil.checkString(UserInfo.getEmp_no());
				session.setAttribute(wxKey,hashData);
				//߿ Popup JSP ͸ ̰   ؿ ٷ  !!!
				//session.removeAttribute(wxKey);
				req.setAttribute("wxKey",wxKey);
				req.setAttribute("dataComplete","V");
				
				req.setAttribute("rwy_yn", rwy_yn);
			}
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SupQ220Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			} else {
				Logger.debug.println("[BASE:SupQ220Serv:selectTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			}
		} 
	}//end selectTask	
	
	/** 
	  * Past Weather Request Servlet Class - checkTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2006/01/26 
	  */	
	public void checkTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 										    	//Box ü 
		String metarTyp = StringUtil.checkString(box.getString("metar_typ"));
		String tafTyp = StringUtil.checkString(box.getString("taf_typ"));
		String textTyp = StringUtil.checkString(box.getString("text_typ"));
		String icaoPort = StringUtil.checkString(box.getString("icao_port"));
		String fromDt = StringUtil.checkString(box.getString("from_dt"));
		String toDt = StringUtil.checkString(box.getString("to_dt"));
		String wxCond1 = StringUtil.checkString(box.getString("wx_cond1"));
		String wxCond2 = StringUtil.checkString(box.getString("wx_cond2"));
		String title = StringUtil.checkString(box.getString("title"));
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		// 2006.01.26 ߰
		String mailAddr = StringUtil.checkString(box.getString("mail_addr"));
		
		String mailSender = StringUtil.checkString(box.getString("mail_sender")); //2009.08.05 ߰ :  ...
		
		try {
			//ȸ Parameter 
			SupQ220BG params = new SupQ220BG();
			params.setMetar_typ(metarTyp);
			params.setTaf_typ(tafTyp);
			params.setText_typ(textTyp);
			params.setIcao_port(icaoPort);
			params.setFrom_dt(fromDt);
			params.setTo_dt(toDt);
			params.setWx_cond1(wxCond1);
			params.setWx_cond2(wxCond2);
			params.setTitle(StringUtil.toKSC5601(title));
			
			//EJB LookUp
			SupAllSL sl = (SupAllSL)EJBFinder.lookup("ejb/SupAllSL");
			Hashtable hashData = sl.selSupQ220Main(params);
			
			if (hashData != null) {
				SupQ220BG sendParam = new SupQ220BG();
				sendParam.setMail_addr(mailAddr);
				sendParam.setMail_sender(mailSender); //2009.08.05 ߰
				
				//20151021 UMS  ߰ 
				sendParam.setMetar_typ(metarTyp);
				sendParam.setTaf_typ(tafTyp);
				sendParam.setText_typ(textTyp);
				sendParam.setIcao_port(icaoPort);
				sendParam.setFrom_dt(fromDt);
				sendParam.setTo_dt(toDt);
				sendParam.setWx_cond1(wxCond1);
				sendParam.setWx_cond2(wxCond2);
				sendParam.setTitle(StringUtil.toKSC5601(title));
				
				WeaAllSL wea = (WeaAllSL)EJBFinder.lookup("ejb/WeaAllSL");
				boolean wxFlag = wea.sendPastWxReq(sendParam, hashData);
				
				if (wxFlag) req.setAttribute("sendOk","Y");
				else throw new Exception("۽");
				
			} else throw new Exception("۽");
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SupQ220Serv:checkTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"check");
			} else {
				Logger.debug.println("[BASE:SupQ220Serv:checkTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"check");
			}
		} 
	}//end checkTask	
}
