package kal.base.sup.serv;

import java.rmi.RemoteException;
import java.util.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import kal.base.com.util.*;
import kal.base.com.serv.*;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.Box;
import kal.base.jdf.serv.HttpUtility;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.sys.dbbean.SysA010BG;
import kal.base.sup.dbbean.SupQ230BG;
import kal.base.sup.ejb.SupAllSL;

/**
 * Sig Weather Request  Servlet Class
 * @version 	1.0
 * @author Copyright (c) 2005/07/13 
 */
public class SupQ230Serv extends PublicBaseServlet {
	
	private static SupQ230Serv instance = null;
	
	public static SupQ230Serv getInstance() {
		if(instance==null)
			instance = new SupQ230Serv();
		return instance;
	}
		
	/** 
	  * Sig Weather Request Servlet Class - selectTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/07/13 
	  */	
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 										    //Box ü 
		String mode = StringUtil.checkString(box.getString("mode"));
		String icaoPort = StringUtil.checkString(box.getString("icao_port"));
		String areaCd = StringUtil.toKSC5601(box.getString("area_cd"));
		String wTyp = StringUtil.checkString(box.getString("w_typ"));
		String vTyp = StringUtil.checkString(box.getString("v_typ"));
		String cTyp = StringUtil.checkString(box.getString("c_typ"));
		String wxCond1 = StringUtil.checkString(box.getString("wx_cond1"));
		String wxCond2 = StringUtil.checkString(box.getString("wx_cond2"));
		String beginDt = StringUtil.checkString(box.getString("begin_dt"));
		String beginTm = StringUtil.checkString(box.getString("begin_tm"));
		String endDt = StringUtil.checkString(box.getString("end_dt"));
		String endTm = StringUtil.checkString(box.getString("end_tm"));
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		try {
			//Weather Type 
			String wxTyp = "";
			boolean typeFlag = false;
			wxTyp += "'A'";
			typeFlag = true;
			
			
			if (wTyp.equals("Y")) {
				if (typeFlag) wxTyp += ",'W'";
				else wxTyp += "'W'";
				typeFlag = true;
			}
			if (vTyp.equals("Y")) {
				if (typeFlag) wxTyp += ",'V'";
				else wxTyp += "'V'";
				typeFlag = true;
			}
			if (cTyp.equals("Y")) {
				if (typeFlag) wxTyp += ",'C'";
				else wxTyp += "'C'";
				typeFlag = true;
			}
			
			//if (typeFlag) wxTyp += ", 'A'";
			
			//ȸ Parameter 
			SupQ230BG params = new SupQ230BG();
			params.setMode(mode);
			params.setIcao_port(icaoPort);
			params.setArea_cd(areaCd);
			params.setWx_typ(wxTyp);
			params.setWx_cond1(wxCond1);
			params.setWx_cond2(wxCond2);
			params.setBegin_dt(beginDt+beginTm);
			params.setEnd_dt(endDt+endTm);
			
			//EJB LookUp
			SupAllSL sl = (SupAllSL)EJBFinder.lookup("ejb/SupAllSL");
			Hashtable hashData = sl.selSupQ230Main(params);
			if (hashData != null) req.setAttribute("successMessage",ComUtil.getInstance().getMessage("Sig Weather Request", hashData, "HASHDATA", MessageCode.getInstance().DATA_MSG));
			req.setAttribute("hashData",hashData);
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SupQ230Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			} else {
				Logger.debug.println("[BASE:SupQ230Serv:selectTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			}
		} 
	}//end selectTask
	
	/**
	 * <b>Sig Weather Request Popup ȸԼ.</b>
	 * @return Hashtable ȸ 
	 * @exception Exception
	 * @author Copyright (c) 2005 HIST 
	 */
	public static Hashtable selSigWxPop(String icaoPort,String wxTyp,String beginDate) throws Exception {
		try {
			//ȸ Parameter 
			SupQ230BG params = new SupQ230BG();
			params.setIcao_port(icaoPort);
			params.setWx_typ(wxTyp);
			params.setBegin_date(beginDate);
			
			SupAllSL sl = (SupAllSL)EJBFinder.lookup("ejb/SupAllSL");
			Hashtable hashData = sl.selSigWxPop(params);
			
			return hashData;
		} catch(Exception e) {
			if(e instanceof Exception) {
				throw new Exception(e.getMessage());
			} else {
				throw new Exception(MessageCode.getInstance().ETC_EXPT);
			}
		}
	}//end of function	

}
