package kal.base.sup.serv;

import java.rmi.RemoteException;
import java.util.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import kal.base.com.util.*;
import kal.base.com.serv.*;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.Box;
import kal.base.jdf.serv.HttpUtility;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.sys.dbbean.SysA010BG;
import kal.base.sup.dbbean.SupQ240BG;
import kal.base.sup.ejb.SupAllSL;

/**
 * SIGMET/AIRREP INFO Servlet Class
 * @version 	1.0
 * @author Copyright (c) 2005/06/21 
 */
public class SupQ240Serv extends PublicBaseServlet {
	/** 
	  * SIGMET/AIRREP INFO Servlet Class - selectTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/06/21 
	  */	
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 										    //Box ü 

		String msg_typ = StringUtil.checkString(box.getString("msg_typ"));			//MSG_TYP
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		try {
			SupQ240BG params = new SupQ240BG();
			params.setMsg_typ(msg_typ);

			//EJB LookUp
			SupAllSL sl = (SupAllSL)EJBFinder.lookup("ejb/SupAllSL");
			Hashtable hashData  = sl.selSupQ240Main(params);
			if (hashData != null){
				req.setAttribute("successMessage",ComUtil.getInstance().getMessage("SIGMET/AIRREP INFO", null, "", MessageCode.getInstance().SELECT_MSG));
			}
			req.setAttribute("msg_typ",msg_typ);
			req.setAttribute("hashData",hashData);
			req.setAttribute("chkParam","Y");
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SupQ240Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			} else {
				Logger.debug.println("[BASE:SupQ240Serv:selectTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			}
		} 
	}//end selectTask
}
