package kal.base.sup.serv;

import java.rmi.RemoteException;
import java.util.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import kal.base.com.util.*;
import kal.base.com.serv.*;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.Box;
import kal.base.jdf.serv.HttpUtility;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.sys.dbbean.SysA010BG;
import kal.base.sup.dbbean.SupQ410BG;
import kal.base.sup.ejb.SupAllSL;

/**
 * Weather Statistics Servlet Class
 * @version 	1.0
 * @author Copyright (c) 2005/08/16 
 */
public class SupQ410Serv extends PublicBaseServlet {

	/** 
	  * Weather Statistics Servlet Class - selectTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/08/16 
	  */	
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 										    	//Box ü 
		String icaoPort = StringUtil.checkString(box.getString("icao_port"));
		String beginDt = StringUtil.checkString(box.getString("begin_dt"));
		String endDt = StringUtil.checkString(box.getString("end_dt"));
		String dataFlag = StringUtil.checkString(box.getString("data_flag"));
		String analyCond1 = StringUtil.checkString(box.getString("analy_cond1"));
		String analyCond2 = StringUtil.checkString(box.getString("analy_cond2"));
		String beginRg = StringUtil.checkString(box.getString("begin_rg"));
		String endRg = StringUtil.checkString(box.getString("end_rg"));
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		try {
			//ȸ Parameter 
			SupQ410BG params = new SupQ410BG();
			params.setIcao_port(icaoPort);
			params.setBegin_dt(beginDt);
			params.setEnd_dt(endDt);
			params.setData_flag(dataFlag);
			params.setAnaly_cond1(analyCond1);
			params.setAnaly_cond2(analyCond2);
			params.setBegin_rg(beginRg);
			params.setEnd_rg(endRg);
			
			//EJB LookUp
			SupAllSL sl = (SupAllSL)EJBFinder.lookup("ejb/SupAllSL");
			Hashtable hashData = sl.selSupQ410Main(params);
			if (hashData != null) req.setAttribute("successMessage",ComUtil.getInstance().getMessage("Weather Statistics", null, "", MessageCode.getInstance().SELECT_MSG));
			req.setAttribute("hashData",hashData);
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SupQ410Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			} else {
				Logger.debug.println("[BASE:SupQ410Serv:selectTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			}
		} 
	}//end selectTask	
}
