package kal.base.sup.serv;

import java.rmi.RemoteException;
import java.util.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import kal.base.com.util.*;
import kal.base.com.serv.*;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.Box;
import kal.base.jdf.serv.HttpUtility;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.sys.dbbean.SysA010BG;
import kal.base.sup.dbbean.SupA360BG;
import kal.base.sup.dbbean.SupQ510BG;
import kal.base.sup.ejb.SupAllSL;

/**
 * Weather Watch Regional Servlet Class
 * @version 	1.0
 * @author Copyright (c) 2005/07/21 
 */
public class SupQ510Serv extends PublicBaseServlet {

	/** 
	  * Weather Watch Regional  ȸ Servlet Class - selectTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/07/21 
	  */	
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 										    //Box ü 
		String areaCd = StringUtil.checkString(box.getString("area_cd"));
		String utcLoc = StringUtil.checkString(box.getString("hid_utc_loc")); //2010.01.26 ߰
		
		String hidAreaCd = StringUtil.checkString(box.getString("hid_area_cd")); //2010.03.05 ߰
		if (areaCd.equals("SCROLL")) areaCd = hidAreaCd;
		
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		try {
			req.setAttribute("areaCd",areaCd);
			
			//ȸ Parameter 
			SupQ510BG params = new SupQ510BG();
			params.setArea_cd(areaCd);
			params.setUtc_loc(utcLoc);
			
			//EJB LookUp
			SupAllSL sl = (SupAllSL)EJBFinder.lookup("ejb/SupAllSL");
			Hashtable hashData = sl.selSupQ510Main(params);
			
			req.setAttribute("hashData",hashData);
			req.setAttribute("returnParam","Y");
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SupQ510Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			} else {
				Logger.debug.println("[BASE:SupQ510Serv:selectTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			}
		} 
	}//end selectTask
	
	/** 
	  * Weather Watch Regional Station Information Servlet Class - checkTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/07/26 
	  */	
	public void checkTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 										    //Box ü 
		String iataPort = StringUtil.checkString(box.getString("iata_port"));
		
		//2011.11.04 man_iss_dt, man_exp_dt ߰
		//  ʾǷ ڸ  ʰ ־Ƿ wx_typ, dtg  ü 
		String wx_typ = StringUtil.checkString(box.getString("wx_typ"));
		String dtg = StringUtil.checkString(box.getString("dtg"));
		
		//2011.12.06 ߰
		String mode = StringUtil.checkString(box.getString("mode"));
		
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		HttpSession session = req.getSession();
		
		try {
			//EJB LookUp
			SupAllSL sl = (SupAllSL)EJBFinder.lookup("ejb/SupAllSL");
			
            /*
			 * 2011.11.04 
			 * Hashtable hashData = sl.selSupQ510StnInfo(iataPort);  Ʒ ڵ
			 * Hashtable hashData = new Hashtable();
			 * Hashtable hashData1 = sl.selSupQ510StnInfo(iataPort); 
			 */
			Hashtable hashData = new Hashtable();
			Hashtable hashData2 = null;
			SupA360BG data = null;
			List dataList = new LinkedList();
			String mod = "";
			
			if(mode.equals("ffs")){
				SupA360BG params = new SupA360BG();
				params.setIata_port(iataPort);
				
				hashData2 = sl.selSupA360Ffs(params);
				mod = (String)hashData2.get("MODE");
			}else{
				if(!wx_typ.equals("")&&!dtg.equals("")){
					SupA360BG params = new SupA360BG();
					params.setIata_port(iataPort);
					params.setWx_typ(wx_typ);
					params.setDtg(dtg);
					
					data = (SupA360BG)sl.selSupA360Detail(params);
					
				}
			}
			
			Hashtable hashData1 = sl.selSupQ510StnInfo(iataPort); 			
			
			//Data Session Input
			if (hashData1 != null || data!=null || hashData.size()!=0) {//2011.11.04  hashData!=null - > hashData1!=null || data!=null
				//2011.11.04 ߰
				//FORECAST  Ѱֱ  
			
				if(mod.equals("FFS")){
					if(hashData1!=null) hashData = hashData1;
					hashData.put("FFSLIST", hashData2.get("FFSLIST"));
					hashData.put("MODE", hashData2.get("MODE"));
				}else{	
					if(hashData1!=null) hashData = hashData1;
					if(data!=null){
						hashData.put("ALERTAPO", data);
					}
				}
				/*
				//User Session Information
				SysA010BG UserInfo = (SysA010BG)session.getAttribute("USERINFO");
				String wxKey = StringUtil.getKST("yyyyMMddHHmmss")+StringUtil.checkString(UserInfo.getEmp_no());
				session.setAttribute(wxKey,hashData);
				//߿ Popup JSP ͸ ̰   ؿ ٷ  !!!
				//session.removeAttribute(wxKey);
				*/
				//2009.11.30  : wxKey
				String wxKey = StringUtil.getKST("yyyyMMddHHmmss");
				session.setAttribute(wxKey,hashData);
				
				req.setAttribute("wxKey",wxKey);
				req.setAttribute("dataComplete","V");
			}			
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SupQ510Serv:checkTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"check");
			} else {
				Logger.debug.println("[BASE:SupQ510Serv:checkTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"check");
			}
		} 
	}//end checkTask		
}
