package kal.base.test.serv;

import java.rmi.RemoteException;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import kal.base.com.util.StringUtil;
import kal.base.jdf.serv.Box;
import kal.base.jdf.serv.HttpUtility;
import kal.base.pbf.serv.PublicBaseServlet;

import java.io.FileWriter;
import java.io.IOException;
import org.jdom.Document;
import org.jdom.Element;
import org.jdom.output.XMLOutputter;

public class TestQ020Serv extends PublicBaseServlet{
	
	public void checkTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		
		Box box = HttpUtility.getBox(req);
		String returnPage = StringUtil.checkString(box.getString("returnPage"));
		
		String T_TimeStamp = StringUtil.checkString(box.getString("TimeStamp"));
		String T_CreatorReference = StringUtil.checkString(box.getString("CreatorReference"));
		String T_TimeMode = StringUtil.checkString(box.getString("TimeMode"));
		String T_Airline = StringUtil.checkString(box.getString("Airline"));
		String T_FlightNumber = StringUtil.checkString(box.getString("FlightNumber"));
		String T_Date = StringUtil.checkString(box.getString("Date"));
		String T_DepartureAirport = StringUtil.checkString(box.getString("DepartureAirport"));
		String T_ArrivalAirport = StringUtil.checkString(box.getString("ArrivalAirport"));
		String T_AircraftRegistration = StringUtil.checkString(box.getString("AircraftRegistration"));
		String T_AirportOfMovement = StringUtil.checkString(box.getString("AirportOfMovement"));
		String T_OffBlockTime = StringUtil.checkString(box.getString("OffBlockTime"));
		String T_EstimatedDepartureTime = StringUtil.checkString(box.getString("EstimatedDepartureTime"));
		String T_DelayReasonCode = StringUtil.checkString(box.getString("DelayReasonCode"));
		String T_DelayDuration = StringUtil.checkString(box.getString("DelayDuration"));
		String T_EstimatedTouchDownTime = StringUtil.checkString(box.getString("EstimatedTouchDownTime"));
		String T_ArrivalAirport2 = StringUtil.checkString(box.getString("ArrivalAirport2"));
		String T_EstimatedOnBlockTime = StringUtil.checkString(box.getString("EstimatedOnBlockTime"));
		String T_ReturnToRampTime = StringUtil.checkString(box.getString("ReturnToRampTime"));
		String T_ActualOnBlockTime = StringUtil.checkString(box.getString("ActualOnBlockTime"));
		String T_Comments = StringUtil.checkString(box.getString("Comments"));
		
		try {
			
	        // ִ org.jdom.Document ü .
			Document doc = new Document();
			
			Element MovementMessage = new Element("MovementMessage"); //root
			Element MessageReference = new Element("MessageReference");
			Element TimeStamp = new Element("TimeStamp");
			Element CreatorReference = new Element("CreatorReference");
			Element MovementUpdates = new Element("MovementUpdates");
			Element TimeMode = new Element("TimeMode");
			Element FlightLegIdentifier = new Element("FlightLegIdentifier");
			Element FlightDesignator = new Element("FlightDesignator");
			Element Airline = new Element("Airline");
			Element FlightNumber = new Element("FlightNumber");
			Element Date = new Element("Date");
			Element DepartureAirport = new Element("DepartureAirport");
			Element ArrivalAirport = new Element("ArrivalAirport");
			Element AircraftRegistration = new Element("AircraftRegistration");
			Element AirportOfMovement = new Element("AirportOfMovement");
			Element Updates = new Element("Updates");
			Element ActualDeparture = new Element("ActualDeparture");
			Element OffBlockTime = new Element("OffBlockTime");
			Element DepartureDelay = new Element("DepartureDelay");
			Element EstimatedDepartureTime = new Element("EstimatedDepartureTime");
			Element DelayInformation = new Element("DelayInformation");
			Element Delays = new Element("Delays");
			Element DelayReasonCode = new Element("DelayReasonCode");
			Element DelayDuration = new Element("DelayDuration");
			Element EstimatedArrivalInformation = new Element("EstimatedArrivalInformation");
			Element EstimatedTouchDownTime = new Element("EstimatedTouchDownTime");
			Element ArrivalAirport2 = new Element("ArrivalAirport2");
			Element EstimatedOnBlockTime = new Element("EstimatedOnBlockTime");
			Element ReturnToRamp = new Element("ReturnToRamp");
			Element ReturnToRampTime = new Element("ReturnToRampTime");
			Element ActualArrival = new Element("ActualArrival");
			Element OnBlockTime = new Element("OnBlockTime");
			Element ActualOnBlockTime = new Element("ActualOnBlockTime");
			Element Comments = new Element("Comments");
			
			//TextҸ ؾ Ѵ.
			TimeStamp.setText(T_TimeStamp);
			CreatorReference.setText(T_CreatorReference);
			TimeMode.setText(T_TimeMode);
			Airline.setText(T_Airline);
			FlightNumber.setText(T_FlightNumber);
			Date.setText(T_Date);
			DepartureAirport.setText(T_DepartureAirport);
			ArrivalAirport.setText(T_ArrivalAirport);
			AircraftRegistration.setText(T_AircraftRegistration);
			AirportOfMovement.setText(T_AirportOfMovement);
			OffBlockTime.setText(T_OffBlockTime);
			EstimatedDepartureTime.setText(T_EstimatedDepartureTime);
			DelayReasonCode.setText(T_DelayReasonCode);
			DelayDuration.setText(T_DelayDuration);
			EstimatedTouchDownTime.setText(T_EstimatedTouchDownTime);
			ArrivalAirport2.setText(T_ArrivalAirport2);
			EstimatedOnBlockTime.setText(T_EstimatedOnBlockTime);
			ReturnToRampTime.setText(T_ReturnToRampTime);
			ActualOnBlockTime.setText(T_ActualOnBlockTime);
			Comments.setText(T_Comments);
			
			// Ʈ ġ ۾- Ʈ ڽ Ҹ ߰Ѵ.
			MessageReference.addContent(TimeStamp);
			MessageReference.addContent(CreatorReference);
			MovementMessage.addContent(MessageReference);
			MovementUpdates.addContent(TimeMode);
			FlightDesignator.addContent(Airline);
			FlightDesignator.addContent(FlightNumber);
			FlightLegIdentifier.addContent(FlightDesignator);
			FlightLegIdentifier.addContent(Date);
			FlightLegIdentifier.addContent(DepartureAirport);
			FlightLegIdentifier.addContent(ArrivalAirport);
			FlightLegIdentifier.addContent(AircraftRegistration);
			FlightLegIdentifier.addContent(AirportOfMovement);
			MovementUpdates.addContent(FlightLegIdentifier);
			ActualDeparture.addContent(OffBlockTime);
			DepartureDelay.addContent(EstimatedDepartureTime);
			Delays.addContent(DelayReasonCode);
			Delays.addContent(DelayDuration);
			DelayInformation.addContent(Delays);
			DepartureDelay.addContent(DelayInformation);
			ActualDeparture.addContent(DepartureDelay);
			EstimatedArrivalInformation.addContent(EstimatedTouchDownTime);
			EstimatedArrivalInformation.addContent(ArrivalAirport2);
			EstimatedArrivalInformation.addContent(EstimatedOnBlockTime);
			ActualDeparture.addContent(EstimatedArrivalInformation);
			ReturnToRamp.addContent(ReturnToRampTime);
			ActualDeparture.addContent(ReturnToRamp);
			Updates.addContent(ActualDeparture);
			OnBlockTime.addContent(ActualOnBlockTime);
			ActualArrival.addContent(OnBlockTime);
			Updates.addContent(ActualArrival);
			MovementUpdates.addContent(Updates);
			MovementUpdates.addContent(Comments);
			MovementMessage.addContent(MovementUpdates);
			
	        // Document root Ѵ.
	        doc.setRootElement(MovementMessage);
	        
	        //Ϸ ϱ ؼ XMLOutputter ü ʿϴ
	        XMLOutputter xo = new XMLOutputter();
	        xo.output(doc, new FileWriter("C:/TEST/XML/XML_TEST.xml"));
	        
			req.setAttribute("returnParam","Y");
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				System.out.println("[BASE:TestQ020Serv:checkTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"check");
			} else {
				System.out.println("[BASE:TestQ020Serv:checkTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"check");
			}
		} 
	}//end checkTask
}
